/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/observableValue","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(Z){for(var e=[],c=0,t=Z.length;c<t;c++)e[c]=De[Z[c]];return e};define(De[77],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function c(y){return y?y.replace(/\$\((.*?)\)/g,(T,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=c;class t{constructor(T,S,k){this.id=T,this.definition=S,this.description=k,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(y,T){const S=["codicon","codicon-"+y];return T&&S.push("codicon-modifier-"+T),S}e.getClassNamesArray=D;var P;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function S(I){if(I instanceof t)return["codicon","codicon-"+I.id];const E=T.exec(I.id);if(!E)return S(t.error);const[,_,w]=E,h=["codicon","codicon-"+_];return w&&h.push("codicon-modifier-"+w.substr(1)),h}y.asClassNameArray=S;function k(I){return S(I).join(" ")}y.asClassName=k;function A(I){return"."+S(I).join(".")}y.asCSSSelector=A})(P=e.CSSIcon||(e.CSSIcon={}))}),define(De[78],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(y,T){const S=Object.create(null);for(const k of y){const A=T(k);let I=S[A];I||(I=S[A]=[]),I.push(k)}return S}e.groupBy=c;function t(y,T){const S=[],k=[];for(const A of y)T.has(A)||S.push(A);for(const A of T)y.has(A)||k.push(A);return{removed:S,added:k}}e.diffSets=t;function D(y,T){const S=[],k=[];for(const[A,I]of y)T.has(A)||S.push(I);for(const[A,I]of T)y.has(A)||k.push(I);return{removed:S,added:k}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(T,S){let k=this.map.get(T);k||(k=new Set,this.map.set(T,k)),k.add(S)}delete(T,S){const k=this.map.get(T);!k||(k.delete(S),k.size===0&&this.map.delete(T))}forEach(T,S){const k=this.map.get(T);!k||k.forEach(S)}}e.SetMap=P}),define(De[60],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(y){return(T,S,k)=>{let A=null,I=null;if(typeof k.value=="function"?(A="value",I=k.value):typeof k.get=="function"&&(A="get",I=k.get),!I)throw new Error("not supported");k[A]=y(I,S)}}e.createDecorator=c;function t(y,T,S){let k=null,A=null;if(typeof S.value=="function"?(k="value",A=S.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",A=S.get),!A)throw new Error("not supported");const I=`$memoize$${T}`;S[k]=function(...E){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,E)}),this[I]}}e.memoize=t;function D(y,T,S){return c((k,A)=>{const I=`$debounce$${A}`,E=`$debounce$result$${A}`;return function(..._){this[E]||(this[E]=S?S():void 0),clearTimeout(this[I]),T&&(this[E]=T(this[E],..._),_=[this[E]]),this[I]=setTimeout(()=>{k.apply(this,_),this[E]=S?S():void 0},y)}})}e.debounce=D;function P(y,T,S){return c((k,A)=>{const I=`$throttle$timer$${A}`,E=`$throttle$result$${A}`,_=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...h){if(this[E]||(this[E]=S?S():void 0),(this[_]===null||this[_]===void 0)&&(this[_]=-Number.MAX_VALUE),T&&(this[E]=T(this[E],...h)),this[w])return;const g=this[_]+y;g<=Date.now()?(this[_]=Date.now(),k.apply(this,[this[E]]),this[E]=S?S():void 0):(this[w]=!0,this[I]=setTimeout(()=>{this[w]=!1,this[_]=Date.now(),k.apply(this,[this[E]]),this[E]=S?S():void 0},g-Date.now()))}})}e.throttle=P}),define(De[10],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?m.isErrorNoTelemetry(s)?new m(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(u=>{u(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=c,e.errorHandler=new c;function t(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=t;function D(b){S(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=D;function P(b){S(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=P;function y(b){if(b instanceof Error){const{name:s,message:u}=b,o=b.stacktrace||b.stack;return{$isError:!0,name:s,message:u,stack:o,noTelemetry:m.isErrorNoTelemetry(b)}}return b}e.transformErrorForSerialization=y;const T="Canceled";function S(b){return b instanceof k?!0:b instanceof Error&&b.name===T&&b.message===T}e.isCancellationError=S;class k extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=k;function A(){const b=new Error(T);return b.name=b.message,b}e.canceled=A;function I(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=I;function E(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=E;function _(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=_;function w(b){const s=new Error(`${b} has been disposed`);return s.name="DISPOSED",s}e.disposed=w;function h(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=h;class g extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=g;class f extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=f;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class m extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof m)return s;const u=new m;return u.message=s.message,u.stack=s.stack,u}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class r extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype);debugger}}e.BugIndicatingError=r}),define(De[17],Ie([1,0,10]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(ie,ce=0){return ie[ie.length-(1+ce)]}e.tail=t;function D(ie){if(ie.length===0)throw new Error("Invalid tail call");return[ie.slice(0,ie.length-1),ie[ie.length-1]]}e.tail2=D;function P(ie,ce,me=(J,ae)=>J===ae){if(ie===ce)return!0;if(!ie||!ce||ie.length!==ce.length)return!1;for(let J=0,ae=ie.length;J<ae;J++)if(!me(ie[J],ce[J]))return!1;return!0}e.equals=P;function y(ie,ce){const me=ie.length-1;ce<me&&(ie[ce]=ie[me]),ie.pop()}e.removeFastWithoutKeepingOrder=y;function T(ie,ce,me){return S(ie.length,J=>me(ie[J],ce))}e.binarySearch=T;function S(ie,ce){let me=0,J=ie-1;for(;me<=J;){const ae=(me+J)/2|0,ne=ce(ae);if(ne<0)me=ae+1;else if(ne>0)J=ae-1;else return ae}return-(me+1)}e.binarySearch2=S;function k(ie,ce){let me=0,J=ie.length;if(J===0)return 0;for(;me<J;){const ae=Math.floor((me+J)/2);ce(ie[ae])?J=ae:me=ae+1}return me}e.findFirstInSorted=k;function A(ie,ce,me){if(ie=ie|0,ie>=ce.length)throw new TypeError("invalid index");const J=ce[Math.floor(ce.length*Math.random())],ae=[],ne=[],se=[];for(const N of ce){const j=me(N,J);j<0?ae.push(N):j>0?ne.push(N):se.push(N)}return ie<ae.length?A(ie,ae,me):ie<ae.length+se.length?se[0]:A(ie-(ae.length+se.length),ne,me)}e.quickSelect=A;function I(ie,ce){const me=[];let J;for(const ae of ie.slice(0).sort(ce))!J||ce(J[0],ae)!==0?(J=[ae],me.push(J)):J.push(ae);return me}e.groupBy=I;function E(ie,ce,me){const J=[];function ae(N,j,G){if(j===0&&G.length===0)return;const X=J[J.length-1];X&&X.start+X.deleteCount===N?(X.deleteCount+=j,X.toInsert.push(...G)):J.push({start:N,deleteCount:j,toInsert:G})}let ne=0,se=0;for(;;){if(ne===ie.length){ae(ne,0,ce.slice(se));break}if(se===ce.length){ae(ne,ie.length-ne,[]);break}const N=ie[ne],j=ce[se],G=me(N,j);G===0?(ne+=1,se+=1):G<0?(ae(ne,1,[]),ne+=1):G>0&&(ae(ne,0,[j]),se+=1)}return J}e.sortedDiff=E;function _(ie,ce,me){const J=E(ie,ce,me),ae=[],ne=[];for(const se of J)ae.push(...ie.slice(se.start,se.start+se.deleteCount)),ne.push(...se.toInsert);return{removed:ae,added:ne}}e.delta=_;function w(ie,ce,me){if(me===0)return[];const J=ie.slice(0,me).sort(ce);return g(ie,ce,J,me,ie.length),J}e.top=w;function h(ie,ce,me,J,ae){return me===0?Promise.resolve([]):new Promise((ne,se)=>{(async()=>{const N=ie.length,j=ie.slice(0,me).sort(ce);for(let G=me,X=Math.min(me+J,N);G<N;G=X,X=Math.min(X+J,N)){if(G>me&&await new Promise(ge=>setTimeout(ge)),ae&&ae.isCancellationRequested)throw new c.CancellationError;g(ie,ce,j,G,X)}return j})().then(ne,se)})}e.topAsync=h;function g(ie,ce,me,J,ae){for(const ne=me.length;J<ae;J++){const se=ie[J];if(ce(se,me[ne-1])<0){me.pop();const N=k(me,j=>ce(se,j)<0);me.splice(N,0,se)}}}function f(ie){return ie.filter(ce=>!!ce)}e.coalesce=f;function v(ie){let ce=0;for(let me=0;me<ie.length;me++)ie[me]&&(ie[ce]=ie[me],ce+=1);ie.length=ce}e.coalesceInPlace=v;function m(ie,ce,me){ie.splice(me,0,ie.splice(ce,1)[0])}e.move=m;function r(ie){return!Array.isArray(ie)||ie.length===0}e.isFalsyOrEmpty=r;function b(ie){return Array.isArray(ie)&&ie.length>0}e.isNonEmptyArray=b;function s(ie,ce=me=>me){const me=new Set;return ie.filter(J=>{const ae=ce(J);return me.has(ae)?!1:(me.add(ae),!0)})}e.distinct=s;function u(ie){const ce=new Set;return me=>{const J=ie(me);return ce.has(J)?!1:(ce.add(J),!0)}}e.uniqueFilter=u;function o(ie,ce){const me=l(ie,ce);if(me!==-1)return ie[me]}e.findLast=o;function l(ie,ce){for(let me=ie.length-1;me>=0;me--){const J=ie[me];if(ce(J))return me}return-1}e.lastIndex=l;function a(ie,ce){return ie.length>0?ie[0]:ce}e.firstOrDefault=a;function d(ie,ce){return ie.length>0?ie[ie.length-1]:ce}e.lastOrDefault=d;function n(ie,ce,me=(J,ae)=>J===ae){let J=0;for(let ae=0,ne=Math.min(ie.length,ce.length);ae<ne&&me(ie[ae],ce[ae]);ae++)J++;return J}e.commonPrefixLength=n;function i(ie){return[].concat(...ie)}e.flatten=i;function p(ie,ce){let me=typeof ce=="number"?ie:0;typeof ce=="number"?me=ie:(me=0,ce=ie);const J=[];if(me<=ce)for(let ae=me;ae<ce;ae++)J.push(ae);else for(let ae=me;ae>ce;ae--)J.push(ae);return J}e.range=p;function C(ie,ce,me){return ie.reduce((J,ae)=>(J[ce(ae)]=me?me(ae):ae,J),Object.create(null))}e.index=C;function R(ie,ce){return ie.push(ce),()=>M(ie,ce)}e.insert=R;function M(ie,ce){const me=ie.indexOf(ce);if(me>-1)return ie.splice(me,1),ce}e.remove=M;function $(ie,ce,me){const J=ie.slice(0,ce),ae=ie.slice(ce);return J.concat(me,ae)}e.arrayInsert=$;function x(ie,ce){let me;if(typeof ce=="number"){let J=ce;me=()=>{const ae=Math.sin(J++)*179426549;return ae-Math.floor(ae)}}else me=Math.random;for(let J=ie.length-1;J>0;J-=1){const ae=Math.floor(me()*(J+1)),ne=ie[J];ie[J]=ie[ae],ie[ae]=ne}}e.shuffle=x;function L(ie,ce){const me=ie.indexOf(ce);me>-1&&(ie.splice(me,1),ie.unshift(ce))}e.pushToStart=L;function B(ie,ce){const me=ie.indexOf(ce);me>-1&&(ie.splice(me,1),ie.push(ce))}e.pushToEnd=B;function O(ie,ce){for(const me of ce)ie.push(me)}e.pushMany=O;function z(ie,ce){return Array.isArray(ie)?ie.map(ce):ce(ie)}e.mapArrayOrNot=z;function U(ie){return Array.isArray(ie)?ie:[ie]}e.asArray=U;function F(ie){return ie[Math.floor(Math.random()*ie.length)]}e.getRandomElement=F;function V(ie,ce){for(const me of ie){const J=ce(me);if(J!==void 0)return J}}e.mapFind=V;function H(ie,ce,me){const J=K(ie,ce),ae=ie.length,ne=me.length;ie.length=ae+ne;for(let se=ae-1;se>=J;se--)ie[se+ne]=ie[se];for(let se=0;se<ne;se++)ie[se+J]=me[se]}e.insertInto=H;function Q(ie,ce,me,J){const ae=K(ie,ce),ne=ie.splice(ae,me);return H(ie,ae,J),ne}e.splice=Q;function K(ie,ce){return ce<0?Math.max(ce+ie.length,0):Math.min(ce,ie.length)}var de;(function(ie){function ce(ae){return ae<0}ie.isLessThan=ce;function me(ae){return ae>0}ie.isGreaterThan=me;function J(ae){return ae===0}ie.isNeitherLessOrGreaterThan=J,ie.greaterThan=1,ie.lessThan=-1,ie.neitherLessOrGreaterThan=0})(de=e.CompareResult||(e.CompareResult={}));function ee(ie,ce){return(me,J)=>ce(ie(me),ie(J))}e.compareBy=ee;function fe(...ie){return(ce,me)=>{for(const J of ie){const ae=J(ce,me);if(!de.isNeitherLessOrGreaterThan(ae))return ae}return de.neitherLessOrGreaterThan}}e.tieBreakComparators=fe;const Y=(ie,ce)=>ie-ce;e.numberComparator=Y;function ve(ie,ce){if(ie.length===0)return;let me=ie[0];for(let J=1;J<ie.length;J++){const ae=ie[J];ce(ae,me)>0&&(me=ae)}return me}e.findMaxBy=ve;function Ee(ie,ce){if(ie.length===0)return;let me=ie[0];for(let J=1;J<ie.length;J++){const ae=ie[J];ce(ae,me)>=0&&(me=ae)}return me}e.findLastMaxBy=Ee;function ke(ie,ce){return ve(ie,(me,J)=>-ce(me,J))}e.findMinBy=ke;class Re{constructor(ce){this.items=ce,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ce){let me=this.firstIdx;for(;me<this.items.length&&ce(this.items[me]);)me++;const J=me===this.firstIdx?null:this.items.slice(this.firstIdx,me);return this.firstIdx=me,J}takeFromEndWhile(ce){let me=this.lastIdx;for(;me>=0&&ce(this.items[me]);)me--;const J=me===this.lastIdx?null:this.items.slice(me+1,this.lastIdx+1);return this.lastIdx=me,J}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ce=this.items[this.firstIdx];return this.firstIdx++,ce}removeLast(){const ce=this.items[this.lastIdx];return this.lastIdx--,ce}takeCount(ce){const me=this.items.slice(this.firstIdx,this.firstIdx+ce);return this.firstIdx+=ce,me}}e.ArrayQueue=Re;class ze{constructor(ce){this.iterate=ce}forEach(ce){this.iterate(me=>(ce(me),!0))}toArray(){const ce=[];return this.iterate(me=>(ce.push(me),!0)),ce}filter(ce){return new ze(me=>this.iterate(J=>ce(J)?me(J):!0))}map(ce){return new ze(me=>this.iterate(J=>me(ce(J))))}some(ce){let me=!1;return this.iterate(J=>(me=ce(J),!me)),me}findFirst(ce){let me;return this.iterate(J=>ce(J)?(me=J,!1):!0),me}findLast(ce){let me;return this.iterate(J=>(ce(J)&&(me=J),!0)),me}findLastMaxBy(ce){let me,J=!0;return this.iterate(ae=>((J||de.isGreaterThan(ce(ae,me)))&&(J=!1,me=ae),!0)),me}}e.CallbackIterable=ze,ze.empty=new ze(ie=>{})}),define(De[48],Ie([1,0,10]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,k){if(!S)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=t;function D(S,k="Unreachable"){throw new Error(k)}e.assertNever=D;function P(S){if(!S)throw new c.BugIndicatingError("Assertion Failed")}e.assert=P;function y(S){if(!S()){debugger;S(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=y;function T(S,k){let A=0;for(;A<S.length-1;){const I=S[A],E=S[A+1];if(!k(I,E))return!1;A++}return!0}e.checkAdjacentItems=T}),define(De[61],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(t){const D=this;let P=!1,y;return function(){return P||(P=!0,y=t.apply(D,arguments)),y}}e.once=c}),define(De[98],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(De[62],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function D(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}t.is=D;const P=Object.freeze([]);function y(){return P}t.empty=y;function*T(r){yield r}t.single=T;function S(r){return D(r)?r:T(r)}t.wrap=S;function k(r){return r||P}t.from=k;function A(r){return!r||r[Symbol.iterator]().next().done===!0}t.isEmpty=A;function I(r){return r[Symbol.iterator]().next().value}t.first=I;function E(r,b){for(const s of r)if(b(s))return!0;return!1}t.some=E;function _(r,b){for(const s of r)if(b(s))return s}t.find=_;function*w(r,b){for(const s of r)b(s)&&(yield s)}t.filter=w;function*h(r,b){let s=0;for(const u of r)yield b(u,s++)}t.map=h;function*g(...r){for(const b of r)for(const s of b)yield s}t.concat=g;function f(r,b,s){let u=s;for(const o of r)u=b(u,o);return u}t.reduce=f;function*v(r,b,s=r.length){for(b<0&&(b+=r.length),s<0?s+=r.length:s>r.length&&(s=r.length);b<s;b++)yield r[b]}t.slice=v;function m(r,b=Number.POSITIVE_INFINITY){const s=[];if(b===0)return[s,r];const u=r[Symbol.iterator]();for(let o=0;o<b;o++){const l=u.next();if(l.done)return[s,t.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return u}}]}t.consume=m})(c=e.Iterable||(e.Iterable={}))}),define(De[144],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(s){s.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function y(s,u=!1){let o=0;const l=s.length;let a="",d=0,n=16,i=0;function p(B){let O=0,z=0;for(;O<B;){const U=s.charCodeAt(o);if(U>=48&&U<=57)z=z*16+U-48;else if(U>=65&&U<=70)z=z*16+U-65+10;else if(U>=97&&U<=102)z=z*16+U-97+10;else break;o++,O++}return O<B&&(z=-1),z}function C(B){o=B,a="",d=0,n=16,i=0}function R(){const B=o;if(s.charCodeAt(o)===48)o++;else for(o++;o<s.length&&k(s.charCodeAt(o));)o++;if(o<s.length&&s.charCodeAt(o)===46)if(o++,o<s.length&&k(s.charCodeAt(o)))for(o++;o<s.length&&k(s.charCodeAt(o));)o++;else return i=3,s.substring(B,o);let O=o;if(o<s.length&&(s.charCodeAt(o)===69||s.charCodeAt(o)===101))if(o++,(o<s.length&&s.charCodeAt(o)===43||s.charCodeAt(o)===45)&&o++,o<s.length&&k(s.charCodeAt(o))){for(o++;o<s.length&&k(s.charCodeAt(o));)o++;O=o}else i=3;return s.substring(B,O)}function M(){let B="",O=o;for(;;){if(o>=l){B+=s.substring(O,o),i=2;break}const z=s.charCodeAt(o);if(z===34){B+=s.substring(O,o),o++;break}if(z===92){if(B+=s.substring(O,o),o++,o>=l){i=2;break}switch(s.charCodeAt(o++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const F=p(4);F>=0?B+=String.fromCharCode(F):i=4;break}default:i=5}O=o;continue}if(z>=0&&z<=31)if(S(z)){B+=s.substring(O,o),i=2;break}else i=6;o++}return B}function $(){if(a="",i=0,d=o,o>=l)return d=l,n=17;let B=s.charCodeAt(o);if(T(B)){do o++,a+=String.fromCharCode(B),B=s.charCodeAt(o);while(T(B));return n=15}if(S(B))return o++,a+=String.fromCharCode(B),B===13&&s.charCodeAt(o)===10&&(o++,a+=`
`),n=14;switch(B){case 123:return o++,n=1;case 125:return o++,n=2;case 91:return o++,n=3;case 93:return o++,n=4;case 58:return o++,n=6;case 44:return o++,n=5;case 34:return o++,a=M(),n=10;case 47:{const O=o-1;if(s.charCodeAt(o+1)===47){for(o+=2;o<l&&!S(s.charCodeAt(o));)o++;return a=s.substring(O,o),n=12}if(s.charCodeAt(o+1)===42){o+=2;const z=l-1;let U=!1;for(;o<z;){if(s.charCodeAt(o)===42&&s.charCodeAt(o+1)===47){o+=2,U=!0;break}o++}return U||(o++,i=1),a=s.substring(O,o),n=13}return a+=String.fromCharCode(B),o++,n=16}case 45:if(a+=String.fromCharCode(B),o++,o===l||!k(s.charCodeAt(o)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=R(),n=11;default:for(;o<l&&x(B);)o++,B=s.charCodeAt(o);if(d!==o){switch(a=s.substring(d,o),a){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return a+=String.fromCharCode(B),o++,n=16}}function x(B){if(T(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let B;do B=$();while(B>=12&&B<=15);return B}return{setPosition:C,getPosition:()=>o,scan:u?L:$,getToken:()=>n,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>o-d,getTokenError:()=>i}}e.createScanner=y;function T(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function k(s){return s>=48&&s<=57}var A;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(A||(A={}));function I(s,u){const o=[],l=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function i(p,C,R,M){d.value=p,d.offset=C,d.length=R,d.type=M,d.colonOffset=void 0,a=d}try{m(s,{onObjectBegin:(p,C)=>{if(u<=p)throw l;a=void 0,n=u>p,o.push("")},onObjectProperty:(p,C,R)=>{if(u<C||(i(p,C,R,"property"),o[o.length-1]=p,u<=C+R))throw l},onObjectEnd:(p,C)=>{if(u<=p)throw l;a=void 0,o.pop()},onArrayBegin:(p,C)=>{if(u<=p)throw l;a=void 0,o.push(0)},onArrayEnd:(p,C)=>{if(u<=p)throw l;a=void 0,o.pop()},onLiteralValue:(p,C,R)=>{if(u<C||(i(p,C,R,b(p)),u<=C+R))throw l},onSeparator:(p,C,R)=>{if(u<=C)throw l;if(p===":"&&a&&a.type==="property")a.colonOffset=C,n=!1,a=void 0;else if(p===","){const M=o[o.length-1];typeof M=="number"?o[o.length-1]=M+1:(n=!0,o[o.length-1]=""),a=void 0}}})}catch(p){if(p!==l)throw p}return{path:o,previousNode:a,isAtPropertyKey:n,matches:p=>{let C=0;for(let R=0;C<p.length&&R<o.length;R++)if(p[C]===o[R]||p[C]==="*")C++;else if(p[C]!=="**")return!1;return C===p.length}}}e.getLocation=I;function E(s,u=[],o=P.DEFAULT){let l=null,a=[];const d=[];function n(p){Array.isArray(a)?a.push(p):l!==null&&(a[l]=p)}return m(s,{onObjectBegin:()=>{const p={};n(p),d.push(a),a=p,l=null},onObjectProperty:p=>{l=p},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const p=[];n(p),d.push(a),a=p,l=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:n,onError:(p,C,R)=>{u.push({error:p,offset:C,length:R})}},o),a[0]}e.parse=E;function _(s,u=[],o=P.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){l.type==="property"&&(l.length=p-l.offset,l=l.parent)}function d(p){return l.children.push(p),p}m(s,{onObjectBegin:p=>{l=d({type:"object",offset:p,length:-1,parent:l,children:[]})},onObjectProperty:(p,C,R)=>{l=d({type:"property",offset:C,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:p,offset:C,length:R,parent:l})},onObjectEnd:(p,C)=>{l.length=p+C-l.offset,l=l.parent,a(p+C)},onArrayBegin:(p,C)=>{l=d({type:"array",offset:p,length:-1,parent:l,children:[]})},onArrayEnd:(p,C)=>{l.length=p+C-l.offset,l=l.parent,a(p+C)},onLiteralValue:(p,C,R)=>{d({type:b(p),offset:C,length:R,parent:l,value:p}),a(C+R)},onSeparator:(p,C,R)=>{l.type==="property"&&(p===":"?l.colonOffset=C:p===","&&a(C))},onError:(p,C,R)=>{u.push({error:p,offset:C,length:R})}},o);const i=l.children[0];return i&&delete i.parent,i}e.parseTree=_;function w(s,u){if(!s)return;let o=s;for(const l of u)if(typeof l=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let a=!1;for(const d of o.children)if(Array.isArray(d.children)&&d.children[0].value===l){o=d.children[1],a=!0;break}if(!a)return}else{const a=l;if(o.type!=="array"||a<0||!Array.isArray(o.children)||a>=o.children.length)return;o=o.children[a]}return o}e.findNodeAtLocation=w;function h(s){if(!s.parent||!s.parent.children)return[];const u=h(s.parent);if(s.parent.type==="property"){const o=s.parent.children[0].value;u.push(o)}else if(s.parent.type==="array"){const o=s.parent.children.indexOf(s);o!==-1&&u.push(o)}return u}e.getNodePath=h;function g(s){switch(s.type){case"array":return s.children.map(g);case"object":{const u=Object.create(null);for(const o of s.children){const l=o.children[1];l&&(u[o.children[0].value]=g(l))}return u}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=g;function f(s,u,o=!1){return u>=s.offset&&u<s.offset+s.length||o&&u===s.offset+s.length}e.contains=f;function v(s,u,o=!1){if(f(s,u,o)){const l=s.children;if(Array.isArray(l))for(let a=0;a<l.length&&l[a].offset<=u;a++){const d=v(l[a],u,o);if(d)return d}return s}}e.findNodeAtOffset=v;function m(s,u,o=P.DEFAULT){const l=y(s,!1);function a(ee){return ee?()=>ee(l.getTokenOffset(),l.getTokenLength()):()=>!0}function d(ee){return ee?fe=>ee(fe,l.getTokenOffset(),l.getTokenLength()):()=>!0}const n=a(u.onObjectBegin),i=d(u.onObjectProperty),p=a(u.onObjectEnd),C=a(u.onArrayBegin),R=a(u.onArrayEnd),M=d(u.onLiteralValue),$=d(u.onSeparator),x=a(u.onComment),L=d(u.onError),B=o&&o.disallowComments,O=o&&o.allowTrailingComma;function z(){for(;;){const ee=l.scan();switch(l.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:B||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ee){case 12:case 13:B?U(10):x();break;case 16:U(1);break;case 15:case 14:break;default:return ee}}}function U(ee,fe=[],Y=[]){if(L(ee),fe.length+Y.length>0){let ve=l.getToken();for(;ve!==17;){if(fe.indexOf(ve)!==-1){z();break}else if(Y.indexOf(ve)!==-1)break;ve=z()}}}function F(ee){const fe=l.getTokenValue();return ee?M(fe):i(fe),z(),!0}function V(){switch(l.getToken()){case 11:{let ee=0;try{ee=JSON.parse(l.getTokenValue()),typeof ee!="number"&&(U(2),ee=0)}catch{U(2)}M(ee);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return z(),!0}function H(){return l.getToken()!==10?(U(3,[],[2,5]),!1):(F(!1),l.getToken()===6?($(":"),z(),de()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function Q(){n(),z();let ee=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ee||U(4,[],[]),$(","),z(),l.getToken()===2&&O)break}else ee&&U(6,[],[]);H()||U(4,[],[2,5]),ee=!0}return p(),l.getToken()!==2?U(7,[2],[]):z(),!0}function K(){C(),z();let ee=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ee||U(4,[],[]),$(","),z(),l.getToken()===4&&O)break}else ee&&U(6,[],[]);de()||U(4,[],[4,5]),ee=!0}return R(),l.getToken()!==4?U(8,[4],[]):z(),!0}function de(){switch(l.getToken()){case 3:return K();case 1:return Q();case 10:return F(!0);default:return V()}}return z(),l.getToken()===17?o.allowEmptyContent?!0:(U(4,[],[]),!1):de()?(l.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=m;function r(s,u){const o=y(s),l=[];let a,d=0,n;do switch(n=o.getPosition(),a=o.scan(),a){case 12:case 13:case 17:d!==n&&l.push(s.substring(d,n)),u!==void 0&&l.push(o.getTokenValue().replace(/[^\r\n]/g,u)),d=o.getPosition();break}while(a!==17);return l.join("")}e.stripComments=r;function b(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(De[79],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new c(()=>D(this.getValue()))}}e.Lazy=c}),define(De[6],Ie([1,0,61,62]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let P=null;function y(d){P=d}if(e.setDisposableTracker=y,D){const d="__is_disposable_tracked__";y(new class{trackDisposable(n){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[d]||console.log(i)},3e3)}setParent(n,i){if(n&&n!==v.None)try{n[d]=!0}catch{}}markAsDisposed(n){if(n&&n!==v.None)try{n[d]=!0}catch{}}markAsSingleton(n){}})}function T(d){return P?.trackDisposable(d),d}function S(d){P?.markAsDisposed(d)}function k(d,n){P?.setParent(d,n)}function A(d,n){if(!!P)for(const i of d)P.setParent(i,n)}function I(d){return P?.markAsSingleton(d),d}e.markAsSingleton=I;function E(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=E;function _(d){if(t.Iterable.is(d)){const n=[];for(const i of d)if(i)try{i.dispose()}catch(p){n.push(p)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}e.dispose=_;function w(d){for(const n of d)E(n)&&n.dispose();return[]}e.disposeIfDisposable=w;function h(...d){const n=g(()=>_(d));return A(d,n),n}e.combinedDisposable=h;function g(d){const n=T({dispose:(0,c.once)(()=>{S(n),d()})});return n}e.toDisposable=g;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,T(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{_(this._toDispose)}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return k(n,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new f,T(this),k(this._store,this)}dispose(){S(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,T(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&k(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&k(n,null),n}}e.MutableDisposable=m;class r{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(n){let i=n;return this.unset=()=>i=void 0,this.isset=()=>i!==void 0,this.dispose=()=>{i&&(i(),i=void 0,S(this))},this}}e.SafeDisposable=b;class s{constructor(){this.references=new Map}acquire(n,...i){let p=this.references.get(n);p||(p={counter:0,object:this.createReferencedObject(n,...i)},this.references.set(n,p));const{object:C}=p,R=(0,c.once)(()=>{--p.counter===0&&(this.destroyReferencedObject(n,p.object),this.references.delete(n))});return p.counter++,{object:C,dispose:R}}}e.ReferenceCollection=s;class u{constructor(n){this.referenceCollection=n}async acquire(n,...i){const p=this.referenceCollection.acquire(n,...i);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(C){throw p.dispose(),C}}}e.AsyncReferenceCollection=u;class o{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=o;function l(d){const n=new f;try{d(n)}finally{n.dispose()}}e.disposeOnReturn=l;class a{constructor(){this._store=new Map,this._isDisposed=!1,T(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{_(this._store.values())}finally{this._store.clear()}}has(n){return this._store.has(n)}get(n){return this._store.get(n)}set(n,i,p=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||this._store.get(n)?.dispose(),this._store.set(n,i)}deleteAndDispose(n){this._store.get(n)?.dispose(),this._store.delete(n)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=a}),define(De[63],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(P){this.element=P,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class t{constructor(){this._first=c.Undefined,this._last=c.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===c.Undefined}clear(){let P=this._first;for(;P!==c.Undefined;){const y=P.next;P.prev=c.Undefined,P.next=c.Undefined,P=y}this._first=c.Undefined,this._last=c.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,y){const T=new c(P);if(this._first===c.Undefined)this._first=T,this._last=T;else if(y){const k=this._last;this._last=T,T.prev=k,k.next=T}else{const k=this._first;this._first=T,T.next=k,k.prev=T}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(T))}}shift(){if(this._first!==c.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==c.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==c.Undefined&&P.next!==c.Undefined){const y=P.prev;y.next=P.next,P.next.prev=y}else P.prev===c.Undefined&&P.next===c.Undefined?(this._first=c.Undefined,this._last=c.Undefined):P.next===c.Undefined?(this._last=this._last.prev,this._last.next=c.Undefined):P.prev===c.Undefined&&(this._first=this._first.next,this._first.prev=c.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==c.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),define(De[28],Ie([1,0]),function(Z,e){"use strict";var c,t,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function P(w,h,g){let f=w.get(h);return f===void 0&&(f=g,w.set(h,f)),f}e.getOrSet=P;function y(w){const h=[];return w.forEach((g,f)=>{h.push(`${f} => ${g}`)}),`Map(${w.size}) {${h.join(", ")}}`}e.mapToString=y;function T(w){const h=[];return w.forEach(g=>{h.push(g)}),`Set(${w.size}) {${h.join(", ")}}`}e.setToString=T;class S{constructor(h,g){this.uri=h,this.value=g}}class k{constructor(h,g){this[c]="ResourceMap",h instanceof k?(this.map=new Map(h.map),this.toKey=g??k.defaultToKey):(this.map=new Map,this.toKey=h??k.defaultToKey)}set(h,g){return this.map.set(this.toKey(h),new S(h,g)),this}get(h){return this.map.get(this.toKey(h))?.value}has(h){return this.map.has(this.toKey(h))}get size(){return this.map.size}clear(){this.map.clear()}delete(h){return this.map.delete(this.toKey(h))}forEach(h,g){typeof g<"u"&&(h=h.bind(g));for(const[f,v]of this.map)h(v.value,v.uri,this)}*values(){for(const h of this.map.values())yield h.value}*keys(){for(const h of this.map.values())yield h.uri}*entries(){for(const h of this.map.values())yield[h.uri,h.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.map)yield[h.uri,h.value]}}e.ResourceMap=k,k.defaultToKey=w=>w.toString();class A{constructor(h,g){this[t]="ResourceSet",!h||typeof h=="function"?this._map=new k(h):(this._map=new k(g),h.forEach(this.add,this))}get size(){return this._map.size}add(h){return this._map.set(h,h),this}clear(){this._map.clear()}delete(h){return this._map.delete(h)}forEach(h,g){this._map.forEach((f,v)=>h.call(g,v,v,this))}has(h){return this._map.has(h)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=A;var I;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class E{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(h){return this._map.has(h)}get(h,g=0){const f=this._map.get(h);if(!!f)return g!==0&&this.touch(f,g),f.value}set(h,g,f=0){let v=this._map.get(h);if(v)v.value=g,f!==0&&this.touch(v,f);else{switch(v={key:h,value:g,next:void 0,previous:void 0},f){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(h,v),this._size++}return this}delete(h){return!!this.remove(h)}remove(h){const g=this._map.get(h);if(!!g)return this._map.delete(h),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const h=this._head;return this._map.delete(h.key),this.removeItem(h),this._size--,h.value}forEach(h,g){const f=this._state;let v=this._head;for(;v;){if(g?h.bind(g)(v.value,v.key,this):h(v.value,v.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const h=this,g=this._state;let f=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:f.key,done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return v}values(){const h=this,g=this._state;let f=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:f.value,done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return v}entries(){const h=this,g=this._state;let f=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:[f.key,f.value],done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return v}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(h){if(h>=this.size)return;if(h===0){this.clear();return}let g=this._head,f=this.size;for(;g&&f>h;)this._map.delete(g.key),g=g.next,f--;this._head=g,this._size=f,g&&(g.previous=void 0),this._state++}addItemFirst(h){if(!this._head&&!this._tail)this._tail=h;else if(this._head)h.next=this._head,this._head.previous=h;else throw new Error("Invalid list");this._head=h,this._state++}addItemLast(h){if(!this._head&&!this._tail)this._head=h;else if(this._tail)h.previous=this._tail,this._tail.next=h;else throw new Error("Invalid list");this._tail=h,this._state++}removeItem(h){if(h===this._head&&h===this._tail)this._head=void 0,this._tail=void 0;else if(h===this._head){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this._head=h.next}else if(h===this._tail){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this._tail=h.previous}else{const g=h.next,f=h.previous;if(!g||!f)throw new Error("Invalid list");g.previous=f,f.next=g}h.next=void 0,h.previous=void 0,this._state++}touch(h,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(h===this._head)return;const f=h.next,v=h.previous;h===this._tail?(v.next=void 0,this._tail=v):(f.previous=v,v.next=f),h.previous=void 0,h.next=this._head,this._head.previous=h,this._head=h,this._state++}else if(g===2){if(h===this._tail)return;const f=h.next,v=h.previous;h===this._head?(f.previous=void 0,this._head=f):(f.previous=v,v.next=f),h.next=void 0,h.previous=this._tail,this._tail.next=h,this._tail=h,this._state++}}}toJSON(){const h=[];return this.forEach((g,f)=>{h.push([f,g])}),h}fromJSON(h){this.clear();for(const[g,f]of h)this.set(g,f)}}e.LinkedMap=E;class _ extends E{constructor(h,g=1){super(),this._limit=h,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(h){this._limit=h,this.checkTrim()}get ratio(){return this._ratio}set ratio(h){this._ratio=Math.min(Math.max(0,h),1),this.checkTrim()}get(h,g=2){return super.get(h,g)}peek(h){return super.get(h,0)}set(h,g){return super.set(h,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=_}),function(Z,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[145],Ie([0]),e):(Z=typeof globalThis<"u"?globalThis:Z||self,e(Z.marked={}))}(this,function(Z){"use strict";function e(ie,ce){for(var me=0;me<ce.length;me++){var J=ce[me];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ie,J.key,J)}}function c(ie,ce,me){return ce&&e(ie.prototype,ce),me&&e(ie,me),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function t(ie,ce){if(!!ie){if(typeof ie=="string")return D(ie,ce);var me=Object.prototype.toString.call(ie).slice(8,-1);if(me==="Object"&&ie.constructor&&(me=ie.constructor.name),me==="Map"||me==="Set")return Array.from(ie);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return D(ie,ce)}}function D(ie,ce){(ce==null||ce>ie.length)&&(ce=ie.length);for(var me=0,J=new Array(ce);me<ce;me++)J[me]=ie[me];return J}function P(ie,ce){var me=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(me)return(me=me.call(ie)).next.bind(me);if(Array.isArray(ie)||(me=t(ie))||ce&&ie&&typeof ie.length=="number"){me&&(ie=me);var J=0;return function(){return J>=ie.length?{done:!0}:{done:!1,value:ie[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=y();function T(ie){Z.defaults=ie}var S=/[&<>"']/,k=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(ce){return E[ce]};function w(ie,ce){if(ce){if(S.test(ie))return ie.replace(k,_)}else if(A.test(ie))return ie.replace(I,_);return ie}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(ie){return ie.replace(h,function(ce,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var f=/(^|[^\[])\^/g;function v(ie,ce){ie=typeof ie=="string"?ie:ie.source,ce=ce||"";var me={replace:function(ae,ne){return ne=ne.source||ne,ne=ne.replace(f,"$1"),ie=ie.replace(ae,ne),me},getRegex:function(){return new RegExp(ie,ce)}};return me}var m=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(ie,ce,me){if(ie){var J;try{J=decodeURIComponent(g(me)).replace(m,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ce&&!r.test(me)&&(me=a(ce,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var s={},u=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ie,ce){s[" "+ie]||(u.test(ie)?s[" "+ie]=ie+"/":s[" "+ie]=p(ie,"/",!0)),ie=s[" "+ie];var me=ie.indexOf(":")===-1;return ce.substring(0,2)==="//"?me?ce:ie.replace(o,"$1")+ce:ce.charAt(0)==="/"?me?ce:ie.replace(l,"$1")+ce:ie+ce}var d={exec:function(){}};function n(ie){for(var ce=1,me,J;ce<arguments.length;ce++){me=arguments[ce];for(J in me)Object.prototype.hasOwnProperty.call(me,J)&&(ie[J]=me[J])}return ie}function i(ie,ce){var me=ie.replace(/\|/g,function(ne,se,N){for(var j=!1,G=se;--G>=0&&N[G]==="\\";)j=!j;return j?"|":" |"}),J=me.split(/ \|/),ae=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ce)J.splice(ce);else for(;J.length<ce;)J.push("");for(;ae<J.length;ae++)J[ae]=J[ae].trim().replace(/\\\|/g,"|");return J}function p(ie,ce,me){var J=ie.length;if(J===0)return"";for(var ae=0;ae<J;){var ne=ie.charAt(J-ae-1);if(ne===ce&&!me)ae++;else if(ne!==ce&&me)ae++;else break}return ie.slice(0,J-ae)}function C(ie,ce){if(ie.indexOf(ce[1])===-1)return-1;for(var me=ie.length,J=0,ae=0;ae<me;ae++)if(ie[ae]==="\\")ae++;else if(ie[ae]===ce[0])J++;else if(ie[ae]===ce[1]&&(J--,J<0))return ae;return-1}function R(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(ie,ce){if(ce<1)return"";for(var me="";ce>1;)ce&1&&(me+=ie),ce>>=1,ie+=ie;return me+ie}function $(ie,ce,me,J){var ae=ce.href,ne=ce.title?w(ce.title):null,se=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){J.state.inLink=!0;var N={type:"link",raw:me,href:ae,title:ne,text:se,tokens:J.inlineTokens(se)};return J.state.inLink=!1,N}return{type:"image",raw:me,href:ae,title:ne,text:w(se)}}function x(ie,ce){var me=ie.match(/^(\s+)(?:```)/);if(me===null)return ce;var J=me[1];return ce.split(`
`).map(function(ae){var ne=ae.match(/^\s+/);if(ne===null)return ae;var se=ne[0];return se.length>=J.length?ae.slice(J.length):ae}).join(`
`)}var L=function(){function ie(me){this.options=me||Z.defaults}var ce=ie.prototype;return ce.space=function(J){var ae=this.rules.block.newline.exec(J);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},ce.code=function(J){var ae=this.rules.block.code.exec(J);if(ae){var ne=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:p(ne,`
`)}}},ce.fences=function(J){var ae=this.rules.block.fences.exec(J);if(ae){var ne=ae[0],se=x(ne,ae[3]||"");return{type:"code",raw:ne,lang:ae[2]?ae[2].trim():ae[2],text:se}}},ce.heading=function(J){var ae=this.rules.block.heading.exec(J);if(ae){var ne=ae[2].trim();if(/#$/.test(ne)){var se=p(ne,"#");(this.options.pedantic||!se||/ $/.test(se))&&(ne=se.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ne,tokens:this.lexer.inline(ne)}}},ce.hr=function(J){var ae=this.rules.block.hr.exec(J);if(ae)return{type:"hr",raw:ae[0]}},ce.blockquote=function(J){var ae=this.rules.block.blockquote.exec(J);if(ae){var ne=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},ce.list=function(J){var ae=this.rules.block.list.exec(J);if(ae){var ne,se,N,j,G,X,ge,be,le,ye,Ce,We,je=ae[1].trim(),Je=je.length>1,Qe={type:"list",raw:"",ordered:Je,start:Je?+je.slice(0,-1):"",loose:!1,items:[]};je=Je?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Je?je:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(We=!1,!(!(ae=Ze.exec(J))||this.rules.block.hr.test(J)));){if(ne=ae[0],J=J.substring(ne.length),be=ae[2].split(`
`,1)[0],le=J.split(`
`,1)[0],this.options.pedantic?(j=2,Ce=be.trimLeft()):(j=ae[2].search(/[^ ]/),j=j>4?1:j,Ce=be.slice(j),j+=ae[1].length),X=!1,!be&&/^ *$/.test(le)&&(ne+=le+`
`,J=J.substring(le.length+1),We=!0),!We)for(var Be=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ut=new RegExp("^ {0,"+Math.min(3,j-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),re=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:```|~~~)"),oe=new RegExp("^ {0,"+Math.min(3,j-1)+"}#");J&&(ye=J.split(`
`,1)[0],be=ye,this.options.pedantic&&(be=be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(re.test(be)||oe.test(be)||Be.test(be)||ut.test(J)));){if(be.search(/[^ ]/)>=j||!be.trim())Ce+=`
`+be.slice(j);else if(!X)Ce+=`
`+be;else break;!X&&!be.trim()&&(X=!0),ne+=ye+`
`,J=J.substring(ye.length+1)}Qe.loose||(ge?Qe.loose=!0:/\n *\n *$/.test(ne)&&(ge=!0)),this.options.gfm&&(se=/^\[[ xX]\] /.exec(Ce),se&&(N=se[0]!=="[ ] ",Ce=Ce.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ne,task:!!se,checked:N,loose:!1,text:Ce}),Qe.raw+=ne}Qe.items[Qe.items.length-1].raw=ne.trimRight(),Qe.items[Qe.items.length-1].text=Ce.trimRight(),Qe.raw=Qe.raw.trimRight();var _e=Qe.items.length;for(G=0;G<_e;G++){this.lexer.state.top=!1,Qe.items[G].tokens=this.lexer.blockTokens(Qe.items[G].text,[]);var ue=Qe.items[G].tokens.filter(function(Le){return Le.type==="space"}),Pe=ue.every(function(Le){for(var Ne=Le.raw.split(""),qe=0,Ye=P(Ne),it;!(it=Ye()).done;){var bt=it.value;if(bt===`
`&&(qe+=1),qe>1)return!0}return!1});!Qe.loose&&ue.length&&Pe&&(Qe.loose=!0,Qe.items[G].loose=!0)}return Qe}},ce.html=function(J){var ae=this.rules.block.html.exec(J);if(ae){var ne={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var se=this.options.sanitizer?this.options.sanitizer(ae[0]):w(ae[0]);ne.type="paragraph",ne.text=se,ne.tokens=this.lexer.inline(se)}return ne}},ce.def=function(J){var ae=this.rules.block.def.exec(J);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ne=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ae[0],href:ae[2],title:ae[3]}}},ce.table=function(J){var ae=this.rules.block.table.exec(J);if(ae){var ne={type:"table",header:i(ae[1]).map(function(ge){return{text:ge}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ae[0];var se=ne.align.length,N,j,G,X;for(N=0;N<se;N++)/^ *-+: *$/.test(ne.align[N])?ne.align[N]="right":/^ *:-+: *$/.test(ne.align[N])?ne.align[N]="center":/^ *:-+ *$/.test(ne.align[N])?ne.align[N]="left":ne.align[N]=null;for(se=ne.rows.length,N=0;N<se;N++)ne.rows[N]=i(ne.rows[N],ne.header.length).map(function(ge){return{text:ge}});for(se=ne.header.length,j=0;j<se;j++)ne.header[j].tokens=this.lexer.inline(ne.header[j].text);for(se=ne.rows.length,j=0;j<se;j++)for(X=ne.rows[j],G=0;G<X.length;G++)X[G].tokens=this.lexer.inline(X[G].text);return ne}}},ce.lheading=function(J){var ae=this.rules.block.lheading.exec(J);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},ce.paragraph=function(J){var ae=this.rules.block.paragraph.exec(J);if(ae){var ne=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ne,tokens:this.lexer.inline(ne)}}},ce.text=function(J){var ae=this.rules.block.text.exec(J);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},ce.escape=function(J){var ae=this.rules.inline.escape.exec(J);if(ae)return{type:"escape",raw:ae[0],text:w(ae[1])}},ce.tag=function(J){var ae=this.rules.inline.tag.exec(J);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):w(ae[0]):ae[0]}},ce.link=function(J){var ae=this.rules.inline.link.exec(J);if(ae){var ne=ae[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var se=p(ne.slice(0,-1),"\\");if((ne.length-se.length)%2===0)return}else{var N=C(ae[2],"()");if(N>-1){var j=ae[0].indexOf("!")===0?5:4,G=j+ae[1].length+N;ae[2]=ae[2].substring(0,N),ae[0]=ae[0].substring(0,G).trim(),ae[3]=""}}var X=ae[2],ge="";if(this.options.pedantic){var be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);be&&(X=be[1],ge=be[3])}else ge=ae[3]?ae[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ne)?X=X.slice(1):X=X.slice(1,-1)),$(ae,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},ce.reflink=function(J,ae){var ne;if((ne=this.rules.inline.reflink.exec(J))||(ne=this.rules.inline.nolink.exec(J))){var se=(ne[2]||ne[1]).replace(/\s+/g," ");if(se=ae[se.toLowerCase()],!se||!se.href){var N=ne[0].charAt(0);return{type:"text",raw:N,text:N}}return $(ne,se,ne[0],this.lexer)}},ce.emStrong=function(J,ae,ne){ne===void 0&&(ne="");var se=this.rules.inline.emStrong.lDelim.exec(J);if(!!se&&!(se[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var N=se[1]||se[2]||"";if(!N||N&&(ne===""||this.rules.inline.punctuation.exec(ne))){var j=se[0].length-1,G,X,ge=j,be=0,le=se[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,ae=ae.slice(-1*J.length+j);(se=le.exec(ae))!=null;)if(G=se[1]||se[2]||se[3]||se[4]||se[5]||se[6],!!G){if(X=G.length,se[3]||se[4]){ge+=X;continue}else if((se[5]||se[6])&&j%3&&!((j+X)%3)){be+=X;continue}if(ge-=X,!(ge>0)){if(X=Math.min(X,X+ge+be),Math.min(j,X)%2){var ye=J.slice(1,j+se.index+X);return{type:"em",raw:J.slice(0,j+se.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}var Ce=J.slice(2,j+se.index+X-1);return{type:"strong",raw:J.slice(0,j+se.index+X+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}}}}},ce.codespan=function(J){var ae=this.rules.inline.code.exec(J);if(ae){var ne=ae[2].replace(/\n/g," "),se=/[^ ]/.test(ne),N=/^ /.test(ne)&&/ $/.test(ne);return se&&N&&(ne=ne.substring(1,ne.length-1)),ne=w(ne,!0),{type:"codespan",raw:ae[0],text:ne}}},ce.br=function(J){var ae=this.rules.inline.br.exec(J);if(ae)return{type:"br",raw:ae[0]}},ce.del=function(J){var ae=this.rules.inline.del.exec(J);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},ce.autolink=function(J,ae){var ne=this.rules.inline.autolink.exec(J);if(ne){var se,N;return ne[2]==="@"?(se=w(this.options.mangle?ae(ne[1]):ne[1]),N="mailto:"+se):(se=w(ne[1]),N=se),{type:"link",raw:ne[0],text:se,href:N,tokens:[{type:"text",raw:se,text:se}]}}},ce.url=function(J,ae){var ne;if(ne=this.rules.inline.url.exec(J)){var se,N;if(ne[2]==="@")se=w(this.options.mangle?ae(ne[0]):ne[0]),N="mailto:"+se;else{var j;do j=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(j!==ne[0]);se=w(ne[0]),ne[1]==="www."?N="http://"+se:N=se}return{type:"link",raw:ne[0],text:se,href:N,tokens:[{type:"text",raw:se,text:se}]}}},ce.inlineText=function(J,ae){var ne=this.rules.inline.text.exec(J);if(ne){var se;return this.lexer.state.inRawBlock?se=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):w(ne[0]):ne[0]:se=w(this.options.smartypants?ae(ne[0]):ne[0]),{type:"text",raw:ne[0],text:se}}},ie}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=v(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=v(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=v(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=v(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=v(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=v(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=n({},B),B.gfm=n({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=v(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=v(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=n({},B.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:v(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=v(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=v(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=v(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=v(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=v(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=v(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=v(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=v(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=v(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=v(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=v(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=n({},O),O.pedantic=n({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=n({},O.normal,{escape:v(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=v(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=n({},O.gfm,{br:v(O.br).replace("{2,}","*").getRegex(),text:v(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(ie){var ce="",me,J,ae=ie.length;for(me=0;me<ae;me++)J=ie.charCodeAt(me),Math.random()>.5&&(J="x"+J.toString(16)),ce+="&#"+J+";";return ce}var F=function(){function ie(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||Z.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:B.normal,inline:O.normal};this.options.pedantic?(J.block=B.pedantic,J.inline=O.pedantic):this.options.gfm&&(J.block=B.gfm,this.options.breaks?J.inline=O.breaks:J.inline=O.gfm),this.tokenizer.rules=J}ie.lex=function(J,ae){var ne=new ie(ae);return ne.lex(J)},ie.lexInline=function(J,ae){var ne=new ie(ae);return ne.inlineTokens(J)};var ce=ie.prototype;return ce.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},ce.blockTokens=function(J,ae){var ne=this;ae===void 0&&(ae=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(ge,be,le){return be+"    ".repeat(le.length)});for(var se,N,j,G;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(se=ge.call({lexer:ne},J,ae))?(J=J.substring(se.raw.length),ae.push(se),!0):!1}))){if(se=this.tokenizer.space(J)){J=J.substring(se.raw.length),se.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(se);continue}if(se=this.tokenizer.code(J)){J=J.substring(se.raw.length),N=ae[ae.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+se.raw,N.text+=`
`+se.text,this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(se);continue}if(se=this.tokenizer.fences(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.heading(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.hr(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.blockquote(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.list(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.html(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.def(J)){J=J.substring(se.raw.length),N=ae[ae.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+se.raw,N.text+=`
`+se.raw,this.inlineQueue[this.inlineQueue.length-1].src=N.text):this.tokens.links[se.tag]||(this.tokens.links[se.tag]={href:se.href,title:se.title});continue}if(se=this.tokenizer.table(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.lheading(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(j=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,be=J.slice(1),le=void 0;ne.options.extensions.startBlock.forEach(function(ye){le=ye.call({lexer:this},be),typeof le=="number"&&le>=0&&(ge=Math.min(ge,le))}),ge<1/0&&ge>=0&&(j=J.substring(0,ge+1))}(),this.state.top&&(se=this.tokenizer.paragraph(j))){N=ae[ae.length-1],G&&N.type==="paragraph"?(N.raw+=`
`+se.raw,N.text+=`
`+se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(se),G=j.length!==J.length,J=J.substring(se.raw.length);continue}if(se=this.tokenizer.text(J)){J=J.substring(se.raw.length),N=ae[ae.length-1],N&&N.type==="text"?(N.raw+=`
`+se.raw,N.text+=`
`+se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(se);continue}if(J){var X="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,ae},ce.inline=function(J,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:J,tokens:ae}),ae},ce.inlineTokens=function(J,ae){var ne=this;ae===void 0&&(ae=[]);var se,N,j,G=J,X,ge,be;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)le.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,X.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(ge||(be=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ce){return(se=Ce.call({lexer:ne},J,ae))?(J=J.substring(se.raw.length),ae.push(se),!0):!1}))){if(se=this.tokenizer.escape(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.tag(J)){J=J.substring(se.raw.length),N=ae[ae.length-1],N&&se.type==="text"&&N.type==="text"?(N.raw+=se.raw,N.text+=se.text):ae.push(se);continue}if(se=this.tokenizer.link(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(se.raw.length),N=ae[ae.length-1],N&&se.type==="text"&&N.type==="text"?(N.raw+=se.raw,N.text+=se.text):ae.push(se);continue}if(se=this.tokenizer.emStrong(J,G,be)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.codespan(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.br(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.del(J)){J=J.substring(se.raw.length),ae.push(se);continue}if(se=this.tokenizer.autolink(J,U)){J=J.substring(se.raw.length),ae.push(se);continue}if(!this.state.inLink&&(se=this.tokenizer.url(J,U))){J=J.substring(se.raw.length),ae.push(se);continue}if(j=J,this.options.extensions&&this.options.extensions.startInline&&function(){var Ce=1/0,We=J.slice(1),je=void 0;ne.options.extensions.startInline.forEach(function(Je){je=Je.call({lexer:this},We),typeof je=="number"&&je>=0&&(Ce=Math.min(Ce,je))}),Ce<1/0&&Ce>=0&&(j=J.substring(0,Ce+1))}(),se=this.tokenizer.inlineText(j,z)){J=J.substring(se.raw.length),se.raw.slice(-1)!=="_"&&(be=se.raw.slice(-1)),ge=!0,N=ae[ae.length-1],N&&N.type==="text"?(N.raw+=se.raw,N.text+=se.text):ae.push(se);continue}if(J){var ye="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return ae},c(ie,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),ie}(),V=function(){function ie(me){this.options=me||Z.defaults}var ce=ie.prototype;return ce.code=function(J,ae,ne){var se=(ae||"").match(/\S*/)[0];if(this.options.highlight){var N=this.options.highlight(J,se);N!=null&&N!==J&&(ne=!0,J=N)}return J=J.replace(/\n$/,"")+`
`,se?'<pre><code class="'+this.options.langPrefix+w(se,!0)+'">'+(ne?J:w(J,!0))+`</code></pre>
`:"<pre><code>"+(ne?J:w(J,!0))+`</code></pre>
`},ce.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ce.html=function(J){return J},ce.heading=function(J,ae,ne,se){if(this.options.headerIds){var N=this.options.headerPrefix+se.slug(ne);return"<h"+ae+' id="'+N+'">'+J+"</h"+ae+`>
`}return"<h"+ae+">"+J+"</h"+ae+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(J,ae,ne){var se=ae?"ol":"ul",N=ae&&ne!==1?' start="'+ne+'"':"";return"<"+se+N+`>
`+J+"</"+se+`>
`},ce.listitem=function(J){return"<li>"+J+`</li>
`},ce.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(J){return"<p>"+J+`</p>
`},ce.table=function(J,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+ae+`</table>
`},ce.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ce.tablecell=function(J,ae){var ne=ae.header?"th":"td",se=ae.align?"<"+ne+' align="'+ae.align+'">':"<"+ne+">";return se+J+("</"+ne+`>
`)},ce.strong=function(J){return"<strong>"+J+"</strong>"},ce.em=function(J){return"<em>"+J+"</em>"},ce.codespan=function(J){return"<code>"+J+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(J){return"<del>"+J+"</del>"},ce.link=function(J,ae,ne){if(J=b(this.options.sanitize,this.options.baseUrl,J),J===null)return ne;var se='<a href="'+w(J)+'"';return ae&&(se+=' title="'+ae+'"'),se+=">"+ne+"</a>",se},ce.image=function(J,ae,ne){if(J=b(this.options.sanitize,this.options.baseUrl,J),J===null)return ne;var se='<img src="'+J+'" alt="'+ne+'"';return ae&&(se+=' title="'+ae+'"'),se+=this.options.xhtml?"/>":">",se},ce.text=function(J){return J},ie}(),H=function(){function ie(){}var ce=ie.prototype;return ce.strong=function(J){return J},ce.em=function(J){return J},ce.codespan=function(J){return J},ce.del=function(J){return J},ce.html=function(J){return J},ce.text=function(J){return J},ce.link=function(J,ae,ne){return""+ne},ce.image=function(J,ae,ne){return""+ne},ce.br=function(){return""},ie}(),Q=function(){function ie(){this.seen={}}var ce=ie.prototype;return ce.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(J,ae){var ne=J,se=0;if(this.seen.hasOwnProperty(ne)){se=this.seen[J];do se++,ne=J+"-"+se;while(this.seen.hasOwnProperty(ne))}return ae||(this.seen[J]=se,this.seen[ne]=0),ne},ce.slug=function(J,ae){ae===void 0&&(ae={});var ne=this.serialize(J);return this.getNextSafeSlug(ne,ae.dryrun)},ie}(),K=function(){function ie(me){this.options=me||Z.defaults,this.options.renderer=this.options.renderer||new V,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new Q}ie.parse=function(J,ae){var ne=new ie(ae);return ne.parse(J)},ie.parseInline=function(J,ae){var ne=new ie(ae);return ne.parseInline(J)};var ce=ie.prototype;return ce.parse=function(J,ae){ae===void 0&&(ae=!0);var ne="",se,N,j,G,X,ge,be,le,ye,Ce,We,je,Je,Qe,Ze,Be,ut,re,oe,_e=J.length;for(se=0;se<_e;se++){if(Ce=J[se],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ce.type]&&(oe=this.options.extensions.renderers[Ce.type].call({parser:this},Ce),oe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ce.type))){ne+=oe||"";continue}switch(Ce.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(Ce.tokens),Ce.depth,g(this.parseInline(Ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(Ce.text,Ce.lang,Ce.escaped);continue}case"table":{for(le="",be="",G=Ce.header.length,N=0;N<G;N++)be+=this.renderer.tablecell(this.parseInline(Ce.header[N].tokens),{header:!0,align:Ce.align[N]});for(le+=this.renderer.tablerow(be),ye="",G=Ce.rows.length,N=0;N<G;N++){for(ge=Ce.rows[N],be="",X=ge.length,j=0;j<X;j++)be+=this.renderer.tablecell(this.parseInline(ge[j].tokens),{header:!1,align:Ce.align[j]});ye+=this.renderer.tablerow(be)}ne+=this.renderer.table(le,ye);continue}case"blockquote":{ye=this.parse(Ce.tokens),ne+=this.renderer.blockquote(ye);continue}case"list":{for(We=Ce.ordered,je=Ce.start,Je=Ce.loose,G=Ce.items.length,ye="",N=0;N<G;N++)Ze=Ce.items[N],Be=Ze.checked,ut=Ze.task,Qe="",Ze.task&&(re=this.renderer.checkbox(Be),Je?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=re+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=re+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:re}):Qe+=re),Qe+=this.parse(Ze.tokens,Je),ye+=this.renderer.listitem(Qe,ut,Be);ne+=this.renderer.list(ye,We,je);continue}case"html":{ne+=this.renderer.html(Ce.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(Ce.tokens));continue}case"text":{for(ye=Ce.tokens?this.parseInline(Ce.tokens):Ce.text;se+1<_e&&J[se+1].type==="text";)Ce=J[++se],ye+=`
`+(Ce.tokens?this.parseInline(Ce.tokens):Ce.text);ne+=ae?this.renderer.paragraph(ye):ye;continue}default:{var ue='Token with "'+Ce.type+'" type was not found.';if(this.options.silent){console.error(ue);return}else throw new Error(ue)}}}return ne},ce.parseInline=function(J,ae){ae=ae||this.renderer;var ne="",se,N,j,G=J.length;for(se=0;se<G;se++){if(N=J[se],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[N.type]&&(j=this.options.extensions.renderers[N.type].call({parser:this},N),j!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(N.type))){ne+=j||"";continue}switch(N.type){case"escape":{ne+=ae.text(N.text);break}case"html":{ne+=ae.html(N.text);break}case"link":{ne+=ae.link(N.href,N.title,this.parseInline(N.tokens,ae));break}case"image":{ne+=ae.image(N.href,N.title,N.text);break}case"strong":{ne+=ae.strong(this.parseInline(N.tokens,ae));break}case"em":{ne+=ae.em(this.parseInline(N.tokens,ae));break}case"codespan":{ne+=ae.codespan(N.text);break}case"br":{ne+=ae.br();break}case"del":{ne+=ae.del(this.parseInline(N.tokens,ae));break}case"text":{ne+=ae.text(N.text);break}default:{var X='Token with "'+N.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ne},ie}();function de(ie,ce,me){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof ce=="function"&&(me=ce,ce=null),ce=n({},de.defaults,ce||{}),R(ce),me){var J=ce.highlight,ae;try{ae=F.lex(ie,ce)}catch(G){return me(G)}var ne=function(X){var ge;if(!X)try{ce.walkTokens&&de.walkTokens(ae,ce.walkTokens),ge=K.parse(ae,ce)}catch(be){X=be}return ce.highlight=J,X?me(X):me(null,ge)};if(!J||J.length<3||(delete ce.highlight,!ae.length))return ne();var se=0;de.walkTokens(ae,function(G){G.type==="code"&&(se++,setTimeout(function(){J(G.text,G.lang,function(X,ge){if(X)return ne(X);ge!=null&&ge!==G.text&&(G.text=ge,G.escaped=!0),se--,se===0&&ne()})},0))}),se===0&&ne();return}function N(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(G.message+"",!0)+"</pre>";throw G}try{var j=F.lex(ie,ce);if(ce.walkTokens){if(ce.async)return Promise.all(de.walkTokens(j,ce.walkTokens)).then(function(){return K.parse(j,ce)}).catch(N);de.walkTokens(j,ce.walkTokens)}return K.parse(j,ce)}catch(G){N(G)}}de.options=de.setOptions=function(ie){return n(de.defaults,ie),T(de.defaults),de},de.getDefaults=y,de.defaults=Z.defaults,de.use=function(){for(var ie=arguments.length,ce=new Array(ie),me=0;me<ie;me++)ce[me]=arguments[me];var J=n.apply(void 0,[{}].concat(ce)),ae=de.defaults.extensions||{renderers:{},childTokens:{}},ne;ce.forEach(function(se){if(se.extensions&&(ne=!0,se.extensions.forEach(function(j){if(!j.name)throw new Error("extension name required");if(j.renderer){var G=ae.renderers?ae.renderers[j.name]:null;G?ae.renderers[j.name]=function(){for(var X=arguments.length,ge=new Array(X),be=0;be<X;be++)ge[be]=arguments[be];var le=j.renderer.apply(this,ge);return le===!1&&(le=G.apply(this,ge)),le}:ae.renderers[j.name]=j.renderer}if(j.tokenizer){if(!j.level||j.level!=="block"&&j.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[j.level]?ae[j.level].unshift(j.tokenizer):ae[j.level]=[j.tokenizer],j.start&&(j.level==="block"?ae.startBlock?ae.startBlock.push(j.start):ae.startBlock=[j.start]:j.level==="inline"&&(ae.startInline?ae.startInline.push(j.start):ae.startInline=[j.start]))}j.childTokens&&(ae.childTokens[j.name]=j.childTokens)})),se.renderer&&function(){var j=de.defaults.renderer||new V,G=function(be){var le=j[be];j[be]=function(){for(var ye=arguments.length,Ce=new Array(ye),We=0;We<ye;We++)Ce[We]=arguments[We];var je=se.renderer[be].apply(j,Ce);return je===!1&&(je=le.apply(j,Ce)),je}};for(var X in se.renderer)G(X);J.renderer=j}(),se.tokenizer&&function(){var j=de.defaults.tokenizer||new L,G=function(be){var le=j[be];j[be]=function(){for(var ye=arguments.length,Ce=new Array(ye),We=0;We<ye;We++)Ce[We]=arguments[We];var je=se.tokenizer[be].apply(j,Ce);return je===!1&&(je=le.apply(j,Ce)),je}};for(var X in se.tokenizer)G(X);J.tokenizer=j}(),se.walkTokens){var N=de.defaults.walkTokens;J.walkTokens=function(j){var G=[];return G.push(se.walkTokens.call(this,j)),N&&(G=G.concat(N.call(this,j))),G}}ne&&(J.extensions=ae),de.setOptions(J)})},de.walkTokens=function(ie,ce){for(var me=[],J=function(){var N=ne.value;switch(me=me.concat(ce.call(de,N)),N.type){case"table":{for(var j=P(N.header),G;!(G=j()).done;){var X=G.value;me=me.concat(de.walkTokens(X.tokens,ce))}for(var ge=P(N.rows),be;!(be=ge()).done;)for(var le=be.value,ye=P(le),Ce;!(Ce=ye()).done;){var We=Ce.value;me=me.concat(de.walkTokens(We.tokens,ce))}break}case"list":{me=me.concat(de.walkTokens(N.items,ce));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[N.type]?de.defaults.extensions.childTokens[N.type].forEach(function(je){me=me.concat(de.walkTokens(N[je],ce))}):N.tokens&&(me=me.concat(de.walkTokens(N.tokens,ce)))}},ae=P(ie),ne;!(ne=ae()).done;)J();return me},de.parseInline=function(ie,ce){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");ce=n({},de.defaults,ce||{}),R(ce);try{var me=F.lexInline(ie,ce);return ce.walkTokens&&de.walkTokens(me,ce.walkTokens),K.parseInline(me,ce)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(J.message+"",!0)+"</pre>";throw J}},de.Parser=K,de.parser=K.parse,de.Renderer=V,de.TextRenderer=H,de.Lexer=F,de.lexer=F.lex,de.Tokenizer=L,de.Slugger=Q,de.parse=de;var ee=de.options,fe=de.setOptions,Y=de.use,ve=de.walkTokens,Ee=de.parseInline,ke=de,Re=K.parse,ze=F.lex;Z.Lexer=F,Z.Parser=K,Z.Renderer=V,Z.Slugger=Q,Z.TextRenderer=H,Z.Tokenizer=L,Z.getDefaults=y,Z.lexer=ze,Z.marked=de,Z.options=ee,Z.parse=ke,Z.parseInline=Ee,Z.parser=Re,Z.setOptions=fe,Z.use=Y,Z.walkTokens=ve,Object.defineProperty(Z,"__esModule",{value:!0})}),define(De[80],Ie([1,0,28]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new c.LRUCache(1e4);function D(k){return S(k,"NFC",t)}e.normalizeNFC=D;const P=new c.LRUCache(1e4);function y(k){return S(k,"NFD",P)}e.normalizeNFD=y;const T=/[^\u0000-\u0080]/;function S(k,A,I){if(!k)return k;const E=I.get(k);if(E)return E;let _;return T.test(k)?_=k.normalize(A):_=k,I.set(k,_),_}e.removeAccents=function(){const k=/[\u0300-\u036f]/g;return function(A){return y(A).replace(k,"")}}()}),define(De[99],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(T,S,k){return Math.min(Math.max(T,S),k)}e.clamp=c;function t(T,S){return(S+T%S)%S}e.rot=t;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class P{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class y{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const k=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function Z(D){const P=[];typeof D=="number"&&P.push("code/timeOrigin",D);function y(S){P.push(S,Date.now())}function T(){const S=[];for(let k=0;k<P.length;k+=2)S.push({name:P[k],startTime:P[k+1]});return S}return{mark:y,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const y of performance.getEntriesByType("mark"))P.push({name:y.name,startTime:Math.round(D+y.startTime)});return P}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function c(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=c(t))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var t in c)(typeof exports=="object"?exports:Z)[t]=c[t]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function c(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return Z[t].call(D.exports,D,D.exports,c),D.l=!0,D.exports}return c.m=Z,c.c=e,c.d=function(t,D,P){c.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:P})},c.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},c.t=function(t,D){if(1&D&&(t=c(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(c.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var y in t)c.d(P,y,function(T){return t[T]}.bind(null,y));return P},c.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return c.d(D,"a",D),D},c.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},c.p="",c(c.s=0)}([function(Z,e,c){(function(t){var D;e=Z.exports=Y,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],k=0,A=k++;S[A]="0|[1-9]\\d*";var I=k++;S[I]="[0-9]+";var E=k++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var _=k++;S[_]="("+S[A]+")\\.("+S[A]+")\\.("+S[A]+")";var w=k++;S[w]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var h=k++;S[h]="(?:"+S[A]+"|"+S[E]+")";var g=k++;S[g]="(?:"+S[I]+"|"+S[E]+")";var f=k++;S[f]="(?:-("+S[h]+"(?:\\."+S[h]+")*))";var v=k++;S[v]="(?:-?("+S[g]+"(?:\\."+S[g]+")*))";var m=k++;S[m]="[0-9A-Za-z-]+";var r=k++;S[r]="(?:\\+("+S[m]+"(?:\\."+S[m]+")*))";var b=k++,s="v?"+S[_]+S[f]+"?"+S[r]+"?";S[b]="^"+s+"$";var u="[v=\\s]*"+S[w]+S[v]+"?"+S[r]+"?",o=k++;S[o]="^"+u+"$";var l=k++;S[l]="((?:<|>)?=?)";var a=k++;S[a]=S[I]+"|x|X|\\*";var d=k++;S[d]=S[A]+"|x|X|\\*";var n=k++;S[n]="[v=\\s]*("+S[d]+")(?:\\.("+S[d]+")(?:\\.("+S[d]+")(?:"+S[f]+")?"+S[r]+"?)?)?";var i=k++;S[i]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[v]+")?"+S[r]+"?)?)?";var p=k++;S[p]="^"+S[l]+"\\s*"+S[n]+"$";var C=k++;S[C]="^"+S[l]+"\\s*"+S[i]+"$";var R=k++;S[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=k++;S[M]="(?:~>?)";var $=k++;S[$]="(\\s*)"+S[M]+"\\s+",T[$]=new RegExp(S[$],"g");var x=k++;S[x]="^"+S[M]+S[n]+"$";var L=k++;S[L]="^"+S[M]+S[i]+"$";var B=k++;S[B]="(?:\\^)";var O=k++;S[O]="(\\s*)"+S[B]+"\\s+",T[O]=new RegExp(S[O],"g");var z=k++;S[z]="^"+S[B]+S[n]+"$";var U=k++;S[U]="^"+S[B]+S[i]+"$";var F=k++;S[F]="^"+S[l]+"\\s*("+u+")$|^$";var V=k++;S[V]="^"+S[l]+"\\s*("+s+")$|^$";var H=k++;S[H]="(\\s*)"+S[l]+"\\s*("+u+"|"+S[n]+")",T[H]=new RegExp(S[H],"g");var Q=k++;S[Q]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var K=k++;S[K]="^\\s*("+S[i]+")\\s+-\\s+("+S[i]+")\\s*$";var de=k++;S[de]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)D(ee,S[ee]),T[ee]||(T[ee]=new RegExp(S[ee]));function fe(le,ye){if(le instanceof Y)return le;if(typeof le!="string"||le.length>P||!(ye?T[o]:T[b]).test(le))return null;try{return new Y(le,ye)}catch{return null}}function Y(le,ye){if(le instanceof Y){if(le.loose===ye)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Y))return new Y(le,ye);D("SemVer",le,ye),this.loose=ye;var Ce=le.trim().match(ye?T[o]:T[b]);if(!Ce)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+Ce[1],this.minor=+Ce[2],this.patch=+Ce[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");Ce[4]?this.prerelease=Ce[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var je=+We;if(je>=0&&je<y)return je}return We}):this.prerelease=[],this.build=Ce[5]?Ce[5].split("."):[],this.format()}e.parse=fe,e.valid=function(le,ye){var Ce=fe(le,ye);return Ce?Ce.version:null},e.clean=function(le,ye){var Ce=fe(le.trim().replace(/^[=v]+/,""),ye);return Ce?Ce.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(le){return D("SemVer.compare",this.version,this.loose,le),le instanceof Y||(le=new Y(le,this.loose)),this.compareMain(le)||this.comparePre(le)},Y.prototype.compareMain=function(le){return le instanceof Y||(le=new Y(le,this.loose)),Ee(this.major,le.major)||Ee(this.minor,le.minor)||Ee(this.patch,le.patch)},Y.prototype.comparePre=function(le){if(le instanceof Y||(le=new Y(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ye=0;do{var Ce=this.prerelease[ye],We=le.prerelease[ye];if(D("prerelease compare",ye,Ce,We),Ce===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ce===void 0)return-1;if(Ce!==We)return Ee(Ce,We)}while(++ye)},Y.prototype.inc=function(le,ye){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ye);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ye);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ye),this.inc("pre",ye);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ye),this.inc("pre",ye);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ce=this.prerelease.length;--Ce>=0;)typeof this.prerelease[Ce]=="number"&&(this.prerelease[Ce]++,Ce=-2);Ce===-1&&this.prerelease.push(0)}ye&&(this.prerelease[0]===ye?isNaN(this.prerelease[1])&&(this.prerelease=[ye,0]):this.prerelease=[ye,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ye,Ce,We){typeof Ce=="string"&&(We=Ce,Ce=void 0);try{return new Y(le,Ce).inc(ye,We).version}catch{return null}},e.diff=function(le,ye){if(ie(le,ye))return null;var Ce=fe(le),We=fe(ye);if(Ce.prerelease.length||We.prerelease.length){for(var je in Ce)if((je==="major"||je==="minor"||je==="patch")&&Ce[je]!==We[je])return"pre"+je;return"prerelease"}for(var je in Ce)if((je==="major"||je==="minor"||je==="patch")&&Ce[je]!==We[je])return je},e.compareIdentifiers=Ee;var ve=/^[0-9]+$/;function Ee(le,ye){var Ce=ve.test(le),We=ve.test(ye);return Ce&&We&&(le=+le,ye=+ye),Ce&&!We?-1:We&&!Ce?1:le<ye?-1:le>ye?1:0}function ke(le,ye,Ce){return new Y(le,Ce).compare(new Y(ye,Ce))}function Re(le,ye,Ce){return ke(le,ye,Ce)>0}function ze(le,ye,Ce){return ke(le,ye,Ce)<0}function ie(le,ye,Ce){return ke(le,ye,Ce)===0}function ce(le,ye,Ce){return ke(le,ye,Ce)!==0}function me(le,ye,Ce){return ke(le,ye,Ce)>=0}function J(le,ye,Ce){return ke(le,ye,Ce)<=0}function ae(le,ye,Ce,We){var je;switch(ye){case"===":typeof le=="object"&&(le=le.version),typeof Ce=="object"&&(Ce=Ce.version),je=le===Ce;break;case"!==":typeof le=="object"&&(le=le.version),typeof Ce=="object"&&(Ce=Ce.version),je=le!==Ce;break;case"":case"=":case"==":je=ie(le,Ce,We);break;case"!=":je=ce(le,Ce,We);break;case">":je=Re(le,Ce,We);break;case">=":je=me(le,Ce,We);break;case"<":je=ze(le,Ce,We);break;case"<=":je=J(le,Ce,We);break;default:throw new TypeError("Invalid operator: "+ye)}return je}function ne(le,ye){if(le instanceof ne){if(le.loose===ye)return le;le=le.value}if(!(this instanceof ne))return new ne(le,ye);D("comparator",le,ye),this.loose=ye,this.parse(le),this.semver===se?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(le,ye){return Ee(ye,le)},e.major=function(le,ye){return new Y(le,ye).major},e.minor=function(le,ye){return new Y(le,ye).minor},e.patch=function(le,ye){return new Y(le,ye).patch},e.compare=ke,e.compareLoose=function(le,ye){return ke(le,ye,!0)},e.rcompare=function(le,ye,Ce){return ke(ye,le,Ce)},e.sort=function(le,ye){return le.sort(function(Ce,We){return e.compare(Ce,We,ye)})},e.rsort=function(le,ye){return le.sort(function(Ce,We){return e.rcompare(Ce,We,ye)})},e.gt=Re,e.lt=ze,e.eq=ie,e.neq=ce,e.gte=me,e.lte=J,e.cmp=ae,e.Comparator=ne;var se={};function N(le,ye){if(le instanceof N)return le.loose===ye?le:new N(le.raw,ye);if(le instanceof ne)return new N(le.value,ye);if(!(this instanceof N))return new N(le,ye);if(this.loose=ye,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(Ce){return this.parseRange(Ce.trim())},this).filter(function(Ce){return Ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function j(le){return!le||le.toLowerCase()==="x"||le==="*"}function G(le,ye,Ce,We,je,Je,Qe,Ze,Be,ut,re,oe,_e){return((ye=j(Ce)?"":j(We)?">="+Ce+".0.0":j(je)?">="+Ce+"."+We+".0":">="+ye)+" "+(Ze=j(Be)?"":j(ut)?"<"+(+Be+1)+".0.0":j(re)?"<"+Be+"."+(+ut+1)+".0":oe?"<="+Be+"."+ut+"."+re+"-"+oe:"<="+Ze)).trim()}function X(le,ye){for(var Ce=0;Ce<le.length;Ce++)if(!le[Ce].test(ye))return!1;if(ye.prerelease.length){for(Ce=0;Ce<le.length;Ce++)if(D(le[Ce].semver),le[Ce].semver!==se&&le[Ce].semver.prerelease.length>0){var We=le[Ce].semver;if(We.major===ye.major&&We.minor===ye.minor&&We.patch===ye.patch)return!0}return!1}return!0}function ge(le,ye,Ce){try{ye=new N(ye,Ce)}catch{return!1}return ye.test(le)}function be(le,ye,Ce,We){var je,Je,Qe,Ze,Be;switch(le=new Y(le,We),ye=new N(ye,We),Ce){case">":je=Re,Je=J,Qe=ze,Ze=">",Be=">=";break;case"<":je=ze,Je=me,Qe=Re,Ze="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ge(le,ye,We))return!1;for(var ut=0;ut<ye.set.length;++ut){var re=ye.set[ut],oe=null,_e=null;if(re.forEach(function(ue){ue.semver===se&&(ue=new ne(">=0.0.0")),oe=oe||ue,_e=_e||ue,je(ue.semver,oe.semver,We)?oe=ue:Qe(ue.semver,_e.semver,We)&&(_e=ue)}),oe.operator===Ze||oe.operator===Be||(!_e.operator||_e.operator===Ze)&&Je(le,_e.semver)||_e.operator===Be&&Qe(le,_e.semver))return!1}return!0}ne.prototype.parse=function(le){var ye=this.loose?T[F]:T[V],Ce=le.match(ye);if(!Ce)throw new TypeError("Invalid comparator: "+le);this.operator=Ce[1],this.operator==="="&&(this.operator=""),Ce[2]?this.semver=new Y(Ce[2],this.loose):this.semver=se},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(le){return D("Comparator.test",le,this.loose),this.semver===se||(typeof le=="string"&&(le=new Y(le,this.loose)),ae(le,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(le,ye){if(!(le instanceof ne))throw new TypeError("a Comparator is required");var Ce;if(this.operator==="")return Ce=new N(le.value,ye),ge(this.value,Ce,ye);if(le.operator==="")return Ce=new N(this.value,ye),ge(le.semver,Ce,ye);var We=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Je=this.semver.version===le.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Ze=ae(this.semver,"<",le.semver,ye)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Be=ae(this.semver,">",le.semver,ye)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return We||je||Je&&Qe||Ze||Be},e.Range=N,N.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},N.prototype.toString=function(){return this.range},N.prototype.parseRange=function(le){var ye=this.loose;le=le.trim(),D("range",le,ye);var Ce=ye?T[K]:T[Q];le=le.replace(Ce,G),D("hyphen replace",le),le=le.replace(T[H],"$1$2$3"),D("comparator trim",le,T[H]),le=(le=(le=le.replace(T[$],"$1~")).replace(T[O],"$1^")).split(/\s+/).join(" ");var We=ye?T[F]:T[V],je=le.split(" ").map(function(Je){return function(Qe,Ze){return D("comp",Qe),Qe=function(Be,ut){return Be.trim().split(/\s+/).map(function(re){return function(oe,_e){D("caret",oe,_e);var ue=_e?T[U]:T[z];return oe.replace(ue,function(Pe,Le,Ne,qe,Ye){var it;return D("caret",oe,Pe,Le,Ne,qe,Ye),j(Le)?it="":j(Ne)?it=">="+Le+".0.0 <"+(+Le+1)+".0.0":j(qe)?it=Le==="0"?">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+".0 <"+(+Le+1)+".0.0":Ye?(D("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),it=Le==="0"?Ne==="0"?">="+Le+"."+Ne+"."+qe+Ye+" <"+Le+"."+Ne+"."+(+qe+1):">="+Le+"."+Ne+"."+qe+Ye+" <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+"."+qe+Ye+" <"+(+Le+1)+".0.0"):(D("no pr"),it=Le==="0"?Ne==="0"?">="+Le+"."+Ne+"."+qe+" <"+Le+"."+Ne+"."+(+qe+1):">="+Le+"."+Ne+"."+qe+" <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+"."+qe+" <"+(+Le+1)+".0.0"),D("caret return",it),it})}(re,ut)}).join(" ")}(Qe,Ze),D("caret",Qe),Qe=function(Be,ut){return Be.trim().split(/\s+/).map(function(re){return function(oe,_e){var ue=_e?T[L]:T[x];return oe.replace(ue,function(Pe,Le,Ne,qe,Ye){var it;return D("tilde",oe,Pe,Le,Ne,qe,Ye),j(Le)?it="":j(Ne)?it=">="+Le+".0.0 <"+(+Le+1)+".0.0":j(qe)?it=">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0":Ye?(D("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),it=">="+Le+"."+Ne+"."+qe+Ye+" <"+Le+"."+(+Ne+1)+".0"):it=">="+Le+"."+Ne+"."+qe+" <"+Le+"."+(+Ne+1)+".0",D("tilde return",it),it})}(re,ut)}).join(" ")}(Qe,Ze),D("tildes",Qe),Qe=function(Be,ut){return D("replaceXRanges",Be,ut),Be.split(/\s+/).map(function(re){return function(oe,_e){oe=oe.trim();var ue=_e?T[C]:T[p];return oe.replace(ue,function(Pe,Le,Ne,qe,Ye,it){D("xRange",oe,Pe,Le,Ne,qe,Ye,it);var bt=j(Ne),st=bt||j(qe),et=st||j(Ye);return Le==="="&&et&&(Le=""),bt?Pe=Le===">"||Le==="<"?"<0.0.0":"*":Le&&et?(st&&(qe=0),et&&(Ye=0),Le===">"?(Le=">=",st?(Ne=+Ne+1,qe=0,Ye=0):et&&(qe=+qe+1,Ye=0)):Le==="<="&&(Le="<",st?Ne=+Ne+1:qe=+qe+1),Pe=Le+Ne+"."+qe+"."+Ye):st?Pe=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":et&&(Pe=">="+Ne+"."+qe+".0 <"+Ne+"."+(+qe+1)+".0"),D("xRange return",Pe),Pe})}(re,ut)}).join(" ")}(Qe,Ze),D("xrange",Qe),Qe=function(Be,ut){return D("replaceStars",Be,ut),Be.trim().replace(T[de],"")}(Qe,Ze),D("stars",Qe),Qe}(Je,ye)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Je){return!!Je.match(We)})),je=je.map(function(Je){return new ne(Je,ye)})},N.prototype.intersects=function(le,ye){if(!(le instanceof N))throw new TypeError("a Range is required");return this.set.some(function(Ce){return Ce.every(function(We){return le.set.some(function(je){return je.every(function(Je){return We.intersects(Je,ye)})})})})},e.toComparators=function(le,ye){return new N(le,ye).set.map(function(Ce){return Ce.map(function(We){return We.value}).join(" ").trim().split(" ")})},N.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new Y(le,this.loose));for(var ye=0;ye<this.set.length;ye++)if(X(this.set[ye],le))return!0;return!1},e.satisfies=ge,e.maxSatisfying=function(le,ye,Ce){var We=null,je=null;try{var Je=new N(ye,Ce)}catch{return null}return le.forEach(function(Qe){Je.test(Qe)&&(We&&je.compare(Qe)!==-1||(je=new Y(We=Qe,Ce)))}),We},e.minSatisfying=function(le,ye,Ce){var We=null,je=null;try{var Je=new N(ye,Ce)}catch{return null}return le.forEach(function(Qe){Je.test(Qe)&&(We&&je.compare(Qe)!==1||(je=new Y(We=Qe,Ce)))}),We},e.validRange=function(le,ye){try{return new N(le,ye).range||"*"}catch{return null}},e.ltr=function(le,ye,Ce){return be(le,ye,"<",Ce)},e.gtr=function(le,ye,Ce){return be(le,ye,">",Ce)},e.outside=be,e.prerelease=function(le,ye){var Ce=fe(le,ye);return Ce&&Ce.prerelease.length?Ce.prerelease:null},e.intersects=function(le,ye,Ce){return le=new N(le,Ce),ye=new N(ye,Ce),le.intersects(ye)},e.coerce=function(le){if(le instanceof Y)return le;if(typeof le!="string")return null;var ye=le.match(T[R]);return ye==null?null:fe((ye[1]||"0")+"."+(ye[2]||"0")+"."+(ye[3]||"0"))}}).call(this,c(1))},function(Z,e){var c,t,D=Z.exports={};function P(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function T(g){if(c===setTimeout)return setTimeout(g,0);if((c===P||!c)&&setTimeout)return c=setTimeout,setTimeout(g,0);try{return c(g,0)}catch{try{return c.call(null,g,0)}catch{return c.call(this,g,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:P}catch{c=P}try{t=typeof clearTimeout=="function"?clearTimeout:y}catch{t=y}})();var S,k=[],A=!1,I=-1;function E(){A&&S&&(A=!1,S.length?k=S.concat(k):I=-1,k.length&&_())}function _(){if(!A){var g=T(E);A=!0;for(var f=k.length;f;){for(S=k,k=[];++I<f;)S&&S[I].run();I=-1,f=k.length}S=null,A=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===y||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(g)}}function w(g,f){this.fun=g,this.array=f}function h(){}D.nextTick=function(g){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];k.push(new w(g,f)),k.length!==1||A||T(_)},w.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=h,D.addListener=h,D.once=h,D.off=h,D.removeListener=h,D.removeAllListeners=h,D.emit=h,D.prependListener=h,D.prependOnceListener=h,D.listeners=function(g){return[]},D.binding=function(g){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(g){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(De[100],Ie([1,0,10,6]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(r){const b=r;return b?typeof b.read=="function":!1}e.isReadable=D;function P(r){const b=r;return b?[b.on,b.pause,b.resume,b.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=P;function y(r){const b=r;return b?P(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=y;function T(r,b){return new S(r,b)}e.newWriteableStream=T;class S{constructor(b,s){this.reducer=b,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b<"u"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(s=>s(b))}emitError(b){this.listeners.error.length===0?(0,c.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(s=>s(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,s){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(b,s){if(this.state.destroyed)return;let u;switch(b){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const o=u.indexOf(s);o>=0&&u.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function k(r,b){const s=[];let u;for(;(u=r.read())!==null;)s.push(u);return b(s)}e.consumeReadable=k;function A(r,b,s){const u=[];let o;for(;(o=r.read())!==null&&u.length<s;)u.push(o);return o===null&&u.length>0?b(u):{read:()=>{if(u.length>0)return u.shift();if(typeof o<"u"){const l=o;return o=void 0,l}return r.read()}}}e.peekReadable=A;function I(r,b){return new Promise((s,u)=>{const o=[];E(r,{onData:l=>{b&&o.push(l)},onError:l=>{b?u(l):s(void 0)},onEnd:()=>{s(b?b(o):void 0)}})})}e.consumeStream=I;function E(r,b){let s=!1;return r.on("error",u=>{s||b.onError(u)}),r.on("end",()=>{s||b.onEnd()}),r.on("data",u=>{s||b.onData(u)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=E;function _(r,b){return new Promise((s,u)=>{const o=new t.DisposableStore,l=[],a=i=>{if(l.push(i),l.length>b)return o.dispose(),r.pause(),s({stream:r,buffer:l,ended:!1})},d=i=>u(i),n=()=>s({stream:r,buffer:l,ended:!0});o.add((0,t.toDisposable)(()=>r.removeListener("error",d))),r.on("error",d),o.add((0,t.toDisposable)(()=>r.removeListener("end",n))),r.on("end",n),o.add((0,t.toDisposable)(()=>r.removeListener("data",a))),r.on("data",a)})}e.peekStream=_;function w(r,b){const s=T(b);return s.end(r),s}e.toStream=w;function h(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}e.emptyStream=h;function g(r){let b=!1;return{read:()=>b?null:(b=!0,r)}}e.toReadable=g;function f(r,b,s){const u=T(s);return E(r,{onData:o=>u.write(b.data(o)),onError:o=>u.error(b.error?b.error(o):o),onEnd:()=>u.end()}),u}e.transform=f;function v(r,b,s){let u=!1;return{read:()=>{const o=b.read();return u?o:(u=!0,o!==null?s([r,o]):r)}}}e.prefixedReadable=v;function m(r,b,s){let u=!1;const o=T(s);return E(b,{onData:l=>u?o.write(l):(u=!0,o.write(s([r,l]))),onError:l=>o.error(l),onEnd:()=>{u||(u=!0,o.write(r)),o.end()}}),o}e.prefixedStream=m}),define(De[23],Ie([1,0,100]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let D,P;class y{static alloc(i){return t?new y(Buffer.allocUnsafe(i)):new y(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new y(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&t?new y(Buffer.from(i)):(D||(D=new TextEncoder),new y(D.encode(i)))}static fromByteArray(i){const p=y.alloc(i.length);for(let C=0,R=i.length;C<R;C++)p.buffer[C]=i[C];return p}static concat(i,p){if(typeof p>"u"){p=0;for(let M=0,$=i.length;M<$;M++)p+=i[M].byteLength}const C=y.alloc(p);let R=0;for(let M=0,$=i.length;M<$;M++){const x=i[M];C.set(x,R),R+=x.byteLength}return C}constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}clone(){const i=y.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(i,p){return new y(this.buffer.subarray(i,p))}set(i,p){if(i instanceof y)this.buffer.set(i.buffer,p);else if(i instanceof Uint8Array)this.buffer.set(i,p);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),p);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(i){return k(this.buffer,i)}writeUInt32BE(i,p){A(this.buffer,i,p)}readUInt32LE(i){return I(this.buffer,i)}writeUInt32LE(i,p){E(this.buffer,i,p)}readUInt8(i){return _(this.buffer,i)}writeUInt8(i,p){w(this.buffer,i,p)}}e.VSBuffer=y;function T(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0}e.readUInt16LE=T;function S(n,i,p){n[p+0]=i&255,i=i>>>8,n[p+1]=i&255}e.writeUInt16LE=S;function k(n,i){return n[i]*2**24+n[i+1]*2**16+n[i+2]*2**8+n[i+3]}e.readUInt32BE=k;function A(n,i,p){n[p+3]=i,i=i>>>8,n[p+2]=i,i=i>>>8,n[p+1]=i,i=i>>>8,n[p]=i}e.writeUInt32BE=A;function I(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0|n[i+2]<<16>>>0|n[i+3]<<24>>>0}e.readUInt32LE=I;function E(n,i,p){n[p+0]=i&255,i=i>>>8,n[p+1]=i&255,i=i>>>8,n[p+2]=i&255,i=i>>>8,n[p+3]=i&255}e.writeUInt32LE=E;function _(n,i){return n[i]}e.readUInt8=_;function w(n,i,p){n[p]=i}e.writeUInt8=w;function h(n){return c.consumeReadable(n,i=>y.concat(i))}e.readableToBuffer=h;function g(n){return c.toReadable(n)}e.bufferToReadable=g;function f(n){return c.consumeStream(n,i=>y.concat(i))}e.streamToBuffer=f;async function v(n){return n.ended?y.concat(n.buffer):y.concat([...n.buffer,await f(n.stream)])}e.bufferedStreamToBuffer=v;function m(n){return c.toStream(n,i=>y.concat(i))}e.bufferToStream=m;function r(n){return c.transform(n,{data:i=>typeof i=="string"?y.fromString(i):y.wrap(i)},i=>y.concat(i))}e.streamToBufferReadableStream=r;function b(n){return c.newWriteableStream(i=>y.concat(i),n)}e.newWriteableBufferStream=b;function s(n,i){return c.prefixedReadable(n,i,p=>y.concat(p))}e.prefixedBufferReadable=s;function u(n,i){return c.prefixedStream(n,i,p=>y.concat(p))}e.prefixedBufferStream=u;function o(n){let i=0,p=0,C=0;const R=new Uint8Array(Math.floor(n.length/4*3)),M=x=>{switch(p){case 3:R[C++]=i|x,p=0;break;case 2:R[C++]=i|x>>>2,i=x<<6,p=3;break;case 1:R[C++]=i|x>>>4,i=x<<4,p=2;break;default:i=x<<2,p=1}};for(let x=0;x<n.length;x++){const L=n.charCodeAt(x);if(L>=65&&L<=90)M(L-65);else if(L>=97&&L<=122)M(L-97+26);else if(L>=48&&L<=57)M(L-48+52);else if(L===43||L===45)M(62);else if(L===47||L===95)M(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${n[x]}`)}}const $=C;for(;p>0;)M(0);return y.wrap(R).slice(0,$)}e.decodeBase64=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:n},i=!0,p=!1){const C=p?a:l;let R="";const M=n.byteLength%3;let $=0;for(;$<n.byteLength-M;$+=3){const x=n[$+0],L=n[$+1],B=n[$+2];R+=C[x>>>2],R+=C[(x<<4|L>>>4)&63],R+=C[(L<<2|B>>>6)&63],R+=C[B&63]}if(M===1){const x=n[$+0];R+=C[x>>>2],R+=C[x<<4&63],i&&(R+="==")}else if(M===2){const x=n[$+0],L=n[$+1];R+=C[x>>>2],R+=C[(x<<4|L>>>4)&63],R+=C[L<<2&63],i&&(R+="=")}return R}e.encodeBase64=d}),define(De[11],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(u){return typeof u=="string"}e.isString=c;function t(u){return Array.isArray(u)&&u.every(o=>c(o))}e.isStringArray=t;function D(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=D;function P(u){const o=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof o}e.isTypedArray=P;function y(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=y;function T(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=T;function S(u){return u===!0||u===!1}e.isBoolean=S;function k(u){return typeof u>"u"}e.isUndefined=k;function A(u){return!I(u)}e.isDefined=A;function I(u){return k(u)||u===null}e.isUndefinedOrNull=I;function E(u,o){if(!u)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=E;function _(u){if(I(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=_;function w(...u){const o=[];for(let l=0;l<u.length;l++){const a=u[l];if(I(a))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);o.push(a)}return o}e.assertAllDefined=w;const h=Object.prototype.hasOwnProperty;function g(u){if(!D(u))return!1;for(const o in u)if(h.call(u,o))return!1;return!0}e.isEmptyObject=g;function f(u){return typeof u=="function"}e.isFunction=f;function v(...u){return u.length>0&&u.every(f)}e.areFunctions=v;function m(u,o){const l=Math.min(u.length,o.length);for(let a=0;a<l;a++)r(u[a],o[a])}e.validateConstraints=m;function r(u,o){if(c(o)){if(typeof u!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(f(o)){try{if(u instanceof o)return}catch{}if(!I(u)&&u.constructor===o||o.length===1&&o.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function b(u){return u===null?void 0:u}e.withNullAsUndefined=b;function s(u){return typeof u>"u"?null:u}e.withUndefinedAsNull=s}),define(De[24],Ie([1,0,11]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const v=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([m,r])=>{v[m]=r&&typeof r=="object"?t(r):r}),v}e.deepClone=t;function D(f){if(!f||typeof f!="object")return f;const v=[f];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const r in m)if(P.call(m,r)){const b=m[r];typeof b=="object"&&!Object.isFrozen(b)&&!(0,c.isTypedArray)(b)&&v.push(b)}}return f}e.deepFreeze=D;const P=Object.prototype.hasOwnProperty;function y(f,v){return T(f,v,new Set)}e.cloneAndChange=y;function T(f,v,m){if((0,c.isUndefinedOrNull)(f))return f;const r=v(f);if(typeof r<"u")return r;if(Array.isArray(f)){const b=[];for(const s of f)b.push(T(s,v,m));return b}if((0,c.isObject)(f)){if(m.has(f))throw new Error("Cannot clone recursive data-structure");m.add(f);const b={};for(const s in f)P.call(f,s)&&(b[s]=T(f[s],v,m));return m.delete(f),b}return f}function S(f,v,m=!0){return(0,c.isObject)(f)?((0,c.isObject)(v)&&Object.keys(v).forEach(r=>{r in f?m&&((0,c.isObject)(f[r])&&(0,c.isObject)(v[r])?S(f[r],v[r],m):f[r]=v[r]):f[r]=v[r]}),f):v}e.mixin=S;function k(f,v){if(f===v)return!0;if(f==null||v===null||v===void 0||typeof f!=typeof v||typeof f!="object"||Array.isArray(f)!==Array.isArray(v))return!1;let m,r;if(Array.isArray(f)){if(f.length!==v.length)return!1;for(m=0;m<f.length;m++)if(!k(f[m],v[m]))return!1}else{const b=[];for(r in f)b.push(r);b.sort();const s=[];for(r in v)s.push(r);if(s.sort(),!k(b,s))return!1;for(m=0;m<b.length;m++)if(!k(f[b[m]],v[b[m]]))return!1}return!0}e.equals=k;function A(f){const v=new Set;return JSON.stringify(f,(m,r)=>{if((0,c.isObject)(r)||Array.isArray(r)){if(v.has(r))return"[Circular]";v.add(r)}return r})}e.safeStringify=A;function I(f,v){const m=Object.create(null);return!f||!v||Object.keys(v).forEach(b=>{const s=f[b],u=v[b];k(s,u)||(m[b]=u)}),m}e.distinct=I;function E(f,v){const m=v.toLowerCase(),r=Object.keys(f).find(b=>b.toLowerCase()===m);return r?f[r]:f[v]}e.getCaseInsensitive=E;function _(f,v){const m=Object.create(null);for(const[r,b]of Object.entries(f))v(r,b)&&(m[r]=b);return m}e.filter=_;function w(f){let v=[],m=Object.getPrototypeOf(f);for(;Object.prototype!==m;)v=v.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return v}e.getAllPropertyNames=w;function h(f){const v=[];for(const m of w(f))typeof f[m]=="function"&&v.push(m);return v}e.getAllMethodNames=h;function g(f,v){const m=b=>function(){const s=Array.prototype.slice.call(arguments,0);return v(b,s)},r={};for(const b of f)r[b]=m(b);return r}e.createProxyObject=g}),define(De[101],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function D(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=D}),define(De[31],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return c.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const P=new Uint8Array(16),y=[];for(let T=0;T<256;T++)y.push(T.toString(16).padStart(2,"0"));return function(){D(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let S=0,k="";return k+=y[P[S++]],k+=y[P[S++]],k+=y[P[S++]],k+=y[P[S++]],k+="-",k+=y[P[S++]],k+=y[P[S++]],k+="-",k+=y[P[S++]],k+=y[P[S++]],k+="-",k+=y[P[S++]],k+=y[P[S++]],k+="-",k+=y[P[S++]],k+=y[P[S++]],k+=y[P[S++]],k+=y[P[S++]],k+=y[P[S++]],k+=y[P[S++]],k}}()}),define(De[102],Ie([1,0,101]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(T){const S=(0,c.toUint8)(T);this._defaultValue=S,this._asciiMap=t._createAsciiMap(S),this._map=new Map}static _createAsciiMap(T){const S=new Uint8Array(256);return S.fill(T),S}set(T,S){const k=(0,c.toUint8)(S);T>=0&&T<256?this._asciiMap[T]=k:this._map.set(T,k)}get(T){return T>=0&&T<256?this._asciiMap[T]:this._map.get(T)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=t;var D;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(D||(D={}));class P{constructor(){this._actual=new t(0)}add(T){this._actual.set(T,1)}has(T){return this._actual.get(T)===1}clear(){return this._actual.clear()}}e.CharacterSet=P}),define(De[49],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(D,P){this.lineNumber=D,this.column=P}with(D=this.lineNumber,P=this.column){return D===this.lineNumber&&P===this.column?this:new c(D,P)}delta(D=0,P=0){return this.with(this.lineNumber+D,this.column+P)}equals(D){return c.equals(this,D)}static equals(D,P){return!D&&!P?!0:!!D&&!!P&&D.lineNumber===P.lineNumber&&D.column===P.column}isBefore(D){return c.isBefore(this,D)}static isBefore(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<P.column}isBeforeOrEqual(D){return c.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<=P.column}static compare(D,P){const y=D.lineNumber|0,T=P.lineNumber|0;if(y===T){const S=D.column|0,k=P.column|0;return S-k}return y-T}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new c(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=c}),define(De[35],Ie([1,0,49]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,y,T,S){P>T||P===T&&y>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=P,this.endColumn=y):(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<P.startColumn||y.lineNumber===P.endLineNumber&&y.column>P.endColumn)}static strictContainsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<=P.startColumn||y.lineNumber===P.endLineNumber&&y.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<=P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,y){let T,S,k,A;return y.startLineNumber<P.startLineNumber?(T=y.startLineNumber,S=y.startColumn):y.startLineNumber===P.startLineNumber?(T=y.startLineNumber,S=Math.min(y.startColumn,P.startColumn)):(T=P.startLineNumber,S=P.startColumn),y.endLineNumber>P.endLineNumber?(k=y.endLineNumber,A=y.endColumn):y.endLineNumber===P.endLineNumber?(k=y.endLineNumber,A=Math.max(y.endColumn,P.endColumn)):(k=P.endLineNumber,A=P.endColumn),new t(T,S,k,A)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,y){let T=P.startLineNumber,S=P.startColumn,k=P.endLineNumber,A=P.endColumn;const I=y.startLineNumber,E=y.startColumn,_=y.endLineNumber,w=y.endColumn;return T<I?(T=I,S=E):T===I&&(S=Math.max(S,E)),k>_?(k=_,A=w):k===_&&(A=Math.min(A,w)),T>k||T===k&&S>A?null:new t(T,S,k,A)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,y){return!P&&!y?!0:!!P&&!!y&&P.startLineNumber===y.startLineNumber&&P.startColumn===y.startColumn&&P.endLineNumber===y.endLineNumber&&P.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new c.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new c.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,y){return new t(this.startLineNumber,this.startColumn,P,y)}setStartPosition(P,y){return new t(P,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,y=P){return new t(P.lineNumber,P.column,y.lineNumber,y.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<P.startColumn)}static areIntersecting(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<=y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,y){if(P&&y){const k=P.startLineNumber|0,A=y.startLineNumber|0;if(k===A){const I=P.startColumn|0,E=y.startColumn|0;if(I===E){const _=P.endLineNumber|0,w=y.endLineNumber|0;if(_===w){const h=P.endColumn|0,g=y.endColumn|0;return h-g}return _-w}return I-E}return k-A}return(P?1:0)-(y?1:0)}static compareRangesUsingEnds(P,y){return P.endLineNumber===y.endLineNumber?P.endColumn===y.endColumn?P.startLineNumber===y.startLineNumber?P.startColumn-y.startColumn:P.startLineNumber-y.startLineNumber:P.endColumn-y.endColumn:P.endLineNumber-y.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(De[146],Ie([1,0,49,35]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(T,S,k,A){super(T,S,k,A),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=k,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return P.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,T,S):new P(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new P(T,S,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new P(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new P(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new P(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new P(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let k=0,A=T.length;k<A;k++)if(!this.selectionsEqual(T[k],S[k]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,k,A,I){return I===0?new P(T,S,k,A):new P(k,A,T,S)}}e.Selection=P}),define(De[147],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[148],Ie([1,0,102]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends c.CharacterClassifier{constructor(T){super(0);for(let S=0,k=T.length;S<k;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function P(y){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=y(S)),T[S])}e.getMapForWordSeparators=P(y=>new D(y))}),define(De[103],Ie([1,0,62,6,63]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(I=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const _ of e.USUAL_WORD_SEPARATORS)I.indexOf(_)>=0||(E+="\\"+_);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=P();function y(I){let E=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)E=I;else{let _="g";I.ignoreCase&&(_+="i"),I.multiline&&(_+="m"),I.unicode&&(_+="u"),E=new RegExp(I.source,_)}return E.lastIndex=0,E}e.ensureValidWordDefinition=y;const T=new D.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(I){const E=T.unshift(I);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function k(I,E,_,w,h){if(h||(h=c.Iterable.first(T)),_.length>h.maxLen){let r=I-h.maxLen/2;return r<0?r=0:w+=r,_=_.substring(r,I+h.maxLen/2),k(I,E,_,w,h)}const g=Date.now(),f=I-1-w;let v=-1,m=null;for(let r=1;!(Date.now()-g>=h.timeBudget);r++){const b=f-h.windowSize*r;E.lastIndex=Math.max(0,b);const s=A(E,_,f,v);if(!s&&m||(m=s,b<=0))break;v=b}if(m){const r={word:m[0],startColumn:w+1+m.index,endColumn:w+1+m.index+m[0].length};return E.lastIndex=0,r}return null}e.getWordAtText=k;function A(I,E,_,w){let h;for(;h=I.exec(E);){const g=h.index||0;if(g<=_&&I.lastIndex>=_)return h;if(w>0&&g>w)return null}return null}}),define(De[149],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class t{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(T.notIn))for(let S=0,k=T.notIn.length;S<k;S++)switch(T.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const k=T.findTokenIndexAtOffset(S-2),A=T.getStandardTokenType(k);return this.isOK(A)}_findNeutralCharacterInRange(T,S){for(let k=T;k<=S;k++){const A=String.fromCharCode(k);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class D{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)P(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),P(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),P(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),P(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&P(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function P(y,T,S){y.has(T)?y.get(T).push(S):y.set(T,[S])}}),define(De[150],Ie([1,0,102]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(_){_[_.Invalid=0]="Invalid",_[_.Start=1]="Start",_[_.H=2]="H",_[_.HT=3]="HT",_[_.HTT=4]="HTT",_[_.HTTP=5]="HTTP",_[_.F=6]="F",_[_.FI=7]="FI",_[_.FIL=8]="FIL",_[_.BeforeColon=9]="BeforeColon",_[_.AfterColon=10]="AfterColon",_[_.AlmostThere=11]="AlmostThere",_[_.End=12]="End",_[_.Accept=13]="Accept",_[_.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class D{constructor(w,h,g){const f=new Uint8Array(w*h);for(let v=0,m=w*h;v<m;v++)f[v]=g;this._data=f,this.rows=w,this.cols=h}get(w,h){return this._data[w*this.cols+h]}set(w,h,g){this._data[w*this.cols+h]=g}}e.Uint8Matrix=D;class P{constructor(w){let h=0,g=0;for(let v=0,m=w.length;v<m;v++){const[r,b,s]=w[v];b>h&&(h=b),r>g&&(g=r),s>g&&(g=s)}h++,g++;const f=new D(g,h,0);for(let v=0,m=w.length;v<m;v++){const[r,b,s]=w[v];f.set(r,b,s)}this._states=f,this._maxCharCode=h}nextState(w,h){return h<0||h>=this._maxCharCode?0:this._states.get(w,h)}}e.StateMachine=P;let y=null;function T(){return y===null&&(y=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var S;(function(_){_[_.None=0]="None",_[_.ForceTermination=1]="ForceTermination",_[_.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let k=null;function A(){if(k===null){k=new c.CharacterClassifier(0);const _=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<_.length;h++)k.set(_.charCodeAt(h),1);const w=".,;:";for(let h=0;h<w.length;h++)k.set(w.charCodeAt(h),2)}return k}class I{static _createLink(w,h,g,f,v){let m=v-1;do{const r=h.charCodeAt(m);if(w.get(r)!==2)break;m--}while(m>f);if(f>0){const r=h.charCodeAt(f-1),b=h.charCodeAt(m);(r===40&&b===41||r===91&&b===93||r===123&&b===125)&&m--}return{range:{startLineNumber:g,startColumn:f+1,endLineNumber:g,endColumn:m+2},url:h.substring(f,m+1)}}static computeLinks(w,h=T()){const g=A(),f=[];for(let v=1,m=w.getLineCount();v<=m;v++){const r=w.getLineContent(v),b=r.length;let s=0,u=0,o=0,l=1,a=!1,d=!1,n=!1,i=!1;for(;s<b;){let p=!1;const C=r.charCodeAt(s);if(l===13){let R;switch(C){case 40:a=!0,R=0;break;case 41:R=a?0:1;break;case 91:n=!0,d=!0,R=0;break;case 93:n=!1,R=d?0:1;break;case 123:i=!0,R=0;break;case 125:R=i?0:1;break;case 39:case 34:case 96:o===C?R=1:o===39||o===34||o===96?R=0:R=1;break;case 42:R=o===42?1:0;break;case 124:R=o===124?1:0;break;case 32:R=n?0:1;break;default:R=g.get(C)}R===1&&(f.push(I._createLink(g,r,v,u,s)),p=!0)}else if(l===12){let R;C===91?(d=!0,R=0):R=g.get(C),R===1?p=!0:l=13}else l=h.nextState(l,C),l===0&&(p=!0);p&&(l=1,a=!1,d=!1,i=!1,u=s+1,o=C),s++}l===13&&f.push(I._createLink(g,r,v,u,b))}return f}}e.LinkComputer=I;function E(_){return!_||typeof _.getLineCount!="function"||typeof _.getLineContent!="function"?[]:I.computeLinks(_)}e.computeLinks=E}),define(De[104],Ie([1,0,24]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var y;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(r){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace),this.bracketPairColorizationOptions=r.bracketPairColorizationOptions}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,r.bracketPairColorizationOptions)}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class A{constructor(r,b){this._findMatchBrand=void 0,this.range=r,this.matches=b}}e.FindMatch=A;var I;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(m){return m&&typeof m.read=="function"}e.isITextSnapshot=E;var _;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(_=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class h{constructor(r,b,s,u,o,l){this.identifier=r,this.range=b,this.text=s,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=o,this._isTracked=l}}e.ValidAnnotatedEditOperation=h;class g{constructor(r,b,s){this.regex=r,this.wordSeparators=b,this.simpleSearch=s}}e.SearchData=g;class f{constructor(r,b,s){this.reverseEdits=r,this.changes=b,this.trimAutoWhitespaceLineNumbers=s}}e.ApplyEditsResult=f;function v(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.shouldSynchronizeModel=v}),define(De[151],Ie([1,0,17,101]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,k){S=(0,t.toUint32)(S);const A=this.values,I=this.prefixSum,E=k.length;return E===0?!1:(this.values=new Uint32Array(A.length+E),this.values.set(A.subarray(0,S),0),this.values.set(A.subarray(S),S+E),this.values.set(k,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,k){return S=(0,t.toUint32)(S),k=(0,t.toUint32)(k),this.values[S]===k?!1:(this.values[S]=k,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,k){S=(0,t.toUint32)(S),k=(0,t.toUint32)(k);const A=this.values,I=this.prefixSum;if(S>=A.length)return!1;const E=A.length-S;return k>=E&&(k=E),k===0?!1:(this.values=new Uint32Array(A.length-k),this.values.set(A.subarray(0,S),0),this.values.set(A.subarray(S+k),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),S>=this.values.length&&(S=this.values.length-1);for(let A=k;A<=S;A++)this.prefixSum[A]=this.prefixSum[A-1]+this.values[A];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let k=0,A=this.values.length-1,I=0,E=0,_=0;for(;k<=A;)if(I=k+(A-k)/2|0,E=this.prefixSum[I],_=E-this.values[I],S<_)A=I-1;else if(S>=E)k=I+1;else break;return new y(I,S-_)}}e.PrefixSumComputer=D;class P{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const k=this._indexBySum[S],A=k>0?this._prefixSum[k-1]:0;return new y(k,S-A)}removeValues(S,k){this._values.splice(S,k),this._invalidate(S)}insertValues(S,k){this._values=(0,c.arrayInsert)(this._values,S,k),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,k=this._values.length;S<k;S++){const A=this._values[S],I=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=I+A;for(let E=0;E<A;E++)this._indexBySum[I+E]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,k){this._values[S]!==k&&(this._values[S]=k,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=P;class y{constructor(S,k){this.index=S,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=k}}e.PrefixSumIndexOfResult=y}),define(De[152],Ie([19,20]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(De[153],Ie([1,0,152]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,P=D*24,y=P*7,T=P*30,S=P*365;function k(I,E,_){typeof I!="number"&&(I=I.getTime());const w=Math.round((new Date().getTime()-I)/1e3);if(w<-30)return(0,c.localize)(0,null,k(new Date().getTime()+w*1e3,!1));if(w<30)return(0,c.localize)(1,null);let h;return w<t?(h=w,E?h===1?_?(0,c.localize)(2,null,h):(0,c.localize)(3,null,h):_?(0,c.localize)(4,null,h):(0,c.localize)(5,null,h):h===1?_?(0,c.localize)(6,null,h):(0,c.localize)(7,null,h):_?(0,c.localize)(8,null,h):(0,c.localize)(9,null,h)):w<D?(h=Math.floor(w/t),E?h===1?_?(0,c.localize)(10,null,h):(0,c.localize)(11,null,h):_?(0,c.localize)(12,null,h):(0,c.localize)(13,null,h):h===1?_?(0,c.localize)(14,null,h):(0,c.localize)(15,null,h):_?(0,c.localize)(16,null,h):(0,c.localize)(17,null,h)):w<P?(h=Math.floor(w/D),E?h===1?_?(0,c.localize)(18,null,h):(0,c.localize)(19,null,h):_?(0,c.localize)(20,null,h):(0,c.localize)(21,null,h):h===1?_?(0,c.localize)(22,null,h):(0,c.localize)(23,null,h):_?(0,c.localize)(24,null,h):(0,c.localize)(25,null,h)):w<y?(h=Math.floor(w/P),E?h===1?(0,c.localize)(26,null,h):(0,c.localize)(27,null,h):h===1?(0,c.localize)(28,null,h):(0,c.localize)(29,null,h)):w<T?(h=Math.floor(w/y),E?h===1?_?(0,c.localize)(30,null,h):(0,c.localize)(31,null,h):_?(0,c.localize)(32,null,h):(0,c.localize)(33,null,h):h===1?_?(0,c.localize)(34,null,h):(0,c.localize)(35,null,h):_?(0,c.localize)(36,null,h):(0,c.localize)(37,null,h)):w<S?(h=Math.floor(w/T),E?h===1?_?(0,c.localize)(38,null,h):(0,c.localize)(39,null,h):_?(0,c.localize)(40,null,h):(0,c.localize)(41,null,h):h===1?_?(0,c.localize)(42,null,h):(0,c.localize)(43,null,h):_?(0,c.localize)(44,null,h):(0,c.localize)(45,null,h)):(h=Math.floor(w/S),E?h===1?_?(0,c.localize)(46,null,h):(0,c.localize)(47,null,h):_?(0,c.localize)(48,null,h):(0,c.localize)(49,null,h):h===1?_?(0,c.localize)(50,null,h):(0,c.localize)(51,null,h):_?(0,c.localize)(52,null,h):(0,c.localize)(53,null,h))}e.fromNow=k;function A(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(De[154],Ie([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(De[50],Ie([1,0,17,11,154]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(I,E){return E&&(I.stack||I.stacktrace)?D.localize(0,null,T(I),y(I.stack)||y(I.stacktrace)):T(I)}function y(I){return Array.isArray(I)?I.join(`
`):I}function T(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?D.localize(1,null,I.message):I.message||D.localize(2,null)}function S(I=null,E=!1){if(!I)return D.localize(3,null);if(Array.isArray(I)){const _=c.coalesce(I),w=S(_[0],E);return _.length>1?D.localize(4,null,w,_.length):w}if(t.isString(I))return I;if(I.detail){const _=I.detail;if(_.error)return P(_.error,E);if(_.exception)return P(_.exception,E)}return I.stack?P(I,E):I.message?I.message:D.localize(5,null)}e.toErrorMessage=S;function k(I){const E=I;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=k;function A(I,E){let _;return typeof I=="string"?_=new Error(I):_=I,_.actions=E,_}e.createErrorWithActions=A}),define(De[155],Ie([19,20]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(De[12],Ie([1,0,155]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,D=!1,P=!1,y=!1,T=!1,S=!1,k=!1,A=!1,I=!1,E=!1,_,w=e.LANGUAGE_DEFAULT,h,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const v=typeof f?.versions?.electron=="string",m=v&&f?.type==="renderer";if(typeof navigator=="object"&&!m)g=navigator.userAgent,t=g.indexOf("Windows")>=0,D=g.indexOf("Macintosh")>=0,A=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=g.indexOf("Linux")>=0,E=g?.indexOf("Mobi")>=0,S=!0,_=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,w=_;else if(typeof f=="object"){t=f.platform==="win32",D=f.platform==="darwin",P=f.platform==="linux",y=P&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,k=v,I=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,_=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const n=f.env.VSCODE_NLS_CONFIG;if(n)try{const i=JSON.parse(n),p=i.availableLanguages["*"];_=i.locale,w=p||e.LANGUAGE_DEFAULT,h=i._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var r;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(r=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let s=0;D?s=1:t?s=3:P&&(s=2),e.isWindows=t,e.isMacintosh=D,e.isLinux=P,e.isLinuxSnap=y,e.isNative=T,e.isElectron=k,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=A,e.isMobile=E,e.isCI=I,e.platform=s,e.userAgent=g,e.language=w;var u;(function(n){function i(){return e.language}n.value=i;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=p;function C(){return e.language==="en"}n.isDefault=C})(u=e.Language||(e.Language={})),e.locale=_,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let C=0,R=n.length;C<R;C++){const M=n[C];if(M.id===p.data.vscodeScheduleAsyncWork){n.splice(C,1),M.callback();return}}});let i=0;return p=>{const C=++i;n.push({id:C,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return n=>setTimeout(n)})();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||A?2:t?1:3;let l=!0,a=!1;function d(){if(!a){a=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,l=new Uint16Array(n.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=d,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[36],Ie([1,0,12]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const D=c.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(De[9],Ie([1,0,36]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,P=90,y=122,T=46,S=47,k=92,A=58,I=63;class E extends Error{constructor(r,b,s){let u;typeof b=="string"&&b.indexOf("not ")===0?(u="must not be",b=b.replace(/^not /,"")):u="must be";const o=r.indexOf(".")!==-1?"property":"argument";let l=`The "${r}" ${o} ${u} of type ${b}`;l+=`. Received type ${typeof s}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function _(m,r){if(typeof m!="string")throw new E(r,"string",m)}function w(m){return m===S||m===k}function h(m){return m===S}function g(m){return m>=t&&m<=P||m>=D&&m<=y}function f(m,r,b,s){let u="",o=0,l=-1,a=0,d=0;for(let n=0;n<=m.length;++n){if(n<m.length)d=m.charCodeAt(n);else{if(s(d))break;d=S}if(s(d)){if(!(l===n-1||a===1))if(a===2){if(u.length<2||o!==2||u.charCodeAt(u.length-1)!==T||u.charCodeAt(u.length-2)!==T){if(u.length>2){const i=u.lastIndexOf(b);i===-1?(u="",o=0):(u=u.slice(0,i),o=u.length-1-u.lastIndexOf(b)),l=n,a=0;continue}else if(u.length!==0){u="",o=0,l=n,a=0;continue}}r&&(u+=u.length>0?`${b}..`:"..",o=2)}else u.length>0?u+=`${b}${m.slice(l+1,n)}`:u=m.slice(l+1,n),o=n-l-1;l=n,a=0}else d===T&&a!==-1?++a:a=-1}return u}function v(m,r){if(r===null||typeof r!="object")throw new E("pathObject","Object",r);const b=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return b?b===r.root?`${b}${s}`:`${b}${m}${s}`:s}e.win32={resolve(...m){let r="",b="",s=!1;for(let u=m.length-1;u>=-1;u--){let o;if(u>=0){if(o=m[u],_(o,"path"),o.length===0)continue}else r.length===0?o=c.cwd():(o=c.env[`=${r}`]||c.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===k)&&(o=`${r}\\`));const l=o.length;let a=0,d="",n=!1;const i=o.charCodeAt(0);if(l===1)w(i)&&(a=1,n=!0);else if(w(i))if(n=!0,w(o.charCodeAt(1))){let p=2,C=p;for(;p<l&&!w(o.charCodeAt(p));)p++;if(p<l&&p!==C){const R=o.slice(C,p);for(C=p;p<l&&w(o.charCodeAt(p));)p++;if(p<l&&p!==C){for(C=p;p<l&&!w(o.charCodeAt(p));)p++;(p===l||p!==C)&&(d=`\\\\${R}\\${o.slice(C,p)}`,a=p)}}}else a=1;else g(i)&&o.charCodeAt(1)===A&&(d=o.slice(0,2),a=2,l>2&&w(o.charCodeAt(2))&&(n=!0,a=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(s){if(r.length>0)break}else if(b=`${o.slice(a)}\\${b}`,s=n,n&&r.length>0)break}return b=f(b,!s,"\\",w),s?`${r}\\${b}`:`${r}${b}`||"."},normalize(m){_(m,"path");const r=m.length;if(r===0)return".";let b=0,s,u=!1;const o=m.charCodeAt(0);if(r===1)return h(o)?"\\":m;if(w(o))if(u=!0,w(m.charCodeAt(1))){let a=2,d=a;for(;a<r&&!w(m.charCodeAt(a));)a++;if(a<r&&a!==d){const n=m.slice(d,a);for(d=a;a<r&&w(m.charCodeAt(a));)a++;if(a<r&&a!==d){for(d=a;a<r&&!w(m.charCodeAt(a));)a++;if(a===r)return`\\\\${n}\\${m.slice(d)}\\`;a!==d&&(s=`\\\\${n}\\${m.slice(d,a)}`,b=a)}}}else b=1;else g(o)&&m.charCodeAt(1)===A&&(s=m.slice(0,2),b=2,r>2&&w(m.charCodeAt(2))&&(u=!0,b=3));let l=b<r?f(m.slice(b),!u,"\\",w):"";return l.length===0&&!u&&(l="."),l.length>0&&w(m.charCodeAt(r-1))&&(l+="\\"),s===void 0?u?`\\${l}`:l:u?`${s}\\${l}`:`${s}${l}`},isAbsolute(m){_(m,"path");const r=m.length;if(r===0)return!1;const b=m.charCodeAt(0);return w(b)||r>2&&g(b)&&m.charCodeAt(1)===A&&w(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let r,b;for(let o=0;o<m.length;++o){const l=m[o];_(l,"path"),l.length>0&&(r===void 0?r=b=l:r+=`\\${l}`)}if(r===void 0)return".";let s=!0,u=0;if(typeof b=="string"&&w(b.charCodeAt(0))){++u;const o=b.length;o>1&&w(b.charCodeAt(1))&&(++u,o>2&&(w(b.charCodeAt(2))?++u:s=!1))}if(s){for(;u<r.length&&w(r.charCodeAt(u));)u++;u>=2&&(r=`\\${r.slice(u)}`)}return e.win32.normalize(r)},relative(m,r){if(_(m,"from"),_(r,"to"),m===r)return"";const b=e.win32.resolve(m),s=e.win32.resolve(r);if(b===s||(m=b.toLowerCase(),r=s.toLowerCase(),m===r))return"";let u=0;for(;u<m.length&&m.charCodeAt(u)===k;)u++;let o=m.length;for(;o-1>u&&m.charCodeAt(o-1)===k;)o--;const l=o-u;let a=0;for(;a<r.length&&r.charCodeAt(a)===k;)a++;let d=r.length;for(;d-1>a&&r.charCodeAt(d-1)===k;)d--;const n=d-a,i=l<n?l:n;let p=-1,C=0;for(;C<i;C++){const M=m.charCodeAt(u+C);if(M!==r.charCodeAt(a+C))break;M===k&&(p=C)}if(C!==i){if(p===-1)return s}else{if(n>i){if(r.charCodeAt(a+C)===k)return s.slice(a+C+1);if(C===2)return s.slice(a+C)}l>i&&(m.charCodeAt(u+C)===k?p=C:C===2&&(p=3)),p===-1&&(p=0)}let R="";for(C=u+p+1;C<=o;++C)(C===o||m.charCodeAt(C)===k)&&(R+=R.length===0?"..":"\\..");return a+=p,R.length>0?`${R}${s.slice(a,d)}`:(s.charCodeAt(a)===k&&++a,s.slice(a,d))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const r=e.win32.resolve(m);if(r.length<=2)return m;if(r.charCodeAt(0)===k){if(r.charCodeAt(1)===k){const b=r.charCodeAt(2);if(b!==I&&b!==T)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===A&&r.charCodeAt(2)===k)return`\\\\?\\${r}`;return m},dirname(m){_(m,"path");const r=m.length;if(r===0)return".";let b=-1,s=0;const u=m.charCodeAt(0);if(r===1)return w(u)?m:".";if(w(u)){if(b=s=1,w(m.charCodeAt(1))){let a=2,d=a;for(;a<r&&!w(m.charCodeAt(a));)a++;if(a<r&&a!==d){for(d=a;a<r&&w(m.charCodeAt(a));)a++;if(a<r&&a!==d){for(d=a;a<r&&!w(m.charCodeAt(a));)a++;if(a===r)return m;a!==d&&(b=s=a+1)}}}}else g(u)&&m.charCodeAt(1)===A&&(b=r>2&&w(m.charCodeAt(2))?3:2,s=b);let o=-1,l=!0;for(let a=r-1;a>=s;--a)if(w(m.charCodeAt(a))){if(!l){o=a;break}}else l=!1;if(o===-1){if(b===-1)return".";o=b}return m.slice(0,o)},basename(m,r){r!==void 0&&_(r,"ext"),_(m,"path");let b=0,s=-1,u=!0,o;if(m.length>=2&&g(m.charCodeAt(0))&&m.charCodeAt(1)===A&&(b=2),r!==void 0&&r.length>0&&r.length<=m.length){if(r===m)return"";let l=r.length-1,a=-1;for(o=m.length-1;o>=b;--o){const d=m.charCodeAt(o);if(w(d)){if(!u){b=o+1;break}}else a===-1&&(u=!1,a=o+1),l>=0&&(d===r.charCodeAt(l)?--l===-1&&(s=o):(l=-1,s=a))}return b===s?s=a:s===-1&&(s=m.length),m.slice(b,s)}for(o=m.length-1;o>=b;--o)if(w(m.charCodeAt(o))){if(!u){b=o+1;break}}else s===-1&&(u=!1,s=o+1);return s===-1?"":m.slice(b,s)},extname(m){_(m,"path");let r=0,b=-1,s=0,u=-1,o=!0,l=0;m.length>=2&&m.charCodeAt(1)===A&&g(m.charCodeAt(0))&&(r=s=2);for(let a=m.length-1;a>=r;--a){const d=m.charCodeAt(a);if(w(d)){if(!o){s=a+1;break}continue}u===-1&&(o=!1,u=a+1),d===T?b===-1?b=a:l!==1&&(l=1):b!==-1&&(l=-1)}return b===-1||u===-1||l===0||l===1&&b===u-1&&b===s+1?"":m.slice(b,u)},format:v.bind(null,"\\"),parse(m){_(m,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return r;const b=m.length;let s=0,u=m.charCodeAt(0);if(b===1)return w(u)?(r.root=r.dir=m,r):(r.base=r.name=m,r);if(w(u)){if(s=1,w(m.charCodeAt(1))){let p=2,C=p;for(;p<b&&!w(m.charCodeAt(p));)p++;if(p<b&&p!==C){for(C=p;p<b&&w(m.charCodeAt(p));)p++;if(p<b&&p!==C){for(C=p;p<b&&!w(m.charCodeAt(p));)p++;p===b?s=p:p!==C&&(s=p+1)}}}}else if(g(u)&&m.charCodeAt(1)===A){if(b<=2)return r.root=r.dir=m,r;if(s=2,w(m.charCodeAt(2))){if(b===3)return r.root=r.dir=m,r;s=3}}s>0&&(r.root=m.slice(0,s));let o=-1,l=s,a=-1,d=!0,n=m.length-1,i=0;for(;n>=s;--n){if(u=m.charCodeAt(n),w(u)){if(!d){l=n+1;break}continue}a===-1&&(d=!1,a=n+1),u===T?o===-1?o=n:i!==1&&(i=1):o!==-1&&(i=-1)}return a!==-1&&(o===-1||i===0||i===1&&o===a-1&&o===l+1?r.base=r.name=m.slice(l,a):(r.name=m.slice(l,o),r.base=m.slice(l,a),r.ext=m.slice(o,a))),l>0&&l!==s?r.dir=m.slice(0,l-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let r="",b=!1;for(let s=m.length-1;s>=-1&&!b;s--){const u=s>=0?m[s]:c.cwd();_(u,"path"),u.length!==0&&(r=`${u}/${r}`,b=u.charCodeAt(0)===S)}return r=f(r,!b,"/",h),b?`/${r}`:r.length>0?r:"."},normalize(m){if(_(m,"path"),m.length===0)return".";const r=m.charCodeAt(0)===S,b=m.charCodeAt(m.length-1)===S;return m=f(m,!r,"/",h),m.length===0?r?"/":b?"./":".":(b&&(m+="/"),r?`/${m}`:m)},isAbsolute(m){return _(m,"path"),m.length>0&&m.charCodeAt(0)===S},join(...m){if(m.length===0)return".";let r;for(let b=0;b<m.length;++b){const s=m[b];_(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.posix.normalize(r)},relative(m,r){if(_(m,"from"),_(r,"to"),m===r||(m=e.posix.resolve(m),r=e.posix.resolve(r),m===r))return"";const b=1,s=m.length,u=s-b,o=1,l=r.length-o,a=u<l?u:l;let d=-1,n=0;for(;n<a;n++){const p=m.charCodeAt(b+n);if(p!==r.charCodeAt(o+n))break;p===S&&(d=n)}if(n===a)if(l>a){if(r.charCodeAt(o+n)===S)return r.slice(o+n+1);if(n===0)return r.slice(o+n)}else u>a&&(m.charCodeAt(b+n)===S?d=n:n===0&&(d=0));let i="";for(n=b+d+1;n<=s;++n)(n===s||m.charCodeAt(n)===S)&&(i+=i.length===0?"..":"/..");return`${i}${r.slice(o+d)}`},toNamespacedPath(m){return m},dirname(m){if(_(m,"path"),m.length===0)return".";const r=m.charCodeAt(0)===S;let b=-1,s=!0;for(let u=m.length-1;u>=1;--u)if(m.charCodeAt(u)===S){if(!s){b=u;break}}else s=!1;return b===-1?r?"/":".":r&&b===1?"//":m.slice(0,b)},basename(m,r){r!==void 0&&_(r,"ext"),_(m,"path");let b=0,s=-1,u=!0,o;if(r!==void 0&&r.length>0&&r.length<=m.length){if(r===m)return"";let l=r.length-1,a=-1;for(o=m.length-1;o>=0;--o){const d=m.charCodeAt(o);if(d===S){if(!u){b=o+1;break}}else a===-1&&(u=!1,a=o+1),l>=0&&(d===r.charCodeAt(l)?--l===-1&&(s=o):(l=-1,s=a))}return b===s?s=a:s===-1&&(s=m.length),m.slice(b,s)}for(o=m.length-1;o>=0;--o)if(m.charCodeAt(o)===S){if(!u){b=o+1;break}}else s===-1&&(u=!1,s=o+1);return s===-1?"":m.slice(b,s)},extname(m){_(m,"path");let r=-1,b=0,s=-1,u=!0,o=0;for(let l=m.length-1;l>=0;--l){const a=m.charCodeAt(l);if(a===S){if(!u){b=l+1;break}continue}s===-1&&(u=!1,s=l+1),a===T?r===-1?r=l:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||s===-1||o===0||o===1&&r===s-1&&r===b+1?"":m.slice(r,s)},format:v.bind(null,"/"),parse(m){_(m,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return r;const b=m.charCodeAt(0)===S;let s;b?(r.root="/",s=1):s=0;let u=-1,o=0,l=-1,a=!0,d=m.length-1,n=0;for(;d>=s;--d){const i=m.charCodeAt(d);if(i===S){if(!a){o=d+1;break}continue}l===-1&&(a=!1,l=d+1),i===T?u===-1?u=d:n!==1&&(n=1):u!==-1&&(n=-1)}if(l!==-1){const i=o===0&&b?1:o;u===-1||n===0||n===1&&u===l-1&&u===o+1?r.base=r.name=m.slice(i,l):(r.name=m.slice(i,u),r.base=m.slice(i,l),r.ext=m.slice(u,l))}return o>0?r.dir=m.slice(0,o-1):b&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=c.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=c.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=c.platform==="win32"?e.win32.join:e.posix.join,e.resolve=c.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=c.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=c.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=c.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=c.platform==="win32"?e.win32.extname:e.posix.extname,e.format=c.platform==="win32"?e.win32.format:e.posix.format,e.parse=c.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=c.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=c.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=c.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(De[105],Ie([1,0,9]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(A){const I=(0,c.extname)(A),E=t[I.toLowerCase()];return E!==void 0?E:y(A)}e.getMediaOrTextMime=P;function y(A){const I=(0,c.extname)(A);return D[I.toLowerCase()]}e.getMediaMime=y;function T(A){for(const I in D)if(D[I]===A)return I}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function k(A,I){const E=S.exec(A);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:I?void 0:A}e.normalizeMimeType=k}),define(De[106],Ie([1,0,12]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(T,...S){const k=S.reduce((E,_)=>(E[_]=!0,E),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(E=>!k[E]).forEach(E=>{for(let _=0;_<A.length;_++)if(E.search(A[_])!==-1){delete T[E];break}})}e.sanitizeProcessEnvironment=P;function y(T){!T||(delete T.DEBUG,c.isMacintosh&&delete T.DYLD_LIBRARY_PATH,c.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=y}),define(De[51],Ie([1,0,12]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=c.globals.performance&&typeof c.globals.performance.now=="function";class D{static create(y=!0){return new D(y)}constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?c.globals.performance.now():Date.now()}}e.StopWatch=D}),define(De[4],Ie([1,0,10,61,6,63,51]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var k;(function(d){d.None=()=>D.Disposable.None;function n(ke){if(S){const{onListenerDidAdd:Re}=ke,ze=w.create();let ie=0;ke.onListenerDidAdd=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ze.print()),Re?.()}}}function i(ke,Re){return z(ke,()=>{},0,void 0,void 0,Re)}d.defer=i;function p(ke,Re=0,ze){return d.debounce(ke,(ie,ce)=>ie?(ie.push(ce),ie):[ce],Re,void 0,void 0,ze)}d.accumulate=p;function C(ke){return(Re,ze=null,ie)=>{let ce=!1,me;return me=ke(J=>{if(!ce)return me?me.dispose():ce=!0,Re.call(ze,J)},null,ie),ce&&me.dispose(),me}}d.once=C;function R(ke,Re,ze){return O((ie,ce=null,me)=>ke(J=>ie.call(ce,Re(J)),null,me),ze)}d.map=R;function M(ke,Re,ze){return O((ie,ce=null,me)=>ke(J=>{Re(J),ie.call(ce,J)},null,me),ze)}d.forEach=M;function $(ke,Re,ze){return O((ie,ce=null,me)=>ke(J=>Re(J)&&ie.call(ce,J),null,me),ze)}d.filter=$;function x(ke){return ke}d.signal=x;function L(...ke){return(Re,ze=null,ie)=>(0,D.combinedDisposable)(...ke.map(ce=>ce(me=>Re.call(ze,me),null,ie)))}d.any=L;function B(ke,Re,ze,ie){let ce=ze;return R(ke,me=>(ce=Re(ce,me),ce),ie)}d.reduce=B;function O(ke,Re){let ze;const ie={onFirstListenerAdd(){ze=ke(ce.fire,ce)},onLastListenerRemove(){ze?.dispose()}};Re||n(ie);const ce=new g(ie);return Re?.add(ce),ce.event}function z(ke,Re,ze=100,ie=!1,ce,me){let J,ae,ne,se=0;const N={leakWarningThreshold:ce,onFirstListenerAdd(){J=ke(G=>{se++,ae=Re(ae,G),ie&&!ne&&(j.fire(ae),ae=void 0),clearTimeout(ne),ne=setTimeout(()=>{const X=ae;ae=void 0,ne=void 0,(!ie||se>1)&&j.fire(X),se=0},ze)})},onLastListenerRemove(){J.dispose()}};me||n(N);const j=new g(N);return me?.add(j),j.event}d.debounce=z;function U(ke,Re=(ie,ce)=>ie===ce,ze){let ie=!0,ce;return $(ke,me=>{const J=ie||!Re(me,ce);return ie=!1,ce=me,J},ze)}d.latch=U;function F(ke,Re,ze){return[d.filter(ke,Re,ze),d.filter(ke,ie=>!Re(ie),ze)]}d.split=F;function V(ke,Re=!1,ze=[]){let ie=ze.slice(),ce=ke(ae=>{ie?ie.push(ae):J.fire(ae)});const me=()=>{ie?.forEach(ae=>J.fire(ae)),ie=null},J=new g({onFirstListenerAdd(){ce||(ce=ke(ae=>J.fire(ae)))},onFirstListenerDidAdd(){ie&&(Re?setTimeout(me):me())},onLastListenerRemove(){ce&&ce.dispose(),ce=null}});return J.event}d.buffer=V;class H{constructor(Re){this.event=Re,this.disposables=new D.DisposableStore}map(Re){return new H(R(this.event,Re,this.disposables))}forEach(Re){return new H(M(this.event,Re,this.disposables))}filter(Re){return new H($(this.event,Re,this.disposables))}reduce(Re,ze){return new H(B(this.event,Re,ze,this.disposables))}latch(){return new H(U(this.event,void 0,this.disposables))}debounce(Re,ze=100,ie=!1,ce){return new H(z(this.event,Re,ze,ie,ce,this.disposables))}on(Re,ze,ie){return this.event(Re,ze,ie)}once(Re,ze,ie){return C(this.event)(Re,ze,ie)}dispose(){this.disposables.dispose()}}function Q(ke){return new H(ke)}d.chain=Q;function K(ke,Re,ze=ie=>ie){const ie=(...ae)=>J.fire(ze(...ae)),ce=()=>ke.on(Re,ie),me=()=>ke.removeListener(Re,ie),J=new g({onFirstListenerAdd:ce,onLastListenerRemove:me});return J.event}d.fromNodeEventEmitter=K;function de(ke,Re,ze=ie=>ie){const ie=(...ae)=>J.fire(ze(...ae)),ce=()=>ke.addEventListener(Re,ie),me=()=>ke.removeEventListener(Re,ie),J=new g({onFirstListenerAdd:ce,onLastListenerRemove:me});return J.event}d.fromDOMEventEmitter=de;function ee(ke){return new Promise(Re=>C(ke)(Re))}d.toPromise=ee;function fe(ke,Re){return Re(void 0),ke(ze=>Re(ze))}d.runAndSubscribe=fe;function Y(ke,Re){let ze=null;function ie(me){ze?.dispose(),ze=new D.DisposableStore,Re(me,ze)}ie(void 0);const ce=ke(me=>ie(me));return(0,D.toDisposable)(()=>{ce.dispose(),ze?.dispose()})}d.runAndSubscribeWithStore=Y;class ve{constructor(Re,ze){this.obs=Re,this._counter=0,this._hasChanged=!1;const ie={onFirstListenerAdd:()=>{Re.addObserver(this)},onLastListenerRemove:()=>{Re.removeObserver(this)}};ze||n(ie),this.emitter=new g(ie),ze&&ze.add(this.emitter)}beginUpdate(Re){this._counter++}handleChange(Re,ze){this._hasChanged=!0}endUpdate(Re){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Ee(ke,Re){return new ve(ke,Re).emitter.event}d.fromObservable=Ee})(k=e.Event||(e.Event={}));class A{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${A._idPool++}`,A.all.add(this)}start(n){this._stopWatch=new y.StopWatch(!0),this.listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=A,A.all=new Set,A._idPool=0;let I=-1;function E(d){const n=I;return I=d,{dispose(){I=n}}}e.setGlobalLeakWarningThreshold=E;class _{constructor(n,i=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n,i){let p=I;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||i<p)return;this._stacks||(this._stacks=new Map);const C=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,C+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let R,M=0;for(const[$,x]of this._stacks)(!R||M<x)&&(R=$,M=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${M}):`),console.warn(R)}return()=>{const R=this._stacks.get(n.value)||0;this._stacks.set(n.value,R-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(n,i,p){this.callback=n,this.callbackThis=i,this.stack=p,this.subscription=new D.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class g{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=I>0?new _(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(T){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const i of n)i.subscription.isset()&&(i.subscription.unset(),i.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,i,p)=>{this._listeners||(this._listeners=new P.LinkedList);const C=this._listeners.isEmpty();C&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,M;this._leakageMon&&this._listeners.size>=30&&(M=w.create(),R=this._leakageMon.check(M,this._listeners.size+1)),T&&(M=M??w.create());const $=new h(n,i,M),x=this._listeners.push($);C&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,i);const L=$.subscription.set(()=>{R?.(),this._disposed||(x(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return p instanceof D.DisposableStore?p.add(L):Array.isArray(p)&&p.push(L),L}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const i of this._listeners)this._deliveryQueue.push(this,i,n);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=g;class f{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(n,i,p){this._queue.push(new m(n,i,p))}clear(n){const i=new P.LinkedList;for(const p of this._queue)p.emitter!==n&&i.push(p);this._queue=i}deliver(){for(;this._queue.size>0;){const n=this._queue.shift();try{n.listener.invoke(n.event)}catch(i){(0,c.onUnexpectedError)(i)}}}}e.EventDeliveryQueue=f;class v extends f{clear(n){this._queue.clear()}}class m{constructor(n,i,p){this.emitter=n,this.listener=i,this.event=p}}class r extends g{async fireAsync(n,i,p){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const C of this._listeners)this._asyncDeliveryQueue.push([C,n]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[C,R]=this._asyncDeliveryQueue.shift(),M=[],$={...R,token:i,waitUntil:x=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");p&&(x=p(x,C.callback)),M.push(x)}};try{C.invoke($)}catch(x){(0,c.onUnexpectedError)(x);continue}Object.freeze(M),await Promise.allSettled(M).then(x=>{for(const L of x)L.status==="rejected"&&(0,c.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=r;class b extends g{constructor(n){super(n),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=b;class s extends b{constructor(n){super(n),this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=s;class u extends g{constructor(n){super(n),this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){!this.hasListeners()||(this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const i={event:n,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const p=()=>{this.hasListeners&&this.unhook(i);const C=this.events.indexOf(i);this.events.splice(C,1)};return(0,D.toDisposable)((0,t.once)(p))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(i=>this.emitter.fire(i))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class l{constructor(){this.buffers=[]}wrapEvent(n){return(i,p,C)=>n(R=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>i.call(p,R)):i.call(p,R)},void 0,C)}bufferEvents(n){const i=[];this.buffers.push(i);const p=n();return this.buffers.pop(),i.forEach(C=>C()),p}}e.EventBufferer=l;class a{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=D.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(De[21],Ie([1,0,4]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(T,S){const k=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(k)}}});var D;(function(T){function S(k){return k===T.None||k===T.Cancelled||k instanceof P?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new c.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=y}),define(De[156],Ie([1,0,21]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new c.CancellationTokenSource,S=this.task(T.token);return this.result={promise:S,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=t;class D{constructor(T){this.fn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const S=JSON.stringify(T);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.fn(T)),this.lastCache}}e.LRUCachedFunction=D;class P{get cachedValues(){return this._map}constructor(T){this.fn=T,this._map=new Map}get(T){if(this._map.has(T))return this._map.get(T);const S=this.fn(T);return this._map.set(T,S),S}}e.CachedFunction=P}),define(De[157],Ie([1,0,4,6]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=y=>({onDidChange:c.Event.None,value:y});e.staticObservableValue=D;class P extends t.Disposable{get value(){return this._value}set value(T){T!==this._value&&(this._value=T,this.changeEmitter.fire(T))}constructor(T){super(),this._value=T,this.changeEmitter=this._register(new c.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=P}),define(De[8],Ie([1,0,156,79]),function(Z,e,c,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=P;const y=/{(\d+)}/g;function T(ue,...Pe){return Pe.length===0?ue:ue.replace(y,function(Le,Ne){const qe=parseInt(Ne,10);return isNaN(qe)||qe<0||qe>=Pe.length?Le:Pe[qe]})}e.format=T;const S=/{([^}]+)}/g;function k(ue,Pe){return ue.replace(S,(Le,Ne)=>Pe[Ne]??Le)}e.format2=k;function A(ue){return ue.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}e.escape=A;function I(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function E(ue,Pe){let Le=0;const Ne=Pe.charCodeAt(0);for(let qe=ue.length-1;qe>=0;qe--)ue.charCodeAt(qe)===Ne&&Le++;return Le}e.count=E;function _(ue,Pe,Le="\u2026"){return ue.length<=Pe?ue:`${ue.substr(0,Pe)}${Le}`}e.truncate=_;function w(ue,Pe=" "){const Le=h(ue,Pe);return g(Le,Pe)}e.trim=w;function h(ue,Pe){if(!ue||!Pe)return ue;const Le=Pe.length;if(Le===0||ue.length===0)return ue;let Ne=0;for(;ue.indexOf(Pe,Ne)===Ne;)Ne=Ne+Le;return ue.substring(Ne)}e.ltrim=h;function g(ue,Pe){if(!ue||!Pe)return ue;const Le=Pe.length,Ne=ue.length;if(Le===0||Ne===0)return ue;let qe=Ne,Ye=-1;for(;Ye=ue.lastIndexOf(Pe,qe-1),!(Ye===-1||Ye+Le!==qe);){if(Ye===0)return"";qe=Ye}return ue.substring(0,qe)}e.rtrim=g;function f(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function v(ue){return ue.replace(/\*/g,"")}e.stripWildcards=v;function m(ue,Pe,Le={}){if(!ue)throw new Error("Cannot create regex from empty string");Pe||(ue=I(ue)),Le.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Ne="";return Le.global&&(Ne+="g"),Le.matchCase||(Ne+="i"),Le.multiline&&(Ne+="m"),Le.unicode&&(Ne+="u"),new RegExp(ue,Ne)}e.createRegExp=m;function r(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=r;function b(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function s(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=s;function u(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=u;function o(ue){for(let Pe=0,Le=ue.length;Pe<Le;Pe++){const Ne=ue.charCodeAt(Pe);if(Ne!==32&&Ne!==9)return Pe}return-1}e.firstNonWhitespaceIndex=o;function l(ue,Pe=0,Le=ue.length){for(let Ne=Pe;Ne<Le;Ne++){const qe=ue.charCodeAt(Ne);if(qe!==32&&qe!==9)return ue.substring(Pe,Ne)}return ue.substring(Pe,Le)}e.getLeadingWhitespace=l;function a(ue,Pe=ue.length-1){for(let Le=Pe;Le>=0;Le--){const Ne=ue.charCodeAt(Le);if(Ne!==32&&Ne!==9)return Le}return-1}e.lastNonWhitespaceIndex=a;function d(ue,Pe,Le){const Ne=[];let qe=0;for(const Ye of ue.matchAll(Pe)){if(Ne.push(ue.slice(qe,Ye.index)),Ye.index===void 0)throw new Error("match.index should be defined");qe=Ye.index+Ye[0].length,Ne.push(Le(Ye[0],...Ye.slice(1),Ye.index,ue,Ye.groups))}return Ne.push(ue.slice(qe)),Promise.all(Ne).then(Ye=>Ye.join(""))}e.replaceAsync=d;function n(ue,Pe){return ue<Pe?-1:ue>Pe?1:0}e.compare=n;function i(ue,Pe,Le=0,Ne=ue.length,qe=0,Ye=Pe.length){for(;Le<Ne&&qe<Ye;Le++,qe++){const st=ue.charCodeAt(Le),et=Pe.charCodeAt(qe);if(st<et)return-1;if(st>et)return 1}const it=Ne-Le,bt=Ye-qe;return it<bt?-1:it>bt?1:0}e.compareSubstring=i;function p(ue,Pe){return C(ue,Pe,0,ue.length,0,Pe.length)}e.compareIgnoreCase=p;function C(ue,Pe,Le=0,Ne=ue.length,qe=0,Ye=Pe.length){for(;Le<Ne&&qe<Ye;Le++,qe++){let st=ue.charCodeAt(Le),et=Pe.charCodeAt(qe);if(st===et)continue;if(st>=128||et>=128)return i(ue.toLowerCase(),Pe.toLowerCase(),Le,Ne,qe,Ye);M(st)&&(st-=32),M(et)&&(et-=32);const wt=st-et;if(wt!==0)return wt}const it=Ne-Le,bt=Ye-qe;return it<bt?-1:it>bt?1:0}e.compareSubstringIgnoreCase=C;function R(ue){return ue>=48&&ue<=57}e.isAsciiDigit=R;function M(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=M;function $(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=$;function x(ue,Pe){return ue.length===Pe.length&&C(ue,Pe)===0}e.equalsIgnoreCase=x;function L(ue,Pe){const Le=Pe.length;return Pe.length>ue.length?!1:C(ue,Pe,0,Le)===0}e.startsWithIgnoreCase=L;function B(ue,Pe){const Le=Math.min(ue.length,Pe.length);let Ne;for(Ne=0;Ne<Le;Ne++)if(ue.charCodeAt(Ne)!==Pe.charCodeAt(Ne))return Ne;return Le}e.commonPrefixLength=B;function O(ue,Pe){const Le=Math.min(ue.length,Pe.length);let Ne;const qe=ue.length-1,Ye=Pe.length-1;for(Ne=0;Ne<Le;Ne++)if(ue.charCodeAt(qe-Ne)!==Pe.charCodeAt(Ye-Ne))return Ne;return Le}e.commonSuffixLength=O;function z(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=z;function U(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=U;function F(ue,Pe){return(ue-55296<<10)+(Pe-56320)+65536}e.computeCodePoint=F;function V(ue,Pe,Le){const Ne=ue.charCodeAt(Le);if(z(Ne)&&Le+1<Pe){const qe=ue.charCodeAt(Le+1);if(U(qe))return F(Ne,qe)}return Ne}e.getNextCodePoint=V;function H(ue,Pe){const Le=ue.charCodeAt(Pe-1);if(U(Le)&&Pe>1){const Ne=ue.charCodeAt(Pe-2);if(z(Ne))return F(Ne,Le)}return Le}class Q{get offset(){return this._offset}constructor(Pe,Le=0){this._str=Pe,this._len=Pe.length,this._offset=Le}setOffset(Pe){this._offset=Pe}prevCodePoint(){const Pe=H(this._str,this._offset);return this._offset-=Pe>=65536?2:1,Pe}nextCodePoint(){const Pe=V(this._str,this._len,this._offset);return this._offset+=Pe>=65536?2:1,Pe}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class K{get offset(){return this._iterator.offset}constructor(Pe,Le=0){this._iterator=new Q(Pe,Le)}nextGraphemeLength(){const Pe=Je.getInstance(),Le=this._iterator,Ne=Le.offset;let qe=Pe.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const Ye=Le.offset,it=Pe.getGraphemeBreakType(Le.nextCodePoint());if(We(qe,it)){Le.setOffset(Ye);break}qe=it}return Le.offset-Ne}prevGraphemeLength(){const Pe=Je.getInstance(),Le=this._iterator,Ne=Le.offset;let qe=Pe.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const Ye=Le.offset,it=Pe.getGraphemeBreakType(Le.prevCodePoint());if(We(it,qe)){Le.setOffset(Ye);break}qe=it}return Ne-Le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function de(ue,Pe){return new K(ue,Pe).nextGraphemeLength()}e.nextCharLength=de;function ee(ue,Pe){return new K(ue,Pe).prevGraphemeLength()}e.prevCharLength=ee;function fe(ue,Pe){Pe>0&&U(ue.charCodeAt(Pe))&&Pe--;const Le=Pe+de(ue,Pe);return[Le-ee(ue,Le),Le]}e.getCharContainingOffset=fe;function Y(ue){const Pe=new K(ue);let Le=0;for(;!Pe.eol();)Le++,Pe.nextGraphemeLength();return Le}e.charCount=Y;let ve;function Ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(ue){return ve||(ve=Ee()),ve.test(ue)}e.containsRTL=ke;const Re=/^[\t\n\r\x20-\x7E]*$/;function ze(ue){return Re.test(ue)}e.isBasicASCII=ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=ie;function ce(ue){return ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=ce;function me(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129008||ue>=129280&&ue<=129535||ue>=129648&&ue<=129782}e.isEmojiImprecise=me;function J(ue,Pe){if(ue.length<Pe)return ue;const Le=/\b/g;let Ne=0;for(;Le.test(ue)&&!(ue.length-Le.lastIndex<Pe);)Ne=Le.lastIndex,Le.lastIndex+=1;return ue.substring(Ne).replace(/^\s/,"")}e.lcut=J;const ae=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,se=/\x1b\[0?m/g;function N(ue){return ue&&(ue=ue.replace(ae,""),ue=ue.replace(ne,""),ue=ue.replace(se,"")),ue}e.removeAnsiEscapeCodes=N,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function j(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=j;function G(ue){return j(ue)?ue.substr(1):ue}e.stripUTF8BOM=G;function X(ue,Pe){if(!ue||!Pe||ue.length<Pe.length)return!1;const Le=Pe.length,Ne=ue.toLowerCase();let qe=0,Ye=-1;for(;qe<Le;){const it=Ne.indexOf(Pe[qe],Ye+1);if(it<0)return!1;Ye=it,qe++}return!0}e.fuzzyContains=X;function ge(ue,Pe=!1){return ue?(Pe&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=ge;function be(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=be;function le(ue,Pe=1){if(Pe===0)return"";let Le=-1;do Le=ue.indexOf(`
`,Le+1),Pe--;while(Pe>0&&Le>=0);return Le===-1?ue:(ue[Le-1]==="\r"&&Le--,ue.substr(0,Le))}e.getNLines=le;function ye(ue){return ue=ue%(2*26),ue<26?String.fromCharCode(97+ue):String.fromCharCode(65+ue-26)}e.singleLetterHash=ye;function Ce(ue){return Je.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=Ce;function We(ue,Pe){return ue===0?Pe!==5&&Pe!==7:ue===2&&Pe===3?!1:ue===4||ue===2||ue===3||Pe===4||Pe===2||Pe===3?!0:!(ue===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(ue===11||ue===9)&&(Pe===9||Pe===10)||(ue===12||ue===10)&&Pe===10||Pe===5||Pe===13||Pe===7||ue===1||ue===13&&Pe===14||ue===6&&Pe===6)}var je;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Je{static getInstance(){return Je._INSTANCE||(Je._INSTANCE=new Je),Je._INSTANCE}constructor(){this._data=Qe()}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const Le=this._data,Ne=Le.length/3;let qe=1;for(;qe<=Ne;)if(Pe<Le[3*qe])qe=2*qe;else if(Pe>Le[3*qe+1])qe=2*qe+1;else return Le[3*qe+2];return 0}}Je._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(ue,Pe){if(ue===0)return 0;const Le=Be(ue,Pe);if(Le!==void 0)return Le;const Ne=new Q(Pe,ue);return Ne.prevCodePoint(),Ne.offset}e.getLeftDeleteOffset=Ze;function Be(ue,Pe){const Le=new Q(Pe,ue);let Ne=Le.prevCodePoint();for(;ut(Ne)||Ne===65039||Ne===8419;){if(Le.offset===0)return;Ne=Le.prevCodePoint()}if(!me(Ne))return;let qe=Le.offset;return qe>0&&Le.prevCodePoint()===8205&&(qe=Le.offset),qe}function ut(ue){return 127995<=ue&&ue<=127999}var re;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(re||(re={})),e.noBreakWhitespace="\xA0";class oe{static getInstance(Pe){return oe.cache.get(Array.from(Pe))}static getLocales(){return oe._locales.getValue()}constructor(Pe){this.confusableDictionary=Pe}isAmbiguous(Pe){return this.confusableDictionary.has(Pe)}getPrimaryConfusable(Pe){return this.confusableDictionary.get(Pe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=oe,D=oe,oe.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),oe.cache=new c.LRUCachedFunction(ue=>{function Pe(et){const wt=new Map;for(let St=0;St<et.length;St+=2)wt.set(et[St],et[St+1]);return wt}function Le(et,wt){const St=new Map(et);for(const[Ct,ft]of wt)St.set(Ct,ft);return St}function Ne(et,wt){if(!et)return wt;const St=new Map;for(const[Ct,ft]of et)wt.has(Ct)&&St.set(Ct,ft);return St}const qe=D.ambiguousCharacterData.getValue();let Ye=ue.filter(et=>!et.startsWith("_")&&et in qe);Ye.length===0&&(Ye=["_default"]);let it;for(const et of Ye){const wt=Pe(qe[et]);it=Ne(it,wt)}const bt=Pe(qe._common),st=Le(bt,it);return new oe(st)}),oe._locales=new t.Lazy(()=>Object.keys(oe.ambiguousCharacterData.getValue()).filter(ue=>!ue.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(Pe){return _e.getData().has(Pe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(De[32],Ie([1,0,9,12,8,11]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(a){return a===47||a===92}e.isPathSeparator=y;function T(a){return a.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=T;function S(a){return a.indexOf("/")===-1&&(a=T(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=S;function k(a,d=c.posix.sep){if(!a)return"";const n=a.length,i=a.charCodeAt(0);if(y(i)){if(y(a.charCodeAt(1))&&!y(a.charCodeAt(2))){let C=3;const R=C;for(;C<n&&!y(a.charCodeAt(C));C++);if(R!==C&&!y(a.charCodeAt(C+1))){for(C+=1;C<n;C++)if(y(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,d)}}return d}else if(f(i)&&a.charCodeAt(1)===58)return y(a.charCodeAt(2))?a.slice(0,2)+d:a.slice(0,2);let p=a.indexOf("://");if(p!==-1){for(p+=3;p<n;p++)if(y(a.charCodeAt(p)))return a.slice(0,p+1)}return""}e.getRoot=k;function A(a){if(!t.isWindows||!a||a.length<5)return!1;let d=a.charCodeAt(0);if(d!==92||(d=a.charCodeAt(1),d!==92))return!1;let n=2;const i=n;for(;n<a.length&&(d=a.charCodeAt(n),d!==92);n++);return!(i===n||(d=a.charCodeAt(n+1),isNaN(d)||d===92))}e.isUNC=A;const I=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(a,d=t.isWindows){const n=d?I:E;return!(!a||a.length===0||/^\s+$/.test(a)||(n.lastIndex=0,n.test(a))||d&&_.test(a)||a==="."||a===".."||d&&a[a.length-1]==="."||d&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=w;function h(a,d,n){const i=a===d;return!n||i?i:!a||!d?!1:(0,D.equalsIgnoreCase)(a,d)}e.isEqual=h;function g(a,d,n,i=c.sep){if(a===d)return!0;if(!a||!d||d.length>a.length)return!1;if(n){if(!(0,D.startsWithIgnoreCase)(a,d))return!1;if(d.length===a.length)return!0;let C=d.length;return d.charAt(d.length-1)===i&&C--,a.charAt(C)===i}return d.charAt(d.length-1)!==i&&(d+=i),a.indexOf(d)===0}e.isEqualOrParent=g;function f(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=f;function v(a,d){return t.isWindows&&a.endsWith(":")&&(a+=c.sep),(0,c.isAbsolute)(a)||(a=(0,c.join)(d,a)),a=(0,c.normalize)(a),t.isWindows?(a=(0,D.rtrim)(a,c.sep),a.endsWith(":")&&(a+=c.sep)):(a=(0,D.rtrim)(a,c.sep),a||(a=c.sep)),a}e.sanitizeFilePath=v;function m(a){const d=(0,c.normalize)(a);return t.isWindows?a.length>3?!1:r(d)&&(a.length===2||d.charCodeAt(2)===92):d===c.posix.sep}e.isRootOrDriveLetter=m;function r(a,d=t.isWindows){return d?f(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function b(a){return r(a)?a[0]:void 0}e.getDriveLetter=b;function s(a,d,n){return d.length>a.length?-1:a===d?0:(n&&(a=a.toLowerCase(),d=d.toLowerCase()),a.indexOf(d))}e.indexOfPath=s;function u(a){const d=a.split(":");let n,i,p;for(const C of d){const R=Number(C);(0,P.isNumber)(R)?i===void 0?i=R:p===void 0&&(p=R):n=n?[n,C].join(":"):C}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:i!==void 0?i:void 0,column:p!==void 0?p:i!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(a,d,n=8){let i="";for(let C=0;C<n;C++)i+=o.charAt(Math.floor(Math.random()*o.length));let p;return d?p=`${d}-${i}`:p=i,a?(0,c.join)(a,p):p}e.randomPath=l}),define(De[107],Ie([1,0,28,8]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...ne){return function(se,N){for(let j=0,G=ne.length;j<G;j++){const X=ne[j](se,N);if(X)return X}return null}}e.or=D,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ne,se,N){if(!N||N.length<se.length)return null;let j;return ne?j=t.startsWithIgnoreCase(N,se):j=N.indexOf(se)===0,j?se.length>0?[{start:0,end:se.length}]:[]:null}function y(ne,se){const N=se.toLowerCase().indexOf(ne.toLowerCase());return N===-1?null:[{start:N,end:N+ne.length}]}e.matchesContiguousSubString=y;function T(ne,se){return S(ne.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=T;function S(ne,se,N,j){if(N===ne.length)return[];if(j===se.length)return null;if(ne[N]===se[j]){let G=null;return(G=S(ne,se,N+1,j+1))?f({start:j,end:j+1},G):null}return S(ne,se,N,j+1)}function k(ne){return 97<=ne&&ne<=122}function A(ne){return 65<=ne&&ne<=90}e.isUpper=A;function I(ne){return 48<=ne&&ne<=57}function E(ne){return ne===32||ne===9||ne===10||ne===13}const _=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>_.add(ne.charCodeAt(0)));function w(ne){return E(ne)||_.has(ne)}function h(ne,se){return ne===se||w(ne)&&w(se)}function g(ne){return k(ne)||A(ne)||I(ne)}function f(ne,se){return se.length===0?se=[ne]:ne.end===se[0].start?se[0].start=ne.start:se.unshift(ne),se}function v(ne,se){for(let N=se;N<ne.length;N++){const j=ne.charCodeAt(N);if(A(j)||I(j)||N>0&&!g(ne.charCodeAt(N-1)))return N}return ne.length}function m(ne,se,N,j){if(N===ne.length)return[];if(j===se.length)return null;if(ne[N]!==se[j].toLowerCase())return null;{let G=null,X=j+1;for(G=m(ne,se,N+1,j+1);!G&&(X=v(se,X))<se.length;)G=m(ne,se,N+1,X),X++;return G===null?null:f({start:j,end:j+1},G)}}function r(ne){let se=0,N=0,j=0,G=0,X=0;for(let Ce=0;Ce<ne.length;Ce++)X=ne.charCodeAt(Ce),A(X)&&se++,k(X)&&N++,g(X)&&j++,I(X)&&G++;const ge=se/ne.length,be=N/ne.length,le=j/ne.length,ye=G/ne.length;return{upperPercent:ge,lowerPercent:be,alphaPercent:le,numericPercent:ye}}function b(ne){const{upperPercent:se,lowerPercent:N}=ne;return N===0&&se>.6}function s(ne){const{upperPercent:se,lowerPercent:N,alphaPercent:j,numericPercent:G}=ne;return N>.2&&se<.8&&j>.6&&G<.2}function u(ne){let se=0,N=0,j=0,G=0;for(let X=0;X<ne.length;X++)j=ne.charCodeAt(X),A(j)&&se++,k(j)&&N++,E(j)&&G++;return(se===0||N===0)&&G===0?ne.length<=30:se<=5}function o(ne,se){if(!se||(se=se.trim(),se.length===0)||!u(ne)||se.length>60)return null;const N=r(se);if(!s(N)){if(!b(N))return null;se=se.toLowerCase()}let j=null,G=0;for(ne=ne.toLowerCase();G<se.length&&(j=m(ne,se,0,G))===null;)G=v(se,G+1);return j}e.matchesCamelCase=o;function l(ne,se,N=!1){if(!se||se.length===0)return null;let j=null,G=0;for(ne=ne.toLowerCase(),se=se.toLowerCase();G<se.length&&(j=a(ne,se,0,G,N))===null;)G=d(se,G+1);return j}e.matchesWords=l;function a(ne,se,N,j,G){if(N===ne.length)return[];if(j===se.length)return null;if(h(ne.charCodeAt(N),se.charCodeAt(j))){let X=null,ge=j+1;if(X=a(ne,se,N+1,j+1,G),!G)for(;!X&&(ge=d(se,ge))<se.length;)X=a(ne,se,N+1,ge,G),ge++;return X?ne.charCodeAt(N)!==se.charCodeAt(j)?X:f({start:j,end:j+1},X):null}else return null}function d(ne,se){for(let N=se;N<ne.length;N++)if(w(ne.charCodeAt(N))||N>0&&w(ne.charCodeAt(N-1)))return N;return ne.length}const n=D(e.matchesPrefix,o,y),i=D(e.matchesPrefix,o,T),p=new c.LRUCache(1e4);function C(ne,se,N=!1){if(typeof ne!="string"||typeof se!="string")return null;let j=p.get(ne);j||(j=new RegExp(t.convertSimple2RegExpPattern(ne),"i"),p.set(ne,j));const G=j.exec(se);return G?[{start:G.index,end:G.index+G[0].length}]:N?i(ne,se):n(ne,se)}e.matchesFuzzy=C;function R(ne,se){const N=Re(ne,ne.toLowerCase(),0,se,se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?$(N):null}e.matchesFuzzy2=R;function M(ne,se,N,j,G,X){const ge=Math.min(13,ne.length);for(;N<ge;N++){const be=Re(ne,se,N,j,G,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(be)return be}return[0,X]}e.anyScore=M;function $(ne){if(typeof ne>"u")return[];const se=[],N=ne[1];for(let j=ne.length-1;j>1;j--){const G=ne[j]+N,X=se[se.length-1];X&&X.end===G?X.end=G+1:se.push({start:G,end:G+1})}return se}e.createMatches=$;const x=128;function L(){const ne=[],se=[];for(let N=0;N<=x;N++)se[N]=0;for(let N=0;N<=x;N++)ne.push(se.slice(0));return ne}function B(ne){const se=[];for(let N=0;N<=ne;N++)se[N]=0;return se}const O=B(2*x),z=B(2*x),U=L(),F=L(),V=L(),H=!1;function Q(ne,se,N,j,G){function X(be,le,ye=" "){for(;be.length<le;)be=ye+be;return be}let ge=` |   |${j.split("").map(be=>X(be,3)).join("|")}
`;for(let be=0;be<=N;be++)be===0?ge+=" |":ge+=`${se[be-1]}|`,ge+=ne[be].slice(0,G+1).map(le=>X(le.toString(),3)).join("|")+`
`;return ge}function K(ne,se,N,j){ne=ne.substr(se),N=N.substr(j),console.log(Q(F,ne,ne.length,N,N.length)),console.log(Q(V,ne,ne.length,N,N.length)),console.log(Q(U,ne,ne.length,N,N.length))}function de(ne,se){if(se<0||se>=ne.length)return!1;const N=ne.codePointAt(se);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(N)}}function ee(ne,se){if(se<0||se>=ne.length)return!1;switch(ne.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function fe(ne,se,N){return se[ne]!==N[ne]}function Y(ne,se,N,j,G,X,ge=!1){for(;se<N&&G<X;)ne[se]===j[G]&&(ge&&(O[se]=G),se+=1),G+=1;return se===N}e.isPatternInWord=Y;var ve;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Ee;(function(ne){ne.Default=[-100,0];function se(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}ne.isDefault=se})(Ee=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(se,N){this.firstMatchCanBeWeak=se,this.boostFullMatch=N}}e.FuzzyScoreOptions=ke,ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ne,se,N,j,G,X,ge=ke.default){const be=ne.length>x?x:ne.length,le=j.length>x?x:j.length;if(N>=be||X>=le||be-N>le-X||!Y(se,N,be,G,X,le,!0))return;ze(be,le,N,X,se,G);let ye=1,Ce=1,We=N,je=X;const Je=[!1];for(ye=1,We=N;We<be;ye++,We++){const re=O[We],oe=z[We],_e=We+1<be?z[We+1]:le;for(Ce=re-X+1,je=re;je<_e;Ce++,je++){let ue=Number.MIN_SAFE_INTEGER,Pe=!1;je<=oe&&(ue=ie(ne,se,We,N,j,G,je,le,X,U[ye-1][Ce-1]===0,Je));let Le=0;ue!==Number.MAX_SAFE_INTEGER&&(Pe=!0,Le=ue+F[ye-1][Ce-1]);const Ne=je>re,qe=Ne?F[ye][Ce-1]+(U[ye][Ce-1]>0?-5:0):0,Ye=je>re+1&&U[ye][Ce-1]>0,it=Ye?F[ye][Ce-2]+(U[ye][Ce-2]>0?-5:0):0;if(Ye&&(!Ne||it>=qe)&&(!Pe||it>=Le))F[ye][Ce]=it,V[ye][Ce]=3,U[ye][Ce]=0;else if(Ne&&(!Pe||qe>=Le))F[ye][Ce]=qe,V[ye][Ce]=2,U[ye][Ce]=0;else if(Pe)F[ye][Ce]=Le,V[ye][Ce]=1,U[ye][Ce]=U[ye-1][Ce-1]+1;else throw new Error("not possible")}}if(H&&K(ne,N,j,X),!Je[0]&&!ge.firstMatchCanBeWeak)return;ye--,Ce--;const Qe=[F[ye][Ce],X];let Ze=0,Be=0;for(;ye>=1;){let re=Ce;do{const oe=V[ye][re];if(oe===3)re=re-2;else if(oe===2)re=re-1;else break}while(re>=1);Ze>1&&se[N+ye-1]===G[X+Ce-1]&&!fe(re+X-1,j,G)&&Ze+1>U[ye][re]&&(re=Ce),re===Ce?Ze++:Ze=1,Be||(Be=re),ye--,Ce=re-1,Qe.push(Ce)}le===be&&ge.boostFullMatch&&(Qe[0]+=2);const ut=Be-be;return Qe[0]-=ut,Qe}e.fuzzyScore=Re;function ze(ne,se,N,j,G,X){let ge=ne-1,be=se-1;for(;ge>=N&&be>=j;)G[ge]===X[be]&&(z[ge]=be,ge--),be--}function ie(ne,se,N,j,G,X,ge,be,le,ye,Ce){if(se[N]!==X[ge])return Number.MIN_SAFE_INTEGER;let We=1,je=!1;return ge===N-j?We=ne[N]===G[ge]?7:5:fe(ge,G,X)&&(ge===0||!fe(ge-1,G,X))?(We=ne[N]===G[ge]?7:5,je=!0):de(X,ge)&&(ge===0||!de(X,ge-1))?We=5:(de(X,ge-1)||ee(X,ge-1))&&(We=5,je=!0),We>1&&N===j&&(Ce[0]=!0),je||(je=fe(ge,G,X)||de(X,ge-1)||ee(X,ge-1)),N===j?ge>le&&(We-=je?3:5):ye?We+=je?2:0:We+=je?0:1,ge+1===be&&(We-=je?3:5),We}function ce(ne,se,N,j,G,X,ge){return J(ne,se,N,j,G,X,!0,ge)}e.fuzzyScoreGracefulAggressive=ce;function me(ne,se,N,j,G,X,ge){return J(ne,se,N,j,G,X,!1,ge)}e.fuzzyScoreGraceful=me;function J(ne,se,N,j,G,X,ge,be){let le=Re(ne,se,N,j,G,X,be);if(le&&!ge)return le;if(ne.length>=3){const ye=Math.min(7,ne.length-1);for(let Ce=N+1;Ce<ye;Ce++){const We=ae(ne,Ce);if(We){const je=Re(We,We.toLowerCase(),N,j,G,X,be);je&&(je[0]-=3,(!le||je[0]>le[0])&&(le=je))}}}return le}function ae(ne,se){if(se+1>=ne.length)return;const N=ne[se],j=ne[se+1];if(N!==j)return ne.slice(0,se)+j+N+ne.slice(se+2)}}),define(De[81],Ie([1,0,8]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return D(f,0)}e.hash=t;function D(f,v){switch(typeof f){case"object":return f===null?P(349,v):Array.isArray(f)?S(f,v):k(f,v);case"string":return T(f,v);case"boolean":return y(f,v);case"number":return P(f,v);case"undefined":return P(937,v);default:return P(617,v)}}e.doHash=D;function P(f,v){return(v<<5)-v+f|0}e.numberHash=P;function y(f,v){return P(f?433:863,v)}function T(f,v){v=P(149417,v);for(let m=0,r=f.length;m<r;m++)v=P(f.charCodeAt(m),v);return v}e.stringHash=T;function S(f,v){return v=P(104579,v),f.reduce((m,r)=>D(r,m),v)}function k(f,v){return v=P(181387,v),Object.keys(f).sort().reduce((m,r)=>(m=T(r,m),D(f[r],m)),v)}class A{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=D(v,this._value),this._value}}e.Hasher=A;var I;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function E(f,v,m=32){const r=m-v,b=~((1<<r)-1);return(f<<v|(b&f)>>>r)>>>0}function _(f,v=0,m=f.byteLength,r=0){for(let b=0;b<m;b++)f[v+b]=r}function w(f,v,m="0"){for(;f.length<v;)f=m+f;return f}function h(f,v=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(m=>m.toString(16).padStart(2,"0")).join(""):w((f>>>0).toString(16),v/4)}e.toHexString=h;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const m=v.length;if(m===0)return;const r=this._buff;let b=this._buffLen,s=this._leftoverHighSurrogate,u,o;for(s!==0?(u=s,o=-1,s=0):(u=v.charCodeAt(0),o=0);;){let l=u;if(c.isHighSurrogate(u))if(o+1<m){const a=v.charCodeAt(o+1);c.isLowSurrogate(a)?(o++,l=c.computeCodePoint(u,a)):l=65533}else{s=u;break}else c.isLowSurrogate(u)&&(l=65533);if(b=this._push(r,b,l),o++,o<m)u=v.charCodeAt(o);else break}this._buffLen=b,this._leftoverHighSurrogate=s}_push(v,m,r){return r<128?v[m++]=r:r<2048?(v[m++]=192|(r&1984)>>>6,v[m++]=128|(r&63)>>>0):r<65536?(v[m++]=224|(r&61440)>>>12,v[m++]=128|(r&4032)>>>6,v[m++]=128|(r&63)>>>0):(v[m++]=240|(r&1835008)>>>18,v[m++]=128|(r&258048)>>>12,v[m++]=128|(r&4032)>>>6,v[m++]=128|(r&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,_(this._buff,this._buffLen),this._buffLen>56&&(this._step(),_(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=g._bigBlock32,m=this._buffDV;for(let n=0;n<64;n+=4)v.setUint32(n,m.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)v.setUint32(n,E(v.getUint32(n-12,!1)^v.getUint32(n-32,!1)^v.getUint32(n-56,!1)^v.getUint32(n-64,!1),1),!1);let r=this._h0,b=this._h1,s=this._h2,u=this._h3,o=this._h4,l,a,d;for(let n=0;n<80;n++)n<20?(l=b&s|~b&u,a=1518500249):n<40?(l=b^s^u,a=1859775393):n<60?(l=b&s|b&u|s&u,a=2400959708):(l=b^s^u,a=3395469782),d=E(r,5)+l+o+a+v.getUint32(n*4,!1)&4294967295,o=u,u=s,s=E(b,30),b=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[158],Ie([1,0,77,107,8]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(c.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${P.source}`,"g");function S(g){return g.replace(T,(f,v)=>v?f:`\\${f}`)}e.escapeIcons=S;const k=new RegExp(`\\\\${P.source}`,"g");function A(g){return g.replace(k,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=A;const I=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function E(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(I,(f,v,m,r)=>m?f:v||r||"")}e.stripIcons=E;function _(g){const f=g.indexOf(e.iconStartMarker);return f===-1?{text:g}:w(g,f)}e.parseLabelWithIcons=_;function w(g,f){const v=[];let m="";function r(n){if(n){m+=n;for(const i of n)v.push(u)}}let b=-1,s="",u=0,o,l,a=f;const d=g.length;for(r(g.substr(0,f));a<d;)o=g[a],l=g[a+1],o===e.iconStartMarker[0]&&l===e.iconStartMarker[1]?(b=a,r(s),s=e.iconStartMarker,a++):o===")"&&b!==-1?(u+=a-b+1,b=-1,s=""):b!==-1?y.test(o)?s+=o:(r(s),b=-1,s=""):r(o),a++;return r(s),{text:m,iconOffsets:v}}function h(g,f,v=!1){const{text:m,iconOffsets:r}=f;if(!r||r.length===0)return(0,t.matchesFuzzy)(g,m,v);const b=(0,D.ltrim)(m," "),s=m.length-b.length,u=(0,t.matchesFuzzy)(g,b,v);if(u)for(const o of u){const l=r[o.start+s]+s;o.start+=l,o.end+=l}return u}e.matchesFuzzyIconAware=h}),define(De[42],Ie([1,0,8]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const P="error",y="warning",T="warn",S="info",k="ignore";function A(E){return E?c.equalsIgnoreCase(P,E)?D.Error:c.equalsIgnoreCase(y,E)||c.equalsIgnoreCase(T,E)?D.Warning:c.equalsIgnoreCase(S,E)?D.Info:D.Ignore:D.Ignore}D.fromValue=A;function I(E){switch(E){case D.Error:return P;case D.Warning:return y;case D.Info:return S;default:return k}}D.toString=I}(t||(t={})),e.default=t}),define(De[64],Ie([1,0,17,8]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this._value="",this._pos=0}reset(_){return this._value=_,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(_){const w=_.charCodeAt(0),h=this._value.charCodeAt(this._pos);return w-h}value(){return this._value[this._pos]}}e.StringIterator=D;class P{constructor(_=!0){this._caseSensitive=_}reset(_){return this._value=_,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let _=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(_)this._from++;else break;else _=!1;return this}cmp(_){return this._caseSensitive?(0,t.compareSubstring)(_,this._value,0,_.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(_,this._value,0,_.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class y{constructor(_=!0,w=!0){this._splitOnBackslash=_,this._caseSensitive=w}reset(_){this._from=0,this._to=0,this._value=_,this._valueLen=_.length;for(let w=_.length-1;w>=0;w--,this._valueLen--){const h=this._value.charCodeAt(w);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let _=!0;for(;this._to<this._valueLen;this._to++){const w=this._value.charCodeAt(this._to);if(w===47||this._splitOnBackslash&&w===92)if(_)this._from++;else break;else _=!1}return this}cmp(_){return this._caseSensitive?(0,t.compareSubstring)(_,this._value,0,_.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(_,this._value,0,_.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var T;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(_,w){this._ignorePathCasing=_,this._ignoreQueryAndFragment=w,this._states=[],this._stateIdx=0}reset(_){return this._value=_,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(_)),this._pathIterator.reset(_.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(_)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(_){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(_,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(_,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(_);if(this._states[this._stateIdx]===4)return(0,t.compare)(_,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(_,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const _=this.right;return this.right=_.left,_.left=this,this.updateHeight(),_.updateHeight(),_}rotateRight(){const _=this.left;return this.left=_.right,_.right=this,this.updateHeight(),_.updateHeight(),_}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(A||(A={}));class I{static forUris(_=()=>!1,w=()=>!1){return new I(new S(_,w))}static forPaths(_=!1){return new I(new y(void 0,!_))}static forStrings(){return new I(new D)}static forConfigKeys(){return new I(new P)}constructor(_){this._iter=_}clear(){this._root=void 0}fill(_,w){if(w){const h=w.slice(0);(0,c.shuffle)(h);for(const g of h)this.set(g,_)}else{const h=_.slice(0);(0,c.shuffle)(h);for(const g of h)this.set(g[0],g[1])}}set(_,w){const h=this._iter.reset(_);let g;this._root||(this._root=new k,this._root.segment=h.value());const f=[];for(g=this._root;;){const m=h.cmp(g.segment);if(m>0)g.left||(g.left=new k,g.left.segment=h.value()),f.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new k,g.right.segment=h.value()),f.push([1,g]),g=g.right;else if(h.hasNext())h.next(),g.mid||(g.mid=new k,g.mid.segment=h.value()),f.push([0,g]),g=g.mid;else break}const v=g.value;g.value=w,g.key=_;for(let m=f.length-1;m>=0;m--){const r=f[m][1];r.updateHeight();const b=r.balanceFactor();if(b<-1||b>1){const s=f[m][0],u=f[m+1][0];if(s===1&&u===1)f[m][1]=r.rotateLeft();else if(s===-1&&u===-1)f[m][1]=r.rotateRight();else if(s===1&&u===-1)r.right=f[m+1][1]=f[m+1][1].rotateRight(),f[m][1]=r.rotateLeft();else if(s===-1&&u===1)r.left=f[m+1][1]=f[m+1][1].rotateLeft(),f[m][1]=r.rotateRight();else throw new Error;if(m>0)switch(f[m-1][0]){case-1:f[m-1][1].left=f[m][1];break;case 1:f[m-1][1].right=f[m][1];break;case 0:f[m-1][1].mid=f[m][1];break}else this._root=f[0][1]}}return v}get(_){return this._getNode(_)?.value}_getNode(_){const w=this._iter.reset(_);let h=this._root;for(;h;){const g=w.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(w.hasNext())w.next(),h=h.mid;else break}return h}has(_){const w=this._getNode(_);return!(w?.value===void 0&&w?.mid===void 0)}delete(_){return this._delete(_,!1)}deleteSuperstr(_){return this._delete(_,!0)}_delete(_,w){const h=this._iter.reset(_),g=[];let f=this._root;for(;f;){const v=h.cmp(f.segment);if(v>0)g.push([-1,f]),f=f.left;else if(v<0)g.push([1,f]),f=f.right;else if(h.hasNext())h.next(),g.push([0,f]),f=f.mid;else break}if(!!f){if(w?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const v=this._min(f.right);if(v.key){const{key:m,value:r,segment:b}=v;this._delete(v.key,!1),f.key=m,f.value=r,f.segment=b}}else{const v=f.left??f.right;if(g.length>0){const[m,r]=g[g.length-1];switch(m){case-1:r.left=v;break;case 0:r.mid=v;break;case 1:r.right=v;break}}else this._root=v}for(let v=g.length-1;v>=0;v--){const m=g[v][1];m.updateHeight();const r=m.balanceFactor();if(r>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[v][1]=m.rotateLeft()):r<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[v][1]=m.rotateRight()),v>0)switch(g[v-1][0]){case-1:g[v-1][1].left=g[v][1];break;case 1:g[v-1][1].right=g[v][1];break;case 0:g[v-1][1].mid=g[v][1];break}else this._root=g[0][1]}}}_min(_){for(;_.left;)_=_.left;return _}findSubstr(_){const w=this._iter.reset(_);let h=this._root,g;for(;h;){const f=w.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(w.hasNext())w.next(),g=h.value||g,h=h.mid;else break}return h&&h.value||g}findSuperstr(_){const w=this._iter.reset(_);let h=this._root;for(;h;){const g=w.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(w.hasNext())w.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(_){for(const[w,h]of this)_(h,w)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(_){const w=[];return this._dfsEntries(_,w),w[Symbol.iterator]()}_dfsEntries(_,w){!_||(_.left&&this._dfsEntries(_.left,w),_.value&&w.push([_.key,_.value]),_.mid&&this._dfsEntries(_.mid,w),_.right&&this._dfsEntries(_.right,w))}_isBalanced(){const _=w=>{if(!w)return!0;const h=w.balanceFactor();return h<-1||h>1?!1:_(w.left)&&_(w.right)};return _(this._root)}}e.TernarySearchTree=I}),define(De[2],Ie([1,0,9,12]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function T(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!D.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!P.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,l){return!o&&!l?"file":o}function k(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==I&&(l=I+l):l=I;break}return l}const A="",I="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class _{static isUri(l){return l instanceof _?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,a,d,n,i,p=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=S(l,p),this.authority=a||A,this.path=k(this.scheme,d||A),this.query=n||A,this.fragment=i||A,T(this,p))}get fsPath(){return m(this,!1)}with(l){if(!l)return this;let{scheme:a,authority:d,path:n,query:i,fragment:p}=l;return a===void 0?a=this.scheme:a===null&&(a=A),d===void 0?d=this.authority:d===null&&(d=A),n===void 0?n=this.path:n===null&&(n=A),i===void 0?i=this.query:i===null&&(i=A),p===void 0?p=this.fragment:p===null&&(p=A),a===this.scheme&&d===this.authority&&n===this.path&&i===this.query&&p===this.fragment?this:new h(a,d,n,i,p)}static parse(l,a=!1){const d=E.exec(l);return d?new h(d[2]||A,u(d[4]||A),u(d[5]||A),u(d[7]||A),u(d[9]||A),a):new h(A,A,A,A,A)}static file(l){let a=A;if(t.isWindows&&(l=l.replace(/\\/g,I)),l[0]===I&&l[1]===I){const d=l.indexOf(I,2);d===-1?(a=l.substring(2),l=I):(a=l.substring(2,d),l=l.substring(d)||I)}return new h("file",a,l,A,A)}static from(l){const a=new h(l.scheme,l.authority,l.path,l.query,l.fragment);return T(a,!0),a}static joinPath(l,...a){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return t.isWindows&&l.scheme==="file"?d=_.file(c.win32.join(m(l,!0),...a)).path:d=c.posix.join(l.path,...a),l.with({path:d})}toString(l=!1){return r(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof _)return l;{const a=new h(l);return a._formatted=l.external,a._fsPath=l._sep===w?l.fsPath:null,a}}else return l}}e.URI=_;const w=t.isWindows?1:void 0;class h extends _{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(l=!1){return l?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=w),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(o,l){let a,d=-1;for(let n=0;n<o.length;n++){const i=o.charCodeAt(n);if(i>=97&&i<=122||i>=65&&i<=90||i>=48&&i<=57||i===45||i===46||i===95||i===126||l&&i===47)d!==-1&&(a+=encodeURIComponent(o.substring(d,n)),d=-1),a!==void 0&&(a+=o.charAt(n));else{a===void 0&&(a=o.substr(0,n));const p=g[i];p!==void 0?(d!==-1&&(a+=encodeURIComponent(o.substring(d,n)),d=-1),a+=p):d===-1&&(d=n)}}return d!==-1&&(a+=encodeURIComponent(o.substring(d))),a!==void 0?a:o}function v(o){let l;for(let a=0;a<o.length;a++){const d=o.charCodeAt(a);d===35||d===63?(l===void 0&&(l=o.substr(0,a)),l+=g[d]):l!==void 0&&(l+=o[a])}return l!==void 0?l:o}function m(o,l){let a;return o.authority&&o.path.length>1&&o.scheme==="file"?a=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?l?a=o.path.substr(1):a=o.path[1].toLowerCase()+o.path.substr(2):a=o.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=m;function r(o,l){const a=l?v:f;let d="",{scheme:n,authority:i,path:p,query:C,fragment:R}=o;if(n&&(d+=n,d+=":"),(i||n==="file")&&(d+=I,d+=I),i){let M=i.indexOf("@");if(M!==-1){const $=i.substr(0,M);i=i.substr(M+1),M=$.indexOf(":"),M===-1?d+=a($,!1):(d+=a($.substr(0,M),!1),d+=":",d+=a($.substr(M+1),!1)),d+="@"}i=i.toLowerCase(),M=i.indexOf(":"),M===-1?d+=a(i,!1):(d+=a(i.substr(0,M),!1),d+=i.substr(M))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const M=p.charCodeAt(1);M>=65&&M<=90&&(p=`/${String.fromCharCode(M+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const M=p.charCodeAt(0);M>=65&&M<=90&&(p=`${String.fromCharCode(M+32)}:${p.substr(2)}`)}d+=a(p,!0)}return C&&(d+="?",d+=a(C,!1)),R&&(d+="#",d+=l?R:f(R,!1)),d}function b(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+b(o.substr(3)):o}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(o){return o.match(s)?o.replace(s,l=>b(l)):o}}),define(De[82],Ie([1,0,23,8,2]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(k){return JSON.stringify(k,T)}e.stringify=P;function y(k){let A=JSON.parse(k);return A=S(A),A}e.parse=y;function T(k,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,t.regExpFlags)(A)}:A}function S(k,A=0){if(!k||A>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return D.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 15:return new Date(k.source)}if(k instanceof c.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let I=0;I<k.length;++I)k[I]=S(k[I],A+1);else for(const I in k)Object.hasOwnProperty.call(k,I)&&(k[I]=S(k[I],A+1))}return k}e.revive=S}),define(De[14],Ie([1,0,12,2]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(k){this._preferredWebSchema=k}setDelegate(k){this._delegate=k}setServerRootPath(k){this._remoteResourcesPath=`${k}/${D.vscodeRemoteResource}`}set(k,A,I){this._hosts[k]=A,this._ports[k]=I}setConnectionToken(k,A){this._connectionTokens[k]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(k){if(this._delegate)return this._delegate(k);const A=k.authority;let I=this._hosts[A];I&&I.indexOf(":")!==-1&&I.indexOf("[")===-1&&(I=`[${I}]`);const E=this._ports[A],_=this._connectionTokens[A];let w=`path=${encodeURIComponent(k.path)}`;return typeof _=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),t.URI.from({scheme:c.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${I}:${E}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new P;class y{asBrowserUri(k,A){const I=this.toUri(k,A);return I.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===D.file&&(c.isNative||c.isWebWorker&&c.globals.origin===`${D.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?I.with({scheme:D.vscodeFileResource,authority:I.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(k,A){const I=this.toUri(k,A);return I.scheme===D.vscodeFileResource?I.with({scheme:D.file,authority:I.authority!==y.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(k,A){return t.URI.isUri(k)?k:t.URI.parse(A.toUrl(k))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y;var T;(function(S){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(k.get("3"));const A="vscode-coi";function I(_){let w;typeof _=="string"?w=new URL(_).searchParams:_ instanceof URL?w=_.searchParams:t.URI.isUri(_)&&(w=new URL(_.toString(!0)).searchParams);const h=w?.get(A);if(!!h)return k.get(h)}S.getHeadersFromQuery=I;function E(_,w,h){if(!globalThis.crossOriginIsolated)return;const g=w&&h?"3":h?"2":"1";_ instanceof URLSearchParams?_.set(A,g):_[A]=g}S.addSearchParam=E})(T=e.COI||(e.COI={}))}),define(De[22],Ie([1,0,32,14,9,12,8,2]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(_){return(0,T.uriToFsPath)(_,!0)}e.originalFSPath=S;class k{constructor(w){this._ignorePathCasing=w}compare(w,h,g=!1){return w===h?0:(0,y.compare)(this.getComparisonKey(w,g),this.getComparisonKey(h,g))}isEqual(w,h,g=!1){return w===h?!0:!w||!h?!1:this.getComparisonKey(w,g)===this.getComparisonKey(h,g)}getComparisonKey(w,h=!1){return w.with({path:this._ignorePathCasing(w)?w.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(w){return this._ignorePathCasing(w)}isEqualOrParent(w,h,g=!1){if(w.scheme===h.scheme){if(w.scheme===t.Schemas.file)return c.isEqualOrParent(S(w),S(h),this._ignorePathCasing(w))&&w.query===h.query&&(g||w.fragment===h.fragment);if((0,e.isEqualAuthority)(w.authority,h.authority))return c.isEqualOrParent(w.path,h.path,this._ignorePathCasing(w),"/")&&w.query===h.query&&(g||w.fragment===h.fragment)}return!1}joinPath(w,...h){return T.URI.joinPath(w,...h)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return D.posix.basename(w.path)}extname(w){return D.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let h;return w.scheme===t.Schemas.file?h=T.URI.file(D.dirname(S(w))).path:(h=D.posix.dirname(w.path),w.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),h="/")),w.with({path:h})}normalizePath(w){if(!w.path.length)return w;let h;return w.scheme===t.Schemas.file?h=T.URI.file(D.normalize(S(w))).path:h=D.posix.normalize(w.path),w.with({path:h})}relativePath(w,h){if(w.scheme!==h.scheme||!(0,e.isEqualAuthority)(w.authority,h.authority))return;if(w.scheme===t.Schemas.file){const v=D.relative(S(w),S(h));return P.isWindows?c.toSlashes(v):v}let g=w.path||"/";const f=h.path||"/";if(this._ignorePathCasing(w)){let v=0;for(const m=Math.min(g.length,f.length);v<m&&!(g.charCodeAt(v)!==f.charCodeAt(v)&&g.charAt(v).toLowerCase()!==f.charAt(v).toLowerCase());v++);g=f.substr(0,v)+g.substr(v)}return D.posix.relative(g,f)}resolvePath(w,h){if(w.scheme===t.Schemas.file){const g=T.URI.file(D.resolve(S(w),h));return w.with({authority:g.authority,path:g.path})}return h=c.toPosixPath(h),w.with({path:D.posix.resolve(w.path,h)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,h){return w===h||w!==void 0&&h!==void 0&&(0,y.equalsIgnoreCase)(w,h)}hasTrailingPathSeparator(w,h=D.sep){if(w.scheme===t.Schemas.file){const g=S(w);return g.length>c.getRoot(g).length&&g[g.length-1]===h}else{const g=w.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,h=D.sep){return(0,e.hasTrailingPathSeparator)(w,h)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,h=D.sep){let g=!1;if(w.scheme===t.Schemas.file){const f=S(w);g=f!==void 0&&f.length===c.getRoot(f).length&&f[f.length-1]===h}else{h="/";const f=w.path;g=f.length===1&&f.charCodeAt(f.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(w,h)?w.with({path:w.path+"/"}):w}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(_=>_.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(_=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(_,w){const h=[];for(let g=0;g<_.length;g++){const f=w(_[g]);_.some((v,m)=>m===g?!1:(0,e.isEqualOrParent)(f,w(v)))||h.push(_[g])}return h}e.distinctParents=A;var I;(function(_){_.META_DATA_LABEL="label",_.META_DATA_DESCRIPTION="description",_.META_DATA_SIZE="size",_.META_DATA_MIME="mime";function w(h){const g=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(m=>{const[r,b]=m.split(":");r&&b&&g.set(r,b)});const v=h.path.substring(0,h.path.indexOf(";"));return v&&g.set(_.META_DATA_MIME,v),g}_.parseMetaData=w})(I=e.DataUri||(e.DataUri={}));function E(_,w,h){if(w){let g=_.path;return g&&g[0]!==D.posix.sep&&(g=D.posix.sep+g),_.with({scheme:h,authority:w,path:g})}return _.with({scheme:h})}e.toLocalResource=E}),define(De[18],Ie([1,0,21,10,4,6,22,12]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=S;function k(fe){const Y=new c.CancellationTokenSource,ve=fe(Y.token),Ee=new Promise((ke,Re)=>{const ze=Y.token.onCancellationRequested(()=>{ze.dispose(),Y.dispose(),Re(new t.CancellationError)});Promise.resolve(ve).then(ie=>{ze.dispose(),Y.dispose(),ke(ie)},ie=>{ze.dispose(),Y.dispose(),Re(ie)})});return new class{cancel(){Y.cancel()}then(ke,Re){return Ee.then(ke,Re)}catch(ke){return this.then(void 0,ke)}finally(ke){return Ee.finally(ke)}}}e.createCancelablePromise=k;function A(fe,Y,ve){return new Promise((Ee,ke)=>{const Re=Y.onCancellationRequested(()=>{Re.dispose(),Ee(ve)});fe.then(Ee,ke).finally(()=>Re.dispose())})}e.raceCancellation=A;function I(fe,Y){return new Promise((ve,Ee)=>{const ke=Y.onCancellationRequested(()=>{ke.dispose(),Ee(new t.CancellationError)});fe.then(ve,Ee).finally(()=>ke.dispose())})}e.raceCancellationError=I;async function E(fe){let Y=-1;const ve=fe.map((ke,Re)=>ke.then(ze=>(Y=Re,ze))),Ee=await Promise.race(ve);return fe.forEach((ke,Re)=>{Re!==Y&&ke.cancel()}),Ee}e.raceCancellablePromises=E;function _(fe,Y,ve){let Ee;const ke=setTimeout(()=>{Ee?.(void 0),ve?.()},Y);return Promise.race([fe.finally(()=>clearTimeout(ke)),new Promise(Re=>Ee=Re)])}e.raceTimeout=_;function w(fe){return new Promise((Y,ve)=>{const Ee=fe();S(Ee)?Ee.then(Y,ve):Y(Ee)})}e.asPromise=w;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const Ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ee};this.queuedPromise=new Promise(Ee=>{this.activePromise.then(ve,ve).then(Ee)})}return new Promise((ve,Ee)=>{this.queuedPromise.then(ve,Ee)})}return this.activePromise=Y(),new Promise((ve,Ee)=>{this.activePromise.then(ke=>{this.activePromise=null,ve(ke)},ke=>{this.activePromise=null,Ee(ke)})})}}e.Throttler=h;class g{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=g;class f{constructor(){this.promiseMap=new Map}queue(Y,ve){const ke=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(Y)===ke&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ke),ke}}e.SequencerByKey=f;const v=(fe,Y)=>{let ve=!0;const Ee=setTimeout(()=>{ve=!1,Y()},fe);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(Ee),ve=!1}}},m=fe=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,fe())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class r{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,ve=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Re)=>{this.doResolve=ke,this.doReject=Re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const Ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?m(Ee):v(ve,Ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=r;class b{constructor(Y){this.delayer=new r(Y),this.throttler=new h}trigger(Y,ve){return this.delayer.trigger(()=>this.throttler.queue(Y),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class s{constructor(){this._isOpen=!1,this._promise=new Promise((Y,ve)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class u extends s{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function o(fe,Y){return Y?new Promise((ve,Ee)=>{const ke=setTimeout(()=>{Re.dispose(),ve()},fe),Re=Y.onCancellationRequested(()=>{clearTimeout(ke),Re.dispose(),Ee(new t.CancellationError)})}):k(ve=>o(fe,ve))}e.timeout=o;function l(fe,Y=0){const ve=setTimeout(fe,Y);return(0,P.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=l;function a(fe){const Y=[];let ve=0;const Ee=fe.length;function ke(){return ve<Ee?fe[ve++]():null}function Re(ze){ze!=null&&Y.push(ze);const ie=ke();return ie?ie.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=a;function d(fe,Y=Ee=>!!Ee,ve=null){let Ee=0;const ke=fe.length,Re=()=>{if(Ee>=ke)return Promise.resolve(ve);const ze=fe[Ee++];return Promise.resolve(ze()).then(ce=>Y(ce)?Promise.resolve(ce):Re())};return Re()}e.first=d;function n(fe,Y=Ee=>!!Ee,ve=null){if(fe.length===0)return Promise.resolve(ve);let Ee=fe.length;const ke=()=>{Ee=-1;for(const Re of fe)Re.cancel?.()};return new Promise((Re,ze)=>{for(const ie of fe)ie.then(ce=>{--Ee>=0&&Y(ce)?(ke(),Re(ce)):Ee===0&&Re(ve)}).catch(ce=>{--Ee>=0&&(ke(),ze(ce))})})}e.firstParallel=n;class i{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((ve,Ee)=>{this.outstandingPromises.push({factory:Y,c:ve,e:Ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const ve=Y.factory();ve.then(Y.c,Y.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=i;class p extends i{constructor(){super(1)}}e.Queue=p;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new V;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,ve=y.extUri){const Ee=ve.getComparisonKey(Y);let ke=this.queues.get(Ee);return ke||(ke=new p,D.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(Ee),this.onDidQueueDrain()}),this.queues.set(Ee,ke)),ke}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class R{constructor(Y,ve){this._token=-1,typeof Y=="function"&&typeof ve=="number"&&this.setIfNotSet(Y,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},ve)}setIfNotSet(Y,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},ve))}}e.TimeoutTimer=R;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,ve){this.cancel(),this._token=setInterval(()=>{Y()},ve)}}e.IntervalTimer=M;class ${constructor(Y,ve){this.timeoutToken=-1,this.runner=Y,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class x{constructor(Y,ve){ve%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=x;class L extends ${constructor(Y,ve){super(Y,ve),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class B extends P.Disposable{constructor(Y,ve){super(),this.options=Y,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,T.setTimeout0)(()=>{if(Y)return;const ve=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(fe,Y)=>{const ve=requestIdleCallback(fe,typeof Y=="number"?{timeout:Y}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(ve))}}}}();class O{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function z(fe,Y,ve){let Ee;for(let ke=0;ke<ve;ke++)try{return await fe()}catch(Re){Ee=Re,await o(Y)}throw Ee}e.retry=z;class U{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,ve,Ee){return this._pending={taskId:Y,cancel:()=>Ee?.(),promise:ve},ve.then(()=>this.donePending(Y),()=>this.donePending(Y)),ve}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let ve,Ee;const ke=new Promise((Re,ze)=>{ve=Re,Ee=ze});this._next={run:Y,promise:ke,promiseResolve:ve,promiseReject:Ee}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=U;class F{constructor(Y,ve=()=>Date.now()){this.interval=Y,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class V{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,ve)=>{this.completeCallback=Y,this.errorCallback=ve})}complete(Y){return new Promise(ve=>{this.completeCallback(Y),this.resolved=!0,ve()})}error(Y){return new Promise(ve=>{this.errorCallback(Y),this.rejected=!0,ve()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=V;var H;(function(fe){async function Y(Ee){let ke;const Re=await Promise.all(Ee.map(ze=>ze.then(ie=>ie,ie=>{ke||(ke=ie)})));if(typeof ke<"u")throw ke;return Re}fe.settled=Y;function ve(Ee){return new Promise(async(ke,Re)=>{try{await Ee(ke,Re)}catch(ze){Re(ze)}})}fe.withAsyncBody=ve})(H=e.Promises||(e.Promises={}));var Q;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(Q||(Q={}));class K{static fromArray(Y){return new K(ve=>{ve.emitMany(Y)})}static fromPromise(Y){return new K(async ve=>{ve.emitMany(await Y)})}static fromPromises(Y){return new K(async ve=>{await Promise.all(Y.map(async Ee=>ve.emitOne(await Ee)))})}static merge(Y){return new K(async ve=>{await Promise.all(Y.map(async Ee=>{for await(const ke of Ee)ve.emitOne(ke)}))})}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const ve={emitOne:Ee=>this.emitOne(Ee),emitMany:Ee=>this.emitMany(Ee),reject:Ee=>this.reject(Ee)};try{await Promise.resolve(Y(ve)),this.resolve()}catch(Ee){this.reject(Ee)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,ve){return new K(async Ee=>{for await(const ke of Y)Ee.emitOne(ve(ke))})}map(Y){return K.map(this,Y)}static filter(Y,ve){return new K(async Ee=>{for await(const ke of Y)ve(ke)&&Ee.emitOne(ke)})}filter(Y){return K.filter(this,Y)}static coalesce(Y){return K.filter(Y,ve=>!!ve)}coalesce(){return K.coalesce(this)}static async toPromise(Y){const ve=[];for await(const Ee of Y)ve.push(Ee);return ve}toPromise(){return K.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class de extends K{constructor(Y,ve){super(ve),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=de;function ee(fe){const Y=new c.CancellationTokenSource,ve=fe(Y.token);return new de(Y,async Ee=>{const ke=Y.token.onCancellationRequested(()=>{ke.dispose(),Y.dispose(),Ee.reject(new t.CancellationError)});try{for await(const Re of ve){if(Y.token.isCancellationRequested)return;Ee.emitOne(Re)}ke.dispose(),Y.dispose()}catch(Re){ke.dispose(),Y.dispose(),Ee.reject(Re)}})}e.createCancelableAsyncIterable=ee}),define(De[108],Ie([1,0,18,9]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new c.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),P=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(p,C,R=!1){const M=p||"",$=C||"",x=D.value.collator.compare(M,$);return D.value.collatorIsNumeric&&x===0&&M!==$?M<$?-1:1:x}e.compareFileNames=T;function S(p,C){const R=P.value.collator;return p=p||"",C=C||"",b(R,p,C)}e.compareFileNamesDefault=S;function k(p,C){const R=P.value.collator;return p=p||"",C=C||"",l(p,C)||b(R,p,C)}e.compareFileNamesUpper=k;function A(p,C){const R=P.value.collator;return p=p||"",C=C||"",o(p,C)||b(R,p,C)}e.compareFileNamesLower=A;function I(p,C){return p=p||"",C=C||"",p===C?0:p<C?-1:1}e.compareFileNamesUnicode=I;function E(p,C,R=!1){R||(p=p&&p.toLowerCase(),C=C&&C.toLowerCase());const[M,$]=m(p),[x,L]=m(C);return M!==x?M<x?-1:1:$===L?0:$<L?-1:1}e.noIntlCompareFileNames=E;function _(p,C){const[R,M]=m(p),[$,x]=m(C);let L=D.value.collator.compare(M,x);if(L===0){if(D.value.collatorIsNumeric&&M!==x)return M<x?-1:1;if(L=D.value.collator.compare(R,$),D.value.collatorIsNumeric&&L===0&&R!==$)return R<$?-1:1}return L}e.compareFileExtensions=_;function w(p,C){p=p||"",C=C||"";const R=r(p),M=r(C),$=P.value.collator,x=y.value.collator;return b(x,R,M)||b($,p,C)}e.compareFileExtensionsDefault=w;function h(p,C){p=p||"",C=C||"";const R=r(p),M=r(C),$=P.value.collator,x=y.value.collator;return b(x,R,M)||l(p,C)||b($,p,C)}e.compareFileExtensionsUpper=h;function g(p,C){p=p||"",C=C||"";const R=r(p),M=r(C),$=P.value.collator,x=y.value.collator;return b(x,R,M)||o(p,C)||b($,p,C)}e.compareFileExtensionsLower=g;function f(p,C){p=p||"",C=C||"";const R=r(p).toLowerCase(),M=r(C).toLowerCase();return R!==M?R<M?-1:1:p!==C?p<C?-1:1:0}e.compareFileExtensionsUnicode=f;const v=/^(.*?)(\.([^.]*))?$/;function m(p,C=!1){const R=p?v.exec(p):[];let M=[R&&R[1]||"",R&&R[3]||""];return C&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function r(p){const C=p?v.exec(p):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function b(p,C,R){const M=p.compare(C,R);return M!==0?M:C.length!==R.length?C.length<R.length?-1:1:0}function s(p){const C=p.charAt(0);return C.toLocaleUpperCase()!==C}function u(p){const C=p.charAt(0);return C.toLocaleLowerCase()!==C}function o(p,C){return s(p)&&u(C)?-1:u(p)&&s(C)?1:0}function l(p,C){return u(p)&&s(C)?-1:s(p)&&u(C)?1:0}function a(p,C,R=!1){return R||(p=p&&p.toLowerCase(),C=C&&C.toLowerCase()),p===C?0:p<C?-1:1}function d(p,C,R=!1){const M=p.split(t.sep),$=C.split(t.sep),x=M.length-1,L=$.length-1;let B,O;for(let z=0;;z++){if(B=x===z,O=L===z,B&&O)return T(M[z],$[z],R);if(B)return-1;if(O)return 1;const U=a(M[z],$[z],R);if(U!==0)return U}}e.comparePaths=d;function n(p,C,R){const M=p.toLowerCase(),$=C.toLowerCase(),x=i(p,C,R);if(x)return x;const L=M.endsWith(R),B=$.endsWith(R);if(L!==B)return L?-1:1;const O=T(M,$);return O!==0?O:M.localeCompare($)}e.compareAnything=n;function i(p,C,R){const M=p.toLowerCase(),$=C.toLowerCase(),x=M.startsWith(R),L=$.startsWith(R);if(x!==L)return x?-1:1;if(x&&L){if(M.length<$.length)return-1;if(M.length>$.length)return 1}return 0}e.compareByPrefix=i}),define(De[109],Ie([1,0,108,107,81,9,12,8]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,k=[S,[]];function A(U,F,V,H){if(!U||!F)return k;const Q=U.length,K=F.length;if(Q<K)return k;const de=U.toLowerCase();return I(F,V,K,U,de,Q,H)}e.scoreFuzzy=A;function I(U,F,V,H,Q,K,de){const ee=[],fe=[];for(let ke=0;ke<V;ke++){const Re=ke*K,ze=Re-K,ie=ke>0,ce=U[ke],me=F[ke];for(let J=0;J<K;J++){const ae=J>0,ne=Re+J,se=ne-1,N=ze+J-1,j=ae?ee[se]:0,G=ie&&ae?ee[N]:0,X=ie&&ae?fe[N]:0;let ge;!G&&ie?ge=0:ge=E(ce,me,H,Q,J,X),ge&&G+ge>=j&&(de||ie||Q.startsWith(F,J))?(fe[ne]=X+1,ee[ne]=G+ge):(fe[ne]=S,ee[ne]=j)}}const Y=[];let ve=V-1,Ee=K-1;for(;ve>=0&&Ee>=0;){const ke=ve*K+Ee;fe[ke]===S||(Y.push(Ee),ve--),Ee--}return[ee[V*K-1],Y.reverse()]}function E(U,F,V,H,Q,K){let de=0;if(!_(F,H[Q]))return de;if(de+=1,K>0&&(de+=K*5),U===V[Q]&&(de+=1),Q===0)de+=8;else{const ee=w(V.charCodeAt(Q-1));ee?de+=ee:(0,t.isUpper)(V.charCodeAt(Q))&&K===0&&(de+=2)}return de}function _(U,F){return U===F?!0:U==="/"||U==="\\"?F==="/"||F==="\\":!1}function w(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function g(U,F,V=0,H=0){const Q=F;return Q.values&&Q.values.length>1?f(U,Q.values,V,H):v(U,F,V,H)}e.scoreFuzzy2=g;function f(U,F,V,H){let Q=0;const K=[];for(const de of F){const[ee,fe]=v(U,de,V,H);if(typeof ee!="number")return h;Q+=ee,K.push(...fe)}return[Q,i(K)]}function v(U,F,V,H){const Q=(0,t.fuzzyScore)(F.original,F.originalLowercase,V,U,U.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,t.createMatches)(Q)]:h}const m=Object.freeze({score:0}),r=1<<18,b=1<<17,s=1<<16;function u(U,F,V,H){const Q=H.values?H.values:[H];return(0,D.hash)({[H.normalized]:{values:Q.map(de=>({value:de.normalized,expectContiguousMatch:de.expectContiguousMatch})),label:U,description:F,allowNonContiguousMatches:V}})}function o(U,F,V,H,Q){if(!U||!F.normalized)return m;const K=H.getItemLabel(U);if(!K)return m;const de=H.getItemDescription(U),ee=u(K,de,V,F),fe=Q[ee];if(fe)return fe;const Y=l(K,de,H.getItemPath(U),F,V);return Q[ee]=Y,Y}e.scoreItemFuzzy=o;function l(U,F,V,H,Q){const K=!V||!H.containsPathSeparator;return V&&(y.isLinux?H.pathNormalized===V:(0,T.equalsIgnoreCase)(H.pathNormalized,V))?{score:r,labelMatch:[{start:0,end:U.length}],descriptionMatch:F?[{start:0,end:F.length}]:void 0}:H.values&&H.values.length>1?a(U,F,V,H.values,K,Q):d(U,F,V,H,K,Q)}function a(U,F,V,H,Q,K){let de=0;const ee=[],fe=[];for(const Y of H){const{score:ve,labelMatch:Ee,descriptionMatch:ke}=d(U,F,V,Y,Q,K);if(ve===S)return m;de+=ve,Ee&&ee.push(...Ee),ke&&fe.push(...ke)}return{score:de,labelMatch:i(ee),descriptionMatch:i(fe)}}function d(U,F,V,H,Q,K){if(Q||!F){const[de,ee]=A(U,H.normalized,H.normalizedLowercase,K&&!H.expectContiguousMatch);if(de){const fe=(0,t.matchesPrefix)(H.normalized,U);let Y;return fe?(Y=b,Y+=Math.round(H.normalized.length/U.length*100)):Y=s,{score:Y+de,labelMatch:fe||n(ee)}}}if(F){let de=F;V&&(de=`${F}${P.sep}`);const ee=de.length,fe=`${de}${U}`,[Y,ve]=A(fe,H.normalized,H.normalizedLowercase,K&&!H.expectContiguousMatch);if(Y){const Ee=n(ve),ke=[],Re=[];return Ee.forEach(ze=>{ze.start<ee&&ze.end>ee?(ke.push({start:0,end:ze.end-ee}),Re.push({start:ze.start,end:ee})):ze.start>=ee?ke.push({start:ze.start-ee,end:ze.end-ee}):Re.push(ze)}),{score:Y,labelMatch:ke,descriptionMatch:Re}}}return m}function n(U){const F=[];if(!U)return F;let V;for(const H of U)V&&V.end===H?V.end+=1:(V={start:H,end:H+1},F.push(V));return F}function i(U){const F=U.sort((Q,K)=>Q.start-K.start),V=[];let H;for(const Q of F)!H||!p(H,Q)?(H=Q,V.push(Q)):(H.start=Math.min(H.start,Q.start),H.end=Math.max(H.end,Q.end));return V}function p(U,F){return!(U.end<F.start||F.end<U.start)}function C(U,F,V,H,Q,K){const de=o(U,V,H,Q,K),ee=o(F,V,H,Q,K),fe=de.score,Y=ee.score;if((fe===r||Y===r)&&fe!==Y)return fe===r?-1:1;if(fe>s||Y>s){if(fe!==Y)return fe>Y?-1:1;if(fe<b&&Y<b){const ce=M(de.labelMatch,ee.labelMatch);if(ce!==0)return ce}const ze=Q.getItemLabel(U)||"",ie=Q.getItemLabel(F)||"";if(ze.length!==ie.length)return ze.length-ie.length}if(fe!==Y)return fe>Y?-1:1;const ve=Array.isArray(de.labelMatch)&&de.labelMatch.length>0,Ee=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(ve&&!Ee)return-1;if(Ee&&!ve)return 1;const ke=R(U,de,Q),Re=R(F,ee,Q);return ke&&Re&&ke!==Re?Re>ke?-1:1:$(U,F,V,Q)}e.compareItemsByFuzzyScore=C;function R(U,F,V){let H=-1,Q=-1;if(F.descriptionMatch&&F.descriptionMatch.length?H=F.descriptionMatch[0].start:F.labelMatch&&F.labelMatch.length&&(H=F.labelMatch[0].start),F.labelMatch&&F.labelMatch.length){if(Q=F.labelMatch[F.labelMatch.length-1].end,F.descriptionMatch&&F.descriptionMatch.length){const K=V.getItemDescription(U);K&&(Q+=K.length)}}else F.descriptionMatch&&F.descriptionMatch.length&&(Q=F.descriptionMatch[F.descriptionMatch.length-1].end);return Q-H}function M(U,F){if(!U&&!F||(!U||!U.length)&&(!F||!F.length))return 0;if(!F||!F.length)return-1;if(!U||!U.length)return 1;const V=U[0].start,Q=U[U.length-1].end-V,K=F[0].start,ee=F[F.length-1].end-K;return Q===ee?0:ee<Q?1:-1}function $(U,F,V,H){const Q=H.getItemLabel(U)||"",K=H.getItemLabel(F)||"",de=H.getItemDescription(U),ee=H.getItemDescription(F),fe=Q.length+(de?de.length:0),Y=K.length+(ee?ee.length:0);if(fe!==Y)return fe-Y;const ve=H.getItemPath(U),Ee=H.getItemPath(F);return ve&&Ee&&ve.length!==Ee.length?ve.length-Ee.length:Q!==K?(0,c.compareAnything)(Q,K,V.normalized):de&&ee&&de!==ee?(0,c.compareAnything)(de,ee,V.normalized):ve&&Ee&&ve!==Ee?(0,c.compareAnything)(ve,Ee,V.normalized):0}function x(U){return U.startsWith('"')&&U.endsWith('"')}const L=" ";function B(U){typeof U!="string"&&(U="");const F=U.toLowerCase(),{pathNormalized:V,normalized:H,normalizedLowercase:Q}=O(U),K=V.indexOf(P.sep)>=0,de=x(U);let ee;const fe=U.split(L);if(fe.length>1)for(const Y of fe){const ve=x(Y),{pathNormalized:Ee,normalized:ke,normalizedLowercase:Re}=O(Y);ke&&(ee||(ee=[]),ee.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:Ee,normalized:ke,normalizedLowercase:Re,expectContiguousMatch:ve}))}return{original:U,originalLowercase:F,pathNormalized:V,normalized:H,normalizedLowercase:Q,values:ee,containsPathSeparator:K,expectContiguousMatch:de}}e.prepareQuery=B;function O(U){let F;y.isWindows?F=U.replace(/\//g,P.sep):F=U.replace(/\\/g,P.sep);const V=(0,T.stripWildcards)(F).replace(/\s|"/g,"");return{pathNormalized:F,normalized:V,normalizedLowercase:V.toLowerCase()}}function z(U){return Array.isArray(U)?B(U.map(F=>F.original).join(L)):B(U.original)}e.pieceToQuery=z}),define(De[37],Ie([1,0,17,18,32,28,9,12,8]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",I="[^/\\\\]",E=/\//g;function _(V,H){switch(V){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${H?`|${A}${I}+`:""})*?`}}function w(V,H){if(!V)return[];const Q=[];let K=!1,de=!1,ee="";for(const fe of V){switch(fe){case H:if(!K&&!de){Q.push(ee),ee="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":de=!0;break;case"]":de=!1;break}ee+=fe}return ee&&Q.push(ee),Q}e.splitGlobAware=w;function h(V){if(!V)return"";let H="";const Q=w(V,e.GLOB_SPLIT);if(Q.every(K=>K===e.GLOBSTAR))H=".*";else{let K=!1;Q.forEach((de,ee)=>{if(de===e.GLOBSTAR){if(K)return;H+=_(2,ee===Q.length-1)}else{let fe=!1,Y="",ve=!1,Ee="";for(const ke of de){if(ke!=="}"&&fe){Y+=ke;continue}if(ve&&(ke!=="]"||!Ee)){let Re;ke==="-"?Re=ke:(ke==="^"||ke==="!")&&!Ee?Re="^":ke===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(ke),Ee+=Re;continue}switch(ke){case"{":fe=!0;continue;case"[":ve=!0;continue;case"}":{H+=`(?:${w(Y,",").map(ie=>h(ie)).join("|")})`,fe=!1,Y="";break}case"]":{H+="["+Ee+"]",ve=!1,Ee="";break}case"?":H+=I;continue;case"*":H+=_(1);continue;default:H+=(0,S.escapeRegExpCharacters)(ke)}}ee<Q.length-1&&(Q[ee+1]!==e.GLOBSTAR||ee+2<Q.length)&&(H+=A)}K=de===e.GLOBSTAR})}return H}const g=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new P.LRUCache(1e4),u=function(){return!1},o=function(){return null};function l(V,H){if(!V)return o;let Q;typeof V!="string"?Q=V.pattern:Q=V,Q=Q.trim();const K=`${Q}_${!!H.trimForExclusions}`;let de=s.get(K);if(de)return a(de,V);let ee;return g.test(Q)?de=n(Q.substr(4),Q):(ee=f.exec(d(Q,H)))?de=i(ee[1],Q):(H.trimForExclusions?m:v).test(Q)?de=p(Q,H):(ee=r.exec(d(Q,H)))?de=C(ee[1].substr(1),Q,!0):(ee=b.exec(d(Q,H)))?de=C(ee[1],Q,!1):de=R(Q),s.set(K,de),a(de,V)}function a(V,H){if(typeof H=="string")return V;const Q=function(K,de){return(0,D.isEqualOrParent)(K,H.base,!T.isLinux)?V(K.substr(H.base.length+1),de):null};return Q.allBasenames=V.allBasenames,Q.allPaths=V.allPaths,Q.basenames=V.basenames,Q.patterns=V.patterns,Q}function d(V,H){return H.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function n(V,H){return function(Q,K){return typeof Q=="string"&&Q.endsWith(V)?H:null}}function i(V,H){const Q=`/${V}`,K=`\\${V}`,de=function(fe,Y){return typeof fe!="string"?null:Y?Y===V?H:null:fe===V||fe.endsWith(Q)||fe.endsWith(K)?H:null},ee=[V];return de.basenames=ee,de.patterns=[H],de.allBasenames=ee,de}function p(V,H){const Q=U(V.slice(1,-1).split(",").map(Y=>l(Y,H)).filter(Y=>Y!==o),V),K=Q.length;if(!K)return o;if(K===1)return Q[0];const de=function(Y,ve){for(let Ee=0,ke=Q.length;Ee<ke;Ee++)if(Q[Ee](Y,ve))return V;return null},ee=Q.find(Y=>!!Y.allBasenames);ee&&(de.allBasenames=ee.allBasenames);const fe=Q.reduce((Y,ve)=>ve.allPaths?Y.concat(ve.allPaths):Y,[]);return fe.length&&(de.allPaths=fe),de}function C(V,H,Q){const K=y.sep===y.posix.sep,de=K?V:V.replace(E,y.sep),ee=y.sep+de,fe=y.posix.sep+V;let Y;return Q?Y=function(ve,Ee){return typeof ve=="string"&&(ve===de||ve.endsWith(ee)||!K&&(ve===V||ve.endsWith(fe)))?H:null}:Y=function(ve,Ee){return typeof ve=="string"&&(ve===de||!K&&ve===V)?H:null},Y.allPaths=[(Q?"*/":"./")+V],Y}function R(V){try{const H=new RegExp(`^${h(V)}$`);return function(Q){return H.lastIndex=0,typeof Q=="string"&&H.test(Q)?V:null}}catch{return o}}function M(V,H,Q){return!V||typeof H!="string"?!1:$(V)(H,void 0,Q)}e.match=M;function $(V,H={}){if(!V)return u;if(typeof V=="string"||x(V)){const Q=l(V,H);if(Q===o)return u;const K=function(de,ee){return!!Q(de,ee)};return Q.allBasenames&&(K.allBasenames=Q.allBasenames),Q.allPaths&&(K.allPaths=Q.allPaths),K}return O(V,H)}e.parse=$;function x(V){const H=V;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=x;function L(V){return V.allBasenames||[]}e.getBasenameTerms=L;function B(V){return V.allPaths||[]}e.getPathTerms=B;function O(V,H){const Q=U(Object.getOwnPropertyNames(V).map(Y=>z(Y,V[Y],H)).filter(Y=>Y!==o)),K=Q.length;if(!K)return o;if(!Q.some(Y=>!!Y.requiresSiblings)){if(K===1)return Q[0];const Y=function(ke,Re){let ze;for(let ie=0,ce=Q.length;ie<ce;ie++){const me=Q[ie](ke,Re);if(typeof me=="string")return me;(0,t.isThenable)(me)&&(ze||(ze=[]),ze.push(me))}return ze?(async()=>{for(const ie of ze){const ce=await ie;if(typeof ce=="string")return ce}return null})():null},ve=Q.find(ke=>!!ke.allBasenames);ve&&(Y.allBasenames=ve.allBasenames);const Ee=Q.reduce((ke,Re)=>Re.allPaths?ke.concat(Re.allPaths):ke,[]);return Ee.length&&(Y.allPaths=Ee),Y}const de=function(Y,ve,Ee){let ke,Re;for(let ze=0,ie=Q.length;ze<ie;ze++){const ce=Q[ze];ce.requiresSiblings&&Ee&&(ve||(ve=(0,y.basename)(Y)),ke||(ke=ve.substr(0,ve.length-(0,y.extname)(Y).length)));const me=ce(Y,ve,ke,Ee);if(typeof me=="string")return me;(0,t.isThenable)(me)&&(Re||(Re=[]),Re.push(me))}return Re?(async()=>{for(const ze of Re){const ie=await ze;if(typeof ie=="string")return ie}return null})():null},ee=Q.find(Y=>!!Y.allBasenames);ee&&(de.allBasenames=ee.allBasenames);const fe=Q.reduce((Y,ve)=>ve.allPaths?Y.concat(ve.allPaths):Y,[]);return fe.length&&(de.allPaths=fe),de}function z(V,H,Q){if(H===!1)return o;const K=l(V,Q);if(K===o)return o;if(typeof H=="boolean")return K;if(H){const de=H.when;if(typeof de=="string"){const ee=(fe,Y,ve,Ee)=>{if(!Ee||!K(fe,Y))return null;const ke=de.replace("$(basename)",ve),Re=Ee(ke);return(0,t.isThenable)(Re)?Re.then(ze=>ze?V:null):Re?V:null};return ee.requiresSiblings=!0,ee}}return K}function U(V,H){const Q=V.filter(Y=>!!Y.basenames);if(Q.length<2)return V;const K=Q.reduce((Y,ve)=>{const Ee=ve.basenames;return Ee?Y.concat(Ee):Y},[]);let de;if(H){de=[];for(let Y=0,ve=K.length;Y<ve;Y++)de.push(H)}else de=Q.reduce((Y,ve)=>{const Ee=ve.patterns;return Ee?Y.concat(Ee):Y},[]);const ee=function(Y,ve){if(typeof Y!="string")return null;if(!ve){let ke;for(ke=Y.length;ke>0;ke--){const Re=Y.charCodeAt(ke-1);if(Re===47||Re===92)break}ve=Y.substr(ke)}const Ee=K.indexOf(ve);return Ee!==-1?de[Ee]:null};ee.basenames=K,ee.patterns=de,ee.allBasenames=K;const fe=V.filter(Y=>!Y.basenames);return fe.push(ee),fe}function F(V,H){return(0,c.equals)(V,H,(Q,K)=>typeof Q=="string"&&typeof K=="string"?Q===K:typeof Q!="string"&&typeof K!="string"?Q.base===K.base&&Q.pattern===K.pattern:!1)}e.patternsEquals=F}),define(De[110],Ie([1,0,10,158,22,8,2]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(f="",v=!1){if(this.value=f,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(f,v=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(m,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,v){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(f,v,m){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(f),")"),m&&(this.value+=` "${this._escape(this._escape(m,'"'),")")}"`),this.value+=")",this}_escape(f,v){const m=new RegExp((0,P.escapeRegExpCharacters)(v),"g");return f.replace(m,(r,b)=>f.charAt(b-1)!=="\\"?`\\${r}`:r)}}e.MarkdownString=S;function k(g){return A(g)?!g.value:Array.isArray(g)?g.every(k):!0}e.isEmptyMarkdownString=k;function A(g){return g instanceof S?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function I(g,f){return g===f?!0:!g||!f?!1:g.value===f.value&&g.isTrusted===f.isTrusted&&g.supportThemeIcons===f.supportThemeIcons&&g.supportHtml===f.supportHtml&&(g.baseUri===f.baseUri||!!g.baseUri&&!!f.baseUri&&(0,D.isEqual)(y.URI.from(g.baseUri),y.URI.from(f.baseUri)))}e.markdownStringEqual=I;function E(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function _(g){return g.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=_;function w(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function h(g){const f=[],v=g.split("|").map(r=>r.trim());g=v[0];const m=v[1];if(m){const r=/height=(\d+)/.exec(m),b=/width=(\d+)/.exec(m),s=r?r[1]:"",u=b?b[1]:"",o=isFinite(parseInt(u)),l=isFinite(parseInt(s));o&&f.push(`width="${u}"`),l&&f.push(`height="${s}"`)}return{href:g,dimensions:f}}e.parseHrefAndDimensions=h}),define(De[111],Ie([1,0,17,32,9,12,22,8]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(o,l){const{os:a,tildify:d,relative:n}=l;if(n){const C=k(o,n,a);if(typeof C=="string")return C}let i=o.fsPath;if(a===1&&!P.isWindows?i=i.replace(/\//g,"\\"):a!==1&&P.isWindows&&(i=i.replace(/\\/g,"/")),a!==1&&d?.userHome){const C=d.userHome.fsPath;let R;o.scheme!==d.userHome.scheme&&o.path.startsWith(D.posix.sep)?R=d.userHome.with({path:o.path}).fsPath:R=o.fsPath,i=E(R,C,a)}return(a===1?D.win32:D.posix).normalize(A(i,a===1))}e.getPathLabel=S;function k(o,l,a){const d=a===1?D.win32:D.posix,n=a===3?y.extUri:y.extUriIgnorePathCase,i=l.getWorkspace(),p=(0,c.firstOrDefault)(i.folders);if(!p)return;o.scheme!==p.uri.scheme&&o.path.startsWith(D.posix.sep)&&(o=p.uri.with({path:o.path}));const C=l.getWorkspaceFolder(o);if(!C)return;let R;if(n.isEqual(C.uri,o)?R="":R=n.relativePath(C.uri,o)??"",R&&(R=d.normalize(R)),i.folders.length>1&&!l.noPrefix){const M=C.name?C.name:n.basenameOrAuthority(C.uri);R=R?`${M} \u2022 ${R}`:M}return R}function A(o,l=P.isWindows){return(0,t.hasDriveLetter)(o,l)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=A;let I=Object.create(null);function E(o,l,a=P.OS){if(a===1||!o||!l)return o;let d=I.original===l?I.normalized:void 0;d||(d=l,P.isWindows&&(d=(0,t.toSlashes)(d)),d=`${(0,T.rtrim)(d,D.posix.sep)}${D.posix.sep}`,I={original:l,normalized:d});let n=o;return P.isWindows&&(n=(0,t.toSlashes)(n)),(a===3?n.startsWith(d):(0,T.startsWithIgnoreCase)(n,d))?`~/${n.substr(d.length)}`:o}e.tildify=E;function _(o,l){return o.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=_;const w="\u2026",h="\\\\",g="~";function f(o,l=D.sep){const a=new Array(o.length);let d=!1;for(let n=0;n<o.length;n++){const i=o[n];if(i===""){a[n]=`.${l}`;continue}if(!i){a[n]=i;continue}d=!0;let p="",C=i;C.indexOf(h)===0?(p=C.substr(0,C.indexOf(h)+h.length),C=C.substr(C.indexOf(h)+h.length)):C.indexOf(l)===0?(p=C.substr(0,C.indexOf(l)+l.length),C=C.substr(C.indexOf(l)+l.length)):C.indexOf(g)===0&&(p=C.substr(0,C.indexOf(g)+g.length),C=C.substr(C.indexOf(g)+g.length));const R=C.split(l);for(let M=1;d&&M<=R.length;M++)for(let $=R.length-M;d&&$>=0;$--){d=!1;let x=R.slice($,$+M).join(l);for(let L=0;!d&&L<o.length;L++)if(L!==n&&o[L]&&o[L].indexOf(x)>-1){const B=$+M===R.length,O=$>0&&o[L].indexOf(l)>-1?l+x:x,z=o[L].endsWith(O);d=!B||z}if(!d){let L="";(R[0].endsWith(":")||p!=="")&&($===1&&($=0,M++,x=R[0]+l+x),$>0&&(L=R[0]+l),L=p+L),$>0&&(L=L+w+l),L=L+x,$+M<R.length&&(L=L+l+w),a[n]=L}}d&&(a[n]=i)}return a}e.shorten=f;var v;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function m(o,l=Object.create(null)){const a=[];let d=!1,n="";for(const i of o)if(i==="$"||d&&i==="{")n&&a.push({value:n,type:v.TEXT}),n="",d=!0;else if(i==="}"&&d){const p=l[n];if(typeof p=="string")p.length&&a.push({value:p,type:v.VARIABLE});else if(p){const C=a[a.length-1];(!C||C.type!==v.SEPARATOR)&&a.push({value:p.label,type:v.SEPARATOR})}n="",d=!1}else n+=i;return n&&!d&&a.push({value:n,type:v.TEXT}),a.filter((i,p)=>{if(i.type===v.SEPARATOR){const C=a[p-1],R=a[p+1];return[C,R].every(M=>M&&(M.type===v.VARIABLE||M.type===v.TEXT)&&M.value.length>0)}return!0}).map(i=>i.value).join("")}e.template=m;function r(o,l){return P.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):o.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=r;function b(o,l){return P.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,""):P.isWindows?o.replace(/&&|&/g,a=>a==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function u(o){const l=o.indexOf("/")!==-1?D.posix:D.win32,a=l.basename(o),d=l.dirname(o);return a.length?{name:a,parentPath:d}:{name:d,parentPath:""}}e.splitName=u}),define(De[112],Ie([1,0,2]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(A){return A.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const E=this._uriTransformer.transformIncoming(I);return E===I?I:t(c.URI.from(E))}transformOutgoing(I){const E=this._uriTransformer.transformOutgoing(I);return E===I?I:t(c.URI.from(E))}transformOutgoingURI(I){const E=this._uriTransformer.transformOutgoing(I);return E===I?I:c.URI.from(E)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,I,E){if(!A||E>200)return null;if(typeof A=="object"){if(A instanceof c.URI)return I.transformOutgoing(A);for(const _ in A)if(Object.hasOwnProperty.call(A,_)){const w=P(A[_],I,E+1);w!==null&&(A[_]=w)}}return null}function y(A,I){const E=P(A,I,0);return E===null?A:E}e.transformOutgoingURIs=y;function T(A,I,E,_){if(!A||_>200)return null;if(typeof A=="object"){if(A.$mid===1)return E?c.URI.revive(I.transformIncoming(A)):I.transformIncoming(A);for(const w in A)if(Object.hasOwnProperty.call(A,w)){const h=T(A[w],I,E,_+1);h!==null&&(A[w]=h)}}return null}function S(A,I){const E=T(A,I,!1,0);return E===null?A:E}e.transformIncomingURIs=S;function k(A,I){const E=T(A,I,!0,0);return E===null?A:E}e.transformAndReviveIncomingURIs=k}),define(De[29],Ie([1,0,65,83,307,18,32,80,9,12,22,2]),function(Z,e,c,t,D,P,y,T,S,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function _(O,z=E.UNLINK){if((0,y.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return z===E.UNLINK?h(O):w(O)}async function w(O){try{const z=(0,y.randomPath)((0,t.tmpdir)());try{await c.promises.rename(O,z)}catch(U){return U.code==="ENOENT"?void 0:h(O)}h(z).catch(U=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function h(O){return(0,D.promisify)(c.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function g(O){if((0,y.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function f(O,z){return r(await(z?v(O):(0,D.promisify)(c.readdir)(O)))}async function v(O){try{return await(0,D.promisify)(c.readdir)(O,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const z=[],U=await f(O);for(const F of U){let V=!1,H=!1,Q=!1;try{const K=await e.Promises.lstat((0,S.join)(O,F));V=K.isFile(),H=K.isDirectory(),Q=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}z.push({name:F,isFile:()=>V,isDirectory:()=>H,isSymbolicLink:()=>Q})}return z}function m(O){return r(c.readdirSync(O))}e.readdirSync=m;function r(O){return O.map(z=>typeof z=="string"?k.isMacintosh?(0,T.normalizeNFC)(z):z:(z.name=k.isMacintosh?(0,T.normalizeNFC)(z.name):z.name,z))}async function b(O){const z=await f(O),U=[];for(const F of z)await u.existsDirectory((0,S.join)(O,F))&&U.push(F);return U}function s(O,z=1e3){return new Promise(U=>{let F=!1;const V=setInterval(()=>{F||(F=!0,c.access(O,H=>{F=!1,H&&(clearInterval(V),U(void 0))}))},z)})}e.whenDeleted=s;var u;(function(O){async function z(V){let H;try{if(H=await e.Promises.lstat(V),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(k.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw K}throw Q}}O.stat=z;async function U(V){try{const{stat:H,symbolicLink:Q}=await O.stat(V);return H.isFile()&&Q?.dangling!==!0}catch{}return!1}O.existsFile=U;async function F(V){try{const{stat:H,symbolicLink:Q}=await O.stat(V);return H.isDirectory()&&Q?.dangling!==!0}catch{}return!1}O.existsDirectory=F})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new P.ResourceQueue;function l(O,z,U){return o.queueFor(I.URI.file(O),A.extUriBiasedIgnorePathCase).queue(()=>{const F=p(U);return new Promise((V,H)=>n(O,z,F,Q=>Q?H(Q):V()))})}let a=!0;function d(O){a=O}e.configureFlushOnWrite=d;function n(O,z,U,F){if(!a)return c.writeFile(O,z,{mode:U.mode,flag:U.flag},F);c.open(O,U.flag,U.mode,(V,H)=>{if(V)return F(V);c.writeFile(H,z,Q=>{if(Q)return c.close(H,()=>F(Q));c.fdatasync(H,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),d(!1)),c.close(H,de=>F(de))))})})}function i(O,z,U){const F=p(U);if(!a)return c.writeFileSync(O,z,{mode:F.mode,flag:F.flag});const V=c.openSync(O,F.flag,F.mode);try{c.writeFileSync(V,z);try{c.fdatasyncSync(V)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),d(!1)}}finally{c.closeSync(V)}}e.writeFileSync=i;function p(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function C(O,z){if(O!==z)try{await e.Promises.rename(O,z)}catch(U){if(O.toLowerCase()!==z.toLowerCase()&&U.code==="EXDEV"||O.endsWith("."))await R(O,z,{preserveSymlinks:!1}),await _(O,E.MOVE);else throw U}}async function R(O,z,U){return $(O,z,{root:{source:O,target:z},options:U,handledSourcePaths:new Set})}const M=511;async function $(O,z,U){if(U.handledSourcePaths.has(O))return;U.handledSourcePaths.add(O);const{stat:F,symbolicLink:V}=await u.stat(O);if(V){if(U.options.preserveSymlinks)try{return await B(O,z,U)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(V.dangling)return}return F.isDirectory()?x(O,z,F.mode&M,U):L(O,z,F.mode&M)}async function x(O,z,U,F){await e.Promises.mkdir(z,{recursive:!0,mode:U});const V=await f(O);for(const H of V)await $((0,S.join)(O,H),(0,S.join)(z,H),F)}async function L(O,z,U){await e.Promises.copyFile(O,z),await e.Promises.chmod(z,U)}async function B(O,z,U){let F=await e.Promises.readlink(O);(0,y.isEqualOrParent)(F,U.root.source,!k.isLinux)&&(F=(0,S.join)(U.root.target,F.substr(U.root.source.length+1))),await e.Promises.symlink(F,z)}e.Promises=new class{get access(){return(0,D.promisify)(c.access)}get stat(){return(0,D.promisify)(c.stat)}get lstat(){return(0,D.promisify)(c.lstat)}get utimes(){return(0,D.promisify)(c.utimes)}get read(){return(O,z,U,F,V)=>new Promise((H,Q)=>{c.read(O,z,U,F,V,(K,de,ee)=>K?Q(K):H({bytesRead:de,buffer:ee}))})}get readFile(){return(0,D.promisify)(c.readFile)}get write(){return(O,z,U,F,V)=>new Promise((H,Q)=>{c.write(O,z,U,F,V,(K,de,ee)=>K?Q(K):H({bytesWritten:de,buffer:ee}))})}get appendFile(){return(0,D.promisify)(c.appendFile)}get fdatasync(){return(0,D.promisify)(c.fdatasync)}get truncate(){return(0,D.promisify)(c.truncate)}get rename(){return(0,D.promisify)(c.rename)}get copyFile(){return(0,D.promisify)(c.copyFile)}get open(){return(0,D.promisify)(c.open)}get close(){return(0,D.promisify)(c.close)}get symlink(){return(0,D.promisify)(c.symlink)}get readlink(){return(0,D.promisify)(c.readlink)}get chmod(){return(0,D.promisify)(c.chmod)}get mkdir(){return(0,D.promisify)(c.mkdir)}get unlink(){return(0,D.promisify)(c.unlink)}get rmdir(){return(0,D.promisify)(c.rmdir)}get realpath(){return(0,D.promisify)(c.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return b}get writeFile(){return l}get rm(){return _}get move(){return C}get copy(){return R}}}),define(De[113],Ie([1,0,65,9,12,8,29]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(E){if(D.isLinux)return E;const _=(0,t.dirname)(E);if(E===_)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const g=(0,y.readdirSync)(_).filter(f=>f.toLowerCase()===w);if(g.length===1){const f=T(_);if(f)return(0,t.join)(f,g[0])}else if(g.length>1){const f=g.indexOf(w);if(f>=0){const v=T(_);if(v)return(0,t.join)(v,g[f])}}}catch{}return null}e.realcaseSync=T;async function S(E){if(D.isLinux)return E;const _=(0,t.dirname)(E);if(E===_)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const g=(await y.Promises.readdir(_)).filter(f=>f.toLowerCase()===w);if(g.length===1){const f=await S(_);if(f)return(0,t.join)(f,g[0])}else if(g.length>1){const f=g.indexOf(w);if(f>=0){const v=await S(_);if(v)return(0,t.join)(v,g[f])}}}catch{}return null}e.realcase=S;async function k(E){try{return await y.Promises.realpath(E)}catch{const w=I(E);return await y.Promises.access(w,c.constants.R_OK),w}}e.realpath=k;function A(E){try{return c.realpathSync(E)}catch{const w=I(E);return c.accessSync(w,c.constants.R_OK),w}}e.realpathSync=A;function I(E){return(0,P.rtrim)((0,t.normalize)(E),t.sep)}}),define(De[114],Ie([1,0,9,12,36,106,11,29]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function S(I=D.env){return I.comspec||"cmd.exe"}e.getWindowsShell=S;function k(I){let E=[],_=!1;const w=function(h){if(_){E.push(h);return}(!I.send(h,f=>{if(f&&console.error(f),_=!1,E.length>0){const v=E.slice(0);E=[],v.forEach(m=>w(m))}})||t.isWindows)&&(_=!0)};return{send:w}}e.createQueuedSender=k;var A;(function(I){async function E(_,w,h){if(c.isAbsolute(_))return _;if(w===void 0&&(w=D.cwd()),c.dirname(_)!=="."||(h===void 0&&y.isString(D.env.PATH)&&(h=D.env.PATH.split(c.delimiter)),h===void 0||h.length===0))return c.join(w,_);async function f(v){if(await T.Promises.exists(v)){let m;try{m=await T.Promises.stat(v)}catch(r){r.message.startsWith("EACCES")&&(m=await T.Promises.lstat(v))}return m?!m.isDirectory():!1}return!1}for(const v of h){let m;if(c.isAbsolute(v)?m=c.join(v,_):m=c.join(w,v,_),await f(m))return m;let r=m+".com";if(await f(r)||(r=m+".exe",await f(r)))return r}return c.join(w,_)}I.findExecutable=E})(A=e.win32||(e.win32={}))});var Ve=this&&this.__decorate||function(Z,e,c,t){var D=arguments.length,P=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,c):t,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Z,e,c,t);else for(var T=Z.length-1;T>=0;T--)(y=Z[T])&&(P=(D<3?y(P):D>3?y(e,c,P):y(e,c))||P);return D>3&&P&&Object.defineProperty(e,c,P),P};define(De[115],Ie([1,0,17,18,23,21,60,10,4,6,82,8,11]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var _;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(_=e.RequestType||(e.RequestType={}));function w(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));class v{constructor(H){this.buffer=H,this.pos=0}read(H){const Q=this.buffer.slice(this.pos,this.pos+H);return this.pos+=Q.byteLength,Q}}class m{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var r;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(r||(r={}));function b(V){const H=D.VSBuffer.alloc(4);return H.writeUInt32BE(V,0),H}function s(V){return V.read(4).readUInt32BE(0)}function u(V){const H=D.VSBuffer.alloc(1);return H.writeUInt8(V,0),H}const o={Undefined:u(r.Undefined),String:u(r.String),Buffer:u(r.Buffer),VSBuffer:u(r.VSBuffer),Array:u(r.Array),Object:u(r.Object)},l=typeof Buffer<"u";function a(V,H){if(typeof H>"u")V.write(o.Undefined);else if(typeof H=="string"){const Q=D.VSBuffer.fromString(H);V.write(o.String),V.write(b(Q.byteLength)),V.write(Q)}else if(l&&Buffer.isBuffer(H)){const Q=D.VSBuffer.wrap(H);V.write(o.Buffer),V.write(b(Q.byteLength)),V.write(Q)}else if(H instanceof D.VSBuffer)V.write(o.VSBuffer),V.write(b(H.byteLength)),V.write(H);else if(Array.isArray(H)){V.write(o.Array),V.write(b(H.length));for(const Q of H)a(V,Q)}else{const Q=D.VSBuffer.fromString(JSON.stringify(H));V.write(o.Object),V.write(b(Q.byteLength)),V.write(Q)}}function d(V){switch(V.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return V.read(s(V)).toString();case r.Buffer:return V.read(s(V)).buffer;case r.VSBuffer:return V.read(s(V));case r.Array:{const Q=s(V),K=[];for(let de=0;de<Q;de++)K.push(d(V));return K}case r.Object:return JSON.parse(V.read(s(V)).toString())}}class n{constructor(H,Q,K=null,de=1e3){this.protocol=H,this.ctx=Q,this.logger=K,this.timeoutDelay=de,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(H,Q){this.channels.set(H,Q),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const Q=this.send([H.type]);this.logger?.logOutgoing(Q,0,1,g(H.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([H.type,H.id],H.data);this.logger?.logOutgoing(Q,H.id,1,g(H.type),H.data);return}}}send(H,Q=void 0){const K=new m;return a(K,H),a(K,Q),this.sendBuffer(K.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onRawMessage(H){const Q=new v(H),K=d(Q),de=d(Q),ee=K[0];switch(ee){case 100:return this.logger?.logIncoming(H.byteLength,K[1],1,`${w(ee)}: ${K[2]}.${K[3]}`,de),this.onPromise({type:ee,id:K[1],channelName:K[2],name:K[3],arg:de});case 102:return this.logger?.logIncoming(H.byteLength,K[1],1,`${w(ee)}: ${K[2]}.${K[3]}`,de),this.onEventListen({type:ee,id:K[1],channelName:K[2],name:K[3],arg:de});case 101:return this.logger?.logIncoming(H.byteLength,K[1],1,`${w(ee)}`),this.disposeActiveRequest({type:ee,id:K[1]});case 103:return this.logger?.logIncoming(H.byteLength,K[1],1,`${w(ee)}`),this.disposeActiveRequest({type:ee,id:K[1]})}}onPromise(H){const Q=this.channels.get(H.channelName);if(!Q){this.collectPendingRequest(H);return}const K=new P.CancellationTokenSource;let de;try{de=Q.call(this.ctx,H.name,H.arg,K.token)}catch(Y){de=Promise.reject(Y)}const ee=H.id;de.then(Y=>{this.sendResponse({id:ee,data:Y,type:201}),this.activeRequests.delete(H.id)},Y=>{Y instanceof Error?this.sendResponse({id:ee,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ee,data:Y,type:203}),this.activeRequests.delete(H.id)});const fe=(0,k.toDisposable)(()=>K.cancel());this.activeRequests.set(H.id,fe)}onEventListen(H){const Q=this.channels.get(H.channelName);if(!Q){this.collectPendingRequest(H);return}const K=H.id,ee=Q.listen(this.ctx,H.name,H.arg)(fe=>this.sendResponse({id:K,data:fe,type:204}));this.activeRequests.set(H.id,ee)}disposeActiveRequest(H){const Q=this.activeRequests.get(H.id);Q&&(Q.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let Q=this.pendingRequests.get(H.channelName);Q||(Q=[],this.pendingRequests.set(H.channelName,Q));const K=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:H,timeoutTimer:K})}flushPendingRequests(H){const Q=this.pendingRequests.get(H);if(Q){for(const K of Q)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,k.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=n;var i;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(i=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(H,Q=null){this.protocol=H,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=Q}getChannel(H){const Q=this;return{call(K,de,ee){return Q.isDisposed?Promise.reject(new T.CancellationError):Q.requestPromise(H,K,de,ee)},listen(K,de){return Q.isDisposed?S.Event.None:Q.requestEvent(H,K,de)}}}requestPromise(H,Q,K,de=P.CancellationToken.None){const ee=this.lastRequestId++,Y={id:ee,type:100,channelName:H,name:Q,arg:K};if(de.isCancellationRequested)return Promise.reject(new T.CancellationError);let ve;return new Promise((ke,Re)=>{if(de.isCancellationRequested)return Re(new T.CancellationError);const ze=()=>{const J=ae=>{switch(ae.type){case 201:this.handlers.delete(ee),ke(ae.data);break;case 202:{this.handlers.delete(ee);const ne=new Error(ae.data.message);ne.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,ne.name=ae.data.name,Re(ne);break}case 203:this.handlers.delete(ee),Re(ae.data);break}};this.handlers.set(ee,J),this.sendRequest(Y)};let ie=null;this.state===f.Idle?ze():(ie=(0,t.createCancelablePromise)(J=>this.whenInitialized()),ie.then(()=>{ie=null,ze()}));const ce=()=>{ie?(ie.cancel(),ie=null):this.sendRequest({id:ee,type:101}),Re(new T.CancellationError)},me=de.onCancellationRequested(ce);ve=(0,k.combinedDisposable)((0,k.toDisposable)(ce),me),this.activeRequests.add(ve)}).finally(()=>{this.activeRequests.delete(ve)})}requestEvent(H,Q,K){const de=this.lastRequestId++,fe={id:de,type:102,channelName:H,name:Q,arg:K};let Y=null;const ve=new S.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(ke=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(ve),this.sendRequest(fe)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(ve),this.sendRequest({id:de,type:103}))}}),Ee=ke=>ve.fire(ke.data);return this.handlers.set(de,Ee),ve.event}sendRequest(H){switch(H.type){case 100:case 102:{const Q=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger?.logOutgoing(Q,H.id,0,`${w(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const Q=this.send([H.type,H.id]);this.logger?.logOutgoing(Q,H.id,0,w(H.type));return}}}send(H,Q=void 0){const K=new m;return a(K,H),a(K,Q),this.sendBuffer(K.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onBuffer(H){const Q=new v(H),K=d(Q),de=d(Q),ee=K[0];switch(ee){case 200:return this.logger?.logIncoming(H.byteLength,0,0,g(ee)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(H.byteLength,K[1],0,g(ee),de),this.onResponse({type:K[0],id:K[1],data:de})}}onResponse(H){if(H.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(H.id)?.(H)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,k.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ve([y.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class C{get connections(){const H=[];return this._connections.forEach(Q=>H.push(Q)),H}constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:Q,onDidClientDisconnect:K})=>{S.Event.once(Q.onMessage)(ee=>{const fe=new v(ee),Y=d(fe),ve=new n(Q,Y),Ee=new p(Q);this.channels.forEach((Re,ze)=>ve.registerChannel(ze,Re));const ke={channelServer:ve,channelClient:Ee,ctx:Y};this._connections.add(ke),this._onDidAddConnection.fire(ke),K(()=>{ve.dispose(),Ee.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}getChannel(H,Q){const K=this;return{call(de,ee,fe){let Y;if((0,E.isFunction)(Q)){const Ee=(0,c.getRandomElement)(K.connections.filter(Q));Y=Ee?Promise.resolve(Ee):S.Event.toPromise(S.Event.filter(K.onDidAddConnection,Q))}else Y=Q.routeCall(K,de,ee);const ve=Y.then(Ee=>Ee.channelClient.getChannel(H));return M(ve).call(de,ee,fe)},listen(de,ee){if((0,E.isFunction)(Q))return K.getMulticastEvent(H,Q,de,ee);const fe=Q.routeEvent(K,de,ee).then(Y=>Y.channelClient.getChannel(H));return M(fe).listen(de,ee)}}}getMulticastEvent(H,Q,K,de){const ee=this;let fe=new k.DisposableStore;const Y=new S.Emitter({onFirstListenerAdd:()=>{fe=new k.DisposableStore;const ve=new S.EventMultiplexer,Ee=new Map,ke=ze=>{const ce=ze.channelClient.getChannel(H).listen(K,de),me=ve.add(ce);Ee.set(ze,me)},Re=ze=>{const ie=Ee.get(ze);!ie||(ie.dispose(),Ee.delete(ze))};ee.connections.filter(Q).forEach(ke),S.Event.filter(ee.onDidAddConnection,Q)(ke,void 0,fe),ee.onDidRemoveConnection(Re,void 0,fe),ve.event(Y.fire,Y,fe),fe.add(ve)},onLastListenerRemove:()=>{fe.dispose()}});return Y.event}registerChannel(H,Q){this.channels.set(H,Q),this._connections.forEach(K=>{K.channelServer.registerChannel(H,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class R{constructor(H,Q,K=null){const de=new m;a(de,Q),H.send(de.buffer),this.channelClient=new p(H,K),this.channelServer=new n(H,Q,K)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,Q){this.channelServer.registerChannel(H,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function M(V){return{call(H,Q,K){return V.then(de=>de.call(H,Q,K))},listen(H,Q){const K=new S.Relay;return V.then(de=>K.input=de.listen(H,Q)),K.event}}}e.getDelayedChannel=M;function $(V){let H=!1;return{call(Q,K,de){return H?V.call(Q,K,de):(0,t.timeout)(0).then(()=>H=!0).then(()=>V.call(Q,K,de))},listen(Q,K){if(H)return V.listen(Q,K);const de=new S.Relay;return(0,t.timeout)(0).then(()=>H=!0).then(()=>de.input=V.listen(Q,K)),de.event}}}e.getNextTickChannel=$;class x{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const Q of H.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=x;var L;(function(V){function H(ee,fe){const Y=ee,ve=fe&&fe.disableMarshalling,Ee=new Map;for(const ke in Y)K(ke)&&Ee.set(ke,S.Event.buffer(Y[ke],!0));return new class{listen(ke,Re,ze){const ie=Ee.get(Re);if(ie)return ie;if(de(Re)){const ce=Y[Re];if(typeof ce=="function")return ce.call(Y,ze)}throw new Error(`Event not found: ${Re}`)}call(ke,Re,ze){const ie=Y[Re];if(typeof ie=="function"){if(!ve&&Array.isArray(ze))for(let ce=0;ce<ze.length;ce++)ze[ce]=(0,A.revive)(ze[ce]);return ie.apply(Y,ze)}throw new Error(`Method not found: ${Re}`)}}}V.fromService=H;function Q(ee,fe){const Y=fe&&fe.disableMarshalling;return new Proxy({},{get(ve,Ee){if(typeof Ee=="string")return fe?.properties?.has(Ee)?fe.properties.get(Ee):de(Ee)?function(ke){return ee.listen(Ee,ke)}:K(Ee)?ee.listen(Ee):async function(...ke){let Re;fe&&!(0,E.isUndefinedOrNull)(fe.context)?Re=[fe.context,...ke]:Re=ke;const ze=await ee.call(Ee,Re);return Y?ze:(0,A.revive)(ze)};throw new Error(`Property not found: ${String(Ee)}`)}})}V.toService=Q;function K(ee){return ee[0]==="o"&&ee[1]==="n"&&I.isUpperAsciiLetter(ee.charCodeAt(2))}function de(ee){return/^onDynamic/.test(ee)&&I.isUpperAsciiLetter(ee.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const H=V.toString();if(H!=="[object Object]")return H}return V}function z(V){return Array.isArray(V)?V.map(O):O(V)}function U(V,H,Q,K,de,ee,fe){fe=z(fe);const Y=B[de],ve=Y[K%Y.length];let Ee=[`%c[${V}]%c[${String(H).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(ee)?(Ee=Ee.concat(fe),Ee.push(")")):Ee.push(fe),console.log.apply(console,Ee)}e.logWithColors=U;class F{constructor(H,Q){this._outgoingPrefix=H,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,Q,K,de,ee){this._totalOutgoing+=H,U(this._outgoingPrefix,this._totalOutgoing,H,Q,K,de,ee)}logIncoming(H,Q,K,de,ee){this._totalIncoming+=H,U(this._incomingPrefix,this._totalIncoming,H,Q,K,de,ee)}}e.IPCLogger=F}),define(De[116],Ie([1,0,23,4,6,115]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var y;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(y=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var T;(function(l){l.enableDiagnostics=!1,l.records=[];const a=new WeakMap;let d=0;function n(p,C){if(!a.has(p)){const R=String(++d);a.set(p,R)}return a.get(p)}function i(p,C,R,M){if(!l.enableDiagnostics)return;const $=n(p,C);if(M instanceof c.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const x=c.VSBuffer.alloc(M.byteLength);x.set(M),l.records.push({timestamp:Date.now(),id:$,label:C,type:R,buff:x})}else l.records.push({timestamp:Date.now(),id:$,label:C,type:R,data:M})}l.traceSocketEvent=i})(T=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function A(){return k||(k=c.VSBuffer.alloc(0)),k}class I{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,d){if(a===0)return A();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const C=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=a),C}if(this._chunks[0].byteLength>a){const C=this._chunks[0].slice(0,a);return d&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),C}const n=c.VSBuffer.alloc(a);let i=0,p=0;for(;a>0;){const C=this._chunks[p];if(C.byteLength>a){const R=C.slice(0,a);n.set(R,i),i+=a,d&&(this._chunks[p]=C.slice(a),this._totalLength-=a),a-=a}else n.set(C,i),i+=C.byteLength,d?(this._chunks.shift(),this._totalLength-=C.byteLength):p++,a-=C.byteLength}return n}}e.ChunkStream=I;var E;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(E||(E={}));function _(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(a,d,n,i){this.type=a,this.id=d,this.ack=n,this.data=i,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends D.Disposable{constructor(a){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:_(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const n=this._state.messageType,i=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new h(n,i,p,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=c.VSBuffer.alloc(13);d.writeUInt8(a.type,0),d.writeUInt32BE(a.id,1),d.writeUInt32BE(a.ack,5),d.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:_(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",a.data),this._writeSoon(d,a.data)}_bufferAdd(a,d){const n=this._totalLength===0;return this._data.push(a,d),this._totalLength+=a.byteLength+d.byteLength,n}_bufferTake(){const a=c.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,d){this._bufferAdd(a,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this._socket.write(a)}}class v extends D.Disposable{constructor(a){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new h(1,0,0,a))}}e.Protocol=v;class m extends P.IPCClient{static fromSocket(a,d){return new m(new v(a),d)}get onDidDispose(){return this.protocol.onDidDispose}constructor(a,d,n=null){super(a,d,n),this.protocol=a}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=m;class r{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=r;class b{constructor(a){this.data=a,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let a=0,d=this._first;for(;d;)d=d.next,a++;return a}peek(){return this._first?this._first.data:null}toArray(){const a=[];let d=0,n=this._first;for(;n;)a[d++]=n.data,n=n.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const d=new b(a);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class u{static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}constructor(){this.lastRuns=[];const a=Date.now();for(let d=0;d<u._HISTORY_LENGTH;d++)this.lastRuns[d]=a-1e3*d;setInterval(()=>{for(let d=u._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}load(){const a=Date.now(),d=(1+u._HISTORY_LENGTH)*1e3;let n=0;for(let i=0;i<u._HISTORY_LENGTH;i++)a-this.lastRuns[i]<=d&&n++;return 1-n/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class o{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(a,d=null,n=u.getInstance()){this._onControlMessage=new r,this.onControlMessage=this._onControlMessage.event,this._onMessage=new r,this.onMessage=this._onMessage.event,this._onDidDispose=new r,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new r,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new r,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=a,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(i=>this._receiveMessage(i))),this._socketDisposables.push(this._socket.onClose(i=>this._onSocketClose.fire(i))),d&&this._socketReader.acceptChunk(d),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new h(5,0,0,A());this._socketWriter.write(a),this._socketWriter.flush()}sendPause(){const a=new h(7,0,0,A());this._socketWriter.write(a)}sendResume(){const a=new h(8,0,0,A());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,d){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(n=>this._onSocketClose.fire(n))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new h(3,0,this._incomingAckId,A());this._socketWriter.write(a);const d=this._outgoingUnackMsg.toArray();for(let n=0,i=d.length;n<i;n++)this._socketWriter.write(d[n]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new h(6,0,0,A())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case 2:{this._onControlMessage.fire(a.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let n=0,i=d.length;n<i;n++)this._socketWriter.write(d[n]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new h(1,d,this._incomingAckId,a);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(a){const d=new h(2,0,0,a);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),d=Date.now()-a.writtenTime,n=Date.now()-this._socketReader.lastReadTime,i=Date.now()-this._lastSocketTimeoutTime;if(d>=2e4&&n>=2e4&&i>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:n});return}const p=Math.max(2e4-d,2e4-n,2e4-i,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new h(3,0,this._incomingAckId,A());this._socketWriter.write(a)}_sendKeepAlive(){const a=new h(9,0,0,A());this._socketWriter.write(a)}}e.PersistentProtocol=o}),define(De[117],Ie([1,0,23,10,4,6,9,12,31,115,116]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:Z.__$__nodeRequire("crypto"),zlib:Z.__$__nodeRequire("zlib"),net:Z.__$__nodeRequire("net"),os:Z.__$__nodeRequire("os")}}class E{traceSocketEvent(n,i){A.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,i)}constructor(n,i=""){this._canWrite=!0,this.debugLabel=i,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,t.onUnexpectedError)(p)}},this.socket.on("error",this._errorListener),this._closeListener=p=>{this.traceSocketEvent("close",{hadError:p}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(n){const i=p=>{this.traceSocketEvent("read",p),n(c.VSBuffer.wrap(p))};return this.socket.on("data",i),{dispose:()=>this.socket.off("data",i)}}onClose(n){const i=p=>{n({type:0,hadError:p,error:void 0})};return this.socket.on("close",i),{dispose:()=>this.socket.off("close",i)}}onEnd(n){const i=()=>{n()};return this.socket.on("end",i),{dispose:()=>this.socket.off("end",i)}}write(n){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,i=>{if(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}})}catch(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,i)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=E;var _;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var w;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(w||(w={}));class h extends P.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(n,i){this.socket.traceSocketEvent(n,i)}constructor(n,i,p,C){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:i,inflateBytesLength:p?.byteLength||0,recordInflateBytes:C}),this._flowManager=this._register(new g(this,i,p,C,this._onData,(R,M)=>this._write(R,M))),this._register(this._flowManager.onError(R=>{console.error(R),(0,t.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new A.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this._onData.event(n)}onClose(n){return this._onClose.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this._flowManager.writeMessage(n)}_write(n,i){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let p=2;n.byteLength<126?p+=0:n.byteLength<2**16?p+=2:p+=8;const C=c.VSBuffer.alloc(p);if(i?C.writeUInt8(194,0):C.writeUInt8(130,0),n.byteLength<126)C.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){C.writeUInt8(126,1);let R=1;C.writeUInt8(n.byteLength>>>8&255,++R),C.writeUInt8(n.byteLength>>>0&255,++R)}else{C.writeUInt8(127,1);let R=1;C.writeUInt8(0,++R),C.writeUInt8(0,++R),C.writeUInt8(0,++R),C.writeUInt8(0,++R),C.writeUInt8(n.byteLength>>>24&255,++R),C.writeUInt8(n.byteLength>>>16&255,++R),C.writeUInt8(n.byteLength>>>8&255,++R),C.writeUInt8(n.byteLength>>>0&255,++R)}this.socket.write(c.VSBuffer.concat([C,n]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(n){if(n.byteLength!==0){for(this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const i=this._incomingData.peek(this._state.readLen),p=i.readUInt8(0),C=(p&128)>>>7,R=(p&64)>>>6,M=i.readUInt8(1),$=(M&128)>>>7,x=M&127;this._state.state=2,this._state.readLen=2+($?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=C,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(C),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const i=this._incomingData.read(this._state.readLen),p=i.readUInt8(1),C=(p&128)>>>7;let R=p&127,M=1;R===126?R=i.readUInt8(++M)*2**8+i.readUInt8(++M):R===127&&(R=i.readUInt8(++M)*0+i.readUInt8(++M)*0+i.readUInt8(++M)*0+i.readUInt8(++M)*0+i.readUInt8(++M)*2**24+i.readUInt8(++M)*2**16+i.readUInt8(++M)*2**8+i.readUInt8(++M));let $=0;C&&($=i.readUInt8(++M)*2**24+i.readUInt8(++M)*2**16+i.readUInt8(++M)*2**8+i.readUInt8(++M)),this._state.state=3,this._state.readLen=R,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const i=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",i),m(i,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",i),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(i,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class g extends P.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(n,i,p,C,R,M){super(),this._tracer=n,this._onData=R,this._writeFn=M,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,i?(this._zlibInflateStream=this._register(new f(this._tracer,C,p,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(n){this._writeQueue.push(n),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const n=this._writeQueue.shift();if(this._zlibDeflateStream){const i=await this._deflateMessage(this._zlibDeflateStream,n);this._writeFn(i,!0)}else this._writeFn(n,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(n,i){return new Promise((p,C)=>{n.write(i),n.flush(R=>p(R))})}acceptFrame(n,i,p){this._readQueue.push({data:n,isCompressed:i,isLastFrameOfMessage:p}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const n=this._readQueue.shift();if(this._zlibInflateStream&&n.isCompressed){const i=await this._inflateFrame(this._zlibInflateStream,n.data,n.isLastFrameOfMessage);this._onData.fire(i)}else this._onData.fire(n.data)}this._isProcessingReadQueue=!1}}_inflateFrame(n,i,p){return new Promise((C,R)=>{n.write(i),p&&n.write(c.VSBuffer.fromByteArray([0,0,255,255])),n.flush(M=>C(M))})}}class f extends P.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?c.VSBuffer.concat(this._recordedInflateBytes):c.VSBuffer.alloc(0)}constructor(n,i,p,C){super(),this._tracer=n,this._recordInflateBytes=i,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=I().zlib.createInflateRaw(C),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(c.VSBuffer.wrap(R))}),p&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(n){this._recordInflateBytes&&this._recordedInflateBytes.push(n.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",n),this._zlibInflate.write(n.buffer)}flush(n){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const i=c.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,n(i)})}}class v extends P.Disposable{constructor(n,i){super(),this._tracer=n,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=I().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",p=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this._onError.fire(p)}),this._zlibDeflate.on("data",p=>{this._tracer.traceSocketEvent("zlibDeflateData",p),this._pendingDeflateData.push(c.VSBuffer.wrap(p))})}write(n){this._tracer.traceSocketEvent("zlibDeflateWrite",n.buffer),this._zlibDeflate.write(n.buffer)}flush(n){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let i=c.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,i=i.slice(0,i.byteLength-4),n(i)})}}function m(d,n){if(n===0)return;const i=d.byteLength>>>2;for(let x=0;x<i;x++){const L=d.readUInt32BE(x*4);d.writeUInt32BE(L^n,x*4)}const p=i*4,C=d.byteLength-p,R=n>>>24&255,M=n>>>16&255,$=n>>>8&255;C>=1&&d.writeUInt8(d.readUInt8(p)^R,p),C>=2&&d.writeUInt8(d.readUInt8(p+1)^M,p+1),C>=3&&d.writeUInt8(d.readUInt8(p+2)^$,p+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const r={[2]:107,[1]:103};function b(){const d=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):n=(0,y.join)(I().os.tmpdir(),`vscode-ipc-${d}.sock`),u(n),n}e.createRandomIPCHandle=b;function s(d,n,i){const p=I().crypto.createHash("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${i}-${n}-sock`;let C;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?C=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${i}-${n}.sock`):C=(0,y.join)(d,`${i}-${n}.sock`),u(C),C}e.createStaticIPCHandle=s;function u(d){const n=r[T.platform];typeof n=="number"&&d.length>=n&&console.warn(`WARNING: IPC handle "${d}" is longer than ${n} chars, try a shorter --user-data-dir`)}class o extends k.IPCServer{static toClientConnectionEvent(n){const i=D.Event.fromNodeEventEmitter(n,"connection");return D.Event.map(i,p=>({protocol:new A.Protocol(new E(p,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(p,"close"))}))}constructor(n){super(o.toClientConnectionEvent(n)),this.server=n}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function l(d){return new Promise((n,i)=>{const p=I().net.createServer();p.on("error",i),p.listen(d,()=>{p.removeListener("error",i),n(new o(p))})})}e.serve=l;function a(d,n){return new Promise((i,p)=>{const C=I().net.createConnection(d,()=>{C.removeListener("error",p),i(A.Client.fromSocket(new E(C,`ipc-client${n}`),n))});C.once("error",p)})}e.connect=a}),define(De[159],Ie([1,0,37,9]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(P,y,T,S,k,A){if(Array.isArray(P)){let I=0;for(const E of P){const _=D(E,y,T,S,k,A);if(_===10)return _;_>I&&(I=_)}return I}else{if(typeof P=="string")return S?P==="*"?5:P===T?10:0:0;if(P){const{language:I,pattern:E,scheme:_,hasAccessToAllModels:w,notebookType:h}=P;if(!S&&!w)return 0;h&&k&&(y=k);let g=0;if(_)if(_===y.scheme)g=10;else if(_==="*")g=5;else return 0;if(I)if(I===T)g=10;else if(I==="*")g=Math.max(g,5);else return 0;if(h)if(h===A)g=10;else if(h==="*"&&A!==void 0)g=Math.max(g,5);else return 0;if(E){let f;if(typeof E=="string"?f=E:f={...E,base:(0,t.normalize)(E.base)},f===y.fsPath||(0,c.match)(f,y.fsPath))g=10;else return 0}return g}else return 0}}e.score=D}),define(De[160],Ie([1,0,8,49,151]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(T,S,k,A){this._uri=T,this._lines=S,this._eol=k,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(T){T.eol&&T.eol!==this._eol&&(this._eol=T.eol,this._lineStarts=null);const S=T.changes;for(const k of S)this._acceptDeleteRange(k.range),this._acceptInsertText(new t.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=T.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const T=this._eol.length,S=this._lines.length,k=new Uint32Array(S);for(let A=0;A<S;A++)k[A]=this._lines[A].length+T;this._lineStarts=new D.PrefixSumComputer(k)}}_setLineText(T,S){this._lines[T]=S,this._lineStarts&&this._lineStarts.setValue(T,this._lines[T].length+this._eol.length)}_acceptDeleteRange(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this._setLineText(T.startLineNumber-1,this._lines[T.startLineNumber-1].substring(0,T.startColumn-1)+this._lines[T.startLineNumber-1].substring(T.endColumn-1));return}this._setLineText(T.startLineNumber-1,this._lines[T.startLineNumber-1].substring(0,T.startColumn-1)+this._lines[T.endLineNumber-1].substring(T.endColumn-1)),this._lines.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}_acceptInsertText(T,S){if(S.length===0)return;const k=(0,c.splitLines)(S);if(k.length===1){this._setLineText(T.lineNumber-1,this._lines[T.lineNumber-1].substring(0,T.column-1)+k[0]+this._lines[T.lineNumber-1].substring(T.column-1));return}k[k.length-1]+=this._lines[T.lineNumber-1].substring(T.column-1),this._setLineText(T.lineNumber-1,this._lines[T.lineNumber-1].substring(0,T.column-1)+k[0]);const A=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(T.lineNumber+I-1,0,k[I]),A[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(T.lineNumber,A)}}e.MirrorTextModel=P}),define(De[161],Ie([1,0,8,148,49,35,104]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(v,m,r,b){this.searchString=v,this.isRegex=m,this.matchCase=r,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=k(this.searchString):v=this.searchString.indexOf(`
`)>=0;let m=null;try{m=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!m)return null;let r=!this.isRegex&&!v;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new y.SearchData(m,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,r?this.searchString:null)}}e.SearchParams=S;function k(f){if(!f||f.length===0)return!1;for(let v=0,m=f.length;v<m;v++){const r=f.charCodeAt(v);if(r===10)return!0;if(r===92){if(v++,v>=m)break;const b=f.charCodeAt(v);if(b===110||b===114||b===87)return!0}}return!1}e.isMultilineRegexSource=k;function A(f,v,m){if(!m)return new y.FindMatch(f,null);const r=[];for(let b=0,s=v.length;b<s;b++)r[b]=v[b];return new y.FindMatch(f,r)}e.createFindMatch=A;class I{constructor(v){const m=[];let r=0;for(let b=0,s=v.length;b<s;b++)v.charCodeAt(b)===10&&(m[r++]=b);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(v){const m=this._lineFeedsOffsets;let r=0,b=m.length-1;if(b===-1||v<=m[0])return 0;for(;r<b;){const s=r+((b-r)/2>>0);m[s]>=v?b=s-1:m[s+1]>=v?(r=s,b=s):r=s+1}return r+1}}class E{static findMatches(v,m,r,b,s){const u=m.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(v,r,new g(u.wordSeparators,u.regex),b,s):this._doFindMatchesLineByLine(v,r,u,b,s):[]}static _getMultilineMatchRange(v,m,r,b,s,u){let o,l=0;b?(l=b.findLineFeedCountBeforeOffset(s),o=m+s+l):o=m+s;let a;if(b){const p=b.findLineFeedCountBeforeOffset(s+u.length)-l;a=o+u.length+p}else a=o+u.length;const d=v.getPositionAt(o),n=v.getPositionAt(a);return new P.Range(d.lineNumber,d.column,n.lineNumber,n.column)}static _doFindMatchesMultiline(v,m,r,b,s){const u=v.getOffsetAt(m.getStartPosition()),o=v.getValueInRange(m,1),l=v.getEOL()===`\r
`?new I(o):null,a=[];let d=0,n;for(r.reset(0);n=r.next(o);)if(a[d++]=A(this._getMultilineMatchRange(v,u,o,l,n.index,n[0]),n,b),d>=s)return a;return a}static _doFindMatchesLineByLine(v,m,r,b,s){const u=[];let o=0;if(m.startLineNumber===m.endLineNumber){const a=v.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return o=this._findMatchesInLine(r,a,m.startLineNumber,m.startColumn-1,o,u,b,s),u}const l=v.getLineContent(m.startLineNumber).substring(m.startColumn-1);o=this._findMatchesInLine(r,l,m.startLineNumber,m.startColumn-1,o,u,b,s);for(let a=m.startLineNumber+1;a<m.endLineNumber&&o<s;a++)o=this._findMatchesInLine(r,v.getLineContent(a),a,0,o,u,b,s);if(o<s){const a=v.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);o=this._findMatchesInLine(r,a,m.endLineNumber,0,o,u,b,s)}return u}static _findMatchesInLine(v,m,r,b,s,u,o,l){const a=v.wordSeparators;if(!o&&v.simpleSearch){const i=v.simpleSearch,p=i.length,C=m.length;let R=-p;for(;(R=m.indexOf(i,R+p))!==-1;)if((!a||h(a,m,C,R,p))&&(u[s++]=new y.FindMatch(new P.Range(r,R+1+b,r,R+1+p+b),null),s>=l))return s;return s}const d=new g(v.wordSeparators,v.regex);let n;d.reset(0);do if(n=d.next(m),n&&(u[s++]=A(new P.Range(r,n.index+1+b,r,n.index+1+n[0].length+b),n,o),s>=l))return s;while(n);return s}static findNextMatch(v,m,r,b){const s=m.parseSearchRequest();if(!s)return null;const u=new g(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(v,r,u,b):this._doFindNextMatchLineByLine(v,r,u,b)}static _doFindNextMatchMultiline(v,m,r,b){const s=new D.Position(m.lineNumber,1),u=v.getOffsetAt(s),o=v.getLineCount(),l=v.getValueInRange(new P.Range(s.lineNumber,s.column,o,v.getLineMaxColumn(o)),1),a=v.getEOL()===`\r
`?new I(l):null;r.reset(m.column-1);const d=r.next(l);return d?A(this._getMultilineMatchRange(v,u,l,a,d.index,d[0]),d,b):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(v,new D.Position(1,1),r,b):null}static _doFindNextMatchLineByLine(v,m,r,b){const s=v.getLineCount(),u=m.lineNumber,o=v.getLineContent(u),l=this._findFirstMatchInLine(r,o,u,m.column,b);if(l)return l;for(let a=1;a<=s;a++){const d=(u+a-1)%s,n=v.getLineContent(d+1),i=this._findFirstMatchInLine(r,n,d+1,1,b);if(i)return i}return null}static _findFirstMatchInLine(v,m,r,b,s){v.reset(b-1);const u=v.next(m);return u?A(new P.Range(r,u.index+1,r,u.index+1+u[0].length),u,s):null}static findPreviousMatch(v,m,r,b){const s=m.parseSearchRequest();if(!s)return null;const u=new g(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(v,r,u,b):this._doFindPreviousMatchLineByLine(v,r,u,b)}static _doFindPreviousMatchMultiline(v,m,r,b){const s=this._doFindMatchesMultiline(v,new P.Range(1,1,m.lineNumber,m.column),r,b,10*T);if(s.length>0)return s[s.length-1];const u=v.getLineCount();return m.lineNumber!==u||m.column!==v.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(v,new D.Position(u,v.getLineMaxColumn(u)),r,b):null}static _doFindPreviousMatchLineByLine(v,m,r,b){const s=v.getLineCount(),u=m.lineNumber,o=v.getLineContent(u).substring(0,m.column-1),l=this._findLastMatchInLine(r,o,u,b);if(l)return l;for(let a=1;a<=s;a++){const d=(s+u-a-1)%s,n=v.getLineContent(d+1),i=this._findLastMatchInLine(r,n,d+1,b);if(i)return i}return null}static _findLastMatchInLine(v,m,r,b){let s=null,u;for(v.reset(0);u=v.next(m);)s=A(new P.Range(r,u.index+1,r,u.index+1+u[0].length),u,b);return s}}e.TextModelSearch=E;function _(f,v,m,r,b){if(r===0)return!0;const s=v.charCodeAt(r-1);if(f.get(s)!==0||s===13||s===10)return!0;if(b>0){const u=v.charCodeAt(r);if(f.get(u)!==0)return!0}return!1}function w(f,v,m,r,b){if(r+b===m)return!0;const s=v.charCodeAt(r+b);if(f.get(s)!==0||s===13||s===10)return!0;if(b>0){const u=v.charCodeAt(r+b-1);if(f.get(u)!==0)return!0}return!1}function h(f,v,m,r,b){return _(f,v,m,r,b)&&w(f,v,m,r,b)}e.isValidMatch=h;class g{constructor(v,m){this._wordSeparators=v,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const m=v.length;let r;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(r=this._searchRegex.exec(v),!r))return null;const b=r.index,s=r[0].length;if(b===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){c.getNextCodePoint(v,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=b,this._prevMatchLength=s,!this._wordSeparators||h(this._wordSeparators,v,m,b,s))return r}while(r);return null}}e.Searcher=g}),define(De[118],Ie([1,0,23,12]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(D||(D={}));function P(I){for(let E=0,_=I.length;E<_;E+=4){const w=I[E+0],h=I[E+1],g=I[E+2],f=I[E+3];I[E+0]=f,I[E+1]=g,I[E+2]=h,I[E+3]=w}}function y(I){const E=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return t.isLittleEndian()||P(E),c.VSBuffer.wrap(E)}function T(I){const E=I.buffer;if(t.isLittleEndian()||P(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const _=new Uint8Array(E.byteLength);return _.set(E),new Uint32Array(_.buffer,_.byteOffset,_.length/4)}}function S(I){const E=new Uint32Array(k(I));let _=0;if(E[_++]=I.id,I.type==="full")E[_++]=1,E[_++]=I.data.length,E.set(I.data,_),_+=I.data.length;else{E[_++]=2,E[_++]=I.deltas.length;for(const w of I.deltas)E[_++]=w.start,E[_++]=w.deleteCount,w.data?(E[_++]=w.data.length,E.set(w.data,_),_+=w.data.length):E[_++]=0}return y(E)}e.encodeSemanticTokensDto=S;function k(I){let E=0;if(E+=1+1,I.type==="full")E+=1+I.data.length;else{E+=1,E+=(1+1+1)*I.deltas.length;for(const _ of I.deltas)_.data&&(E+=_.data.length)}return E}function A(I){const E=T(I);let _=0;const w=E[_++];if(E[_++]===1){const v=E[_++],m=E.subarray(_,_+v);return _+=v,{id:w,type:"full",data:m}}const g=E[_++],f=[];for(let v=0;v<g;v++){const m=E[_++],r=E[_++],b=E[_++];let s;b>0&&(s=E.subarray(_,_+b),_+=b),f[v]={start:m,deleteCount:r,data:s}}return{id:w,type:"delta",deltas:f}}e.decodeSemanticTokensDto=A}),define(De[162],Ie([1,0,4,6]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this._map.set(T,S),this.fire([T]),(0,t.toDisposable)(()=>{this._map.get(T)===S&&(this._map.delete(T),this.fire([T]))})}registerFactory(T,S){this._factories.get(T)?.dispose();const k=new P(this,T,S);return this._factories.set(T,k),(0,t.toDisposable)(()=>{const A=this._factories.get(T);!A||A!==k||(this._factories.delete(T),A.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const k=this._factories.get(T);return!k||k.isResolved?null:(await k.resolve(),this.get(T))}get(T){return this._map.get(T)||null}isResolved(T){if(this.get(T))return!0;const k=this._factories.get(T);return!!(!k||k.isResolved)}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class P extends t.Disposable{get isResolved(){return this._isResolved}constructor(T,S,k){super(),this._registry=T,this._languageId=S,this._factory=k,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const T=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,T&&!this._isDisposed&&this._register(this._registry.register(this._languageId,T))}}}),define(De[66],Ie([1,0,77,2,35,162]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(p,C,R){this._tokenBrand=void 0,this.offset=p,this.type=C,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class T{constructor(p,C){this._tokenizationResultBrand=void 0,this.tokens=p,this.endState=C}}e.TokenizationResult=T;class S{constructor(p,C){this._encodedTokenizationResultBrand=void 0,this.tokens=p,this.endState=C}}e.EncodedTokenizationResult=S;var k;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(k=e.CompletionItemKind||(e.CompletionItemKind={}));var A;(function(i){const p=new Map;p.set(0,c.Codicon.symbolMethod),p.set(1,c.Codicon.symbolFunction),p.set(2,c.Codicon.symbolConstructor),p.set(3,c.Codicon.symbolField),p.set(4,c.Codicon.symbolVariable),p.set(5,c.Codicon.symbolClass),p.set(6,c.Codicon.symbolStruct),p.set(7,c.Codicon.symbolInterface),p.set(8,c.Codicon.symbolModule),p.set(9,c.Codicon.symbolProperty),p.set(10,c.Codicon.symbolEvent),p.set(11,c.Codicon.symbolOperator),p.set(12,c.Codicon.symbolUnit),p.set(13,c.Codicon.symbolValue),p.set(15,c.Codicon.symbolEnum),p.set(14,c.Codicon.symbolConstant),p.set(15,c.Codicon.symbolEnum),p.set(16,c.Codicon.symbolEnumMember),p.set(17,c.Codicon.symbolKeyword),p.set(27,c.Codicon.symbolSnippet),p.set(18,c.Codicon.symbolText),p.set(19,c.Codicon.symbolColor),p.set(20,c.Codicon.symbolFile),p.set(21,c.Codicon.symbolReference),p.set(22,c.Codicon.symbolCustomColor),p.set(23,c.Codicon.symbolFolder),p.set(24,c.Codicon.symbolTypeParameter),p.set(25,c.Codicon.account),p.set(26,c.Codicon.issues);function C($){let x=p.get($);return x||(console.info("No codicon found for CompletionItemKind "+$),x=c.Codicon.symbolProperty),x}i.toIcon=C;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function M($,x){let L=R.get($);return typeof L>"u"&&!x&&(L=9),L}i.fromString=M})(A=e.CompletionItemKinds||(e.CompletionItemKinds={}));var I;(function(i){i[i.Deprecated=1]="Deprecated"})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(i){i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var _;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(i){return i&&t.URI.isUri(i.uri)&&D.Range.isIRange(i.range)&&(D.Range.isIRange(i.originSelectionRange)||D.Range.isIRange(i.targetSelectionRange))}e.isLocationLink=v;var m;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(m=e.SymbolKind||(e.SymbolKind={}));var r;(function(i){i[i.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var b;(function(i){const p=new Map;p.set(0,c.Codicon.symbolFile),p.set(1,c.Codicon.symbolModule),p.set(2,c.Codicon.symbolNamespace),p.set(3,c.Codicon.symbolPackage),p.set(4,c.Codicon.symbolClass),p.set(5,c.Codicon.symbolMethod),p.set(6,c.Codicon.symbolProperty),p.set(7,c.Codicon.symbolField),p.set(8,c.Codicon.symbolConstructor),p.set(9,c.Codicon.symbolEnum),p.set(10,c.Codicon.symbolInterface),p.set(11,c.Codicon.symbolFunction),p.set(12,c.Codicon.symbolVariable),p.set(13,c.Codicon.symbolConstant),p.set(14,c.Codicon.symbolString),p.set(15,c.Codicon.symbolNumber),p.set(16,c.Codicon.symbolBoolean),p.set(17,c.Codicon.symbolArray),p.set(18,c.Codicon.symbolObject),p.set(19,c.Codicon.symbolKey),p.set(20,c.Codicon.symbolNull),p.set(21,c.Codicon.symbolEnumMember),p.set(22,c.Codicon.symbolStruct),p.set(23,c.Codicon.symbolEvent),p.set(24,c.Codicon.symbolOperator),p.set(25,c.Codicon.symbolTypeParameter);function C(R){let M=p.get(R);return M||(console.info("No codicon found for SymbolKind "+R),M=c.Codicon.symbolProperty),M}i.toIcon=C})(b=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(p){this.value=p}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var u;(function(i){function p(C){return!C||typeof C!="object"?!1:typeof C.id=="string"&&typeof C.title=="string"}i.is=p})(u=e.Command||(e.Command={}));var o;(function(i){i[i.Collapsed=0]="Collapsed",i[i.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(i){i[i.Unresolved=0]="Unresolved",i[i.Resolved=1]="Resolved"})(l=e.CommentThreadState||(e.CommentThreadState={}));var a;(function(i){i[i.Editing=0]="Editing",i[i.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var d;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(d=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var n;(function(i){i[i.None=0]="None",i[i.Option=1]="Option",i[i.Default=2]="Default",i[i.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[163],Ie([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(De[119],Ie([1,0,163,12,103,17,24,147]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=k;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(oe,_e,ue,Pe){this.id=oe,this.name=_e,this.defaultValue=ue,this.schema=Pe}applyUpdate(oe,_e){return _(oe,_e)}compute(oe,_e,ue){return ue}}class E{constructor(oe,_e){this.newValue=oe,this.didChange=_e}}e.ApplyUpdateResult=E;function _(re,oe){if(typeof re!="object"||typeof oe!="object"||!re||!oe)return new E(oe,re!==oe);if(Array.isArray(re)||Array.isArray(oe)){const ue=Array.isArray(re)&&Array.isArray(oe)&&P.equals(re,oe);return new E(oe,!ue)}let _e=!1;for(const ue in oe)if(oe.hasOwnProperty(ue)){const Pe=_(re[ue],oe[ue]);Pe.didChange&&(re[ue]=Pe.newValue,_e=!0)}return new E(re,_e)}class w{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,_e){return _(oe,_e)}validate(oe){return this.defaultValue}}class h{constructor(oe,_e,ue,Pe){this.id=oe,this.name=_e,this.defaultValue=ue,this.schema=Pe}applyUpdate(oe,_e){return _(oe,_e)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,_e,ue){return ue}}function g(re,oe){return typeof re>"u"?oe:re==="false"?!1:Boolean(re)}e.boolean=g;class f extends h{constructor(oe,_e,ue,Pe=void 0){typeof Pe<"u"&&(Pe.type="boolean",Pe.default=ue),super(oe,_e,ue,Pe)}validate(oe){return g(oe,this.defaultValue)}}function v(re,oe,_e,ue){if(typeof re>"u")return oe;let Pe=parseInt(re,10);return isNaN(Pe)?oe:(Pe=Math.max(_e,Pe),Pe=Math.min(ue,Pe),Pe|0)}e.clampedInt=v;class m extends h{static clampedInt(oe,_e,ue,Pe){return v(oe,_e,ue,Pe)}constructor(oe,_e,ue,Pe,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="integer",Ne.default=ue,Ne.minimum=Pe,Ne.maximum=Le),super(oe,_e,ue,Ne),this.minimum=Pe,this.maximum=Le}validate(oe){return m.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}class r extends h{static clamp(oe,_e,ue){return oe<_e?_e:oe>ue?ue:oe}static float(oe,_e){if(typeof oe=="number")return oe;if(typeof oe>"u")return _e;const ue=parseFloat(oe);return isNaN(ue)?_e:ue}constructor(oe,_e,ue,Pe,Le){typeof Le<"u"&&(Le.type="number",Le.default=ue),super(oe,_e,ue,Le),this.validationFn=Pe}validate(oe){return this.validationFn(r.float(oe,this.defaultValue))}}class b extends h{static string(oe,_e){return typeof oe!="string"?_e:oe}constructor(oe,_e,ue,Pe=void 0){typeof Pe<"u"&&(Pe.type="string",Pe.default=ue),super(oe,_e,ue,Pe)}validate(oe){return b.string(oe,this.defaultValue)}}function s(re,oe,_e){return typeof re!="string"||_e.indexOf(re)===-1?oe:re}e.stringSet=s;class u extends h{constructor(oe,_e,ue,Pe,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.enum=Pe,Le.default=ue),super(oe,_e,ue,Le),this._allowedValues=Pe}validate(oe){return s(oe,this.defaultValue,this._allowedValues)}}class o extends I{constructor(oe,_e,ue,Pe,Le,Ne,qe=void 0){typeof qe<"u"&&(qe.type="string",qe.enum=Le,qe.default=Pe),super(oe,_e,ue,qe),this._allowedValues=Le,this._convert=Ne}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function l(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,_e,ue){return ue===0?oe.accessibilitySupport:ue}}class d extends I{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:c.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{insertSpace:g(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(re){switch(re){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function R(re){switch(re){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class M extends w{constructor(){super(130)}compute(oe,_e,ue){const Pe=["monaco-editor"];return _e.get(34)&&Pe.push(_e.get(34)),oe.extraEditorClassName&&Pe.push(oe.extraEditorClassName),_e.get(67)==="default"?Pe.push("mouse-default"):_e.get(67)==="copy"&&Pe.push("mouse-copy"),_e.get(101)&&Pe.push("showUnused"),_e.get(128)&&Pe.push("showDeprecated"),Pe.join(" ")}}class $ extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(oe,_e,ue){return ue&&oe.emptySelectionClipboard}}class x extends I{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:c.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:c.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{cursorMoveOnType:g(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":s(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":s(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(_e.loop,this.defaultValue.loop)}}}class L extends I{constructor(){super(46,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?L.OFF:oe==="true"?L.ON:oe:Boolean(oe)?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class B extends w{constructor(){super(45)}compute(oe,_e,ue){return oe.fontInfo}}class O extends h{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(oe){const _e=r.float(oe,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:r.clamp(_e,6,100)}compute(oe,_e,ue){return oe.fontInfo.fontSize}}class z extends I{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(m.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class U extends I{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),..._e},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),..._e},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),..._e},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),..._e},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),..._e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:ue,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:ue,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:ue,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:ue,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:ue,description:c.localize(38,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{multiple:s(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:_e.multipleDefinitions??s(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:_e.multipleTypeDefinitions??s(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:_e.multipleDeclarations??s(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:_e.multipleImplementations??s(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:_e.multipleReferences??s(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class F extends I{constructor(){const oe={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:c.localize(41,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:c.localize(42,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{enabled:g(_e.enabled,this.defaultValue.enabled),delay:m.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:g(_e.sticky,this.defaultValue.sticky),above:g(_e.above,this.defaultValue.above)}}}var V;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class H extends w{constructor(){super(133)}compute(oe,_e,ue){return H.computeLayout(_e,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio})}static computeContainedMinimapLineCount(oe){const _e=oe.height/oe.lineHeight,ue=oe.scrollBeyondLastLine?_e-1:0,Pe=(oe.viewLineCount+ue)/(oe.pixelRatio*oe.height),Le=Math.floor(oe.viewLineCount/Pe);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:ue,desiredRatio:Pe,minimapLineCount:Le}}static _computeMinimapLayout(oe,_e){const ue=oe.outerWidth,Pe=oe.outerHeight,Le=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Le*Pe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Pe};const Ne=_e.stableMinimapLayoutInput,qe=Ne&&oe.outerHeight===Ne.outerHeight&&oe.lineHeight===Ne.lineHeight&&oe.typicalHalfwidthCharacterWidth===Ne.typicalHalfwidthCharacterWidth&&oe.pixelRatio===Ne.pixelRatio&&oe.scrollBeyondLastLine===Ne.scrollBeyondLastLine&&oe.minimap.enabled===Ne.minimap.enabled&&oe.minimap.side===Ne.minimap.side&&oe.minimap.size===Ne.minimap.size&&oe.minimap.showSlider===Ne.minimap.showSlider&&oe.minimap.renderCharacters===Ne.minimap.renderCharacters&&oe.minimap.maxColumn===Ne.minimap.maxColumn&&oe.minimap.scale===Ne.minimap.scale&&oe.verticalScrollbarWidth===Ne.verticalScrollbarWidth&&oe.isViewportWrapping===Ne.isViewportWrapping,Ye=oe.lineHeight,it=oe.typicalHalfwidthCharacterWidth,bt=oe.scrollBeyondLastLine,st=oe.minimap.renderCharacters;let et=Le>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const wt=oe.minimap.maxColumn,St=oe.minimap.size,Ct=oe.minimap.side,ft=oe.verticalScrollbarWidth,Dt=oe.viewLineCount,Ft=oe.remainingWidth,Ut=oe.isViewportWrapping,Xe=st?2:3;let Tt=Math.floor(Le*Pe);const Rt=Tt/Le;let Nt=!1,pt=!1,Ae=Xe*et,Oe=et/Le,Se=1;if(St==="fill"||St==="fit"){const{typicalViewportLineCount:lt,extraLinesBeyondLastLine:It,desiredRatio:vt,minimapLineCount:kt}=H.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:bt,height:Pe,lineHeight:Ye,pixelRatio:Le});if(Dt/kt>1)Nt=!0,pt=!0,et=1,Ae=1,Oe=et/Le;else{let Lt=!1,mt=et+1;if(St==="fit"){const zt=Math.ceil((Dt+It)*Ae);Ut&&qe&&Ft<=_e.stableFitRemainingWidth?(Lt=!0,mt=_e.stableFitMaxMinimapScale):Lt=zt>Tt}if(St==="fill"||Lt){Nt=!0;const zt=et;Ae=Math.min(Ye*Le,Math.max(1,Math.floor(1/vt))),Ut&&qe&&Ft<=_e.stableFitRemainingWidth&&(mt=_e.stableFitMaxMinimapScale),et=Math.min(mt,Math.max(1,Math.floor(Ae/Xe))),et>zt&&(Se=Math.min(2,et/zt)),Oe=et/Le/Se,Tt=Math.ceil(Math.max(lt,Dt+It)*Ae),Ut?(_e.stableMinimapLayoutInput=oe,_e.stableFitRemainingWidth=Ft,_e.stableFitMaxMinimapScale=et):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0)}}}const te=Math.floor(wt*Oe),Fe=Math.min(te,Math.max(0,Math.floor((Ft-ft-2)*Oe/(it+Oe)))+e.MINIMAP_GUTTER_WIDTH);let xe=Math.floor(Le*Fe);const rt=xe/Le;xe=Math.floor(xe*Se);const Ge=st?1:2,ot=Ct==="left"?0:ue-Fe-ft;return{renderMinimap:Ge,minimapLeft:ot,minimapWidth:Fe,minimapHeightIsEditorHeight:Nt,minimapIsSampling:pt,minimapScale:et,minimapLineHeight:Ae,minimapCanvasInnerWidth:xe,minimapCanvasInnerHeight:Tt,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:Rt}}static computeLayout(oe,_e){const ue=_e.outerWidth|0,Pe=_e.outerHeight|0,Le=_e.lineHeight|0,Ne=_e.lineNumbersDigitCount|0,qe=_e.typicalHalfwidthCharacterWidth,Ye=_e.maxDigitWidth,it=_e.pixelRatio,bt=_e.viewLineCount,st=oe.get(125),et=st==="inherit"?oe.get(124):st,wt=et==="inherit"?oe.get(120):et,St=oe.get(123),Ct=_e.isDominatedByLongLines,ft=oe.get(51),Dt=oe.get(61).renderType!==0,Ft=oe.get(62),Ut=oe.get(95),Xe=oe.get(66),Tt=oe.get(93),Rt=Tt.verticalScrollbarSize,Nt=Tt.verticalHasArrows,pt=Tt.arrowSize,Ae=Tt.horizontalScrollbarSize,Oe=oe.get(59),Se=oe.get(38),te=oe.get(100)!=="never";let Fe;if(typeof Oe=="string"&&/^\d+(\.\d+)?ch$/.test(Oe)){const Wt=parseFloat(Oe.substr(0,Oe.length-2));Fe=m.clampedInt(Wt*qe,0,0,1e3)}else Fe=m.clampedInt(Oe,0,0,1e3);Se&&te&&(Fe+=16);let xe=0;if(Dt){const Wt=Math.max(Ne,Ft);xe=Math.round(Wt*Ye)}let rt=0;ft&&(rt=Le);let Ge=0,ot=Ge+rt,lt=ot+xe,It=lt+Fe;const vt=ue-rt-xe-Fe;let kt=!1,_t=!1,Lt=-1;et==="inherit"&&Ct?(kt=!0,_t=!0):wt==="on"||wt==="bounded"?_t=!0:wt==="wordWrapColumn"&&(Lt=St);const mt=H._computeMinimapLayout({outerWidth:ue,outerHeight:Pe,lineHeight:Le,typicalHalfwidthCharacterWidth:qe,pixelRatio:it,scrollBeyondLastLine:Ut,minimap:Xe,verticalScrollbarWidth:Rt,viewLineCount:bt,remainingWidth:vt,isViewportWrapping:_t},_e.memory||new A);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Ge+=mt.minimapWidth,ot+=mt.minimapWidth,lt+=mt.minimapWidth,It+=mt.minimapWidth);const zt=vt-mt.minimapWidth,tn=Math.max(1,Math.floor((zt-Rt-2)/qe)),Et=Nt?pt:0;return _t&&(Lt=Math.max(1,tn),wt==="bounded"&&(Lt=Math.min(Lt,St))),{width:ue,height:Pe,glyphMarginLeft:Ge,glyphMarginWidth:rt,lineNumbersLeft:ot,lineNumbersWidth:xe,decorationsLeft:lt,decorationsWidth:Fe,contentLeft:It,contentWidth:zt,minimap:mt,viewportColumn:tn,isWordWrapMinified:kt,isViewportWrapping:_t,wrappingColumn:Lt,verticalScrollbarWidth:Rt,horizontalScrollbarHeight:Ae,overviewRuler:{top:Et,width:Rt,height:Pe-2*Et,right:0}}}}e.EditorLayoutInfoComputer=H;class Q extends I{constructor(){super(127,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(43,null),c.localize(44,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(45,null)}})}validate(oe){return s(oe,"simple",["simple","advanced"])}compute(oe,_e,ue){return _e.get(2)===2?"advanced":ue}}class K extends I{constructor(){const oe={enabled:!0};super(58,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:c.localize(46,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:g(oe.enabled,this.defaultValue.enabled)}}}class de extends I{constructor(){const oe={enabled:!1,maxLineCount:5};super(105,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:c.localize(47,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:10,description:c.localize(48,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{enabled:g(_e.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(_e.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class ee extends I{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:c.localize(49,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(50,null),c.localize(51,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(52,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(53,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:c.localize(54,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:c.localize(55,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:c.localize(56,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return typeof _e.enabled=="boolean"&&(_e.enabled=_e.enabled?"on":"off"),{enabled:s(_e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(_e.fontFamily,this.defaultValue.fontFamily),padding:g(_e.padding,this.defaultValue.padding)}}}class fe extends r{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>r.clamp(oe,0,150),{markdownDescription:c.localize(57,null)})}compute(oe,_e,ue){return oe.fontInfo.lineHeight}}class Y extends I{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:c.localize(58,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:c.localize(59,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)],default:oe.size,description:c.localize(63,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:c.localize(64,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:c.localize(65,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(66,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:c.localize(67,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:c.localize(68,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{enabled:g(_e.enabled,this.defaultValue.enabled),autohide:g(_e.autohide,this.defaultValue.autohide),size:s(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(_e.side,this.defaultValue.side,["right","left"]),showSlider:s(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(_e.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(_e.scale,1,1,3),maxColumn:m.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(re){return re==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ee extends I{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(69,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(70,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{top:m.clampedInt(_e.top,0,0,1e3),bottom:m.clampedInt(_e.bottom,0,0,1e3)}}}class ke extends I{constructor(){const oe={enabled:!0,cycle:!1};super(77,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:c.localize(71,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:c.localize(72,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{enabled:g(_e.enabled,this.defaultValue.enabled),cycle:g(_e.cycle,this.defaultValue.cycle)}}}class Re extends w{constructor(){super(131)}compute(oe,_e,ue){return oe.pixelRatio}}class ze extends I{constructor(){const oe={other:"on",comments:"off",strings:"off"},_e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(73,null),c.localize(74,null),c.localize(75,null)]}];super(80,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:_e,default:oe.strings,description:c.localize(76,null)},comments:{anyOf:_e,default:oe.comments,description:c.localize(77,null)},other:{anyOf:_e,default:oe.other,description:c.localize(78,null)}},default:oe,markdownDescription:c.localize(79,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const it=oe?"on":"off";return{comments:it,strings:it,other:it}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:_e,comments:ue,strings:Pe}=oe,Le=["on","inline","off"];let Ne,qe,Ye;return typeof _e=="boolean"?Ne=_e?"on":"off":Ne=s(_e,this.defaultValue.other,Le),typeof ue=="boolean"?qe=ue?"on":"off":qe=s(ue,this.defaultValue.comments,Le),typeof Pe=="boolean"?Ye=Pe?"on":"off":Ye=s(Pe,this.defaultValue.strings,Le),{other:Ne,comments:qe,strings:Ye}}}var ie;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ce extends I{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(80,null),c.localize(81,null),c.localize(82,null),c.localize(83,null)],default:"on",description:c.localize(84,null)})}validate(oe){let _e=this.defaultValue.renderType,ue=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(_e=4,ue=oe):oe==="interval"?_e=3:oe==="relative"?_e=2:oe==="on"?_e=1:_e=0),{renderType:_e,renderFn:ue}}}function me(re){const oe=re.get(88);return oe==="editable"?re.get(82):oe!=="on"}e.filterValidationDecorations=me;class J extends I{constructor(){const oe=[],_e={type:"number",description:c.localize(85,null)};super(92,"rulers",oe,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:c.localize(86,null),format:"color-hex"}}}]},default:oe,description:c.localize(87,null)})}validate(oe){if(Array.isArray(oe)){const _e=[];for(const ue of oe)if(typeof ue=="number")_e.push({column:m.clampedInt(ue,0,0,1e4),color:null});else if(ue&&typeof ue=="object"){const Pe=ue;_e.push({column:m.clampedInt(Pe.column,0,0,1e4),color:Pe.color})}return _e.sort((ue,Pe)=>ue.column-Pe.column),_e}return this.defaultValue}}function ae(re,oe){if(typeof re!="string")return oe;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class ne extends I{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(88,null),c.localize(89,null),c.localize(90,null)],default:"auto",description:c.localize(91,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(92,null),c.localize(93,null),c.localize(94,null)],default:"auto",description:c.localize(95,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:c.localize(96,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:c.localize(97,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:c.localize(98,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe,ue=m.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Pe=m.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(_e.vertical,this.defaultValue.vertical),horizontal:ae(_e.horizontal,this.defaultValue.horizontal),useShadows:g(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ue,horizontalSliderSize:m.clampedInt(_e.horizontalSliderSize,ue,0,1e3),verticalScrollbarSize:Pe,verticalSliderSize:m.clampedInt(_e.verticalSliderSize,Pe,0,1e3),scrollByPage:g(_e.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class se extends I{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:c.localize(99,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:c.localize(100,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:c.localize(101,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:c.localize(104,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:c.localize(105,null)}})}applyUpdate(oe,_e){let ue=!1;_e.allowedCharacters&&oe&&(y.equals(oe.allowedCharacters,_e.allowedCharacters)||(oe={...oe,allowedCharacters:_e.allowedCharacters},ue=!0)),_e.allowedLocales&&oe&&(y.equals(oe.allowedLocales,_e.allowedLocales)||(oe={...oe,allowedLocales:_e.allowedLocales},ue=!0));const Pe=super.applyUpdate(oe,_e);return ue?new E(Pe.newValue,!0):Pe}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{nonBasicASCII:X(_e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(_e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(_e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:X(_e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:X(_e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,_e){if(typeof oe!="object"||!oe)return _e;const ue={};for(const[Pe,Le]of Object.entries(oe))Le===!0&&(ue[Pe]=!0);return ue}}class N extends I{constructor(){const oe={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:c.localize(106,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{enabled:g(_e.enabled,this.defaultValue.enabled),mode:s(_e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class j extends I{constructor(){const oe={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:c.localize(107,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:c.localize(108,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{enabled:g(_e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(_e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class G extends I{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(109,null),c.localize(110,null),c.localize(111,null)],default:oe.bracketPairs,description:c.localize(112,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(113,null),c.localize(114,null),c.localize(115,null)],default:oe.bracketPairsHorizontal,description:c.localize(116,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:c.localize(117,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:c.localize(118,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(119,null),c.localize(120,null),c.localize(121,null)],default:oe.highlightActiveIndentation,description:c.localize(122,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{bracketPairs:X(_e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:X(_e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(_e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(_e.indentation,this.defaultValue.indentation),highlightActiveIndentation:X(_e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function X(re,oe,_e){const ue=_e.indexOf(re);return ue===-1?oe:_e[ue]}class ge extends I{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(123,null),c.localize(124,null)],default:oe.insertMode,description:c.localize(125,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:c.localize(126,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:c.localize(127,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:c.localize(128,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:c.localize(129,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:c.localize(130,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:c.localize(131,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:c.localize(132,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:c.localize(133,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(134,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(135,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(136,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(137,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(138,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(139,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(140,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(141,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(142,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(143,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(145,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(146,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const _e=oe;return{insertMode:s(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(_e.showIcons,this.defaultValue.showIcons),showStatusBar:g(_e.showStatusBar,this.defaultValue.showStatusBar),preview:g(_e.preview,this.defaultValue.preview),previewMode:s(_e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(_e.showMethods,this.defaultValue.showMethods),showFunctions:g(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:g(_e.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(_e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(_e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(_e.showFields,this.defaultValue.showFields),showVariables:g(_e.showVariables,this.defaultValue.showVariables),showClasses:g(_e.showClasses,this.defaultValue.showClasses),showStructs:g(_e.showStructs,this.defaultValue.showStructs),showInterfaces:g(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:g(_e.showModules,this.defaultValue.showModules),showProperties:g(_e.showProperties,this.defaultValue.showProperties),showEvents:g(_e.showEvents,this.defaultValue.showEvents),showOperators:g(_e.showOperators,this.defaultValue.showOperators),showUnits:g(_e.showUnits,this.defaultValue.showUnits),showValues:g(_e.showValues,this.defaultValue.showValues),showConstants:g(_e.showConstants,this.defaultValue.showConstants),showEnums:g(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:g(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(_e.showKeywords,this.defaultValue.showKeywords),showWords:g(_e.showWords,this.defaultValue.showWords),showColors:g(_e.showColors,this.defaultValue.showColors),showFiles:g(_e.showFiles,this.defaultValue.showFiles),showReferences:g(_e.showReferences,this.defaultValue.showReferences),showFolders:g(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:g(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(_e.showSnippets,this.defaultValue.showSnippets),showUsers:g(_e.showUsers,this.defaultValue.showUsers),showIssues:g(_e.showIssues,this.defaultValue.showIssues)}}}class be extends I{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(166,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class le extends w{constructor(){super(132)}compute(oe,_e,ue){return _e.get(82)?!0:oe.tabFocusMode}}var ye;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(ye=e.WrappingIndent||(e.WrappingIndent={}));class Ce extends I{constructor(){super(126,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(167,null),c.localize(168,null),c.localize(169,null),c.localize(170,null)],description:c.localize(171,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,_e,ue){return _e.get(2)===2?0:ue}}class We extends w{constructor(){super(134)}compute(oe,_e,ue){const Pe=_e.get(133);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:Pe.isWordWrapMinified,isViewportWrapping:Pe.isViewportWrapping,wrappingColumn:Pe.wrappingColumn}}}class je extends I{constructor(){const oe={enabled:!0};super(32,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:c.localize(172,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:g(oe.enabled,this.defaultValue.enabled)}}}const Je="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",Ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Qe:t.isLinux?Ze:Je,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(re){return e.editorOptionsRegistry[re.id]=re,re}var ut;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.autoClosingBrackets=5]="autoClosingBrackets",re[re.autoClosingDelete=6]="autoClosingDelete",re[re.autoClosingOvertype=7]="autoClosingOvertype",re[re.autoClosingQuotes=8]="autoClosingQuotes",re[re.autoIndent=9]="autoIndent",re[re.automaticLayout=10]="automaticLayout",re[re.autoSurround=11]="autoSurround",re[re.bracketPairColorization=12]="bracketPairColorization",re[re.guides=13]="guides",re[re.codeLens=14]="codeLens",re[re.codeLensFontFamily=15]="codeLensFontFamily",re[re.codeLensFontSize=16]="codeLensFontSize",re[re.colorDecorators=17]="colorDecorators",re[re.columnSelection=18]="columnSelection",re[re.comments=19]="comments",re[re.contextmenu=20]="contextmenu",re[re.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",re[re.cursorBlinking=22]="cursorBlinking",re[re.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",re[re.cursorStyle=24]="cursorStyle",re[re.cursorSurroundingLines=25]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",re[re.cursorWidth=27]="cursorWidth",re[re.disableLayerHinting=28]="disableLayerHinting",re[re.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",re[re.domReadOnly=30]="domReadOnly",re[re.dragAndDrop=31]="dragAndDrop",re[re.dropIntoEditor=32]="dropIntoEditor",re[re.emptySelectionClipboard=33]="emptySelectionClipboard",re[re.extraEditorClassName=34]="extraEditorClassName",re[re.fastScrollSensitivity=35]="fastScrollSensitivity",re[re.find=36]="find",re[re.fixedOverflowWidgets=37]="fixedOverflowWidgets",re[re.folding=38]="folding",re[re.foldingStrategy=39]="foldingStrategy",re[re.foldingHighlight=40]="foldingHighlight",re[re.foldingImportsByDefault=41]="foldingImportsByDefault",re[re.foldingMaximumRegions=42]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=44]="fontFamily",re[re.fontInfo=45]="fontInfo",re[re.fontLigatures=46]="fontLigatures",re[re.fontSize=47]="fontSize",re[re.fontWeight=48]="fontWeight",re[re.formatOnPaste=49]="formatOnPaste",re[re.formatOnType=50]="formatOnType",re[re.glyphMargin=51]="glyphMargin",re[re.gotoLocation=52]="gotoLocation",re[re.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",re[re.hover=54]="hover",re[re.inDiffEditor=55]="inDiffEditor",re[re.inlineSuggest=56]="inlineSuggest",re[re.letterSpacing=57]="letterSpacing",re[re.lightbulb=58]="lightbulb",re[re.lineDecorationsWidth=59]="lineDecorationsWidth",re[re.lineHeight=60]="lineHeight",re[re.lineNumbers=61]="lineNumbers",re[re.lineNumbersMinChars=62]="lineNumbersMinChars",re[re.linkedEditing=63]="linkedEditing",re[re.links=64]="links",re[re.matchBrackets=65]="matchBrackets",re[re.minimap=66]="minimap",re[re.mouseStyle=67]="mouseStyle",re[re.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=69]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",re[re.multiCursorModifier=71]="multiCursorModifier",re[re.multiCursorPaste=72]="multiCursorPaste",re[re.occurrencesHighlight=73]="occurrencesHighlight",re[re.overviewRulerBorder=74]="overviewRulerBorder",re[re.overviewRulerLanes=75]="overviewRulerLanes",re[re.padding=76]="padding",re[re.parameterHints=77]="parameterHints",re[re.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",re[re.quickSuggestions=80]="quickSuggestions",re[re.quickSuggestionsDelay=81]="quickSuggestionsDelay",re[re.readOnly=82]="readOnly",re[re.renameOnType=83]="renameOnType",re[re.renderControlCharacters=84]="renderControlCharacters",re[re.renderFinalNewline=85]="renderFinalNewline",re[re.renderLineHighlight=86]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=88]="renderValidationDecorations",re[re.renderWhitespace=89]="renderWhitespace",re[re.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",re[re.roundedSelection=91]="roundedSelection",re[re.rulers=92]="rulers",re[re.scrollbar=93]="scrollbar",re[re.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=95]="scrollBeyondLastLine",re[re.scrollPredominantAxis=96]="scrollPredominantAxis",re[re.selectionClipboard=97]="selectionClipboard",re[re.selectionHighlight=98]="selectionHighlight",re[re.selectOnLineNumbers=99]="selectOnLineNumbers",re[re.showFoldingControls=100]="showFoldingControls",re[re.showUnused=101]="showUnused",re[re.snippetSuggestions=102]="snippetSuggestions",re[re.smartSelect=103]="smartSelect",re[re.smoothScrolling=104]="smoothScrolling",re[re.stickyScroll=105]="stickyScroll",re[re.stickyTabStops=106]="stickyTabStops",re[re.stopRenderingLineAfter=107]="stopRenderingLineAfter",re[re.suggest=108]="suggest",re[re.suggestFontSize=109]="suggestFontSize",re[re.suggestLineHeight=110]="suggestLineHeight",re[re.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",re[re.suggestSelection=112]="suggestSelection",re[re.tabCompletion=113]="tabCompletion",re[re.tabIndex=114]="tabIndex",re[re.unicodeHighlighting=115]="unicodeHighlighting",re[re.unusualLineTerminators=116]="unusualLineTerminators",re[re.useShadowDOM=117]="useShadowDOM",re[re.useTabStops=118]="useTabStops",re[re.wordSeparators=119]="wordSeparators",re[re.wordWrap=120]="wordWrap",re[re.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=123]="wordWrapColumn",re[re.wordWrapOverride1=124]="wordWrapOverride1",re[re.wordWrapOverride2=125]="wordWrapOverride2",re[re.wrappingIndent=126]="wrappingIndent",re[re.wrappingStrategy=127]="wrappingStrategy",re[re.showDeprecated=128]="showDeprecated",re[re.inlayHints=129]="inlayHints",re[re.editorClassName=130]="editorClassName",re[re.pixelRatio=131]="pixelRatio",re[re.tabFocusMode=132]="tabFocusMode",re[re.layoutInfo=133]="layoutInfo",re[re.wrappingInfo=134]="wrappingInfo"})(ut=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(173,null)})),acceptSuggestionOnEnter:Be(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(174,null),""],markdownDescription:c.localize(175,null)})),accessibilitySupport:Be(new a),accessibilityPageSize:Be(new m(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(176,null),tags:["accessibility"]})),ariaLabel:Be(new b(4,"ariaLabel",c.localize(177,null))),autoClosingBrackets:Be(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(178,null),c.localize(179,null),""],description:c.localize(180,null)})),autoClosingDelete:Be(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(181,null),""],description:c.localize(182,null)})),autoClosingOvertype:Be(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(183,null),""],description:c.localize(184,null)})),autoClosingQuotes:Be(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(185,null),c.localize(186,null),""],description:c.localize(187,null)})),autoIndent:Be(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[c.localize(188,null),c.localize(189,null),c.localize(190,null),c.localize(191,null),c.localize(192,null)],description:c.localize(193,null)})),automaticLayout:Be(new f(10,"automaticLayout",!1)),autoSurround:Be(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(194,null),c.localize(195,null),c.localize(196,null),""],description:c.localize(197,null)})),bracketPairColorization:Be(new j),bracketPairGuides:Be(new G),stickyTabStops:Be(new f(106,"stickyTabStops",!1,{description:c.localize(198,null)})),codeLens:Be(new f(14,"codeLens",!0,{description:c.localize(199,null)})),codeLensFontFamily:Be(new b(15,"codeLensFontFamily","",{description:c.localize(200,null)})),codeLensFontSize:Be(new m(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(201,null)})),colorDecorators:Be(new f(17,"colorDecorators",!0,{description:c.localize(202,null)})),columnSelection:Be(new f(18,"columnSelection",!1,{description:c.localize(203,null)})),comments:Be(new d),contextmenu:Be(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new f(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(204,null)})),cursorBlinking:Be(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:c.localize(205,null)})),cursorSmoothCaretAnimation:Be(new f(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(206,null)})),cursorStyle:Be(new o(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:c.localize(207,null)})),cursorSurroundingLines:Be(new m(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(208,null)})),cursorSurroundingLinesStyle:Be(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(209,null),c.localize(210,null)],description:c.localize(211,null)})),cursorWidth:Be(new m(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(212,null)})),disableLayerHinting:Be(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new f(30,"domReadOnly",!1)),dragAndDrop:Be(new f(31,"dragAndDrop",!0,{description:c.localize(213,null)})),emptySelectionClipboard:Be(new $),dropIntoEditor:Be(new je),stickyScroll:Be(new de),extraEditorClassName:Be(new b(34,"extraEditorClassName","")),fastScrollSensitivity:Be(new r(35,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:c.localize(214,null)})),find:Be(new x),fixedOverflowWidgets:Be(new f(37,"fixedOverflowWidgets",!1)),folding:Be(new f(38,"folding",!0,{description:c.localize(215,null)})),foldingStrategy:Be(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(216,null),c.localize(217,null)],description:c.localize(218,null)})),foldingHighlight:Be(new f(40,"foldingHighlight",!0,{description:c.localize(219,null)})),foldingImportsByDefault:Be(new f(41,"foldingImportsByDefault",!1,{description:c.localize(220,null)})),foldingMaximumRegions:Be(new m(42,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(221,null)})),unfoldOnClickAfterEndOfLine:Be(new f(43,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(222,null)})),fontFamily:Be(new b(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(223,null)})),fontInfo:Be(new B),fontLigatures2:Be(new L),fontSize:Be(new O),fontWeight:Be(new z),formatOnPaste:Be(new f(49,"formatOnPaste",!1,{description:c.localize(224,null)})),formatOnType:Be(new f(50,"formatOnType",!1,{description:c.localize(225,null)})),glyphMargin:Be(new f(51,"glyphMargin",!0,{description:c.localize(226,null)})),gotoLocation:Be(new U),hideCursorInOverviewRuler:Be(new f(53,"hideCursorInOverviewRuler",!1,{description:c.localize(227,null)})),hover:Be(new F),inDiffEditor:Be(new f(55,"inDiffEditor",!1)),letterSpacing:Be(new r(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>r.clamp(re,-5,20),{description:c.localize(228,null)})),lightbulb:Be(new K),lineDecorationsWidth:Be(new h(59,"lineDecorationsWidth",10)),lineHeight:Be(new fe),lineNumbers:Be(new ce),lineNumbersMinChars:Be(new m(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new f(63,"linkedEditing",!1,{description:c.localize(229,null)})),links:Be(new f(64,"links",!0,{description:c.localize(230,null)})),matchBrackets:Be(new u(65,"matchBrackets","always",["always","near","never"],{description:c.localize(231,null)})),minimap:Be(new Y),mouseStyle:Be(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new r(68,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:c.localize(232,null)})),mouseWheelZoom:Be(new f(69,"mouseWheelZoom",!1,{markdownDescription:c.localize(233,null)})),multiCursorMergeOverlapping:Be(new f(70,"multiCursorMergeOverlapping",!0,{description:c.localize(234,null)})),multiCursorModifier:Be(new o(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[c.localize(235,null),c.localize(236,null)],markdownDescription:c.localize(237,null)})),multiCursorPaste:Be(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(238,null),c.localize(239,null)],markdownDescription:c.localize(240,null)})),occurrencesHighlight:Be(new f(73,"occurrencesHighlight",!0,{description:c.localize(241,null)})),overviewRulerBorder:Be(new f(74,"overviewRulerBorder",!0,{description:c.localize(242,null)})),overviewRulerLanes:Be(new m(75,"overviewRulerLanes",3,0,3)),padding:Be(new Ee),parameterHints:Be(new ke),peekWidgetDefaultFocus:Be(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(243,null),c.localize(244,null)],description:c.localize(245,null)})),definitionLinkOpensInPeek:Be(new f(79,"definitionLinkOpensInPeek",!1,{description:c.localize(246,null)})),quickSuggestions:Be(new ze),quickSuggestionsDelay:Be(new m(81,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(247,null)})),readOnly:Be(new f(82,"readOnly",!1)),renameOnType:Be(new f(83,"renameOnType",!1,{description:c.localize(248,null),markdownDeprecationMessage:c.localize(249,null)})),renderControlCharacters:Be(new f(84,"renderControlCharacters",!0,{description:c.localize(250,null),restricted:!0})),renderFinalNewline:Be(new f(85,"renderFinalNewline",!0,{description:c.localize(251,null)})),renderLineHighlight:Be(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(252,null)],description:c.localize(253,null)})),renderLineHighlightOnlyWhenFocus:Be(new f(87,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(254,null)})),renderValidationDecorations:Be(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(255,null),c.localize(256,null),c.localize(257,null),""],description:c.localize(258,null)})),revealHorizontalRightPadding:Be(new m(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new f(91,"roundedSelection",!0,{description:c.localize(259,null)})),rulers:Be(new J),scrollbar:Be(new ne),scrollBeyondLastColumn:Be(new m(94,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(260,null)})),scrollBeyondLastLine:Be(new f(95,"scrollBeyondLastLine",!0,{description:c.localize(261,null)})),scrollPredominantAxis:Be(new f(96,"scrollPredominantAxis",!0,{description:c.localize(262,null)})),selectionClipboard:Be(new f(97,"selectionClipboard",!0,{description:c.localize(263,null),included:t.isLinux})),selectionHighlight:Be(new f(98,"selectionHighlight",!0,{description:c.localize(264,null)})),selectOnLineNumbers:Be(new f(99,"selectOnLineNumbers",!0)),showFoldingControls:Be(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(265,null),c.localize(266,null),c.localize(267,null)],description:c.localize(268,null)})),showUnused:Be(new f(101,"showUnused",!0,{description:c.localize(269,null)})),showDeprecated:Be(new f(128,"showDeprecated",!0,{description:c.localize(270,null)})),inlayHints:Be(new ee),snippetSuggestions:Be(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(271,null),c.localize(272,null),c.localize(273,null),c.localize(274,null)],description:c.localize(275,null)})),smartSelect:Be(new be),smoothScrolling:Be(new f(104,"smoothScrolling",!1,{description:c.localize(276,null)})),stopRenderingLineAfter:Be(new m(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new ge),inlineSuggest:Be(new N),suggestFontSize:Be(new m(109,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(277,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new m(110,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(278,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new f(111,"suggestOnTriggerCharacters",!0,{description:c.localize(279,null)})),suggestSelection:Be(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(280,null),c.localize(281,null),c.localize(282,null)],description:c.localize(283,null)})),tabCompletion:Be(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(284,null),c.localize(285,null),c.localize(286,null)],description:c.localize(287,null)})),tabIndex:Be(new m(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new se),unusualLineTerminators:Be(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(288,null),c.localize(289,null),c.localize(290,null)],description:c.localize(291,null)})),useShadowDOM:Be(new f(117,"useShadowDOM",!0)),useTabStops:Be(new f(118,"useTabStops",!0,{description:c.localize(292,null)})),wordSeparators:Be(new b(119,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:c.localize(293,null)})),wordWrap:Be(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null),c.localize(296,null),c.localize(297,null)],description:c.localize(298,null)})),wordWrapBreakAfterCharacters:Be(new b(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new b(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new m(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(299,null)})),wordWrapOverride1:Be(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new M),pixelRatio:Be(new Re),tabFocusMode:Be(new le),layoutInfo:Be(new H),wrappingInfo:Be(new We),wrappingIndent:Be(new Ce),wrappingStrategy:Be(new Q)}}),define(De[164],Ie([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[165],Ie([19,20]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[166],Ie([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[167],Ie([19,20]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[168],Ie([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(De[169],Ie([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(De[170],Ie([19,20]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(De[171],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[172],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[173],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(De[174],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[175],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[176],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[177],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[178],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[179],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[180],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(De[181],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[182],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[183],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[184],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[185],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[186],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[187],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[188],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[189],Ie([1,0,22,42,166,308]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(f){return f=f.trim(),f==="*"||y.test(f)}e.isValidVersionStr=S;function k(f){if(!S(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=f.match(y);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function A(f){if(!f)return null;const v=f.majorBase,m=f.majorMustEqual,r=f.minorBase;let b=f.minorMustEqual;const s=f.patchBase;let u=f.patchMustEqual;f.hasCaret&&(v===0||(b=!1),u=!1);let o=0;if(f.preRelease){const l=T.exec(f.preRelease);if(l){const[,a,d,n]=l;o=Date.UTC(Number(a),Number(d)-1,Number(n))}}return{majorBase:v,majorMustEqual:m,minorBase:r,minorMustEqual:b,patchBase:s,patchMustEqual:u,isMinimum:f.hasGreaterEquals,notBefore:o}}e.normalizeVersion=A;function I(f,v,m){let r;typeof f=="string"?r=A(k(f)):r=f;let b;v instanceof Date?b=v.getTime():typeof v=="string"&&(b=new Date(v).getTime());let s;if(typeof m=="string"?s=A(k(m)):s=m,!r||!s)return!1;const u=r.majorBase,o=r.minorBase,l=r.patchBase;let a=s.majorBase,d=s.minorBase,n=s.patchBase;const i=s.notBefore;let p=s.majorMustEqual,C=s.minorMustEqual,R=s.patchMustEqual;return s.isMinimum?u>a?!0:u<a?!1:o>d?!0:o<d||b&&b<i?!1:l>=n:(u===1&&a===0&&(!p||!C||!R)&&(a=1,d=0,n=0,p=!0,C=!1,R=!1),u<a?!1:u>a?!p:o<d?!1:o>d?!C:l<n?!1:l>n?!R:!(b&&b<i))}e.isValidVersion=I;function E(f,v,m,r,b){const s=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return s.push([t.default.Error,D.localize(0,null)]),s;if(typeof r.name!="string")return s.push([t.default.Error,D.localize(1,null,"name")]),s;if(typeof r.version!="string")return s.push([t.default.Error,D.localize(2,null,"version")]),s;if(!r.engines)return s.push([t.default.Error,D.localize(3,null,"engines")]),s;if(typeof r.engines.vscode!="string")return s.push([t.default.Error,D.localize(4,null,"engines.vscode")]),s;if(typeof r.extensionDependencies<"u"&&!g(r.extensionDependencies))return s.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),s;if(typeof r.activationEvents<"u"){if(!g(r.activationEvents))return s.push([t.default.Error,D.localize(6,null,"activationEvents")]),s;if(typeof r.main>"u"&&typeof r.browser>"u")return s.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),s}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&s.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return s.push([t.default.Error,D.localize(9,null,"main")]),s;{const l=(0,c.joinPath)(m,r.main);(0,c.isEqualOrParent)(l,m)||s.push([t.default.Warning,D.localize(10,null,l.path,m.path)])}if(typeof r.activationEvents>"u")return s.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),s}if(typeof r.browser<"u"){if(typeof r.browser!="string")return s.push([t.default.Error,D.localize(12,null,"browser")]),s;{const l=(0,c.joinPath)(m,r.browser);(0,c.isEqualOrParent)(l,m)||s.push([t.default.Warning,D.localize(13,null,l.path,m.path)])}if(typeof r.activationEvents>"u")return s.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),s}if(!P.valid(r.version))return s.push([t.default.Error,D.localize(15,null)]),s;const u=[];if(!_(f,v,r,b,u))for(const l of u)s.push([t.default.Error,l]);return s}e.validateExtensionManifest=E;function _(f,v,m,r,b){return r||typeof m.main>"u"&&typeof m.browser>"u"?!0:h(f,v,m.engines.vscode,b)}e.isValidExtensionVersion=_;function w(f,v,m){return f==="*"||h(v,m,f)}e.isEngineValid=w;function h(f,v,m,r=[]){const b=A(k(m));if(!b)return r.push(D.localize(16,null,m)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return r.push(D.localize(17,null,m)),!1}else if(!b.majorMustEqual)return r.push(D.localize(18,null,m)),!1;return I(f,v,b)?!0:(r.push(D.localize(19,null,f,m)),!1)}function g(f){if(!Array.isArray(f))return!1;for(let v=0,m=f.length;v<m;v++)if(typeof f[v]!="string")return!1;return!0}}),define(De[120],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(D,P=[],y=!1){this.ctor=D,this.staticArguments=P,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=c}),define(De[84],Ie([1,0,120]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var D;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function P(T,S,k){S instanceof c.SyncDescriptor||(S=new c.SyncDescriptor(S,[],Boolean(k))),t.push([T,S])}e.registerSingleton=P;function y(){return t}e.getSingletonServiceDescriptors=y}),define(De[190],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(P,y){this.key=P,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const y of this._nodes.values())y.outgoing.size===0&&P.push(y);return P}insertEdge(P,y){const T=this.lookupOrInsertNode(P),S=this.lookupOrInsertNode(y);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(P){const y=this._hashFn(P);this._nodes.delete(y);for(const T of this._nodes.values())T.outgoing.delete(y),T.incoming.delete(y)}lookupOrInsertNode(P){const y=this._hashFn(P);let T=this._nodes.get(y);return T||(T=new c(y,P),this._nodes.set(y,T)),T}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[y,T]of this._nodes)P.push(`${y}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,y]of this._nodes){const T=new Set([P]),S=this._findCycle(y,T);if(S)return S}}_findCycle(P,y){for(const[T,S]of P.outgoing){if(y.has(T))return[...y,T].join(" -> ");y.add(T);const k=this._findCycle(S,y);if(k)return k;y.delete(T)}}}e.Graph=t}),define(De[3],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=T})(c=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(y,T,S){T[c.DI_TARGET]===T?T[c.DI_DEPENDENCIES].push({id:y,index:S}):(T[c.DI_DEPENDENCIES]=[{id:y,index:S}],T[c.DI_TARGET]=T)}function D(y){if(c.serviceIds.has(y))return c.serviceIds.get(y);const T=function(S,k,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(T,S,A)};return T.toString=()=>y,c.serviceIds.set(y,T),T}e.createDecorator=D;function P(y){return y}e.refineServiceDecorator=P}),define(De[52],Ie([1,0,11,2,3]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function P(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=P;function y(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=y;var T;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function k(f,v){const m=Object.create(null);for(const r in f)A(m,r,f[r],v);return m}e.toValuesTree=k;function A(f,v,m,r){const b=v.split("."),s=b.pop();let u=f;for(let o=0;o<b.length;o++){const l=b[o];let a=u[l];switch(typeof a){case"undefined":a=u[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${v} as ${b.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}u=a}if(typeof u=="object"&&u!==null)try{u[s]=m}catch{r(`Ignoring ${v} as ${b.join(".")} is ${JSON.stringify(u)}`)}else r(`Ignoring ${v} as ${b.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=A;function I(f,v){const m=v.split(".");E(f,m)}e.removeFromValueTree=I;function E(f,v){const m=v.shift();if(v.length===0){delete f[m];return}if(Object.keys(f).indexOf(m)!==-1){const r=f[m];typeof r=="object"&&!Array.isArray(r)&&(E(r,v),Object.keys(r).length===0&&delete f[m])}}function _(f,v,m){function r(u,o){let l=u;for(const a of o){if(typeof l!="object"||l===null)return;l=l[a]}return l}const b=v.split("."),s=r(f,b);return typeof s>"u"?m:s}e.getConfigurationValue=_;function w(f,v,m){Object.keys(v).forEach(r=>{r!=="__proto__"&&(r in f?c.isObject(f[r])&&c.isObject(v[r])?w(f[r],v[r],m):m&&(f[r]=v[r]):f[r]=v[r])})}e.merge=w;function h(f,v,m){const r=f.inspect(v),b=f.inspect(m);return typeof r.userValue<"u"||typeof r.workspaceValue<"u"||typeof r.workspaceFolderValue<"u"?r.value:typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:r.defaultValue}e.getMigratedSettingValue=h;function g(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(De[53],Ie([1,0,12,8,3]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",c.isMacintosh),P.set("isLinux",c.isLinux),P.set("isWindows",c.isWindows),P.set("isWeb",c.isWeb),P.set("isMacNative",c.isMacintosh&&!c.isWeb),P.set("isEdge",c.isEdge),P.set("isFirefox",c.isFirefox),P.set("isChrome",c.isChrome),P.set("isSafari",c.isSafari);const y=Object.prototype.hasOwnProperty;var T;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return I.INSTANCE}static true(){return E.INSTANCE}static has(L){return _.create(L)}static equals(L,B){return w.create(L,B)}static notEquals(L,B){return f.create(L,B)}static regex(L,B){return o.create(L,B)}static in(L,B){return h.create(L,B)}static notIn(L,B){return g.create(L,B)}static not(L){return v.create(L)}static and(...L){return d.create(L,null,!0)}static or(...L){return n.create(L,null,!0)}static greater(L,B){return r.create(L,B)}static greaterEquals(L,B){return b.create(L,B)}static smaller(L,B){return s.create(L,B)}static smallerEquals(L,B){return u.create(L,B)}static deserialize(L,B=!1){if(!!L)return this._deserializeOrExpression(L,B)}static _deserializeOrExpression(L,B){const O=L.split("||");return n.create(O.map(z=>this._deserializeAndExpression(z,B)),null,!0)}static _deserializeAndExpression(L,B){const O=L.split("&&");return d.create(O.map(z=>this._deserializeOne(z,B)),null,!0)}static _deserializeOne(L,B){if(L=L.trim(),L.indexOf("!=")>=0){const O=L.split("!=");return f.create(O[0].trim(),this._deserializeValue(O[1],B))}if(L.indexOf("==")>=0){const O=L.split("==");return w.create(O[0].trim(),this._deserializeValue(O[1],B))}if(L.indexOf("=~")>=0){const O=L.split("=~");return o.create(O[0].trim(),this._deserializeRegexValue(O[1],B))}if(L.indexOf(" not in ")>=0){const O=L.split(" not in ");return g.create(O[0].trim(),this._deserializeValue(O[1],B))}if(L.indexOf(" in ")>=0){const O=L.split(" in ");return h.create(O[0].trim(),this._deserializeValue(O[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const O=L.split(">=");return b.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const O=L.split(">");return r.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const O=L.split("<=");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const O=L.split("<");return s.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(L)?v.create(L.substr(1).trim()):_.create(L)}static _deserializeValue(L,B){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const O=/^'([^']*)'$/.exec(L);return O?O[1].trim():L}static _deserializeRegexValue(L,B){if((0,t.isFalsyOrWhitespace)(L)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=L.indexOf("/"),z=L.lastIndexOf("/");if(O===z||O<0){if(B)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const U=L.slice(O+1,z),F=L[z+1]==="i"?"i":"";try{return new RegExp(U,F)}catch(V){if(B)throw new Error(`bad regexp-value '${L}', parse error: ${V}`);return console.warn(`bad regexp-value '${L}', parse error: ${V}`),null}}}e.ContextKeyExpr=S;function k(x,L){const B=x?x.substituteConstants():void 0,O=L?L.substituteConstants():void 0;return!B&&!O?!0:!B||!O?!1:B.equals(O)}e.expressionsAreEqualWithConstantSubstitution=k;function A(x,L){return x.cmp(L)}class I{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class E{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class _{static create(L,B=null){const O=P.get(L);return typeof O=="boolean"?O?E.INSTANCE:I.INSTANCE:new _(L,B)}constructor(L,B){this.key=L,this.negated=B,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:p(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=P.get(this.key);return typeof L=="boolean"?L?E.INSTANCE:I.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=_;class w{static create(L,B,O=null){if(typeof B=="boolean")return B?_.create(L,O):v.create(L,O);const z=P.get(L);return typeof z=="boolean"?B===(z?"true":"false")?E.INSTANCE:I.INSTANCE:new w(L,B,O)}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=P.get(this.key);if(typeof L=="boolean"){const B=L?"true":"false";return this.value===B?E.INSTANCE:I.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class h{static create(L,B){return new h(L,B)}constructor(L,B){this.key=L,this.valueKey=B,this.type=10,this.negated=null}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const B=L.getValue(this.valueKey),O=L.getValue(this.key);return Array.isArray(B)?B.includes(O):typeof O=="string"&&typeof B=="object"&&B!==null?y.call(B,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=h;class g{static create(L,B){return new g(L,B)}constructor(L,B){this.key=L,this.valueKey=B,this.type=11,this._negated=h.create(L,B)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=g;class f{static create(L,B,O=null){if(typeof B=="boolean")return B?v.create(L,O):_.create(L,O);const z=P.get(L);return typeof z=="boolean"?B===(z?"true":"false")?I.INSTANCE:E.INSTANCE:new f(L,B,O)}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=P.get(this.key);if(typeof L=="boolean"){const B=L?"true":"false";return this.value===B?I.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class v{static create(L,B=null){const O=P.get(L);return typeof O=="boolean"?O?I.INSTANCE:E.INSTANCE:new v(L,B)}constructor(L,B){this.key=L,this.negated=B,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:p(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=P.get(this.key);return typeof L=="boolean"?L?I.INSTANCE:E.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function m(x,L){if(typeof x=="string"){const B=parseFloat(x);isNaN(B)||(x=B)}return typeof x=="string"||typeof x=="number"?L(x):I.INSTANCE}class r{static create(L,B,O=null){return m(B,z=>new r(L,z,O))}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=r;class b{static create(L,B,O=null){return m(B,z=>new b(L,z,O))}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=b;class s{static create(L,B,O=null){return m(B,z=>new s(L,z,O))}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class u{static create(L,B,O=null){return m(B,z=>new u(L,z,O))}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class o{static create(L,B){return new o(L,B)}constructor(L,B){this.key=L,this.regexp=B,this.type=7,this.negated=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const B=this.regexp?this.regexp.source:"",O=L.regexp?L.regexp.source:"";return B<O?-1:B>O?1:0}equals(L){if(L.type===this.type){const B=this.regexp?this.regexp.source:"",O=L.regexp?L.regexp.source:"";return this.key===L.key&&B===O}return!1}substituteConstants(){return this}evaluate(L){const B=L.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class l{static create(L){return new l(L)}constructor(L){this._actual=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new l(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;function a(x){let L=null;for(let B=0,O=x.length;B<O;B++){const z=x[B].substituteConstants();if(x[B]!==z&&L===null){L=[];for(let U=0;U<B;U++)L[U]=x[U]}L!==null&&(L[B]=z)}return L===null?x:L}class d{static create(L,B,O){return d._normalizeArr(L,B,O)}constructor(L,B){this.expr=L,this.negated=B,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const z=A(this.expr[B],L.expr[B]);if(z!==0)return z}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(L.expr[B]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:d.create(L,this.negated,!1)}evaluate(L){for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].evaluate(L))return!1;return!0}static _normalizeArr(L,B,O){const z=[];let U=!1;for(const F of L)if(!!F){if(F.type===1){U=!0;continue}if(F.type===0)return I.INSTANCE;if(F.type===6){z.push(...F.expr);continue}z.push(F)}if(z.length===0&&U)return E.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(A);for(let F=1;F<z.length;F++)z[F-1].equals(z[F])&&(z.splice(F,1),F--);if(z.length===1)return z[0];for(;z.length>1;){const F=z[z.length-1];if(F.type!==9)break;z.pop();const V=z.pop(),H=z.length===0,Q=n.create(F.expr.map(K=>d.create([K,V],null,O)),null,H);Q&&(z.push(Q),z.sort(A))}if(z.length===1)return z[0];if(O){for(let F=0;F<z.length;F++)for(let V=F+1;V<z.length;V++)if(z[F].negate().equals(z[V]))return I.INSTANCE;if(z.length===1)return z[0]}return new d(z,B)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const B of this.expr)L.push(...B.keys());return L}map(L){return new d(this.expr.map(B=>B.map(L)),null)}negate(){if(!this.negated){const L=[];for(const B of this.expr)L.push(B.negate());this.negated=n.create(L,this,!0)}return this.negated}}class n{static create(L,B,O){return n._normalizeArr(L,B,O)}constructor(L,B){this.expr=L,this.negated=B,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const z=A(this.expr[B],L.expr[B]);if(z!==0)return z}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(L.expr[B]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:n.create(L,this.negated,!1)}evaluate(L){for(let B=0,O=this.expr.length;B<O;B++)if(this.expr[B].evaluate(L))return!0;return!1}static _normalizeArr(L,B,O){let z=[],U=!1;if(L){for(let F=0,V=L.length;F<V;F++){const H=L[F];if(!!H){if(H.type===0){U=!0;continue}if(H.type===1)return E.INSTANCE;if(H.type===9){z=z.concat(H.expr);continue}z.push(H)}}if(z.length===0&&U)return I.INSTANCE;z.sort(A)}if(z.length!==0){if(z.length===1)return z[0];for(let F=1;F<z.length;F++)z[F-1].equals(z[F])&&(z.splice(F,1),F--);if(z.length===1)return z[0];if(O){for(let F=0;F<z.length;F++)for(let V=F+1;V<z.length;V++)if(z[F].negate().equals(z[V]))return E.INSTANCE;if(z.length===1)return z[0]}return new n(z,B)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const B of this.expr)L.push(...B.keys());return L}map(L){return new n(this.expr.map(B=>B.map(L)),null)}negate(){if(!this.negated){const L=[];for(const B of this.expr)L.push(B.negate());for(;L.length>1;){const B=L.shift(),O=L.shift(),z=[];for(const U of $(B))for(const F of $(O))z.push(d.create([U,F],null,!1));L.unshift(n.create(z,null,!1))}this.negated=n.create(L,this,!0)}return this.negated}}class i extends _{static all(){return i._info.values()}constructor(L,B,O){super(L,null),this._defaultValue=B,typeof O=="object"?i._info.push({...O,key:L}):O!==!0&&i._info.push({key:L,description:O,type:B!=null?typeof B:void 0})}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return w.create(this.key,L)}notEqualsTo(L){return f.create(this.key,L)}}e.RawContextKey=i,i._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(x,L){return x<L?-1:x>L?1:0}function C(x,L,B,O){return x<B?-1:x>B?1:L<O?-1:L>O?1:0}function R(x,L){if(x.type===0||L.type===1)return!0;if(x.type===9)return L.type===9?M(x.expr,L.expr):!1;if(L.type===9){for(const B of L.expr)if(R(x,B))return!0;return!1}if(x.type===6){if(L.type===6)return M(L.expr,x.expr);for(const B of x.expr)if(R(B,L))return!0;return!1}return x.equals(L)}e.implies=R;function M(x,L){let B=0,O=0;for(;B<x.length&&O<L.length;){const z=x[B].cmp(L[O]);if(z<0)return!1;z===0&&B++,O++}return B===x.length}function $(x){return x.type===9?x.expr:[x]}}),define(De[191],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(De[121],Ie([1,0,165,3]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function P(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function T(f,v){return v==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(f,v,m){return T(v,m)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===m?!0:k(m).includes(f)}e.isTargetPlatformCompatible=S;function k(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A;var I;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var E;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var _;(function(f){f.Install="install",f.Uninstall="uninstall"})(_=e.StatisticType||(e.StatisticType={}));var w;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var h;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(v,m){super(v),this.code=m,this.name=m}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[192],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(De[193],Ie([1,0,44,14,9,12,106,29,114,167,192]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=k.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:_.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class _ extends E{openTerminal(r,b){return this.spawnTerminal(c,r,S.getWindowsShell(),b)}spawnTerminal(r,b,s,u){const o=b.windowsExec||_.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const l=D.basename(o).toLowerCase();if(l==="cmder"||l==="cmder.exe")return r.spawn(o,u?[u]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return o.indexOf(" ")>=0&&a.push('""'),a.push(o),(l==="wt"||l==="wt.exe")&&a.push("-d ."),new Promise((d,n)=>{const i=g(process),p=r.spawn(s,a,{cwd:u,env:i});p.on("error",n),p.on("exit",()=>d())})}runInTerminal(r,b,s,u,o){const l="windowsExec"in o&&o.windowsExec?o.windowsExec:_.getDefaultTerminalWindows();return new Promise((a,d)=>{const n=`"${b} - ${I}"`,i=`""${s.join('" "')}" & pause"`,p=["/c","start",n,"/wait",l,"/c",i],C=Object.assign({},g(process),u);Object.keys(C).filter($=>C[$]===null).forEach($=>delete C[$]);const R={cwd:b,env:C,windowsVerbatimArguments:!0};c.spawn(_.CMD,p,R).on("error",$=>{d(f($))}),a(void 0)})}static getDefaultTerminalWindows(){if(!_._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");_._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return _._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=_,_.CMD="cmd.exe";class w extends E{openTerminal(r,b){return this.spawnTerminal(c,r,b)}runInTerminal(r,b,s,u,o){const l=o.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((a,d)=>{if(l===A.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const n=l===A.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`,Z).fsPath,"-t",r||I,"-w",b];for(const M of s)p.push("-a"),p.push(M);if(u){const M=Object.assign({},g(process),u);for(const $ in M){const x=M[$];x===null?(p.push("-u"),p.push($)):(p.push("-e"),p.push(`${$}=${x}`))}}let C="";const R=c.spawn(w.OSASCRIPT,p);R.on("error",M=>{d(f(M))}),R.stderr.on("data",M=>{C+=M.toString()}),R.on("exit",M=>{if(M===0)a(void 0);else if(C){const $=C.split(`
`,1);d(new Error($[0]))}else d(new Error(k.localize(1,null,n,M)))})}else d(new Error(k.localize(2,null,l)))})}spawnTerminal(r,b,s){const u=b.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((o,l)=>{const a=["-a",u];s&&a.push(s);const d=g(process),n=r.spawn("/usr/bin/open",a,{cwd:s,env:d});n.on("error",l),n.on("exit",()=>o())})}}e.MacExternalTerminalService=w,w.OSASCRIPT="/usr/bin/osascript";class h extends E{openTerminal(r,b){return this.spawnTerminal(c,r,b)}runInTerminal(r,b,s,u,o){const l=o.linuxExec?Promise.resolve(o.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((a,d)=>{const n=[];l.then(i=>{i.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const p=`${v(s)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;n.push(`''${p}''`);const C=Object.assign({},g(process),u);Object.keys(C).filter(x=>C[x]===null).forEach(x=>delete C[x]);const R={cwd:b,env:C};let M="";const $=c.spawn(i,n,R);$.on("error",x=>{d(f(x))}),$.stderr.on("data",x=>{M+=x.toString()}),$.on("exit",x=>{if(x===0)a(void 0);else if(M){const L=M.split(`
`,1);d(new Error(L[0]))}else d(new Error(k.localize(4,null,i,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await T.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(b=>{r?b("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?b("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?b("konsole"):process.env.COLORTERM?b(process.env.COLORTERM):process.env.TERM?b(process.env.TERM):b("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,b,s){const u=b.linuxExec?Promise.resolve(b.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((o,l)=>{u.then(a=>{const d=g(process),n=r.spawn(a,[],{cwd:s,env:d});n.on("error",l),n.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=k.localize(3,null);function g(m){const r={...m.env};return(0,y.sanitizeProcessEnvironment)(r),r}function f(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(k.localize(5,null,m.path)):m}function v(m){let r="";for(const b of m)b.indexOf(" ")>=0?r+='"'+b+'"':r+=b,r+=" ";return r}}),define(De[38],Ie([1,0,64,9,8,11,2,168,3]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function k(U){return U.create===!0}e.isFileOpenForWriteOptions=k;var A;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var E;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=_;function w(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=w;function h(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=h;function g(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function f(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=f;function v(U){return _(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var m;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class r extends Error{constructor(F,V){super(F),this.code=V}}e.FileSystemProviderError=r;function b(U,F){const V=new r(U.toString(),F);return u(V,F),V}e.createFileSystemProviderError=b;function s(U){return U||b((0,T.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=s;function u(U,F){return U.name=F?`${F} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=u;function o(U){if(!U)return m.Unknown;if(U instanceof r)return U.code;const F=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!F)return m.Unknown;switch(F[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=o;function l(U){if(U instanceof C)return U.fileOperationResult;switch(o(U)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var a;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class d{constructor(F,V,H){this.resource=F,this.operation=V,this.target=H}isOperation(F){return this.operation===F}}e.FileOperationEvent=d;var n;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class i{constructor(F,V){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=F;const H=new Map;for(const Q of F){const K=H.get(Q.type);switch(K?K.push([Q.resource,Q]):H.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,K]of H)switch(Q){case 1:this.added=c.TernarySearchTree.forUris(()=>V),this.added.fill(K);break;case 0:this.updated=c.TernarySearchTree.forUris(()=>V),this.updated.fill(K);break;case 2:this.deleted=c.TernarySearchTree.forUris(()=>V),this.deleted.fill(K);break}}contains(F,...V){return this.doContains(F,{includeChildren:!1},...V)}affects(F,...V){return this.doContains(F,{includeChildren:!0},...V)}doContains(F,V,...H){if(!F)return!1;const Q=H.length>0;return!!((!Q||H.includes(1))&&(this.added?.get(F)||V.includeChildren&&this.added?.findSuperstr(F))||(!Q||H.includes(0))&&(this.updated?.get(F)||V.includeChildren&&this.updated?.findSuperstr(F))||(!Q||H.includes(2))&&(this.deleted?.findSubstr(F)||V.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=i;function p(U,F,V){return!U||!F||U===F||F.length>U.length?!1:(F.charAt(F.length-1)!==t.sep&&(F+=t.sep),V?(0,D.startsWithIgnoreCase)(U,F):U.indexOf(F)===0)}e.isParent=p;class C extends Error{constructor(F,V,H){super(F),this.fileOperationResult=V,this.options=H}}e.FileOperationError=C;class R extends C{constructor(F,V,H){super(F,2,H),this.stat=V}}e.NotModifiedSinceFileOperationError=R;var M;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})($=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function x(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=x;async function L(U,F){if(!F.hasProvider(y.URI.from({scheme:U.scheme})))return new Promise(V=>{const H=F.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===U.scheme&&Q.added&&(H.dispose(),V())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(F){return(0,P.isNumber)(F)||(F=0),F<B.KB?(0,T.localize)(1,null,F.toFixed(0)):F<B.MB?(0,T.localize)(2,null,(F/B.KB).toFixed(2)):F<B.GB?(0,T.localize)(3,null,(F/B.MB).toFixed(2)):F<B.TB?(0,T.localize)(4,null,(F/B.GB).toFixed(2)):(0,T.localize)(5,null,(F/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var O;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function z(U){return{maxFileSize:U===0?300*B.MB:16*B.GB,maxHeapSize:U===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=z}),define(De[85],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...D){this._entries=new Map;for(const[P,y]of D)this.set(P,y)}set(D,P){const y=this._entries.get(D);return this._entries.set(D,P),y}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=c}),define(De[194],Ie([1,0,18,10,6,120,190,3,85,63]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class I extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class E{constructor(g=new S.ServiceCollection,f=!1,v,m=A){this._services=g,this._strict=f,this._parent=v,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=m?v?._globalGraph??new y.Graph(r=>r):void 0}createChild(g){return new E(g,this._strict,this,this._enableTracing)}invokeFunction(g,...f){const v=w.traceInvocation(this._enableTracing,g);let m=!1;try{return g({get:b=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(b,v);if(!s)throw new Error(`[invokeFunction] unknown service '${b}'`);return s}},...f)}finally{m=!0,v.stop()}}createInstance(g,...f){let v,m;return g instanceof P.SyncDescriptor?(v=w.traceCreation(this._enableTracing,g.ctor),m=this._createInstance(g.ctor,g.staticArguments.concat(f),v)):(v=w.traceCreation(this._enableTracing,g),m=this._createInstance(g,f,v)),v.stop(),m}_createInstance(g,f=[],v){const m=T._util.getServiceDependencies(g).sort((s,u)=>s.index-u.index),r=[];for(const s of m){const u=this._getOrCreateServiceInstance(s.id,v);u||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${s.id}.`,!1),r.push(u)}const b=m.length>0?m[0].index:f.length;if(f.length!==b){console.trace(`[createInstance] First service dependency of ${g.name} at position ${b+1} conflicts with ${f.length} static arguments`);const s=b-f.length;s>0?f=f.concat(new Array(s)):f=f.slice(0,b)}return Reflect.construct(g,f.concat(r))}_setServiceInstance(g,f){if(this._services.get(g)instanceof P.SyncDescriptor)this._services.set(g,f);else if(this._parent)this._parent._setServiceInstance(g,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){const f=this._services.get(g);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):f}_getOrCreateServiceInstance(g,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(g));const v=this._getServiceInstanceOrDescriptor(g);return v instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,v,f.branch(g,!0)):(f.branch(g,!1),v)}_safeCreateAndCacheServiceInstance(g,f,v){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,f,v)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,f,v){const m=new y.Graph(s=>s.id.toString());let r=0;const b=[{id:g,desc:f,_trace:v}];for(;b.length;){const s=b.pop();if(m.lookupOrInsertNode(s),r++>1e3)throw new I(m);for(const u of T._util.getServiceDependencies(s.desc.ctor)){const o=this._getServiceInstanceOrDescriptor(u.id);if(o||this._throwIfStrict(`[createInstance] ${g} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(u.id)),o instanceof P.SyncDescriptor){const l={id:u.id,desc:o,_trace:s._trace.branch(u.id,!0)};m.insertEdge(s,l),b.push(l)}}}for(;;){const s=m.roots();if(s.length===0){if(!m.isEmpty())throw new I(m);break}for(const{data:u}of s){if(this._getServiceInstanceOrDescriptor(u.id)instanceof P.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}m.removeNode(u)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,f,v=[],m,r){if(this._services.get(g)instanceof P.SyncDescriptor)return this._createServiceInstance(g,f,v,m,r);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,f,v,m,r);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(g,f,v=[],m,r){if(m){const b=new E(void 0,this._strict,this,this._enableTracing);b._globalGraphImplicitDependency=String(g);const s=new Map,u=new c.IdleValue(()=>{const o=b._createInstance(f,v,r);for(const[l,a]of s){const d=o[l];if(typeof d=="function")for(const n of a)d.apply(o,n)}return s.clear(),o});return new Proxy(Object.create(null),{get(o,l){if(!u.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let n=s.get(l);return n||(n=new k.LinkedList,s.set(l,n)),(p,C,R)=>{const M=n.push([p,C,R]);return(0,D.toDisposable)(M)}}if(l in o)return o[l];const a=u.value;let d=a[l];return typeof d!="function"||(d=d.bind(a),o[l]=d),d},set(o,l,a){return u.value[l]=a,!0}})}else return this._createInstance(f,v,r)}_throwIfStrict(g,f){if(f&&console.warn(g),this._strict)throw new Error(g)}}e.InstantiationService=E;var _;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(_||(_={}));class w{static traceInvocation(g,f){return g?new w(1,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w._None}static traceCreation(g,f){return g?new w(0,f.name):w._None}constructor(g,f){this.type=g,this.name=f,this._start=Date.now(),this._dep=[]}branch(g,f){const v=new w(2,g.toString());return this._dep.push([g,f,v]),v}stop(){const g=Date.now()-this._start;w._totals+=g;let f=!1;function v(r,b){const s=[],u=new Array(r+1).join("	");for(const[o,l,a]of b._dep)if(l&&a){f=!0,s.push(`${u}CREATES -> ${o}`);const d=v(r+1,a);d&&s.push(d)}else s.push(`${u}uses -> ${o}`);return s.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(g>2||f)&&w.all.add(m.join(`
`))}}e.Trace=w,w.all=new Set,w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(De[13],Ie([1,0,50,4,6,28,12,2,3]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function k(){return new Date().toISOString()}var A;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(A=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=A.Info;function I(d,n,i){switch(n){case A.Trace:d.trace(i);break;case A.Debug:d.debug(i);break;case A.Info:d.info(i);break;case A.Warning:d.warn(i);break;case A.Error:d.error(i);break;case A.Critical:d.critical(i);break;default:throw new Error("Invalid log level")}}e.log=I;function E(d){let n="";for(let i=0;i<d.length;i++){let p=d[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}n+=(i>0?" ":"")+p}return n}e.format=E;class _ extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class w extends _{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(A.Trace)&&this.log(A.Trace,E([n,...i]))}debug(n,...i){this.checkLogLevel(A.Debug)&&this.log(A.Debug,E([n,...i]))}info(n,...i){this.checkLogLevel(A.Info)&&this.log(A.Info,E([n,...i]))}warn(n,...i){this.checkLogLevel(A.Warning)&&this.log(A.Warning,E([n,...i]))}error(n,...i){if(this.checkLogLevel(A.Error))if(n instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=n.stack,this.log(A.Error,E(p))}else this.log(A.Error,E([n,...i]))}critical(n,...i){this.checkLogLevel(A.Critical)&&this.log(A.Critical,E([n,...i]))}flush(){}}e.AbstractMessageLogger=w;class h extends _{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!y.isWindows}trace(n,...i){this.getLevel()<=A.Trace&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...i):console.log(`[main ${k()}]`,n,...i))}debug(n,...i){this.getLevel()<=A.Debug&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...i):console.log(`[main ${k()}]`,n,...i))}info(n,...i){this.getLevel()<=A.Info&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...i):console.log(`[main ${k()}]`,n,...i))}warn(n,...i){this.getLevel()<=A.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,n,...i):console.warn(`[main ${k()}]`,n,...i))}error(n,...i){this.getLevel()<=A.Error&&(this.useColors?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,n,...i):console.error(`[main ${k()}]`,n,...i))}critical(n,...i){this.getLevel()<=A.Critical&&(this.useColors?console.error(`\x1B[90m[main ${k()}]\x1B[0m`,n,...i):console.error(`[main ${k()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class g extends _{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...i){this.getLevel()<=A.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=A.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=A.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=A.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=A.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=A.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=g;class f extends _{constructor(n,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=A.Trace&&this.adapter.log(A.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=A.Debug&&this.adapter.log(A.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=A.Info&&this.adapter.log(A.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=A.Warning&&this.adapter.log(A.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=A.Error&&this.adapter.log(A.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=A.Critical&&this.adapter.log(A.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,c.toErrorMessage)(n,this.getLevel()<=A.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class v extends _{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const p of this.logServices)p.trace(n,...i)}debug(n,...i){for(const p of this.logServices)p.debug(n,...i)}info(n,...i){for(const p of this.logServices)p.info(n,...i)}warn(n,...i){for(const p of this.logServices)p.warn(n,...i)}error(n,...i){for(const p of this.logServices)p.error(n,...i)}critical(n,...i){for(const p of this.logServices)p.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class m extends D.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=m;class r extends D.Disposable{constructor(n,i){super(),this.logLevel=n,this.loggerItems=new P.ResourceMap,this._register(i(p=>this.setLevel(p)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:n})=>n)}getLogger(n){return this.loggerItems.get(n)?.logger}createLogger(n,i,p){let C=this.loggerItems.get(n)?.logger;return C||(p=i?.always?A.Trace:p,C=this.doCreateLogger(n,p??this.logLevel,i),this.loggerItems.set(n,{logger:C,logLevel:p})),C}setLevel(n,i){const p=T.URI.isUri(n)?n:void 0,C=p?i:n;if(p){const R=this.loggerItems.get(p);R&&R.logLevel!==C&&(R.logLevel=C,R.logger.setLevel(C))}else this.logLevel=C,this.loggerItems.forEach(({logLevel:R,logger:M})=>{R===void 0&&M.setLevel(this.logLevel)})}getLogLevel(n){return this.loggerItems.get(n)?.logLevel}dispose(){this.loggerItems.forEach(({logger:n})=>n.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=r;class b{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return A.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogger=b;class s extends b{}e.NullLogService=s;class u extends r{constructor(){super(A.Info,t.Event.None)}doCreateLogger(n,i,p){return new b}}e.NullLoggerService=u;function o(d){if(d.verbose)return A.Trace;if(typeof d.logLevel=="string"){const n=l(d.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(d){switch(d){case"trace":return A.Trace;case"debug":return A.Debug;case"info":return A.Info;case"warn":return A.Warning;case"error":return A.Error;case"critical":return A.Critical;case"off":return A.Off}}e.parseLogLevel=l;function a(d){switch(d){case A.Trace:return"trace";case A.Debug:return"debug";case A.Info:return"info";case A.Warning:return"warn";case A.Error:return"error";case A.Critical:return"critical";case A.Off:return"off"}}e.LogLevelToString=a}),define(De[195],Ie([1,0,38,13]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(T,S,k,A,I){try{const E=await new Promise((w,h)=>{Z(["spdlog"],w,h)});E.setFlushOn(t.LogLevel.Trace);const _=await E.createAsyncRotatingLogger(T,S,k,A);return I?_.clearFormatters():_.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),_}catch(E){console.error(E)}return null}function P(T,S,k){switch(S){case t.LogLevel.Trace:T.trace(k);break;case t.LogLevel.Debug:T.debug(k);break;case t.LogLevel.Info:T.info(k);break;case t.LogLevel.Warning:T.warn(k);break;case t.LogLevel.Error:T.error(k);break;case t.LogLevel.Critical:T.critical(k);break;default:throw new Error("Invalid log level")}}class y extends t.AbstractMessageLogger{constructor(S,k,A,I,E){super(),this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(S,k,A,I),this._register(this.onDidChangeLogLevel(_=>{this._logger?.setLevel(_)}))}async _createSpdLogLogger(S,k,A,I){const E=A?6:1,_=30/E*c.ByteSize.MB,w=await D(S,k,_,E,I);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:h,message:g}of this.buffer)P(this._logger,h,g);this.buffer=[]}}log(S,k){this._logger?P(this._logger,S,k):this.getLevel()<=S&&this.buffer.push({level:S,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(De[122],Ie([1,0,42,169,3]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(w,h){return h-w}S.compare=k;const A=Object.create(null);A[S.Error]=(0,t.localize)(0,null),A[S.Warning]=(0,t.localize)(1,null),A[S.Info]=(0,t.localize)(2,null);function I(w){return A[w]||""}S.toString=I;function E(w){switch(w){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=E;function _(w){switch(w){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=_}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const k="";function A(E){return I(E,!0)}S.makeKey=A;function I(E,_){const w=[k];return E.source?w.push(E.source.replace("\xA6","\\\xA6")):w.push(k),E.code?typeof E.code=="string"?w.push(E.code.replace("\xA6","\\\xA6")):w.push(E.code.value.replace("\xA6","\\\xA6")):w.push(k),E.severity!==void 0&&E.severity!==null?w.push(y.toString(E.severity)):w.push(k),E.message&&_?w.push(E.message.replace("\xA6","\\\xA6")):w.push(k),E.startLineNumber!==void 0&&E.startLineNumber!==null?w.push(E.startLineNumber.toString()):w.push(k),E.startColumn!==void 0&&E.startColumn!==null?w.push(E.startColumn.toString()):w.push(k),E.endLineNumber!==void 0&&E.endLineNumber!==null?w.push(E.endLineNumber.toString()):w.push(k),E.endColumn!==void 0&&E.endColumn!==null?w.push(E.endColumn.toString()):w.push(k),w.push(k),w.join("\xA6")}S.makeKeyOptionalMessage=I})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(De[196],Ie([1,0,4,42,3]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,D.createDecorator)("notificationService");var P;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=S}),define(De[123],Ie([1,0,6,8,2,3]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(A){return{resolved:A,dispose(){}}}});function y(A,I){return D.URI.isUri(A)?(0,t.equalsIgnoreCase)(A.scheme,I):(0,t.startsWithIgnoreCase)(A,I+":")}e.matchesScheme=y;function T(A,...I){return I.some(E=>y(A,E))}e.matchesSomeScheme=T;function S(A,I){return A.with({fragment:`${I.startLineNumber},${I.startColumn}${I.endLineNumber?`-${I.endLineNumber}${I.endColumn?`,${I.endColumn}`:""}`:""}`})}e.withSelection=S;function k(A){let I;const E=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(A.fragment);return E&&(I={startLineNumber:parseInt(E[1]),startColumn:E[2]?parseInt(E[2]):1,endLineNumber:E[4]?parseInt(E[4]):void 0,endColumn:E[4]?E[5]?parseInt(E[5]):1:void 0},A=A.with({fragment:""})),{selection:I,uri:A}}e.extractSelection=k}),define(De[197],Ie([1,0,14,12,36,22]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const T=t.globals.vscode.context.configuration();if(T)y=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const T=(0,P.dirname)(c.FileAccess.asFileUri("",Z));if(y=Z.__$__nodeRequire((0,P.joinPath)(T,"product.json").fsPath),D.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0}),!y.version){const S=Z.__$__nodeRequire((0,P.joinPath)(T,"package.json").fsPath);Object.assign(y,{version:S.version})}}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y}),define(De[198],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(Z,e){return function(c,t){e(c,t,Z)}};define(De[124],Ie([1,0,18,21,6,3]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var y;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this._value}constructor(I){this.callback=I}report(I){this._value=I,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends D.Disposable{constructor(I,E){super(),this.deferred=new c.DeferredPromise,E.withProgress(I,_=>(this.reporter=_,this.lastStep&&_.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=Ve([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends D.Disposable{constructor(I){super(),this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(I){this.stop();const E=++this.currentOperationId,_=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{E===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>_.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:E,token:_.token,stop:()=>this.doStop(E),isCurrent:()=>this.currentOperationId===E}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(De[43],Ie([1,0,48,11]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(y,T){c.ok(t.isString(y)),c.ok(t.isObject(T)),c.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,T)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new D}),define(De[125],Ie([1,0,4,43]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class P{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,k){this.schemasById[D(S)]=k,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new P;t.Registry.add(e.Extensions.JSONContribution,y)}),define(De[126],Ie([1,0,17,4,11,164,52,125,43]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=S.Registry.as(T.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,u=!0){this.registerConfigurations([s],u)}registerConfigurations(s,u=!0){const o=this.doRegisterConfigurations(s,u);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(s){const u=this.doDeregisterConfigurations(s);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:s,remove:u}){const o=[];o.push(...this.doDeregisterConfigurations(u)),o.push(...this.doRegisterConfigurations(s,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,c.distinct)(o)})}registerDefaultConfigurations(s){const u=[],o=[];for(const{overrides:l,source:a}of s)for(const d in l)if(u.push(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const n=this.configurationDefaultsOverrides.get(d),i=n?.valuesSources??new Map;if(a)for(const M of Object.keys(l[d]))i.set(M,a);const p={...n?.value||{},...l[d]};this.configurationDefaultsOverrides.set(d,{source:a,value:p,valuesSources:i});const C=(0,y.getLanguageTagSettingPlainKey)(d),R={type:"object",default:p,description:P.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:D.isString(a)?void 0:a,defaultValueSource:a};o.push(...h(d)),this.configurationProperties[d]=R,this.defaultLanguageConfigurationOverridesNode.properties[d]=R}else{this.configurationDefaultsOverrides.set(d,{value:l[d],source:a});const n=this.configurationProperties[d];n&&(this.updatePropertyDefaultValue(d,n),this.updateSchema(d,n))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const u=[];for(const{overrides:o,source:l}of s)for(const a in o){const d=this.configurationDefaultsOverrides.get(a),n=D.isString(l)?l:l?.id,i=D.isString(d?.source)?d?.source:d?.source?.id;if(n===i)if(u.push(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const p=this.configurationProperties[a];p&&(this.updatePropertyDefaultValue(a,p),this.updateSchema(a,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const u of s)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,u){const o=[];return s.forEach(l=>{o.push(...this.validateAndRegisterProperties(l,u,l.extensionInfo,l.restrictedProperties)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),o}doDeregisterConfigurations(s){const u=[],o=l=>{if(l.properties)for(const a in l.properties){u.push(a);const d=this.configurationProperties[a];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[a],this.removeFromSchema(a,l.properties[a])}l.allOf?.forEach(a=>o(a))};for(const l of s){o(l);const a=this.configurationContributors.indexOf(l);a!==-1&&this.configurationContributors.splice(a,1)}return u}validateAndRegisterProperties(s,u=!0,o,l,a=3){a=D.isUndefinedOrNull(s.scope)?a:s.scope;const d=[],n=s.properties;if(n)for(const p in n){const C=n[p];if(u&&m(p,C)){delete n[p];continue}if(C.source=o,C.defaultDefaultValue=n[p].default,this.updatePropertyDefaultValue(p,C),e.OVERRIDE_PROPERTY_REGEX.test(p)?C.scope=void 0:(C.scope=D.isUndefinedOrNull(C.scope)?a:C.scope,C.restricted=D.isUndefinedOrNull(C.restricted)?!!l?.includes(p):C.restricted),n[p].hasOwnProperty("included")&&!n[p].included){this.excludedConfigurationProperties[p]=n[p],delete n[p];continue}else this.configurationProperties[p]=n[p],n[p].policy?.name&&this.policyConfigurations.set(n[p].policy.name,p);!n[p].deprecationMessage&&n[p].markdownDeprecationMessage&&(n[p].deprecationMessage=n[p].markdownDeprecationMessage),d.push(p)}const i=s.allOf;if(i)for(const p of i)d.push(...this.validateAndRegisterProperties(p,u,o,l,a));return d}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const u=o=>{const l=o.properties;if(l)for(const d in l)this.updateSchema(d,l[d]);o.allOf?.forEach(u)};u(s)}updateSchema(s,u){switch(e.allSettings.properties[s]=u,u.scope){case 1:e.applicationSettings.properties[s]=u;break;case 2:e.machineSettings.properties[s]=u;break;case 6:e.machineOverridableSettings.properties[s]=u;break;case 3:e.windowSettings.properties[s]=u;break;case 4:e.resourceSettings.properties[s]=u;break;case 5:e.resourceSettings.properties[s]=u,this.resourceLanguageSettingsSchema.properties[s]=u;break}}removeFromSchema(s,u){switch(delete e.allSettings.properties[s],u.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const u=`[${s}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,o),e.allSettings.properties[u]=o,e.applicationSettings.properties[u]=o,e.machineSettings.properties[u]=o,e.machineOverridableSettings.properties[u]=o,e.windowSettings.properties[u]=o,e.resourceSettings.properties[u]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,u){const o=this.configurationDefaultsOverrides.get(s);let l=o?.value,a=o?.source;D.isUndefined(l)&&(l=u.defaultDefaultValue,a=void 0),D.isUndefined(l)&&(l=f(u.type)),u.default=l,u.defaultValueSource=a}}const _="\\[([^\\]]+)\\]",w=new RegExp(_,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${_})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(b){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let u=w.exec(b);for(;u?.length;){const o=u[1].trim();o&&s.push(o),u=w.exec(b)}}return(0,c.distinct)(s)}e.overrideIdentifiersFromKey=h;function g(b){return b.reduce((s,u)=>`${s}[${u}]`,"")}e.keyFromOverrideIdentifiers=g;function f(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new E;S.Registry.add(e.Extensions.Configuration,v);function m(b,s){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?P.localize(7,null,b):v.getConfigurationProperties()[b]!==void 0?P.localize(8,null,b):s.policy?.name&&v.getPolicyConfigurations().get(s.policy?.name)!==void 0?P.localize(9,null,b,s.policy?.name,v.getPolicyConfigurations().get(s.policy?.name)):null:P.localize(6,null)}e.validateProperty=m;function r(){const b=[],s=v.getConfigurationProperties();for(const u of Object.keys(s))b.push([u,s[u].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=r}),define(De[199],Ie([1,0,17,4,144,6,28,24,11,2,52,126,43]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class _{constructor(u={},o=[],l=[],a){this._contents=u,this._keys=o,this._overrides=l,this.raw=a,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const u=this.raw.map(o=>{if(o instanceof _)return o;const l=new w("");return l.parseRaw(o),l.configurationModel});this._rawConfiguration=u.reduce((o,l)=>l===o?l:o.merge(l),u[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(u){return u?(0,A.getConfigurationValue)(this.contents,u):this.contents}inspect(u,o){const l=this.rawConfiguration.getValue(u),a=o?this.rawConfiguration.getOverrideValue(u,o):void 0,d=o?this.rawConfiguration.override(o).getValue(u):l;return{value:l,override:a,merged:d}}getOverrideValue(u,o){const l=this.getContentsForOverrideIdentifer(o);return l?u?(0,A.getConfigurationValue)(l,u):l:void 0}getKeysForOverrideIdentifier(u){const o=[];for(const l of this.overrides)l.identifiers.includes(u)&&o.push(...l.keys);return c.distinct(o)}getAllOverrideIdentifiers(){const u=[];for(const o of this.overrides)u.push(...o.identifiers);return c.distinct(u)}override(u){let o=this.overrideConfigurations.get(u);return o||(o=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,o)),o}merge(...u){const o=T.deepClone(this.contents),l=T.deepClone(this.overrides),a=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const n of u)if(d.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.mergeContents(o,n.contents);for(const i of n.overrides){const[p]=l.filter(C=>c.equals(C.identifiers,i.identifiers));p?(this.mergeContents(p.contents,i.contents),p.keys.push(...i.keys),p.keys=c.distinct(p.keys)):l.push(T.deepClone(i))}for(const i of n.keys)a.indexOf(i)===-1&&a.push(i)}return new _(o,a,l,d.every(n=>n instanceof _)?void 0:d)}freeze(){return this.frozen=!0,this}clone(){return new _(T.deepClone(this.contents),[...this.keys],T.deepClone(this.overrides))}createOverrideConfigurationModel(u){const o=this.getContentsForOverrideIdentifer(u);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const l={};for(const a of c.distinct([...Object.keys(this.contents),...Object.keys(o)])){let d=this.contents[a];const n=o[a];n&&(typeof d=="object"&&typeof n=="object"?(d=T.deepClone(d),this.mergeContents(d,n)):d=n),l[a]=d}return new _(l,this.keys,this.overrides)}mergeContents(u,o){for(const l of Object.keys(o)){if(l in u&&S.isObject(u[l])&&S.isObject(o[l])){this.mergeContents(u[l],o[l]);continue}u[l]=T.deepClone(o[l])}}checkAndFreeze(u){return this.frozen&&!Object.isFrozen(u)?T.deepFreeze(u):u}getContentsForOverrideIdentifer(u){let o=null,l=null;const a=d=>{d&&(l?this.mergeContents(l,d):l=T.deepClone(d))};for(const d of this.overrides)c.equals(d.identifiers,[u])?o=d.contents:d.identifiers.includes(u)&&a(d.contents);return a(o),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(u,o){this.addKey(u),(0,A.addToValueTree)(this.contents,u,o,l=>{throw new Error(l)})}removeValue(u){this.removeKey(u)&&(0,A.removeFromValueTree)(this.contents,u)}addKey(u){let o=this.keys.length;for(let l=0;l<o;l++)u.indexOf(this.keys[l])===0&&(o=l);this.keys.splice(o,1,u)}removeKey(u){const o=this.keys.indexOf(u);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=_;class w{constructor(u){this._name=u,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new _}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,o){if(!S.isUndefinedOrNull(u)){const l=this.doParseContent(u);this.parseRaw(l,o)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,o){this._raw=u;const{contents:l,keys:a,overrides:d,restricted:n,hasExcludedProperties:i}=this.doParseRaw(u,o);this._configurationModel=new _(l,a,d,i?[u]:void 0),this._restrictedConfigurations=n||[]}doParseContent(u){let o={},l=null,a=[];const d=[],n=[];function i(C){Array.isArray(a)?a.push(C):l!==null&&(a[l]=C)}const p={onObjectBegin:()=>{const C={};i(C),d.push(a),a=C,l=null},onObjectProperty:C=>{l=C},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const C=[];i(C),d.push(a),a=C,l=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:i,onError:(C,R,M)=>{n.push({error:C,offset:R,length:M})}};if(u)try{D.visit(u,p),o=a[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return o}doParseRaw(u,o){const l=E.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),a=this.filter(u,l,!0,o);u=a.raw;const d=(0,A.toValuesTree)(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),n=Object.keys(u),i=this.toOverrides(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:d,keys:n,overrides:i,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(u,o,l,a){let d=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:u,restricted:[],hasExcludedProperties:d};const n={},i=[];for(const p in u)if(I.OVERRIDE_PROPERTY_REGEX.test(p)&&l){const C=this.filter(u[p],o,!1,a);n[p]=C.raw,d=d||C.hasExcludedProperties,i.push(...C.restricted)}else{const C=o[p],R=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&i.push(p),(R===void 0||a.scopes===void 0||a.scopes.includes(R))&&!(a.skipRestricted&&C?.restricted)?n[p]=u[p]:d=!0}return{raw:n,restricted:i,hasExcludedProperties:d}}toOverrides(u,o){const l=[];for(const a of Object.keys(u))if(I.OVERRIDE_PROPERTY_REGEX.test(a)){const d={};for(const n in u[a])d[n]=u[a][n];l.push({identifiers:(0,I.overrideIdentifiersFromKey)(a),keys:Object.keys(d),contents:(0,A.toValuesTree)(d,o)})}return l}}e.ConfigurationModelParser=w;class h extends P.Disposable{constructor(u,o,l,a){super(),this.userSettingsResource=u,this.scopes=o,this.fileService=a,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,d=>(d.isOperation(0)||d.isOperation(3)||d.isOperation(1)||d.isOperation(4))&&l.isEqual(d.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new _}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class g{constructor(u,o,l,a,d,n,i,p,C,R,M,$,x){this.key=u,this.overrides=o,this.value=l,this.overrideIdentifiers=a,this.defaultConfiguration=d,this.policyConfiguration=n,this.applicationConfiguration=i,this.userConfiguration=p,this.localUserConfiguration=C,this.remoteUserConfiguration=R,this.workspaceConfiguration=M,this.folderConfigurationModel=$,this.memoryInspectValue=x}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class f{constructor(u,o,l,a,d=new _,n=new _,i=new y.ResourceMap,p=new _,C=new y.ResourceMap,R=!0){this._defaultConfiguration=u,this._policyConfiguration=o,this._applicationConfiguration=l,this._localUserConfiguration=a,this._remoteUserConfiguration=d,this._workspaceConfiguration=n,this._folderConfigurations=i,this._memoryConfiguration=p,this._memoryConfigurationByResource=C,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(u,o,l){return this.getConsolidatedConfigurationModel(u,o,l).getValue(u)}updateValue(u,o,l={}){let a;l.resource?(a=this._memoryConfigurationByResource.get(l.resource),a||(a=new _,this._memoryConfigurationByResource.set(l.resource,a))):a=this._memoryConfiguration,o===void 0?a.removeValue(u):a.setValue(u,o),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,o,l){const a=this.getConsolidatedConfigurationModel(u,o,l),d=c.distinct(a.overrides.map(p=>p.identifiers).flat()).filter(p=>a.getOverrideValue(u,p)!==void 0),n=this.getFolderConfigurationModelForResource(o.resource,l),i=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration;return new g(u,o,a.getValue(u),d.length?d:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),l?this._workspaceConfiguration.freeze():void 0,n?n.freeze():void 0,i.inspect(u,o.overrideIdentifier))}keys(u){const o=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(u){this._policyConfiguration=u}updateApplicationConfiguration(u){this._applicationConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,o){this._folderConfigurations.set(u,o),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,o){const l=[];if(!o){const{added:a,updated:d,removed:n}=r(this._defaultConfiguration,u);o=[...a,...d,...n]}for(const a of o)for(const d of(0,I.overrideIdentifiersFromKey)(a)){const n=this._defaultConfiguration.getKeysForOverrideIdentifier(d),i=u.getKeysForOverrideIdentifier(d),p=[...i.filter(C=>n.indexOf(C)===-1),...n.filter(C=>i.indexOf(C)===-1),...n.filter(C=>!T.equals(this._defaultConfiguration.override(d).getValue(C),u.override(d).getValue(C)))];l.push([d,p])}return this.updateDefaultConfiguration(u),{keys:o,overrides:l}}compareAndUpdatePolicyConfiguration(u){const{added:o,updated:l,removed:a}=r(this._policyConfiguration,u),d=[...o,...l,...a];return d.length&&this.updatePolicyConfiguration(u),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:o,updated:l,removed:a,overrides:d}=r(this.applicationConfiguration,u),n=[...o,...l,...a];return n.length&&this.updateApplicationConfiguration(u),{keys:n,overrides:d}}compareAndUpdateLocalUserConfiguration(u){const{added:o,updated:l,removed:a,overrides:d}=r(this.localUserConfiguration,u),n=[...o,...l,...a];return n.length&&this.updateLocalUserConfiguration(u),{keys:n,overrides:d}}compareAndUpdateRemoteUserConfiguration(u){const{added:o,updated:l,removed:a,overrides:d}=r(this.remoteUserConfiguration,u),n=[...o,...l,...a];return n.length&&this.updateRemoteUserConfiguration(u),{keys:n,overrides:d}}compareAndUpdateWorkspaceConfiguration(u){const{added:o,updated:l,removed:a,overrides:d}=r(this.workspaceConfiguration,u),n=[...o,...l,...a];return n.length&&this.updateWorkspaceConfiguration(u),{keys:n,overrides:d}}compareAndUpdateFolderConfiguration(u,o){const l=this.folderConfigurations.get(u),{added:a,updated:d,removed:n,overrides:i}=r(l,o),p=[...a,...d,...n];return(p.length||!l)&&this.updateFolderConfiguration(u,o),{keys:p,overrides:i}}compareAndDeleteFolderConfiguration(u){const o=this.folderConfigurations.get(u);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:l,updated:a,removed:d,overrides:n}=r(o,void 0);return{keys:[...l,...a,...d],overrides:n}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(u,o,l){let a=this.getConsolidatedConfigurationModelForResource(o,l);return o.overrideIdentifier&&(a=a.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(u)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:u},o){let l=this.getWorkspaceConsolidatedConfiguration();if(o&&u){const a=o.getFolder(u);a&&(l=this.getFolderConsolidatedConfiguration(a.uri)||l);const d=this._memoryConfigurationByResource.get(u);d&&(l=l.merge(d))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let o=this._foldersConsolidatedConfigurations.get(u);if(!o){const l=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(u);a?(o=l.merge(a),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(u,o)):o=l}return o}getFolderConfigurationModelForResource(u,o){if(o&&u){const l=o.getFolder(u);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,o)=>{const{contents:l,overrides:a,keys:d}=this._folderConfigurations.get(o);return u.push([o,{contents:l,overrides:a,keys:d}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>u.add(o)),this.userConfiguration.freeze().keys.forEach(o=>u.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>u.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(l=>u.add(l))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>u.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>u.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(l=>u.add(l))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(l=>o.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(l=>o.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(l=>o.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(u).forEach(a=>o.add(a))),[...o.values()]}static parse(u){const o=this.parseConfigurationModel(u.defaults),l=this.parseConfigurationModel(u.policy),a=this.parseConfigurationModel(u.application),d=this.parseConfigurationModel(u.user),n=this.parseConfigurationModel(u.workspace),i=u.folders.reduce((p,C)=>(p.set(k.URI.revive(C[0]),this.parseConfigurationModel(C[1])),p),new y.ResourceMap);return new f(o,l,a,d,new _,n,i,new _,new y.ResourceMap,!1)}static parseConfigurationModel(u){return new _(u.contents,u.keys,u.overrides).freeze()}}e.Configuration=f;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,o=new Map;for(const a of s)a.keys.forEach(d=>u.add(d)),a.overrides.forEach(([d,n])=>{const i=(0,y.getOrSet)(o,d,new Set);n.forEach(p=>i.add(p))});const l=[];return o.forEach((a,d)=>l.push([d,[...a.values()]])),{keys:[...u.values()],overrides:l}}e.mergeChanges=v;class m{constructor(u,o,l,a){this.change=u,this.previous=o,this.currentConfiguraiton=l,this.currentWorkspace=a,this._previousConfiguration=void 0;const d=new Set;u.keys.forEach(i=>d.add(i)),u.overrides.forEach(([,i])=>i.forEach(p=>d.add(p))),this.affectedKeys=[...d.values()];const n=new _;this.affectedKeys.forEach(i=>n.setValue(i,{})),this.affectedKeysTree=n.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(u,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,u)){if(o){const l=this.previousConfiguration?this.previousConfiguration.getValue(u,o,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(u,o,this.currentWorkspace);return!T.equals(l,a)}return!0}return!1}doesAffectedKeysTreeContains(u,o){let l=(0,A.toValuesTree)({[o]:!0},()=>{}),a;for(;typeof l=="object"&&(a=Object.keys(l)[0]);){if(u=u[a],!u)return!1;l=l[a]}return!0}}e.ConfigurationChangeEvent=m;function r(s,u){const{added:o,removed:l,updated:a}=b(u?.rawConfiguration,s?.rawConfiguration),d=[],n=s?.getAllOverrideIdentifiers()||[],i=u?.getAllOverrideIdentifiers()||[];if(u){const p=i.filter(C=>!n.includes(C));for(const C of p)d.push([C,u.getKeysForOverrideIdentifier(C)])}if(s){const p=n.filter(C=>!i.includes(C));for(const C of p)d.push([C,s.getKeysForOverrideIdentifier(C)])}if(u&&s){for(const p of n)if(i.includes(p)){const C=b({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:u.getOverrideValue(void 0,p)||{},keys:u.getKeysForOverrideIdentifier(p)});d.push([p,[...C.added,...C.removed,...C.updated]])}}return{added:o,removed:l,updated:a,overrides:d}}function b(s,u){const o=s?u?s.keys.filter(d=>u.keys.indexOf(d)===-1):[...s.keys]:[],l=u?s?u.keys.filter(d=>s.keys.indexOf(d)===-1):[...u.keys]:[],a=[];if(s&&u){for(const d of u.keys)if(s.keys.indexOf(d)!==-1){const n=(0,A.getConfigurationValue)(u.contents,d),i=(0,A.getConfigurationValue)(s.contents,d);T.equals(n,i)||a.push(d)}}return{added:o,removed:l,updated:a}}}),define(De[127],Ie([1,0,10,3]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends c.ErrorNoTelemetry{static isNotAvailable(T){return T instanceof P&&T._code===D.NotAvailable}static isTemporarilyNotAvailable(T){return T instanceof P&&T._code===D.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof P&&T._code===D.NoResolverFound}static isHandled(T){return T instanceof P&&T.isHandled}constructor(T,S=D.Unknown,k){super(T),this._message=T,this._code=S,this._detail=k,this.isHandled=S===D.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P}),define(De[86],Ie([1,0,14]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(k){return k.scheme===c.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=t;function D(k){if(!k)return;const A=k.indexOf("+");return A<0?k:k.substr(0,A)}e.getRemoteName=D;function P(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=P;function y(k){const{host:A,port:I}=S(k);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:I}}e.parseAuthorityWithPort=y;function T(k,A){let{host:I,port:E}=S(k);return typeof E>"u"&&(E=A),{host:I,port:E}}e.parseAuthorityWithOptionalPort=T;function S(k){const A=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const I=k.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const E=k.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:k,port:void 0}}}),define(De[26],Ie([1,0,8,3,86]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=P;function y(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,g){if(typeof h>"u"||h===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof h=="string"||typeof g=="string"){const f=typeof h=="string"?h:h.value,v=typeof g=="string"?g:g.value;return c.equalsIgnoreCase(f,v)}return h._lower===g._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=k;function A(w){return I(w)}e.isApplicationScopedExtension=A;function I(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function E(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function _(w,h){if(h){const g=`onResolveRemoteAuthority:${(0,D.getRemoteName)(h)}`;return w.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[200],Ie([1,0,8,121,26,12,2,10,36]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(u,o){return u.uuid&&o.uuid?u.uuid===o.uuid:u.id===o.id?!0:(0,c.compareIgnoreCase)(u.id,o.id)===0}e.areSameExtensions=k;const A=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{static create(o){const l=o.manifest?o.manifest.version:o.version,a=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new I(o.identifier,l,a)}static parse(o){const l=A.exec(o);return l&&l[1]&&l[2]?new I({id:l[1]},l[2],l[4]||void 0):null}constructor(o,l,a="undefined"){this.version=l,this.targetPlatform=a,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof I?k(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=I;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function _(u){const o=E.exec(u);return o&&o[1]?[h(o[1]),o[2]]:[h(u),void 0]}e.getIdAndVersion=_;function w(u,o){return`${u}.${o}`}e.getExtensionId=w;function h(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function g(u,o){return h(w(u,o))}e.getGalleryExtensionId=g;function f(u,o){const l=[],a=d=>{for(const n of l)if(n.some(i=>k(o(i),o(d))))return n;return null};for(const d of u){const n=a(d);n?n.push(d):l.push([d])}return l}e.groupByExtension=f;function v(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function m(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function r(u,o){const l=[],a=o.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const d=a.shift();if(d&&l.every(n=>!k(n.identifier,{id:d}))){const n=u.filter(i=>k(i.identifier,{id:d}));n.length===1&&(l.push(n[0]),a.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=r;async function b(u,o){if(!P.isLinux)return!1;let l;try{l=(await u.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await u.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){o.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(d))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=b;async function s(u,o){const l=await b(u,o),a=(0,t.getTargetPlatform)(l?"alpine":P.platform,S.arch);return o.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=s}),define(De[201],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.validators=new Map}vsda(){return new Promise((D,P)=>Z(["vsda"],D,P))}async createNewMessage(D){try{const P=await this.vsda(),y=new P.validator;if(y){const T=String(c._nextId++);return this.validators.set(T,y),{id:T,data:y.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,P){if(!D.id)return!0;const y=this.validators.get(D.id);if(!y)return!1;this.validators.delete(D.id);try{return y.validate(P)==="ok"}catch{return!1}}async sign(D){try{const P=await this.vsda(),y=new P.signer;if(y)return y.sign(D)}catch{}return D}}e.SignService=c,c._nextId=1}),define(De[202],Ie([1,0,12,36,2,31]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function y(k){if(c.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function T(k,A,I,E,_,w,h,g,f,v){const m=Object.create(null);m["common.machineId"]=h,m.sessionID=(0,P.generateUuid)()+Date.now(),m.commitHash=_,m.version=w,m["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,c.PlatformToString)(c.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=E,m["common.product"]=v||"desktop",g&&(m["common.msftInternal"]=g);let r=0;const b=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),c.isLinuxSnap&&(m["common.snap"]="true");const s=y(I);s&&(m["common.platformDetail"]=s);try{const u=await k.readFile(D.URI.file(f));m["common.source"]=u.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=T;function S(k){const A=t.env.USERDNSDOMAIN;if(!A)return!1;const I=A.toLowerCase();return k.some(E=>I===E)}e.verifyMicrosoftInternalDomain=S}),define(De[203],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[204],Ie([1,0,24,157,11,52,202,203]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(l,a){return Promise.resolve(void 0)}publicLog2(l,a){return this.publicLog(l,a)}publicLogError(l,a){return Promise.resolve(void 0)}publicLogError2(l,a){return this.publicLogError(l,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class k{async publicLog(l,a,d){}async publicLogError(l,a,d){}}e.NullEndpointTelemetryService=k,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function A(o,l){return l.onDidChangeConfiguration(a=>{a.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(a.source),configurationKeys:f(a.sourceConfig)})})}e.configurationTelemetry=A;function I(o,l){return!(l.disableTelemetry||!o.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=I;function E(o){const l=o.getValue(T.TELEMETRY_SETTING_ID),a=o.getValue("telemetry.enableCrashReporter");if(o.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function _(o){const l={},a={},d={};g(o,d);for(let n in d){n=n.length>150?n.substr(n.length-149):n;const i=d[n];typeof i=="number"?a[n]=i:typeof i=="boolean"?a[n]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${i.length}`),l[n]=i.substring(0,8191)):typeof i<"u"&&i!==null&&(l[n]=i)}return{properties:l,measurements:a}}e.validateTelemetryData=_;const w=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function h(o){if(!o)return"none";for(const l of w)if(o.startsWith(`${l}+`))return l;return"other"}e.cleanRemoteAuthority=h;function g(o,l,a=0,d){if(!!o)for(const n of Object.getOwnPropertyNames(o)){const i=o[n],p=d?d+n:n;Array.isArray(i)?l[p]=(0,c.safeStringify)(i):i instanceof Date?l[p]=i.toISOString():(0,D.isObject)(i)?a<2?g(i,l,a+1,p+"."):l[p]=(0,c.safeStringify)(i):l[p]=i}}function f(o){if(!o)return[];const l=[];return v(l,"",o),l}function v(o,l,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(d=>v(o,l?`${l}.${d}`:d,a[d])):o.push(l)}function m(o,l){const a=o.msftInternalDomains||[],d=l.getValue("telemetry.internalTesting");return(0,y.verifyMicrosoftInternalDomain)(a)||d}e.isInternalTelemetry=m;function r(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=r;function b(o,l){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let a=o;const d=[];for(const C of l)for(;;){const R=C.exec(o);if(!R)break;d.push([R.index,C.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(a="";;){const C=i.exec(o);if(!C)break;const R=d.some(([M,$])=>C.index<$&&M<i.lastIndex);!n.test(C[0])&&!R&&(a+=o.substring(p,C.index)+"<REDACTED: user-file-path>",p=i.lastIndex)}return p<o.length&&(a+=o.substr(p)),a}function s(o){if(!o)return o;const l=o.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of a)if(d.regex.test(l))return`<REDACTED: ${d.label}>`;return o}function u(o,l){return(0,c.cloneAndChange)(o,a=>{if(typeof a=="string"){let d=a;d=b(d,l);for(const n of l)d=d.replace(n,"");return d=s(d),d}})}e.cleanData=u}),define(De[205],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,P,y=5){const T=P(S=>{const k=typeof S=="string"?S:S.data;let A=this._terminalBufferMap.get(D);if(A){A.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(D),y);A={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(D),T.dispose()}},this._terminalBufferMap.set(D,A)});return T}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const P=this._terminalBufferMap.get(D);P&&(this._terminalBufferMap.delete(D),this._callback(D,P.data.join("")))}}e.TerminalDataBufferer=c}),define(De[206],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var c;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(c=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===c.HIGH_CONTRAST_DARK||P===c.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(P){return P===c.DARK||P===c.HIGH_CONTRAST_DARK}e.isDark=D}),define(De[87],Ie([1,0,77,4,6,3,43,206]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var S;(function(g){function f(v){return v&&typeof v=="object"&&typeof v.id=="string"}g.isThemeColor=f})(S=e.ThemeColor||(e.ThemeColor={}));function k(g){return{id:g}}e.themeColorFromId=k;var A;(function(g){function f(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||S.isThemeColor(l.color))}g.isThemeIcon=f;const v=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function m(l){const a=v.exec(l);if(!a)return;const[,d]=a;return{id:d}}g.fromString=m;function r(l){return{id:l}}g.fromId=r;function b(l,a){let d=l.id;const n=d.lastIndexOf("~");return n!==-1&&(d=d.substring(0,n)),a&&(d=`${d}~${a}`),{id:d}}g.modify=b;function s(l){const a=l.id.lastIndexOf("~");if(a!==-1)return l.id.substring(a+1)}g.getModifier=s;function u(l,a){return l.id===a.id&&l.color?.id===a.color?.id}g.isEqual=u;function o(l,a){return{id:l.id,color:a?k(a):void 0}}g.asThemeIcon=o,g.asClassNameArray=c.CSSIcon.asClassNameArray,g.asClassName=c.CSSIcon.asClassName,g.asCSSSelector=c.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function I(g){switch(g){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case T.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,D.toDisposable)(()=>{const v=this.themingParticipants.indexOf(f);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const _=new E;y.Registry.add(e.Extensions.ThemingContribution,_);function w(g){return _.onColorThemeChange(g)}e.registerThemingParticipant=w;class h extends D.Disposable{constructor(f){super(),this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,v){let m=this.theme.getColor(f);return m&&v&&(m=v(m,this.theme)),m?m.toString():null}}e.Themable=h}),define(De[128],Ie([1,0,4,52,3,13]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var y;(function(h){h.Http="http",h.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function E(h,g,f,v){if(f===1)return!1;if(f===2&&I(g)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(m?.length===4&&parseInt(m[1])>=18)return!1}return h<1024}e.isPortPrivileged=E;class _{constructor(g,f,v){this.remoteAddress=g,this.localAddress=f,this._dispose=v,this._onDispose=new c.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=_;let w=class{constructor(g,f){this.logService=g,this.configurationService=f,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],f=Array.from(this._tunnels.values());for(const v of f){const m=Array.from(v.values());for(const r of m){const b=await r.value;b&&g.push(b)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:f}of g.values())await f.then(v=>v?.dispose());g.clear()}this._tunnels.clear()}setEnvironmentTunnel(g,f,v,m,r){this.addTunnelToMap(g,f,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:f,localAddress:v,privacy:m,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,f){(I(g)||A(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const v=this.getTunnelFromMap(g,f);if(v)return++v.refcount,v.value}openTunnel(g,f,v,m,r=!1,b,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${v} on local port ${m}.`),!g)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(g,f,v,m,r,b,s);return u?u.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.makeTunnel(o);return(o.tunnelRemoteHost!==f||o.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(l),l}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const f=this._tunnels.get(g.tunnelRemoteHost);if(f){const v=f.get(g.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,v))}}}}async tryDisposeTunnel(g,f,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${f}.`);const m=v.value.then(async r=>{r&&(await r.dispose(!0),this._onTunnelClosed.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(f),m}}async closeTunnel(g,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${f} `);const v=this._tunnels.get(g);if(v&&v.has(f)){const m=v.get(f);m.refcount=0,await this.tryDisposeTunnel(g,f,m)}}addTunnelToMap(g,f,v){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(f,{refcount:1,value:v})}async removeEmptyTunnelFromMap(g,f){const v=this._tunnels.get(g);v&&(await v.get(f)||v.delete(f),v.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,f){const v=[g];A(g)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):I(g)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const m=v.map(r=>this._tunnels.get(r));for(const r of m){const b=r?.get(f);if(b)return b}}canTunnel(g){return!!k(g)}createWithProvider(g,f,v,m,r,b,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${v} on local port ${m}.`);const u=v;this._factoryInProgress.add(u);const o=m===void 0?v:m,l={elevationRequired:r?this.isPortPrivileged(o):!1},a={remoteAddress:{host:f,port:v},localAddressPort:m,privacy:b,public:b?b!==T.Private:void 0,protocol:s},d=g.forwardPort(a,l);return d?(this.addTunnelToMap(f,v,d),d.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),d}};w=Ve([He(0,P.ILogService),He(1,t.IConfigurationService)],w),e.AbstractTunnelService=w}),define(De[207],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var t;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[208],Ie([1,0,14]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==c.Schemas.file&&S.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=t;function D(S){if(S.folders.length)return S.folders.every(k=>t(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=D;function P(S){return D(S)?.scheme}e.getVirtualWorkspaceScheme=P;function y(S){return D(S)?.authority}e.getVirtualWorkspaceAuthority=y;function T(S){return D(S)!==void 0}e.isVirtualWorkspace=T}),define(De[45],Ie([1,0,170,9,64,22,2,3,14]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function k(u){const o=u;return typeof o?.id=="string"&&y.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function A(u,o){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,t.basename)(u)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const l=u;if(l.configuration)return{id:l.id,configPath:l.configuration};if(l.folders.length===1)return{id:l.id,uri:l.folders[0].uri}}e.toWorkspaceIdentifier=A;function I(u){const o=u;return typeof o?.id=="string"&&y.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=I;function E(u){const o=u;if(o?.uri)return{id:o.id,uri:y.URI.revive(o.uri)};const l=u;if(l?.configPath)return{id:l.id,configPath:y.URI.revive(l.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=E;var _;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(_=e.WorkbenchState||(e.WorkbenchState={}));function w(u){const o=u;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=w;function h(u){const o=u;return!!(o&&typeof o=="object"&&y.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=h;class g{constructor(o,l,a,d,n){this._id=o,this._transient=a,this._configuration=d,this._ignorePathCasing=n,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=l}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class f{constructor(o,l){this.raw=l,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,P.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function v(u){return new f({uri:u,index:0,name:(0,P.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(u,o){return P.extUriBiasedIgnorePathCase.isEqualOrParent(u,o.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function r(u){let o;return y.URI.isUri(u)?o=u:o=u.configuration,o?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=r;function b(u,o){return!m(u,o)&&!r(u)}e.isSavedWorkspace=b;function s(u){return(typeof u=="string"?(0,t.extname)(u):(0,P.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(De[88],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const P=this._idPool++;return this._data.set(P,D),this.logDebugInfo(),P}get(D,P){return this._data.has(D)?this._data.get(D)[P]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(De[46],Ie([1,0,14,22,3]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(T=>{const S=this._providerInfo.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this._providerInfo.delete(T.scheme):this._providerInfo.set(T.scheme,S)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(De[25],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(De[209],Ie([1,0,18]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(y,T,S){this._deferredPromises=new Map,this._id=y,this._shared=T,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of k.values())A.complete()}catch(A){for(const I of k.values())I.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,T){let S=this._value[y];return typeof S>"u"&&(S=T),S}update(y,T){this._value[y]=T;const S=this._deferredPromises.get(y);if(S!==void 0)return S.p;const k=new c.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class D extends t{setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}constructor(y,T){super(y.identifier.value,!0,T),this._extension=y}}e.ExtensionGlobalMemento=D}),define(De[210],Ie([1,0,4,2]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new c.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,T,S,k){const I=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptModelChanged(T.value,S,k);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(y,T){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptDirty(T)}$acceptModelSaved(y){const T=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y));this._onDidSaveNotebookDocument.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(De[16],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c},Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[211],Ie([1,0,26,4]),function(Z,e,c,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(T,S){D.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(T.identifier),nt(this,D,S,"f"),Ue(this,D,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(T){return Ue(this,D,"f").get(this._id,T)}store(T,S){return Ue(this,D,"f").store(this._id,T,S)}delete(T){return Ue(this,D,"f").delete(this._id,T)}}e.ExtensionSecrets=P,D=new WeakMap}),define(De[54],Ie([1,0,3,128,4,16]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(S){function k(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:I.protocol}}S.fromApiTunnel=k;function A(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==t.TunnelPrivacyId.ConstantPrivate&&I.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}S.fromServiceTunnel=A})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let T=class{constructor(k){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,A){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,A){return{dispose:()=>{}}}async $providePortAttributes(k,A,I,E,_){return[]}async $forwardPort(k,A){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([He(0,P.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(De[55],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=t}),define(De[212],Ie([1,0,23]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function D(T,S){if(S.serializeBuffersForPostMessage){const k=new t,A=(_,w)=>{if(w instanceof ArrayBuffer){const h=k.add(w);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(w)){const h=P(w);if(h){const g=k.add(w.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:h,byteLength:w.byteLength,byteOffset:w.byteOffset}}}}return w},I=JSON.stringify(T,A),E=k.buffers.map(_=>{const w=new Uint8Array(_);return c.VSBuffer.wrap(w)});return{message:I,buffers:E}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=D;function P(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(T,S){const k=S.map(E=>{const _=new ArrayBuffer(E.byteLength);return new Uint8Array(_).set(E.buffer),_}),A=S.length?(E,_)=>{if(_&&typeof _=="object"&&_.$$vscode_array_buffer_reference$$){const w=_,{index:h}=w,g=k[h];if(w.view)switch(w.view.type){case 1:return new Int8Array(g,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return _}:void 0;return{message:JSON.parse(T,A),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(De[213],Ie([1,0,112]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:y=>y.scheme==="vscode-remote"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="file"?{scheme:"vscode-local",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoing:y=>y.scheme==="file"?{scheme:"vscode-remote",authority:P,path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="vscode-local"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoingScheme:y=>y==="file"?"vscode-remote":y==="vscode-local"?"file":y}}function D(P){return new c.URITransformer(t(P))}e.createURITransformer=D}),define(De[129],Ie([1,0,180,11,2,6,3,43,38,14]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var A;(function(V){V[V.PROGRAMMATIC=1]="PROGRAMMATIC",V[V.USER=2]="USER",V[V.EDIT=3]="EDIT",V[V.NAVIGATION=4]="NAVIGATION",V[V.JUMP=5]="JUMP"})(A=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var I;(function(V){V[V.IDENTICAL=1]="IDENTICAL",V[V.SIMILAR=2]="SIMILAR",V[V.DIFFERENT=3]="DIFFERENT"})(I=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(V){const H=V;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.isEditorPaneWithSelection=E;function _(V,H,Q){for(const K of Q.visibleEditorPanes)if(K.group.id===H&&V.matches(K.input))return K.getViewState()}e.findViewStateForEditor=_;function w(V){if(a(V))return!1;const H=V;return D.URI.isUri(H?.resource)}e.isResourceEditorInput=w;function h(V){if(a(V))return!1;const H=V;return H?.original!==void 0&&H.modified!==void 0}e.isResourceDiffEditorInput=h;function g(V){if(a(V)||h(V))return!1;const H=V;return H?.primary!==void 0&&H.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function f(V){if(a(V))return!1;const H=V;return H?H.resource===void 0||H.resource.scheme===k.Schemas.untitled||H.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=f;const v=/Untitled-\d+/;function m(V){return V.scheme===k.Schemas.untitled&&V.path.length>1&&!v.test(V.path)}e.isUntitledWithAssociatedResource=m;function r(V){if(a(V))return!1;const H=V;return D.URI.isUri(H?.base?.resource)&&D.URI.isUri(H?.input1?.resource)&&D.URI.isUri(H?.input2?.resource)&&D.URI.isUri(H?.result?.resource)}e.isResourceMergeEditorInput=r;var b;(function(V){V[V.SHORT=0]="SHORT",V[V.MEDIUM=1]="MEDIUM",V[V.LONG=2]="LONG"})(b=e.Verbosity||(e.Verbosity={}));var s;(function(V){V[V.EXPLICIT=1]="EXPLICIT",V[V.AUTO=2]="AUTO",V[V.FOCUS_CHANGE=3]="FOCUS_CHANGE",V[V.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource(H,Q){let K=this.mapIdToSaveSource.get(H);return K||(K={source:H,label:Q},this.mapIdToSaveSource.set(H,K)),K.source}getSourceLabel(H){return this.mapIdToSaveSource.get(H)?.label??H}}e.SaveSourceRegistry=new u;var o;(function(V){V[V.None=0]="None",V[V.Readonly=2]="Readonly",V[V.Untitled=4]="Untitled",V[V.Singleton=8]="Singleton",V[V.RequiresTrust=16]="RequiresTrust",V[V.CanSplitInGroup=32]="CanSplitInGroup",V[V.ForceDescription=64]="ForceDescription",V[V.CanDropIntoEditor=128]="CanDropIntoEditor",V[V.MultipleEditors=256]="MultipleEditors"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends P.Disposable{}e.AbstractEditorInput=l;function a(V){return V instanceof l}e.isEditorInput=a;function d(V){const H=V;return D.URI.isUri(H?.preferredResource)}function n(V){const H=V;return a(H?.primary)&&a(H?.secondary)}e.isSideBySideEditorInput=n;function i(V){const H=V;return a(H?.modified)&&a(H?.original)}e.isDiffEditorInput=i;function p(V){return a(V?.editor)}e.isEditorInputWithOptions=p;function C(V){const H=V;return p(V)&&H?.group!==void 0}e.isEditorInputWithOptionsAndGroup=C;function R(V){const H=V;return typeof H?.groupId=="number"&&a(H.editor)}e.isEditorIdentifier=R;var M;(function(V){V[V.UNKNOWN=0]="UNKNOWN",V[V.REPLACE=1]="REPLACE",V[V.MOVE=2]="MOVE",V[V.UNPIN=3]="UNPIN"})(M=e.EditorCloseContext||(e.EditorCloseContext={}));var $;(function(V){V[V.GROUP_ACTIVE=0]="GROUP_ACTIVE",V[V.GROUP_INDEX=1]="GROUP_INDEX",V[V.GROUP_LOCKED=2]="GROUP_LOCKED",V[V.EDITOR_OPEN=3]="EDITOR_OPEN",V[V.EDITOR_CLOSE=4]="EDITOR_CLOSE",V[V.EDITOR_MOVE=5]="EDITOR_MOVE",V[V.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",V[V.EDITOR_LABEL=7]="EDITOR_LABEL",V[V.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",V[V.EDITOR_PIN=9]="EDITOR_PIN",V[V.EDITOR_STICKY=10]="EDITOR_STICKY",V[V.EDITOR_DIRTY=11]="EDITOR_DIRTY",V[V.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})($=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(V){V[V.PRIMARY=1]="PRIMARY",V[V.SECONDARY=2]="SECONDARY",V[V.BOTH=3]="BOTH",V[V.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class L{getOriginalUri(H,Q){if(!H)return;if(r(H))return e.EditorResourceAccessor.getOriginalUri(H.result,Q);if(Q?.supportSideBySide){const{primary:de,secondary:ee}=this.getSideEditors(H);if(de&&ee){if(Q?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===x.ANY)return this.getOriginalUri(de,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:Q.filterByScheme});H=Q.supportSideBySide===x.PRIMARY?de:ee}}if(h(H)||g(H)||r(H))return;const K=d(H)?H.preferredResource:H.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}getSideEditors(H){return n(H)||g(H)?{primary:H.primary,secondary:H.secondary}:i(H)||h(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,Q){if(!H)return;if(r(H))return e.EditorResourceAccessor.getCanonicalUri(H.result,Q);if(Q?.supportSideBySide){const{primary:de,secondary:ee}=this.getSideEditors(H);if(de&&ee){if(Q?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===x.ANY)return this.getCanonicalUri(de,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:Q.filterByScheme});H=Q.supportSideBySide===x.PRIMARY?de:ee}}if(h(H)||g(H)||r(H))return;const K=H.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}filterUri(H,Q){if(Array.isArray(Q)){if(Q.some(K=>H.scheme===K))return H}else if(Q===H.scheme)return H}}e.EditorResourceAccessor=new L;var B;(function(V){V[V.LEFT=0]="LEFT",V[V.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class O{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(H){const Q=this.instantiationService=H.get(y.IInstantiationService);for(const[K,de]of this.editorSerializerConstructors)this.createEditorSerializer(K,de,Q);this.editorSerializerConstructors.clear()}createEditorSerializer(H,Q,K){const de=K.createInstance(Q);this.editorSerializerInstances.set(H,de)}registerFileEditorFactory(H){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=H}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(H,Q){if(this.editorSerializerConstructors.has(H)||this.editorSerializerInstances.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.instantiationService?this.createEditorSerializer(H,Q,this.instantiationService):this.editorSerializerConstructors.set(H,Q),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(H),this.editorSerializerInstances.delete(H)})}getEditorSerializer(H){return this.editorSerializerInstances.get(typeof H=="string"?H:H.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new O);async function z(V,H,Q){return!V||!V.length?[]:await Promise.all(V.map(async K=>{const de=D.URI.revive(K.fileUri);if(!de){Q.info("Cannot resolve the path because it is not valid.",K);return}if(!await H.canHandleResource(de)){Q.info("Cannot resolve the path because it cannot be handled",K);return}let fe=K.exists,Y=K.type;if(typeof fe!="boolean"||typeof Y!="number")try{Y=(await H.stat(de)).isDirectory?S.FileType.Directory:S.FileType.Unknown,fe=!0}catch(Ee){Q.error(Ee),fe=!1}if(!fe&&K.openOnlyIfExists){Q.info("Cannot resolve the path because it does not exist",K);return}if(Y===S.FileType.Directory){Q.info("Cannot resolve the path because it is a directory",K);return}const ve={...K.options,pinned:!0};return fe?{resource:de,options:ve}:{resource:de,options:ve,forceUntitled:!0}}))}e.pathsToEditors=z;var U;(function(V){V[V.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",V[V.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function F(V){const H=V;if(!H)return!1;const Q=H;if(Q.modified)return F(Q.modified);const K=H;return!!(K.contributionsState&&K.viewState&&Array.isArray(K.cursorState))}e.isTextEditorViewState=F}),define(De[89],Ie([1,0,14,2]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(T,S){return T.scheme===c.Schemas.http||T.scheme===c.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===c.Schemas.file&&(T=t.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:T.path})),t.URI.from({scheme:c.Schemas.https,authority:`${T.scheme}+${P(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=D;function P(T){return T.replace(/./g,S=>{const k=S.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?S:"-"+k.toString(16).padStart(4,"0")})}function y(T){return T.replace(/-([0-9a-f]{4})/g,(S,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=y}),define(De[214],Ie([1,0,4,6,89]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(T,S,k){this._proxy=T,this._editors=S,this._remoteInfo=k,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const A=S.getVisibleTextEditors();for(const I of this._insets.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,S,k,A,I){let E;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===T){E=m;break}if(!E)throw new Error("not a visible editor");const _=this,w=this._handlePool++,h=new c.Emitter,g=new c.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,D.asWebviewUri)(m,_._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(m){this._options=m,_._proxy.$setOptions(w,m)}get options(){return this._options}set html(m){this._html=m,_._proxy.$setHtml(w,m)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(m){return _._proxy.$postMessage(w,m)}},v=new class{constructor(){this.editor=T,this.line=S,this.height=k,this.webview=f,this.onDidDispose=g.event}dispose(){_._insets.has(w)&&(_._insets.delete(w),_._proxy.$disposeEditorInset(w),g.fire(),g.dispose(),h.dispose())}};return this._proxy.$createEditorInset(w,E.id,E.value.document.uri,S+1,k,A||{},I.identifier,I.extensionLocation),this._insets.set(w,{editor:T,inset:v,onDidReceiveMessage:h}),v}$onDidDispose(T){const S=this._insets.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this._insets.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=P}),define(De[130],Ie([1,0,4,18,181]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,S,k,A){const I={command:T};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof A=="number"){const E=setTimeout(()=>{clearTimeout(E);const _=this.pendingRequests.get(I.seq);if(_){this.pendingRequests.delete(I.seq);const w={type:"response",seq:0,request_seq:I.seq,success:!1,command:T,message:(0,D.localize)(0,null,A,T)};_(w)}},A)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,S){return T.type!=="event"||S.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,t.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback?.(T);break;case"request":this.requestCallback?.(T);break;case"response":{const S=T,k=this.pendingRequests.get(S.request_seq);k&&(this.pendingRequests.delete(S.request_seq),k(S));break}}}}internalSend(T,S){S.type=T,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((S,k)=>T.set(k,S)),await(0,t.timeout)(500),T.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(De[215],Ie([1,0,182,53,3]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const P=E=>c.localize(51,null,E);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var y;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(y=e.State||(e.State={}));function T(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var A;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(A=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,D.createDecorator)(e.DEBUG_SERVICE_ID);var I;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(I=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[216],Ie([1,0,8,2,9,24,14]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(o,l,a){return o.replace(T,function(d,n){return l&&n.length>0&&n[0]!=="_"?d:a&&a.hasOwnProperty(n)?a[n]:d})}e.formatPII=S;function k(o){const l={};for(const a of Object.keys(o))a.startsWith("!")||(l[a]=o[a]);return l}e.filterExceptionsFromTelemetry=k;function A(o){return o.configuration.request==="attach"&&!I(o)&&(!o.parentSession||A(o.parentSession))}e.isSessionAttach=A;function I(o){let l=o.configuration.type;if(!!l)return l==="vslsShare"&&(l=o.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(l,"extensionhost")||(0,c.equalsIgnoreCase)(l,"pwa-extensionhost")?o:o.parentSession?I(o.parentSession):void 0}e.getExtensionHostDebugSession=I;function E(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=E;function _(o,l,a){let d,n=0;const i=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=i.exec(o);){const C=p.index+1,R=C+p[0].length;if(C<=l&&R>=a){d=p[0],n=C;break}}if(d){const C=/\w+/g;let R=null;for(;(R=C.exec(d))&&!(R.index+1+n+R[0].length>=a););R&&(d=d.substring(0,C.lastIndex))}return d?{start:n,end:n+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=_;const w=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(o){return!!(o&&o.match(w))}e.isUri=h;function g(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(h(o.path))return t.URI.parse(o.path);if((0,D.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function f(o){if(typeof o.path=="object"){const l=t.URI.revive(o.path);if(l)return l.scheme===y.Schemas.file?l.fsPath:l.toString()}return o.path}function v(o,l){const a=l?g:f,d=(0,P.deepClone)(o);return r(d,(n,i)=>{n&&i&&(i.path=a(i))}),d}e.convertToDAPaths=v;function m(o,l){const a=l?g:f,d=(0,P.deepClone)(o);return r(d,(n,i)=>{!n&&i&&(i.path=a(i))}),d}e.convertToVSCPaths=m;function r(o,l){switch(o.type){case"event":{const a=o;switch(a.event){case"output":l(!1,a.body.source);break;case"loadedSource":l(!1,a.body.source);break;case"breakpoint":l(!1,a.body.breakpoint.source);break;default:break}break}case"request":{const a=o;switch(a.command){case"setBreakpoints":l(!0,a.arguments.source);break;case"breakpointLocations":l(!0,a.arguments.source);break;case"source":l(!0,a.arguments.source);break;case"gotoTargets":l(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(d=>l(!1,d));break;default:break}break}case"response":{const a=o;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(d=>l(!1,d.source));break;case"loadedSources":a.body.sources.forEach(d=>l(!1,d));break;case"scopes":a.body.scopes.forEach(d=>l(!1,d.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(d=>l(!1,d.source));break;case"setBreakpoints":a.body.breakpoints.forEach(d=>l(!1,d.source));break;case"disassemble":a.body?.instructions.forEach(n=>l(!1,n.location));break;default:break}break}}}function b(o){return o.filter(l=>!l.presentation?.hidden).sort((l,a)=>l.presentation?a.presentation?l.presentation.group?a.presentation.group?l.presentation.group!==a.presentation.group?l.presentation.group.localeCompare(a.presentation.group):s(l.presentation.order,a.presentation.order):-1:a.presentation.group?1:s(l.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=b;function s(o,l){return typeof o!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:o-l}async function u(o,l){const a=o.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if(a!=="none"&&(await l.saveAll(),a==="allEditorsInActiveGroup")){const d=l.activeEditorPane;d&&d.input.resource?.scheme===y.Schemas.untitled&&await l.save({editor:d.input,groupId:d.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(De[217],Ie([1,0,44,218,24,9,12,8,29,183,130]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class I extends A.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(f,v){this.outputStream=v,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,f.on("data",m=>this.handleData(m))}sendMessage(f){if(this.outputStream){const v=JSON.stringify(f);this.outputStream.write(`Content-Length: ${Buffer.byteLength(v,"utf8")}${I.TWO_CRLF}${v}`,"utf8")}}handleData(f){for(this.rawData=Buffer.concat([this.rawData,f]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const v=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,v.length>0)try{this.acceptMessage(JSON.parse(v))}catch(m){this._onError.fire(new Error((m.message||m)+`
`+v))}continue}}else{const v=this.rawData.indexOf(I.TWO_CRLF);if(v!==-1){const r=this.rawData.toString("utf8",0,v).split(I.HEADER_LINESEPARATOR);for(const b of r){const s=b.split(I.HEADER_FIELDSEPARATOR);s[0]==="Content-Length"&&(this.contentLength=Number(s[1]))}this.rawData=this.rawData.slice(v+I.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=I,I.TWO_CRLF=`\r
\r
`,I.HEADER_LINESEPARATOR=/\r?\n/,I.HEADER_FIELDSEPARATOR=/: */;class E extends I{startSession(){return new Promise((f,v)=>{let m=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),f(),m=!0}),this.socket.on("close",()=>{m?this._onError.fire(new Error("connection closed")):v(new Error("connection closed"))}),this.socket.on("error",r=>{m?this._onError.fire(r):v(r)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class _ extends E{constructor(f){super(),this.adapterServer=f}createConnection(f){return t.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",f)}}e.SocketDebugAdapter=_;class w extends E{constructor(f){super(),this.adapterServer=f}createConnection(f){return t.createConnection(this.adapterServer.path,f)}}e.NamedPipeDebugAdapter=w;class h extends I{constructor(f,v){super(),this.adapterExecutable=f,this.debugType=v}async startSession(){const f=this.adapterExecutable.command,v=this.adapterExecutable.args,m=this.adapterExecutable.options||{};try{if(f)if(P.isAbsolute(f)){if(!await S.Promises.exists(f))throw new Error(k.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let r=process.env;if(m.env&&Object.keys(m.env).length>0&&(r=D.mixin(D.deepClone(process.env),m.env)),f==="node")if(Array.isArray(v)&&v.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:r,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};m.cwd&&(s.cwd=m.cwd);const u=c.fork(v[0],v.slice(1),s);if(!u.pid)throw new Error(k.localize(2,null,v[0]));this.serverProcess=u}else throw new Error(k.localize(3,null));else{const b={env:r};m.cwd&&(b.cwd=m.cwd),this.serverProcess=c.spawn(f,v,b)}this.serverProcess.on("error",b=>{this._onError.fire(b)}),this.serverProcess.on("exit",(b,s)=>{this._onExit.fire(b)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stdin.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(r){this._onError.fire(r)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),y.isWindows?new Promise((f,v)=>{const m=c.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(r,b,s){if(r)return v(r)});m.on("exit",f),m.on("error",v)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(f,v){if(!f)return;const m=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?m.runtime=P.join(v,f.runtime):m.runtime=f.runtime),f.runtimeArgs&&(m.runtimeArgs=f.runtimeArgs),f.program&&(P.isAbsolute(f.program)?m.program=f.program:m.program=P.join(v,f.program)),f.args&&(m.args=f.args);const r=f;return r.win&&(m.win=h.extract(r.win,v)),r.winx86&&(m.winx86=h.extract(r.winx86,v)),r.windows&&(m.windows=h.extract(r.windows,v)),r.osx&&(m.osx=h.extract(r.osx,v)),r.linux&&(m.linux=h.extract(r.linux,v)),m}static platformAdapterExecutable(f,v){let m=Object.create(null);v=v.toLowerCase();for(const l of f)if(l.contributes){const a=l.contributes.debuggers;a&&a.length>0&&a.filter(d=>typeof d.type=="string"&&T.equalsIgnoreCase(d.type,v)).forEach(d=>{const n=h.extract(d,l.extensionLocation.fsPath);m=D.mixin(m,n,l.isBuiltin)})}let r;y.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=m.winx86||m.win||m.windows:y.isWindows?r=m.win||m.windows:y.isMacintosh?r=m.osx:y.isLinux&&(r=m.linux),r=r||m;const b=r.program||m.program,s=r.args||m.args,u=r.runtime||m.runtime,o=r.runtimeArgs||m.runtimeArgs;if(u)return{type:"executable",command:u,args:(o||[]).concat(typeof b=="string"?[b]:[]).concat(s||[])};if(b)return{type:"executable",command:b,args:s||[]}}}e.ExecutableDebugAdapter=h}),define(De[219],Ie([1,0,44,32,12]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(k,A){return new Promise((I,E)=>{let _="";const w=c.spawn(k,A);w.pid&&w.stdout.on("data",h=>{_+=h.toString()}),w.on("error",h=>{E(h)}),w.on("close",h=>{I(_)})})}async function y(k){if(k)if(D.isWindows){const A=await new Promise((I,E)=>{Z(["windows-process-tree"],I,E)});return new Promise(I=>{A.getProcessTree(k,E=>{I(!!E&&E.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(k)]).then(A=>{const I=A.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var T;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(T||(T={}));function S(k,A,I,E,_){k=k.trim().toLowerCase();let w;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?w=1:k.indexOf("cmd.exe")>=0?w=0:k.indexOf("bash")>=0?w=2:D.isWindows?w=0:w=2;let h,g=" ";switch(w){case 1:if(h=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),E){const f=(0,t.getDriveLetter)(E);f&&(g+=`${f}:; `),g+=`cd ${h(E)}; `}if(_)for(const f in _){const v=_[f];v===null?g+=`Remove-Item env:${f}; `:g+=`\${env:${f}}='${v}'; `}if(A.length>0){const f=A.shift(),v=I?f:h(f);g+=v[0]==="'"?`& ${v} `:`${v} `;for(const m of A)g+=m==="<"||m===">"||I?m:h(m),g+=" "}break;case 0:if(h=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(v=>f.includes(v))||f.length===0?`"${f}"`:f),E){const f=(0,t.getDriveLetter)(E);f&&(g+=`${f}: && `),g+=`cd ${h(E)} && `}if(_){g+='cmd /C "';for(const f in _){let v=_[f];v===null?g+=`set "${f}=" && `:(v=v.replace(/[&^|<>]/g,m=>`^${m}`),g+=`set "${f}=${v}" && `)}}for(const f of A)g+=f==="<"||f===">"||I?f:h(f),g+=" ";_&&(g+='"');break;case 2:{h=v=>(v=v.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),v.length===0?'""':v);const f=v=>/[^\w@%\/+=,.:^-]/.test(v)?`'${v.replace(/'/g,"'\\''")}'`:v;if(E&&(g+=`cd ${h(E)} ; `),_){g+="/usr/bin/env";for(const v in _){const m=_[v];m===null?g+=` -u ${f(v)}`:g+=` ${f(`${v}=${m}`)}`}g+=" "}for(const v of A)g+=v==="<"||v===">"||I?v:h(v),g+=" ";break}}return g}e.prepareCommand=S}),define(De[90],Ie([1,0,23,37,62,105,14,9,12,53]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var A;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(_=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var v;(function(z){z.scheme=y.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],F=new RegExp(`^[${U.join("")}]+`),V=7;function H(Y,ve){const Ee=ve.toString(V),Re=`${Ee.length<U.length?U[Ee.length-1]:"z"}${Ee}s${(0,c.encodeBase64)(c.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:z.scheme,fragment:Re})}z.generate=H;function Q(Y){if(Y.scheme!==z.scheme)return;const ve=Y.fragment.indexOf("s");if(ve<0)return;const Ee=parseInt(Y.fragment.substring(0,ve).replace(F,""),V),ke=(0,c.decodeBase64)(Y.fragment.substring(ve+1)).toString();if(!isNaN(Ee))return{handle:Ee,notebook:Y.with({scheme:ke,fragment:null})}}z.parse=Q;function K(Y,ve){return Y.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${ve??""},${Y.scheme!==y.Schemas.file?Y.scheme:""}`})}z.generateCellOutputUri=K;function de(Y){if(Y.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const ve=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!ve)return;const Ee=ve[1]&&ve[1]!==""?ve[1]:void 0,ke=ve[2];return{outputId:Ee,notebook:Y.with({scheme:ke||y.Schemas.file,fragment:null})}}z.parseCellOutputUri=de;function ee(Y,ve,Ee){return z.generate(Y,ve).with({scheme:Ee})}z.generateCellPropertyUri=ee;function fe(Y,ve){if(Y.scheme===ve)return z.parse(Y.with({scheme:z.scheme}))}z.parseCellPropertyUri=fe})(v=e.CellUri||(e.CellUri={}));const m=z=>S.isWindows?z.replace(/\//g,"\\"):z;class r{constructor(U=[],F=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=F,this.order=[...new Set(U)].map(V=>({pattern:V,matches:t.parse(m(V))}))}sort(U){const F=new Map(D.Iterable.map(U,H=>[H,m(H)]));let V=[];for(const{matches:H}of this.order)for(const[Q,K]of F)if(H(K)){V.push(Q),F.delete(Q);break}return F.size&&(V=V.concat([...F.keys()].sort((H,Q)=>this.defaultOrder.indexOf(H)-this.defaultOrder.indexOf(Q)))),V}prioritize(U,F){const V=this.findIndex(U);if(V===-1){this.order.unshift({pattern:U,matches:t.parse(m(U))});return}const H=new Set(F.map(K=>this.findIndex(K,V)));H.delete(-1);const Q=Array.from(H).sort();this.order.splice(V+1,0,...Q.map(K=>this.order[K]));for(let K=Q.length-1;K>=0;K--)this.order.splice(Q[K],1)}toArray(){return this.order.map(U=>U.pattern)}findIndex(U,F=this.order.length){const V=m(U);for(let H=0;H<F;H++)if(this.order[H].matches(V))return H;return-1}}e.MimeTypeDisplayOrder=r;function b(z,U,F,V=(H,Q)=>H===Q){const H=[];function Q(ee,fe,Y){if(fe===0&&Y.length===0)return;const ve=H[H.length-1];ve&&ve.start+ve.deleteCount===ee?(ve.deleteCount+=fe,ve.toInsert.push(...Y)):H.push({start:ee,deleteCount:fe,toInsert:Y})}let K=0,de=0;for(;;){if(K===z.length){Q(K,0,U.slice(de));break}if(de===U.length){Q(K,z.length-K,[]);break}const ee=z[K],fe=U[de];if(V(ee,fe)){K+=1,de+=1;continue}F(fe)?(Q(K,1,[]),K+=1):(Q(K,0,[fe]),de+=1)}return H}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(z){z.default="default",z.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(z){const U=z;return!!((typeof U.include=="string"||t.isRelativePattern(U.include))&&(typeof U.exclude=="string"||t.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=u;function o(z,U,F){if(Array.isArray(z.viewType)&&z.viewType.indexOf(U)>=0||z.viewType===U)return!0;if(z.filenamePattern){const V=u(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,H=u(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(t.match(V,(0,T.basename)(F.fsPath).toLowerCase()))return!(H&&t.match(H,(0,T.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var l;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(U){return`${a._prefix}${U}`}static parse(U){if(U.startsWith(a._prefix))return U.substring(a._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a._prefix="notebook/";function d(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.isTextStreamMime=d;const n=new TextDecoder;function i(z){const U=[];let F=!1;for(const V of z)(U.length===0||F)&&(U.push(V),F=!0);return M(U),O(c.VSBuffer.concat(U.map(V=>c.VSBuffer.wrap(V))))}e.compressOutputItemStreams=i;const p=`${String.fromCharCode(27)}[A`,C=p.split("").map(z=>z.charCodeAt(0)),R=10;function M(z){z.forEach((U,F)=>{if(F===0||U.length<p.length)return;const V=z[F-1],H=U.subarray(0,p.length);if(H[0]===C[0]&&H[1]===C[1]&&H[2]===C[2]){const Q=V.lastIndexOf(R);if(Q===-1)return;z[F-1]=V.subarray(0,Q),z[F]=U.subarray(p.length)}})}function $(z){let U=z;do z=U,U=z.replace(/[^\n]\x08/gm,"");while(U.length<z.length);return z}function x(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const U=z.match(/^(.*)\r+/m)[1];let F=z.match(/\r+(.*)$/m)[1];F=F+U.slice(F.length,U.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,F)}return z}const L="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(z){return!z.buffer.includes(L)&&!z.buffer.includes(B)?z:c.VSBuffer.fromString(x($(n.decode(z.buffer))))}}),define(De[220],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(De[221],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=c;function t(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=t;function D(y){return Array.from(y.entries()).map(T=>[T[0],c(T[1].map)])}e.serializeEnvironmentVariableCollections=D;function P(y){return new Map(y.map(T=>[T[0],{map:t(T[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(De[56],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(P){P.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(y,T,S=y.parent){if(y._isRoot)return new D([T]);const k=[y.id];for(let A=S;A&&A.id!==T;A=A.parent)k.push(A.id);return k.push(T),new D(k.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const T=y.indexOf("\0");return T===-1?y:y.slice(0,T)}static fromString(y){return new D(y.split("\0"))}static join(y,T){return new D([...y.path,T])}static joinToString(y,T){return y.toString()+"\0"+T}static parentId(y){const T=y.lastIndexOf("\0");return T===-1?void 0:y.slice(0,T)}static compare(y,T){return y===T?0:T.startsWith(y+"\0")?2:y.startsWith(T+"\0")?3:1}constructor(y,T=y.length){if(this.path=y,this.viewEnd=T,y.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new D(this.path,y)}*idsToRoot(){for(let y=this.viewEnd;y>0;y--)yield new D(this.path,y)}compare(y){if(typeof y=="string")return D.compare(this.toString(),y);for(let T=0;T<y.viewEnd&&T<this.viewEnd;T++)if(y.path[T]!==this.path[T])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=D}),define(De[67],Ie([1,0,2,35,56]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var P;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(P=e.TestResultState||(e.TestResultState={}));var y;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(y=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(n){n.serialize=i=>({range:i.range.toJSON(),uri:i.uri.toJSON()}),n.deserialize=i=>({range:t.Range.lift(i.range),uri:c.URI.revive(i.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var S;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var k;(function(n){n.serialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&T.serialize(i.location)}),n.deserialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&T.deserialize(i.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const A=(n,i)=>`${i?"s":"e"}${n}`;e.getMarkId=A;var I;(function(n){n.serialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&T.serialize(i.location)}),n.deserialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&T.deserialize(i.location)})})(I=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(n){n.serialize=i=>i.type===0?k.serialize(i):I.serialize(i),n.deserialize=i=>i.type===0?k.deserialize(i):I.deserialize(i)})(E=e.ITestMessage||(e.ITestMessage={}));var _;(function(n){n.serializeWithoutMessages=i=>({state:i.state,duration:i.duration,messages:[]}),n.serialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(E.serialize)}),n.deserialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(E.deserialize)})})(_=e.ITestTaskState||(e.ITestTaskState={}));const w="\0",h=(n,i)=>n+w+i;e.namespaceTestTag=h;const g=n=>{const i=n.indexOf(w);return{ctrlId:n.slice(0,i),tagId:n.slice(i+1)}};e.denamespaceTestTag=g;var f;(function(n){n.serialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?.toJSON(),range:i.range?.toJSON()||null,description:i.description,error:i.error,sortText:i.sortText}),n.deserialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?c.URI.revive(i.uri):void 0,range:i.range?t.Range.lift(i.range):null,description:i.description,error:i.error,sortText:i.sortText})})(f=e.ITestItem||(e.ITestItem={}));var v;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var m;(function(n){n.serialize=i=>({expand:i.expand,item:f.serialize(i.item)}),n.deserialize=i=>({controllerId:D.TestId.root(i.item.extId),expand:i.expand,item:f.deserialize(i.item)})})(m=e.InternalTestItem||(e.InternalTestItem={}));var r;(function(n){n.serialize=i=>{let p;return i.item&&(p={},i.item.label!==void 0&&(p.label=i.item.label),i.item.tags!==void 0&&(p.tags=i.item.tags),i.item.busy!==void 0&&(p.busy=i.item.busy),i.item.uri!==void 0&&(p.uri=i.item.uri?.toJSON()),i.item.range!==void 0&&(p.range=i.item.range?.toJSON()),i.item.description!==void 0&&(p.description=i.item.description),i.item.error!==void 0&&(p.error=i.item.error),i.item.sortText!==void 0&&(p.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:p}},n.deserialize=i=>{let p;return i.item&&(p={},i.item.label!==void 0&&(p.label=i.item.label),i.item.tags!==void 0&&(p.tags=i.item.tags),i.item.busy!==void 0&&(p.busy=i.item.busy),i.item.range!==void 0&&(p.range=i.item.range?t.Range.lift(i.item.range):null),i.item.description!==void 0&&(p.description=i.item.description),i.item.error!==void 0&&(p.error=i.item.error),i.item.sortText!==void 0&&(p.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:p}}})(r=e.ITestItemUpdate||(e.ITestItemUpdate={}));const b=(n,i)=>{i.expand!==void 0&&(n.expand=i.expand),i.item!==void 0&&(n.item=n.item?Object.assign(n.item,i.item):i.item)};e.applyTestItemUpdate=b;var s;(function(n){n.serializeWithoutMessages=i=>({...m.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(_.serializeWithoutMessages),retired:i.retired}),n.serialize=i=>({...m.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(_.serialize),retired:i.retired}),n.deserialize=i=>({...m.deserialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(_.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var u;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var o;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(n){n.deserialize=i=>i.op===0?{op:i.op,item:m.deserialize(i.item)}:i.op===1?{op:i.op,item:r.deserialize(i.item)}:i.op===2?{op:i.op,uri:c.URI.revive(i.uri),docv:i.docv}:i,n.serialize=i=>i.op===0?{op:i.op,item:m.serialize(i.item)}:i.op===1?{op:i.op,item:r.serialize(i.item)}:i})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class a{add(i){}update(i){}remove(i,p){}complete(){}}e.IncrementalChangeCollector=a;class d{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const p=this.createChangeCollector();for(const C of i)switch(C.op){case 0:{const R=m.deserialize(C.item),M=D.TestId.parentId(R.item.extId)?.toString();if(M){if(this.items.has(M)){const $=this.items.get(M);$.children.add(R.item.extId);const x=this.createItem(R,$);this.items.set(R.item.extId,x),p.add(x)}}else{const $=this.createItem(R);this.roots.add($),this.items.set(R.item.extId,$),p.add($)}R.expand===2&&this.busyControllerCount++;break}case 1:{const R=r.deserialize(C.item),M=this.items.get(R.extId);if(!M)break;R.expand!==void 0&&(M.expand===2&&this.busyControllerCount--,R.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(M,R),p.update(M);break}case 3:{const R=this.items.get(C.itemId);if(!R)break;const M=D.TestId.parentId(R.item.extId)?.toString();M?this.items.get(M).children.delete(R.item.extId):this.roots.delete(R);const $=[[C.itemId]];for(;$.length;)for(const x of $.pop()){const L=this.items.get(x);L&&($.push(L.children),this.items.delete(x),p.remove(L,L!==R),L.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(C.itemId);break;case 4:this.updatePendingRoots(C.amount);break;case 6:this._tags.set(C.tag.id,C.tag);break;case 7:this._tags.delete(C.id);break}p.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new a}}e.AbstractIncrementalTestCollection=d}),define(De[91],Ie([1,0,18,4,6,48,67,56]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(f,v)=>f===v,A={range:(f,v)=>f===v?!0:!f||!v?!1:f.equalsRange(v),busy:k,label:k,description:k,error:k,tags:(f,v)=>!(f.length!==v.length||f.some(m=>!v.includes(m)))},I=(f,v)=>{let m;for(const[r,b]of Object.entries(A))b(f[r],v[r])||(m?m[r]=v[r]:m={[r]:v[r]});return m};class E extends D.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const m of this.diff)if(m.op===2&&m.uri===v.uri){m.docv=v.docv;return}break}case 1:{const m=this.diff[this.diff.length-1];if(m){if(m.op===1&&m.item.extId===v.item.extId){(0,y.applyTestItemUpdate)(m.item,v.item);return}if(m.op===0&&m.item.item.extId===v.item.extId){(0,y.applyTestItemUpdate)(m.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,m){const r=this.tree.get(v);if(!!r){if((r.expandLevels===void 0||m>r.expandLevels)&&(r.expandLevels=m),r.expand===1){const b=this.resolveChildren(r);return b.isOpen()?this.expandChildren(r,m-1):b.wait().then(()=>this.expandChildren(r,m-1))}else if(r.expand===3)return r.resolveBarrier?.isOpen()===!1?r.resolveBarrier.wait().then(()=>this.expandChildren(r,m-1)):this.expandChildren(r,m-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,m){switch(m.op){case 3:this.removeItem(T.TestId.joinToString(v.fullId,m.id));break;case 0:this.upsertItem(m.item,v);break;case 5:for(const r of m.ops)this.onTestItemEvent(v,r);break;case 1:this.diffTagRefs(m.new,m.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:m.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,P.assertNever)(m)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,m){const r=T.TestId.fromExtHostTestItem(v,this.root.id,m?.actual),b=this.options.getApiFor(v);b.parent&&b.parent!==m?.actual&&this.options.getChildren(b.parent).delete(v.id);let s=this.tree.get(r.toString());if(!s){s={fullId:r,actual:v,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(v,m),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,s,m);return}if(s.actual===v){this.connectItem(v,s,m);return}const u=this.options.getChildren(s.actual),o=s.actual,l=I(this.options.toITestItem(o),this.options.toITestItem(v));this.options.getApiFor(o).listener=void 0,s.actual=v,s.expand=0,l&&(l.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,o.tags,r.toString()),delete l.tags),this.onTestItemEvent(s,{op:4,update:l})),this.connectItemAndChildren(v,s,m);for(const[a,d]of u)this.options.getChildren(v).get(d.id)||this.removeItem(T.TestId.joinToString(r,d.id));this.documentSynced(s.actual.uri)}diffTagRefs(v,m,r){const b=new Set(m.map(s=>s.id));for(const s of v)b.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:r,item:{tags:v.map(s=>(0,y.namespaceTestTag)(this.options.controllerId,s.id))}}}),b.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const m=this.tags.get(v.id);m?m.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const m=this.tags.get(v);m&&!--m.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,y.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,m){this.options.getApiFor(v).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(v,m,r){this.setItemParent(v,r);const b=this.options.getApiFor(v);b.parent=r?.actual,b.listener=s=>this.onTestItemEvent(m,s),this.updateExpandability(m)}connectItemAndChildren(v,m,r){this.connectItem(v,m,r);for(const[b,s]of this.options.getChildren(v))this.upsertItem(s,m)}updateExpandability(v){let m;this._resolveHandler?v.resolveBarrier?m=v.resolveBarrier.isOpen()?3:2:m=v.actual.canResolveChildren?1:0:m=0,m!==v.expand&&(v.expand=m,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:m}}),m===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,m){if(m<0)return;const r=[];for(const[b,s]of this.options.getChildren(v.actual)){const u=this.expand(T.TestId.joinToString(v.fullId,s.id),m);(0,c.isThenable)(u)&&r.push(u)}if(r.length)return Promise.all(r).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const s=new c.Barrier;return s.open(),s}v.expand=2,this.pushExpandStateUpdate(v);const m=v.resolveBarrier=new c.Barrier,r=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let b;try{b=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(s){r(s)}return(0,c.isThenable)(b)?b.catch(r).then(()=>{m.open(),this.updateExpandability(v)}):(m.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const m=this.tree.get(v);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const r=[m];for(;r.length;){const b=r.pop();if(!!b){this.options.getApiFor(b.actual).listener=void 0;for(const s of b.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(b.fullId.toString());for(const[s,u]of this.options.getChildren(b.actual))r.push(this.tree.get(T.TestId.joinToString(b.fullId,u.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=E;class _ extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=_;class w extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class h extends Error{constructor(v,m,r){super(`TestItem with ID "${v}" is from controller "${m}" and cannot be added as a child of an item from controller "${r}".`)}}e.MixedTestItemController=h;const g=(f,v,m)=>{let r=new Map;return{get size(){return r.size},forEach(b,s){for(const u of r.values())b.call(s,u,this)},[Symbol.iterator](){return r.entries()},replace(b){const s=new Map,u=new Set(r.keys()),o={op:5,ops:[]};for(const l of b){if(!(l instanceof m))throw new w(l.id);const a=v(l).controllerId;if(a!==f.controllerId)throw new h(l.id,a,f.controllerId);if(s.has(l.id))throw new _(l.id);s.set(l.id,l),u.delete(l.id),o.ops.push({op:0,item:l})}for(const l of u.keys())o.ops.push({op:3,id:l});f.listener?.(o),r=s},add(b){if(!(b instanceof m))throw new w(b.id);r.set(b.id,b),f.listener?.({op:0,item:b})},delete(b){r.delete(b)&&f.listener?.({op:3,id:b})},get(b){return r.get(b)},toJSON(){return Array.from(r.values())}}};e.createTestItemChildren=g}),define(De[131],Ie([1,0,91]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(y,T)=>{const S={controllerId:T};return t.set(y,S),S};e.createPrivateApiFor=D;const P=y=>{const T=t.get(y);if(!T)throw new c.InvalidTestItemError(y?.id||"<unknown>");return T};e.getPrivateApiFor=P}),define(De[222],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(y,T){super(T),this.variable=y}}e.VariableError=D}),define(De[223],Ie([1,0,9,36,11,24,12,111,186,222,8]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(_,w,h,g){this._contributedVariables=new Map,this._context=_,this._labelService=w,this._userHomePromise=h,g&&(this._envVariablesPromise=g.then(f=>this.prepareEnv(f)))}prepareEnv(_){if(y.isWindows){const w=Object.create(null);return Object.keys(_).forEach(h=>{w[h.toLowerCase()]=_[h]}),w}return _}resolveWithEnvironment(_,w,h){return this.recursiveResolve({env:this.prepareEnv(_),userHome:void 0},w?w.uri:void 0,h)}async resolveAsync(_,w){const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,_?_.uri:void 0,w)}async resolveAnyBase(_,w,h,g){const f=P.deepClone(w);y.isWindows&&f.windows?Object.keys(f.windows).forEach(m=>f[m]=f.windows[m]):y.isMacintosh&&f.osx?Object.keys(f.osx).forEach(m=>f[m]=f.osx[m]):y.isLinux&&f.linux&&Object.keys(f.linux).forEach(m=>f[m]=f.linux[m]),delete f.windows,delete f.osx,delete f.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,_?_.uri:void 0,f,h,g)}async resolveAnyAsync(_,w,h){return this.resolveAnyBase(_,w,h)}async resolveAnyMap(_,w,h){const g=new Map;return{newConfig:await this.resolveAnyBase(_,w,h,g),resolvedVariables:g}}resolveWithInteractionReplace(_,w,h,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,w,h,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,w){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,w)}async recursiveResolve(_,w,h,g,f){if(D.isString(h))return this.resolveString(_,w,h,g,f);if(Array.isArray(h))return Promise.all(h.map(v=>this.recursiveResolve(_,w,v,g,f)));if(D.isObject(h)){const v=Object.create(null),m=await Promise.all(Object.keys(h).map(async r=>[await this.resolveString(_,w,r,g,f),await this.recursiveResolve(_,w,h[r],g,f)]));for(const[r,b]of m)v[r]=b;return v}return h}resolveString(_,w,h,g,f){return(0,A.replaceAsync)(h,I.VARIABLE_REGEXP,async(v,m)=>{if(m.includes(I.VARIABLE_LHS))return v;let r=await this.evaluateSingleVariable(_,v,m,w,g);return f?.set(m,r),r!==v&&D.isString(r)&&r.match(I.VARIABLE_REGEXP)&&(r=await this.resolveString(_,w,r,g,f)),r})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}async evaluateSingleVariable(_,w,h,g,f){let v;const m=h.split(":");m.length>1&&(h=m[0],v=m[1]);const r=u=>{const o=this._context.getFilePath();if(o)return o;throw new k.VariableError(u,(0,S.localize)(0,null,w))},b=u=>{const o=r(u);if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new k.VariableError(u,(0,S.localize)(1,null,w,c.basename(o)))},s=u=>{if(v){const o=this._context.getFolderUri(v);if(o)return o;throw new k.VariableError(u,(0,S.localize)(2,null,w,v))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new k.VariableError(u,(0,S.localize)(3,null,w)):new k.VariableError(u,(0,S.localize)(4,null,w))};switch(h){case"env":if(v){if(_.env){const u=_.env[y.isWindows?v.toLowerCase():v];if(D.isString(u))return u}return""}throw new k.VariableError(k.VariableKind.Env,(0,S.localize)(5,null,w));case"config":if(v){const u=this._context.getConfigurationValue(g,v);if(D.isUndefinedOrNull(u))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(6,null,w,v));if(D.isObject(u))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(7,null,w,v));return u}throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(8,null,w));case"command":return this.resolveFromMap(k.VariableKind.Command,w,v,f,"command");case"input":return this.resolveFromMap(k.VariableKind.Input,w,v,f,"input");case"extensionInstallFolder":if(v){const u=await this._context.getExtension(v);if(!u)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,w,v));return this.fsPath(u.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,w));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(s(k.VariableKind.WorkspaceFolder)));case"cwd":return g||v?(0,T.normalizeDriveLetter)(this.fsPath(s(k.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(s(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(_.userHome)return _.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,S.localize)(11,null,w))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new k.VariableError(k.VariableKind.LineNumber,(0,S.localize)(12,null,w))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new k.VariableError(k.VariableKind.SelectedText,(0,S.localize)(13,null,w))}case"file":return r(k.VariableKind.File);case"fileWorkspaceFolder":return b(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return g||v?c.relative(this.fsPath(s(k.VariableKind.RelativeFile)),r(k.VariableKind.RelativeFile)):r(k.VariableKind.RelativeFile);case"relativeFileDirname":{const u=c.dirname(r(k.VariableKind.RelativeFileDirname));if(g||v){const o=c.relative(this.fsPath(s(k.VariableKind.RelativeFileDirname)),u);return o.length===0?".":o}return u}case"fileDirname":return c.dirname(r(k.VariableKind.FileDirname));case"fileExtname":return c.extname(r(k.VariableKind.FileExtname));case"fileBasename":return c.basename(r(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=c.basename(r(k.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-c.extname(u).length)}case"fileDirnameBasename":return c.basename(c.dirname(r(k.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||w}case"execInstallFolder":{const u=this._context.getAppRoot();return u||w}case"pathSeparator":return c.sep;default:try{const u=v?`${h}:${v}`:h;return this.resolveFromMap(k.VariableKind.Unknown,w,u,f,void 0)}catch{return w}}}}resolveFromMap(_,w,h,g,f){if(h&&g){const v=f===void 0?g[h]:g[f+":"+h];if(typeof v=="string")return v;throw new k.VariableError(_,(0,S.localize)(14,null,w))}return w}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[132],Ie([1,0,3,129]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var D;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var P;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var T;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function k(w){const h=w;return(0,t.isEditorInput)(h?.editor)&&(0,t.isEditorInput)(h?.replacement)}e.isEditorReplacement=k;var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function E(w){const h=w;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=E;function _(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=_}),define(De[224],Ie([1,0,3,132]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(P){const y=P;return typeof P=="number"||(0,t.isEditorGroup)(y)}e.isPreferredGroup=D}),define(De[225],Ie([1,0,3,191]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(t.IEnvironmentService)}),define(De[226],Ie([1,0,26,4,9]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(I){this.removedDueToLooping=I}}e.DeltaExtensionsResult=P;class y{constructor(I){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=I,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const I of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(I.identifier))){console.error("Extension `"+I.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(I.identifier),I),this._extensionsArr.push(I),Array.isArray(I.activationEvents))for(let E of I.activationEvents)E==="onUri"&&(E=`onUri:${c.ExtensionIdentifier.toKey(I.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(I)}}set(I){this._extensionDescriptions=I,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(I,E){this._extensionDescriptions=k(this._extensionDescriptions,E),this._extensionDescriptions=this._extensionDescriptions.concat(I);const _=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=k(this._extensionDescriptions,_.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(_)}static _findLoopingExtensions(I){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,v){this.addNode(f),this.addNode(v),this._arcs.has(f)?this._arcs.get(f).push(v):this._arcs.set(f,[v])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,v){const m=E.getArcs(f);for(let r=0;r<m.length;r++)if(!v.has(m[r]))return!1;return!0}getNodes(){return this._nodesArr}},_=new Map;for(const f of I){const v=c.ExtensionIdentifier.toKey(f.identifier);if(_.set(v,f),f.extensionDependencies)for(const m of f.extensionDependencies){const r=c.ExtensionIdentifier.toKey(m);E.addArc(v,r)}}const w=new Set;E.getNodes().filter(f=>E.getArcs(f).length===0).forEach(f=>w.add(f));const h=E.getNodes().filter(f=>!w.has(f));let g;do{g=!1;for(let f=0;f<h.length;f++){const v=h[f];E.hasOnlyGoodArcs(v,w)&&(h.splice(f,1),f--,w.add(v),g=!0)}}while(g);return h.map(f=>_.get(f))}containsActivationEvent(I){return this._activationMap.has(I)}containsExtension(I){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(I))}getExtensionDescriptionsForActivationEvent(I){const E=this._activationMap.get(I);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(I){const E=this._extensionsMap.get(c.ExtensionIdentifier.toKey(I));return E||void 0}getExtensionDescriptionByUUID(I){for(const E of this._extensionsArr)if(E.uuid===I)return E}getExtensionDescriptionByIdOrUUID(I,E){return this.getExtensionDescription(I)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=y;var T;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(T||(T={}));function S(A,I){const E=A.isBuiltin?0:A.isUnderDevelopment?2:1,_=I.isBuiltin?0:I.isUnderDevelopment?2:1;if(E!==_)return E-_;const w=D.posix.basename(A.extensionLocation.path),h=D.posix.basename(I.extensionLocation.path);return w<h?-1:w>h?1:0}function k(A,I){const E=new Set;return I.forEach(_=>E.add(c.ExtensionIdentifier.toKey(_))),A.filter(_=>!E.has(c.ExtensionIdentifier.toKey(_.identifier)))}}),define(De[227],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(I){I[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(I){I[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function y(A){delete A[t.ENV_KEY],delete A[D.ENV_KEY],delete A[P.ENV_KEY]}function T(A,I){y(I),A.serialize(I)}e.writeExtHostConnection=T;function S(A){if(A[t.ENV_KEY])return k(A,new t(A[t.ENV_KEY]));if(A[D.ENV_KEY])return k(A,new D);if(A[P.ENV_KEY])return k(A,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function k(A,I){return y(A),I}}),define(De[92],Ie([1,0,23]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var D;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function y(k){const A=c.VSBuffer.alloc(1);switch(k){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=y;function T(k,A){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=T;var S;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[93],Ie([1,0,3,4,13,25,92,86,204,24,2]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let I=class{constructor(h,g){this.initData=h,this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,this._outputLogger=g.createLogger(A.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(h,g){const f=this.getTelemetryDetails(),v=new E(g,h,this._outputLogger,this.getBuiltInCommonProperties(h),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled});return this._telemetryLoggers.set(h.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(h,g){this._level=h,this._productConfig=g||{usage:!0,error:!0}}getBuiltInCommonProperties(h){const g={};switch(g["common.extname"]=h.name,g["common.extversion"]=h.version,g["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,g["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,g["common.vscodeversion"]=this.initData.version,g["common.isnewappinstall"]=_(this.initData.telemetryInfo.firstSessionDate),g["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case y.UIKind.Web:g["common.uikind"]="web";break;case y.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.initData.remote.authority)),g}$onDidChangeTelemetryLevel(h){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=h;const g=this.getTelemetryDetails();this._telemetryLoggers.forEach(f=>{f.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(h,g){const f=this._telemetryLoggers.get(h.value);return f?(f.logError(g),!0):!1}};I=Ve([He(0,P.IExtHostInitDataService),He(1,D.ILoggerService)],I),e.ExtHostTelemetry=I;class E{constructor(h,g,f,v,m){this._extension=g,this._logger=f,this._commonProperties=v,this._onDidChangeEnableStates=new t.Emitter,this._appender=h,this._telemetryEnablements={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(h,g){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:h,isErrorsEnabled:g},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(h){return this._appender.ignoreBuiltInCommonProperties||(h=(0,k.mixin)(h,this._commonProperties)),this._appender.additionalCommonProperties&&(h=(0,k.mixin)(h,this._appender.additionalCommonProperties)),h=(0,S.cleanData)(h,[]),h}logEvent(h,g){h=this._extension.identifier.value+"/"+h,g=this.mixInCommonPropsAndCleanData(g||{}),this._appender.logEvent(h,g),this._logger.trace(h,g)}logUsage(h,g){!this._telemetryEnablements.isUsageEnabled||this.logEvent(h,g)}logError(h,g){!this._telemetryEnablements.isErrorsEnabled||(typeof h=="string"?this.logEvent(h,g):this._appender.logException(h,g))}get apiTelemetryLogger(){if(!this._apiObject){const h=this,g={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return h._telemetryEnablements.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h._onDidChangeEnableStates.event.bind(h)};this._apiObject=Object.freeze(g)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=E;function _(w){const h=Date.now()-new Date(w).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=_,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(De[27],Ie([1,0,4,2,3,26,200]),function(Z,e,c,t,D,P,y){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class S{constructor(d){this.affinity=d,this.kind=1}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class k{constructor(d){this.affinity=d,this.kind=2}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class A{constructor(){this.kind=3,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"Remote"}}e.RemoteRunningLocation=A;class I{constructor(d){this.dependency=d}}e.MissingExtensionDependency=I;var E;(function(a){a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(a){if(a===null)return"None";switch(a){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=_;class w{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(d,n){const i=[],p=[],C=[],R=[],M=f(this._allExtensions),$=f(d),x=(z,U)=>z.extensionLocation.toString()===U.extensionLocation.toString()||z.isBuiltin===U.isBuiltin||z.isUserBuiltin===U.isUserBuiltin||z.isUnderDevelopment===U.isUnderDevelopment;for(const z of this._allExtensions){const U=$.get(P.ExtensionIdentifier.toKey(z.identifier));if(!U){i.push(z.identifier),M.delete(P.ExtensionIdentifier.toKey(z.identifier));continue}if(!x(z,U)){i.push(z.identifier),M.delete(P.ExtensionIdentifier.toKey(z.identifier));continue}}for(const z of d){const U=M.get(P.ExtensionIdentifier.toKey(z.identifier));if(!U){p.push(z);continue}if(!x(U,z)){i.push(U.identifier),M.delete(P.ExtensionIdentifier.toKey(U.identifier));continue}}const L=g(this._myExtensions),B=g(n);for(const z of this._myExtensions)B.has(P.ExtensionIdentifier.toKey(z))||C.push(z);for(const z of n)L.has(P.ExtensionIdentifier.toKey(z))||R.push(z);const O={toRemove:i,toAdd:p,myToRemove:C,myToAdd:R};return this.delta(O),O}delta(d){const{toRemove:n,toAdd:i,myToRemove:p,myToAdd:C}=d,R=g(n),M=g(p);for(let $=0;$<this._allExtensions.length;$++)R.has(P.ExtensionIdentifier.toKey(this._allExtensions[$].identifier))&&(this._allExtensions.splice($,1),$--);for(let $=0;$<this._myExtensions.length;$++)M.has(P.ExtensionIdentifier.toKey(this._myExtensions[$]))&&(this._myExtensions.splice($,1),$--);for(const $ of i)this._allExtensions.push($);for(const $ of C)this._myExtensions.push($)}containsExtension(d){for(const n of this._myExtensions)if(P.ExtensionIdentifier.equals(n,d))return!0;return!1}}e.ExtensionHostExtensions=w;class h{constructor(d){if(this[T]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,d)for(const n of d)this.add(n)}get size(){return this._map.size}add(d){return this._map.set(this._toKey(d),d),this}clear(){this._map.clear()}delete(d){return this._map.delete(this._toKey(d))}has(d){return this._map.has(this._toKey(d))}forEach(d,n){this._map.forEach(i=>d.call(n,i,i,this))}*entries(){for(const[d,n]of this._map)yield[n,n]}keys(){return this._map.values()}values(){return this._map.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=h;function g(a){const d=new Set;for(const n of a)d.add(P.ExtensionIdentifier.toKey(n));return d}e.extensionIdentifiersArrayToSet=g;function f(a){const d=new Map;for(const n of a)d.set(P.ExtensionIdentifier.toKey(n.identifier),n);return d}function v(a,d){return a.enabledApiProposals?a.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=v;function m(a,d){if(!v(a,d))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=m;class r{constructor(d,n,i,p){this.codeLoadingTime=d,this.activateCallTime=n,this.activateResolvedTime=i,this.activationReason=p}}e.ActivationTimes=r;class b{constructor(d,n){this.description=d,this.value=n}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function o(a,d){return{identifier:new P.ExtensionIdentifier((0,y.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!d,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,browserNlsBundleUris:a.browserNlsBundleUris}}e.toExtensionDescription=o;class l{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d,n){return Promise.resolve(0)}getInspectPorts(d,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(d,n){return Promise.resolve()}}e.NullExtensionService=l}),define(De[228],Ie([1,0,10,26,27,13,18]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class T{constructor(g,f,v,m){this.startup=g,this.codeLoadingTime=f,this.activateCallTime=v,this.activateResolvedTime=m}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class S{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,f){return g===-1||f===-1?-1:f-g}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class k{constructor(g,f,v,m,r,b){this.activationFailed=g,this.activationFailedError=f,this.activationTimes=v,this.module=m,this.exports=r,this.subscriptions=b}}e.ActivatedExtension=k;class A extends k{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class I extends k{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class E extends k{constructor(g){super(!0,g,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=E;let _=class{constructor(g,f,v,m,r){this._logService=r,this._registry=g,this._resolvedExtensionsSet=new Set,f.forEach(b=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(b))),this._externalExtensionsMap=new Map,v.forEach(b=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(b),b)),this._host=m,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[g,f]of this._operations)f.dispose()}isActivated(g){const f=this._operations.get(t.ExtensionIdentifier.toKey(g));return Boolean(f&&f.value)}getActivatedExtension(g){const f=this._operations.get(t.ExtensionIdentifier.toKey(g));if(!f||!f.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return f.value}async activateByEvent(g,f){if(this._alreadyActivatedEvents[g])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(g);await this._activateExtensions(v.map(m=>({id:m.identifier,reason:{startup:f,extensionId:m.identifier,activationEvent:g}}))),this._alreadyActivatedEvents[g]=!0}activateById(g,f){const v=this._registry.getExtensionDescription(g);if(!v)throw new Error(`Extension '${g}' is not known`);return this._activateExtensions([{id:v.identifier,reason:f}])}async _activateExtensions(g){const f=g.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(f.map(v=>v.wait()))}_handleActivationRequest(g){if(this._operations.has(t.ExtensionIdentifier.toKey(g.id)))return this._operations.get(t.ExtensionIdentifier.toKey(g.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id)))return this._createAndSaveOperation(g,null,[],null);const f=this._registry.getExtensionDescription(g.id);if(!f){const r=new Error(`Cannot activate unknown extension '${g.id.value}'`),b=this._createAndSaveOperation(g,null,[],new E(r));return this._host.onExtensionActivationError(g.id,r,new D.MissingExtensionDependency(g.id.value)),b}const v=[],m=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const r of m){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(r)))continue;const b=this._operations.get(t.ExtensionIdentifier.toKey(r));if(b){v.push(b);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(r))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(r)),reason:g.reason}));continue}const s=this._registry.getExtensionDescription(r);if(s){if(!s.main&&!s.browser)continue;v.push(this._handleActivationRequest({id:s.identifier,reason:g.reason}));continue}const u=f.displayName||f.identifier.value,o=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${r}'`),l=this._createAndSaveOperation(g,f.displayName,[],new E(o));return this._host.onExtensionActivationError(f.identifier,o,new D.MissingExtensionDependency(r)),l}return this._createAndSaveOperation(g,f.displayName,v,null)}_createAndSaveOperation(g,f,v,m){const r=new w(g.id,f,g.reason,v,m,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(g.id),r),r}};_=Ve([He(4,P.ILogService)],_),e.ExtensionsActivator=_;let w=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(g,f,v,m,r,b,s){this._id=g,this._displayName=f,this._reason=v,this._deps=m,this._value=r,this._host=b,this._logService=s,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let g=0;g<this._deps.length;g++){const f=this._deps[g];if(f.value&&!f.value.activationFailed){this._deps.splice(g,1),g--;continue}if(f.value&&f.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);v.detail=f.value.activationFailedError,this._value=new E(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(g=>g.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(g){const f=new Error;if(g&&g.name&&(f.name=g.name),g&&g.message?f.message=`Activating extension '${this._id.value}' failed: ${g.message}.`:f.message=`Activating extension '${this._id.value}' failed: ${g}.`,g&&g.stack&&(f.stack=g.stack),this._value=new E(f),this._isDisposed&&c.isCancellationError(g))return;this._host.onExtensionActivationError(this._id,f,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(g)}}};w=Ve([He(6,P.ILogService)],w)}),define(De[229],Ie([1,0,13,25,27]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends c.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:D.ExtensionHostLogFileName}))}};P=Ve([He(0,c.ILoggerService),He(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c},Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[7],Ie([1,0,17,10,110,28,105,8,11,2,31,38,127,90,27]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w){"use strict";var h,g,f,v,m,r,b,s,u,o,l,a,d,n,i,p,C,R,M,$,x,L,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O(q){return Object.assign(q,{apply:function(){const he=arguments.length===1?[]:arguments[1];return Reflect.construct(q,he,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(q,[]);{const[he,...Te]=arguments;return Reflect.construct(q,Te,he.constructor)}}})}let z=r=class{static from(...W){let he=W;return new r(function(){if(he){for(const Te of he)Te&&typeof Te.dispose=="function"&&Te.dispose();he=void 0}})}constructor(W){h.set(this,void 0),nt(this,h,W,"f")}dispose(){typeof Ue(this,h,"f")=="function"&&(Ue(this,h,"f").call(this),nt(this,h,void 0,"f"))}};h=new WeakMap,z=r=Ve([O],z),e.Disposable=z;let U=b=class{static Min(...W){if(W.length===0)throw new TypeError;let he=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isBefore(he)&&(he=Ke)}return he}static Max(...W){if(W.length===0)throw new TypeError;let he=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isAfter(he)&&(he=Ke)}return he}static isPosition(W){if(!W)return!1;if(W instanceof b)return!0;const{line:he,character:Te}=W;return typeof he=="number"&&typeof Te=="number"}static of(W){if(W instanceof b)return W;if(this.isPosition(W))return new b(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,he){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=W,this._character=he}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,he=0){if(W===null||he===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,he=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&he===0?this:new b(this.line+Te,this.character+he)}with(W,he=this.character){if(W===null||he===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,he=typeof W.character=="number"?W.character:this.character),Te===this.line&&he===this.character?this:new b(Te,he)}toJSON(){return{line:this.line,character:this.character}}};U=b=Ve([O],U),e.Position=U;let F=s=class{static isRange(W){return W instanceof s?!0:W?U.isPosition(W.start)&&U.isPosition(W.end):!1}static of(W){if(W instanceof s)return W;if(this.isRange(W))return new s(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,he,Te,Ke){let tt,ct;if(typeof W=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"?(tt=new U(W,he),ct=new U(Te,Ke)):U.isPosition(W)&&U.isPosition(he)&&(tt=U.of(W),ct=U.of(he)),!tt||!ct)throw new Error("Invalid arguments");tt.isBefore(ct)?(this._start=tt,this._end=ct):(this._start=ct,this._end=tt)}contains(W){return s.isRange(W)?this.contains(W.start)&&this.contains(W.end):U.isPosition(W)?!(U.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const he=U.Max(W.start,this._start),Te=U.Min(W.end,this._end);if(!he.isAfter(Te))return new s(he,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const he=U.Min(W.start,this._start),Te=U.Max(W.end,this.end);return new s(he,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,he=this.end){if(W===null||he===null)throw(0,t.illegalArgument)();let Te;return W?U.isPosition(W)?Te=W:(Te=W.start||this.start,he=W.end||this.end):Te=this.start,Te.isEqual(this._start)&&he.isEqual(this.end)?this:new s(Te,he)}toJSON(){return[this.start,this.end]}};F=s=Ve([O],F),e.Range=F;let V=u=class extends F{static isSelection(W){return W instanceof u?!0:W?F.isRange(W)&&U.isPosition(W.anchor)&&U.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,he,Te,Ke){let tt,ct;if(typeof W=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"?(tt=new U(W,he),ct=new U(Te,Ke)):U.isPosition(W)&&U.isPosition(he)&&(tt=U.of(W),ct=U.of(he)),!tt||!ct)throw new Error("Invalid arguments");super(tt,ct),this._anchor=tt,this._active=ct}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=u=Ve([O],V),e.Selection=V;class H{constructor(W,he,Te){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(he),this.connectionToken=Te}}e.ResolvedAuthority=H;class Q extends Error{static NotAvailable(W,he){return new Q(W,E.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(W){return new Q(W,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,he=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=he,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}}e.RemoteAuthorityResolverError=Q;var K;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var de;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(de=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=o=class{static isTextEdit(W){return W instanceof o?!0:W?F.isRange(W)&&typeof W.newText=="string":!1}static replace(W,he){return new o(W,he)}static insert(W,he){return o.replace(new F(W,W),he)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const he=new o(new F(new U(0,0),new U(0,0)),"");return he.newEol=W,he}get range(){return this._range}set range(W){if(W&&!F.isRange(W))throw(0,t.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this._newEol=W}constructor(W,he){this._range=W,this._newText=he}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=o=Ve([O],ee),e.TextEdit=ee;let fe=l=class{static isNotebookCellEdit(W){return W instanceof l?!0:W?jt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,he){return new l(W,he)}static insertCells(W,he){return new l(new jt(W,W),he)}static deleteCells(W){return new l(W,[])}static updateCellMetadata(W,he){const Te=new l(new jt(W,W),[]);return Te.newCellMetadata=he,Te}static updateNotebookMetadata(W){const he=new l(new jt(0,0),[]);return he.newNotebookMetadata=W,he}constructor(W,he){this.range=W,this.newCells=he}};fe=l=Ve([O],fe),e.NotebookEdit=fe;class Y{static isSnippetTextEdit(W){return W instanceof Y?!0:W?F.isRange(W.range)&&ke.isSnippetString(W.snippet):!1}static replace(W,he){return new Y(W,he)}static insert(W,he){return Y.replace(new F(W,W),he)}constructor(W,he){this.range=W,this.snippet=he}}e.SnippetTextEdit=Y;var ve;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let Ee=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,he,Te,Ke){this._edits.push({_type:1,from:W,to:he,options:Te,metadata:Ke})}createFile(W,he,Te){this._edits.push({_type:1,from:void 0,to:W,options:he,metadata:Te})}deleteFile(W,he,Te){this._edits.push({_type:1,from:W,to:void 0,options:he,metadata:Te})}replaceNotebookMetadata(W,he,Te){this._edits.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:he},notebookMetadata:he})}replaceNotebookCells(W,he,Te,Ke){const tt=he.start,ct=he.end;(tt!==ct||Te.length>0)&&this._edits.push({_type:5,uri:W,index:tt,count:ct-tt,cells:Te,metadata:Ke})}replaceNotebookCellMetadata(W,he,Te,Ke){this._edits.push({_type:3,metadata:Ke,uri:W,edit:{editType:8,index:he,metadata:Te}})}replace(W,he,Te,Ke){this._edits.push({_type:2,uri:W,edit:new ee(he,Te),metadata:Ke})}insert(W,he,Te,Ke){this.replace(W,new F(he,he),Te,Ke)}delete(W,he,Te){this.replace(W,he,"",Te)}has(W){return this._edits.some(he=>he._type===2&&he.uri.toString()===W.toString())}set(W,he){if(he)for(const Te of he){if(!Te)continue;let Ke,tt;Array.isArray(Te)?(Ke=Te[0],tt=Te[1]):Ke=Te,fe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(W,Ke.range.start,Ke.newCellMetadata,tt):Ke.newNotebookMetadata?this.replaceNotebookMetadata(W,Ke.newNotebookMetadata,tt):this.replaceNotebookCells(W,Ke.range,Ke.newCells,tt):Y.isSnippetTextEdit(Ke)?this._edits.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:tt}):this._edits.push({_type:2,uri:W,edit:Ke,metadata:tt})}else{for(let Te=0;Te<this._edits.length;Te++){const Ke=this._edits[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this._edits[Te]=void 0);break}}(0,c.coalesceInPlace)(this._edits)}}get(W){const he=[];for(const Te of this._edits)Te._type===2&&Te.uri.toString()===W.toString()&&he.push(Te.edit);return he}entries(){const W=new P.ResourceMap;for(const he of this._edits)if(he._type===2){let Te=W.get(he.uri);Te||(Te=[he.uri,[]],W.set(he.uri,Te)),Te[1].push(he.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ee=Ve([O],Ee),e.WorkspaceEdit=Ee;let ke=a=class{static isSnippetString(W){return W instanceof a?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=a._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,he=this._tabstop++){if(typeof W=="function"){const Te=new a;Te._tabstop=this._tabstop,W(Te),this._tabstop=Te._tabstop,W=Te.value}else W=a._escape(W);return this.value+="${",this.value+=he,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,he=this._tabstop++){const Te=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,he){if(typeof he=="function"){const Te=new a;Te._tabstop=this._tabstop,he(Te),this._tabstop=Te._tabstop,he=Te.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,he&&(this.value+=":",this.value+=he),this.value+="}",this}};ke=a=Ve([O],ke),e.SnippetString=ke;var Re;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(Re=e.DiagnosticTag||(e.DiagnosticTag={}));var ze;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(ze=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ie=d=class{static isLocation(W){return W instanceof d?!0:W?F.isRange(W.range)&&k.URI.isUri(W.uri):!1}constructor(W,he){if(this.uri=W,he)if(F.isRange(he))this.range=F.of(he);else if(U.isPosition(he))this.range=new F(he,he);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ie=d=Ve([O],ie),e.Location=ie;let ce=class{static is(W){return W?typeof W.message=="string"&&W.location&&F.isRange(W.location.range)&&k.URI.isUri(W.location.uri):!1}constructor(W,he){this.location=W,this.message=he}static isEqual(W,he){return W===he?!0:!W||!he?!1:W.message===he.message&&W.location.range.isEqual(he.location.range)&&W.location.uri.toString()===he.location.uri.toString()}};ce=Ve([O],ce),e.DiagnosticRelatedInformation=ce;let me=class{constructor(W,he,Te=ze.Error){if(!F.isRange(W))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=W,this.message=he,this.severity=Te}toJSON(){return{severity:ze[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,he){return W===he?!0:!W||!he?!1:W.message===he.message&&W.severity===he.severity&&W.code===he.code&&W.severity===he.severity&&W.source===he.source&&W.range.isEqual(he.range)&&(0,c.equals)(W.tags,he.tags)&&(0,c.equals)(W.relatedInformation,he.relatedInformation,ce.isEqual)}};me=Ve([O],me),e.Diagnostic=me;let J=class{constructor(W,he){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=he}};J=Ve([O],J),e.Hover=J;var ae;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ne=class{constructor(W,he=ae.Text){this.range=W,this.kind=he}toJSON(){return{range:this.range,kind:ae[this.kind]}}};ne=Ve([O],ne),e.DocumentHighlight=ne;var se;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(se=e.SymbolKind||(e.SymbolKind={}));var N;(function(q){q[q.Deprecated=1]="Deprecated"})(N=e.SymbolTag||(e.SymbolTag={}));let j=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,he,Te,Ke,tt){this.name=W,this.kind=he,this.containerName=tt,typeof Te=="string"&&(this.containerName=Te),Ke instanceof ie?this.location=Ke:Te instanceof F&&(this.location=new ie(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};j=n=Ve([O],j),e.SymbolInformation=j;let G=i=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(i.validate)}constructor(W,he,Te,Ke,tt){this.name=W,this.detail=he,this.kind=Te,this.range=Ke,this.selectionRange=tt,this.children=[],i.validate(this)}};G=i=Ve([O],G),e.DocumentSymbol=G;var X;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ge=class{constructor(W,he){this.title=W,this.kind=he}};ge=Ve([O],ge),e.CodeAction=ge;let be=p=class{constructor(W){this.value=W}append(W){return new p(this.value?this.value+p.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+p.sep)}};be.sep=".",be=p=Ve([O],be),e.CodeActionKind=be,be.Empty=new be(""),be.QuickFix=be.Empty.append("quickfix"),be.Refactor=be.Empty.append("refactor"),be.RefactorExtract=be.Refactor.append("extract"),be.RefactorInline=be.Refactor.append("inline"),be.RefactorMove=be.Refactor.append("move"),be.RefactorRewrite=be.Refactor.append("rewrite"),be.Source=be.Empty.append("source"),be.SourceOrganizeImports=be.Source.append("organizeImports"),be.SourceFixAll=be.Source.append("fixAll");let le=class{constructor(W,he){if(this.range=W,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};le=Ve([O],le),e.SelectionRange=le;class ye{constructor(W,he,Te,Ke,tt,ct){this.kind=W,this.name=he,this.detail=Te,this.uri=Ke,this.range=tt,this.selectionRange=ct}}e.CallHierarchyItem=ye;class Ce{constructor(W,he){this.fromRanges=he,this.from=W}}e.CallHierarchyIncomingCall=Ce;class We{constructor(W,he){this.fromRanges=he,this.to=W}}e.CallHierarchyOutgoingCall=We;var je;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(W,he){this.range=W,this.command=he}get isResolved(){return!!this.command}};Je=Ve([O],Je),e.CodeLens=Je;let Qe=C=class{static isMarkdownString(W){return W instanceof C?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,he=!1){g.set(this,void 0),nt(this,g,new D.MarkdownString(W,{supportThemeIcons:he}),"f")}get value(){return Ue(this,g,"f").value}set value(W){Ue(this,g,"f").value=W}get isTrusted(){return Ue(this,g,"f").isTrusted}set isTrusted(W){Ue(this,g,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,g,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,g,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,g,"f").supportHtml}set supportHtml(W){Ue(this,g,"f").supportHtml=W}get baseUri(){return Ue(this,g,"f").baseUri}set baseUri(W){Ue(this,g,"f").baseUri=W}appendText(W){return Ue(this,g,"f").appendText(W),this}appendMarkdown(W){return Ue(this,g,"f").appendMarkdown(W),this}appendCodeblock(W,he){return Ue(this,g,"f").appendCodeblock(he??"",W),this}};g=new WeakMap,Qe=C=Ve([O],Qe),e.MarkdownString=Qe;let Ze=class{constructor(W,he){this.label=W,this.documentation=he}};Ze=Ve([O],Ze),e.ParameterInformation=Ze;let Be=class{constructor(W,he){this.label=W,this.documentation=he,this.parameters=[]}};Be=Ve([O],Be),e.SignatureInformation=Be;let ut=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ut=Ve([O],ut),e.SignatureHelp=ut;var re;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(re=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var oe;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(oe=e.InlayHintKind||(e.InlayHintKind={}));let _e=class{constructor(W){this.value=W}};_e=Ve([O],_e),e.InlayHintLabelPart=_e;let ue=class{constructor(W,he,Te){this.position=W,this.label=he,this.kind=Te}};ue=Ve([O],ue),e.InlayHint=ue;var Pe;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(Le=e.CompletionItemKind||(e.CompletionItemKind={}));var Ne;(function(q){q[q.Deprecated=1]="Deprecated"})(Ne=e.CompletionItemTag||(e.CompletionItemTag={}));let qe=class{constructor(W,he){this.label=W,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&Le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};qe=Ve([O],qe),e.CompletionItem=qe;let Ye=class{constructor(W=[],he=!1){this.items=W,this.isIncomplete=he}};Ye=Ve([O],Ye),e.CompletionList=Ye;let it=class{constructor(W,he,Te){this.insertText=W,this.range=he,this.command=Te}};it=Ve([O],it),e.InlineSuggestion=it;let bt=class{constructor(W){this.commands=void 0,this.items=W}};bt=Ve([O],bt),e.InlineSuggestionList=bt;let st=class{constructor(W,he,Te){this.insertText=W,this.range=he,this.command=Te}};st=Ve([O],st),e.InlineSuggestionNew=st;let et=class{constructor(W,he){this.items=W,this.commands=he}};et=Ve([O],et),e.InlineSuggestionsNew=et;var wt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(wt=e.ViewColumn||(e.ViewColumn={}));var St;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(St=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ct;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Dt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Dt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ft;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(Ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ut;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(Ut=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Xe;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Xe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function W(he){switch(he){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=W}(Ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Tt=class{constructor(W,he){if(he&&!k.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!F.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=he}};Tt=Ve([O],Tt),e.DocumentLink=Tt;let Rt=class{constructor(W,he,Te,Ke){this.red=W,this.green=he,this.blue=Te,this.alpha=Ke}};Rt=Ve([O],Rt),e.Color=Rt;let Nt=class{constructor(W,he){if(he&&!(he instanceof Rt))throw(0,t.illegalArgument)("color");if(!F.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=he}};Nt=Ve([O],Nt),e.ColorInformation=Nt;let pt=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};pt=Ve([O],pt),e.ColorPresentation=pt;var Ae;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ae=e.ColorFormat||(e.ColorFormat={}));var Oe;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Oe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Se;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(Se=e.TerminalExitReason||(e.TerminalExitReason={}));class te{constructor(W,he,Te){if(this.startIndex=W,this.length=he,this.tooltip=Te,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=te;var Fe;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Fe=e.TerminalLocation||(e.TerminalLocation={}));class xe{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=xe;var rt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(rt=e.TaskRevealKind||(e.TaskRevealKind={}));var Ge;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Ge=e.TaskPanelKind||(e.TaskPanelKind={}));let ot=R=class{static from(W){switch(W){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}constructor(W,he){if(this.label=he,typeof W!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this._id=W}get id(){return this._id}};ot.Clean=new R("clean","Clean"),ot.Build=new R("build","Build"),ot.Rebuild=new R("rebuild","Rebuild"),ot.Test=new R("test","Test"),ot=R=Ve([O],ot),e.TaskGroup=ot;function lt(q){let W="";for(let he=0;he<q.length;he++)W+=q[he].replace(/,/g,",,")+",";return W}let It=class{constructor(W,he,Te){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=W,he!==void 0&&(Array.isArray(he)?(this._args=he,this._options=Te):this._options=he)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const he of this._args)W.push(he);return lt(W)}};It=Ve([O],It),e.ProcessExecution=It;let vt=class{constructor(W,he,Te){if(this._args=[],Array.isArray(he)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W,this._args=he,this._options=Te}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W,this._options=he}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const he of this._args)W.push(typeof he=="string"?he:he.value);return lt(W)}};vt=Ve([O],vt),e.ShellExecution=vt;var kt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(kt=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class Lt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Lt;let mt=M=class{constructor(W,he,Te,Ke,tt,ct){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof he=="string"?(this._name=this.name=he,this._source=this.source=Te,this.execution=Ke,ht=tt,this.__deprecated=!0):he===_t.Global||he===_t.Workspace?(this.target=he,this._name=this.name=Te,this._source=this.source=Ke,this.execution=tt,ht=ct):(this.target=he,this._name=this.name=Te,this._source=this.source=Ke,this.execution=tt,ht=ct),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof It?this._definition={type:M.ProcessType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:M.ShellType,id:this._execution.computeId()}:this._execution instanceof Lt?this._definition={type:M.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:M.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const he=this._definition.type;(M.EmptyType===he||M.ProcessType===he||M.ShellType===he||M.ExtensionCallbackType===he)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};mt.ExtensionCallbackType="customExecution",mt.ProcessType="process",mt.ShellType="shell",mt.EmptyType="$empty",mt=M=Ve([O],mt),e.Task=mt;var zt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(zt=e.ProgressLocation||(e.ProgressLocation={}));var tn;(function(q){function W(he){const Te=he;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}q.isViewBadge=W})(tn=e.ViewBadge||(e.ViewBadge={}));let Et=$=class{static isTreeItem(W,he){if(W instanceof $)return!0;const Te=W;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!k.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!k.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof Qe))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<Wt.None&&Te.collapsibleState>Wt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,w.checkProposedApiEnabled)(he,"treeItemCheckbox");const Ke=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,tt=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==nn.Checked&&Ke!==nn.Unchecked||tt!==void 0&&!(0,S.isString)(tt))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,he=Wt.None){this.collapsibleState=he,k.URI.isUri(W)?this.resourceUri=W:this.label=W}};Et=$=Ve([O],Et),e.TreeItem=Et;var Wt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Wt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var nn;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(nn=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let rn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,he){this.value=W,this.id=he??(0,A.generateUuid)()}};rn=Ve([O],rn),e.DataTransferItem=rn;let bn=class{constructor(W){f.set(this,new Map);for(const[he,Te]of W??[]){const Ke=Ue(this,f,"f").get(he);Ke?Ke.push(Te):Ue(this,f,"f").set(he,[Te])}}get(W){return Ue(this,f,"f").get(W)?.[0]}set(W,he){Ue(this,f,"f").set(W,[he])}forEach(W,he){for(const[Te,Ke]of Ue(this,f,"f"))for(const tt of Ke)W.call(he,tt,Te,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[W,he]of Ue(this,f,"f"))for(const Te of he)yield[W,Te]}};bn=Ve([O],bn),e.DataTransfer=bn;let Pt=class{constructor(W){this.insertText=W}};Pt=Ve([O],Pt),e.DocumentDropEdit=Pt;let sn=class{constructor(W){this.insertText=W}};sn=Ve([O],sn),e.DocumentPasteEdit=sn;let xt=class{constructor(W,he){this.id=W,this.color=he}};xt=Ve([O],xt),e.ThemeIcon=xt,xt.File=new xt("file"),xt.Folder=new xt("folder");let Yt=class{constructor(W){this.id=W}};Yt=Ve([O],Yt),e.ThemeColor=Yt;var on;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(on=e.ConfigurationTarget||(e.ConfigurationTarget={}));let dt=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=k.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,he){if(typeof W!="string"&&(!W||!k.URI.isUri(W)&&!k.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=k.URI.file(W):k.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=he}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};dt=Ve([O],dt),e.RelativePattern=dt;let Jt=class{constructor(W,he,Te,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof he=="string"&&(this.condition=he),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};Jt=Ve([O],Jt),e.Breakpoint=Jt;let Ht=class extends Jt{constructor(W,he,Te,Ke,tt){if(super(he,Te,Ke,tt),W===null)throw(0,t.illegalArgument)("location");this.location=W}};Ht=Ve([O],Ht),e.SourceBreakpoint=Ht;let Gt=class extends Jt{constructor(W,he,Te,Ke,tt){super(he,Te,Ke,tt),this.functionName=W}};Gt=Ve([O],Gt),e.FunctionBreakpoint=Gt;let an=class extends Jt{constructor(W,he,Te,Ke,tt,ct,ht){if(super(Ke,tt,ct,ht),!he)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=he,this.canPersist=Te}};an=Ve([O],an),e.DataBreakpoint=an;let wn=class{constructor(W,he,Te){this.command=W,this.args=he||[],this.options=Te}};wn=Ve([O],wn),e.DebugAdapterExecutable=wn;let cn=class{constructor(W,he){this.port=W,this.host=he}};cn=Ve([O],cn),e.DebugAdapterServer=cn;let En=class{constructor(W){this.path=W}};En=Ve([O],En),e.DebugAdapterNamedPipeServer=En;let ln=class{constructor(W){this.implementation=W}};ln=Ve([O],ln),e.DebugAdapterInlineImplementation=ln;let Zt=class{constructor(W,he){this.range=W,this.expression=he}};Zt=Ve([O],Zt),e.EvaluatableExpression=Zt;var Nn;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(Nn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Sn;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(Sn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let en=class{constructor(W,he){this.range=W,this.text=he}};en=Ve([O],en),e.InlineValueText=en;let _n=class{constructor(W,he,Te=!0){this.range=W,this.variableName=he,this.caseSensitiveLookup=Te}};_n=Ve([O],_n),e.InlineValueVariableLookup=_n;let yn=class{constructor(W,he){this.range=W,this.expression=he}};yn=Ve([O],yn),e.InlineValueEvaluatableExpression=yn;let Kt=class{constructor(W,he){this.frameId=W,this.stoppedLocation=he}};Kt=Ve([O],Kt),e.InlineValueContext=Kt;var Fn;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Fn=e.FileChangeType||(e.FileChangeType={}));let Cn=x=class extends Error{static FileExists(W){return new x(W,I.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(W){return new x(W,I.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(W){return new x(W,I.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(W){return new x(W,I.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(W){return new x(W,I.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(W){return new x(W,I.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(W,he=I.FileSystemProviderErrorCode.Unknown,Te){super(k.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,he),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Cn=x=Ve([O],Cn),e.FileSystemError=Cn;let Dn=class{constructor(W,he,Te){this.start=W,this.end=he,this.kind=Te}};Dn=Ve([O],Dn),e.FoldingRange=Dn;var Mn;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(Mn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var In;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(In=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Pn=e.CommentMode||(e.CommentMode={}));var An;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(An=e.CommentThreadState||(e.CommentThreadState={}));class $e{constructor(W,he=[]){this.tokenTypes=W,this.tokenModifiers=he}}e.SemanticTokensLegend=$e;function Vt(q){return typeof q>"u"||(0,S.isStringArray)(q)}class un{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let he=0,Te=W.tokenTypes.length;he<Te;he++)this._tokenTypeStrToInt.set(W.tokenTypes[he],he);for(let he=0,Te=W.tokenModifiers.length;he<Te;he++)this._tokenModifierStrToInt.set(W.tokenModifiers[he],he)}}push(W,he,Te,Ke,tt){if(typeof W=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this._pushEncoded(W,he,Te,Ke,tt);if(F.isRange(W)&&typeof he=="string"&&Vt(Te))return this._push(W,he,Te);throw(0,t.illegalArgument)()}_push(W,he,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(he))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,tt=W.start.character,ct=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(he);let Ot=0;if(Te)for(const Bt of Te){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(Bt);Ot|=1<<$t>>>0}this._pushEncoded(Ke,tt,ct,ht,Ot)}_pushEncoded(W,he,Te,Ke,tt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&he<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ot=this._data.length/5|0;let Bt=0,$t=0;for(let qt=0;qt<Ot;qt++){let Xt=this._data[5*qt],kn=this._data[5*qt+1];Xt===0?(Xt=Bt,kn+=$t):Xt+=Bt,this._data[5*qt]=Xt,this._data[5*qt+1]=kn,Bt=Xt,$t=kn}}let ct=W,ht=he;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=tt,this._prevLine=W,this._prevChar=he}static _sortAndDeltaEncode(W){const he=[],Te=W.length/5|0;for(let ht=0;ht<Te;ht++)he[ht]=ht;he.sort((ht,Ot)=>{const Bt=W[5*ht],$t=W[5*Ot];if(Bt===$t){const qt=W[5*ht+1],Xt=W[5*Ot+1];return qt-Xt}return Bt-$t});const Ke=new Uint32Array(W.length);let tt=0,ct=0;for(let ht=0;ht<Te;ht++){const Ot=5*he[ht],Bt=W[Ot+0],$t=W[Ot+1],qt=W[Ot+2],Xt=W[Ot+3],kn=W[Ot+4],Zn=Bt-tt,Di=Zn===0?$t-ct:$t,Tn=5*ht;Ke[Tn+0]=Zn,Ke[Tn+1]=Di,Ke[Tn+2]=qt,Ke[Tn+3]=Xt,Ke[Tn+4]=kn,tt=Bt,ct=$t}return Ke}build(W){return this._dataIsSortedAndDeltaEncoded?new gt(new Uint32Array(this._data),W):new gt(un._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=un;class gt{constructor(W,he){this.resultId=he,this.data=W}}e.SemanticTokens=gt;class Un{constructor(W,he,Te){this.start=W,this.deleteCount=he,this.data=Te}}e.SemanticTokensEdit=Un;class Bn{constructor(W,he){this.resultId=he,this.edits=W}}e.SemanticTokensEdits=Bn;var Rn;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Rn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let dn=class{constructor(){}};dn.Back={iconPath:new xt("arrow-left")},dn=Ve([O],dn),e.QuickInputButtons=dn;var hn;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(hn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zn;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(zn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Wn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Wn=e.ExtensionKind||(e.ExtensionKind={}));class Hn{static validate(W){if(W.badge){let he=(0,T.nextCharLength)(W.badge,0);if(he<W.badge.length&&(he+=(0,T.nextCharLength)(W.badge,he)),W.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,he,Te){this.badge=W,this.tooltip=he,this.color=Te}}e.FileDecoration=Hn;let fn=class{constructor(W){this.kind=W}};fn=Ve([O],fn),e.ColorTheme=fn;var $n;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})($n=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{static isNotebookRange(W){return W instanceof jt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,he){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");W<=he?(this._start=W,this._end=he):(this._start=he,this._end=W)}with(W){let he=this._start,Te=this._end;return W.start!==void 0&&(he=W.start),W.end!==void 0&&(Te=W.end),he===this._start&&Te===this._end?this:new jt(he,Te)}}e.NotebookRange=jt;class mn{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(he=>mn.isNotebookCellData(he))}static isNotebookCellData(W){return!0}constructor(W,he,Te,Ke,tt,ct,ht){this.kind=W,this.value=he,this.languageId=Te,this.mime=Ke,this.outputs=tt??[],this.metadata=ct,this.executionSummary=ht,mn.validate(this)}}e.NotebookCellData=mn;class xn{constructor(W){this.cells=W}}e.NotebookData=xn;class Mt{static isNotebookCellOutputItem(W){return W instanceof Mt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const he={name:W.name,message:W.message,stack:W.stack};return Mt.json(he,"application/vnd.code.notebook.error")}static stdout(W){return Mt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Mt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,he="application/octet-stream"){return new Mt(W,he)}static text(W,he=y.Mimes.text){const Te=Ue(Mt,v,"f",m).encode(String(W));return new Mt(Te,he)}static json(W,he="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return Mt.text(Te,he)}constructor(W,he){this.data=W,this.mime=he;const Te=(0,y.normalizeMimeType)(he,!0);if(!Te)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=Mt,v=Mt,m={value:new TextEncoder};class gn{static isNotebookCellOutput(W){return W instanceof gn?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,he=!1){const Te=new Set,Ke=new Set;for(let tt=0;tt<W.length;tt++){const ct=W[tt],ht=(0,y.normalizeMimeType)(ct.mime);if(!Te.has(ht)||(0,_.isTextStreamMime)(ht)){Te.add(ht);continue}Ke.add(tt),he&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?W:W.filter((tt,ct)=>!Ke.has(ct))}constructor(W,he,Te){this.items=gn.ensureUniqueMimeTypes(W,!0),typeof he=="string"?(this.id=he,this.metadata=Te):(this.id=(0,A.generateUuid)(),this.metadata=he??Te)}}e.NotebookCellOutput=gn;var pe;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(pe=e.NotebookCellKind||(e.NotebookCellKind={}));var we;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(we=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Me;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Me=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var at;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(at=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class yt{constructor(W,he){this.text=W,this.alignment=he}}e.NotebookCellStatusBarItem=yt;var At;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(At=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ii;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(ii=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ri{constructor(W,he=[]){this.uri=W,this.provides=(0,c.asArray)(he)}}e.NotebookRendererScript=ri;let Vn=class{constructor(W,he){this.label=W,this.timestamp=he}};Vn=Ve([O],Vn),e.TimelineItem=Vn;var si;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class ci{constructor(W,he){this.ranges=W,this.wordPattern=he}}e.LinkedEditingRanges=ci;class li{constructor(W,he){this._port=W,this._autoForwardAction=he}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=li;var ui;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var di;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(di=e.TestRunProfileKind||(e.TestRunProfileKind={}));let jn=class{constructor(W=void 0,he=void 0,Te=void 0){this.include=W,this.exclude=he,this.profile=Te}};jn=Ve([O],jn),e.TestRunRequest=jn;let qn=L=class{static diff(W,he,Te){const Ke=new L(W);return Ke.expectedOutput=he,Ke.actualOutput=Te,Ke}constructor(W){this.message=W}};qn=L=Ve([O],qn),e.TestMessage=qn;let Gn=class{constructor(W){this.id=W}};Gn=Ve([O],Gn),e.TestTag=Gn;let pn=class{constructor(W,he){this.covered=W,this.total=he}};pn=Ve([O],pn),e.CoveredCount=pn;let Kn=B=class{static fromDetails(W,he){const Te=new pn(0,0),Ke=new pn(0,0),tt=new pn(0,0);for(const ht of he)if("branches"in ht){Te.total+=1,Te.covered+=ht.executionCount>0?1:0;for(const Ot of ht.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const ct=new B(W,Te,Ke.total>0?Ke:void 0,tt.total>0?tt:void 0);return ct.detailedCoverage=he,ct}constructor(W,he,Te,Ke){this.uri=W,this.statementCoverage=he,this.branchCoverage=Te,this.functionCoverage=Ke}};Kn=B=Ve([O],Kn),e.FileCoverage=Kn;let Xn=class{constructor(W,he,Te=[]){this.executionCount=W,this.location=he,this.branches=Te}};Xn=Ve([O],Xn),e.StatementCoverage=Xn;let Qn=class{constructor(W,he){this.executionCount=W,this.location=he}};Qn=Ve([O],Qn),e.BranchCoverage=Qn;let Yn=class{constructor(W,he){this.executionCount=W,this.location=he}};Yn=Ve([O],Yn),e.FunctionCoverage=Yn;var hi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fi;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(fi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(W,he,Te,Ke,tt,ct){this.kind=W,this.name=he,this.detail=Te,this.uri=Ke,this.range=tt,this.selectionRange=ct}}e.TypeHierarchyItem=gi;class pi{constructor(W){this.uri=W}}e.TextTabInput=pi;class vi{constructor(W,he){this.original=W,this.modified=he}}e.TextDiffTabInput=vi;class bi{constructor(W,he,Te,Ke){this.base=W,this.input1=he,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=bi;class wi{constructor(W,he){this.uri=W,this.viewType=he}}e.CustomEditorTabInput=wi;class Ei{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Ei;class Si{constructor(W,he){this.uri=W,this.notebookType=he}}e.NotebookEditorTabInput=Si;class _i{constructor(W,he,Te){this.original=W,this.modified=he,this.notebookType=Te}}e.NotebookDiffEditorTabInput=_i;class yi{constructor(){}}e.TerminalEditorTabInput=yi;class Ci{constructor(W,he){this.uri=W,this.inputBoxUri=he}}e.InteractiveWindowInput=Ci}),define(De[133],Ie([1,0,48,14,8,160,103,7,17]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function A(w,h){h?k.set(w,h):k.delete(w)}e.setWordDefinitionFor=A;function I(w){return k.get(w)}e.getWordDefinitionFor=I;class E extends P.MirrorTextModel{constructor(h,g,f,v,m,r,b,s){super(g,f,v,m),this._proxy=h,this._languageId=r,this._isDirty=b,this.notebook=s,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,S.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===t.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},save(){return h._save()},getText(g){return g?h._getTextInRange(g):h.getText()},get eol(){return h._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(g){return h._lineAt(g)},offsetAt(g){return h._offsetAt(g)},positionAt(g){return h._positionAt(g)},validateRange(g){return h._validateRange(g)},validatePosition(g){return h._validatePosition(g)},getWordRangeAtPosition(g,f){return h._getWordRangeAtPosition(g,f)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,c.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,c.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const g=this._validateRange(h);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const f=this._eol,v=g.start.line,m=g.end.line,r=[];r.push(this._lines[v].substring(g.start.character));for(let b=v+1;b<m;b++)r.push(this._lines[b]);return r.push(this._lines[m].substring(0,g.end.character)),r.join(f)}_lineAt(h){let g;if(h instanceof T.Position?g=h.line:typeof h=="number"&&(g=h),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new _(g,this._lines[g],g===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(h),f=this._lines[g.index].length;return new T.Position(g.index,Math.min(g.remainder,f))}_validateRange(h){if(!(h instanceof T.Range))throw new Error("Invalid argument");const g=this._validatePosition(h.start),f=this._validatePosition(h.end);return g===h.start&&f===h.end?h:new T.Range(g.line,g.character,f.line,f.character)}_validatePosition(h){if(!(h instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:g,character:f}=h,v=!1;if(g<0)g=0,f=0,v=!0;else if(g>=this._lines.length)g=this._lines.length-1,f=this._lines[g].length,v=!0;else{const m=this._lines[g].length;f<0?(f=0,v=!0):f>m&&(f=m,v=!0)}return v?new T.Position(g,f):h}_getWordRangeAtPosition(h,g){const f=this._validatePosition(h);if(!g)g=I(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const v=(0,y.getWordAtText)(f.character+1,(0,y.ensureValidWordDefinition)(g),this._lines[f.line],0);if(v)return new T.Range(f.line,v.startColumn-1,f.line,v.endColumn-1)}}e.ExtHostDocumentData=E;class _{constructor(h,g,f){this._line=h,this._text=g,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=_}),define(De[230],Ie([1,0,7,16,4]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(T){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let S;switch(T){case"light":S=c.ColorThemeKind.Light;break;case"hcDark":S=c.ColorThemeKind.HighContrast;break;case"hcLight":S=c.ColorThemeKind.HighContrastLight;break;default:S=c.ColorThemeKind.Dark}this._actual=new c.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=Ve([He(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(De[15],Ie([1,0,17,23,110,28,145,82,24,11,2,35,66,122,131,129,90,56,67,224,7,61]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m,r,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Ae){function Oe(te){const{selectionStartLineNumber:Fe,selectionStartColumn:xe,positionLineNumber:rt,positionColumn:Ge}=te,ot=new r.Position(Fe-1,xe-1),lt=new r.Position(rt-1,Ge-1);return new r.Selection(ot,lt)}Ae.to=Oe;function Se(te){const{anchor:Fe,active:xe}=te;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Ae.from=Se})(s=e.Selection||(e.Selection={}));var u;(function(Ae){function Oe(te){if(!te)return;const{start:Fe,end:xe}=te;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Ae.from=Oe;function Se(te){if(!te)return;const{startLineNumber:Fe,startColumn:xe,endLineNumber:rt,endColumn:Ge}=te;return new r.Range(Fe-1,xe-1,rt-1,Ge-1)}Ae.to=Se})(u=e.Range||(e.Range={}));var o;(function(Ae){function Oe(Se){switch(Se){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ae.to=Oe})(o=e.TokenType||(e.TokenType={}));var l;(function(Ae){function Oe(te){return new r.Position(te.lineNumber-1,te.column-1)}Ae.to=Oe;function Se(te){return{lineNumber:te.line+1,column:te.character+1}}Ae.from=Se})(l=e.Position||(e.Position={}));var a;(function(Ae){function Oe(Fe,xe){return(0,c.coalesce)((0,c.asArray)(Fe).map(rt=>Se(rt,xe)))}Ae.from=Oe;function Se(Fe,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:te(Fe.scheme,xe),pattern:oe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function te(Fe,xe){return xe&&typeof Fe=="string"?xe.transformOutgoingScheme(Fe):Fe}})(a=e.DocumentSelector||(e.DocumentSelector={}));var d;(function(Ae){function Oe(te){switch(te){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Se(te){switch(te){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ae.to=Se})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(Ae){function Oe(te){let Fe;return te.code&&((0,k.isString)(te.code)||(0,k.isNumber)(te.code)?Fe=String(te.code):Fe={value:String(te.code.value),target:te.code.target}),{...u.from(te.range),message:te.message,source:te.source,code:Fe,severity:p.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(i.from),tags:Array.isArray(te.tags)?(0,c.coalesce)(te.tags.map(d.from)):void 0}}Ae.from=Oe;function Se(te){const Fe=new r.Diagnostic(u.to(te),te.message,p.to(te.severity));return Fe.source=te.source,Fe.code=(0,k.isString)(te.code)?te.code:te.code?.value,Fe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(i.to),Fe.tags=te.tags&&(0,c.coalesce)(te.tags.map(d.to)),Fe}Ae.to=Se})(n=e.Diagnostic||(e.Diagnostic={}));var i;(function(Ae){function Oe(te){return{...u.from(te.location.range),message:te.message,resource:te.location.uri}}Ae.from=Oe;function Se(te){return new r.DiagnosticRelatedInformation(new r.Location(te.resource,u.to(te)),te.message)}Ae.to=Se})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(Ae){function Oe(te){switch(te){case r.DiagnosticSeverity.Error:return _.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return _.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return _.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return _.MarkerSeverity.Hint}return _.MarkerSeverity.Error}Ae.from=Oe;function Se(te){switch(te){case _.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case _.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case _.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case _.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ae.to=Se})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var C;(function(Ae){function Oe(te){return typeof te=="number"&&te>=r.ViewColumn.One?te-1:te===r.ViewColumn.Beside?m.SIDE_GROUP:m.ACTIVE_GROUP}Ae.from=Oe;function Se(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Se})(C=e.ViewColumn||(e.ViewColumn={}));function R(Ae){return typeof Ae.range<"u"}function M(Ae){return Ae.length===0?!0:!!R(Ae[0])}e.isDecorationOptionsArr=M;var $;(function(Ae){function Oe(Ge){return Ge.map(Ae.from)}Ae.fromMany=Oe;function Se(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function te(Ge){let ot;if(Se(Ge)){const{language:kt,value:_t}=Ge;ot={value:"```"+kt+`
`+_t+"\n```\n"}}else r.MarkdownString.isMarkdownString(Ge)?ot={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ot={value:Ge}:ot={value:""};const lt=Object.create(null);ot.uris=lt;const It=kt=>{try{let _t=A.URI.parse(kt,!0);_t=_t.with({query:Fe(_t.query,lt)}),lt[kt]=_t}catch{}return""},vt=new y.marked.Renderer;return vt.link=It,vt.image=kt=>typeof kt=="string"?It(D.parseHrefAndDimensions(kt).href):"",(0,y.marked)(ot.value,{renderer:vt}),ot}Ae.from=te;function Fe(Ge,ot){if(!Ge)return Ge;let lt;try{lt=(0,T.parse)(Ge)}catch{}if(!lt)return Ge;let It=!1;return lt=(0,S.cloneAndChange)(lt,vt=>{if(A.URI.isUri(vt)){const kt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[kt]=vt,It=!0,kt}else return}),It?JSON.stringify(lt):Ge}function xe(Ge){const ot=new r.MarkdownString(Ge.value,Ge.supportThemeIcons);return ot.isTrusted=Ge.isTrusted,ot.supportHtml=Ge.supportHtml,ot.baseUri=Ge.baseUri?A.URI.from(Ge.baseUri):void 0,ot}Ae.to=xe;function rt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Ae.from(Ge)}Ae.fromStrict=rt})($=e.MarkdownString||(e.MarkdownString={}));function x(Ae){return M(Ae)?Ae.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?$.fromMany(Oe.hoverMessage):Oe.hoverMessage?$.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=x;function L(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?A.URI.file(Ae):Ae}e.pathOrURIToURI=L;var B;(function(Ae){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?L(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Ae.from=Oe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(Ae){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?L(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?B.from(Se.before):void 0,after:Se.after?B.from(Se.after):void 0}}Ae.from=Oe})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(Ae){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(Ae){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?z.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?O.from(Se.light):void 0,dark:Se.dark?O.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?L(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?B.from(Se.before):void 0,after:Se.after?B.from(Se.after):void 0}}Ae.from=Oe})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var F;(function(Ae){function Oe(te){return{text:te.newText,eol:te.newEol&&Qe.from(te.newEol),range:u.from(te.range)}}Ae.from=Oe;function Se(te){const Fe=new r.TextEdit(u.to(te.range),te.text);return Fe.newEol=typeof te.eol>"u"?void 0:Qe.to(te.eol),Fe}Ae.to=Se})(F=e.TextEdit||(e.TextEdit={}));var V;(function(Ae){function Oe(te,Fe){const xe={edits:[]};if(te instanceof r.WorkspaceEdit){const rt=new P.ResourceSet;for(const Ge of te._allEntries())Ge._type===1&&A.URI.isUri(Ge.to)&&Ge.from===void 0&&rt.add(Ge.to);for(const Ge of te._allEntries())Ge._type===1?xe.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contentsBase64:Ge.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ge.options.contents))},metadata:Ge.metadata}):Ge._type===2?xe.edits.push({resource:Ge.uri,textEdit:F.from(Ge.edit),versionId:rt.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?xe.edits.push({resource:Ge.uri,textEdit:{range:u.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:rt.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?xe.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&xe.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Ye.from)}})}return xe}Ae.from=Oe;function Se(te){const Fe=new r.WorkspaceEdit;for(const xe of te.edits)xe.textEdit?Fe.replace(A.URI.revive(xe.resource),u.to(xe.textEdit.range),xe.textEdit.text):Fe.renameFile(A.URI.revive(xe.oldResource),A.URI.revive(xe.newResource),xe.options);return Fe}Ae.to=Se})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(Ae){const Oe=Object.create(null);Oe[r.SymbolKind.File]=0,Oe[r.SymbolKind.Module]=1,Oe[r.SymbolKind.Namespace]=2,Oe[r.SymbolKind.Package]=3,Oe[r.SymbolKind.Class]=4,Oe[r.SymbolKind.Method]=5,Oe[r.SymbolKind.Property]=6,Oe[r.SymbolKind.Field]=7,Oe[r.SymbolKind.Constructor]=8,Oe[r.SymbolKind.Enum]=9,Oe[r.SymbolKind.Interface]=10,Oe[r.SymbolKind.Function]=11,Oe[r.SymbolKind.Variable]=12,Oe[r.SymbolKind.Constant]=13,Oe[r.SymbolKind.String]=14,Oe[r.SymbolKind.Number]=15,Oe[r.SymbolKind.Boolean]=16,Oe[r.SymbolKind.Array]=17,Oe[r.SymbolKind.Object]=18,Oe[r.SymbolKind.Key]=19,Oe[r.SymbolKind.Null]=20,Oe[r.SymbolKind.EnumMember]=21,Oe[r.SymbolKind.Struct]=22,Oe[r.SymbolKind.Event]=23,Oe[r.SymbolKind.Operator]=24,Oe[r.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Ae.from=Se;function te(Fe){for(const xe in Oe)if(Oe[xe]===Fe)return Number(xe);return r.SymbolKind.Property}Ae.to=te})(H=e.SymbolKind||(e.SymbolKind={}));var Q;(function(Ae){function Oe(te){switch(te){case r.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Se(te){switch(te){case 1:return r.SymbolTag.Deprecated}}Ae.to=Se})(Q=e.SymbolTag||(e.SymbolTag={}));var K;(function(Ae){function Oe(te){return{name:te.name,kind:H.from(te.kind),tags:te.tags&&te.tags.map(Q.from),containerName:te.containerName,location:ve.from(te.location)}}Ae.from=Oe;function Se(te){const Fe=new r.SymbolInformation(te.name,H.to(te.kind),te.containerName,ve.to(te.location));return Fe.tags=te.tags&&te.tags.map(Q.to),Fe}Ae.to=Se})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(Ae){function Oe(te){const Fe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:u.from(te.range),selectionRange:u.from(te.selectionRange),kind:H.from(te.kind),tags:te.tags?.map(Q.from)??[]};return te.children&&(Fe.children=te.children.map(Oe)),Fe}Ae.from=Oe;function Se(te){const Fe=new r.DocumentSymbol(te.name,te.detail,H.to(te.kind),u.to(te.range),u.to(te.selectionRange));return(0,c.isNonEmptyArray)(te.tags)&&(Fe.tags=te.tags.map(Q.to)),te.children&&(Fe.children=te.children.map(Se)),Fe}Ae.to=Se})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(Ae){function Oe(te){const Fe=new r.CallHierarchyItem(H.to(te.kind),te.name,te.detail||"",A.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Ae.to=Oe;function Se(te,Fe,xe){if(Fe=Fe??te._sessionId,xe=xe??te._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,name:te.name,detail:te.detail,kind:H.from(te.kind),uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(Q.from)}}Ae.from=Se})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var fe;(function(Ae){function Oe(Se){return new r.CallHierarchyIncomingCall(ee.to(Se.from),Se.fromRanges.map(te=>u.to(te)))}Ae.to=Oe})(fe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(Ae){function Oe(Se){return new r.CallHierarchyOutgoingCall(ee.to(Se.to),Se.fromRanges.map(te=>u.to(te)))}Ae.to=Oe})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Ae){function Oe(te){return{range:te.range&&u.from(te.range),uri:te.uri}}Ae.from=Oe;function Se(te){return new r.Location(A.URI.revive(te.uri),u.to(te.range))}Ae.to=Se})(ve=e.location||(e.location={}));var Ee;(function(Ae){function Oe(te){const Fe=te,xe=te;return{originSelectionRange:Fe.originSelectionRange?u.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:xe.uri,range:u.from(Fe.targetRange?Fe.targetRange:xe.range),targetSelectionRange:Fe.targetSelectionRange?u.from(Fe.targetSelectionRange):void 0}}Ae.from=Oe;function Se(te){return{targetUri:A.URI.revive(te.uri),targetRange:u.to(te.range),targetSelectionRange:te.targetSelectionRange?u.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?u.to(te.originSelectionRange):void 0}}Ae.to=Se})(Ee=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Ae){function Oe(te){return{range:u.from(te.range),contents:$.fromMany(te.contents)}}Ae.from=Oe;function Se(te){return new r.Hover(te.contents.map($.to),u.to(te.range))}Ae.to=Se})(ke=e.Hover||(e.Hover={}));var Re;(function(Ae){function Oe(te){return{range:u.from(te.range),expression:te.expression}}Ae.from=Oe;function Se(te){return new r.EvaluatableExpression(u.to(te.range),te.expression)}Ae.to=Se})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ze;(function(Ae){function Oe(te){if(te instanceof r.InlineValueText)return{type:"text",range:u.from(te.range),text:te.text};if(te instanceof r.InlineValueVariableLookup)return{type:"variable",range:u.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Se(te){switch(te.type){case"text":return{range:u.to(te.range),text:te.text};case"variable":return{range:u.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:u.to(te.range),expression:te.expression}}}Ae.to=Se})(ze=e.InlineValue||(e.InlineValue={}));var ie;(function(Ae){function Oe(te){return{frameId:te.frameId,stoppedLocation:u.from(te.stoppedLocation)}}Ae.from=Oe;function Se(te){return new r.InlineValueContext(te.frameId,u.to(te.stoppedLocation))}Ae.to=Se})(ie=e.InlineValueContext||(e.InlineValueContext={}));var ce;(function(Ae){function Oe(te){return{range:u.from(te.range),kind:te.kind}}Ae.from=Oe;function Se(te){return new r.DocumentHighlight(u.to(te.range),te.kind)}Ae.to=Se})(ce=e.DocumentHighlight||(e.DocumentHighlight={}));var me;(function(Ae){function Oe(Se){switch(Se){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ae.to=Oe})(me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(Ae){function Oe(Se){return{triggerKind:me.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Ae.to=Oe})(J=e.CompletionContext||(e.CompletionContext={}));var ae;(function(Ae){function Oe(te){switch(te){case r.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Se(te){switch(te){case 1:return r.CompletionItemTag.Deprecated}}Ae.to=Se})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(Ae){const Oe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Se(xe){return Oe.get(xe)??9}Ae.from=Se;const te=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Fe(xe){return te.get(xe)??r.CompletionItemKind.Property}Ae.to=Fe})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(Ae){function Oe(Se,te){const Fe=new r.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=ne.to(Se.kind),Fe.tags=Se.tags?.map(ae.to),Fe.detail=Se.detail,Fe.documentation=D.isMarkdownString(Se.documentation)?$.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,I.Range.isIRange(Se.range)?Fe.range=u.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:u.to(Se.range.insert),replacing:u.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new r.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof r.Range?new r.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(xe=>F.to(xe))),Fe.command=te&&Se.command?te.fromInternal(Se.command):void 0,Fe}Ae.to=Oe})(se=e.CompletionItem||(e.CompletionItem={}));var N;(function(Ae){function Oe(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:$.fromStrict(te.documentation)}}Ae.from=Oe;function Se(te){return{label:te.label,documentation:D.isMarkdownString(te.documentation)?$.to(te.documentation):te.documentation}}Ae.to=Se})(N=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(Ae){function Oe(te){return{label:te.label,documentation:$.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(N.from):[],activeParameter:te.activeParameter}}Ae.from=Oe;function Se(te){return{label:te.label,documentation:D.isMarkdownString(te.documentation)?$.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(N.to):[],activeParameter:te.activeParameter}}Ae.to=Se})(j=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Ae){function Oe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(j.from):[]}}Ae.from=Oe;function Se(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(j.to):[]}}Ae.to=Se})(G=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Ae){function Oe(Se,te){const Fe=new r.InlayHint(l.to(te.position),typeof te.label=="string"?te.label:te.label.map(ge.to.bind(void 0,Se)),te.kind&&be.to(te.kind));return Fe.textEdits=te.textEdits&&te.textEdits.map(F.to),Fe.tooltip=D.isMarkdownString(te.tooltip)?$.to(te.tooltip):te.tooltip,Fe.paddingLeft=te.paddingLeft,Fe.paddingRight=te.paddingRight,Fe}Ae.to=Oe})(X=e.InlayHint||(e.InlayHint={}));var ge;(function(Ae){function Oe(Se,te){const Fe=new r.InlayHintLabelPart(te.label);return Fe.tooltip=D.isMarkdownString(te.tooltip)?$.to(te.tooltip):te.tooltip,E.Command.is(te.command)&&(Fe.command=Se.fromInternal(te.command)),te.location&&(Fe.location=ve.to(te.location)),Fe}Ae.to=Oe})(ge=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(Ae){function Oe(te){return te}Ae.from=Oe;function Se(te){return te}Ae.to=Se})(be=e.InlayHintKind||(e.InlayHintKind={}));var le;(function(Ae){function Oe(te){return{range:u.from(te.range),url:te.target,tooltip:te.tooltip}}Ae.from=Oe;function Se(te){let Fe;if(te.url)try{Fe=typeof te.url=="string"?A.URI.parse(te.url,!0):A.URI.revive(te.url)}catch{}return new r.DocumentLink(u.to(te.range),Fe)}Ae.to=Se})(le=e.DocumentLink||(e.DocumentLink={}));var ye;(function(Ae){function Oe(te){const Fe=new r.ColorPresentation(te.label);return te.textEdit&&(Fe.textEdit=F.to(te.textEdit)),te.additionalTextEdits&&(Fe.additionalTextEdits=te.additionalTextEdits.map(xe=>F.to(xe))),Fe}Ae.to=Oe;function Se(te){return{label:te.label,textEdit:te.textEdit?F.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Fe=>F.from(Fe)):void 0}}Ae.from=Se})(ye=e.ColorPresentation||(e.ColorPresentation={}));var Ce;(function(Ae){function Oe(te){return new r.Color(te[0],te[1],te[2],te[3])}Ae.to=Oe;function Se(te){return[te.red,te.green,te.blue,te.alpha]}Ae.from=Se})(Ce=e.Color||(e.Color={}));var We;(function(Ae){function Oe(te){return{range:u.from(te.range)}}Ae.from=Oe;function Se(te){return new r.SelectionRange(u.to(te.range))}Ae.to=Se})(We=e.SelectionRange||(e.SelectionRange={}));var je;(function(Ae){function Oe(Se){switch(Se){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(Ae){function Oe(te){switch(te){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Se(te){switch(te){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ae.to=Se})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Qe;(function(Ae){function Oe(te){if(te===r.EndOfLine.CRLF)return 1;if(te===r.EndOfLine.LF)return 0}Ae.from=Oe;function Se(te){if(te===1)return r.EndOfLine.CRLF;if(te===0)return r.EndOfLine.LF}Ae.to=Se})(Qe=e.EndOfLine||(e.EndOfLine={}));var Ze;(function(Ae){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(Ze=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(Ae){function Oe(Se){const te={start:Se.start+1,end:Se.end+1};return Se.kind&&(te.kind=ut.from(Se.kind)),te}Ae.from=Oe})(Be=e.FoldingRange||(e.FoldingRange={}));var ut;(function(Ae){function Oe(Se){if(Se)switch(Se){case r.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Ae.from=Oe})(ut=e.FoldingRangeKind||(e.FoldingRangeKind={}));var re;(function(Ae){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?u.from(Se.selection):void 0,override:typeof Se.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(re=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var oe;(function(Ae){function Oe(xe){return xe instanceof r.RelativePattern?xe.toJSON():typeof xe=="string"?xe:Se(xe)||te(xe)?new r.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Ae.from=Oe;function Se(xe){const rt=xe;return rt?A.URI.isUri(rt.baseUri)&&typeof rt.pattern=="string":!1}function te(xe){const rt=xe;return rt?typeof rt.base=="string"&&typeof rt.pattern=="string":!1}function Fe(xe){return typeof xe=="string"?xe:new r.RelativePattern(A.URI.revive(xe.baseUri),xe.pattern)}Ae.to=Fe})(oe=e.GlobPattern||(e.GlobPattern={}));var _e;(function(Ae){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const te=Se;return{language:te.language,scheme:te.scheme,pattern:oe.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Ae.from=Oe})(_e=e.LanguageSelector||(e.LanguageSelector={}));var ue;(function(Ae){function Oe(te){return{start:te.start,end:te.end}}Ae.from=Oe;function Se(te){return new r.NotebookRange(te.start,te.end)}Ae.to=Se})(ue=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(Ae){function Oe(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Ae.to=Oe;function Se(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Ae.from=Se})(Pe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Le;(function(Ae){function Oe(Se){if(Se===g.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Se===g.NotebookCellExecutionState.Pending)return;if(Se===g.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Ae.to=Oe})(Le=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ne;(function(Ae){function Oe(te){switch(te){case r.NotebookCellKind.Markup:return g.CellKind.Markup;case r.NotebookCellKind.Code:default:return g.CellKind.Code}}Ae.from=Oe;function Se(te){switch(te){case g.CellKind.Markup:return r.NotebookCellKind.Markup;case g.CellKind.Code:default:return r.NotebookCellKind.Code}}Ae.to=Se})(Ne=e.NotebookCellKind||(e.NotebookCellKind={}));var qe;(function(Ae){function Oe(te){const Fe={metadata:te.metadata??Object.create(null),cells:[]};for(const xe of te.cells)r.NotebookCellData.validate(xe),Fe.cells.push(Ye.from(xe));return Fe}Ae.from=Oe;function Se(te){const Fe=new r.NotebookData(te.cells.map(Ye.to));return(0,k.isEmptyObject)(te.metadata)||(Fe.metadata=te.metadata),Fe}Ae.to=Se})(qe=e.NotebookData||(e.NotebookData={}));var Ye;(function(Ae){function Oe(te){return{cellKind:Ne.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Pe.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(bt.from):[]}}Ae.from=Oe;function Se(te){return new r.NotebookCellData(Ne.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(bt.to):void 0,te.metadata,te.internalMetadata?Pe.to(te.internalMetadata):void 0)}Ae.to=Se})(Ye=e.NotebookCellData||(e.NotebookCellData={}));var it;(function(Ae){function Oe(te){return{mime:te.mime,valueBytes:t.VSBuffer.wrap(te.data)}}Ae.from=Oe;function Se(te){return new r.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Ae.to=Se})(it=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var bt;(function(Ae){function Oe(te){return{outputId:te.id,items:te.items.map(it.from),metadata:te.metadata}}Ae.from=Oe;function Se(te){const Fe=te.items.map(it.to);return new r.NotebookCellOutput(Fe,te.outputId,te.metadata)}Ae.to=Se})(bt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(Ae){function Oe(Fe){return te(Fe)?{include:(0,k.withNullAsUndefined)(oe.from(Fe.include)),exclude:(0,k.withNullAsUndefined)(oe.from(Fe.exclude))}:(0,k.withNullAsUndefined)(oe.from(Fe))}Ae.from=Oe;function Se(Fe){return te(Fe)?{include:oe.to(Fe.include),exclude:oe.to(Fe.exclude)}:oe.to(Fe)}Ae.to=Se;function te(Fe){const xe=Fe;return xe?!(0,k.isUndefinedOrNull)(xe.include)&&!(0,k.isUndefinedOrNull)(xe.exclude):!1}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var et;(function(Ae){function Oe(Se,te,Fe){const xe=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(xe,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Ae.from=Oe})(et=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var wt;(function(Ae){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Ae.from=Oe})(wt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var St;(function(Ae){function Oe(te){return{uri:te.uri,provides:te.provides}}Ae.from=Oe;function Se(te){return new r.NotebookRendererScript(A.URI.revive(te.uri),te.provides)}Ae.to=Se})(St=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ct;(function(Ae){function Oe(te){return{message:$.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,location:te.location&&{range:u.from(te.location.range),uri:te.location.uri}}}Ae.from=Oe;function Se(te){const Fe=new r.TestMessage(typeof te.message=="string"?te.message:$.to(te.message));return Fe.actualOutput=te.actual,Fe.expectedOutput=te.expected,Fe.location=te.location?ve.to(te.location):void 0,Fe}Ae.to=Se})(Ct=e.TestMessage||(e.TestMessage={}));var ft;(function(Ae){Ae.namespace=v.namespaceTestTag,Ae.denamespace=v.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Dt;(function(Ae){function Oe(te){const Fe=(0,w.getPrivateApiFor)(te).controllerId;return{extId:f.TestId.fromExtHostTestItem(te,Fe).toString(),label:te.label,uri:A.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(xe=>ft.namespace(Fe,xe.id)),range:I.Range.lift(u.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&$.fromStrict(te.error)||null}}Ae.from=Oe;function Se(te){return{parent:void 0,error:void 0,id:f.TestId.fromString(te.extId).localId,label:te.label,uri:A.URI.revive(te.uri),tags:(te.tags||[]).map(Fe=>{const{tagId:xe}=ft.denamespace(Fe);return new r.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Ae.toPlain=Se})(Dt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(te){return{id:te.id}}Ae.from=Oe;function Se(te){return new r.TestTag(te.id)}Ae.to=Se}(ft=e.TestTag||(e.TestTag={}));var Ft;(function(Ae){const Oe=(te,Fe)=>{const xe=[];for(const[Ge,ot]of Fe)f.TestId.compare(ot.item.extId,Ge)===2&&(Fe.delete(Ge),xe.push(ot));const rt={...Dt.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ot=>ot.type===0).map(Ct.to)})),children:xe.map(Ge=>Oe(Ge,Fe))};for(const Ge of rt.children)Ge.parent=rt;return rt};function Se(te){const Fe=[],xe=new Map;for(const rt of te.items){xe.set(rt.item.extId,rt);const Ge=f.TestId.root(rt.item.extId);te.request.targets.some(ot=>ot.controllerId===Ge&&ot.testIds.includes(rt.item.extId))&&Fe.push(rt)}return{completedAt:te.completedAt,results:Fe.map(rt=>Oe(rt,xe))}}Ae.to=Se})(Ft=e.TestResults||(e.TestResults={}));var Ut;(function(Ae){function Oe(xe){return{covered:xe.covered,total:xe.covered}}function Se(xe){return"line"in xe?l.from(xe):u.from(xe)}function te(xe){return"branches"in xe?{count:xe.executionCount,location:Se(xe.location),type:1,branches:xe.branches.length?xe.branches.map(rt=>({count:rt.executionCount,location:rt.location&&Se(rt.location)})):void 0}:{type:0,count:xe.executionCount,location:Se(xe.location)}}Ae.fromDetailed=te;function Fe(xe){return{uri:xe.uri,statement:Oe(xe.statementCoverage),branch:xe.branchCoverage&&Oe(xe.branchCoverage),function:xe.functionCoverage&&Oe(xe.functionCoverage),details:xe.detailedCoverage?.map(te)}}Ae.fromFile=Fe})(Ut=e.TestCoverage||(e.TestCoverage={}));var Xe;(function(Ae){function Oe(Se){switch(Se){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Tt;(function(Ae){function Oe(te){const Fe=new r.TypeHierarchyItem(H.to(te.kind),te.name,te.detail||"",A.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Ae.to=Oe;function Se(te,Fe,xe){if(Fe=Fe??te._sessionId,xe=xe??te._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,kind:H.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(Q.from)}}Ae.from=Se})(Tt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Rt;(function(Ae){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Ae.from=Oe})(Rt=e.ViewBadge||(e.ViewBadge={}));var Nt;(function(Ae){function Oe(Se,te){const Fe=Se.fileData;return Fe?new class extends r.DataTransferItem{asFile(){return{name:Fe.name,uri:A.URI.revive(Fe.uri),data:(0,b.once)(()=>te())}}}("",Se.id):new r.DataTransferItem(Se.asString)}Ae.toDataTransferItem=Oe})(Nt=e.DataTransferItem||(e.DataTransferItem={}));var pt;(function(Ae){function Oe(te,Fe){const xe=te.items.map(([rt,Ge])=>[rt,Nt.toDataTransferItem(Ge,()=>Fe(Ge.id))]);return new r.DataTransfer(xe)}Ae.toDataTransfer=Oe;async function Se(te){const Fe={items:[]},xe=[];return te.forEach((rt,Ge)=>{xe.push((async()=>{const ot=await rt.asString(),lt=rt.asFile();Fe.items.push([Ge,{id:rt.id,asString:ot,fileData:lt?{name:lt.name,uri:lt.uri}:void 0}])})())}),await Promise.all(xe),Fe}Ae.toDataTransferDTO=Se})(pt=e.DataTransfer||(e.DataTransfer={}))}),define(De[231],Ie([1,0,2,10,7,15,63]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(k,A,I,E={timeout:1500,errors:3}){this._logService=k,this._documents=A,this._mainThreadBulkEdits=I,this._thresholds=E,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(A,I,E)=>{const w={dispose:this._callbacks.push([A,I,k])};return Array.isArray(E)&&E.push(w),w}}async $participateInSave(k,A){const I=c.URI.revive(k);let E=!1;const _=setTimeout(()=>E=!0,this._thresholds.timeout),w=[];try{for(const h of[...this._callbacks]){if(E)break;const g=this._documents.getDocument(I),f=await this._deliverEventAsyncAndBlameBadListeners(h,{document:g,reason:P.TextDocumentSaveReason.to(A)});w.push(f)}}finally{clearTimeout(_)}return w}_deliverEventAsyncAndBlameBadListeners([k,A,I],E){const _=this._badListeners.get(k);return typeof _=="number"&&_>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,A,E).then(()=>!0,w=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const h=this._badListeners.get(k);this._badListeners.set(k,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,A,I,E){const _=[],w=Date.now(),{document:h,reason:g}=E,{version:f}=h,v=Object.freeze({document:h,reason:g,waitUntil(m){if(Object.isFrozen(_))throw(0,t.illegalState)("waitUntil can not be called async");_.push(Promise.resolve(m))}});try{A.apply(I,[v])}catch(m){return Promise.reject(m)}return Object.freeze(_),new Promise((m,r)=>{const b=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(_).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(b),m(s)}).catch(s=>{clearTimeout(b),r(s)})}).then(m=>{const r={edits:[]};for(const b of m)if(Array.isArray(b)&&b.every(s=>s instanceof D.TextEdit))for(const{newText:s,newEol:u,range:o}of b)r.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:o&&P.Range.from(o),text:s,eol:u&&P.EndOfLine.from(u)}});if(r.edits.length!==0)return f===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(De[232],Ie([1,0,14,2,15,7,90]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(I,E,_,w){this.start=I,this.deletedCount=E,this.deletedItems=_,this.items=w}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(I,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,E,_){this.notebook=I,this._extHostDocument=E,this._cellData=_,this.handle=_.handle,this.uri=t.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=_.internalMetadata??{},this._metadata=Object.freeze(_.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(_.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const _={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return I._mime},set mime(w){I._mime=w},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(_)}return this._apiCell}setOutputs(I){this._outputs=I.map(D.NotebookCellOutput.to)}setOutputItems(I,E,_){const w=_.map(D.NotebookCellOutputItem.to),h=this._outputs.find(g=>g.id===I);if(h&&(E||(h.items.length=0),h.items.push(...w),h.items.length>1&&h.items.every(g=>y.isTextStreamMime(g.mime)))){const g=new Map,f=[];h.items.forEach(v=>{let m;g.has(v.mime)?m=g.get(v.mime):(m=[],g.set(v.mime,m),f.push(v.mime)),m.push(v.data)}),h.items.length=0,f.forEach(v=>{const m=y.compressOutputItemStreams(g.get(v));h.items.push({mime:v,data:m.buffer})})}}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=S;class k{constructor(I,E,_,w,h){this._proxy=I,this._textDocumentsAndEditors=E,this._textDocuments=_,this.uri=w,this.handle=k._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=h.viewType,this._metadata=Object.freeze(h.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,h.cells]],!0,void 0),this._versionId=h.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const I=this,E={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===c.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(_){return _=I._validateIndex(_),I._cells[_].apiCell},getCells(_){return(_?I._getCells(_):I._cells).map(h=>h.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(E)}return this._notebook}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,E,_){this._versionId=I.versionId,this._isDirty=E,this.acceptDocumentPropertiesChanged({metadata:_});const w={notebook:this.apiNotebook,metadata:_,cellChanges:[],contentChanges:[]},h=[];for(const f of I.rawEvents)f.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,w.contentChanges):f.kind===y.NotebookCellsChangeType.Move?this._moveCells(f.index,f.length,f.newIdx,w.contentChanges):f.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),h.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),h.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),h.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===y.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),h.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),h.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const g=new Map;for(let f=0;f<h.length;f++){const v=h[f],m=g.get(v.cell);if(m===void 0){const r=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});g.set(v.cell,r-1)}else w.cellChanges[m]={...w.cellChanges[m],...v}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let E=I.start|0,_=I.end|0;return E<0&&(E=0),_>this._cells.length&&(_=this._cells.length),I.with({start:E,end:_})}_getCells(I){I=this._validateRange(I);const E=[];for(let _=I.start;_<I.end;_++)E.push(this._cells[_]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,E,_){if(this._disposed)return;const w=[],h=[],g=[];if(I.reverse().forEach(f=>{const m=f[2].map(s=>{const u=new S(this,this._textDocumentsAndEditors,s);return E||h.push(S.asModelAddData(this.apiNotebook,s)),u}),r=new T(f[0],f[1],[],m),b=this._cells.splice(f[0],f[1],...m);for(const s of b)g.push(s.uri),r.deletedItems.push(s.apiCell);w.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:g}),_)for(const f of w)_.push(f.asApiEvent())}_moveCells(I,E,_,w){const h=this._cells.splice(I,E);this._cells.splice(_,0,...h);const g=[new T(I,E,h.map(f=>f.apiCell),[]),new T(_,0,[],h)];for(const f of g)w.push(f.asApiEvent())}_setCellOutputs(I,E){this._cells[I].setOutputs(E)}_setCellOutputItems(I,E,_,w){this._cells[I].setOutputItems(E,_,w)}_changeCellLanguage(I,E){const _=this._cells[I];_.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelLanguageChanged(_.uri,E)}_changeCellMime(I,E){const _=this._cells[I];_.apiCell.mime=E}_changeCellMetadata(I,E){this._cells[I].setMetadata(E)}_changeCellInternalMetadata(I,E){this._cells[I].setInternalMetadata(E)}getCellFromApiCell(I){return this._cells.find(E=>E.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(E=>E.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(De[134],Ie([1,0,10,15,7]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(T,S,k,A,I,E){this.id=T,this._proxy=S,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=I,this._visibleRanges=A,this._viewColumn=E}get apiEditor(){if(!this._editor){const T=this;this._editor={get notebook(){return T.notebookData.apiNotebook},get selection(){return T._selections[0]},set selection(S){this.selections=[S]},get selections(){return T._selections},set selections(S){if(!Array.isArray(S)||!S.every(D.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");T._selections=S,T._trySetSelections(S)},get visibleRanges(){return T._visibleRanges},revealRange(S,k){T._proxy.$tryRevealRange(T.id,t.NotebookRange.from(S),k??D.NotebookEditorRevealType.Default)},get viewColumn(){return T._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(T){this._visible=T}_acceptVisibleRanges(T){this._visibleRanges=T}_acceptSelections(T){this._selections=T}_trySetSelections(T){this._proxy.$trySetSelections(this.id,T.map(t.NotebookRange.from))}_acceptViewColumn(T){this._viewColumn=T}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(De[233],Ie([1,0,4,13,15]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(T,S){this._logService=T,this._notebooksAndEditors=S,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(T,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const k=this._notebooksAndEditors.getEditorById(T);S.visibleRanges&&k._acceptVisibleRanges(S.visibleRanges.ranges.map(D.NotebookRange.to)),S.selections&&k._acceptSelections(S.selections.selections.map(D.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(D.ViewColumn.to(T[S]))}};P=Ve([He(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[234],Ie([1,0,15,124,173,21,60,10]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}async withProgress(E,_,w){const h=this._handles++,{title:g,location:f,cancellable:v}=_,m={label:(0,D.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(h,{location:c.ProgressLocation.from(f),title:g,source:m,cancellable:v},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.onUnexpectedExternalError),this._withProgress(h,w,!!v)}_withProgress(E,_,w){let h;w&&(h=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,h));const g=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),h?.dispose()};let f;try{f=_(new A(this._proxy,E),w&&h?h.token:P.CancellationToken.None)}catch(v){throw g(E),v}return f.then(v=>g(E),v=>g(E)),f}$acceptProgressCanceled(E){const _=this._mapHandleToCancellationSource.get(E);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=S;function k(I,E){return I.message=E.message,typeof E.increment=="number"&&(typeof I.increment=="number"?I.increment+=E.increment:I.increment=E.increment),I}class A extends t.Progress{constructor(E,_){super(w=>this.throttledReport(w)),this._proxy=E,this._handle=_}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}Ve([(0,y.throttle)(100,(I,E)=>k(I,E),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(De[135],Ie([1,0,35,131,56,91,67,15,2]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(m,r,b,s)=>{let u=r;return{enumerable:!0,configurable:!1,get(){return u},set(o){if(!b(u,o)){const l=u;u=o,m.listener?.(s(o,l))}}}},A=(m,r)=>m===r,I={range:(m,r)=>m===r?!0:!m||!r?!1:m.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(m,r)=>!(m.length!==r.length||m.some(b=>!r.find(s=>b.id===s.id)))},E=m=>r=>({op:4,update:m(r)}),_=(m,r)=>({range:(()=>{let b;const s=E(u=>({range:c.Range.lift(T.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return b},set(u){m.listener?.({op:6}),I.range(b,u)||(b=u,m.listener?.(s(u)))}}})(),label:k(m,r,I.label,E(b=>({label:b}))),description:k(m,void 0,I.description,E(b=>({description:b}))),sortText:k(m,void 0,I.sortText,E(b=>({sortText:b}))),canResolveChildren:k(m,!1,I.canResolveChildren,b=>({op:2,state:b})),busy:k(m,!1,I.busy,E(b=>({busy:b}))),error:k(m,void 0,I.error,E(b=>({error:T.MarkdownString.fromStrict(b)||null}))),tags:k(m,[],I.tags,(b,s)=>({op:1,new:b.map(T.TestTag.from),old:s.map(T.TestTag.from)}))}),w=m=>{const r=D.TestId.fromString(m.extId),b=new g(r.controllerId,r.localId,m.label,S.URI.revive(m.uri)||void 0);return b.range=T.Range.to(m.range||void 0),b.description=m.description||void 0,b.sortText=m.sortText||void 0,b.tags=m.tags.map(s=>T.TestTag.to({id:(0,y.denamespaceTestTag)(s).tagId})),b},h=m=>{let r;for(const b of m.tests){const s=w(b.item);(0,t.getPrivateApiFor)(s).parent=r,r=s}return r};e.toItemFromContext=h;class g{constructor(r,b,s,u){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const o=(0,t.createPrivateApiFor)(this,r);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof f?void 0:o.parent}},children:{value:(0,P.createTestItemChildren)(o,t.getPrivateApiFor,g),enumerable:!0,writable:!1},..._(o,s)})}}e.TestItemImpl=g;class f extends g{constructor(r,b){super(r,r,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class v extends P.TestItemCollection{constructor(r,b,s){super({controllerId:r,getDocumentVersion:u=>u&&s.getDocument(u)?.version,getApiFor:t.getPrivateApiFor,getChildren:u=>u.children,root:new f(r,b),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(De[136],Ie([1,0,48,10,98,15,7]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(E,_,w){const h=T._Keys.nextId();E.$registerTextEditorDecorationType(_.identifier,h,P.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:h,dispose(){E.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=T,T._Keys=new D.IdGenerator("TextEditorDecorationType");class S{constructor(E,_){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=E,this._documentVersionId=E.version,this._undoStopBefore=_.undoStopBefore,this._undoStopAfter=_.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(E,_){this._throwIfFinalized();let w=null;if(E instanceof y.Position)w=new y.Range(E,E);else if(E instanceof y.Range)w=E;else throw new Error("Unrecognized location");this._pushEdit(w,_,!1)}insert(E,_){this._throwIfFinalized(),this._pushEdit(new y.Range(E,E),_,!0)}delete(E){this._throwIfFinalized();let _=null;if(E instanceof y.Range)_=E;else throw new Error("Unrecognized location");this._pushEdit(_,null,!0)}_pushEdit(E,_,w){const h=this._document.validateRange(E);this._collectedEdits.push({range:h,text:_,forceMoveMarkers:w})}setEndOfLine(E){if(this._throwIfFinalized(),E!==y.EndOfLine.LF&&E!==y.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=E}}e.TextEditorEdit=S;class k{constructor(E,_,w,h){this._proxy=E,this._id=_,this._accept(w),this._logService=h;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(f){g._setTabSize(f)},get insertSpaces(){return g._insertSpaces},set insertSpaces(f){g._setInsertSpaces(f)},get cursorStyle(){return g._cursorStyle},set cursorStyle(f){g._setCursorStyle(f)},get lineNumbers(){return g._lineNumbers},set lineNumbers(f){g._setLineNumbers(f)}}}_accept(E){this._tabSize=E.tabSize,this._insertSpaces=E.insertSpaces,this._cursorStyle=E.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(E.lineNumbers)}_validateTabSize(E){if(E==="auto")return"auto";if(typeof E=="number"){const _=Math.floor(E);return _>0?_:null}if(typeof E=="string"){const _=parseInt(E,10);return isNaN(_)?null:_>0?_:null}return null}_setTabSize(E){const _=this._validateTabSize(E);if(_!==null){if(typeof _=="number"){if(this._tabSize===_)return;this._tabSize=_}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:_}))}}_validateInsertSpaces(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}_setInsertSpaces(E){const _=this._validateInsertSpaces(E);if(typeof _=="boolean"){if(this._insertSpaces===_)return;this._insertSpaces=_}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:_}))}_setCursorStyle(E){this._cursorStyle!==E&&(this._cursorStyle=E,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:E})))}_setLineNumbers(E){this._lineNumbers!==E&&(this._lineNumbers=E,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(E)})))}assign(E){const _={};let w=!1;if(typeof E.tabSize<"u"){const h=this._validateTabSize(E.tabSize);h==="auto"?(w=!0,_.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,w=!0,_.tabSize=h)}if(typeof E.insertSpaces<"u"){const h=this._validateInsertSpaces(E.insertSpaces);h==="auto"?(w=!0,_.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,w=!0,_.insertSpaces=h)}typeof E.cursorStyle<"u"&&this._cursorStyle!==E.cursorStyle&&(this._cursorStyle=E.cursorStyle,w=!0,_.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this._lineNumbers!==E.lineNumbers&&(this._lineNumbers=E.lineNumbers,w=!0,_.lineNumbers=P.TextEditorLineNumbersStyle.from(E.lineNumbers)),w&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,_))}_warnOnError(E,_){_.catch(w=>{this._logService.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this._logService.warn(w)})}}e.ExtHostTextEditorOptions=k;class A{constructor(E,_,w,h,g,f,v,m){this.id=E,this._proxy=_,this._logService=w,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new k(this._proxy,this.id,f,w),this._visibleRanges=v,this._viewColumn=m;const r=this;this.value=Object.freeze({get document(){return h.getValue()},set document(b){throw(0,t.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(b){if(!(b instanceof y.Selection))throw(0,t.illegalArgument)("selection");r._selections=[b],r._trySetSelection()},get selections(){return r._selections},set selections(b){if(!Array.isArray(b)||b.some(s=>!(s instanceof y.Selection)))throw(0,t.illegalArgument)("selections");r._selections=b,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(b){throw(0,t.readonly)("visibleRanges")},get options(){return r._options.value},set options(b){r._disposed||r._options.assign(b)},get viewColumn(){return r._viewColumn},set viewColumn(b){throw(0,t.readonly)("viewColumn")},edit(b,s={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new S(h.getValue(),s);return b(u),r._applyEdit(u)},insertSnippet(b,s,u={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!s||Array.isArray(s)&&s.length===0)o=r._selections.map(l=>P.Range.from(l));else if(s instanceof y.Position){const{lineNumber:l,column:a}=P.Position.from(s);o=[{startLineNumber:l,startColumn:a,endLineNumber:l,endColumn:a}]}else if(s instanceof y.Range)o=[P.Range.from(s)];else{o=[];for(const l of s)if(l instanceof y.Range)o.push(P.Range.from(l));else{const{lineNumber:a,column:d}=P.Position.from(l);o.push({startLineNumber:a,startColumn:d,endLineNumber:a,endColumn:d})}}return _.$tryInsertSnippet(E,h.getValue().version,b.value,o,u)},setDecorations(b,s){const u=s.length===0;u&&!r._hasDecorationsForKey.has(b.key)||(u?r._hasDecorationsForKey.delete(b.key):r._hasDecorationsForKey.add(b.key),r._runOnProxy(()=>{if(P.isDecorationOptionsArr(s))return _.$trySetDecorations(E,b.key,P.fromRangeOrRangeWithMessage(s));{const o=new Array(4*s.length);for(let l=0,a=s.length;l<a;l++){const d=s[l];o[4*l]=d.start.line+1,o[4*l+1]=d.start.character+1,o[4*l+2]=d.end.line+1,o[4*l+3]=d.end.character+1}return _.$trySetDecorationsFast(E,b.key,o)}}))},revealRange(b,s){r._runOnProxy(()=>_.$tryRevealRange(E,P.Range.from(b),s||y.TextEditorRevealType.Default))},show(b){_.$tryShowEditor(E,P.ViewColumn.from(b))},hide(){_.$tryHideEditor(E)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(E){(0,c.ok)(!this._disposed),this._options._accept(E)}_acceptVisibleRanges(E){(0,c.ok)(!this._disposed),this._visibleRanges=E}_acceptViewColumn(E){(0,c.ok)(!this._disposed),this._viewColumn=E}_acceptSelections(E){(0,c.ok)(!this._disposed),this._selections=E}async _trySetSelection(){const E=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,E)),this.value}_applyEdit(E){const _=E.finalize();if(_.edits.length===0&&!_.setEndOfLine)return Promise.resolve(!0);const w=_.edits.map(g=>g.range);w.sort((g,f)=>g.end.line===f.end.line?g.end.character===f.end.character?g.start.line===f.start.line?g.start.character-f.start.character:g.start.line-f.start.line:g.end.character-f.end.character:g.end.line-f.end.line);for(let g=0,f=w.length-1;g<f;g++){const v=w[g].end;if(w[g+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=_.edits.map(g=>({range:P.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,h,{setEndOfLine:typeof _.setEndOfLine=="number"?P.EndOfLine.from(_.setEndOfLine):void 0,undoStopBefore:_.undoStopBefore,undoStopAfter:_.undoStopAfter})}_runOnProxy(E){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,_=>(_ instanceof Error&&_.name==="DISPOSED"||this._logService.warn(_),null))}}e.ExtHostTextEditor=A}),define(De[235],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribTerminalQuickFixes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribTerminalQuickFixes.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[236],Ie([1,0,187,10,42,121,125,43,26,235,198]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const I=T.Registry.as(y.Extensions.JSONContribution);class E{constructor(r,b,s){this._messageHandler=r,this._extension=b,this._extensionPointId=s}_msg(r,b){this._messageHandler({type:r,message:b,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(r){this._msg(D.default.Error,r)}warn(r){this._msg(D.default.Warning,r)}info(r){this._msg(D.default.Info,r)}}e.ExtensionMessageCollector=E;class _{static _toSet(r){const b=new Set;for(let s=0,u=r.length;s<u;s++)b.add(S.ExtensionIdentifier.toKey(r[s].description.identifier));return b}static compute(r,b){if(!r||!r.length)return new _(b,[]);if(!b||!b.length)return new _([],r);const s=this._toSet(r),u=this._toSet(b),o=b.filter(a=>!s.has(S.ExtensionIdentifier.toKey(a.description.identifier))),l=r.filter(a=>!u.has(S.ExtensionIdentifier.toKey(a.description.identifier)));return new _(o,l)}constructor(r,b){this.added=r,this.removed=b}}e.ExtensionPointUserDelta=_;class w{constructor(r,b){this.name=r,this.defaultExtensionKind=b,this._handler=null,this._users=null,this._delta=null}setHandler(r){if(this._handler!==null)throw new Error("Handler already set!");this._handler=r,this._handle()}acceptUsers(r){this._delta=_.compute(this._users,r),this._users=r,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(r){(0,t.onUnexpectedError)(r)}}}e.ExtensionPoint=w;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:c.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:c.localize(31,null)},{label:"onUri",body:"onUri",description:c.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(36,null)},{label:"onRenderer",description:c.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(39,null)},{label:"*",description:c.localize(40,null),body:"*"}]}},badges:{type:"array",description:c.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(42,null)},href:{type:"string",description:c.localize(43,null)},description:{type:"string",description:c.localize(44,null)}}}},markdown:{type:"string",description:c.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(49,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(50,null)},{body:["workspace"],description:c.localize(51,null)},{body:["ui","workspace"],description:c.localize(52,null)},{body:["workspace","ui"],description:c.localize(53,null)},{body:[],description:c.localize(54,null)}]},capabilities:{description:c.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(58,null),c.localize(59,null),c.localize(60,null)]},description:{type:"string",markdownDescription:c.localize(61,null)}}},untrustedWorkspaces:{description:c.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(64,null),c.localize(65,null),c.localize(66,null)]},restrictedConfigurations:{description:c.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(68,null)}}}}},sponsor:{description:c.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(71,null),type:"string"},"vscode:uninstall":{description:c.localize(72,null),type:"string"}}},icon:{type:"string",description:c.localize(73,null)},l10n:{type:"string",description:c.localize(74,null)}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(r){if(this._extensionPoints.has(r.extensionPoint))throw new Error("Duplicate extension point: "+r.extensionPoint);const b=new w(r.extensionPoint,r.defaultExtensionKind);return this._extensionPoints.set(r.extensionPoint,b),e.schema.properties.contributes.properties[r.extensionPoint]=r.jsonSchema,I.registerSchema(g,e.schema),b}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const v={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(v.ExtensionsRegistry,new f),e.ExtensionsRegistry=T.Registry.as(v.ExtensionsRegistry),I.registerSchema(g,e.schema),I.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(De[237],Ie([1,0,184,11,24,236,53,4]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var k;(function(E){function _(w,h,g){if(!w)return;const f=t.isString(w.type)?w.type:void 0;if(!f||f.length===0){g.error(c.localize(3,null));return}const v=[];if(Array.isArray(w.required))for(const m of w.required)t.isString(m)&&v.push(m);return{extensionId:h.value,taskType:f,required:v,properties:w.properties?D.deepClone(w.properties):{},when:w.when?y.ContextKeyExpr.deserialize(w.when):void 0}}E.from=_})(k||(k={}));const A=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:S}});class I{constructor(){this._onDefinitionsChanged=new T.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((_,w)=>{A.setHandler((h,g)=>{this._schema=void 0;try{for(const f of g.removed){const v=f.value;for(const m of v)this.taskTypes&&m.type&&this.taskTypes[m.type]&&delete this.taskTypes[m.type]}for(const f of g.added){const v=f.value;for(const m of v){const r=k.from(m,f.description.identifier,f.collector);r&&(this.taskTypes[r.taskType]=r)}}(g.removed.length>0||g.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}_(void 0)})})}onReady(){return this.readyPromise}get(_){return this.taskTypes[_]}all(){return Object.keys(this.taskTypes).map(_=>this.taskTypes[_])}getJsonSchema(){if(this._schema===void 0){const _=[];for(const w of this.all()){const h={type:"object",additionalProperties:!1};w.required.length>0&&(h.required=w.required.slice(0)),w.properties!==void 0?h.properties=D.deepClone(w.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[w.taskType]},_.push(h)}this._schema={oneOf:_}}return this._schema}}e.TaskDefinitionRegistryImpl=I,e.TaskDefinitionRegistry=new I}),define(De[238],Ie([1,0,185,11,22,24,53,237]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var S;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function z(U){if(!U)return O.Strong;switch(U.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=z}(S=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var A;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(A=e.RevealKind||(e.RevealKind={})),function(O){function z(U){switch(U.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=z}(A=e.RevealKind||(e.RevealKind={}));var I;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(I=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function z(U){switch(U.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=z}(I=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(O){function z(U){switch(U.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=z}(E=e.PanelKind||(e.PanelKind={}));var _;(function(O){O.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(_=e.PresentationOptions||(e.PresentationOptions={}));var w;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(w=e.RuntimeType||(e.RuntimeType={})),function(O){function z(F){switch(F.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=z;function U(F){switch(F){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=U}(w=e.RuntimeType||(e.RuntimeType={}));var h;(function(O){function z(U){return t.isString(U)?U:U.value}O.value=z})(h=e.CommandString||(e.CommandString={}));var g;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function z(F){return F===O.Clean._id||F===O.Build._id||F===O.Rebuild._id||F===O.Test._id}O.is=z;function U(F){if(F!==void 0)return t.isString(F)?z(F)?{_id:F,isDefault:!1}:void 0:F}O.from=U})(g=e.TaskGroup||(e.TaskGroup={}));var f;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var v;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function z(U){switch(U){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=z})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var m;(function(O){O.parallel="parallel",O.sequence="sequence"})(m=e.DependsOrder||(e.DependsOrder={}));var r;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(r=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class s{constructor(z,U,F,V,H,Q){this._label="",this._id=z,U&&(this._label=U),F&&(this.type=F),this.runOptions=V,this.configurationProperties=H,this._source=Q}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.getFolderId(),id:this._id};return JSON.stringify(z)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,U=!1){if(z===void 0)return!1;if(t.isString(z))return z===this._label||z===this.configurationProperties.identifier||U&&z===this._id;const F=this.getDefinition(!0);return F!==void 0&&F._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),z&&(this._taskLoadMessages=this._taskLoadMessages.concat(z))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=s;class u extends s{constructor(z,U,F,V,H,Q,K,de){super(z,F,void 0,K,de,U),this.command={},this._source=U,this.hasDefinedMatchers=Q,H&&(this.command=H)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case w.Shell:U="shell";break;case w.Process:U="process";break;case w.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(z){return z instanceof u}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.getFolderId();if(!z)return;let U=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(U+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:U};return JSON.stringify(F)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(z){return new u(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.CustomTask=u;class o extends s{constructor(z,U,F,V,H,Q,K){super(z,F,V,Q,K,U),this._source=U,this.configures=H}static is(z){return z instanceof o}fromObject(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.getFolderId();if(!z)return;let U=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(U+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:U};return JSON.stringify(F)}}e.ConfiguringTask=o;class l extends s{constructor(z,U,F,V,H,Q,K,de,ee){super(z,F,V,de,ee,U),this.defines=H,this.hasDefinedMatchers=K,this.command=Q,this.icon=ee.icon,this.hide=ee.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof l}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.getFolderId(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(z){return new l(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.ContributedTask=l;class a extends s{constructor(z,U,F,V,H,Q){super(z,F,V,H,Q,U),this._source=U}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(z){return new a(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.InMemoryTask=a;var d;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(d=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(d=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class i{constructor(z){this._order=new Map;for(let U=0;U<z.length;U++)this._order.set(z[U].uri.toString(),U)}compare(z,U){const F=z.getWorkspaceFolder(),V=U.getWorkspaceFolder();if(F&&V){let H=this._order.get(F.uri.toString());H=H===void 0?0:H+1;let Q=this._order.get(V.uri.toString());return Q=Q===void 0?0:Q+1,H===Q?z._label.localeCompare(U._label):H-Q}else return!F&&V?-1:F&&!V?1:0}}e.TaskSorter=i;var p;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var C;(function(O){O.SingleRun="singleRun",O.Background="background"})(C=e.TaskRunType||(e.TaskRunType={}));var R;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(O){function z(U,F,V,H,Q){if(F){const K={kind:U,taskId:F._id,taskName:F.configurationProperties.name,runType:F.configurationProperties.isBackground?"background":"singleRun",group:F.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:F};return U==="start"?(K.terminalId=V,K.resolvedVariables=H):U==="processStarted"?K.processId=V:U==="processEnded"&&(K.exitCode=V),Object.freeze(K)}else return Object.freeze({kind:"changed"})}O.create=z})(M=e.TaskEvent||(e.TaskEvent={}));var $;(function(O){function z(F){const V=Object.keys(F).sort();let H="";for(const Q of V){let K=F[Q];K instanceof Object?K=z(K):typeof K=="string"&&(K=K.replace(/,/g,",,")),H+=Q+","+K+","}return H}function U(F){const H={_key:z(F),type:F.taskType};return Object.assign(H,F),H}O.create=U})($=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var L;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(L=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(O){function z(U,F){const V=T.TaskDefinitionRegistry.get(U.type);if(V===void 0){const de=P.deepClone(U);return delete de._key,$.create(de)}const H=Object.create(null);H.type=V.taskType;const Q=new Set;V.required.forEach(de=>Q.add(de));const K=V.properties;for(const de of Object.keys(K)){const ee=U[de];if(ee!=null)H[de]=ee;else if(Q.has(de)){const fe=K[de];if(fe.default!==void 0)H[de]=P.deepClone(fe.default);else switch(fe.type){case"boolean":H[de]=!1;break;case"number":case"integer":H[de]=0;break;case"string":H[de]="";break;default:F.error(c.localize(2,null,JSON.stringify(U,void 0,0),de));return}}}return $.create(H)}O.createTaskIdentifier=z})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[239],Ie([1,0,10]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,T)=>{this._actualOk=y,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,c.onUnexpectedError)(y))}then(y,T){return this._ensureActual().then(y,T)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=t;class D extends t{constructor(){super(),this._hasErr=!0,this._err=new c.CancellationError}}e.CanceledLazyPromise=D}),define(De[57],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const t=[];function D(T){const S=new c(T);return t[S.nid]=S,S}e.createProxyIdentifier=D;function P(T){return t[T].sid}e.getStringIdentifierForProxy=P;class y{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=y}),define(De[5],Ie([1,0,57]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var P;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(g){return g._id=I._n++,g}}e.IdObject=I,I._n=0;var E;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var _;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(_=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(De[68],Ie([1,0,3,13,5,16]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,k,A){const I=this.getUsageKey(S,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}getUsageKey(S,k){return`${S}-${k.identifier.value}`}};y=Ve([He(0,P.IExtHostRpcService),He(1,t.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,k){}})}),define(De[240],Ie([1,0,4,5,7,26]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,k,A,I={}){const E=P.ExtensionIdentifier.toKey(S.identifier),_=this._inFlightRequests.get(E)||[],w=[...A].sort().join(" ");let h=_.find(g=>g.providerId===k&&g.scopes===w);if(h)return h.result;{const g=this._getSession(S,E,k,A,I);h={providerId:k,scopes:w,result:g},_.push(h),this._inFlightRequests.set(E,_);try{await g}finally{const f=_.findIndex(v=>v.providerId===k&&v.scopes===w);f>-1&&(_.splice(f),this._inFlightRequests.set(E,_))}return g}}async _getSession(S,k,A,I,E={}){await this._proxy.$ensureProvider(A);const _=S.displayName||S.name;return this._proxy.$getSession(A,I,k,_,E)}async removeSession(S,k){const A=this._authenticationProviders.get(S);return A?A.provider.removeSession(k):this._proxy.$removeSession(S,k)}registerAuthenticationProvider(S,k,A,I){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:k,provider:A,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(_=>_.id===S)||this._providers.push({id:S,label:k});const E=A.onDidChangeSessions(_=>{this._proxy.$sendDidChangeSessions(S,{added:_.added??[],changed:_.changed??[],removed:_.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,k,I?.supportsMultipleAccounts??!1),new D.Disposable(()=>{E.dispose(),this._authenticationProviders.delete(S);const _=this._providers.findIndex(w=>w.id===S);_>-1&&this._providers.splice(_),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this._onDidChangeSessions.fire({provider:{id:S,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(De[241],Ie([1,0,5,16,15]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(T,S){this._proxy=T.getProxy(c.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:k=>S.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,k){const A=D.WorkspaceEdit.from(T,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,k?.isRefactoring??!1)}};P=Ve([He(0,t.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(De[242],Ie([1,0,5]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const y=P.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(T){return y.$writeText(T)}})}}e.ExtHostClipboard=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c},Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[39],Ie([1,0,11,7,15,24,5,17,13,82,35,49,2,6,3,16,135,23,57,50]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m){"use strict";var r,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(n,i){r.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,b.set(this,void 0),nt(this,r,n.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=i,nt(this,b,n.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,p=>{const C=this._apiCommands.get(p);return C?.result===l.Void?C:void 0},i),this._argumentProcessors=[{processArgument(p){return(0,k.revive)(p)}},{processArgument(p){return(0,P.cloneAndChange)(p,function(C){if(A.Range.isIRange(C))return D.Range.to(C);if(I.Position.isIPosition(C))return D.Position.to(C);if(A.Range.isIRange(C.range)&&E.URI.isUri(C.uri))return D.location.to(C);if(C instanceof f.VSBuffer)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const i=this.registerCommand(!1,n.id,async(...p)=>{const C=n.args.map((M,$)=>{if(!M.validate(p[$]))throw new Error(`Invalid argument '${M.name}' when running '${n.id}', received: ${p[$]}`);return M.convert(p[$])}),R=await this.executeCommand(n.internalId,...C);return n.result.convert(R,p,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new t.Disposable(()=>{i.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,i,p,C,R,M){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:p,thisArg:C,description:R,extension:M}),n&&Ue(this,r,"f").$registerCommand(i),new t.Disposable(()=>{this._commands.delete(i)&&n&&Ue(this,r,"f").$unregisterCommand(i)})}executeCommand(n,...i){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,i,!0)}async _doExecuteCommand(n,i,p){if(this._commands.has(n))return Ue(this,r,"f").$fireCommandActivationEvent(n),this._executeContributedCommand(n,i,!1);{let C=!1;const R=(0,P.cloneAndChange)(i,function(M){if(M instanceof t.Position)return D.Position.from(M);if(M instanceof t.Range)return D.Range.from(M);if(M instanceof t.Location)return D.location.from(M);if(t.NotebookRange.isNotebookRange(M))return D.NotebookRange.from(M);if(M instanceof ArrayBuffer)return C=!0,f.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return C=!0,f.VSBuffer.wrap(M);if(M instanceof f.VSBuffer)return C=!0,M;if(!Array.isArray(M))return M});try{const M=await Ue(this,r,"f").$executeCommand(n,C?new v.SerializableObjectWithBuffers(R):R,p);return(0,k.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(n,i,!1);throw M}}}async _executeContributedCommand(n,i,p){const C=this._commands.get(n);if(!C)throw new Error("Unknown command");this._reportTelemetry(C,n);const{callback:R,thisArg:M,description:$}=C;if($)for(let x=0;x<$.args.length;x++)try{(0,c.validateConstraint)(i[x],$.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${$.args[x].name}' - ${$.args[x].description}`)}try{return await R.apply(M,i)}catch(x){if(n===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...i);L&&(n=L.command)}throw this._logService.error(x,n,C.extension?.identifier),p?new class extends Error{constructor(){super((0,m.toErrorMessage)(x)),this.id=n,this.source=C.extension?.displayName??C.extension?.name}}:x}}_reportTelemetry(n,i){!n.extension||n.extension.isBuiltin||Ue(this,b,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:i})}$executeContributedCommand(n,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(i=i.map(p=>this._argumentProcessors.reduce((C,R)=>R.processArgument(C),p)),this._executeContributedCommand(n,i,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),Ue(this,r,"f").$getCommands().then(i=>(n&&(i=i.filter(p=>p[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[i,p]of this._commands){const{description:C}=p;C&&(n[i]=C)}return Promise.resolve(n)}};r=new WeakMap,b=new WeakMap,s=Ve([He(0,h.IExtHostRpcService),He(1,S.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,w.createDecorator)("IExtHostCommands");class u{constructor(n,i,p){this._commands=n,this._lookupApiCommand=i,this._logService=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,i){if(!n)return;const p={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return p;const C=this._lookupApiCommand(n.command);if(C)p.id=C.internalId,p.arguments=C.args.map((R,M)=>R.convert(n.arguments&&n.arguments[M]));else if((0,T.isNonEmptyArray)(n.arguments)){const R=++this._cachIdPool;this._cache.set(R,n),i.add((0,_.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),p.$ident=R,p.id=this.delegatingCommandId,p.arguments=[R],this._logService.trace("CommandsConverter#CREATE",n.command,R)}return p}fromInternal(n){return typeof n.$ident=="number"?this._cache.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const i=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class o{constructor(n,i,p,C){this.name=n,this.description=i,this.validate=p,this.convert=C}optional(){return new o(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,i){return new o(n??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",d=>E.URI.isUri(d),d=>d),o.Position=new o("position","A position in a text document",d=>t.Position.isPosition(d),D.Position.from),o.Range=new o("range","A range in a text document",d=>t.Range.isRange(d),D.Range.from),o.Selection=new o("selection","A selection in a text document",d=>t.Selection.isSelection(d),D.Selection.from),o.Number=new o("number","",d=>typeof d=="number",d=>d),o.String=new o("string","",d=>typeof d=="string",d=>d),o.CallHierarchyItem=new o("item","A call hierarchy item",d=>d instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",d=>d instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",d=>d instanceof g.TestItemImpl,D.TestItem.from);class l{constructor(n,i){this.description=n,this.convert=i}}e.ApiCommandResult=l,l.Void=new l("no result",d=>d);class a{constructor(n,i,p,C,R){this.id=n,this.internalId=i,this.description=p,this.args=C,this.result=R}}e.ApiCommand=a}),define(De[243],Ie([1,0,2,15,7,66,39,17,118,123,14]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",_(t.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,g)=>{if((0,T.isFalsyOrEmpty)(h))return;class f extends D.SymbolInformation{static to(m){const r=new f(m.name,t.SymbolKind.to(m.kind),m.containerName||"",new D.Location(g[0],t.Range.to(m.range)));return r.detail=m.detail,r.range=r.location.range,r.selectionRange=t.Range.to(m.selectionRange),r.children=m.children?m.children.map(f.to):[],r}}return h.map(f.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new y.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(t.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(t.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(g=>D.Position.isPosition(g)),h=>h.map(t.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(g=>{let f;for(const v of g.reverse())f=new D.SelectionRange(t.Range.to(v),f);return f}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(t.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:t.Range.to(h.range),placeholder:h.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return t.WorkspaceEdit.to(h)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(t.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new D.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,S.decodeSemanticTokensDto)(h);if(g.type==="full")return new D.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new D.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,S.decodeSemanticTokensDto)(h);if(g.type==="full")return new D.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,g,f)=>{if(!h)return new D.CompletionList([]);const v=h.suggestions.map(m=>t.CompletionItem.to(m,f));return new D.CompletionList(v,h.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return t.SignatureHelp.to(h)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,g,f)=>_(v=>new D.CodeLens(t.Range.to(v.range),v.command&&f.fromInternal(v.command)))(h))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>D.Range.isRange(h),h=>D.Selection.isSelection(h)?t.Selection.from(h):t.Range.from(h)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,g,f)=>_(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const m=new D.CodeAction(v.title,v.kind?new D.CodeActionKind(v.kind):void 0);return v.edit&&(m.edit=t.WorkspaceEdit.to(v.edit)),v.command&&(m.command=f.fromInternal(v.command)),m.isPreferred=v.isPreferred,m}})(h))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(g=>new D.ColorInformation(t.Range.to(g.range),t.Color.to(g.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",h=>h instanceof D.Color,t.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:t.Range.from(h.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(t.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,g,f)=>h.map(t.InlayHint.to.bind(void 0,f)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(g=>t.NotebookExclusiveDocumentPattern.to(g))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(t.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>c.URI.isUri(h)||typeof h=="string"&&(0,k.matchesSomeScheme)(h,A.Schemas.http,A.Schemas.https),h=>h),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[t.ViewColumn.from(h),void 0]:[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[t.ViewColumn.from(h),void 0]:[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class E{static register(g){I.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=E;function _(h){return g=>{if(Array.isArray(g))return g.map(h)}}function w(h){if(!Array.isArray(h))return;const g=[];for(const f of h)P.isLocationLink(f)?g.push(t.DefinitionLink.to(f)):g.push(t.location.to(f));return g}}),define(De[244],Ie([1,0,18,60,4,6,2,66,26,15,7,27,5]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function _(w,h,g){const f=w.getProxy(E.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const n=this._commentControllers.get(d.handle);return n?n.value:d}else if(d&&d.$mid===7){const n=this._commentControllers.get(d.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.commentThreadHandle);return i?i.value:d}else if(d&&d.$mid===8){const n=this._commentControllers.get(d.thread.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.thread.commentThreadHandle);return i?{thread:i.value,text:d.text}:d}else if(d&&d.$mid===9){const n=this._commentControllers.get(d.thread.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.thread.commentThreadHandle);if(!i)return d;const p=d.commentUniqueId,C=i.getCommentByUniqueId(p);return C||d}else if(d&&d.$mid===10){const n=this._commentControllers.get(d.thread.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.thread.commentThreadHandle);if(!i)return d;const p=d.text,C=d.commentUniqueId,R=i.getCommentByUniqueId(C);return R?(typeof R.body=="string"?R.body=p:R.body.value=p,R):d}return d}})}createCommentController(d,n,i){const p=v.handlePool++,C=new r(d,p,n,i);this._commentControllers.set(C.handle,C);const R=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(d.identifier))||[];return R.push(C),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(d.identifier),R),C.value}$createCommentThreadTemplate(d,n,i){const p=this._commentControllers.get(d);!p||p.$createCommentThreadTemplate(n,i)}async $updateCommentThreadTemplate(d,n,i){const p=this._commentControllers.get(d);!p||p.$updateCommentThreadTemplate(n,i)}$deleteCommentThread(d,n){this._commentControllers.get(d)?.$deleteCommentThread(n)}$provideCommentingRanges(d,n,i){const p=this._commentControllers.get(d);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const C=g.getDocument(y.URI.revive(n));return(0,c.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(C,i)).then(R=>R?R.map(M=>k.Range.from(M)):void 0)}$toggleReaction(d,n,i,p,C){const R=this._commentControllers.get(d);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const M=R.getCommentThread(n);if(M){const $=M.getCommentByUniqueId(p.uniqueIdInThread);if(R!==void 0&&$&&R.reactionHandler)return R.reactionHandler($,u(C))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class m{set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get state(){return(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(d){(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=d,this.modifications.state=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(d,n,i,p,C,R,M,$){this._commentControllerHandle=n,this._id=i,this._uri=p,this._range=C,this._comments=R,this.extensionDescription=M,this._isTemplate=$,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),f.$createCommentThread(n,this.handle,this._id,this._uri,k.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(n,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(L){x.range=L},get comments(){return x.comments},set comments(L){x.comments=L},get collapsibleState(){return x.collapsibleState},set collapsibleState(L){x.collapsibleState=L},get canReply(){return x.canReply},set canReply(L){x.canReply=L},get contextValue(){return x.contextValue},set contextValue(L){x.contextValue=L},get label(){return x.label},set label(L){x.label=L},get state(){return x.state},set state(L){x.state=L},dispose:()=>{x.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const d=i=>Object.prototype.hasOwnProperty.call(this.modifications,i),n={};d("range")&&(n.range=k.Range.from(this._range)),d("label")&&(n.label=this.label),d("contextValue")&&(n.contextValue=this.contextValue??null),d("comments")&&(n.comments=this._comments.map(i=>b(this,i,this._commentsMap))),d("collapsibleState")&&(n.collapseState=o(this._collapseState)),d("canReply")&&(n.canReply=this.canReply),d("state")&&(n.state=l(this._state)),d("isTemplate")&&(n.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,n)}getCommentByUniqueId(d){for(const n of this._commentsMap){const i=n[0],p=n[1];if(d===p)return i}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}m._handlePool=0,Ve([(0,t.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(d,n,i,p){this._extension=d,this._handle=n,this._id=i,this._label=p,this._threads=new Map,f.$registerCommentController(this.handle,i,p);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(R){C.options=R},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(R){C.commentingRangeProvider=R},get reactionHandler(){return C.reactionHandler},set reactionHandler(R){C.reactionHandler=R},createCommentThread(R,M,$){return C.createCommentThread(R,M,$).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(d,n,i,p){if(typeof d=="string"){const C=new m(this.id,this.handle,d,n,i,p,this._extension,!1);return this._threads.set(C.handle,C),C}else{const C=new m(this.id,this.handle,void 0,d,n,i,this._extension,!1);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(d,n){const i=new m(this.id,this.handle,void 0,y.URI.revive(d),k.Range.to(n),[],this._extension,!0);return i.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(i.handle,i),i}$updateCommentThreadTemplate(d,n){const i=this._threads.get(d);i&&(i.range=k.Range.to(n))}$deleteCommentThread(d){this._threads.get(d)?.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function b(a,d,n){let i=n.get(d);i||(i=++a.commentHandle,n.set(d,i));const p=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;return{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:i,body:typeof d.body=="string"?d.body:k.MarkdownString.from(d.body),userName:d.author.name,userIconPath:p,label:d.label,commentReactions:d.reactions?d.reactions.map(C=>s(C)):void 0,timestamp:d.timestamp?.toJSON()}}function s(a){return{label:a.label,iconPath:a.iconPath?k.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function u(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?y.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function o(a){if(a!==void 0)switch(a){case A.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function l(a){if(a!==void 0)switch(a){case A.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new v}e.createExtHostComments=_}),define(De[245],Ie([1,0,24,5,25,16]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(A,I){this._mainThreadConsole=A.getProxy(t.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,I){const E=this,_=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){E._handleConsoleCall(A,I,_,arguments)}})}_handleConsoleCall(A,I,E,_){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:S(_,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,E,_)}};y=Ve([He(0,P.IExtHostRpcService),He(1,D.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const T=1e5;function S(k,A){const I=[];if(k.length)for(let E=0;E<k.length;E++){let _=k[E];if(typeof _>"u")_="undefined";else if(_ instanceof Error){const w=_;w.stack?_=w.stack:_=w.toString()}I.push(_)}if(A){const E=new Error().stack;E&&I.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,c.safeStringify)(I);return E.length>T?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(De[137],Ie([1,0,2,5,7,3,16,13,17,8,9]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class Ln{constructor(_,w){this._logService=w,this._provider=new Map,this._proxy=_.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(_,w){const h=Ln._handlePool++;this._provider.set(h,{provider:_,extensionId:w}),this._proxy.$registerDecorationProvider(h,w.value);const g=_.onDidChangeFileDecorations&&_.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(h,null);return}const v=(0,S.asArray)(f);if(v.length<=Ln._maxEventSize){this._proxy.$onDidChange(h,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",w.value,v.length);const m=v.map(s=>({uri:s,rank:(0,k.count)(s.path,"/")})),r=(0,S.groupBy)(m,(s,u)=>s.rank-u.rank||(0,k.compare)(s.uri.path,u.uri.path)),b=[];e:for(const s of r){let u;for(const o of s){const l=(0,A.dirname)(o.uri.path);if(u!==l&&(u=l,b.push(o.uri)>=Ln._maxEventSize))break e}}this._proxy.$onDidChange(h,b)});return new D.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(_,w,h){if(!this._provider.has(_))return Object.create(null);const g=Object.create(null),{provider:f,extensionId:v}=this._provider.get(_);return await Promise.all(w.map(async m=>{try{const{uri:r,id:b}=m,s=await Promise.resolve(f.provideFileDecoration(c.URI.revive(r),h));if(!s)return;try{D.FileDecoration.validate(s),g[b]=[s.propagate,s.tooltip,s.badge,s.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${v.value}': ${u}`)}}catch(r){this._logService.error(r)}})),g}};I._handlePool=0,I._maxEventSize=250,I=Ve([He(0,y.IExtHostRpcService),He(1,T.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c},Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[246],Ie([1,0,171,122,2,5,7,15,4,13,28,46]),function(Z,e,c,t,D,P,y,T,S,k,A,I){"use strict";var E,_,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(v,m,r,b,s,u,o){this._name=v,this._owner=m,this._maxDiagnosticsPerFile=r,this._modelVersionIdProvider=b,E.set(this,void 0),_.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,nt(this,w,new A.ResourceMap(l=>s.getComparisonKey(l)),"f"),nt(this,E,u,"f"),nt(this,_,o,"f")}dispose(){this._isDisposed||(Ue(this,_,"f").fire([...Ue(this,w,"f").keys()]),Ue(this,E,"f")?.$clear(this._owner),Ue(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,m){if(!v){this.clear();return}this._checkDisposed();let r=[];if(D.URI.isUri(v)){if(!m){this.delete(v);return}Ue(this,w,"f").set(v,m.slice()),r=[v]}else if(Array.isArray(v)){r=[];let s;v=[...v].sort(h._compareIndexedTuplesByUri);for(const u of v){const[o,l]=u;if((!s||o.toString()!==s.toString())&&(s&&Ue(this,w,"f").get(s).length===0&&Ue(this,w,"f").delete(s),s=o,r.push(o),Ue(this,w,"f").set(o,[])),l)Ue(this,w,"f").get(o)?.push(...l);else{const a=Ue(this,w,"f").get(o);a&&(a.length=0)}}}if(Ue(this,_,"f").fire(r),!Ue(this,E,"f"))return;const b=[];for(const s of r){let u=[];const o=Ue(this,w,"f").get(s);if(o)if(o.length>this._maxDiagnosticsPerFile){u=[];const l=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const d of o)if(d.severity===l[a]&&u.push({...T.Diagnostic.from(d),modelVersionId:this._modelVersionIdProvider(s)})===this._maxDiagnosticsPerFile)break e;u.push({severity:t.MarkerSeverity.Info,message:(0,c.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=o.map(l=>({...T.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(s)}));b.push([s,u])}Ue(this,E,"f").$changeMany(this._owner,b)}delete(v){this._checkDisposed(),Ue(this,_,"f").fire([v]),Ue(this,w,"f").delete(v),Ue(this,E,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Ue(this,_,"f").fire([...Ue(this,w,"f").keys()]),Ue(this,w,"f").clear(),Ue(this,E,"f")?.$clear(this._owner)}forEach(v,m){this._checkDisposed();for(const[r,b]of this)v.call(m,r,b,this)}*[(E=new WeakMap,_=new WeakMap,w=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Ue(this,w,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const m=Ue(this,w,"f").get(v);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Ue(this,w,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,m){return v[0].toString()<m[0].toString()?-1:v[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=h;let g=class vn{static _mapper(v){const m=new A.ResourceMap;for(const r of v)m.set(r,r);return{uris:Object.freeze(Array.from(m.values()))}}constructor(v,m,r,b){this._logService=m,this._fileSystemInfoService=r,this._extHostDocumentsAndEditors=b,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,vn._mapper),this._proxy=v.getProxy(P.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,m){const{_collections:r,_proxy:b,_onDidChangeDiagnostics:s,_logService:u,_fileSystemInfoService:o,_extHostDocumentsAndEditors:l}=this,a=new class{$changeMany(i,p){b.$changeMany(i,p),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,i,p.length===0?"CLEARING":p)}$clear(i){b.$clear(i),u.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,i)}dispose(){b.dispose()}};let d;if(!m)m="_generated_diagnostic_collection_name_#"+vn._idPool++,d=m;else if(!r.has(m))d=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do d=m+vn._idPool++;while(r.has(d))}return new class extends h{constructor(){super(m,d,vn._maxDiagnosticsPerFile,i=>l.getDocument(i)?.version,o.extUri,a,s),r.set(d,this)}dispose(){super.dispose(),r.delete(d)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const m=new Map,r=[];for(const b of this._collections.values())b.forEach((s,u)=>{let o=m.get(s.toString());typeof o>"u"&&(o=r.length,m.set(s.toString(),o),r.push([s,[]])),r[o][1]=r[o][1].concat(...u)});return r}}_getDiagnostics(v){let m=[];for(const r of this._collections.values())r.has(v)&&(m=m.concat(r.get(v)));return m}$acceptMarkersChange(v){if(!this._mirrorCollection){const m="_generated_mirror",r=new h(m,m,vn._maxDiagnosticsPerFile,b=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,r),this._mirrorCollection=r}for(const[m,r]of v)this._mirrorCollection.set(D.URI.revive(m),r.map(T.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=Ve([He(1,k.ILogService),He(2,I.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(De[247],Ie([1,0,2,5]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(y){this._proxy=y.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(T=>T?T.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(T=>T?c.URI.revive(T):void 0)}}e.ExtHostDialogs=D}),define(De[248],Ie([1,0,10,2,7,5,14,21,8]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,E,_){this._documentsAndEditors=E,this._logService=_,this._documentContentProviders=new Map,this._proxy=I.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,E){if(Object.keys(y.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const _=k._handlePool++;this._documentContentProviders.set(_,E),this._proxy.$registerTextContentProvider(_,I);let w;return typeof E.onDidChange=="function"&&(w=E.onDidChange(h=>{if(h.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(_,h).then(g=>{if(!g&&typeof g!="string")return;const f=this._documentsAndEditors.getDocument(h);if(!f)return;const v=(0,S.splitLines)(g);if(!f.equalLines(v))return this._proxy.$onVirtualDocumentChange(h,g)},c.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(_)&&this._proxy.$unregisterTextContentProvider(_),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(I,E){const _=this._documentContentProviders.get(I);return _?Promise.resolve(_.provideTextDocumentContent(t.URI.revive(E),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(De[249],Ie([1,0,4,6,2,5,133,15,11,24,7]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(_,w){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const g of h)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const g of h)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!_)return;const w=this._documentsAndEditors.getDocument(_);if(w)return w}getDocument(_){const w=this.getDocumentData(_);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${_}'`);return w.document}ensureDocumentData(_){const w=this._documentsAndEditors.getDocument(_);if(w)return Promise.resolve(w);let h=this._documentLoader.get(_.toString());return h||(h=this._proxy.$tryOpenDocument(_).then(g=>{this._documentLoader.delete(_.toString());const f=D.URI.revive(g);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(f))},g=>(this._documentLoader.delete(_.toString()),Promise.reject(g))),this._documentLoader.set(_.toString(),h)),h}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(w=>D.URI.revive(w))}$acceptModelLanguageChanged(_,w){const h=D.URI.revive(_),g=this._documentsAndEditors.getDocument(h);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(w),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(_){const w=D.URI.revive(_),h=this._documentsAndEditors.getDocument(w);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(_,w){const h=D.URI.revive(_),g=this._documentsAndEditors.getDocument(h);if(!g)throw new Error("unknown document");g._acceptIsDirty(w),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(_,w,h){const g=D.URI.revive(_),f=this._documentsAndEditors.getDocument(g);if(!f)throw new Error("unknown document");f._acceptIsDirty(h),f.onEvents(w);let v;w.isUndoing?v=A.TextDocumentChangeReason.Undo:w.isRedoing&&(v=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:f.document,contentChanges:w.changes.map(m=>({range:T.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:v}))}setWordDefinitionFor(_,w){(0,y.setWordDefinitionFor)(_,w)}}e.ExtHostDocuments=I}),define(De[58],Ie([1,0,48,4,6,2,3,5,133,16,136,15,13,28,14,62,79]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(r,b){this._extHostRpc=r,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new _.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const b=[],s=[],u=[];if(r.removedDocuments)for(const o of r.removedDocuments){const l=P.URI.revive(o),a=this._documents.get(l);a?.unref()&&(this._documents.delete(l),b.push(a.value))}if(r.addedDocuments)for(const o of r.addedDocuments){const l=P.URI.revive(o.uri);let a=this._documents.get(l);if(a&&l.scheme!==w.Schemas.vscodeNotebookCell&&l.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);a||(a=new f(new S.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),l,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(l,a),s.push(a.value)),a.ref()}if(r.removedEditors)for(const o of r.removedEditors){const l=this._editors.get(o);this._editors.delete(o),l&&u.push(l)}if(r.addedEditors)for(const o of r.addedEditors){const l=P.URI.revive(o.documentUri);c.ok(this._documents.has(l),`document '${l}' does not exist`),c.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const a=this._documents.get(l).value,d=new A.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>a.document),o.selections.map(I.Selection.to),o.options,o.visibleRanges.map(n=>I.Range.to(n)),typeof o.editorPosition=="number"?I.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,d)}r.newActiveEditor!==void 0&&(c.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,D.dispose)(b),(0,D.dispose)(u),r.removedDocuments&&this._onDidRemoveDocuments.fire(b),r.addedDocuments&&this._onDidAddDocuments.fire(s),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const b=this._editors.get(this._activeEditorId);return r?b:b?.value}allEditors(){return[...this._editors.values()]}};v=Ve([He(0,k.IExtHostRpcService),He(1,E.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[59],Ie([1,0,15,5,2,4,3,7,16,11,78]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class I{constructor(g,f,v){this._activeTabIdGetter=v,this._parentGroup=f,this.acceptDtoUpdate(g)}get apiObject(){if(!this._apiObject){const g=this,f={get isActive(){return g._dto.id===g._activeTabIdGetter()},get label(){return g._dto.label},get input(){return g._input},get isDirty(){return g._dto.isDirty},get isPinned(){return g._dto.isPinned},get isPreview(){return g._dto.isPreview},get group(){return g._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(g){this._dto=g,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new T.TextTabInput(D.URI.revive(this._dto.input.uri));case 2:return new T.TextDiffTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified));case 3:return new T.TextMergeTabInput(D.URI.revive(this._dto.input.base),D.URI.revive(this._dto.input.input1),D.URI.revive(this._dto.input.input2),D.URI.revive(this._dto.input.result));case 6:return new T.CustomEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new T.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new T.NotebookEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(D.URI.revive(this._dto.input.uri),D.URI.revive(this._dto.input.inputBoxUri));default:return}}}class E{constructor(g,f){this._tabs=[],this._activeTabId="",this._dto=g,this._activeGroupIdGetter=f;for(const v of g.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new I(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const g=this,f={get isActive(){return g._dto.groupId===g._activeGroupIdGetter()},get viewColumn(){return c.ViewColumn.to(g._dto.viewColumn)},get activeTab(){return g._tabs.find(v=>v.tabId===g._activeTabId)?.apiObject},get tabs(){return Object.freeze(g._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(g){this._dto=g}acceptTabOperation(g){if(g.kind===0){const v=new I(g.tabDto,this,()=>this.activeTabId());return this._tabs.splice(g.index,0,v),g.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(g.kind===1){const v=this._tabs.splice(g.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(g.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this._tabs.splice(g.index,0,v),v}const f=this._tabs.find(v=>v.tabId===g.tabDto.id);if(!f)throw new Error("INVALID tab");return g.tabDto.isActive?this._activeTabId=g.tabDto.id:this._activeTabId===g.tabDto.id&&!g.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(g.tabDto),f}activeTabId(){return this._activeTabId}}let _=class{constructor(g){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=g.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const g=this,f={onDidChangeTabGroups:g._onDidChangeTabGroups.event,onDidChangeTabs:g._onDidChangeTabs.event,get all(){return Object.freeze(g._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=g._activeGroupId;return(0,k.assertIsDefined)(g._extHostTabGroups.find(r=>r.groupId===v)?.apiObject)},close:async(v,m)=>{const r=Array.isArray(v)?v:[v];return r.length?w(r[0])?this._closeGroups(r,m):this._closeTabs(r,m):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(g){const f=new Set(this._extHostTabGroups.map(o=>o.groupId)),v=new Set(g.map(o=>o.groupId)),m=(0,A.diffSets)(f,v),r=this._extHostTabGroups.filter(o=>m.removed.includes(o.groupId)).map(o=>o.apiObject),b=[],s=[];this._extHostTabGroups=g.map(o=>{const l=new E(o,()=>this._activeGroupId);return m.added.includes(l.groupId)?b.push(l.apiObject):s.push(l.apiObject),l});const u=(0,k.assertIsDefined)(g.find(o=>o.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:b,closed:r,changed:s}))}$acceptTabGroupUpdate(g){const f=this._extHostTabGroups.find(v=>v.groupId===g.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(g),g.isActive&&(this._activeGroupId=g.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const f=this._extHostTabGroups.find(m=>m.groupId===g.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const v=f.acceptTabOperation(g);switch(g.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(g){for(const f of this._extHostTabGroups)for(const v of f.tabs)if(v.apiObject===g)return v}_findExtHostTabGroupFromApi(g){return this._extHostTabGroups.find(f=>f.apiObject===g)}async _closeTabs(g,f){const v=[];for(const m of g){const r=this._findExtHostTabFromApi(m);if(!r)throw new Error("Tab close: Invalid tab not found!");v.push(r.tabId)}return this._proxy.$closeTab(v,f)}async _closeGroups(g,f){const v=[];for(const m of g){const r=this._findExtHostTabGroupFromApi(m);if(!r)throw new Error("Group close: Invalid group not found!");v.push(r.groupId)}return this._proxy.$closeGroup(v,f)}};_=Ve([He(0,S.IExtHostRpcService)],_),e.ExtHostEditorTabs=_;function w(h){return h.tabs!==void 0}}),define(De[250],Ie([1,0,2,5,6,7,15,150,8,23,27]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const h=this._schemes.indexOf(w);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),h=[];let g,f,v=14,m=14;for(const r of w){let b=g?(0,S.commonPrefixLength)(g,r):0;for(b===0?f=1:f=m;b<r.length;b++)b+1===r.length?(v=m,m=9):m+=1,h.push([f,r.toUpperCase().charCodeAt(b),m]),h.push([f,r.toLowerCase().charCodeAt(b),m]),f=m;g=r,m=v}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new T.StateMachine(h)}}provideDocumentLinks(w){this._initStateMachine();const h=[],g=T.LinkComputer.computeLinks({getLineContent(f){return w.lineAt(f-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const f of g){const v=y.DocumentLink.to(f);v.target&&h.push(v)}return h}}class E{constructor(w,h){this._extHostLanguageFeatures=h,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,h,g,f={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(v,g);let m=2;f.isCaseSensitive&&(m+=1024),f.isReadonly&&(m+=2048),typeof g.copy=="function"&&(m+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,A.checkProposedApiEnabled)(w,"fsChunks"),m+=4),this._proxy.$registerFileSystemProvider(v,h,m).catch(b=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${h}`),console.error(b)});const r=g.onDidChangeFile(b=>{const s=[];for(const u of b){const{uri:o,type:l}=u;if(o.scheme!==h)continue;let a;switch(l){case P.FileChangeType.Changed:a=0;break;case P.FileChangeType.Created:a=1;break;case P.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:o,type:a})}this._proxy.$onFileSystemChange(v,s)});return(0,D.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(w){const{type:h,ctime:g,mtime:f,size:v,permissions:m}=w;return{type:h,ctime:g,mtime:f,size:v,permissions:m}}$stat(w,h){return Promise.resolve(this._getFsProvider(w).stat(c.URI.revive(h))).then(g=>E._asIStat(g))}$readdir(w,h){return Promise.resolve(this._getFsProvider(w).readDirectory(c.URI.revive(h)))}$readFile(w,h){return Promise.resolve(this._getFsProvider(w).readFile(c.URI.revive(h))).then(g=>k.VSBuffer.wrap(g))}$writeFile(w,h,g,f){return Promise.resolve(this._getFsProvider(w).writeFile(c.URI.revive(h),g.buffer,f))}$delete(w,h,g){return Promise.resolve(this._getFsProvider(w).delete(c.URI.revive(h),g))}$rename(w,h,g,f){return Promise.resolve(this._getFsProvider(w).rename(c.URI.revive(h),c.URI.revive(g),f))}$copy(w,h,g,f){const v=this._getFsProvider(w);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(c.URI.revive(h),c.URI.revive(g),f))}$mkdir(w,h){return Promise.resolve(this._getFsProvider(w).createDirectory(c.URI.revive(h)))}$watch(w,h,g,f){const v=this._getFsProvider(w).watch(c.URI.revive(g),f);this._watches.set(h,v)}$unwatch(w,h){const g=this._watches.get(h);g&&(g.dispose(),this._watches.delete(h))}$open(w,h,g){const f=this._getFsProvider(w);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(c.URI.revive(h),g))}$close(w,h){const g=this._getFsProvider(w);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(h))}$read(w,h,g,f){const v=this._getFsProvider(w);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const m=k.VSBuffer.alloc(f);return Promise.resolve(v.read(h,g,m.buffer,0,f)).then(r=>m.slice(0,r))}$write(w,h,g,f){const v=this._getFsProvider(w);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(h,g,f.buffer,0,f.byteLength))}_getFsProvider(w){const h=this._fsProvider.get(w);if(!h){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return h}}e.ExtHostFileSystem=E}),define(De[69],Ie([1,0,5,38,7,23,3,16,46,6]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Qt{constructor(E,_){this._fileSystemProvider=new Map,this._proxy=E.getProxy(c.MainContext.MainThreadFileSystem);const w=this;this.value=Object.freeze({async stat(h){try{const g=w._fileSystemProvider.get(h.scheme);if(!g)return await w._proxy.$stat(h);await w._proxy.$ensureActivation(h.scheme);const f=await g.stat(h);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(g){Qt._handleError(g)}},async readDirectory(h){try{const g=w._fileSystemProvider.get(h.scheme);return g?(await w._proxy.$ensureActivation(h.scheme),(await g.readDirectory(h)).slice()):await w._proxy.$readdir(h)}catch(g){return Qt._handleError(g)}},async createDirectory(h){try{return await w._proxy.$mkdir(h)}catch(g){return Qt._handleError(g)}},async readFile(h){try{const g=w._fileSystemProvider.get(h.scheme);return g?(await w._proxy.$ensureActivation(h.scheme),(await g.readFile(h)).slice()):(await w._proxy.$readFile(h)).buffer}catch(g){return Qt._handleError(g)}},async writeFile(h,g){try{return await w._proxy.$writeFile(h,P.VSBuffer.wrap(g))}catch(f){return Qt._handleError(f)}},async delete(h,g){try{const f=w._fileSystemProvider.get(h.scheme);return f?(await w._proxy.$ensureActivation(h.scheme),await f.delete(h,{recursive:!1,...g})):await w._proxy.$delete(h,{recursive:!1,useTrash:!1,...g})}catch(f){return Qt._handleError(f)}},async rename(h,g,f){try{return await w._proxy.$rename(h,g,{overwrite:!1,...f})}catch(v){return Qt._handleError(v)}},async copy(h,g,f){try{return await w._proxy.$copy(h,g,{overwrite:!1,...f})}catch(v){return Qt._handleError(v)}},isWritableFileSystem(h){const g=_.getCapabilities(h);if(typeof g=="number")return!(g&2048)}})}static _handleError(E){if(E instanceof D.FileSystemError)throw E;if(!(E instanceof Error))throw new D.FileSystemError(String(E));if(E.name==="ENOPRO")throw D.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(E.message);default:throw new D.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,_){return this._fileSystemProvider.set(E,_),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(E))}};A=Ve([He(0,T.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(De[251],Ie([1,0,4,37,2,5,15,7]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(I,E,_,w,h,g,f,v){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter;const m=this.ensureWatching(I,_,h);this._config=0,g&&(this._config+=1),f&&(this._config+=2),v&&(this._config+=4);const r=(0,t.parse)(h),b=typeof h=="string",s=w(u=>{if(!g)for(const o of u.created){const l=D.URI.revive(o);r(l.fsPath)&&(!b||E.getWorkspaceFolder(l))&&this._onDidCreate.fire(l)}if(!f)for(const o of u.changed){const l=D.URI.revive(o);r(l.fsPath)&&(!b||E.getWorkspaceFolder(l))&&this._onDidChange.fire(l)}if(!v)for(const o of u.deleted){const l=D.URI.revive(o);r(l.fsPath)&&(!b||E.getWorkspaceFolder(l))&&this._onDidDelete.fire(l)}});this._disposable=T.Disposable.from(m,this._onDidCreate,this._onDidChange,this._onDidDelete,s)}ensureWatching(I,E,_){const w=T.Disposable.from();if(typeof _=="string")return w;const h=I.getProxy(P.MainContext.MainThreadFileSystem);let g=!1;(_.pattern.includes(t.GLOBSTAR)||_.pattern.includes(t.GLOB_SPLIT))&&(g=!0);const f=Math.random();return h.$watch(E.identifier.value,f,_.baseUri,{recursive:g,excludes:[]}),T.Disposable.from({dispose:()=>h.$unwatch(f)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(I,E,_){this._mainContext=I,this._logService=E,this._extHostDocumentsAndEditors=_,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,E,_,w,h,g){return new S(this._mainContext,I,E,this._onFileSystemEvent.event,y.GlobPattern.from(_),w,h,g)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,E){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(_=>({oldUri:D.URI.revive(_.source),newUri:D.URI.revive(_.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(_=>D.URI.revive(_.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:E.map(_=>D.URI.revive(_.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,E){return(_,w,h)=>{const g=function(v){_.call(w,v)};return g.extension=I,E.event(g,void 0,h)}}async $onWillRunFileOperation(I,E,_,w){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(h=>({oldUri:D.URI.revive(h.source),newUri:D.URI.revive(h.target)}))},_,w);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(h=>D.URI.revive(h.target))},_,w);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(h=>D.URI.revive(h.target))},_,w)}}async _fireWillEvent(I,E,_,w){const h=new Set,g=[];if(await I.fireAsync(E,w,async(v,m)=>{const r=Date.now(),b=await Promise.resolve(v);b instanceof T.WorkspaceEdit&&(g.push([m.extension,b]),h.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-r>_&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),w.isCancellationRequested||g.length===0)return;const f={edits:[]};for(const[,v]of g){const{edits:m}=y.WorkspaceEdit.from(v,{getTextDocumentVersion:r=>this._extHostDocumentsAndEditors.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(m)}return{edit:f,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=k}),define(De[252],Ie([1,0,2,39]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(y,T,S,k,A){this._extHostNotebooks=T,this._textDocumentsAndEditors=S,this._commands=k;const I=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const _=this._extHostNotebooks.getEditorById(E.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",_.id),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri),notebookEditor:_.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(y,T,S,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=D}),define(De[253],Ie([1,0,6,5]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(y){this._handlePool=0,this._proxy=y.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,y),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=D}),define(De[254],Ie([1,0,2,24,15,7,66,5,8,35,17,11,146,21,6,118,98,88,51,10,18,27]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m,r,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(N,j){this._documents=N,this._provider=j}async provideDocumentSymbols(N,j){const G=this._documents.getDocument(N),X=await this._provider.provideDocumentSymbols(G,j);if(!(0,A.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(D.DocumentSymbol.from):s._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(N){N=N.slice(0).sort((X,ge)=>{let be=X.location.range.start.compareTo(ge.location.range.start);return be===0&&(be=ge.location.range.end.compareTo(X.location.range.end)),be});const j=[],G=[];for(const X of N){const ge={name:X.name||"!!MISSING: name!!",kind:D.SymbolKind.from(X.kind),tags:X.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:D.Range.from(X.location.range),selectionRange:D.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(ge),j.push(ge);break}const be=G[G.length-1];if(k.Range.containsRange(be.range,ge.range)&&!k.Range.equalsRange(be.range,ge.range)){be.children?.push(ge),G.push(ge);break}G.pop()}}return j}}class u{constructor(N,j,G){this._documents=N,this._commands=j,this._provider=G,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,j){const G=this._documents.getDocument(N),X=await this._provider.provideCodeLenses(G,j);if(!X||j.isCancellationRequested)return;const ge=this._cache.add(X),be=new w.DisposableStore;this._disposables.set(ge,be);const le={cacheId:ge,lenses:[]};for(let ye=0;ye<X.length;ye++)le.lenses.push({cacheId:[ge,ye],range:D.Range.from(X[ye].range),command:this._commands.toInternal(X[ye].command,be)});return le}async resolveCodeLens(N,j){const G=N.cacheId&&this._cache.get(...N.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,j),X||(X=G),j.isCancellationRequested)return;const ge=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!ge)return N.command=this._commands.toInternal(X.command??u._badCmd,ge),N}releaseCodeLenses(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(se){return Array.isArray(se)?se.map(D.DefinitionLink.from):se?[D.DefinitionLink.from(se)]:[]}class l{constructor(N,j){this._documents=N,this._provider=j}async provideDefinition(N,j,G){const X=this._documents.getDocument(N),ge=D.Position.to(j),be=await this._provider.provideDefinition(X,ge,G);return o(be)}}class a{constructor(N,j){this._documents=N,this._provider=j}async provideDeclaration(N,j,G){const X=this._documents.getDocument(N),ge=D.Position.to(j),be=await this._provider.provideDeclaration(X,ge,G);return o(be)}}class d{constructor(N,j){this._documents=N,this._provider=j}async provideImplementation(N,j,G){const X=this._documents.getDocument(N),ge=D.Position.to(j),be=await this._provider.provideImplementation(X,ge,G);return o(be)}}class n{constructor(N,j){this._documents=N,this._provider=j}async provideTypeDefinition(N,j,G){const X=this._documents.getDocument(N),ge=D.Position.to(j),be=await this._provider.provideTypeDefinition(X,ge,G);return o(be)}}class i{constructor(N,j){this._documents=N,this._provider=j}async provideHover(N,j,G){const X=this._documents.getDocument(N),ge=D.Position.to(j),be=await this._provider.provideHover(X,ge,G);if(!(!be||(0,A.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=X.getWordRangeAtPosition(ge)),be.range||(be.range=new P.Range(ge,ge)),D.Hover.from(be)}}class p{constructor(N,j){this._documents=N,this._provider=j}async provideEvaluatableExpression(N,j,G){const X=this._documents.getDocument(N),ge=D.Position.to(j),be=await this._provider.provideEvaluatableExpression(X,ge,G);if(be)return D.EvaluatableExpression.from(be)}}class C{constructor(N,j){this._documents=N,this._provider=j}async provideInlineValues(N,j,G,X){const ge=this._documents.getDocument(N),be=await this._provider.provideInlineValues(ge,D.Range.to(j),D.InlineValueContext.to(G),X);if(Array.isArray(be))return be.map(le=>D.InlineValue.from(le))}}class R{constructor(N,j){this._documents=N,this._provider=j}async provideDocumentHighlights(N,j,G){const X=this._documents.getDocument(N),ge=D.Position.to(j),be=await this._provider.provideDocumentHighlights(X,ge,G);if(Array.isArray(be))return be.map(D.DocumentHighlight.from)}}class M{constructor(N,j){this._documents=N,this._provider=j}async provideLinkedEditingRanges(N,j,G){const X=this._documents.getDocument(N),ge=D.Position.to(j),be=await this._provider.provideLinkedEditingRanges(X,ge,G);if(be&&Array.isArray(be.ranges))return{ranges:(0,A.coalesce)(be.ranges.map(D.Range.from)),wordPattern:be.wordPattern}}}class ${constructor(N,j){this._documents=N,this._provider=j}async provideReferences(N,j,G,X){const ge=this._documents.getDocument(N),be=D.Position.to(j),le=await this._provider.provideReferences(ge,be,G,X);if(Array.isArray(le))return le.map(D.location.from)}}class x{constructor(N,j,G,X,ge,be,le){this._documents=N,this._commands=j,this._diagnostics=G,this._provider=X,this._logService=ge,this._extension=be,this._apiDeprecation=le,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(N,j,G,X){const ge=this._documents.getDocument(N),be=E.Selection.isISelection(j)?D.Selection.to(j):D.Range.to(j),le=[];for(const Qe of this._diagnostics.getDiagnostics(N))if(be.intersection(Qe.range)&&le.push(Qe)>x._maxCodeActionsPerFile)break;const ye={diagnostics:le,only:G.only?new P.CodeActionKind(G.only):void 0,triggerKind:D.CodeActionTriggerKind.to(G.trigger)},Ce=await this._provider.provideCodeActions(ge,be,ye,X);if(!(0,A.isNonEmptyArray)(Ce)||X.isCancellationRequested)return;const We=this._cache.add(Ce),je=new w.DisposableStore;this._disposables.set(We,je);const Je=[];for(let Qe=0;Qe<Ce.length;Qe++){const Ze=Ce[Qe];!Ze||(x._isCommand(Ze)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:Ze.title,command:this._commands.toInternal(Ze,je)})):(ye.only&&(Ze.kind?ye.only.contains(Ze.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ye.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ye.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[We,Qe],title:Ze.title,command:Ze.command&&this._commands.toInternal(Ze.command,je),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(D.Diagnostic.from),edit:Ze.edit&&D.WorkspaceEdit.from(Ze.edit,void 0),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,disabled:Ze.disabled?.reason})))}return{cacheId:We,actions:Je}}async resolveCodeAction(N,j){const[G,X]=N,ge=this._cache.get(G,X);if(!ge||x._isCommand(ge)||!this._provider.resolveCodeAction)return;const be=await this._provider.resolveCodeAction(ge,j)??ge;return be?.edit?D.WorkspaceEdit.from(be.edit,void 0):void 0}releaseCodeActions(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}x._maxCodeActionsPerFile=1e3;class L{constructor(N,j,G,X){this._proxy=N,this._documents=j,this._provider=G,this._handle=X}async prepareDocumentPaste(N,j,G,X){if(!this._provider.prepareDocumentPaste)return;const ge=this._documents.getDocument(N),be=j.map(ye=>D.Range.to(ye)),le=D.DataTransfer.toDataTransfer(G,()=>{throw new m.NotImplementedError});return await this._provider.prepareDocumentPaste(ge,be,le,X),D.DataTransfer.toDataTransferDTO(le)}async providePasteEdits(N,j,G,X,ge){const be=this._documents.getDocument(j),le=G.map(We=>D.Range.to(We)),ye=D.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolvePasteFileData(this._handle,N,We)).buffer),Ce=await this._provider.provideDocumentPasteEdits(be,le,ye,ge);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?D.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class B{constructor(N,j){this._documents=N,this._provider=j}async provideDocumentFormattingEdits(N,j,G){const X=this._documents.getDocument(N),ge=await this._provider.provideDocumentFormattingEdits(X,j,G);if(Array.isArray(ge))return ge.map(D.TextEdit.from)}}class O{constructor(N,j){this._documents=N,this._provider=j}async provideDocumentRangeFormattingEdits(N,j,G,X){const ge=this._documents.getDocument(N),be=D.Range.to(j),le=await this._provider.provideDocumentRangeFormattingEdits(ge,be,G,X);if(Array.isArray(le))return le.map(D.TextEdit.from)}}class z{constructor(N,j){this._documents=N,this._provider=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,j,G,X,ge){const be=this._documents.getDocument(N),le=D.Position.to(j),ye=await this._provider.provideOnTypeFormattingEdits(be,le,G,X,ge);if(Array.isArray(ye))return ye.map(D.TextEdit.from)}}class U{constructor(N,j){this._provider=N,this._logService=j,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,j){const G=await this._provider.provideWorkspaceSymbols(N,j);if(!(0,A.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),ge={cacheId:X,symbols:[]};for(let be=0;be<G.length;be++){const le=G[be];if(!le||!le.name){this._logService.warn("INVALID SymbolInformation",le);continue}ge.symbols.push({...D.WorkspaceSymbol.from(le),cacheId:[X,be]})}return ge}async resolveWorkspaceSymbol(N,j){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const G=this._cache.get(...N.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,j);return X&&(0,t.mixin)(N,D.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(N){this._cache.delete(N)}}class F{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,j,G){this._documents=N,this._provider=j,this._logService=G}async provideRenameEdits(N,j,G,X){const ge=this._documents.getDocument(N),be=D.Position.to(j);try{const le=await this._provider.provideRenameEdits(ge,be,G,X);return le?D.WorkspaceEdit.from(le):void 0}catch(le){const ye=F._asMessage(le);return ye?{rejectReason:ye,edits:void 0}:Promise.reject(le)}}async resolveRenameLocation(N,j,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(N),ge=D.Position.to(j);try{const be=await this._provider.prepareRename(X,ge,G);let le,ye;if(P.Range.isRange(be)?(le=be,ye=X.getText(be)):(0,I.isObject)(be)&&(le=be.range,ye=be.placeholder),!le||!ye)return;if(le.start.line>ge.line||le.end.line<ge.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(le),text:ye}}catch(be){const le=F._asMessage(be);return le?{rejectReason:le,range:void 0,text:void 0}:Promise.reject(be)}}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class V{constructor(N,j){this.resultId=N,this.tokens=j}}class H{constructor(N,j){this._documents=N,this._provider=j,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(N,j,G){const X=this._documents.getDocument(N),ge=j!==0?this._previousResults.get(j):null;let be=typeof ge?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,ge.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return ge&&this._previousResults.delete(j),be?(be=H._fixProvidedSemanticTokens(be),this._send(H._convertToEdits(ge,be),be)):null}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return H._isSemanticTokens(N)?H._isCorrectSemanticTokens(N)?N:new P.SemanticTokens(new Uint32Array(N.data),N.resultId):H._isSemanticTokensEdits(N)?H._isCorrectSemanticTokensEdits(N)?N:new P.SemanticTokensEdits(N.edits.map(j=>new P.SemanticTokensEdit(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const j of N.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,j){if(!H._isSemanticTokens(j)||!N||!N.tokens)return j;const G=N.tokens,X=G.length,ge=j.data,be=ge.length;let le=0;const ye=Math.min(X,be);for(;le<ye&&G[le]===ge[le];)le++;if(le===X&&le===be)return new P.SemanticTokensEdits([],j.resultId);let Ce=0;const We=ye-le;for(;Ce<We&&G[X-Ce-1]===ge[be-Ce-1];)Ce++;return new P.SemanticTokensEdits([{start:le,deleteCount:X-le-Ce,data:ge.subarray(le,be-Ce)}],j.resultId)}_send(N,j){if(H._isSemanticTokens(N)){const G=this._nextResultId++;return this._previousResults.set(G,new V(N.resultId,N.data)),(0,h.encodeSemanticTokensDto)({id:G,type:"full",data:N.data})}if(H._isSemanticTokensEdits(N)){const G=this._nextResultId++;return H._isSemanticTokens(j)?this._previousResults.set(G,new V(j.resultId,j.data)):this._previousResults.set(G,new V(N.resultId)),(0,h.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(N.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class Q{constructor(N,j){this._documents=N,this._provider=j}async provideDocumentRangeSemanticTokens(N,j,G){const X=this._documents.getDocument(N),ge=await this._provider.provideDocumentRangeSemanticTokens(X,D.Range.to(j),G);return ge?this._send(ge):null}_send(N){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=Q;class K{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,j,G,X,ge){this._documents=N,this._commands=j,this._provider=G,this._apiDeprecation=X,this._extension=ge,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(N,j,G,X){const ge=this._documents.getDocument(N),be=D.Position.to(j),le=ge.getWordRangeAtPosition(be)||new P.Range(be,be),ye=le.with({end:be}),Ce=new v.StopWatch(!0),We=await this._provider.provideCompletionItems(ge,be,X,D.CompletionContext.to(G));if(!We||X.isCancellationRequested)return;const je=Array.isArray(We)?new P.CompletionList(We):We,Je=K.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),Qe=new w.DisposableStore;this._disposables.set(Je,Qe);const Ze=[],Be={x:Je,b:Ze,a:{replace:D.Range.from(le),insert:D.Range.from(ye)},c:je.isIncomplete||void 0,d:Ce.elapsed()};for(let ut=0;ut<je.items.length;ut++){const re=je.items[ut],oe=this._convertCompletionItem(re,[Je,ut],ye,le);Ze.push(oe)}return Be}async resolveCompletionItem(N,j){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...N);if(!G)return;const X=await this._provider.resolveCompletionItem(G,j);if(!!X)return this._convertCompletionItem(X,N)}releaseCompletionItems(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,j,G,X){const ge=this._disposables.get(j[0]);if(!ge)throw Error("DisposableStore is missing...");const be=this._commands.toInternal(N.command,ge),le={x:j,a:N.label,b:N.kind!==void 0?D.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(D.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:D.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(D.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),le.h=N.textEdit.newText):typeof N.insertText=="string"?le.h=N.insertText:N.insertText instanceof P.SnippetString&&(le.h=N.insertText.value,le.i|=4);let ye;return N.textEdit?ye=N.textEdit.range:N.range&&(ye=N.range),P.Range.isRange(ye)?le.j=D.Range.from(ye):ye&&(!G?.isEqual(ye.inserting)||!X?.isEqual(ye.replacing))&&(le.j={insert:D.Range.from(ye.inserting),replace:D.Range.from(ye.replacing)}),le}}class de{async provideInlineCompletions(N,j,G,X){}disposeCompletions(N){}handleDidShowCompletionItem(N,j){}}class ee extends de{constructor(N,j,G,X){super(),this._extension=N,this._documents=j,this._provider=G,this._commands=X,this._references=new Y,this._isAdditionsProposedApiEnabled=(0,b.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(N,j,G,X){const ge=this._documents.getDocument(N),be=D.Position.to(j),le=await this._provider.provideInlineCompletionItems(ge,be,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:D.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!le||X.isCancellationRequested)return;const ye=Array.isArray(le)?le:le.items,Ce=this._isAdditionsProposedApiEnabled?Array.isArray(le)?[]:le.commands||[]:[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:ye}),items:ye.map((Je,Qe)=>{let Ze;Je.command&&(We||(We=new w.DisposableStore),Ze=this._commands.toInternal(Je.command,We));const Be=Je.insertText;return{insertText:typeof Be=="string"?Be:{snippet:Be.value},filterText:Je.filterText,range:Je.range?D.Range.from(Je.range):void 0,command:Ze,idx:Qe,completeBracketPairs:this._isAdditionsProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:Ce.map(Je=>(We||(We=new w.DisposableStore),this._commands.toInternal(Je,We)))}}disposeCompletions(N){this._references.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,j){const G=this._references.get(N)?.items[j];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class fe extends de{constructor(N,j,G,X){super(),this.extension=N,this._documents=j,this._provider=G,this._commands=X,this._references=new Y,this.isAdditionProposedApiEnabled=(0,b.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(N,j,G,X){const ge=this._documents.getDocument(N),be=D.Position.to(j),le=await this._provider.provideInlineCompletionItems(ge,be,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:D.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!le||X.isCancellationRequested)return;const ye=Array.isArray(le)?le:le.items,Ce=Array.isArray(le)?[]:le.commands||[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:ye}),items:ye.map((Je,Qe)=>{let Ze;Je.command&&(We||(We=new w.DisposableStore),Ze=this._commands.toInternal(Je.command,We));const Be=Je.insertText;return{insertText:typeof Be=="string"?Be:{snippet:Be.value},filterText:Je.filterText,range:Je.range?D.Range.from(Je.range):void 0,command:Ze,idx:Qe,completeBracketPairs:this.isAdditionProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:Ce.map(Je=>(We||(We=new w.DisposableStore),this._commands.toInternal(Je,We)))}}disposeCompletions(N){this._references.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,j){const G=this._references.get(N)?.items[j];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class Y{constructor(){this._references=new Map,this._idPool=1}createReferenceId(N){const j=this._idPool++;return this._references.set(j,N),j}disposeReferenceId(N){const j=this._references.get(N);return this._references.delete(N),j}get(N){return this._references.get(N)}}class ve{constructor(N,j){this._documents=N,this._provider=j,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(N,j,G,X){const ge=this._documents.getDocument(N),be=D.Position.to(j),le=this.reviveContext(G),ye=await this._provider.provideSignatureHelp(ge,be,X,le);if(ye){const Ce=this._cache.add([ye]);return{...D.SignatureHelp.from(ye),id:Ce}}}reviveContext(N){let j;if(N.activeSignatureHelp){const G=D.SignatureHelp.to(N.activeSignatureHelp),X=this._cache.get(N.activeSignatureHelp.id,0);X?(j=X,j.activeSignature=G.activeSignature,j.activeParameter=G.activeParameter):j=G}return{...N,activeSignatureHelp:j}}releaseSignatureHelp(N){this._cache.delete(N)}}class Ee{constructor(N,j,G,X,ge){this._documents=N,this._commands=j,this._provider=G,this._logService=X,this._extension=ge,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(N,j,G){const X=this._documents.getDocument(N),ge=D.Range.to(j),be=await this._provider.provideInlayHints(X,ge,G);if(!Array.isArray(be)||be.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${j}`);return}if(G.isCancellationRequested)return;const le=this._cache.add(be);this._disposables.set(le,new w.DisposableStore);const ye={hints:[],cacheId:le};for(let Ce=0;Ce<be.length;Ce++)this._isValidInlayHint(be[Ce],ge)&&ye.hints.push(this._convertInlayHint(be[Ce],[le,Ce]));return this._logService.trace(`[InlayHints] ${ye.hints.length} inlay hints from '${this._extension.identifier.value}' for ${j}`),ye}async resolveInlayHint(N,j){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...N);if(!G)return;const X=await this._provider.resolveInlayHint(G,j);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,N)}releaseHints(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_isValidInlayHint(N,j){return N.label.length===0||Array.isArray(N.label)&&N.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(j&&!j.contains(N.position))}_convertInlayHint(N,j){const G=this._disposables.get(j[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:j,tooltip:D.MarkdownString.fromStrict(N.tooltip),position:D.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(D.TextEdit.from),kind:N.kind&&D.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?X.label=N.label:X.label=N.label.map(ge=>{const be={label:ge.value};return be.tooltip=D.MarkdownString.fromStrict(ge.tooltip),P.Location.isLocation(ge.location)&&(be.location=D.location.from(ge.location)),ge.command&&(be.command=this._commands.toInternal(ge.command,G)),be}),X}}class ke{constructor(N,j){this._documents=N,this._provider=j,this._cache=new f.Cache("DocumentLink")}async provideLinks(N,j){const G=this._documents.getDocument(N),X=await this._provider.provideDocumentLinks(G,j);if(!(!Array.isArray(X)||X.length===0)&&!j.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(ke._validateLink).map(D.DocumentLink.from)};{const ge=this._cache.add(X),be={links:[],cacheId:ge};for(let le=0;le<X.length;le++){if(!ke._validateLink(X[le]))continue;const ye=D.DocumentLink.from(X[le]);ye.cacheId=[ge,le],be.links.push(ye)}return be}}}static _validateLink(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,j){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...N);if(!G)return;const X=await this._provider.resolveDocumentLink(G,j);if(!(!X||!ke._validateLink(X)))return D.DocumentLink.from(X)}releaseLinks(N){this._cache.delete(N)}}class Re{constructor(N,j){this._documents=N,this._provider=j}async provideColors(N,j){const G=this._documents.getDocument(N),X=await this._provider.provideDocumentColors(G,j);return Array.isArray(X)?X.map(be=>({color:D.Color.from(be.color),range:D.Range.from(be.range)})):[]}async provideColorPresentations(N,j,G){const X=this._documents.getDocument(N),ge=D.Range.to(j.range),be=D.Color.to(j.color),le=await this._provider.provideColorPresentations(be,{document:X,range:ge},G);if(!!Array.isArray(le))return le.map(D.ColorPresentation.from)}}class ze{constructor(N,j){this._documents=N,this._provider=j}async provideFoldingRanges(N,j,G){const X=this._documents.getDocument(N),ge=await this._provider.provideFoldingRanges(X,j,G);if(!!Array.isArray(ge))return ge.map(D.FoldingRange.from)}}class ie{constructor(N,j,G){this._documents=N,this._provider=j,this._logService=G}async provideSelectionRanges(N,j,G){const X=this._documents.getDocument(N),ge=j.map(D.Position.to),be=await this._provider.provideSelectionRanges(X,ge,G);if(!(0,A.isNonEmptyArray)(be))return[];if(be.length!==ge.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const le=[];for(let ye=0;ye<ge.length;ye++){const Ce=[];le.push(Ce);let We=ge[ye],je=be[ye];for(;;){if(!je.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(D.SelectionRange.from(je)),!je.parent)break;We=je.range,je=je.parent}}return le}}class ce{constructor(N,j){this._documents=N,this._provider=j,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(N,j,G){const X=this._documents.getDocument(N),ge=D.Position.to(j),be=await this._provider.prepareCallHierarchy(X,ge,G);if(!be)return;const le=this._idPool.nextId();return this._cache.set(le,new Map),Array.isArray(be)?be.map(ye=>this._cacheAndConvertItem(le,ye)):[this._cacheAndConvertItem(le,be)]}async provideCallsTo(N,j,G){const X=this._itemFromCache(N,j);if(!X)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!ge)return ge.map(be=>({from:this._cacheAndConvertItem(N,be.from),fromRanges:be.fromRanges.map(le=>D.Range.from(le))}))}async provideCallsFrom(N,j,G){const X=this._itemFromCache(N,j);if(!X)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!ge)return ge.map(be=>({to:this._cacheAndConvertItem(N,be.to),fromRanges:be.fromRanges.map(le=>D.Range.from(le))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,j){const G=this._cache.get(N),X=D.CallHierarchyItem.from(j,N,G.size.toString(36));return G.set(X._itemId,j),X}_itemFromCache(N,j){return this._cache.get(N)?.get(j)}}class me{constructor(N,j){this._documents=N,this._provider=j,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(N,j,G){const X=this._documents.getDocument(N),ge=D.Position.to(j),be=await this._provider.prepareTypeHierarchy(X,ge,G);if(!be)return;const le=this._idPool.nextId();return this._cache.set(le,new Map),Array.isArray(be)?be.map(ye=>this._cacheAndConvertItem(le,ye)):[this._cacheAndConvertItem(le,be)]}async provideSupertypes(N,j,G){const X=this._itemFromCache(N,j);if(!X)throw new Error("missing type hierarchy item");const ge=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!ge)return ge.map(be=>this._cacheAndConvertItem(N,be))}async provideSubtypes(N,j,G){const X=this._itemFromCache(N,j);if(!X)throw new Error("missing type hierarchy item");const ge=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!ge)return ge.map(be=>this._cacheAndConvertItem(N,be))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,j){const G=this._cache.get(N),X=D.TypeHierarchyItem.from(j,N,G.size.toString(36));return G.set(X._itemId,j),X}_itemFromCache(N,j){return this._cache.get(N)?.get(j)}}class J{constructor(N,j,G,X){this._proxy=N,this._documents=j,this._provider=G,this._handle=X}async provideDocumentOnDropEdits(N,j,G,X,ge){const be=this._documents.getDocument(j),le=D.Position.to(G),ye=D.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,N,We)).buffer),Ce=await this._provider.provideDocumentDropEdits(be,le,ye,ge);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?D.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ae{constructor(N,j){this.adapter=N,this.extension=j}}class ne{constructor(N,j,G,X,ge,be,le,ye){this._uriTransformer=j,this._documents=G,this._commands=X,this._diagnostics=ge,this._logService=be,this._apiDeprecation=le,this._extensionTelemetry=ye,this._adapter=new Map,this._proxy=N.getProxy(T.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(N){return D.DocumentSelector.from(N,this._uriTransformer)}_createDisposable(N){return new P.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return ne._handlePool++}async _withAdapter(N,j,G,X,ge,be=!1){const le=this._adapter.get(N);if(!le||!(le.adapter instanceof j))return X;const ye=Date.now();be||this._logService.trace(`[${le.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ce=G(le.adapter,le.extension);return Promise.resolve(Ce).catch(We=>{(0,m.isCancellationError)(We)||(this._logService.error(`[${le.extension.identifier.value}] provider FAILED`),this._logService.error(We),this._extensionTelemetry.onExtensionError(le.extension.identifier,We))}).finally(()=>{be||this._logService.trace(`[${le.extension.identifier.value}] provider DONE after ${Date.now()-ye}ms`)}),_.CancellationToken.isCancellationToken(ge)?(0,r.raceCancellationError)(Ce,ge):Ce}_addNewAdapter(N,j){const G=this._nextHandle();return this._adapter.set(G,new ae(N,j)),G}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,j,G,X){const ge=this._addNewAdapter(new s(this._documents,G),N),be=X&&X.label||ne._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(ge,this._transformDocumentSelector(j),be),this._createDisposable(ge)}$provideDocumentSymbols(N,j,G){return this._withAdapter(N,s,X=>X.provideDocumentSymbols(c.URI.revive(j),G),void 0,G)}registerCodeLensProvider(N,j,G){const X=this._nextHandle(),ge=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new u(this._documents,this._commands.converter,G),N)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(j),ge);let be=this._createDisposable(X);if(ge!==void 0){const le=G.onDidChangeCodeLenses(ye=>this._proxy.$emitCodeLensEvent(ge));be=P.Disposable.from(be,le)}return be}$provideCodeLenses(N,j,G){return this._withAdapter(N,u,X=>X.provideCodeLenses(c.URI.revive(j),G),void 0,G)}$resolveCodeLens(N,j,G){return this._withAdapter(N,u,X=>X.resolveCodeLens(j,G),void 0,void 0)}$releaseCodeLenses(N,j){this._withAdapter(N,u,G=>Promise.resolve(G.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(N,j,G){const X=this._addNewAdapter(new l(this._documents,G),N);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDefinition(N,j,G,X){return this._withAdapter(N,l,ge=>ge.provideDefinition(c.URI.revive(j),G,X),[],X)}registerDeclarationProvider(N,j,G){const X=this._addNewAdapter(new a(this._documents,G),N);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDeclaration(N,j,G,X){return this._withAdapter(N,a,ge=>ge.provideDeclaration(c.URI.revive(j),G,X),[],X)}registerImplementationProvider(N,j,G){const X=this._addNewAdapter(new d(this._documents,G),N);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideImplementation(N,j,G,X){return this._withAdapter(N,d,ge=>ge.provideImplementation(c.URI.revive(j),G,X),[],X)}registerTypeDefinitionProvider(N,j,G){const X=this._addNewAdapter(new n(this._documents,G),N);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideTypeDefinition(N,j,G,X){return this._withAdapter(N,n,ge=>ge.provideTypeDefinition(c.URI.revive(j),G,X),[],X)}registerHoverProvider(N,j,G,X){const ge=this._addNewAdapter(new i(this._documents,G),N);return this._proxy.$registerHoverProvider(ge,this._transformDocumentSelector(j)),this._createDisposable(ge)}$provideHover(N,j,G,X){return this._withAdapter(N,i,ge=>ge.provideHover(c.URI.revive(j),G,X),void 0,X)}registerEvaluatableExpressionProvider(N,j,G,X){const ge=this._addNewAdapter(new p(this._documents,G),N);return this._proxy.$registerEvaluatableExpressionProvider(ge,this._transformDocumentSelector(j)),this._createDisposable(ge)}$provideEvaluatableExpression(N,j,G,X){return this._withAdapter(N,p,ge=>ge.provideEvaluatableExpression(c.URI.revive(j),G,X),void 0,X)}registerInlineValuesProvider(N,j,G,X){const ge=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,be=this._addNewAdapter(new C(this._documents,G),N);this._proxy.$registerInlineValuesProvider(be,this._transformDocumentSelector(j),ge);let le=this._createDisposable(be);if(ge!==void 0){const ye=G.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(ge));le=P.Disposable.from(le,ye)}return le}$provideInlineValues(N,j,G,X,ge){return this._withAdapter(N,C,be=>be.provideInlineValues(c.URI.revive(j),G,X,ge),void 0,ge)}registerDocumentHighlightProvider(N,j,G){const X=this._addNewAdapter(new R(this._documents,G),N);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentHighlights(N,j,G,X){return this._withAdapter(N,R,ge=>ge.provideDocumentHighlights(c.URI.revive(j),G,X),void 0,X)}registerLinkedEditingRangeProvider(N,j,G){const X=this._addNewAdapter(new M(this._documents,G),N);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideLinkedEditingRanges(N,j,G,X){return this._withAdapter(N,M,async ge=>{const be=await ge.provideLinkedEditingRanges(c.URI.revive(j),G,X);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?ne._serializeRegExp(be.wordPattern):void 0}},void 0,X)}registerReferenceProvider(N,j,G){const X=this._addNewAdapter(new $(this._documents,G),N);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideReferences(N,j,G,X,ge){return this._withAdapter(N,$,be=>be.provideReferences(c.URI.revive(j),G,X,ge),void 0,ge)}registerCodeActionProvider(N,j,G,X){const ge=new w.DisposableStore,be=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,G,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(j),{providedKinds:X?.providedCodeActionKinds?.map(le=>le.value),documentation:X?.documentation?.map(le=>({kind:le.kind.value,command:this._commands.converter.toInternal(le.command,ge)}))},ne._extLabel(N),Boolean(G.resolveCodeAction)),ge.add(this._createDisposable(be)),ge}$provideCodeActions(N,j,G,X,ge){return this._withAdapter(N,x,be=>be.provideCodeActions(c.URI.revive(j),G,X,ge),void 0,ge)}$resolveCodeAction(N,j,G){return this._withAdapter(N,x,X=>X.resolveCodeAction(j,G),void 0,void 0)}$releaseCodeActions(N,j){this._withAdapter(N,x,G=>Promise.resolve(G.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(N,j,G){const X=this._addNewAdapter(new B(this._documents,G),N);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(j),N.identifier,N.displayName||N.name),this._createDisposable(X)}$provideDocumentFormattingEdits(N,j,G,X){return this._withAdapter(N,B,ge=>ge.provideDocumentFormattingEdits(c.URI.revive(j),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(N,j,G){const X=this._addNewAdapter(new O(this._documents,G),N);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(j),N.identifier,N.displayName||N.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(N,j,G,X,ge){return this._withAdapter(N,O,be=>be.provideDocumentRangeFormattingEdits(c.URI.revive(j),G,X,ge),void 0,ge)}registerOnTypeFormattingEditProvider(N,j,G,X){const ge=this._addNewAdapter(new z(this._documents,G),N);return this._proxy.$registerOnTypeFormattingSupport(ge,this._transformDocumentSelector(j),X,N.identifier),this._createDisposable(ge)}$provideOnTypeFormattingEdits(N,j,G,X,ge,be){return this._withAdapter(N,z,le=>le.provideOnTypeFormattingEdits(c.URI.revive(j),G,X,ge,be),void 0,be)}registerWorkspaceSymbolProvider(N,j){const G=this._addNewAdapter(new U(j,this._logService),N);return this._proxy.$registerNavigateTypeSupport(G,typeof j.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(N,j,G){return this._withAdapter(N,U,X=>X.provideWorkspaceSymbols(j,G),{symbols:[]},G)}$resolveWorkspaceSymbol(N,j,G){return this._withAdapter(N,U,X=>X.resolveWorkspaceSymbol(j,G),void 0,void 0)}$releaseWorkspaceSymbols(N,j){this._withAdapter(N,U,G=>G.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(N,j,G){const X=this._addNewAdapter(new F(this._documents,G,this._logService),N);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(j),F.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(N,j,G,X,ge){return this._withAdapter(N,F,be=>be.provideRenameEdits(c.URI.revive(j),G,X,ge),void 0,ge)}$resolveRenameLocation(N,j,G,X){return this._withAdapter(N,F,ge=>ge.resolveRenameLocation(c.URI.revive(j),G,X),void 0,X)}registerDocumentSemanticTokensProvider(N,j,G,X){const ge=this._addNewAdapter(new H(this._documents,G),N),be=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ge,this._transformDocumentSelector(j),X,be);let le=this._createDisposable(ge);if(be){const ye=G.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(be));le=P.Disposable.from(le,ye)}return le}$provideDocumentSemanticTokens(N,j,G,X){return this._withAdapter(N,H,ge=>ge.provideDocumentSemanticTokens(c.URI.revive(j),G,X),null,X)}$releaseDocumentSemanticTokens(N,j){this._withAdapter(N,H,G=>G.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,j,G,X){const ge=this._addNewAdapter(new Q(this._documents,G),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ge,this._transformDocumentSelector(j),X),this._createDisposable(ge)}$provideDocumentRangeSemanticTokens(N,j,G,X){return this._withAdapter(N,Q,ge=>ge.provideDocumentRangeSemanticTokens(c.URI.revive(j),G,X),null,X)}registerCompletionItemProvider(N,j,G,X){const ge=this._addNewAdapter(new K(this._documents,this._commands.converter,G,this._apiDeprecation,N),N);return this._proxy.$registerCompletionsProvider(ge,this._transformDocumentSelector(j),X,K.supportsResolving(G),`${N.identifier.value}(${X.join("")})`),this._createDisposable(ge)}$provideCompletionItems(N,j,G,X,ge){return this._withAdapter(N,K,be=>be.provideCompletionItems(c.URI.revive(j),G,X,ge),void 0,ge)}$resolveCompletionItem(N,j,G){return this._withAdapter(N,K,X=>X.resolveCompletionItem(j,G),void 0,G)}$releaseCompletionItems(N,j){this._withAdapter(N,K,G=>G.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(N,j,G){const X=new ee(N,this._documents,G,this._commands.converter),ge=this._addNewAdapter(X,N);return this._proxy.$registerInlineCompletionsSupport(ge,this._transformDocumentSelector(j),X.supportsHandleDidShowCompletionItem),this._createDisposable(ge)}registerInlineCompletionsProviderNew(N,j,G){const X=this._addNewAdapter(new fe(N,this._documents,G,this._commands.converter),N);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(j),!0),this._createDisposable(X)}$provideInlineCompletions(N,j,G,X,ge){return this._withAdapter(N,de,be=>be.provideInlineCompletions(c.URI.revive(j),G,X,ge),void 0,ge)}$handleInlineCompletionDidShow(N,j,G){this._withAdapter(N,de,async X=>{X.handleDidShowCompletionItem(j,G)},void 0,void 0)}$freeInlineCompletionsList(N,j){this._withAdapter(N,de,async G=>{G.disposeCompletions(j)},void 0,void 0)}registerSignatureHelpProvider(N,j,G,X){const ge=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,be=this._addNewAdapter(new ve(this._documents,G),N);return this._proxy.$registerSignatureHelpProvider(be,this._transformDocumentSelector(j),ge),this._createDisposable(be)}$provideSignatureHelp(N,j,G,X,ge){return this._withAdapter(N,ve,be=>be.provideSignatureHelp(c.URI.revive(j),G,X,ge),void 0,ge)}$releaseSignatureHelp(N,j){this._withAdapter(N,ve,G=>G.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(N,j,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new Ee(this._documents,this._commands.converter,G,this._logService,N),N);this._proxy.$registerInlayHintsProvider(ge,this._transformDocumentSelector(j),typeof G.resolveInlayHint=="function",X,ne._extLabel(N));let be=this._createDisposable(ge);if(X!==void 0){const le=G.onDidChangeInlayHints(ye=>this._proxy.$emitInlayHintsEvent(X));be=P.Disposable.from(be,le)}return be}$provideInlayHints(N,j,G,X){return this._withAdapter(N,Ee,ge=>ge.provideInlayHints(c.URI.revive(j),G,X),void 0,X)}$resolveInlayHint(N,j,G){return this._withAdapter(N,Ee,X=>X.resolveInlayHint(j,G),void 0,G)}$releaseInlayHints(N,j){this._withAdapter(N,Ee,G=>G.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(N,j,G){const X=this._addNewAdapter(new ke(this._documents,G),N);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(j),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(N,j,G){return this._withAdapter(N,ke,X=>X.provideLinks(c.URI.revive(j),G),void 0,G,j.scheme==="output")}$resolveDocumentLink(N,j,G){return this._withAdapter(N,ke,X=>X.resolveLink(j,G),void 0,void 0,!0)}$releaseDocumentLinks(N,j){this._withAdapter(N,ke,G=>G.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(N,j,G){const X=this._addNewAdapter(new Re(this._documents,G),N);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentColors(N,j,G){return this._withAdapter(N,Re,X=>X.provideColors(c.URI.revive(j),G),[],G)}$provideColorPresentations(N,j,G,X){return this._withAdapter(N,Re,ge=>ge.provideColorPresentations(c.URI.revive(j),G,X),void 0,X)}registerFoldingRangeProvider(N,j,G){const X=this._nextHandle(),ge=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new ze(this._documents,G),N)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(j),N.identifier,ge);let be=this._createDisposable(X);if(ge!==void 0){const le=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ge));be=P.Disposable.from(be,le)}return be}$provideFoldingRanges(N,j,G,X){return this._withAdapter(N,ze,ge=>ge.provideFoldingRanges(c.URI.revive(j),G,X),void 0,X)}registerSelectionRangeProvider(N,j,G){const X=this._addNewAdapter(new ie(this._documents,G,this._logService),N);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideSelectionRanges(N,j,G,X){return this._withAdapter(N,ie,ge=>ge.provideSelectionRanges(c.URI.revive(j),G,X),[],X)}registerCallHierarchyProvider(N,j,G){const X=this._addNewAdapter(new ce(this._documents,G),N);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$prepareCallHierarchy(N,j,G,X){return this._withAdapter(N,ce,ge=>Promise.resolve(ge.prepareSession(c.URI.revive(j),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(N,j,G,X){return this._withAdapter(N,ce,ge=>ge.provideCallsTo(j,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(N,j,G,X){return this._withAdapter(N,ce,ge=>ge.provideCallsFrom(j,G,X),void 0,X)}$releaseCallHierarchy(N,j){this._withAdapter(N,ce,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(N,j,G){const X=this._addNewAdapter(new me(this._documents,G),N);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$prepareTypeHierarchy(N,j,G,X){return this._withAdapter(N,me,ge=>Promise.resolve(ge.prepareSession(c.URI.revive(j),G,X)),void 0,X)}$provideTypeHierarchySupertypes(N,j,G,X){return this._withAdapter(N,me,ge=>ge.provideSupertypes(j,G,X),void 0,X)}$provideTypeHierarchySubtypes(N,j,G,X){return this._withAdapter(N,me,ge=>ge.provideSubtypes(j,G,X),void 0,X)}$releaseTypeHierarchy(N,j){this._withAdapter(N,me,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(N,j,G){const X=this._nextHandle();return this._adapter.set(X,new ae(new J(this._proxy,this._documents,G,X),N)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentOnDropEdits(N,j,G,X,ge,be){return this._withAdapter(N,J,le=>Promise.resolve(le.provideDocumentOnDropEdits(j,c.URI.revive(G),X,ge,be)),void 0,void 0)}registerDocumentPasteEditProvider(N,j,G,X){const ge=this._nextHandle();return this._adapter.set(ge,new ae(new L(this._proxy,this._documents,G,ge),N)),this._proxy.$registerPasteEditProvider(ge,this._transformDocumentSelector(j),!!G.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(ge)}$prepareDocumentPaste(N,j,G,X,ge){return this._withAdapter(N,L,be=>be.prepareDocumentPaste(c.URI.revive(j),G,X,ge),void 0,ge)}$providePasteEdits(N,j,G,X,ge,be){return this._withAdapter(N,L,le=>le.providePasteEdits(j,c.URI.revive(G),X,ge,be),void 0,be)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,S.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:ne._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:ne._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ne._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ne._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:ne._serializeRegExp(N.beforeText),afterText:N.afterText?ne._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?ne._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(ne._serializeOnEnterRule)}setLanguageConfiguration(N,j,G){const{wordPattern:X}=G;if(X&&(0,S.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(j,X):this._documents.setWordDefinitionFor(j,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const ge=this._nextHandle(),be={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ne._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ne._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ne._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ge,j,be),this._createDisposable(ge)}$setWordDefinitions(N){for(const j of N)this._documents.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.ExtHostLanguageFeatures=ne,ne._handlePool=0}),define(De[255],Ie([1,0,5,15,7,42,18,6]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(A,I,E,_){this._documents=I,this._commands=E,this._uriTransformer=_,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=A.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(A){this._languageIds=A}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(A,I){await this._proxy.$changeLanguage(A,I);const E=this._documents.getDocumentData(A);if(!E)throw new Error(`document '${A.toString()}' NOT found`);return E.document}async tokenAtPosition(A,I){const E=A.version,_=t.Position.from(I),w=await this._proxy.$tokensAtPosition(A.uri,_),h={type:D.StandardTokenType.Other,range:A.getWordRangeAtPosition(I)??new D.Range(I.line,I.character,I.line,I.character)};if(!w)return h;const g={range:t.Range.to(w.range),type:t.TokenType.to(w.type)};return!g.range.contains(I)||E!==A.version?h:g}createLanguageStatusItem(A,I,E){const _=this._handlePool++,w=this._proxy,h=this._ids,g=`${A.identifier.value}/${I}`;if(h.has(g))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);h.add(g);const f={selector:E,id:I,name:A.displayName??A.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const m=new T.DisposableStore,r=()=>{v?.dispose(),v=(0,y.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(_,{id:g,name:f.name??A.displayName??A.name,source:A.displayName??A.name,selector:t.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===D.LanguageStatusSeverity.Error?P.default.Error:f.severity===D.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:f.command&&this._commands.toInternal(f.command,m),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},b={dispose(){m.dispose(),v?.dispose(),w.$removeLanguageStatus(_),h.delete(g)},get id(){return f.id},get name(){return f.name},set name(s){f.name=s,r()},get selector(){return f.selector},set selector(s){f.selector=s,r()},get text(){return f.text},set text(s){f.text=s,r()},get detail(){return f.detail},set detail(s){f.detail=s,r()},get severity(){return f.severity},set severity(s){f.severity=s,r()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(s){f.accessibilityInformation=s,r()},get command(){return f.command},set command(s){f.command=s,r()},get busy(){return f.busy},set busy(s){f.busy=s,r()}};return r(),b}}e.ExtHostLanguages=S}),define(De[94],Ie([1,0,12,8,2,3,13,5,25,16]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=class{constructor(E,_,w){this.logService=w,this.bundleCache=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadLocalization),this.currentLanguage=E.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===c.LANGUAGE_DEFAULT}getMessage(E,_){const{message:w,args:h,comment:g}=_;if(this.isDefaultLanguage)return(0,t.format2)(w,h??{});let f=w;g&&g.length>0&&(f+=`/${Array.isArray(g)?g.join():g}`);const v=this.bundleCache.get(E)?.contents[f];return v||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,t.format2)(v??f,h??{})}getBundle(E){return this.bundleCache.get(E)?.contents}getBundleUri(E){return this.bundleCache.get(E)?.uri}async initializeLocalizedMessages(E){if(this.isDefaultLanguage||!E.l10n&&!E.isBuiltin||this.bundleCache.has(E.identifier.value))return;let _;const w=await this.getBundleLocation(E);if(!w){this.logService.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const h=await this._proxy.$fetchBundleContents(w),g=JSON.parse(h);_=E.isBuiltin?g.contents?.bundle:g}catch(h){this.logService.error(`Failed to load translations for ${E.identifier.value} from ${w}: ${h.message}`);return}_&&this.bundleCache.set(E.identifier.value,{contents:_,uri:w})}async getBundleLocation(E){if(E.isBuiltin){const _=await this._proxy.$fetchBuiltInBundleUri(E.identifier.value);return D.URI.revive(_)}return E.l10n?D.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};A=Ve([He(0,S.IExtHostInitDataService),He(1,k.IExtHostRpcService),He(2,y.ILogService)],A),e.ExtHostLocalizationService=A,e.IExtHostLocalizationService=(0,P.createDecorator)("IExtHostLocalizationService")}),define(De[138],Ie([1,0,13,5,25,16,2,4,11]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends c.AbstractLoggerService{constructor(E,_){super(_.logLevel,T.Event.None),this._proxy=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,_){_?this.setLevel(y.URI.revive(_),E):(0,S.isUndefined)(E)||this.setLevel(E)}doCreateLogger(E,_,w){return new A(this._proxy,E,_,w)}};k=Ve([He(0,P.IExtHostRpcService),He(1,D.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class A extends c.AbstractMessageLogger{constructor(E,_,w,h){super(h?.always),this.proxy=E,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(w),this.proxy.$createLogger(_,h).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,_){const w=[[E,_]];this.isLoggerCreated?this.doLog(w):this.buffer.push(...w)}doLog(E){this.proxy.$log(this.file,E)}}}),define(De[256],Ie([1,0,5,13,27]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(T){return T&&T.title}let y=class{constructor(S,k){this._logService=k,this._proxy=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,k,A,I,E){const _={source:{identifier:S.identifier,label:S.displayName||S.name}};let w;typeof I=="string"||P(I)?w=[I,...E]:(_.modal=I?.modal,_.useCustom=I?.useCustom,_.detail=I?.detail,w=E),_.useCustom&&(0,D.checkProposedApiEnabled)(S,"resolvers");const h=[];for(let g=0;g<w.length;g++){const f=w[g];if(typeof f=="string")h.push({title:f,handle:g,isCloseAffordance:!1});else if(typeof f=="object"){const{title:v,isCloseAffordance:m}=f;h.push({title:v,isCloseAffordance:!!m,handle:g})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(k,A,_,h).then(g=>{if(typeof g=="number")return w[g]})}};y=Ve([He(1,t.ILogService)],y),e.ExtHostMessageService=y}),define(De[257],Ie([1,0,23,4,6,28,8,11,2,88,5,39,15,7,57,232,134]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}constructor(m,r,b,s){this._textDocumentsAndEditors=b,this._textDocuments=s,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=m.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const o=u.notebookEditor?.notebookUri,l=u.cell.handle,d=this._documents.get(o)?.getCell(l);if(d)return d.apiCell}if(u&&u.$mid===13){const o=u.uri,l=this._documents.get(o);if(l)return l.apiNotebook}return u}}),f._registerApiCommands(r)}getEditorById(m){const r=this._editors.get(m);if(!r)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(m){for(const[r,b]of this._editors)if(b.apiEditor===m)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,r){const b=this._documents.get(m);if(!b&&!r)throw new Error(`NO notebook document for '${m}'`);return b}_getProviderData(m){const r=this._notebookContentProviders.get(m);if(!r)throw new Error(`NO provider for '${m}'`);return r}registerNotebookContentProvider(m,r,b,s){if((0,y.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);return this._notebookContentProviders.set(r,{extension:m,provider:b}),this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation},r,E.NotebookDocumentContentOptions.from(s),void 0),new _.Disposable(()=>{this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(m,r){if(!r)return;const b=r.filenamePattern.map(s=>E.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(r.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:r.displayName,filenamePattern:b,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,r,b){const s=f._notebookStatusBarItemProviderHandlePool++,u=typeof b.onDidChangeCellStatusBarItems=="function"?f._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,b),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,u,r);let o;return u!==void 0&&(o=b.onDidChangeCellStatusBarItems(l=>this._notebookProxy.$emitCellStatusBarEvent(u))),new _.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,u),o?.dispose()})}async createNotebookDocument(m){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&E.NotebookData.from(m.content)});return S.URI.revive(r)}async openNotebookDocument(m){const r=this._documents.get(m);if(r)return r.apiNotebook;const b=await this._notebookDocumentsProxy.$tryOpenNotebook(m),s=this._documents.get(S.URI.revive(b));return(0,T.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(m,r){S.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let b;typeof r=="object"?b={position:E.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(E.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:b={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,b),u=s&&this._editors.get(s)?.apiEditor;if(u)return u;throw s?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,r,b,s){const u=this._notebookStatusBarItemProviders.get(m),o=S.URI.revive(r),l=this._documents.get(o);if(!l||!u)return;const a=l.getCellFromIndex(b);if(!a)return;const d=await u.provideCellStatusBarItems(a.apiCell,s);if(!d)return;const n=new D.DisposableStore,i=this._statusBarCache.add([n]),C=(Array.isArray(d)?d:[d]).map(R=>E.NotebookStatusBarItem.from(R,this._commandsConverter,n));return{cacheId:i,items:C}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,r,b,s,u){if((0,y.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,b),this._notebookProxy.$registerNotebookSerializer(o,{id:m.identifier,location:m.extensionLocation},r,E.NotebookDocumentContentOptions.from(s),f._convertNotebookRegistrationData(m,u)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(m,r,b){const s=this._notebookSerializer.get(m);if(!s)throw new Error("NO serializer found");const u=await s.deserializeNotebook(r.buffer,b);return new w.SerializableObjectWithBuffers(E.NotebookData.from(u))}async $notebookToData(m,r,b){const s=this._notebookSerializer.get(m);if(!s)throw new Error("NO serializer found");const u=await s.serializeNotebook(E.NotebookData.to(r.value),b);return c.VSBuffer.wrap(u)}async $openNotebook(m,r,b,s,u){const{provider:o}=this._getProviderData(m),l=await o.openNotebook(S.URI.revive(r),{backupId:b,untitledDocumentData:s?.buffer},u);return new w.SerializableObjectWithBuffers({metadata:l.metadata??Object.create(null),cells:l.cells.map(E.NotebookCellData.from)})}_createExtHostEditor(m,r,b){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const s=new g.ExtHostNotebookEditor(r,this._notebookEditorsProxy,m,b.visibleRanges.map(E.NotebookRange.to),b.selections.map(E.NotebookRange.to),typeof b.viewColumn=="number"?E.ViewColumn.to(b.viewColumn):void 0);this._editors.set(r,s)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const b of m.value.removedDocuments){const s=S.URI.revive(b),u=this._documents.get(s);u&&(u.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===s.toString()&&this._editors.delete(o.id)}if(m.value.addedDocuments){const b=[];for(const s of m.value.addedDocuments){const u=S.URI.revive(s.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const o=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,u,s);b.push(...s.cells.map(l=>h.ExtHostCell.asModelAddData(o.apiNotebook,l))),this._documents.get(u)?.dispose(),this._documents.set(u,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(m.value.addedEditors)for(const b of m.value.addedEditors){if(this._editors.has(b.id))return;const s=S.URI.revive(b.documentUri),u=this._documents.get(s);u&&this._createExtHostEditor(u,b.id,b)}const r=[];if(m.value.removedEditors)for(const b of m.value.removedEditors){const s=this._editors.get(b);s&&(this._editors.delete(b),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),r.push(s))}if(m.value.visibleEditors){this._visibleNotebookEditors=m.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const b=new Set;this._visibleNotebookEditors.forEach(s=>b.add(s.id));for(const s of this._editors.values()){const u=b.has(s.id);s._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this._activeNotebookEditor=void 0:m.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(m){const r=I.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new I.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[r,new I.ApiCommandArgument("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>c.VSBuffer.wrap(u))],new I.ApiCommandResult("Notebook Data",u=>E.NotebookData.to(u.value))),s=new I.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[r,new I.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new w.SerializableObjectWithBuffers(E.NotebookData.from(u)))],new I.ApiCommandResult("Bytes",u=>u.buffer));m.registerApiCommand(b),m.registerApiCommand(s)}}e.ExtHostNotebookController=f,f._notebookStatusBarItemProviderHandlePool=0}),define(De[258],Ie([1,0,17,18,21,4,6,28,2,26,13,5,39,15,7,89,220,27,57]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let m=class{constructor(l,a,d,n,i){this._initData=a,this._extHostNotebook=d,this._commands=n,this._logService=i,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=l.getProxy(I.MainContext.MainThreadNotebookKernels);const p=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const R=this._extHostNotebook.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:R}}else if(C&&"notebookEditor"in C){const R=this._extHostNotebook.getIdByEditor(C.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:R}}return C})],E.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(l,a,d,n,i,p){for(const K of this._kernelData.values())if(K.controller.id===a&&k.ExtensionIdentifier.equals(l.identifier,K.extensionId))throw new Error(`notebook controller with id '${a}' ALREADY exist`);const C=this._handlePool++,R=this;this._logService.trace(`NotebookController[${C}], CREATED by ${l.identifier.value}, ${a}`);const M=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${l.identifier}'`);let $=!1;const x=new y.DisposableStore,L=new P.Emitter,B=new P.Emitter,O={id:u(l.identifier,a),notebookType:d,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:n||l.identifier.value,preloads:p?p.map(_.NotebookRendererScript.from):[]};let z=i??M,U;this._proxy.$addKernel(C,O).catch(K=>{console.log(K),$=!0});let F=0;const V=()=>{if($)return;const K=++F;Promise.resolve().then(()=>{K===F&&this._proxy.$updateKernel(C,O)})},H=new T.ResourceMap,Q={get id(){return a},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return O.label},set label(K){O.label=K??l.displayName??l.name,V()},get detail(){return O.detail??""},set detail(K){O.detail=K,V()},get description(){return O.description??""},set description(K){O.description=K,V()},get kind(){return(0,f.checkProposedApiEnabled)(l,"notebookControllerKind"),O.kind??""},set kind(K){(0,f.checkProposedApiEnabled)(l,"notebookControllerKind"),O.kind=K,V()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(K){O.supportedLanguages=K,V()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(K){O.supportsExecutionOrder=K,V()},get rendererScripts(){return O.preloads?O.preloads.map(_.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(K){z=K??M},get interruptHandler(){return U},set interruptHandler(K){U=K,O.supportsInterrupt=Boolean(K),V()},createNotebookCellExecution(K){if($)throw new Error("notebook controller is DISPOSED");if(!H.has(K.notebook.uri))throw R._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${K.notebook.uri.toString()}`);return R._createNotebookCellExecution(K,u(l.identifier,this.id))},dispose:()=>{$||(this._logService.trace(`NotebookController[${C}], DISPOSED`),$=!0,this._kernelData.delete(C),x.dispose(),L.dispose(),B.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(K,de){de===w.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),R._proxy.$updateNotebookPriority(C,K.uri,de)},onDidReceiveMessage:B.event,postMessage(K,de){return(0,f.checkProposedApiEnabled)(l,"notebookMessaging"),R._proxy.$postMessage(C,de&&R._extHostNotebook.getIdByEditor(de),K)},asWebviewUri(K){return(0,f.checkProposedApiEnabled)(l,"notebookMessaging"),(0,h.asWebviewUri)(K,R._initData.remote)}};return this._kernelData.set(C,{extensionId:l.identifier,controller:Q,onDidReceiveMessage:B,onDidChangeSelection:L,associatedNotebooks:H}),Q}getIdByController(l){for(const[a,d]of this._kernelData)if(d.controller===l)return u(d.extensionId,l.id);return null}$acceptNotebookAssociation(l,a,d){const n=this._kernelData.get(l);if(n){const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a));d?n.associatedNotebooks.set(i.uri,!0):n.associatedNotebooks.delete(i.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,i.uri.toString(),d),n.onDidChangeSelection.fire({selected:d,notebook:i.apiNotebook})}}async $executeCells(l,a,d){const n=this._kernelData.get(l);if(!n)return;const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a)),p=[];for(const C of d){const R=i.getCell(C);R&&p.push(R.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,i.uri.toString(),p.length),await n.controller.executeHandler.call(n.controller,p,i.apiNotebook,n.controller)}catch(C){this._logService.error(`NotebookController[${l}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(l,a,d){const n=this._kernelData.get(l);if(!n)return;const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,i.apiNotebook);else for(const p of d){const C=i.getCell(p);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,a,d){const n=this._kernelData.get(l);if(!n)return;const i=this._extHostNotebook.getEditorById(a);n.onDidReceiveMessage.fire(Object.freeze({editor:i.apiEditor,message:d}))}$cellExecutionChanged(l,a,d){const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(l)).getCell(a);if(i){const p=d?_.NotebookCellExecutionState.to(d):w.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:i.apiCell,state:p})}}_createNotebookCellExecution(l,a){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const i=new b(a,n,this._proxy);this._activeExecutions.set(n.uri,i);const p=i.onDidChangeState(()=>{i.state===r.Resolved&&(i.dispose(),p.dispose(),this._activeExecutions.delete(n.uri))});return i.asApiObject()}};m=Ve([He(4,A.ILogService)],m),e.ExtHostNotebookKernels=m;var r;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(r||(r={}));class b extends y.Disposable{get state(){return this._state}constructor(l,a,d){super(),this._cell=a,this._proxy=d,this._handle=b.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new s(10,n=>this.update(n)),this._executionOrder=a.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,l,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(l){await this._collector.addItem(l)}async update(l){const a=Array.isArray(l)?l:[l];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(a))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(l){let a=this._cell;if(l&&(a=this._cell.notebook.getCellFromApiCell(l)),!a)throw new Error("INVALID cell");return a.handle}validateAndConvertOutputs(l){return l.map(a=>{const d=w.NotebookCellOutput.ensureUniqueMimeTypes(a.items,!0);return d===a.items?_.NotebookCellOutput.from(a):_.NotebookCellOutput.from({items:d,id:a.id,metadata:a.metadata})})}async updateOutputs(l,a,d){const n=this.cellIndexToHandle(a),i=this.validateAndConvertOutputs((0,c.asArray)(l));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,cellHandle:n,append:d,outputs:i})}async updateOutputItems(l,a,d){return l=w.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(l),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,items:l.map(_.NotebookCellOutputItem.from),outputId:a.id,append:d})}asApiObject(){const l=this;return Object.freeze({get token(){return l._tokenSource.token},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(d){l._executionOrder=d,l.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:l._executionOrder}])},start(d){if(l._state===r.Resolved||l._state===r.Started)throw new Error("Cannot call start again");l._state=r.Started,l._onDidChangeState.fire(),l.update({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,n){if(l._state===r.Resolved)throw new Error("Cannot call resolve twice");l._state=r.Resolved,l._onDidChangeState.fire(),l._collector.flush(),l._proxy.$completeExecution(l._handle,new v.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:d}))},clearOutput(d){return l.verifyStateForOutput(),l.updateOutputs([],d,!1)},appendOutput(d,n){return l.verifyStateForOutput(),l.updateOutputs(d,n,!0)},replaceOutput(d,n){return l.verifyStateForOutput(),l.updateOutputs(d,n,!1)},appendOutputItems(d,n){return l.verifyStateForOutput(),l.updateOutputItems(d,n,!0)},replaceOutputItems(d,n){return l.verifyStateForOutput(),l.updateOutputItems(d,n,!1)}})}}b.HANDLE=0;class s{constructor(l,a){this.delay=l,this.callback=a,this.batch=[],this.startedTimer=Date.now()}addItem(l){return this.batch.push(l),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const l=this.currentDeferred;this.currentDeferred=void 0;const a=this.batch;return this.batch=[],this.callback(a).finally(()=>l.complete())}}function u(o,l){return`${o.value}/${l}`}e.createKernelId=u}),define(De[259],Ie([1,0,4,5,134]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(T,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=T.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,k){const A=this._extHostNotebook.getEditorById(T);this._rendererMessageEmitters.get(S)?.fire({editor:A.apiEditor,message:k})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(A=>A.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(A,I,E)=>this.getOrCreateEmitterFor(S).event(A,I,E),postMessage:(A,I)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const E=I&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(E?.id,S,A)}}}getOrCreateEmitterFor(T){let S=this._rendererMessageEmitters.get(T);return S||(S=new c.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(T)}}),this._rendererMessageEmitters.set(T,S),S)}}e.ExtHostNotebookRenderers=P}),define(De[260],Ie([1,0,21,4,6,5,2,7,10,17,42,87]),function(Z,e,c,t,D,P,y,T,S,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(_,w,h){const g=_.getProxy(P.MainContext.MainThreadQuickOpen);class f{constructor(a,d){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=d}showQuickPick(a,d,n=c.CancellationToken.None){this._onDidSelectItem=void 0;const i=Promise.resolve(a),p=++this._instances,C=g.$show(p,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},n),R={},M=C.then(()=>R);return Promise.race([M,i]).then($=>{if($!==R)return i.then(x=>{const L=[];for(let B=0;B<x.length;B++){const O=x[B];typeof O=="string"?L.push({label:O,handle:B}):O.kind===T.QuickPickItemKind.Separator?L.push({type:"separator",label:O.label}):L.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:B})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{d.onDidSelectItem(x[B])}),g.$setItems(p,L),C.then(B=>{if(typeof B=="number")return x[B];if(Array.isArray(B))return B.map(O=>x[O])})})}).then(void 0,$=>{if(!(0,S.isCancellationError)($))return g.$setError(p,$),Promise.reject($)})}$onItemSelected(a){this._onDidSelectItem?.(a)}showInput(a,d=c.CancellationToken.None){return this._validateInput=a?.validateInput,g.$input(a,typeof this._validateInput=="function",d).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(a){if(!this._validateInput)return;const d=await this._validateInput(a);if(!d||typeof d=="string")return d;let n;switch(d.severity){case T.InputBoxValidationSeverity.Info:n=A.default.Info;break;case T.InputBoxValidationSeverity.Warning:n=A.default.Warning;break;case T.InputBoxValidationSeverity.Error:n=A.default.Error;break;default:n=d.message?A.default.Error:A.default.Ignore;break}return{content:d.message,severity:n}}async showWorkspaceFolderPick(a,d=c.CancellationToken.None){const n=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!n)return;const i=await this._workspace.getWorkspaceFolders2();if(!!i)return i.find(p=>p.uri.toString()===n.uri.toString())}createQuickPick(a){const d=new u(a,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(a){const d=new o(a,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(a,d){this._sessions.get(a)?._fireDidChangeValue(d)}$onDidAccept(a){this._sessions.get(a)?._fireDidAccept()}$onDidChangeActive(a,d){const n=this._sessions.get(a);n instanceof u&&n._fireDidChangeActive(d)}$onDidChangeSelection(a,d){const n=this._sessions.get(a);n instanceof u&&n._fireDidChangeSelection(d)}$onDidTriggerButton(a,d){this._sessions.get(a)?._fireDidTriggerButton(d)}$onDidTriggerItemButton(a,d,n){const i=this._sessions.get(a);i instanceof u&&i._fireDidTriggerItemButton(d,n)}$onDidHide(a){this._sessions.get(a)?._fireDidHide()}}class v{constructor(a,d){this._extensionId=a,this._onDidDispose=d,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((d,n)=>{const i=d===T.QuickInputButtons.Back?-1:n;this._handlesToButtons.set(i,d)}),this.update({buttons:a.map((d,n)=>({...s(d),tooltip:d.tooltip,handle:d===T.QuickInputButtons.Back?-1:n}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const d=this._handlesToButtons.get(a);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(a){if(!this._disposed){for(const d of Object.keys(a)){const n=a[d];this._pendingUpdate[d]=n===void 0?null:n}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function m(l){if(l instanceof T.ThemeIcon)return{id:l.id};const a=b(l),d=r(l);return{dark:typeof a=="string"?y.URI.file(a):a,light:typeof d=="string"?y.URI.file(d):d}}function r(l){return typeof l=="object"&&"light"in l?l.light:l}function b(l){return typeof l=="object"&&"dark"in l?l.dark:l}function s(l){const a=m(l.iconPath);let d,n;return"id"in a?n=I.ThemeIcon.asClassName(a):d=a,{iconPath:d,iconClass:n}}class u extends v{constructor(a,d){super(a.identifier,d),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((n,i)=>{this._handlesToItems.set(i,n),this._itemsToHandles.set(n,i)});const d=[];for(let n=0;n<a.length;n++){const i=a[n];i.kind===T.QuickPickItemKind.Separator?d.push({type:"separator",label:i.label}):d.push({handle:n,label:i.label,description:i.description,detail:i.detail,picked:i.picked,alwaysShow:i.alwaysShow,buttons:i.buttons?.map((p,C)=>({...s(p),tooltip:p.tooltip,handle:C}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(a){const d=(0,k.coalesce)(a.map(n=>this._handlesToItems.get(n)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(a){const d=(0,k.coalesce)(a.map(n=>this._handlesToItems.get(n)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(a,d){const n=this._handlesToItems.get(a);if(!n||!n.buttons||!n.buttons.length)return;const i=n.buttons[d];i&&this._onDidTriggerItemButtonEmitter.fire({button:i,item:n})}}class o extends v{constructor(a,d){super(a.identifier,d),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get valueSelection(){return this._valueSelection}set valueSelection(a){this._valueSelection=a,this.update({valueSelection:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,a?typeof a=="string"?this.update({validationMessage:a,severity:A.default.Error}):this.update({validationMessage:a.message,severity:a.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new f(w,h)}e.createExtHostQuickOpen=E});var Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)},nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c};define(De[261],Ie([1,0,2,4,60,6,18,5,17,108,13,26,87,15,27]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w){"use strict";var h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(i){if(i)return typeof i.iconPath=="string"?c.URI.file(i.iconPath):c.URI.isUri(i.iconPath)||E.ThemeIcon.isThemeIcon(i.iconPath)?i.iconPath:void 0}function v(i,p){if(!i.iconPath&&!p.iconPath)return 0;if(i.iconPath){if(!p.iconPath)return 1}else return-1;const C=typeof i.iconPath=="string"?i.iconPath:c.URI.isUri(i.iconPath)?i.iconPath.fsPath:i.iconPath.id,R=typeof p.iconPath=="string"?p.iconPath:c.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,k.comparePaths)(C,R)}function m(i,p){let C=0;if(i.strikeThrough!==p.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==p.faded)return i.faded?1:-1;if(i.tooltip!==p.tooltip)return(i.tooltip||"").localeCompare(p.tooltip||"");if(C=v(i,p),C!==0)return C;if(i.light&&p.light)C=v(i.light,p.light);else{if(i.light)return 1;if(p.light)return-1}if(C!==0)return C;if(i.dark&&p.dark)C=v(i.dark,p.dark);else{if(i.dark)return 1;if(p.dark)return-1}return C}function r(i,p){if(i.command!==p.command)return i.command<p.command?-1:1;if(i.title!==p.title)return i.title<p.title?-1:1;if(i.tooltip!==p.tooltip){if(i.tooltip!==void 0&&p.tooltip!==void 0)return i.tooltip<p.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(i.arguments===p.arguments)return 0;if(i.arguments)if(p.arguments){if(i.arguments.length!==p.arguments.length)return i.arguments.length-p.arguments.length}else return 1;else return-1;for(let C=0;C<i.arguments.length;C++){const R=i.arguments[C],M=p.arguments[C];if(R!==M)return R<M?-1:1}return 0}function b(i,p){let C=(0,k.comparePaths)(i.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(C!==0)return C;if(i.command&&p.command)C=r(i.command,p.command);else{if(i.command)return 1;if(p.command)return-1}if(C!==0)return C;if(i.decorations&&p.decorations)C=m(i.decorations,p.decorations);else{if(i.decorations)return 1;if(p.decorations)return-1}return C}function s(i,p){for(let C=0;C<i.length;C++)if(i[C]!==p[C])return!1;return!0}function u(i,p){return i.command===p.command&&i.title===p.title&&i.tooltip===p.tooltip&&(i.arguments&&p.arguments?s(i.arguments,p.arguments):i.arguments===p.arguments)}function o(i,p){return(0,S.equals)(i,p,u)}class l{get value(){return this._value}set value(p){p=p??"",Ue(this,h,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Ue(this,h,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Ue(this,h,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Ue(this,h,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Ue(this,h,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}constructor(p,C,R){this._extension=p,this._sourceControlHandle=R,h.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,nt(this,h,C,"f")}showValidationMessage(p,C){(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),Ue(this,h,"f").$showValidationMessage(this._sourceControlHandle,p,C)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=l,h=new WeakMap;class a{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}constructor(p,C,R,M,$){this._proxy=p,this._commands=C,this._sourceControlHandle=R,this._id=M,this._label=$,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,C){const R=this._resourceStatesCommandsMap.get(p);return R?(0,y.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(b),R=(0,S.sortedDiff)(this._resourceSnapshot,p,b).map(x=>{const L=x.toInsert.map(B=>{const O=this._resourceHandlePool++;this._resourceStatesMap.set(O,B);const z=B.resourceUri;let U;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ve=new P.DisposableStore;U=this._commands.converter.toInternal(B.command,ve),this._resourceStatesDisposablesMap.set(O,ve)}else this._resourceStatesCommandsMap.set(O,B.command);const F=f(B.decorations),V=B.decorations&&f(B.decorations.light)||F,H=B.decorations&&f(B.decorations.dark)||F,Q=[V,H],K=B.decorations&&B.decorations.tooltip||"",de=B.decorations&&!!B.decorations.strikeThrough,ee=B.decorations&&!!B.decorations.faded,fe=B.contextValue||"";return{rawResource:[O,z,Q,K,de,ee,fe,U],handle:O}});return{start:x.start,deleteCount:x.deleteCount,toInsert:L}}),M=R.map(({start:x,deleteCount:L,toInsert:B})=>[x,L,B.map(O=>O.rawResource)]),$=R.reverse();for(const{start:x,deleteCount:L,toInsert:B}of $){const O=B.map(U=>U.handle),z=this._handlesSnapshot.splice(x,L,...O);for(const U of z)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=p,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class d{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Ue(this,g,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Ue(this,g,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Ue(this,g,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=p;const C=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Ue(this,g,"f").$updateSourceControl(this.handle,{acceptInputCommand:C})}get actionButton(){return(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=p;const C=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(R=>R.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Ue(this,g,"f").$updateSourceControl(this.handle,{actionButton:C??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&o(this._statusBarCommands,p))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=p;const C=(p||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Ue(this,g,"f").$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}constructor(p,C,R,M,$,x){this._extension=p,this._commands=R,this._id=M,this._label=$,this._rootUri=x,g.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=d._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,nt(this,g,C,"f"),this._inputBox=new l(p,Ue(this,g,"f"),this.handle),Ue(this,g,"f").$registerSourceControl(this.handle,M,$,x)}createResourceGroup(p,C){const R=new a(Ue(this,g,"f"),this._commands,this.handle,p,C),M=t.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,M),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const p=[],C=[];for(const[R,M]of this.createdResourceGroups){M.dispose();const $=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),$.dispose(),this._groups.delete(R.handle),Ue(this,g,"f").$unregisterGroup(this.handle,R.handle)}),p.push([R.handle,R.id,R.label,R.features]);const x=R._takeResourceStateSnapshot();x.length>0&&C.push([R.handle,x]),this._groups.set(R.handle,R)}Ue(this,g,"f").$registerGroups(this.handle,p,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(C=>{const R=C._takeResourceStateSnapshot();R.length!==0&&p.push([C.handle,R])}),p.length>0&&Ue(this,g,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Ue(this,g,"f").$unregisterSourceControl(this.handle)}}g=new WeakMap,d._handlePool=0,Ve([(0,D.debounce)(100)],d.prototype,"eventuallyAddResourceGroups",null),Ve([(0,D.debounce)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let n=class ei{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(p,C,R){this._commands=C,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=p.getProxy(T.MainContext.MainThreadSCM),this._telemetry=p.getProxy(T.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const $=this._sourceControls.get(M.sourceControlHandle);if(!$)return M;const x=$.getResourceGroup(M.groupHandle);return x?x.getResourceState(M.handle):M}else if(M&&M.$mid===4){const $=this._sourceControls.get(M.sourceControlHandle);return $?$.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const $=this._sourceControls.get(M.handle);return $||M}return M}})}createSourceControl(p,C,R,M){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,C,R,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const $=ei._handlePool++,x=new d(p,this._proxy,this._commands,C,R,M);this._sourceControls.set($,x);const L=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(p.identifier))||[];return L.push(x),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(p.identifier),L),x}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const C=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(p.identifier)),R=C&&C[C.length-1];return R&&R.inputBox}$provideOriginalResource(p,C,R){const M=c.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,M.toString());const $=this._sourceControls.get(p);return!$||!$.quickDiffProvider||!$.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>$.quickDiffProvider.provideOriginalResource(M,R)).then(x=>x||null)}$onInputBoxValueChange(p,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const R=this._sourceControls.get(p);return R&&R.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(p,C,R,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,C,R);const $=this._sourceControls.get(p);if(!$)return Promise.resolve(void 0);const x=$.getResourceGroup(C);return x?x.$executeResourceCommand(R,M):Promise.resolve(void 0)}$validateInput(p,C,R){this.logService.trace("ExtHostSCM#$validateInput",p);const M=this._sourceControls.get(p);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>M.inputBox.validateInput(C,R)).then($=>{if(!$)return Promise.resolve(void 0);const x=_.MarkdownString.fromStrict($.message);return x?Promise.resolve([x,$.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};n._handlePool=0,n=Ve([He(2,A.ILogService)],n),e.ExtHostSCM=n}),define(De[95],Ie([1,0,5,4,3]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(T){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,S){return this._proxy.$getPassword(T,S)}store(T,S,k){return this._proxy.$setPassword(T,S,k)}delete(T,S){return this._proxy.$deletePassword(T,S)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c},Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[262],Ie([1,0,7,5,174,6,15,11]),function(Z,e,c,t,D,P,y,T){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(w,h,g,f,v=c.StatusBarAlignment.Left,m){S.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,nt(this,S,w,"f"),nt(this,k,h,"f"),this._entryId=A.ID_GEN++,this._extension=g,this._id=f,this._alignment=v,this._priority=this.validatePriority(m)}validatePriority(w){if(!!(0,T.isNumber)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set name(w){this._name=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!A.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){this._command?.fromApi!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:Ue(this,k,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:Ue(this,k,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let w;this._extension?this._id?w=`${this._extension.identifier.value}.${this._id}`:w=this._extension.identifier.value:w=this._id;let h;this._name?h=this._name:h=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=y.MarkdownString.fromStrict(this._tooltip);Ue(this,S,"f").$setEntry(this._entryId,w,h,this._text,f,this._command?.internal,g,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,S=new WeakMap,k=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(w){this._messages=[],this._item=w.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const h={message:w};return this._messages.unshift(h),this._update(),new c.Disposable(()=>{const g=this._messages.indexOf(h);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class E{constructor(w,h){this._proxy=w.getProxy(t.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new I(this)}createStatusBarEntry(w,h,g,f){return new A(this._proxy,this._commands,w,h,g,f)}setStatusBarMessage(w,h){const g=this._statusMessage.setMessage(w);let f;return typeof h=="number"?f=setTimeout(()=>g.dispose(),h):typeof h<"u"&&h.then(()=>g.dispose(),()=>g.dispose()),new c.Disposable(()=>{g.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=E}),define(De[96],Ie([1,0,5,4,3]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(T){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this._proxy.$registerExtensionStorageKeysToSync(T,S)}initializeExtensionStorage(T,S,k){return this._proxy.$initializeExtensionStorage(T,S).then(A=>A||k)}setValue(T,S,k){return this._proxy.$setValue(T,S,k)}$acceptValue(T,S,k){this._onDidChangeStorage.fire({shared:T,key:S,value:k})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(De[70],Ie([1,0,3,25,13,69,2]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let T=class{constructor(k,A,I){this._logService=A,this._extHostFileSystem=I,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(E=>this._value=E)}async _getWorkspaceStorageURI(k){return y.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,A=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ve([He(0,t.IExtHostInitDataService),He(1,D.ILogService),He(2,P.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(De[40],Ie([1,0,4,5,3,2,16,6,7,175,10,221,21,31,205,87,11,18,15]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class m{constructor(n,i,p,C){this._proxy=n,this._id=i,this._creationOptions=p,this._name=C,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(M=>this._pidPromiseComplete=M);const R=this;this.value={get name(){return R._name||""},get processId(){return R._pidPromise},get creationOptions(){return R._creationOptions},get exitStatus(){return R._exitStatus},get state(){return R._state},sendText(M,$=!0){R._checkDisposed(),R._proxy.$sendText(R._id,M,$)},show(M){R._checkDisposed(),R._proxy.$show(R._id,M)},hide(){R._checkDisposed(),R._proxy.$hide(R._id)},dispose(){R._disposed||(R._disposed=!0,R._proxy.$dispose(R._id))},get dimensions(){if(!(R._cols===void 0||R._rows===void 0))return{columns:R._cols,rows:R._rows}}}}async create(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,g.withNullAsUndefined)(n.shellPath),shellArgs:(0,g.withNullAsUndefined)(n.shellArgs),cwd:(0,g.withNullAsUndefined)(n.cwd),env:(0,g.withNullAsUndefined)(n.env),icon:(0,g.withNullAsUndefined)(l(n.iconPath)),color:h.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,g.withNullAsUndefined)(n.message),strictEnv:(0,g.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(i?.useShellEnvironment),location:i?.location||this._serializeParentTerminal(n.location,i?.resolvedExtHostIdentifier),isTransient:(0,g.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,i,p,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:h.ThemeColor.isThemeColor(C)?C.id:void 0,location:this._serializeParentTerminal(n,i),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,i){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&i?{parentTerminal:i}:"viewColumn"in n?{viewColumn:v.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,i){this._exitStatus=Object.freeze({code:n,reason:i})}setDimensions(n,i){return n===this._cols&&i===this._rows||n===0||i===0?!1:(this._cols=n,this._rows=i,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=m;class r{get onProcessReady(){return this._onProcessReady.event}constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new c.Emitter,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,i){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${i}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,i){this._pty.setDimensions?.({columns:n,rows:i})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose?.((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions?.(i=>{i&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:i.columns,rows:i.rows}})}),this._pty.onDidChangeName?.(i=>{this._onDidChangeProperty.fire({type:"title",value:i})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=r;let b=1,s=class extends T.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(n,i){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new c.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=i.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new w.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[p,C]of this._terminalProcesses)C.shutdown(!0)}})}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,i){const p=new m(this._proxy,(0,_.generateUuid)(),n,n.name),C=new r(n.pty);return p.createExtensionTerminal(n.location,this._serializeParentTerminal(n,i).resolvedExtHostIdentifier,l(n.iconPath),a(n.color)).then(R=>{const M=this._setupExtHostProcessListeners(R,C);this._terminalProcessDisposables[R]=M}),this._terminals.push(p),p.value}_serializeParentTerminal(n,i){if(i=i||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const p=n.location.parentTerminal;if(p){const C=this._terminals.find(R=>R.value===p);C&&(i.resolvedExtHostIdentifier=C._id)}}else n.location&&typeof n.location!="object"?i.location=n.location:i.location&&typeof i.location=="object"&&"splitActiveTerminal"in i.location&&(i.location={splitActiveTerminal:!0});return i}attachPtyToTerminal(n,i){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const C=new r(i),R=this._setupExtHostProcessListeners(n,C);this._terminalProcessDisposables[n]=R}async $acceptActiveTerminalChanged(n){const i=this._activeTerminal;if(n===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(n);p&&(this._activeTerminal=p,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,i){const p=this._getTerminalById(n);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:i})}async $acceptTerminalDimensions(n,i,p){const C=this._getTerminalById(n);C&&C.setDimensions(i,p)&&this._onDidChangeTerminalDimensions.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptTerminalMaximumDimensions(n,i,p){this._terminalProcesses.get(n)?.resize(i,p)}async $acceptTerminalTitleChange(n,i){const p=this._getTerminalById(n);p&&(p.name=i)}async $acceptTerminalClosed(n,i,p){const C=this._getTerminalObjectIndexById(this._terminals,n);if(C!==null){const R=this._terminals.splice(C,1)[0];R.setExitStatus(i,p),this._onDidCloseTerminal.fire(R.value)}}$acceptTerminalOpened(n,i,p,C){if(i){const $=this._getTerminalObjectIndexById(this._terminals,i);if($!==null){this._terminals[$]._id=n,this._onDidOpenTerminal.fire(this.terminals[$]),this._terminals[$].isOpen=!0;return}}const R={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:P.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},M=new m(this._proxy,n,R,p);this._terminals.push(M),this._onDidOpenTerminal.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(n,i){this._getTerminalById(n)?._setProcessId(i)}async $startExtensionTerminal(n,i){const p=this._getTerminalById(n);if(!p)return{message:(0,k.localize)(0,null,n)};p.isOpen||await new Promise(R=>{const M=this.onDidOpenTerminal(async $=>{$===p.value&&(M.dispose(),R())})});const C=this._terminalProcesses.get(n);C?C.startSendingEvents(i):this._extensionTerminalAwaitingStart[n]={initialDimensions:i}}_setupExtHostProcessListeners(n,i){const p=new T.DisposableStore;p.add(i.onProcessReady(R=>this._proxy.$sendProcessReady(n,R.pid,R.cwd))),p.add(i.onDidChangeProperty(R=>this._proxy.$sendProcessProperty(n,R))),this._bufferer.startBuffering(n,i.onProcessData),p.add(i.onProcessExit(R=>this._onProcessExit(n,R))),this._terminalProcesses.set(n,i);const C=this._extensionTerminalAwaitingStart[n];return C&&i instanceof r&&(i.startSendingEvents(C.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),p}$acceptProcessAckDataEvent(n,i){this._terminalProcesses.get(n)?.acknowledgeDataEvent(i)}$acceptProcessInput(n,i){this._terminalProcesses.get(n)?.input(i)}$acceptTerminalInteraction(n){const i=this._getTerminalById(n);i?.setInteractedWith()&&this._onDidChangeTerminalState.fire(i.value)}$acceptProcessResize(n,i,p){try{this._terminalProcesses.get(n)?.resize(i,p)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(n,i){this._terminalProcesses.get(n)?.shutdown(i)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(i=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:i}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(i=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:i}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,i,p){if(this._profileProviders.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this._profileProviders.set(i,p),this._proxy.$registerProfileProvider(i,n.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(i),this._proxy.$unregisterProfileProvider(i)})}async $createContributedProfileTerminal(n,i){const p=new E.CancellationTokenSource().token;let C=await this._profileProviders.get(n)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,i);return}this.createTerminalFromOptions(C.options,i)}}async $provideLinks(n,i){const p=this._getTerminalById(n);if(!p)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const R=new E.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,R);const M=[],$={terminal:p.value,line:i},x=[];for(const O of this._linkProviders)x.push(f.Promises.withAsyncBody(async z=>{R.token.onCancellationRequested(()=>z({provider:O,links:[]}));const U=await O.provideTerminalLinks($,R.token)||[];R.token.isCancellationRequested||z({provider:O,links:U})}));const L=await Promise.all(x);if(R.token.isCancellationRequested)return[];const B=new Map;for(const O of L)O&&O.links.length>0&&M.push(...O.links.map(z=>{const U={id:b++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return B.set(U.id,{provider:O.provider,link:z}),U}));return this._terminalLinkCache.set(n,B),M}$activateLink(n,i){const p=this._terminalLinkCache.get(n)?.get(i);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(n,i){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const p=this._terminalProcessDisposables[n];p&&(p.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,i)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,i){const p=this._getTerminalObjectIndexById(n,i);return p!==null?n[p]:null}_getTerminalObjectIndexById(n,i){let p=null;return n.some((C,R)=>C._id===i?(p=R,!0):!1),p}getEnvironmentVariableCollection(n){let i=this._environmentVariableCollections.get(n.identifier.value);return i||(i=new u,this._setEnvironmentVariableCollection(n.identifier.value,i)),i}_syncEnvironmentVariableCollection(n,i){const p=(0,I.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(n,i.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(n){n.forEach(i=>{const p=i[0],C=new u(i[1]);this._setEnvironmentVariableCollection(p,C)})}$acceptDefaultProfile(n,i){const p=this._defaultProfile;this._defaultProfile=n,this._defaultAutomationProfile=i,p?.path!==n.path&&this._onDidChangeShell.fire(n.path)}_setEnvironmentVariableCollection(n,i){this._environmentVariableCollections.set(n,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,i)})}};s=Ve([He(1,y.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class u{get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Replace})}append(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,i){const p=this.map.get(n);(!p||p.value!==i.value||p.type!==i.type)&&(this.map.set(n,i),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,i){this.map.forEach((p,C)=>n.call(i,C,p,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let o=class extends s{constructor(n){super(!1,n)}createTerminal(n,i,p){throw new A.NotSupportedError}createTerminalFromOptions(n,i){throw new A.NotSupportedError}};o=Ve([He(0,y.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o;function l(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function a(d){return h.ThemeColor.isThemeColor(d)?d:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)},nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c};define(De[263],Ie([1,0,17,23,21,4,61,81,6,24,11,31,5,16,135,15,7,56,91,67]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m){"use strict";var r,b;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor($,x,L){this.editors=L,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=$.getProxy(E.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new o(this.proxy),x.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==14)return B;const O=B,z=O.tests[O.tests.length-1].item.extId;return this.controllers.get(f.TestId.root(z))?.collection.tree.get(z)?.actual??(0,w.toItemFromContext)(B)}})}createTestController($,x,L){if(this.controllers.has($))throw new Error(`Attempt to insert a duplicate controller with ID "${$}"`);const B=new S.DisposableStore,O=B.add(new w.ExtHostTestItemCollection($,x,this.editors));O.root.label=x;const z=new Map,U=this.proxy,F={items:O.root.children,get label(){return x},set label(H){x=H,O.root.label=H,U.$updateController($,{label:x})},get refreshHandler(){return L},set refreshHandler(H){L=H,U.$updateController($,{canRefresh:!!H})},get id(){return $},createRunProfile:(H,Q,K,de,ee)=>{let fe=(0,T.hash)(H);for(;z.has(fe);)fe++;return new C(this.proxy,z,$,fe,H,Q,K,de,ee)},createTestItem(H,Q,K){return new w.TestItemImpl($,H,Q,K)},createTestRun:(H,Q,K=!0)=>this.runTracker.createTestRun($,O,H,Q,K),set resolveHandler(H){O.resolveHandler=H},get resolveHandler(){return O.resolveHandler},dispose:()=>{B.dispose()}};U.$registerTestController($,x,!!L),B.add((0,S.toDisposable)(()=>U.$unregisterTestController($)));const V={controller:F,collection:O,profiles:z};return this.controllers.set($,V),B.add((0,S.toDisposable)(()=>this.controllers.delete($))),B.add(O.onDidGenerateDiff(H=>U.$publishDiff($,H.map(m.TestsDiffOp.serialize)))),F}createTestObserver(){return this.observer.checkout()}async runTests($,x=D.CancellationToken.None){const L=l($);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(L.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:$.include?.map(O=>f.TestId.fromExtHostTestItem(O,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:R[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:$.exclude?.map(O=>O.id)},x)}$syncTests(){for(const{collection:$}of this.controllers.values())$.flushDiff();return Promise.resolve()}$provideFileCoverage($,x,L){return(0,c.mapFind)(this.runTracker.trackers,O=>O.id===$?O.getCoverage(x):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage($,x,L,B){return(0,c.mapFind)(this.runTracker.trackers,z=>z.id===$?z.getCoverage(x):void 0)?.resolveFileCoverage(L,B)??Promise.resolve([])}$configureRunProfile($,x){this.controllers.get($)?.profiles.get(x)?.configureHandler?.()}async $refreshTests($,x){await this.controllers.get($)?.controller.refreshHandler?.(x)}$publishTestResults($){this.results=Object.freeze($.map(x=>(0,k.deepFreeze)(h.TestResults.to(x))).concat(this.results).sort((x,L)=>L.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest($,x){const L=this.controllers.get(f.TestId.fromString($).controllerId)?.collection;L&&(await L.expand($,x<0?1/0:x),L.flushDiff())}$acceptDiff($){this.observer.applyDiff($.map(m.TestsDiffOp.deserialize))}async $runControllerTests($,x){return Promise.all($.map(L=>this.runControllerTestRequest(L,x)))}async runControllerTestRequest($,x){const L=this.controllers.get($.controllerId);if(!L)return{};const{collection:B,profiles:O}=L,z=O.get($.profileId);if(!z)return{};const U=$.testIds.map(Q=>B.tree.get(Q)).filter(A.isDefined),F=$.excludeExtIds.map(Q=>L.collection.tree.get(Q)).filter(A.isDefined).filter(Q=>U.some(K=>K.fullId.compare(Q.fullId)===2));if(!U.length)return{};const V=new g.TestRunRequest(U.some(Q=>Q.actual instanceof w.TestItemRootImpl)?void 0:U.map(Q=>Q.actual),F.map(Q=>Q.actual),z),H=this.runTracker.prepareForMainThreadTestRun(V,a.fromInternal($,L.collection),x);try{return await z.runHandler(V,x),{}}catch(Q){return{error:String(Q)}}finally{H.isRunning&&!x.isCancellationRequested&&await P.Event.toPromise(H.onEnd),H.dispose()}}$cancelExtensionTestRun($){$===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById($)}};s=Ve([He(0,_.IExtHostRpcService)],s),e.ExtHostTesting=s;class u extends S.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor($,x,L){super(),this.dto=$,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:B}of this.tasks.values())B.end()}))}getCoverage($){return this.tasks.get($)?.coverage}createRun($){const x=this.dto.id,L=this.dto.controllerId,B=(0,I.generateUuid)(),O=new d(this.proxy,x,B),z=H=>(Q,...K)=>{if(F){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),H(Q,...K))},U=(H,Q)=>{const K=Q instanceof Array?Q.map(h.TestMessage.from):[h.TestMessage.from(Q)];if(H.uri&&H.range){const de={range:h.Range.from(H.range),uri:H.uri};for(const ee of K)ee.location=ee.location||de}this.proxy.$appendTestMessagesInRun(x,B,f.TestId.fromExtHostTestItem(H,L).toString(),K)};let F=!1;const V={isPersisted:this.dto.isPersisted,token:this.cts.token,name:$,get coverageProvider(){return O.coverageProvider},set coverageProvider(H){O.coverageProvider=H},enqueued:z(H=>{this.proxy.$updateTestStateInRun(x,B,f.TestId.fromExtHostTestItem(H,L).toString(),1)}),skipped:z(H=>{this.proxy.$updateTestStateInRun(x,B,f.TestId.fromExtHostTestItem(H,L).toString(),5)}),started:z(H=>{this.proxy.$updateTestStateInRun(x,B,f.TestId.fromExtHostTestItem(H,L).toString(),2)}),errored:z((H,Q,K)=>{U(H,Q),this.proxy.$updateTestStateInRun(x,B,f.TestId.fromExtHostTestItem(H,L).toString(),6,K)}),failed:z((H,Q,K)=>{U(H,Q),this.proxy.$updateTestStateInRun(x,B,f.TestId.fromExtHostTestItem(H,L).toString(),4,K)}),passed:z((H,Q)=>{this.proxy.$updateTestStateInRun(x,B,f.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString(),3,Q)}),appendOutput:(H,Q,K)=>{F||(K&&(this.dto.isIncluded(K)?this.ensureTestIsKnown(K):K=void 0),this.proxy.$appendOutputToRun(x,B,t.VSBuffer.fromString(H),Q&&h.location.from(Q),K&&f.TestId.fromExtHostTestItem(K,L).toString()))},end:()=>{F||(F=!0,this.proxy.$finishedTestRunTask(x,B),this.tasks.delete(B),this.isRunning||this.dispose())}};return this.tasks.set(B,{run:V,coverage:O}),this.proxy.$startedTestRunTask(x,{id:B,name:$,running:!0}),V}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown($){if(!($ instanceof w.TestItemImpl))throw new v.InvalidTestItemError($.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem($,this.dto.controllerId).toString()))return;const x=[],L=this.dto.colllection.root;for(;;){const B=h.TestItem.from($);if(x.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),$===L))break;$=$.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class o{get trackers(){return this.tracked.values()}constructor($){this.proxy=$,this.tracked=new Map}prepareForMainThreadTestRun($,x,L){return this.getTracker($,x,L)}cancelRunById($){for(const x of this.tracked.values())if(x.id===$){x.dispose();return}}cancelAllRuns(){for(const $ of this.tracked.values())$.dispose()}createTestRun($,x,L,B,O){const z=this.tracked.get(L);if(z)return z.createRun(B);const U=a.fromPublic($,x,L,O),F=l(L);this.proxy.$startedExtensionTestRun({controllerId:$,profile:F&&{group:R[F.kind],id:F.profileId},exclude:L.exclude?.map(H=>f.TestId.fromExtHostTestItem(H,x.root.id).toString())??[],id:U.id,include:L.include?.map(H=>f.TestId.fromExtHostTestItem(H,x.root.id).toString())??[x.root.id],persist:O});const V=this.getTracker(L,U);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun(U.id)),V.createRun(B)}getTracker($,x,L){const B=new u(x,this.proxy,L);return this.tracked.set($,B),B.onEnd(()=>this.tracked.delete($)),B}}e.TestRunCoordinator=o;const l=M=>{if(!!M.profile){if(!(M.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class a{static fromPublic($,x,L,B){return new a($,(0,I.generateUuid)(),L.include?.map(O=>f.TestId.fromExtHostTestItem(O,$).toString())??[$],L.exclude?.map(O=>f.TestId.fromExtHostTestItem(O,$).toString())??[],B,x)}static fromInternal($,x){return new a($.controllerId,$.runId,$.testIds,$.excludeExtIds,!0,x)}constructor($,x,L,B,O,z){this.controllerId=$,this.id=x,this.isPersisted=O,this.colllection=z,this.includePrefix=L.map(U=>U+"\0"),this.excludePrefix=B.map(U=>U+"\0")}isIncluded($){const x=f.TestId.fromExtHostTestItem($,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(x===L||x.startsWith(L))return!1;for(const L of this.includePrefix)if(x===L||x.startsWith(L))return!0;return!1}}e.TestRunDto=a;class d{set coverageProvider($){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!$||(this._coverageProvider=$,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor($,x,L){this.proxy=$,this.runId=x,this.taskId=L}async provideFileCoverage($){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage($))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage($,x){const L=await this.fileCoverage;let B=L?.[$];return!this._coverageProvider||!L||!B?[]:(B.detailedCoverage||(B=L[$]=await this._coverageProvider.resolveFileCoverage?.(B,x)??B),B.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class n extends m.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor($){super(),this.emitter=$,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add($){this.added.add($)}update($){Object.assign($.revived,h.TestItem.toPlain($.item)),this.added.has($)||this.updated.add($)}remove($){if(this.added.has($)){this.added.delete($);return}this.updated.delete($);const x=f.TestId.parentId($.item.extId);if(x&&this.alreadyRemoved.has(x.toString())){this.alreadyRemoved.add($.item.extId);return}this.removed.add($)}getChangeEvent(){const{added:$,updated:x,removed:L}=this;return{get added(){return[...$].map(B=>B.revived)},get updated(){return[...x].map(B=>B.revived)},get removed(){return[...L].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class i extends m.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById($){return this.items.get($)}getMirroredTestDataByReference($){return this.items.get($.id)}createItem($,x){return{...$,revived:h.TestItem.toPlain($.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new n(this.changeEmitter)}}e.MirroredTestCollection=i;class p{constructor($){this.proxy=$}checkout(){this.current||(this.current=this.createObserverData());const $=this.current;return $.observers++,{onDidChangeTest:$.tests.onDidChangeTests,get tests(){return[...$.tests.rootTests].map(x=>x.revived)},dispose:(0,y.once)(()=>{--$.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference($){return this.current?.tests.getMirroredTestDataByReference($)}applyDiff($){this.current?.tests.apply($)}createObserverData(){const $=new i;return this.proxy.$subscribeToDiffs(),{observers:0,tests:$}}}class C{get label(){return this._label}set label($){$!==this._label&&(this._label=$,Ue(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:$}))}get isDefault(){return this._isDefault}set isDefault($){$!==this._isDefault&&(this._isDefault=$,Ue(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:$}))}get tag(){return this._tag}set tag($){$?.id!==this._tag?.id&&(this._tag=$,Ue(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:$?h.TestTag.namespace(this.controllerId,$.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler($){$!==this._configureHandler&&(this._configureHandler=$,Ue(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!$}))}constructor($,x,L,B,O,z,U,F=!1,V=void 0){this.controllerId=L,this.profileId=B,this._label=O,this.kind=z,this.runHandler=U,this._isDefault=F,this._tag=V,r.set(this,void 0),b.set(this,void 0),nt(this,r,$,"f"),nt(this,b,x,"f"),x.set(B,this);const H=R[z];if(typeof H!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);Ue(this,r,"f").$publishTestRunProfile({profileId:B,controllerId:L,tag:V?h.TestTag.namespace(this.controllerId,V.id):null,label:O,group:H,isDefault:F,hasConfigurationHandler:!1})}dispose(){Ue(this,b,"f")?.delete(this.profileId)&&(nt(this,b,void 0,"f"),Ue(this,r,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=C,r=new WeakMap,b=new WeakMap;const R={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(De[264],Ie([1,0,17,4,5,136,15,7]),function(Z,e,c,t,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(A,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(E=>this._onDidChangeVisibleTextEditors.fire(E)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(E=>this._onDidChangeActiveTextEditor.fire(E))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const I=this._extHostDocumentsAndEditors.allEditors();return A?I:I.map(E=>E.value)}async showTextDocument(A,I,E){let _;typeof I=="number"?_={position:y.ViewColumn.from(I),preserveFocus:E}:typeof I=="object"?_={position:y.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?y.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:_={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(A.uri,_),h=w&&this._extHostDocumentsAndEditors.getEditor(w);if(h)return h.value;throw w?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,I){return new P.TextEditorDecorationType(this._proxy,A,I).value}$acceptEditorPropertiesChanged(A,I){const E=this._extHostDocumentsAndEditors.getEditor(A);if(!E)throw new Error("unknown text editor");if(I.options&&E._acceptOptions(I.options),I.selections){const _=I.selections.selections.map(y.Selection.to);E._acceptSelections(_)}if(I.visibleRanges){const _=c.coalesce(I.visibleRanges.map(y.Range.to));E._acceptVisibleRanges(_)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:E.value,options:{...I.options,lineNumbers:y.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const _=T.TextEditorSelectionChangeKind.fromValue(I.selections.source),w=I.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:E.value,selections:w,kind:_})}if(I.visibleRanges){const _=c.coalesce(I.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:E.value,visibleRanges:_})}}$acceptEditorPositionData(A){for(const I in A){const E=this._extHostDocumentsAndEditors.getEditor(I);if(!E)throw new Error("Unknown text editor");const _=y.ViewColumn.to(A[I]);E.value.viewColumn!==_&&(E._acceptViewColumn(_),this._onDidChangeTextEditorViewColumn.fire({textEditor:E.value,viewColumn:_}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=S}),define(De[265],Ie([1,0,2,3,5,6,7,15,11]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class k{constructor(E,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(D.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===11){const h=w.uri===void 0?void 0:c.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(A(h))?.get(w.handle)}return w}})}async $getTimeline(E,_,w,h){return this._providers.get(E)?.provideTimeline(c.URI.revive(_),w,h)}registerTimelineProvider(E,_,w,h){const g=new P.DisposableStore,f=this.convertTimelineItem(_.id,h,g).bind(this);let v;_.onDidChange&&(v=_.onDidChange(r=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...r,id:_.id}),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:E,onDidChange:void 0,async provideTimeline(r,b,s){b?.resetCache&&(g.clear(),m.get(_.id)?.clear());const u=await _.provideTimeline(r,b,s);if(u==null)return;const o=f(r,b);return{...u,source:_.id,items:u.items.map(o)}},dispose(){for(const r of m.values())r.get(_.id)?.clear();v?.dispose(),g.dispose()}})}convertTimelineItem(E,_,w){return(h,g)=>{let f;if(g?.cacheResults){let v=this._itemsBySourceAndUriMap.get(E);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(E,v));const m=A(h);f=v.get(m),f===void 0&&(f=new Map,v.set(m,f))}return v=>{const{iconPath:m,...r}=v,b=`${E}|${v.id??v.timestamp}`;f?.set(b,v);let s,u,o;v.iconPath&&(m instanceof y.ThemeIcon?o={id:m.id,color:m.color}:c.URI.isUri(m)?(s=m,u=m):{light:s,dark:u}=m);let l;return y.MarkdownString.isMarkdownString(r.tooltip)?l=T.MarkdownString.from(r.tooltip):(0,S.isString)(r.tooltip)?l=r.tooltip:y.MarkdownString.isMarkdownString(r.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=T.MarkdownString.from(r.detail)):(0,S.isString)(r.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=r.detail),{...r,id:r.id??void 0,handle:b,source:E,command:v.command?_.toInternal(v.command,w):void 0,icon:s,iconDark:u,themeIcon:o,tooltip:l,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(E){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,E),(0,P.toDisposable)(()=>{for(const w of this._itemsBySourceAndUriMap.values())w.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=k;function A(I){return I?.toString()}}),define(De[266],Ie([1,0,6,14,2,5]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this._openers=new Map,this._proxy=S.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,A,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const E=I.schemes.find(_=>!y.supportedSchemes.has(_));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,A),this._proxy.$registerUriOpener(k,I.schemes,S,I.label),(0,c.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(S,k,A){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const E=D.URI.revive(k);return I.canOpenExternalUri(E,A)}async $openUri(S,k,A){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(D.URI.revive(k.resolvedUri),{sourceUri:D.URI.revive(k.sourceUri)},A)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(De[267],Ie([1,0,5,2,6,10,26]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(k,A){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=T.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(I,A),this._proxy.$registerUriHandler(I,k),(0,D.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,A){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(t.URI.revive(A))}catch(E){(0,P.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(k){return t.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=T,T.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c},Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[71],Ie([1,0,4,14,24,2,189,212,89,5]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";var A,I,E,_,w,h,g,f,v,m,r,b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(R,M,$,x,L,B,O){A.set(this,void 0),I.set(this,void 0),E.set(this,void 0),_.set(this,void 0),w.set(this,void 0),h.set(this,void 0),g.set(this,""),f.set(this,void 0),v.set(this,!1),m.set(this,!1),r.set(this,void 0),b.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new c.Emitter),this._onDidDispose=Ue(this,s,"f").event,nt(this,A,R,"f"),nt(this,I,M,"f"),nt(this,f,$,"f"),nt(this,_,x,"f"),nt(this,w,L,"f"),nt(this,h,B,"f"),nt(this,r,o(B),"f"),nt(this,b,l(B),"f"),nt(this,E,O,"f")}dispose(){nt(this,v,!0,"f"),Ue(this,s,"f").fire(),Ue(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(R){return nt(this,m,!0,"f"),(0,S.asWebviewUri)(R,Ue(this,_,"f"))}get cspSource(){const R=Ue(this,h,"f").extensionLocation;if(R.scheme===t.Schemas.https||R.scheme===t.Schemas.http){let M=R.toString();return M.endsWith("/")||(M+="/"),M+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,g,"f")}set html(R){this.assertNotDisposed(),Ue(this,g,"f")!==R&&(nt(this,g,R,"f"),Ue(this,b,"f")&&!Ue(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(R)&&(nt(this,m,!0,"f"),Ue(this,E,"f").report("Webview vscode-resource: uris",Ue(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,I,"f").$setHtml(Ue(this,A,"f"),this.rewriteOldResourceUrlsIfNeeded(R)))}get options(){return this.assertNotDisposed(),Ue(this,f,"f")}set options(R){this.assertNotDisposed(),D.equals(Ue(this,f,"f"),R)||Ue(this,I,"f").$setOptions(Ue(this,A,"f"),n(Ue(this,h,"f"),Ue(this,w,"f"),R)),nt(this,f,R,"f")}async postMessage(R){if(Ue(this,v,"f"))return!1;const M=(0,T.serializeWebviewMessage)(R,{serializeBuffersForPostMessage:Ue(this,r,"f")});return Ue(this,I,"f").$postMessage(Ue(this,A,"f"),M.message,...M.buffers)}assertNotDisposed(){if(Ue(this,v,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(R){if(!Ue(this,b,"f"))return R;const M=Ue(this,h,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,$=Ue(this,h,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Ue(this,h,"f").extensionLocation.authority:void 0;return R.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,L,B,O,z,U)=>{const F=P.URI.from({scheme:O||"file",path:decodeURIComponent(z)}),V=(0,S.asWebviewUri)(F,{isRemote:M,authority:$}).toString();return`${L}${V}${U}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,L,B,O,z,U)=>{const F=P.URI.from({scheme:O||"file",path:decodeURIComponent(z)}),V=(0,S.asWebviewUri)(F,{isRemote:M,authority:$}).toString();return`${L}${V}${U}`})}}e.ExtHostWebview=u,A=new WeakMap,I=new WeakMap,E=new WeakMap,_=new WeakMap,w=new WeakMap,h=new WeakMap,g=new WeakMap,f=new WeakMap,v=new WeakMap,m=new WeakMap,r=new WeakMap,b=new WeakMap,s=new WeakMap;function o(C){try{const R=(0,y.normalizeVersion)((0,y.parseVersion)(C.engines.vscode));return!!R&&R.majorBase>=1&&R.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;function l(C){try{const R=(0,y.normalizeVersion)((0,y.parseVersion)(C.engines.vscode));return R?R.majorBase<1||R.majorBase===1&&R.minorBase<60:!1}catch{return!1}}class a{constructor(R,M,$,x,L){this.remoteInfo=M,this.workspace=$,this._logService=x,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=R.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(R,M,$){const x=this.getWebview(R);if(x){const{message:L}=(0,T.deserializeWebviewMessage)(M,$.value);x._onMessageEmitter.fire(L)}}$onMissingCsp(R,M){this._logService.warn(`${M} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(R,M,$){const x=new u(R,this._webviewProxy,i(M),this.remoteInfo,this.workspace,$,this._deprecationService);return this._webviews.set(R,x),x._onDidDispose(()=>{this._webviews.delete(R)}),x}deleteWebview(R){this._webviews.delete(R)}getWebview(R){return this._webviews.get(R)}}e.ExtHostWebviews=a;function d(C){return{id:C.identifier,location:C.extensionLocation}}e.toExtensionData=d;function n(C,R,M){return{enableCommandUris:M.enableCommandUris,enableScripts:M.enableScripts,enableForms:M.enableForms,portMapping:M.portMapping,localResourceRoots:M.localResourceRoots||p(C,R)}}e.serializeWebviewOptions=n;function i(C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,enableForms:C.enableForms,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots?.map(R=>P.URI.from(R))}}e.reviveOptions=i;function p(C,R){return[...(R?.getWorkspaceFolders()||[]).map(M=>M.uri),C.extensionLocation]}}),define(De[268],Ie([1,0,21,81,6,14,22,2,15,71,88,5,7]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class _{constructor(u,o){this.document=u,this._storagePath=o,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,o){await this.getEdit(u).undo(),o||this.disposeBackup()}async redo(u,o){await this.getEdit(u).redo(),o||this.disposeBackup()}disposeEdits(u){for(const o of u)this._edits.delete(o)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=b(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const o=this._edits.get(u,0);if(!o)throw new Error("No edit found");return o}}class w{constructor(){this._documents=new Map}get(u,o){return this._documents.get(this.key(u,o))}add(u,o,l){const a=this.key(u,o.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${u} resource:${o.uri}`);const d=new _(o,l);return this._documents.set(a,d),d}delete(u,o){const l=this.key(u,o.uri);this._documents.delete(l)}key(u,o){return`${u}@@@${o}`}}var h;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(h||(h={}));class g{constructor(){this._providers=new Map}addTextProvider(u,o,l){return this.add(0,u,o,l)}addCustomProvider(u,o,l){return this.add(1,u,o,l)}get(u){return this._providers.get(u)}add(u,o,l,a){if(this._providers.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this._providers.set(o,{type:u,extension:l,provider:a}),new E.Disposable(()=>this._providers.delete(o))}}class f{constructor(u,o,l,a,d){this._extHostDocuments=o,this._extensionStoragePaths=l,this._extHostWebview=a,this._extHostWebviewPanels=d,this._editorProviders=new g,this._documents=new w,this._proxy=u.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,o,l,a){const d=new D.DisposableStore;return m(l)?(d.add(this._editorProviders.addTextProvider(o,u,l)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(u),o,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(u))):(d.add(this._editorProviders.addCustomProvider(o,u,l)),v(l)&&d.add(l.onDidChangeCustomDocument(n=>{const i=this.getCustomDocumentEntry(o,n.document.uri);if(r(n)){const p=i.addEdit(n);this._proxy.$onDidEdit(n.document.uri,o,p,n.label)}else this._proxy.$onContentChange(n.document.uri,o)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(u),o,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(u))),E.Disposable.from(d,new E.Disposable(()=>{this._proxy.$unregisterEditorProvider(o)}))}async $createCustomDocument(u,o,l,a,d){const n=this._editorProviders.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${o}'`);const i=T.URI.revive(u),p=await n.provider.openCustomDocument(i,{backupId:l,untitledDocumentData:a?.buffer},d);let C;return v(n.provider)&&this._extensionStoragePaths&&(C=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(o,p,C),{editable:v(n.provider)}}async $disposeCustomDocument(u,o){const l=this._editorProviders.get(o);if(!l)throw new Error(`No provider found for '${o}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${o}'`);const a=T.URI.revive(u),{document:d}=this.getCustomDocumentEntry(o,a);this._documents.delete(o,d),d.dispose()}async $resolveWebviewEditor(u,o,l,a,d,n){const i=this._editorProviders.get(l);if(!i)throw new Error(`No provider found for '${l}'`);const p=S.ViewColumn.to(d),C=this._extHostWebview.createNewWebview(o,a.contentOptions,i.extension),R=this._extHostWebviewPanels.createNewWebviewPanel(o,l,a.title,p,a.options,C,!0),M=T.URI.revive(u);switch(i.type){case 1:{const{document:$}=this.getCustomDocumentEntry(l,M);return i.provider.resolveCustomEditor($,R,n)}case 0:{const $=this._extHostDocuments.getDocument(M);return i.provider.resolveCustomTextEditor($,R,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,o,l){this.getCustomDocumentEntry(o,u).disposeEdits(l)}async $onMoveCustomEditor(u,o,l){const a=this._editorProviders.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const d=this._extHostWebviewPanels.getWebviewPanel(u);if(!d)throw new Error("No webview found");const n=T.URI.revive(o),i=this._extHostDocuments.getDocument(n);await a.provider.moveCustomTextEditor(i,d,c.CancellationToken.None)}async $undo(u,o,l,a){return this.getCustomDocumentEntry(o,u).undo(l,a)}async $redo(u,o,l,a){return this.getCustomDocumentEntry(o,u).redo(l,a)}async $revert(u,o,l){const a=this.getCustomDocumentEntry(o,u);await this.getCustomEditorProvider(o).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(u,o,l){const a=this.getCustomDocumentEntry(o,u);await this.getCustomEditorProvider(o).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(u,o,l,a){const d=this.getCustomDocumentEntry(o,u);return this.getCustomEditorProvider(o).saveCustomDocumentAs(d.document,T.URI.revive(l),a)}async $backup(u,o,l){const a=this.getCustomDocumentEntry(o,u),n=await this.getCustomEditorProvider(o).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(n),n.id}getCustomDocumentEntry(u,o){const l=this._documents.get(u,T.URI.revive(o));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(u){const l=this._editorProviders.get(u)?.provider;if(!l||!v(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=f;function v(s){return!!s.onDidChangeCustomDocument}function m(s){return typeof s.resolveCustomTextEditor=="function"}function r(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function b(s){const u=s.scheme===P.Schemas.file||s.scheme===P.Schemas.untitled?s.fsPath:s.toString();return(0,t.hash)(u)+""}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c},Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[269],Ie([1,0,4,6,2,31,15,71,5,7]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";var A,I,E,_,w,h,g,f,v,m,r,b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends t.Disposable{constructor(d,n,i,p){super(),A.set(this,void 0),I.set(this,void 0),E.set(this,void 0),_.set(this,void 0),w.set(this,void 0),h.set(this,void 0),g.set(this,void 0),f.set(this,void 0),v.set(this,!0),m.set(this,void 0),r.set(this,!1),b.set(this,this._register(new c.Emitter)),this.onDidDispose=Ue(this,b,"f").event,s.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Ue(this,s,"f").event,nt(this,A,d,"f"),nt(this,I,n,"f"),nt(this,_,i,"f"),nt(this,E,p.viewType,"f"),nt(this,w,p.panelOptions,"f"),nt(this,f,p.viewColumn,"f"),nt(this,h,p.title,"f"),nt(this,m,p.active,"f")}dispose(){Ue(this,r,"f")||(nt(this,r,!0,"f"),Ue(this,b,"f").fire(),Ue(this,I,"f").$disposeWebview(Ue(this,A,"f")),Ue(this,_,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,_,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,E,"f")}get title(){return this.assertNotDisposed(),Ue(this,h,"f")}set title(d){this.assertNotDisposed(),Ue(this,h,"f")!==d&&(nt(this,h,d,"f"),Ue(this,I,"f").$setTitle(Ue(this,A,"f"),d))}get iconPath(){return this.assertNotDisposed(),Ue(this,g,"f")}set iconPath(d){this.assertNotDisposed(),Ue(this,g,"f")!==d&&(nt(this,g,d,"f"),Ue(this,I,"f").$setIconPath(Ue(this,A,"f"),D.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Ue(this,w,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,f,"f")=="number"&&Ue(this,f,"f")<0))return Ue(this,f,"f")}get active(){return this.assertNotDisposed(),Ue(this,m,"f")}get visible(){return this.assertNotDisposed(),Ue(this,v,"f")}_updateViewState(d){Ue(this,r,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(nt(this,m,d.active,"f"),nt(this,v,d.visible,"f"),nt(this,f,d.viewColumn,"f"),Ue(this,s,"f").fire({webviewPanel:this}))}reveal(d,n){this.assertNotDisposed(),Ue(this,I,"f").$reveal(Ue(this,A,"f"),{viewColumn:typeof d>"u"?void 0:y.ViewColumn.from(d),preserveFocus:!!n})}assertNotDisposed(){if(Ue(this,r,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,I=new WeakMap,E=new WeakMap,_=new WeakMap,w=new WeakMap,h=new WeakMap,g=new WeakMap,f=new WeakMap,v=new WeakMap,m=new WeakMap,r=new WeakMap,b=new WeakMap,s=new WeakMap;class o{static newHandle(){return(0,P.generateUuid)()}constructor(d,n,i){this.webviews=n,this.workspace=i,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(d,n,i,p,C={}){const R=typeof p=="object"?p.viewColumn:p,M={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof p=="object"&&!!p.preserveFocus},$=(0,T.shouldSerializeBuffersForPostMessage)(d),x=o.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(d),x,n,{title:i,panelOptions:l(C),webviewOptions:(0,T.serializeWebviewOptions)(d,this.workspace,C),serializeBuffersForPostMessage:$},M);const L=this.webviews.createNewWebview(x,C,d);return this.createNewWebviewPanel(x,n,i,R,C,L,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((i,p)=>{const C=d[i],R=d[p];return C.active?1:R.active?-1:+C.visible-+R.visible});for(const i of n){const p=this.getWebviewPanel(i);if(!p)continue;const C=d[i];p._updateViewState({active:C.active,visible:C.visible,viewColumn:y.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,n,i){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:i,extension:d}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(d)}),new k.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,i,p){const C=this._serializers.get(n);if(!C)throw new Error(`No serializer found for '${n}'`);const{serializer:R,extension:M}=C,$=this.webviews.createNewWebview(d,i.webviewOptions,M),x=this.createNewWebviewPanel(d,n,i.title,p,i.panelOptions,$,i.active);await R.deserializeWebviewPanel(x,i.state)}createNewWebviewPanel(d,n,i,p,C,R,M){const $=new u(d,this._proxy,R,{viewType:n,title:i,viewColumn:p,panelOptions:C,active:M});return this._webviewPanels.set(d,$),$}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=o;function l(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c},Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[270],Ie([1,0,4,6,71,15,5,7]),function(Z,e,c,t,D,P,y,T){"use strict";var S,k,A,I,E,_,w,h,g,f,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends t.Disposable{constructor(s,u,o,l,a,d){super(),S.set(this,void 0),k.set(this,void 0),A.set(this,void 0),I.set(this,void 0),E.set(this,!1),_.set(this,void 0),w.set(this,void 0),h.set(this,void 0),g.set(this,void 0),f.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Ue(this,f,"f").event,v.set(this,this._register(new c.Emitter)),this.onDidDispose=Ue(this,v,"f").event,nt(this,A,o,"f"),nt(this,w,l,"f"),nt(this,S,s,"f"),nt(this,k,u,"f"),nt(this,I,a,"f"),nt(this,_,d,"f")}dispose(){Ue(this,E,"f")||(nt(this,E,!0,"f"),Ue(this,v,"f").fire(),Ue(this,I,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,w,"f")}set title(s){this.assertNotDisposed(),Ue(this,w,"f")!==s&&(nt(this,w,s,"f"),Ue(this,k,"f").$setWebviewViewTitle(Ue(this,S,"f"),s))}get description(){return this.assertNotDisposed(),Ue(this,h,"f")}set description(s){this.assertNotDisposed(),Ue(this,h,"f")!==s&&(nt(this,h,s,"f"),Ue(this,k,"f").$setWebviewViewDescription(Ue(this,S,"f"),s))}get visible(){return Ue(this,_,"f")}get webview(){return Ue(this,I,"f")}get viewType(){return Ue(this,A,"f")}_setVisible(s){s===Ue(this,_,"f")||Ue(this,E,"f")||(nt(this,_,s,"f"),Ue(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),Ue(this,g,"f")}set badge(s){this.assertNotDisposed(),!(s?.value===Ue(this,g,"f")?.value&&s?.tooltip===Ue(this,g,"f")?.tooltip)&&(nt(this,g,P.ViewBadge.from(s),"f"),Ue(this,k,"f").$setWebviewViewBadge(Ue(this,S,"f"),s))}show(s){this.assertNotDisposed(),Ue(this,k,"f").$show(Ue(this,S,"f"),!!s)}assertNotDisposed(){if(Ue(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,k=new WeakMap,A=new WeakMap,I=new WeakMap,E=new WeakMap,_=new WeakMap,w=new WeakMap,h=new WeakMap,g=new WeakMap,f=new WeakMap,v=new WeakMap;class r{constructor(s,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,u,o,l){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:o,extension:s}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(s),u,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(s)}),new T.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(s,u,o,l,a){const d=this._viewProviders.get(u);if(!d)throw new Error(`No view provider found for '${u}'`);const{provider:n,extension:i}=d,p=this._extHostWebview.createNewWebview(s,{},i),C=new m(s,this._proxy,u,o,p,!0);this._webviewViews.set(s,C),await n.resolveWebviewView(C,{state:l},a)}async $onDidChangeWebviewViewVisibility(s,u){this.getWebviewView(s)._setVisible(u)}async $disposeWebviewView(s){const u=this.getWebviewView(s);this._webviewViews.delete(s),u.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const u=this._webviewViews.get(s);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=r}),define(De[139],Ie([1,0,4,5,2,14,8,3,16]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class ti{get state(){return this._state}constructor(I){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ti.InitialState,this._proxy=I.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,E){let _;if(typeof I=="string"){_=I;try{I=D.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,y.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,_,E)}async asExternalUri(I,E){if((0,y.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const _=await this._proxy.$asExternalUri(I,E);return D.URI.from(_)}};k.InitialState={focused:!0},k=Ve([He(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(De[271],Ie([1,0,117,272,65,39,2,13,45]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(E,_,w){this._commands=E,this.logService=_,this._ipcHandlePath=w,this._server=t.createServer((h,g)=>this.onRequest(h,g)),this.setup().catch(h=>(_.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,_){const w=(g,f)=>{_.writeHead(g,{"content-type":"application/json"}),_.end(JSON.stringify(f||null),v=>v&&this.logService.error(v))},h=[];E.setEncoding("utf8"),E.on("data",g=>h.push(g)),E.on("end",async()=>{try{const g=JSON.parse(h.join(""));let f;switch(g.type){case"open":f=await this.open(g);break;case"openExternal":f=await this.openExternal(g);break;case"status":f=await this.getStatus(g);break;case"extensionManagement":f=await this.manageExtensions(g);break;default:w(404,`Unknown message type: ${g.type}`);break}w(200,f)}catch(g){const f=g instanceof Error?g.message:JSON.stringify(g);w(500,f),this.logService.error("Error while processing pipe request",g)}})}async open(E){const{fileURIs:_,folderURIs:w,forceNewWindow:h,diffMode:g,mergeMode:f,addMode:v,forceReuseWindow:m,gotoLineMode:r,waitMarkerFilePath:b,remoteAuthority:s}=E,u=[];if(Array.isArray(w))for(const d of w)try{u.push({folderUri:y.URI.parse(d)})}catch{}if(Array.isArray(_))for(const d of _)try{(0,S.hasWorkspaceFileExtension)(d)?u.push({workspaceUri:y.URI.parse(d)}):u.push({fileUri:y.URI.parse(d)})}catch{}const o=b?y.URI.file(b):void 0,a={forceNewWindow:h,diffMode:g,mergeMode:f,addMode:v,gotoLineMode:r,forceReuseWindow:m,preferNewWindow:!m&&!o&&!v,waitMarkerFileURI:o,remoteAuthority:s};return this._commands.executeCommand("_remoteCLI.windowOpen",u,a),""}async openExternal(E){for(const _ of E.uris){const w=y.URI.parse(_),h=w.scheme==="file"?w:_;await this._commands.executeCommand("_remoteCLI.openExternal",h)}}async manageExtensions(E){const _=h=>h?.map(g=>/\.vsix$/i.test(g)?y.URI.parse(g):g),w={list:E.list,install:_(E.install),uninstall:_(E.uninstall),force:E.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",w)}async getStatus(E){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let A=class extends k{constructor(E,_){super(E,_,(0,c.createRandomIPCHandle)())}};A=Ve([He(0,P.IExtHostCommands),He(1,T.ILogService)],A),e.CLIServer=A}),define(De[273],Ie([1,0,245,25,16]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let y=class extends c.AbstractExtHostConsoleForwarder{constructor(S,k){super(S,k),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(S,k,A){const I=S==="error"||S==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,I.write(`
START_NATIVE_LOG
`),k.apply(console,A),I.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(S,k){const A=process[S],I=A.write;let E="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(_,w,h)=>{if(!this._isMakingConsoleCall){E+=_.toString(w);const g=E.length>P?E.length:E.lastIndexOf(`
`);g!==-1&&(console[k](E.slice(0,g)),E=E.slice(g+1))}I.call(A,_,w,h)}})}};y=Ve([He(0,D.IExtHostRpcService),He(1,t.IExtHostInitDataService)],y),e.ExtHostConsoleForwarder=y}),define(De[274],Ie([1,0,9,83,31,39,6,5,2,16]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let A=class extends y.Disposable{constructor(E,_){super();const w=E.getProxy(T.MainContext.MainThreadDownloadService);_.registerCommand(!1,"_workbench.downloadResource",async h=>{const g=S.URI.file((0,c.join)((0,t.tmpdir)(),(0,D.generateUuid)()));return await w.$download(h,g),g})}};A=Ve([He(0,k.IExtHostRpcService),He(1,P.IExtHostCommands)],A),e.ExtHostDownloadService=A}),define(De[275],Ie([1,0,138,14,195,31]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class y extends c.ExtHostLoggerService{doCreateLogger(S,k,A){return S.scheme===t.Schemas.file?new D.SpdLogLogger(A?.name||(0,P.generateUuid)(),S.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,k):super.doCreateLogger(S,k,A)}}e.ExtHostLoggerService=y}),define(De[276],Ie([1,0,65,9,2,70,6,14,18,29]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(s){const u=await super._getWorkspaceStorageURI(s);if(u.scheme!==T.Schemas.file)return u;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const o=u.fsPath;let l=0;do{let a;l===0?a=o:a=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${l}`:`${o}-${l}`,await I(a);const d=t.join(a,"vscode.lock"),n=await h(this._logService,d,!1);if(n)return this._workspaceStorageLock=n,process.on("exit",()=>{n.dispose()}),D.URI.file(a);l++}while(l<10);return u}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function I(b){try{await k.Promises.stat(b);return}catch{}try{await k.Promises.mkdir(b,{recursive:!0})}catch{}}const E=1e3,_=10*60*1e3;class w extends y.Disposable{constructor(s,u){super(),this.logService=s,this.filename=u,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const o=await g(s,u);(!o||o.pid!==process.pid)&&(s.info(`Lock '${u}': The lock was lost unexpectedly.`),this._timer.cancel());try{await k.Promises.utimes(u,new Date,new Date)}catch(l){s.error(l),s.info(`Lock '${u}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{c.unlinkSync(this.filename)}catch{}}async setWillRelease(s){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+s};await k.Promises.writeFile(this.filename,JSON.stringify(u),{flag:"w"})}catch(u){this.logService.error(u)}}}async function h(b,s,u){try{const l={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(s,JSON.stringify(l),{flag:"wx"})}catch(l){b.error(l)}const o=await g(b,s);return!o||o.pid!==process.pid?u?(b.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(b.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),m(b,s)):(b.info(`Lock '${s}': Lock acquired.`),new w(b,s))}async function g(b,s){let u;try{u=await k.Promises.readFile(s)}catch(o){return b.error(o),null}try{return JSON.parse(String(u))}catch(o){return b.error(o),null}}async function f(b,s){let u;try{u=await k.Promises.stat(s)}catch(o){return b.error(o),0}return u.mtime.getTime()}function v(b){try{return process.kill(b,0),!0}catch{return!1}}async function m(b,s){const u=await g(b,s);if(!u)return b.info(`Lock '${s}': Could not read pid of lock holder.`),r(b,s);if(u.willReleaseAt){let n=u.willReleaseAt-Date.now();if(n<5e3){for(n>0?b.info(`Lock '${s}': The lockfile is scheduled to be released in ${n} ms.`):b.info(`Lock '${s}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await f(b,s)===0)return r(b,s);n=u.willReleaseAt-Date.now()}return r(b,s)}}if(!v(u.pid))return b.info(`Lock '${s}': The pid ${u.pid} appears to be gone.`),r(b,s);const o=await f(b,s),l=Date.now()-o;if(l<=_)return b.info(`Lock '${s}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;b.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const a=await f(b,s),d=Date.now()-a;return d<=_?(b.info(`Lock '${s}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(b.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),r(b,s))}async function r(b,s){b.info(`Lock '${s}': Deleting a stale lock.`);try{await k.Promises.unlink(s)}catch{}return h(b,s,!0)}}),define(De[277],Ie([1,0,31,16,40]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends D.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,k){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:k})}createTerminalFromOptions(T,S){const k=new D.ExtHostTerminal(this._proxy,(0,c.generateUuid)(),T,T.name);return this._terminals.push(k),k.create(T,this._serializeParentTerminal(T,S)),k.value}};P=Ve([He(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(De[278],Ie([1,0,5,16,179,6,25,2,44,22,29,7,12,54,4,128,99,13]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v extends h.DisposableTunnel{}function m(n){const i=n.trim().split(`
`),p=[];return i.forEach(R=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);M&&M.length>=3&&p.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),p.reduce((R,M)=>(R[M.socket]=M,R),{})}e.getSockets=m;function r(...n){const i=[].concat(...n.map(s));return[...new Map(i.filter(p=>p.st==="0A").map(p=>{const C=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:b(C[0]),port:parseInt(C[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=r;function b(n){let i="";if(n.length===8)for(let p=n.length-2;p>=0;p-=2)i+=parseInt(n.substr(p,2),16),p!==0&&(i+=".");else for(let p=n.length-4;p>=0;p-=4)i+=parseInt(n.substr(p,4),16).toString(16),p!==0&&(i+=":");return i}e.parseIpAddress=b;function s(n){const i=n.trim().split(`
`),p=i.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return i.map(R=>R.trim().split(/\s+/).reduce((M,$,x)=>(M[p[x]||x]=$,M),{}))}e.loadConnectionTable=s;function u(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function o(n){const i=n.trim().split(`
`),p=[];return i.forEach(C=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(C);R&&R.length>=4&&p.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),p}e.getRootProcesses=o;async function l(n,i,p){const C=p.reduce((M,$)=>(M[$.pid]=$,M),{}),R=[];return n.forEach(({socket:M,ip:$,port:x})=>{const L=i[M]?i[M].pid:void 0,B=L?C[L]?.cmd:void 0;L&&B&&!u(B)&&R.push({host:$,port:x,detail:B,pid:L})}),R}e.findPorts=l;function a(n,i,p){const C=new Map,R=o(i);for(const M of n){const $=p.get(M.port);if($){C.set(M.port,$);continue}const x=R.find(L=>L.cmd.includes(`${M.port}`));if(x){let L=x,B;do B=R.find(O=>O.ppid===L.pid),B&&(L=B);while(B);C.set(M.port,{host:M.ip,port:M.port,pid:L.pid,detail:L.cmd,ppid:L.ppid})}else C.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return C}e.tryFindRootPorts=a;let d=class extends P.Disposable{constructor(i,p,C){super(),this.logService=C,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new w.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=i.getProxy(c.MainContext.MainThreadTunnelService),E.isLinux&&p.remote.isRemote&&p.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(i,p){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${p.remoteAddress.host}:${p.remoteAddress.port}.`);const C=await this._proxy.$openTunnel(p,i.displayName);if(C){const R=new v(C.remoteAddress,C.localAddress,()=>this._proxy.$closeTunnel(C.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(i){return Math.max(i*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(i,p){const C=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(C,{selector:i,provider:p}),this._proxy.$registerPortsAttributesProvider(i,C),new I.Disposable(()=>{this._portAttributesProviders.delete(C),this._proxy.$unregisterPortsAttributesProvider(C)})}async $providePortAttributes(i,p,C,R,M){const $=[];for(const L of i){const B=this._portAttributesProviders.get(L);if(!B)return[];$.push(...await Promise.all(p.map(async O=>B.provider.providePortAttributes(O,C,R,M))))}const x=$.filter(L=>!!L);return x.length>0?x.map(L=>({autoForwardAction:L.autoForwardAction,port:L.port})):[]}async $registerCandidateFinder(i){if(i&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=i;const p=new g.MovingAverage;let C;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),M=(await this.findCandidatePorts()).filter(x=>(0,h.isLocalhost)(x.host)||(0,h.isAllInterfaces)(x.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(x=>x.port).join(", ")}`);const $=new Date().getTime()-R;p.update($),(!C||JSON.stringify(C)!==JSON.stringify(M))&&(C=M,await this._proxy.$onFoundNewCandidates(C)),await new Promise(x=>setTimeout(()=>x(),this.calculateDelay(p.value)))}}async setTunnelFactory(i){if(i){if(i.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this._showCandidatePort=i.showCandidatePort,this._proxy.$setCandidateFilter()),i.tunnelFactory){this._forwardPortProvider=i.tunnelFactory;let p=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&p.length===0&&(p=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]);const C=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:p}:void 0;this._proxy.$setTunnelProvider(C)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(i,p){if(this._extensionTunnels.has(i.host)){const C=this._extensionTunnels.get(i.host);C.has(i.port)&&(p&&C.get(i.port).disposeListener.dispose(),await C.get(i.port).tunnel.dispose(),C.delete(i.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(i,p){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const C=this._forwardPortProvider(i,p);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),C!==void 0){const R=await C;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(i.remoteAddress.host)||this._extensionTunnels.set(i.remoteAddress.host,new Map);const M=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:R,disposeListener:M}),_.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(i){const p=await Promise.all(i.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),C=i.filter((R,M)=>p[M]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(R=>R.port).join(", ")} to ${C.map(R=>R.port).join(", ")}`),C}async findCandidatePorts(){let i="",p="";try{i=await A.Promises.readFile("/proc/net/tcp","utf8"),p=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const C=r(i,p),R=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,V,H)=>{U(V)})}),M=m(R),$=await A.Promises.readdir("/proc"),x=[];for(const U of $)try{const F=Number(U),V=k.joinPath(T.URI.file("/proc"),U);if((await A.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(F)){const Q=await A.Promises.readlink(k.joinPath(V,"cwd").fsPath),K=await A.Promises.readFile(k.joinPath(V,"cmdline").fsPath,"utf8");x.push({pid:F,cwd:Q,cmd:K})}}catch{}const L=[],B=C.filter(U=>{const F=M[U.socket];return F||L.push(U),F}),O=l(B,M,x);let z;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${L.length}`),L.length>0){const U=await new Promise(F=>{(0,S.exec)("ps -F -A -l | grep root",(V,H,Q)=>{F(H)})});this._foundRootPorts=a(L,U,this._foundRootPorts),z=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.join(", ")}`)}return O.then(U=>z?U.concat(z):U)}};d=Ve([He(0,t.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,f.ILogService)],d),e.ExtHostTunnelService=d}),define(De[279],Ie([1,0,18,23,21,10,4,6,112,239,57]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(C,R){try{return JSON.stringify(C,R)}catch{return"null"}}const _="$$ref$$",w={[_]:-1};class h{constructor(R,M){this.jsonString=R,this.referencedBuffers=M}}function g(C,R=null,M=!1){const $=[];return{jsonString:(M?E:JSON.stringify)(C,(L,B)=>{if(typeof B>"u")return w;if(typeof B=="object"){if(B instanceof t.VSBuffer){const O=$.push(B)-1;return{[_]:O}}if(R)return R(L,B)}return B}),referencedBuffers:$}}e.stringifyJsonWithBufferRefs=g;function f(C,R,M){return JSON.parse(C,($,x)=>{if(x){const L=x[_];if(typeof L=="number")return R[L];if(M&&x.$mid===1)return M.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=f;function v(C,R){return JSON.stringify(C,R)}function m(C){return C?(R,M)=>M&&M.$mid===1?C.transformOutgoing(M):M:null}var r;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},u=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class l extends T.Disposable{constructor(R,M=null,$=null){super(),this[I]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=M,this._uriTransformer=$,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,L=A.ProxyIdentifier.count;x<L;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,S.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:M,sid:$}=R;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,$)),this._proxies[M]}_createProxy(R,M){const $={get:(x,L)=>(typeof L=="string"&&!x[L]&&L.charCodeAt(0)===36&&(x[L]=(...B)=>this._remoteCall(R,L,B)),L===o?M:x[L])};return new Proxy(Object.create(null),$)}set(R,M){return this._locals[R.nid]=M,M}assertRegistered(R){for(let M=0,$=R.length;M<$;M++){const x=R[M];if(!this._locals[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const M=R.byteLength,$=a.read(R,0),x=$.readUInt8(),L=$.readUInt32();switch(x){case 1:case 2:{let{rpcId:B,method:O,args:z}=n.deserializeRequestJSONArgs($);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(M,L,B,O,z,x===2);break}case 3:case 4:{let{rpcId:B,method:O,args:z}=n.deserializeRequestMixedArgs($);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(M,L,B,O,z,x===4);break}case 5:{this._logger?.logIncoming(M,L,0,"ack"),this._onDidReceiveAcknowledge(L);break}case 6:{this._receiveCancel(M,L);break}case 7:{this._receiveReply(M,L,void 0);break}case 9:{let B=n.deserializeReplyOKJSON($);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(M,L,B);break}case 10:{const B=n.deserializeReplyOKJSONWithBuffers($,this._uriTransformer);this._receiveReply(M,L,B);break}case 8:{const B=n.deserializeReplyOKVSBuffer($);this._receiveReply(M,L,B);break}case 11:{let B=n.deserializeReplyErrError($);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(M,L,B);break}case 12:{this._receiveReplyErr(M,L,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,M,$,x,L,B){this._logger?.logIncoming(R,M,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)($)}.${x}(`,L);const O=String(M);let z,U;if(B){const V=new D.CancellationTokenSource;L.push(V.token),z=this._invokeHandler($,x,L),U=()=>V.cancel()}else z=this._invokeHandler($,x,L),U=s;this._cancelInvokedHandlers[O]=U;const F=n.serializeAcknowledged(M);this._logger?.logOutgoing(F.byteLength,M,1,"ack"),this._protocol.send(F),z.then(V=>{delete this._cancelInvokedHandlers[O];const H=n.serializeReplyOK(M,V,this._uriReplacer);this._logger?.logOutgoing(H.byteLength,M,1,"reply:",V),this._protocol.send(H)},V=>{delete this._cancelInvokedHandlers[O];const H=n.serializeReplyErr(M,V);this._logger?.logOutgoing(H.byteLength,M,1,"replyErr:",V),this._protocol.send(H)})}_receiveCancel(R,M){this._logger?.logIncoming(R,M,1,"receiveCancel");const $=String(M);this._cancelInvokedHandlers[$]?.()}_receiveReply(R,M,$){this._logger?.logIncoming(R,M,0,"receiveReply:",$);const x=String(M);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const L=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],L.resolveOk($)}_receiveReplyErr(R,M,$){this._logger?.logIncoming(R,M,0,"receiveReplyErr:",$);const x=String(M);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const L=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let B;$&&($.$isError?(B=new Error,B.name=$.name,B.message=$.message,B.stack=$.stack):B=$),L.resolveErr(B)}_invokeHandler(R,M,$){try{return Promise.resolve(this._doInvokeHandler(R,M,$))}catch(x){return Promise.reject(x)}}_doInvokeHandler(R,M,$){const x=this._locals[R];if(!x)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(R));const L=x[M];if(typeof L!="function")throw new Error("Unknown method "+M+" on actor "+(0,A.getStringIdentifierForProxy)(R));return L.apply(x,$)}_remoteCall(R,M,$){if(this._isDisposed)return new k.CanceledLazyPromise;let x=null;if($.length>0&&D.CancellationToken.isCancellationToken($[$.length-1])&&(x=$.pop()),x&&x.isCancellationRequested)return Promise.reject(P.canceled());const L=n.serializeRequestArguments($,this._uriReplacer),B=++this._lastMessageId,O=String(B),z=new k.LazyPromise;x&&x.onCancellationRequested(()=>{const F=n.serializeCancel(B);this._logger?.logOutgoing(F.byteLength,B,0,"cancel"),this._protocol.send(n.serializeCancel(B))}),this._pendingRPCReplies[O]=z,this._onWillSendRequest(B);const U=n.serializeRequest(B,R,M,L,!!x);return this._logger?.logOutgoing(U.byteLength,B,0,`request: ${(0,A.getStringIdentifierForProxy)(R)}.${M}(`,$),this._protocol.send(U),z}}e.RPCProtocol=l,I=u,l.UNRESPONSIVE_TIME=3*1e3;class a{static alloc(R,M,$){const x=new a(t.VSBuffer.alloc($+1+4),0);return x.writeUInt8(R),x.writeUInt32(M),x}static read(R,M){return new a(R,M)}get buffer(){return this._buff}constructor(R,M){this._buff=R,this._offset=M}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const $=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,$}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,$}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,M}static sizeMixedArray(R){let M=0;M+=1;for(let $=0,x=R.length;$<x;$++){const L=R[$];switch(M+=1,L.type){case 1:M+=this.sizeLongString(L.value);break;case 2:M+=this.sizeVSBuffer(L.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(L.value);for(let B=0;B<L.buffers.length;++B)M+=this.sizeVSBuffer(L.buffers[B]);break;case 4:break}}return M}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let M=0,$=R.length;M<$;M++){const x=R[M];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let L=0;L<x.buffers.length;++L)this.writeBuffer(x.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(R);for(let $=0;$<R;$++)switch(this.readUInt8()){case 1:M[$]=this.readLongString();break;case 2:M[$]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),B=this.readLongString(),O=[];for(let z=0;z<L;++z)O.push(this.readVSBuffer());M[$]=new A.SerializableObjectWithBuffers(f(B,O,null));break}case 4:M[$]=void 0;break}return M}}a.sizeUInt32=4;var d;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(d||(d={}));class n{static _useMixedArgSerialization(R){for(let M=0,$=R.length;M<$;M++)if(R[M]instanceof t.VSBuffer||R[M]instanceof A.SerializableObjectWithBuffers||typeof R[M]>"u")return!0;return!1}static serializeRequestArguments(R,M){if(this._useMixedArgSerialization(R)){const $=[];for(let x=0,L=R.length;x<L;x++){const B=R[x];if(B instanceof t.VSBuffer)$[x]={type:2,value:B};else if(typeof B>"u")$[x]={type:4};else if(B instanceof A.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:z}=g(B.value,M);$[x]={type:3,value:t.VSBuffer.fromString(O),buffers:z}}else $[x]={type:1,value:t.VSBuffer.fromString(v(B,M))}}return{type:1,args:$}}return{type:0,args:v(R,M)}}static serializeRequest(R,M,$,x,L){switch(x.type){case 0:return this._requestJSONArgs(R,M,$,x.args,L);case 1:return this._requestMixedArgs(R,M,$,x.args,L)}}static _requestJSONArgs(R,M,$,x,L){const B=t.VSBuffer.fromString($),O=t.VSBuffer.fromString(x);let z=0;z+=a.sizeUInt8(),z+=a.sizeShortString(B),z+=a.sizeLongString(O);const U=a.alloc(L?2:1,R,z);return U.writeUInt8(M),U.writeShortString(B),U.writeLongString(O),U.buffer}static deserializeRequestJSONArgs(R){const M=R.readUInt8(),$=R.readShortString(),x=R.readLongString();return{rpcId:M,method:$,args:JSON.parse(x)}}static _requestMixedArgs(R,M,$,x,L){const B=t.VSBuffer.fromString($);let O=0;O+=a.sizeUInt8(),O+=a.sizeShortString(B),O+=a.sizeMixedArray(x);const z=a.alloc(L?4:3,R,O);return z.writeUInt8(M),z.writeShortString(B),z.writeMixedArray(x),z.buffer}static deserializeRequestMixedArgs(R){const M=R.readUInt8(),$=R.readShortString(),x=R.readMixedArray(),L=new Array(x.length);for(let B=0,O=x.length;B<O;B++){const z=x[B];typeof z=="string"?L[B]=JSON.parse(z):L[B]=z}return{rpcId:M,method:$,args:L}}static serializeAcknowledged(R){return a.alloc(5,R,0).buffer}static serializeCancel(R){return a.alloc(6,R,0).buffer}static serializeReplyOK(R,M,$){if(typeof M>"u")return this._serializeReplyOKEmpty(R);if(M instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(R,M);if(M instanceof A.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:L}=g(M.value,$,!0);return this._serializeReplyOKJSONWithBuffers(R,x,L)}else return this._serializeReplyOKJSON(R,E(M,$))}static _serializeReplyOKEmpty(R){return a.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,M){let $=0;$+=a.sizeVSBuffer(M);const x=a.alloc(8,R,$);return x.writeVSBuffer(M),x.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,M){const $=t.VSBuffer.fromString(M);let x=0;x+=a.sizeLongString($);const L=a.alloc(9,R,x);return L.writeLongString($),L.buffer}static _serializeReplyOKJSONWithBuffers(R,M,$){const x=t.VSBuffer.fromString(M);let L=0;L+=a.sizeUInt32,L+=a.sizeLongString(x);for(const O of $)L+=a.sizeVSBuffer(O);const B=a.alloc(10,R,L);B.writeUInt32($.length),B.writeLongString(x);for(const O of $)B.writeBuffer(O);return B.buffer}static deserializeReplyOKJSON(R){const M=R.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(R,M){const $=R.readUInt32(),x=R.readLongString(),L=[];for(let B=0;B<$;++B)L.push(R.readVSBuffer());return new A.SerializableObjectWithBuffers(f(x,L,M))}static serializeReplyErr(R,M){const $=M?E(P.transformErrorForSerialization(M),null):void 0;if(typeof $!="string")return this._serializeReplyErrEmpty(R);const x=t.VSBuffer.fromString($);let L=0;L+=a.sizeLongString(x);const B=a.alloc(11,R,L);return B.writeLongString(x),B.buffer}static deserializeReplyErrError(R){const M=R.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(R){return a.alloc(12,R,0).buffer}}var i;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(i||(i={}));var p;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(p||(p={}))}),define(De[280],Ie([1,0,4,43,53,3,38,10,18]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.channels=new Map,this._onDidRegisterChannel=new c.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new c.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(w){this.channels.has(w.id)||(this.channels.set(w.id,w),this._onDidRegisterChannel.fire(w.id))}getChannels(){const w=[];return this.channels.forEach(h=>w.push(h)),w}getChannel(w){return this.channels.get(w)}removeChannel(w){this.channels.delete(w),this._onDidRemoveChannel.fire(w)}}t.Registry.add(e.Extensions.OutputChannels,new A);function I(_,w,h,g,f){return(0,S.createCancelablePromise)(async v=>{await(0,y.whenProviderRegistered)(h,g);const m=t.Registry.as(e.Extensions.OutputChannels);try{await E(h,1,g,f,v),m.registerChannel({id:_,label:w,file:h,log:!0})}catch(r){(0,T.isCancellationError)(r)||f.error("Error while registering log channel",h.toString(),(0,T.getErrorMessage)(r))}})}e.registerLogChannel=I;async function E(_,w,h,g,f){if(!await h.exists(_)){if(f.isCancellationRequested)throw new T.CancellationError;if(w>10)throw new Error("Timed out while waiting for file to be created");g.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",_.toString()),await(0,S.timeout)(1e3,f),await E(_,w+1,h,g,f)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(De[140],Ie([1,0,5,3,16,26,13,280,69,25,46,153,23,11,38,4,6,27]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class v extends y.AbstractMessageLogger{get disposed(){return this._disposed}constructor(s,u,o,l,a){super(),this.id=s,this.name=u,this.logger=o,this.proxy=l,this.extension=a,this.offset=0,this._disposed=!1,this.visible=!1,this._register(o.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.logger.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}clear(){const s=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,s)}replace(s){const u=this.offset;this.info(s),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,u),this.visible&&this.logger.flush()}show(s,u){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof s=="boolean"?s:u))}hide(){this.proxy.$close(this.id)}log(s,u){this.offset+=E.VSBuffer.fromString(u).byteLength,(0,y.log)(this.logger,s,u)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class m extends v{appendLine(s){this.append(s)}}let r=class{constructor(s,u,o,l,a,d){this.initData=u,this.extHostFileSystem=o,this.extHostFileSystemInfo=l,this.loggerService=a,this.logService=d,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=s.getProxy(c.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(u.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.visibleChannelId=s;for(const[u,o]of this.channels)o.visible=u===this.visibleChannelId}createOutputChannel(s,u,o){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const l=typeof u=="object"&&u.log;l&&(0,f.checkProposedApiEnabled)(o,"extensionLog");const a=(0,_.isString)(u)?u:void 0;if((0,_.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const n=this.initData.environment.extensionLogLevel?.find(([p])=>P.ExtensionIdentifier.equals(o.identifier,p))?.[1];n&&(d=(0,y.parseLogLevel)(n));const i=l?this.doCreateLogOutputChannel(s,d,o):this.doCreateOutputChannel(s,a,o);return i.then(p=>{this.channels.set(p.id,p),p.visible=p.id===this.visibleChannelId}),l?this.createExtHostLogOutputChannel(s,d??this.logService.getLevel(),i):this.createExtHostOutputChannel(s,i)}async doCreateOutputChannel(s,u,o){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const l=await this.outputDirectoryPromise,a=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(a,{always:!0,donotRotate:!0,donotUseFormatters:!0}),n=await this.proxy.$register(s,a,!1,u,o.identifier.value);return new v(n,s,d,this.proxy,o)}async doCreateLogOutputChannel(s,u,o){const l=await this.createExtensionLogDirectory(o),a=this.extHostFileSystemInfo.extUri.joinPath(l,`${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(a,{name:s},u),n=await this.proxy.$register(s,a,!0,void 0,o.identifier.value);return new m(n,s,d,this.proxy,o)}createExtensionLogDirectory(s){let u=this.extensionLogDirectoryPromise.get(s.identifier.value);if(!u){const o=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,s.identifier.value);this.extensionLogDirectoryPromise.set(s.identifier.value,u=(async()=>{try{await this.extHostFileSystem.value.createDirectory(o)}catch(l){if((0,w.toFileSystemProviderErrorCode)(l)!==w.FileSystemProviderErrorCode.FileExists)throw l}return o})())}return u}createExtHostOutputChannel(s,u){let o=!1;const l=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return s},append(a){l(),u.then(d=>d.append(a))},appendLine(a){l(),u.then(d=>d.appendLine(a))},clear(){l(),u.then(a=>a.clear())},replace(a){l(),u.then(d=>d.replace(a))},show(a,d){l(),u.then(n=>n.show(a,d))},hide(){l(),u.then(a=>a.hide())},dispose(){o=!0,u.then(a=>a.dispose())}}}createExtHostLogOutputChannel(s,u,o){const l=new g.DisposableStore,a=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},d=l.add(new h.Emitter);return o.then(n=>{l.add(n),l.add(n.onDidChangeLogLevel(i=>{u=i,d.fire(i)}))}),{...this.createExtHostOutputChannel(s,o),get logLevel(){return u},onDidChangeLogLevel:d.event,trace(n,...i){a(),o.then(p=>p.trace(n,...i))},debug(n,...i){a(),o.then(p=>p.debug(n,...i))},info(n,...i){a(),o.then(p=>p.info(n,...i))},warn(n,...i){a(),o.then(p=>p.warn(n,...i))},error(n,...i){a(),o.then(p=>p.error(n,...i))},dispose(){l.dispose()}}}};r=Ve([He(0,D.IExtHostRpcService),He(1,k.IExtHostInitDataService),He(2,S.IExtHostConsumerFileSystem),He(3,A.IExtHostFileSystemInfo),He(4,y.ILoggerService),He(5,y.ILogService)],r),e.ExtHostOutputService=r,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(De[281],Ie([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(De[282],Ie([1,0,32,14,9,12,22,2,3,208,45,225,281]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let _=class ni{constructor(h,g,f,v){this.localUserHome=h,this.remoteAgentService=g,this.environmentService=f,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const m=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=m?.userHome??h})()}hasValidBasename(h,g,f){return typeof g=="string"||typeof g>"u"?this.resolveOS.then(v=>this.doHasValidBasename(h,v,g)):this.doHasValidBasename(h,g,f)}doHasValidBasename(h,g,f){return h.scheme===t.Schemas.file||h.scheme===t.Schemas.vscodeRemote?(0,c.isValidBasename)(f??(0,y.basename)(h),g===1):!0}get defaultUriScheme(){return ni.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,g){if(h.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,k.getVirtualWorkspaceScheme)(g.getWorkspace());if(f)return f;const v=g.getWorkspace().folders[0];if(v)return v.uri.scheme;const m=g.getWorkspace().configuration;return m?m.scheme:t.Schemas.file}userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?D.win32:D.posix)}async fileURI(h){let g="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const v=h.indexOf("/",2);v===-1?(g=h.substring(2),h="/"):(g=h.substring(2,v),h=h.substring(v)||"/")}return T.URI.from({scheme:t.Schemas.file,authority:g,path:h,query:"",fragment:""})}};_=Ve([He(1,E.IRemoteAgentService),He(2,I.IWorkbenchEnvironmentService),He(3,A.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(De[72],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(y,T){this.line=y,this.character=T}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,T){return new c(0,0)}with(y){return new c(0,0)}}e.Position=c;class t{constructor(y,T,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(y,T),this.end=new c(S,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new t(0,0,0,0)}with(y){return new t(0,0,0,0)}}e.Range=t;var D;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[30],Ie([1,0,17,37,24,32,8,3,9,10,72,18]),function(Z,e,c,t,D,P,y,T,S,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",_=" characters skipped \u27EB",w=(E.length+_.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var h;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function f(K){return!!K.preview}e.resultIsMatch=f;function v(K){return!!K.resource}e.isFileMatch=v;function m(K){return!!K.message}e.isProgressMessage=m;var r;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=b;class s{constructor(de,ee,fe){this.ranges=ee;const Y=Array.isArray(ee)?ee:[ee];if(fe&&fe.matchLines===1&&u(Y)){de=(0,y.getNLines)(de,fe.matchLines);let ve="",Ee=0,ke=0;const Re=Math.floor(fe.charsPerLine/5),ze=[];for(const ie of Y){const ce=Math.max(ie.startColumn-Re,0),me=ie.startColumn+fe.charsPerLine;if(ce>ke+Re+w){const J=E+(ce-ke)+_;ve+=J+de.slice(ce,me),Ee+=ce-(ke+J.length)}else ve+=de.slice(ke,me);ze.push(new l(0,ie.startColumn-Ee,ie.endColumn-Ee)),ke=me}this.preview={text:ve,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const ve=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:de,matches:(0,c.mapArrayOrNot)(ee,Ee=>new o(Ee.startLineNumber-ve,Ee.startColumn,Ee.endLineNumber-ve,Ee.endColumn))}}}}e.TextSearchMatch=s;function u(K){const de=K[0].startLineNumber;for(const ee of K)if(ee.startLineNumber!==de||ee.endLineNumber!==de)return!1;return!0}class o{constructor(de,ee,fe,Y){this.startLineNumber=de,this.startColumn=ee,this.endLineNumber=fe,this.endColumn=Y}}e.SearchRange=o;class l extends o{constructor(de,ee,fe){super(de,ee,de,fe)}}e.OneLineRange=l;var a;(function(K){K.List="list",K.Tree="tree"})(a=e.ViewMode||(e.ViewMode={}));var d;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function n(K,de=!0){const ee=K&&K.files&&K.files.exclude,fe=de&&K&&K.search&&K.search.exclude;if(!ee&&!fe)return;if(!ee||!fe)return ee||fe;let Y=Object.create(null);return Y=D.mixin(Y,D.deepClone(ee)),Y=D.mixin(Y,D.deepClone(fe),!0),Y}e.getExcludes=n;function i(K,de){return K.excludePattern&&t.match(K.excludePattern,de)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&t.match(K.includePattern,de)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(ee=>{const fe=ee.folder.fsPath;if(P.isEqualOrParent(de,fe)){const Y=S.relative(fe,de);return!ee.includePattern||!!t.match(ee.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var p;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class C extends Error{constructor(de,ee){super(de),this.code=ee}}e.SearchError=C;function R(K){const de=K.message;if((0,k.isCancellationError)(K))return new C(de,p.canceled);try{const ee=JSON.parse(de);return new C(ee.message,ee.code)}catch{return new C(de,p.other)}}e.deserializeSearchError=R;function M(K){const de={message:K.message,code:K.code};return new Error(JSON.stringify(de))}e.serializeSearchError=M;function $(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=$;function x(K){return K.type==="success"}e.isSerializedSearchSuccess=x;function L(K){return!!K.path}e.isSerializedFileMatch=L;function B(K,de){const ee=K.searchPath?K.searchPath:K.relativePath;return(0,y.fuzzyContains)(ee,de)}e.isFilePatternMatch=B;class O{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function z(K,de){const ee={...K||{},...de||{}};return Object.keys(ee).filter(fe=>{const Y=ee[fe];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=z;class U{constructor(de,ee){this._parsedIncludeExpression=null,this._excludeExpression={...de.excludePattern||{},...ee.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let fe=de.includePattern;ee.includePattern&&(fe?fe={...fe,...ee.includePattern}:fe=ee.includePattern),fe&&(this._parsedIncludeExpression=t.parse(fe))}matchesExcludesSync(de,ee,fe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,ee,fe))}includedInQuerySync(de,ee,fe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,ee,fe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(de,ee,fe))}includedInQuery(de,ee,fe){const Y=this._parsedExcludeExpression(de,ee,fe),ve=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(de,ee,fe):!0;return(0,I.isThenable)(Y)?Y.then(Ee=>Ee?!1:ve()):ve()}hasSiblingExcludeClauses(){return F(this._excludeExpression)}}e.QueryGlobTester=U;function F(K){for(const de in K)if(typeof K[de]!="boolean")return!0;return!1}function V(K){if(!K)return;let de;return ee=>(de||(de=(K()||Promise.resolve([])).then(fe=>fe?Q(fe):{})),de.then(fe=>!!fe[ee]))}e.hasSiblingPromiseFn=V;function H(K){if(!K)return;let de;return ee=>{if(!de){const fe=K();de=fe?Q(fe):{}}return!!de[ee]}}e.hasSiblingFn=H;function Q(K){const de={};for(const ee of K)de[ee]=!0;return de}}),define(De[33],Ie([1,0,17,18,21,4,6,64,14,99,22,8,11,2,177,3,13,196,45,46,25,16,15,7,55,30,5]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m,r,b,s,u,o,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(x,L,B){return new A.ExtUri(O=>C(O,B)).isEqual(x,L)}function n(x,L,B){return d(x.uri,L.uri,B)?0:(0,I.compare)(x.uri.toString(),L.uri.toString())}function i(x,L,B){return x.index!==L.index?x.index<L.index?-1:1:d(x.uri,L.uri,B)?(0,I.compare)(x.name,L.name):(0,I.compare)(x.uri.toString(),L.uri.toString())}function p(x,L,B,O){const z=x.slice(0).sort((F,V)=>B(F,V,O)),U=L.slice(0).sort((F,V)=>B(F,V,O));return(0,c.delta)(z,U,(F,V)=>B(F,V,O))}function C(x,L){const B=L.getCapabilities(x.scheme);return!(B&&B&1024)}class R extends v.Workspace{static toExtHostWorkspace(L,B,O,z){if(!L)return{workspace:null,added:[],removed:[]};const{id:U,name:F,folders:V,configuration:H,transient:Q,isUntitled:K}=L,de=[],ee=B;B?V.forEach((Ee,ke)=>{const Re=_.URI.revive(Ee.uri),ze=R._findFolder(O||B,Re,z);ze?(ze.name=Ee.name,ze.index=Ee.index,de.push(ze)):de.push({uri:Re,name:Ee.name,index:ke})}):de.push(...V.map(({uri:Ee,name:ke,index:Re})=>({uri:_.URI.revive(Ee),name:ke,index:Re}))),de.sort((Ee,ke)=>Ee.index<ke.index?-1:1);const fe=new R(U,F,de,!!Q,H?_.URI.revive(H):null,!!K,Ee=>C(Ee,z)),{added:Y,removed:ve}=p(ee?ee.workspaceFolders:[],fe.workspaceFolders,n,z);return{workspace:fe,added:Y,removed:ve}}static _findFolder(L,B,O){for(let z=0;z<L.folders.length;z++){const U=L.workspaceFolders[z];if(d(U.uri,B,O))return U}}constructor(L,B,O,z,U,F,V){super(L,O.map(H=>new v.WorkspaceFolder(H)),z,U,V),this._name=B,this._isUntitled=F,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(V),O.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,B){return B&&this._structure.get(L)&&(L=(0,A.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let M=class{constructor(L,B,O,z,U){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=z,this._extHostFileSystemInfo=O,this._uriTransformerService=U,this._requestIdProvider=new k.Counter,this._barrier=new t.Barrier,this._proxy=L.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(a.MainContext.MainThreadMessageService);const F=B.workspace;this._confirmedWorkspace=F?new R(F.id,F.name,[],!!F.transient,F.configuration?_.URI.revive(F.configuration):null,!!F.isUntitled,V=>C(V,O)):void 0}$initializeWorkspace(L,B){this._trusted=B,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:S.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,O,...z){const U=[];if(Array.isArray(z)&&z.forEach(K=>{_.URI.isUri(K.uri)&&!U.some(de=>d(de.uri,K.uri,this._extHostFileSystemInfo))&&U.push({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[B,O].some(K=>typeof K!="number"||K<0)||O===0&&U.length===0)return!1;const F=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+O>F.length)return!1;const V=F.slice(0);V.splice(B,O,...U.map(K=>({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<V.length;K++){const de=V[K];if(V.some((ee,fe)=>fe!==K&&d(de.uri,ee.uri,this._extHostFileSystemInfo)))return!1}V.forEach((K,de)=>K.index=de);const{added:H,removed:Q}=p(F,V,i,this._extHostFileSystemInfo);if(H.length===0&&Q.length===0)return!1;if(this._proxy){const K=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(K,B,O,U).then(void 0,de=>{this._unconfirmedWorkspace=void 0;const ee={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(f.Severity.Error,(0,w.localize)(0,null,K,de.toString()),ee,[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(L,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,B){let O,z="";if(typeof L=="string"?(O=_.URI.file(L),z=L):typeof L<"u"&&(O=L,z=L.fsPath),!O)return z;const U=this.getWorkspaceFolder(O,!0);if(!U)return z;typeof B>"u"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let F=(0,A.relativePath)(U.uri,O);return B&&U.name&&(F=`${U.name}/${F}`),F}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=R.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:O,removed:z}=R.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:z}))}findFiles(L,B,O,z,U=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let F;if(B===null?F=!1:B&&(typeof B=="string"?F=B:F=B.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:H}=$(s.GlobPattern.from(L));return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(V),(0,E.withUndefinedAsNull)(H),(0,E.withUndefinedAsNull)(F),(0,E.withUndefinedAsNull)(O),U).then(Q=>Array.isArray(Q)?Q.map(K=>_.URI.revive(K)):[])}async findTextInFiles(L,B,O,z,U=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const F=this._requestIdProvider.getNext(),V=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:H,folder:Q}=$(s.GlobPattern.from(B.include)),K=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,de={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:V,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:H,excludePattern:K},ee=!1;if(this._activeSearchCallbacks[F]=fe=>{if(ee)return;const Y=_.URI.revive(fe.resource);fe.results.forEach(ve=>{(0,l.resultIsMatch)(ve)?O({uri:Y,preview:{text:ve.preview.text,matches:(0,c.mapArrayOrNot)(ve.preview.matches,Ee=>new u.Range(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))},ranges:(0,c.mapArrayOrNot)(ve.ranges,Ee=>new u.Range(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))}):O({uri:Y,text:ve.text,lineNumber:ve.lineNumber})})},U.isCancellationRequested)return{};try{const fe=await this._proxy.$startTextSearch(L,(0,E.withUndefinedAsNull)(Q),de,F,U);return delete this._activeSearchCallbacks[F],fe||{}}catch(fe){throw delete this._activeSearchCallbacks[F],fe}}$handleTextSearchResult(L,B){this._activeSearchCallbacks[B]?.(L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(L,B){if(this._editSessionIdentityProviders.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this._editSessionIdentityProviders.set(L,B);const O=this._uriTransformerService.transformOutgoingScheme(L),z=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(z,O),(0,y.toDisposable)(()=>{this._editSessionIdentityProviders.delete(L),this._proxy.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(L,B){this._logService.info("Getting edit session identifier for workspaceFolder",L);const O=await this.resolveWorkspaceFolder(_.URI.revive(L));if(!O){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const z=this._editSessionIdentityProviders.get(O.uri.scheme);if(this._logService.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!z),!z)return;const U=await z.provideEditSessionIdentity(O,B);if(this._logService.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(L,B,O,z){this._logService.info("Getting edit session identifier for workspaceFolder",L);const U=await this.resolveWorkspaceFolder(_.URI.revive(L));if(!U){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const F=this._editSessionIdentityProviders.get(U.uri.scheme);if(this._logService.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!F),!F)return;const V=await F.provideEditSessionIdentityMatch?.(B,O,z);if(this._logService.info("Provider returned edit session identifier match result: ",V),!!V)return V}};M=Ve([He(0,b.IExtHostRpcService),He(1,r.IExtHostInitDataService),He(2,m.IExtHostFileSystemInfo),He(3,g.ILogService),He(4,o.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function $(x){let L,B;return x&&(typeof x=="string"?L=x:(L=x.pattern,B=_.URI.revive(x.baseUri))),{includePattern:L,folder:B}}}),define(De[34],Ie([1,0,24,4,33,5,7,199,126,11,18,3,16,13,2]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(u,o){if(o){const l=o.split(".");let a=u;for(let d=0;a&&d<l.length;d++)a=a[l[d]];return a}}function g(u){return u instanceof w.URI}function f(u){return u&&u.uri instanceof w.URI&&u.languageId&&typeof u.languageId=="string"}function v(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function m(u){return u&&u.uri instanceof w.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function r(u){if(g(u))return{resource:u};if(f(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(v(u))return{overrideIdentifier:u.languageId};if(m(u))return{resource:u.uri};if(u===null)return{resource:null}}let b=class{constructor(o,l,a){this._proxy=o.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=a,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new s(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,l){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(o,l))}};b=Ve([He(0,E.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,_.ILogService)],b),e.ExtHostConfiguration=b;class s{constructor(o,l,a,d){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=d,this._extHostWorkspace=l,this._configuration=T.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,l){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,a))}getConfiguration(o,l,a){const d=r(l)||{},n=this._toReadonlyValue(o?h(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,d,a?.identifier);function i(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(C){return typeof h(n,C)<"u"},get:(C,R)=>{this._validateConfigurationAccess(o?`${o}.${C}`:C,d,a?.identifier);let M=h(n,C);if(typeof M>"u")M=R;else{let $;const x=(L,B)=>{let O;const z=()=>{$=$||(0,c.deepClone)(n),O=O||h($,B)};return(0,k.isObject)(L)?new Proxy(L,{get:(U,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return z(),()=>O;if($)return O=O||h($,B),O[F];const V=U[F];return typeof F=="string"?x(V,`${B}.${F}`):V},set:(U,F,V)=>(z(),O&&(O[F]=V),!0),deleteProperty:(U,F)=>(z(),O&&delete O[F],!0),defineProperty:(U,F,V)=>(z(),O&&Object.defineProperty(O,F,V),!0)}):L};M=x(M,C)}return M},update:(C,R,M,$)=>{C=o?`${o}.${C}`:C;const x=i(M);return R!==void 0?this._proxy.$updateConfigurationOption(x,C,R,d,$):this._proxy.$removeConfigurationOption(x,C,d,$)},inspect:C=>{C=o?`${o}.${C}`:C;const R=this._configuration.inspect(C,d,this._extHostWorkspace.workspace);if(R)return{key:C,defaultValue:(0,c.deepClone)(R.policy?.value??R.default?.value),globalValue:(0,c.deepClone)(R.user?.value??R.application?.value),workspaceValue:(0,c.deepClone)(R.workspace?.value),workspaceFolderValue:(0,c.deepClone)(R.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(R.default?.override),globalLanguageValue:(0,c.deepClone)(R.user?.override??R.application?.override),workspaceLanguageValue:(0,c.deepClone)(R.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(R.workspaceFolder?.override),languageIds:(0,c.deepClone)(R.overrideIdentifiers)}}};return typeof n=="object"&&(0,c.mixin)(p,n,!1),Object.freeze(p)}_toReadonlyValue(o){const l=a=>(0,k.isObject)(a)?new Proxy(a,{get:(d,n)=>l(d[n]),set:(d,n,i)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(d,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(d,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return l(o)}_validateConfigurationAccess(o,l,a){const d=S.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),n=a?`[${a.value}] `:"";if(d===4){typeof l?.resource>"u"&&this._logService.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){l?.resource&&this._logService.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,l){const a=new T.ConfigurationChangeEvent(o,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,n)=>a.affectsConfiguration(d,r(n))})}_toMap(o){return o.reduce((l,a)=>(l.set(a[0],a[1]),l),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c},Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[73],Ie([1,0,2,18,4,5,7,33,58,34,21,40,16,25,3,14,12,13,68,238,10]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m,r){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(B){function O(U){if(U!=null)return U}B.from=O;function z(U){if(U!=null)return U}B.to=z})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(B){function O(U){if(U!=null)return U}B.from=O;function z(U){if(U!=null)return U}B.to=z})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(B){function O(U){if(U!=null)return U}B.from=O;function z(U){if(U!=null)return U}B.to=z})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var l;(function(B){function O(F){if(F){const V=F;return V&&!!V.process}else return!1}B.is=O;function z(F){if(F==null)return;const V={process:F.process,args:F.args};return F.options&&(V.options=o.from(F.options)),V}B.from=z;function U(F){if(F!=null)return new y.ProcessExecution(F.process,F.args,F.options)}B.to=U})(l=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(B){function O(U){if(U!=null)return U}B.from=O;function z(U){if(U!=null)return U}B.to=z})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(B){function O(F){if(F){const V=F;return V&&(!!V.commandLine||!!V.command)}else return!1}B.is=O;function z(F){if(F==null)return;const V={};return F.commandLine!==void 0?V.commandLine=F.commandLine:(V.command=F.command,V.args=F.args),F.options&&(V.options=a.from(F.options)),V}B.from=z;function U(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new y.ShellExecution(F.commandLine,F.options):new y.ShellExecution(F.command,F.args?F.args:[],F.options)}B.to=U})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var n;(function(B){function O(F){if(F){const V=F;return V&&V.customExecution==="customExecution"}else return!1}B.is=O;function z(F){return{customExecution:"customExecution"}}B.from=z;function U(F,V){return V.get(F)}B.to=U})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var i;(function(B){function O(z,U){let F;return z.scope!==void 0&&typeof z.scope!="number"?F=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?F=U.workspaceFile:F=m.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:F}}B.from=O})(i=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(B){function O(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}B.from=O})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var C;(function(B){function O(F,V){if(F==null)return[];const H=[];for(const Q of F){const K=z(Q,V);K&&H.push(K)}return H}B.fromMany=O;function z(F,V){if(F==null)return;let H;F.execution instanceof y.ProcessExecution?H=l.from(F.execution):F.execution instanceof y.ShellExecution?H=d.from(F.execution):F.execution&&F.execution instanceof y.CustomExecution&&(H=n.from(F.execution));const Q=s.from(F.definition);let K;return F.scope?typeof F.scope=="number"?K=F.scope:K=F.scope.uri:K=y.TaskScope.Workspace,!Q||!K?void 0:{_id:F._id,definition:Q,name:F.name,source:{extensionId:V.identifier.value,label:F.source,scope:K},execution:H,isBackground:F.isBackground,group:p.from(F.group),presentationOptions:u.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}B.from=z;async function U(F,V,H){if(F==null)return;let Q;l.is(F.execution)?Q=l.to(F.execution):d.is(F.execution)?Q=d.to(F.execution):n.is(F.execution)&&(Q=n.to(F._id,H));const K=s.to(F.definition);let de;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?de=F.source.scope:de=await V.resolveWorkspaceFolder(c.URI.revive(F.source.scope)):de=y.TaskScope.Workspace),!K||!de)return;const ee=new y.Task(K,de,F.name,F.source.label,Q,F.problemMatchers);return F.isBackground!==void 0&&(ee.isBackground=F.isBackground),F.group!==void 0&&(ee.group=y.TaskGroup.from(F.group._id),ee.group&&F.group.isDefault&&(ee.group=new y.TaskGroup(ee.group.id,ee.group.label),F.group.isDefault===!0&&(ee.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ee.presentationOptions=u.to(F.presentationOptions)),F._id&&(ee._id=F._id),F.detail&&(ee.detail=F.detail),ee}B.to=U})(C=e.TaskDTO||(e.TaskDTO={}));var R;(function(B){function O(U){return U}B.from=O;function z(U){if(!!U)return Object.assign(Object.create(null),U)}B.to=z})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class M{constructor(O,z,U){this._id=z,this._task=U,b.set(this,void 0),nt(this,b,O,"f")}get task(){return this._task}terminate(){Ue(this,b,"f").terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}b=new WeakMap;var $;(function(B){function O(z){return{id:z._id,task:void 0}}B.from=O})($=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(O,z,U,F,V,H,Q,K){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=O.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=F,this._configurationService=V,this._terminalService=H,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(O,z,U){if(!U)return new y.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:z,provider:U,extension:O}),this._proxy.$registerTaskProvider(F,z),new y.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(O,z){this._proxy.$registerTaskSystem(O,z)}fetchTasks(O){return this._proxy.$fetchTasks(R.from(O)).then(async z=>{const U=[];for(const F of z){const V=await C.to(F,this._workspaceProvider,this._providedCustomExecutions2);V&&U.push(V)}return U})}get taskExecutions(){const O=[];return this._taskExecutions.forEach(z=>O.push(z)),O}terminateTask(O){if(!(O instanceof M))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(O._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(O,z,U){const F=this._providedCustomExecutions2.get(O.id);F&&(this._activeCustomExecutions2.set(O.id,F),this._terminalService.attachPtyToTerminal(z,await F.callback(U))),this._lastStartedTask=O.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(O)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(O){const z=await this.getTaskExecution(O);this._taskExecutionPromises.delete(O.id),this._taskExecutions.delete(O.id),this.customExecutionComplete(O),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(O){const z=await this.getTaskExecution(O.id);this._onDidTaskProcessStarted.fire({execution:z,processId:O.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(O){const z=await this.getTaskExecution(O.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:O.exitCode})}$provideTasks(O,z){const U=this._handlers.get(O);if(!U)return Promise.reject(new Error("no handler found"));const F=[],V=(0,t.asPromise)(()=>U.provider.provideTasks(A.CancellationToken.None)).then(H=>this.provideTasksInternal(z,F,U,H));return new Promise(H=>{V.then(Q=>{Promise.all(F).then(()=>{H(Q)})})})}async $resolveTask(O,z){const U=this._handlers.get(O);if(!U)return Promise.reject(new Error("no handler found"));if(z.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${U.type}].`);const F=await C.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const V=await U.provider.resolveTask(F,A.CancellationToken.None);if(!V)return;this.checkDeprecation(V,U);const H=C.from(V,U.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(H.execution)&&await this.addCustomExecution(H,V,!0),await this.resolveTaskInternal(H)}nextHandle(){return this._handleCounter++}async addCustomExecution(O,z,U){const F=await this._proxy.$createTaskId(O);!U&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,z.execution)),this._providedCustomExecutions2.set(F,z.execution)}async getTaskExecution(O,z){if(typeof O=="string"){const V=this._taskExecutionPromises.get(O);if(!V)throw new r.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const U=this._taskExecutionPromises.get(O.id);if(U)return U;const F=new Promise((V,H)=>{function Q(K,de,ee){ee?V(new M(K,de.id,ee)):H("Unexpected: Task does not exist.")}z?Q(this,O,z):C.to(O.task,this._workspaceProvider,this._providedCustomExecutions2).then(K=>Q(this,O,K))});return this._taskExecutionPromises.set(O.id,F),F.then(V=>(this._taskExecutions.set(O.id,V),V),V=>Promise.reject(V))}checkDeprecation(O,z){O._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(O){this._activeCustomExecutions2.get(O.id)&&this._activeCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.has(O.id)&&this._lastStartedTask!==O.id&&(this._providedCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.delete(O.id));const U=this._notProvidedCustomExecutions.values();let F=U.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=U.next()}};x=Ve([He(0,E.IExtHostRpcService),He(1,_.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,f.ILogService),He(7,v.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let L=class extends x{constructor(O,z,U,F,V,H,Q,K){super(O,z,U,F,V,H,Q,K),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(O,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const U=C.from(z,O);if(U===void 0)throw new Error("Task is not valid");if(n.is(U.execution))await this.addCustomExecution(U,z,!1);else throw new r.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),z);return this._proxy.$executeTask(U).catch(V=>{throw new Error(V)}),F}provideTasksInternal(O,z,U,F){const V=[];if(F)for(const H of F){this.checkDeprecation(H,U),(!H.definition||!O[H.definition.type])&&this._logService.warn(`The task [${H.source}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=C.from(H,U.extension);Q&&n.is(Q.execution)?(V.push(Q),z.push(this.addCustomExecution(Q,H,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:U.extension}}async resolveTaskInternal(O){if(n.is(O.execution))return O;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(O,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,z,U){}};L=Ve([He(0,E.IExtHostRpcService),He(1,_.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,f.ILogService),He(7,v.IExtHostApiDeprecationService)],L),e.WorkerExtHostTask=L,e.IExtHostTask=(0,w.createDecorator)("IExtHostTask")}),define(De[283],Ie([1,0,9,21,50,37,22,51,30]),function(Z,e,c,t,D,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(E,_,w){this.config=E,this.provider=_,this.sessionToken=w,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=E.filePattern,this.includePattern=E.includePattern&&P.parse(E.includePattern),this.maxResults=E.maxResults||void 0,this.exists=E.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=E.excludePattern&&P.parse(E.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(E=>E.cancel()),this.activeCancellationTokens=new Set}search(E){const _=this.config.folderQueries||[];return new Promise((w,h)=>{const g=f=>{this.resultCount++,E(f)};if(this.isCanceled)return w({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const v=f.toString(),m=c.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,m)||this.matchFile(g,{base:f,basename:m})}),Promise.all(_.map(f=>this.searchInFolder(f,g))).then(f=>{w({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{h(new Error((0,D.toErrorMessage)(f)))})})}async searchInFolder(E,_){const w=new t.CancellationTokenSource,h=this.getSearchOptionsForFolder(E),g=this.initDirectoryTree(),f=new S.QueryGlobTester(this.config,E),v=!f.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(w),m=T.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,w.token),b=m.elapsed(),s=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(u=>{const o=c.posix.relative(E.folder.path,u.path);if(v){const l=c.basename(u.path);this.matchFile(_,{base:E.folder,relativePath:o,basename:l});return}this.addDirectoryEntries(g,E.folder,o,_)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,f,_),{providerTime:b,postProcessTime:s.elapsed()})}finally{w.dispose(),this.activeCancellationTokens.delete(w)}}getSearchOptionsForFolder(E){const _=(0,S.resolvePatternsForProvider)(this.config.includePattern,E.includePattern),w=(0,S.resolvePatternsForProvider)(this.config.excludePattern,E.excludePattern);return{folder:E.folder,excludes:w,includes:_,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}addDirectoryEntries({pathToEntries:E},_,w,h){if(w===this.filePattern){const f=c.basename(this.filePattern);this.matchFile(h,{base:_,relativePath:this.filePattern,basename:f})}function g(f){const v=c.basename(f),m=c.dirname(f);let r=E[m];r||(r=E[m]=[],g(m)),r.push({base:_,relativePath:f,basename:v})}g(w)}matchDirectoryTree({rootEntries:E,pathToEntries:_},w,h){const g=this,f=this.filePattern;function v(m){const r=(0,S.hasSiblingFn)(()=>m.map(b=>b.basename));for(let b=0,s=m.length;b<s;b++){const u=m[b],{relativePath:o,basename:l}=u;if(w.matchesExcludesSync(o,l,f!==l?r:void 0))continue;const a=_[o];if(a)v(a);else{if(o===f)continue;g.matchFile(h,u)}if(g.isLimitHit)break}}v(E)}matchFile(E,_){(!this.includePattern||_.relativePath&&this.includePattern(_.relativePath,_.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||E(_))}}class A{constructor(){this.sessions=new Map}fileSearch(E,_,w,h){const g=this.getSessionTokenSource(E.cacheKey),f=new k(E,_,g&&g.token);let v=0;const m=r=>{v+=r.length,w(r.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(f,A.BATCH_SIZE,m,h).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:r.stats}}))}clearCache(E){this.getSessionTokenSource(E)?.cancel()}getSessionTokenSource(E){if(!!E)return this.sessions.has(E)||this.sessions.set(E,new t.CancellationTokenSource),this.sessions.get(E)}rawMatchToSearchItem(E){return E.relativePath?{resource:y.joinPath(E.base,E.relativePath)}:{resource:E.base}}doSearch(E,_,w,h){h.onCancellationRequested(()=>{E.cancel()});const g=v=>{v&&(f.push(v),_>0&&f.length>=_&&(w(f),f=[]))};let f=[];return E.search(g).then(v=>(f.length&&w(f),v),v=>(f.length&&w(f),Promise.reject(v)))}}e.FileSearchManager=A,A.BATCH_SIZE=512}),define(De[284],Ie([1,0,17,78,37,111,28,14,9,22,8,11,2,161,188,52,13,45,132,282,30]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(p,C,R,M,$){this.configurationService=p,this.workspaceContextService=C,this.editorGroupsService=R,this.logService=M,this.pathService=$}text(p,C,R={}){p=this.getContentPattern(p,R);const M=this.configurationService.getValue(),$=C&&C.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(C?.map(f.toWorkspaceFolder),R),type:2,contentPattern:p,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:M.search.usePCRE2||$||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(p,C){const R=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const M={...p,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(p,C)&&(M.isCaseSensitive=!0),this.isMultiline(p)&&(M.isMultiline=!0),M}file(p,C={}){return{...this.commonQuery(p,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}handleIncludeExclude(p,C){return p?(p=Array.isArray(p)?p.map(a):a(p),C?this.parseSearchPaths(p):{pattern:u(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],C={}){const R=this.handleIncludeExclude(C.includePattern,C.expandPatterns),M=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),$=p.length>1,x=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,C,M)):p.map(O=>this.getFolderQueryForRoot(O,C,M,$))).filter(O=>!!O),L={_reason:C._reason,folderQueries:x,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:M.pattern,includePattern:R.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const O=c.coalesce(c.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(V=>V.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const z=O.filter(F=>(0,r.pathIncludedInQuery)(L,F.fsPath)),U=this.commonQueryFromFileList(z);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...L,...U}}const B=C.extraFileResources&&C.extraFileResources.filter(O=>(0,r.pathIncludedInQuery)(L,O.fsPath));return L.extraFileResources=B&&B.length?B:void 0,L}commonQueryFromFileList(p){const C=[],R=new y.ResourceMap,M={};let $=!1;return p.forEach(x=>{if(x.scheme===T.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(x)){const B=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:S.dirname(x.fsPath)});let O=R.get(B);O||($=!0,O={folder:B,includePattern:{}},C.push(O),R.set(B,O));const z=S.relative(B.fsPath,x.fsPath);(0,I.assertIsDefined)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else x.fsPath&&($=!0,M[x.fsPath]=!0)}),{folderQueries:C,includePattern:M,usingSearchPaths:!0,excludePattern:$?void 0:{"**/*":!0}}}isCaseSensitive(p,C){if(C.isSmartCase){if(p.isRegExp){if(A.containsUppercaseCharacter(p.pattern,!0))return!0}else if(A.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,_.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const C=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),M=(Array.isArray(p)?p:o(p)).map(U=>{const F=this.pathService.resolvedUserHome;return F?(0,P.untildify)(U,F.scheme===T.Schemas.file?F.fsPath:F.path):U}),$=t.groupBy(M,U=>C(U)?"searchPaths":"exprSegments"),x=($.exprSegments||[]).map(U=>A.rtrim(U,"/")).map(U=>A.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),l(U))),L={},B=this.expandSearchPathPatterns($.searchPaths||[]);B&&B.length&&(L.searchPaths=B);const O=c.flatten(x),z=u(...O);return z&&(L.pattern=z),L}getExcludesForFolder(p,C){return C.disregardExcludeSettings?void 0:(0,r.getExcludes)(p,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const C=c.flatten(p.map(M=>{let{pathPortion:$,globPortion:x}=s(M);x&&(x=d(x));const L=this.expandOneSearchPath($);return c.flatten(L.map(B=>this.resolveOneSearchPathPattern(B,x)))})),R=new Map;return C.forEach(M=>{const $=M.searchPath.toString(),x=R.get($);x?M.pattern&&(x.pattern=x.pattern||{},x.pattern[M.pattern]=!0):R.set($,{searchPath:M.searchPath,pattern:M.pattern?u(M.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(p){if(S.isAbsolute(p)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==T.Schemas.file?[{searchPath:C[0].uri.with({path:p})}]:[{searchPath:E.URI.file(S.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=a(p),p.startsWith("../")||p===".."){const M=S.posix.resolve(C.path,p);return[{searchPath:C.with({path:M})}]}const R=d(p);return[{searchPath:C,pattern:R}]}else{if(p==="./"||p===".\\")return[];{const C=p.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map($=>{const x=C.match(new RegExp(`^${A.escapeRegExpCharacters($.name)}(?:/(.*)|$)`));return x?{match:x,folder:$}:null}).filter(I.isDefined);if(M.length)return M.map($=>{const x=$.match[1];return{searchPath:$.folder.uri,pattern:x&&d(x)}});{const $=p.match(/\.[\/\\](.+)[\/\\]?/),x=$?$[1]:p,L=w.localize(0,null,x);throw new Error(L)}}}}resolveOneSearchPathPattern(p,C){const R=p.pattern&&C?`${p.pattern}/${C}`:p.pattern||C,M=[{searchPath:p.searchPath,pattern:R}];return R&&!R.endsWith("**")&&M.push({searchPath:p.searchPath,pattern:R+"/**"}),M}getFolderQueryForSearchPath(p,C,R){const M=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(p.searchPath),C,R,!1);return M?{...M,includePattern:p.pattern}:null}getFolderQueryForRoot(p,C,R,M){let $;const x=E.URI.isUri(p)?p:p.uri;if(R.searchPaths){const U=R.searchPaths.filter(F=>(0,k.isEqual)(F.searchPath,x))[0];if(U&&!U.pattern)return null;U&&($=U.pattern)}const L=this.configurationService.getValue({resource:x}),O={...this.getExcludesForFolder(L,C)||{},...$||{}},z=E.URI.isUri(p)?(0,k.basename)(p):p.name;return{folder:x,folderName:M?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!L.search.followSymlinks}}};b=Ve([He(0,h.IConfigurationService),He(1,f.IWorkspaceContextService),He(2,v.IEditorGroupsService),He(3,g.ILogService),He(4,m.IPathService)],b),e.QueryBuilder=b;function s(i){const p=i.match(/[\*\{\}\(\)\[\]\?]/);if(p){const C=p.index,R=i.substr(0,C).match(/[/|\\][^/\\]*$/);if(R){let M=i.substr(0,R.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:i.substr((R.index||0)+1)}}}return{pathPortion:i}}function u(...i){return i.length?i.reduce((p,C)=>(p[C]=!0,p),Object.create(null)):void 0}function o(i){return D.splitGlobAware(i,",").map(p=>p.trim()).filter(p=>!!p.length)}function l(i){return[`**/${i}/**`,`**/${i}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function a(i){return i.replace(/\\/g,"/")}function d(i){return a(i).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(i,p){i=c.distinct(i,M=>M.toString());const C=[],R=p.getWorkspace();return i&&i.forEach(M=>{let $;if(p.getWorkbenchState()===2)$=(0,k.relativePath)(R.folders[0].uri,M),$&&$!=="."&&($="./"+$);else{const x=p.getWorkspaceFolder(M);if(x){const L=x.name;if(R.folders.filter(O=>O.name===L).length===1){const O=(0,k.relativePath)(x.uri,M);O===""?$=`./${x.name}`:$=`./${x.name}/${O}`}else $=M.fsPath}}$&&C.push($)}),C}e.resolveResourcesForSearchIncludes=n}),define(De[285],Ie([1,0,22,2,21,10,3,284,30,45]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function I(h,g){const f=g.activationEvents;if(!f)return Promise.resolve(void 0);const v=[],m=[];for(const l of f)if(/^workspaceContains:/.test(l)){const a=l.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||h.forceUsingSearch?m.push(a):v.push(a)}if(v.length===0&&m.length===0)return Promise.resolve(void 0);let r;const b=new Promise((l,a)=>{r=l}),s=l=>r({activationEvent:l}),u=Promise.all(v.map(l=>E(h,l,s))).then(()=>{}),o=_(h,g.identifier,m,s);return Promise.all([u,o]).then(()=>{r(void 0)}),b}e.checkActivateWorkspaceContainsExtension=I;async function E(h,g,f){for(const v of h.folders)if(await h.exists(c.joinPath(t.URI.revive(v),g))){f(`workspaceContains:${g}`);return}}async function _(h,g,f,v){if(f.length===0)return Promise.resolve(void 0);const m=new D.CancellationTokenSource,r=h.checkExists(h.folders,f,m.token),b=setTimeout(async()=>{m.cancel(),h.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},A);let s=!1;try{s=await r}catch(u){P.isCancellationError(u)||P.onUnexpectedError(u)}m.dispose(),clearTimeout(b),s&&v(`workspaceContains:${f.join(",")}`)}function w(h,g,f,v){const m=h.get(y.IInstantiationService),r=h.get(S.ISearchService),s=m.createInstance(T.QueryBuilder).file(g.map(u=>(0,k.toWorkspaceFolder)(t.URI.revive(u))),{_reason:"checkExists",includePattern:f,exists:!0});return r.fileSearch(s,v).then(u=>!!u.limitHit,u=>P.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=w});var nt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,c):D?D.value=c:e.set(Z,c),c},Ue=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[41],Ie([1,0,172,9,74,22,18,6,64,2,13,5,34,228,96,33,27,226,10,26,23,209,7,127,3,25,70,16,85,54,40,4,285,95,211,14,94]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m,r,b,s,u,o,l,a,d,n,i,p,C,R,M,$,x,L){"use strict";var B,O,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let U=class On extends T.Disposable{constructor(ee,fe,Y,ve,Ee,ke,Re,ze,ie,ce,me){super(),this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=fe,this._extHostContext=Y,this._initData=Re,this._extHostWorkspace=ve,this._extHostConfiguration=Ee,this._logService=ke,this._extHostTunnelService=ie,this._extHostTerminalService=ce,this._extHostLocalizationService=me,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new f.ExtensionDescriptionRegistry(this._initData.allExtensions);const J=(0,g.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry(H(this._globalRegistry,J)),this._storage=new w.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=ze,this._instaService=ee.createChild(new n.ServiceCollection([w.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));let ae=[],ne=[];this._initData.remote.isRemote&&(ae=this._initData.allExtensions.filter(N=>!N.main&&!N.browser).map(N=>N.identifier),ne=this._initData.allExtensions.filter(N=>!J.has(m.ExtensionIdentifier.toKey(N.identifier.value))).filter(N=>(N.main||N.browser)&&N.api==="none").map(N=>N.identifier));const se=(0,g.extensionIdentifiersArrayToSet)(ne);this._activator=this._register(new _.ExtensionsActivator(this._myRegistry,ae,ne,{onExtensionActivationError:(N,j,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(N,v.transformErrorForSerialization(j),G)},actualActivateExtension:async(N,j)=>{if(se.has(m.ExtensionIdentifier.toKey(N)))return await this._mainThreadExtensionsProxy.$activateExtension(N,j),new _.HostExtension;const G=this._myRegistry.getExtensionDescription(N);return this._activateExtension(G,j)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ee){v.onUnexpectedError(ee)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ee=[];try{ee=this._myRegistry.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this._deactivate(Ee))}catch{}await Promise.all(ee)}terminate(ee,fe=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ee}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(ve=>{this._logService.error(ve)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${fe}`):this._logService.info(`Extension host exiting with code ${fe}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(fe)})}isActivated(ee){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ee):!1}async getExtension(ee){const fe=await this._mainThreadExtensionsProxy.$getExtension(ee);let Y;if(fe?.browserNlsBundleUris){Y={};for(const ve of Object.keys(fe.browserNlsBundleUris))Y[ve]=k.URI.revive(fe.browserNlsBundleUris[ve])}return fe&&{...fe,identifier:new m.ExtensionIdentifier(fe.identifier.value),extensionLocation:k.URI.revive(fe.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(ee,fe){return this._activator.activateByEvent(ee,fe)}_activateById(ee,fe){return this._activator.activateById(ee,fe)}activateByIdWithErrors(ee,fe){return this._activateById(ee,fe).then(()=>{const Y=this._activator.getActivatedExtension(ee);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ee=>this._myRegistry)}getExtensionExports(ee){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ee).exports:null}async _realPathExtensionUri(ee){if(ee.scheme!==x.Schemas.file)return ee;const fe=await this._hostUtils.realpath(ee.fsPath);return k.URI.file(fe)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ee=>new K(ee))),this._extensionPathIndex}async _createExtensionPathIndex(ee){const fe=S.TernarySearchTree.forUris(Y=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(ee.map(async Y=>{if(this._getEntryPoint(Y)){const ve=await this._realPathExtensionUri(Y.extensionLocation);fe.set(ve,Y)}})),fe}_deactivate(ee){let fe=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ee))return fe;const Y=this._activator.getActivatedExtension(ee);if(!Y)return fe;try{typeof Y.module.deactivate=="function"&&(fe=Promise.resolve(Y.module.deactivate()).then(void 0,ve=>(this._logService.error(ve),Promise.resolve(void 0))))}catch(ve){this._logService.error(`An error occurred when deactivating the extension '${ee.value}':`),this._logService.error(ve)}try{(0,T.dispose)(Y.subscriptions)}catch(ve){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this._logService.error(ve)}return fe}async _activateExtension(ee,fe){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier),this._doActivateExtension(ee,fe).then(Y=>{const ve=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ee.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,fe),this._logExtensionActivationTimes(ee,fe,"success",ve),Y},Y=>{throw this._logExtensionActivationTimes(ee,fe,"failure"),Y})}_logExtensionActivationTimes(ee,fe,Y,ve){const Ee=F(ee,fe);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Ee,...ve||{},outcome:Y})}_doActivateExtension(ee,fe){const Y=F(ee,fe);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const ve=this._getEntryPoint(ee);if(!ve)return Promise.resolve(new _.EmptyExtension(_.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${fe.startup}, activationEvent: '${fe.activationEvent}'${ee.identifier.value!==fe.extensionId.value?`, root cause: ${fe.extensionId.value}`:""}`),this._logService.flush();const Ee=new _.ExtensionActivationTimesBuilder(fe.startup);return Promise.all([this._loadCommonJSModule(ee,(0,P.joinPath)(ee.extensionLocation,ve),Ee),this._loadExtensionContext(ee)]).then(ke=>(D.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),On._callActivate(this._logService,ee.identifier,ke[0],ke[1],Ee))).then(ke=>(D.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),ke))}_loadExtensionContext(ee){const fe=new b.ExtensionGlobalMemento(ee,this._storage),Y=new b.ExtensionMemento(ee.identifier.value,!1,this._storage),ve=new $.ExtensionSecrets(ee,this._secretState),Ee=ee.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,ke=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([fe.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let ze,ie;const ce=(0,g.isProposedApiEnabled)(ee,"ipc")?this._initData.messagePorts?.get(m.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:fe,workspaceState:Y,secrets:ve,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(me){return t.join(ee.extensionLocation.fsPath,me)},get storagePath(){return Re._storagePath.workspaceValue(ee)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(ee).fsPath},get logPath(){return t.join(Re._initData.logsLocation.fsPath,ee.identifier.value)},get logUri(){return k.URI.joinPath(Re._initData.logsLocation,ee.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(ee)},get globalStorageUri(){return Re._storagePath.globalValue(ee)},get extensionMode(){return Ee},get extension(){return ze===void 0&&(ze=new V(Re,ee.identifier,ee,ke,!1)),ze},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(ee,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!ie){if(!ce)return;const me=C.Event.buffer(C.Event.fromDOMEventEmitter(ce,"message",J=>J.data));ce.start(),ie={onDidReceiveMessage:me,postMessage:ce.postMessage.bind(ce)}}return ie}})})}static _callActivate(ee,fe,Y,ve,Ee){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(ee,fe,Y,ve,Ee).then(ke=>new _.ActivatedExtension(!1,null,Ee.build(),Y,ke,ve.subscriptions))}static _callActivateOptional(ee,fe,Y,ve,Ee){if(typeof Y.activate=="function")try{Ee.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${fe.value}`);const ke=typeof global=="object"?global:self,Re=Y.activate.apply(ke,[ve]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(Re).then(ze=>(Ee.activateResolveStop(),ze))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(Y)}_activateOneStartupFinished(ee,fe){this._activateById(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:fe}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const ee of this._myRegistry.getAllExtensionDescriptions())if(ee.activationEvents)for(const fe of ee.activationEvents)fe==="onStartupFinished"&&this._activateOneStartupFinished(ee,fe)}_handleEagerExtensions(){const ee=this._activateByEvent("*",!0).then(void 0,Ee=>{this._logService.error(Ee)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Ee=>this._handleWorkspaceContainsEagerExtensions(Ee.added)));const fe=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(fe),ve=Promise.all([ee,Y]).then(()=>{});return Promise.race([ve,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ve}_handleWorkspaceContainsEagerExtensions(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(fe=>this._handleWorkspaceContainsEagerExtension(ee,fe))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ee,fe){if(this.isActivated(fe.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ve={logService:this._logService,folders:ee.map(ke=>ke.uri),forceUsingSearch:Y,exists:ke=>this._hostUtils.exists(ke.fsPath),checkExists:(ke,Re,ze)=>this._mainThreadWorkspaceProxy.$checkExists(ke,Re,ze)},Ee=await(0,R.checkActivateWorkspaceContainsExtension)(ve,fe);if(!!Ee)return this._activateById(fe.identifier,{startup:!0,extensionId:fe.identifier,activationEvent:Ee.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ee){throw console.error(ee),ee}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:fe}=this._initData.environment;if(!ee||!fe)throw new Error(c.localize(0,null));const Y=await this._loadCommonJSModule(null,fe,new _.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(c.localize(1,null,fe.toString()));return new Promise((ve,Ee)=>{const ke=(ie,ce)=>{ie?Ee(ie):ve(typeof ce=="number"&&ce>0?1:0)},Re=(0,P.originalFSPath)(fe),ze=Y.run(Re,ke);ze&&ze.then&&ze.then(()=>{ve(0)}).catch(ie=>{Ee(ie instanceof Error&&ie.stack?ie.stack:String(ie))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,fe){return this._resolvers[ee]=fe,(0,T.toDisposable)(()=>{delete this._resolvers[ee]})}async _activateAndGetResolver(ee){const fe=ee.indexOf("+");if(fe===-1)throw new Error("Not an authority that can be resolved!");const Y=ee.substr(0,fe);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(ee,fe){this._logService.info(`$resolveAuthority invoked for authority (${Q(ee)})`);const{authorityPrefix:Y,resolver:ve}=await this._activateAndGetResolver(ee);if(!ve)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ve)),D.mark(`code/extHost/willResolveAuthority/${Y}`);const Ee=await ve.resolve(ee,{resolveAttempt:fe});D.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const ke={authority:ee,host:Ee.host,port:Ee.port,connectionToken:Ee.connectionToken},Re={extensionHostEnv:Ee.extensionHostEnv,isTrusted:Ee.isTrusted,authenticationSession:Ee.authenticationSessionForInitializingExtensions?{id:Ee.authenticationSessionForInitializingExtensions.id,providerId:Ee.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:Re,tunnelInformation:{environmentTunnels:Ee.environmentTunnels,features:Ee.tunnelFeatures}}}}catch(Ee){if(D.mark(`code/extHost/didResolveAuthorityError/${Y}`),Ee instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:Ee._code,message:Ee._message,detail:Ee._detail}};throw Ee}}async $getCanonicalURI(ee,fe){this._logService.info(`$getCanonicalURI invoked for authority (${Q(ee)})`);const{resolver:Y}=await this._activateAndGetResolver(ee);if(!Y)return null;const ve=k.URI.revive(fe);if(typeof Y.getCanonicalURI>"u")return ve;const Ee=await(0,y.asPromise)(()=>Y.getCanonicalURI(ve));return Ee||ve}static _applyExtensionsDelta(ee,fe,Y){const ve=new f.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());ve.deltaExtensions(Y.toAdd,Y.toRemove);const Ee=(0,g.extensionIdentifiersArrayToSet)(fe.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Y.myToRemove)Ee.delete(m.ExtensionIdentifier.toKey(Re));for(const Re of Y.myToAdd)Ee.add(m.ExtensionIdentifier.toKey(Re));const ke=H(ve,Ee);return{globalRegistry:ve,myExtensions:ke}}$startExtensionHost(ee){ee.toAdd.forEach(ve=>ve.extensionLocation=k.URI.revive(ve.extensionLocation));const{globalRegistry:fe,myExtensions:Y}=On._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee);return this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(ee,fe){return fe===1?this._activateByEvent(ee,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(ee,!1))}async $activate(ee,fe){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ee)?(await this._activateById(ee,fe),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(ke=>ke.extensionLocation=k.URI.revive(ke.extensionLocation));const{globalRegistry:fe,myExtensions:Y}=On._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee),ve=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(ve),this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const fe=r.VSBuffer.alloc(ee),Y=Math.random()%256;for(let ve=0;ve<ee;ve++)fe.writeUInt8(Y,ve);return fe}async $updateRemoteConnectionData(ee){this._remoteConnectionData=ee,this._onDidChangeRemoteConnectionData.fire()}};U=Ve([He(0,o.IInstantiationService),He(1,e.IHostUtils),He(2,d.IExtHostRpcService),He(3,h.IExtHostWorkspace),He(4,E.IExtHostConfiguration),He(5,A.ILogService),He(6,l.IExtHostInitDataService),He(7,a.IExtensionStoragePaths),He(8,i.IExtHostTunnelService),He(9,p.IExtHostTerminalService),He(10,L.IExtHostLocalizationService)],U),e.AbstractExtHostExtensionService=U;function F(de,ee){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class V{constructor(ee,fe,Y,ve,Ee){B.set(this,void 0),O.set(this,void 0),z.set(this,void 0),nt(this,B,ee,"f"),nt(this,O,fe,"f"),nt(this,z,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=ve,this.isFromDifferentExtensionHost=Ee}get isActive(){return Ue(this,B,"f").isActivated(Ue(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,B,"f").getExtensionExports(Ue(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,B,"f").activateByIdWithErrors(Ue(this,z,"f"),{startup:!1,extensionId:Ue(this,O,"f"),activationEvent:"api"}),this.exports}}e.Extension=V,B=new WeakMap,O=new WeakMap,z=new WeakMap;function H(de,ee){return de.getAllExtensionDescriptions().filter(fe=>ee.has(m.ExtensionIdentifier.toKey(fe.identifier)))}function Q(de){const ee=de.indexOf("+");return ee===-1?de:de.substring(0,ee)}class K{constructor(ee){this._searchTree=ee}setSearchTree(ee){this._searchTree=ee}findSubstr(ee){return this._searchTree.findSubstr(ee)}forEach(ee){return this._searchTree.forEach(ee)}}e.ExtensionPaths=K}),define(De[286],Ie([1,0,74,2,5,34,27,26,16,25,3,41,36,13,8]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(b,s,u,o,l,a,d){this._apiFactory=b,this._extensionRegistry=s,this._instaService=u,this._extHostConfiguration=o,this._extHostExtensionService=l,this._initData=a,this._logService=d,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const b=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,s,this._extensionRegistry,b,this._logService)),this.register(this._instaService.createInstance(v,s)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,s,this._initData.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const s of b.nodeModuleName)this._factories.set(s,b);else this._factories.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this._alternatives.push(s=>b.alternativeModuleName(s))}};h=Ve([He(2,A.IInstantiationService),He(3,P.IExtHostConfiguration),He(4,I.IExtHostExtensionService),He(5,k.IExtHostInitDataService),He(6,_.ILogService)],h),e.RequireInterceptor=h;let g=class Jn{constructor(b){if(b.environment.appRoot&&Jn.aliased.size){const s=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(b.environment.appRoot.fsPath)),u="[a-z0-9_.-]",o=`@${u}+\\/${u}+|${u}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${l}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(b){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(b));if(!s)return;const[,u,o,l]=s,a=Jn.aliased.get(o);if(a!==void 0)return console.warn(`${o} as been renamed to ${a}, please update your imports`),u+a+l}forceForwardSlashes(b){return b.replace(/\\/g,"/")}};g.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=Ve([He(0,k.IExtHostInitDataService)],g);class f{constructor(b,s,u,o,l){this._apiFactory=b,this._extensionPaths=s,this._extensionRegistry=u,this._configProvider=o,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(b,s){const u=this._extensionPaths.findSubstr(s);if(u){let o=this._extApiImpl.get(T.ExtensionIdentifier.toKey(u.identifier));return o||(o=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(u.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((l,a)=>o+=`	${a} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(b,s,u){this._extensionPaths=b,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(D.MainContext.MainThreadTelemetry);const{environment:o}=u,l=s.getProxy(D.MainContext.MainThreadKeytar);if(o.appRoot){let a=o.appRoot.fsPath;E.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,d)=>l.$getPassword(a,d),setPassword:(a,d,n)=>l.$setPassword(a,d,n),deletePassword:(a,d)=>l.$deletePassword(a,d),findPassword:a=>l.$findPassword(a),findCredentials(a){return l.$findCredentials(a)}}}load(b,s){const u=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(b){const s=b.length;if(s<=7||!this.alternativeNames)return;const u=s-7;if((b.charAt(u)==="/"||b.charAt(u)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.alternativeNames.has(b)))return"keytar"}};v=Ve([He(1,S.IExtHostRpcService),He(2,k.IExtHostInitDataService)],v);let m=class{constructor(b,s,u){this._extensionPaths=b,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(D.MainContext.MainThreadTelemetry);const o=u.getProxy(D.MainContext.MainThreadWindow);this._impl=(l,a)=>{const d=t.URI.parse(l);return a?this.callOriginal(l,a):d.scheme==="http"||d.scheme==="https"?o.$openUri(d,l,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this._appUriScheme?o.$openUri(d,l,{}):this.callOriginal(l,a)}}load(b,s,u){const o=this._extensionPaths.findSubstr(s);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=u(b),this._impl}callOriginal(b,s){return this.sendNoForwardTelemetry(),this._original(b,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=Ve([He(2,S.IExtHostRpcService)],m)}),define(De[47],Ie([1,0,79,6,9,36,3,58,59,41,7,33,223,34]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class w extends E.AbstractVariableResolverService{constructor(f,v,m,r,b,s,u){function o(){if(m){const l=m.activeEditor();if(l)return l.document.uri;const a=r.tabGroups.all.find(d=>d.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof A.TextDiffTabInput||a.input instanceof A.NotebookDiffEditorTabInput)return a.input.modified;if(a.input instanceof A.TextTabInput||a.input instanceof A.NotebookEditorTabInput||a.input instanceof A.CustomEditorTabInput)return a.input.uri}}}super({getFolderUri:l=>{const a=s.folders.filter(d=>d.name===l);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(l,a)=>b.getConfiguration(void 0,l).get(a),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=o();if(l)return D.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const l=o();if(l){const a=v.getWorkspaceFolder(l);if(a)return D.normalize(a.uri.fsPath)}}},getSelectedText:()=>{if(m){const l=m.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(m){const l=m.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>f.getExtension(l)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(P.env))}}let h=class extends t.Disposable{constructor(f,v,m,r,b){super(),this.extensionService=f,this.workspaceService=v,this.editorService=m,this.configurationService=r,this.editorTabs=b,this._resolver=new c.Lazy(async()=>{const s=await this.configurationService.getConfigProvider(),o={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async l=>{o.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new w(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,s,o,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};h=Ve([He(0,k.IExtHostExtensionService),He(1,I.IExtHostWorkspace),He(2,T.IExtHostDocumentsAndEditors),He(3,_.IExtHostConfiguration),He(4,S.IExtHostEditorTabs)],h),e.ExtHostVariableResolverProviderService=h}),define(De[75],Ie([1,0,18,4,11,2,3,5,59,41,16,7,33,130,216,34,47]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(o,l,a,d,n,i){this._workspaceService=l,this._extensionService=a,this._configurationService=d,this._editorTabs=n,this._variableResolver=i,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=o.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new m(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(C=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}asDebugSourceUri(o,l){const a=o;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let d=`debug:${encodeURIComponent(a.path||"")}`,n="?";return l&&(d+=`${n}session=${encodeURIComponent(l.id)}`,n="&"),d+=`${n}ref=${a.sourceReference}`,P.URI.parse(d)}else{if(a.path)return P.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const l=[];for(const a of o.getAllExtensionDescriptions())if(a.contributes){const d=a.contributes.debuggers;if(d&&d.length>0)for(const n of d)(0,w.isDebuggerMainContribution)(n)&&l.push(n.type)}this._debugServiceProxy.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(l=>o.push(l)),o}addBreakpoints(o){this.startBreakpoints();const l=o.filter(n=>{const i=n.id;return this._breakpoints.has(i)?!1:(this._breakpoints.set(i,n),!0)});this.fireBreakpointChanges(l,[],[]);const a=[],d=new Map;for(const n of l)if(n instanceof I.SourceBreakpoint){let i=d.get(n.location.uri.toString());i||(i={type:"sourceMulti",uri:n.location.uri,lines:[]},d.set(n.location.uri.toString(),i),a.push(i)),i.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof I.FunctionBreakpoint&&a.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this._debugServiceProxy.$registerBreakpoints(a)}removeBreakpoints(o){this.startBreakpoints();const l=o.filter(i=>this._breakpoints.delete(i.id));this.fireBreakpointChanges([],l,[]);const a=l.filter(i=>i instanceof I.SourceBreakpoint).map(i=>i.id),d=l.filter(i=>i instanceof I.FunctionBreakpoint).map(i=>i.id),n=l.filter(i=>i instanceof I.DataBreakpoint).map(i=>i.id);return this._debugServiceProxy.$unregisterBreakpoints(a,d,n)}startDebugging(o,l,a){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,l,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,suppressSaveBeforeStart:a.suppressSaveBeforeStart,suppressDebugStatusbar:a.suppressDebugStatusbar??a.debugUI?.simple,suppressDebugToolbar:a.suppressDebugToolbar??a.debugUI?.simple,suppressDebugView:a.suppressDebugView??a.debugUI?.simple})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,l,a){if(!l)return new I.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:d,provider:l}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,a,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,d),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(n=>n.provider!==l),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(o,l,a){if(!a)return new I.Disposable(()=>{});if(!this.definesDebugType(o,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.getAdapterDescriptorFactoryByType(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:l,handle:d,factory:a}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(l,d),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(n=>n.factory!==a),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(o,l){if(!l)return new I.Disposable(()=>{});const a=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:a,factory:l}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==l)})}async $runInTerminal(o,l){return Promise.resolve(void 0)}async $substituteVariables(o,l){let a;const d=await this.getFolder(o);return d&&(a={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(a,l)}createDebugAdapter(o,l){if(o.type==="implementation")return new b(o.implementation)}createSignService(){}async $startDASession(o,l){const a=this,d=await this.getSession(l);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const i=this.convertToDto(n),p=this.createDebugAdapter(i,d);if(!p)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const C=p;return this._debugAdapters.set(o,C),this.getDebugAdapterTrackers(d).then(R=>(R&&this._debugAdaptersTrackers.set(o,R),C.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const $=M,x={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign($.arguments.value);x.body={signature:L},C.sendResponse(x)}else throw new Error("no signer")}catch(L){x.success=!1,x.message=L.message,C.sendResponse(x)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(M),M=(0,w.convertToVSCPaths)(M,!0),a._debugServiceProxy.$acceptDAMessage(o,M)}),C.onError(M=>{R&&R.onError&&R.onError(M),this._debugServiceProxy.$acceptDAError(o,M.name,M.message,M.stack)}),C.onExit(M=>{R&&R.onExit&&R.onExit((0,D.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,D.withNullAsUndefined)(M),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),C.startSession()))})}$sendDAMessage(o,l){l=(0,w.convertToDAPaths)(l,!1);const a=this._debugAdaptersTrackers.get(o);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(l),this._debugAdapters.get(o)?.sendMessage(l)}$stopDASession(o){const l=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),l&&l.onWillStopSession&&l.onWillStopSession();const a=this._debugAdapters.get(o);return this._debugAdapters.delete(o),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const l=[],a=[],d=[];if(o.added)for(const n of o.added){const i=n.id;if(i&&!this._breakpoints.has(i)){let p;if(n.type==="function")p=new I.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")p=new I.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const C=P.URI.revive(n.uri);p=new I.SourceBreakpoint(new I.Location(C,new I.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}p._id=i,this._breakpoints.set(i,p),l.push(p)}}if(o.removed)for(const n of o.removed){const i=this._breakpoints.get(n);i&&(this._breakpoints.delete(n),a.push(i))}if(o.changed){for(const n of o.changed)if(n.id){const i=this._breakpoints.get(n.id);if(i){if(i instanceof I.FunctionBreakpoint&&n.type==="function"){const p=i;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.functionName=n.functionName}else if(i instanceof I.SourceBreakpoint&&n.type==="source"){const p=i;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.location=new I.Location(P.URI.revive(n.uri),new I.Position(n.line,n.character))}d.push(i)}}}this.fireBreakpointChanges(l,a,d)}$provideDebugConfigurations(o,l,a){return(0,c.asPromise)(async()=>{const d=this.getConfigProviderByHandle(o);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.getFolder(l);return d.provideDebugConfigurations(n,a)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(o,l,a,d){return(0,c.asPromise)(async()=>{const n=this.getConfigProviderByHandle(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const i=await this.getFolder(l);return n.resolveDebugConfiguration(i,a,d)})}$resolveDebugConfigurationWithSubstitutedVariables(o,l,a,d){return(0,c.asPromise)(async()=>{const n=this.getConfigProviderByHandle(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const i=await this.getFolder(l);return n.resolveDebugConfigurationWithSubstitutedVariables(i,a,d)})}async $provideDebugAdapter(o,l){const a=this.getAdapterDescriptorFactoryByHandle(o);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(l);return this.getAdapterDescriptor(a,d).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(n)})}async $acceptDebugSessionStarted(o){const l=await this.getSession(o);this._onDidStartDebugSession.fire(l)}async $acceptDebugSessionTerminated(o){const l=await this.getSession(o);l&&(this._onDidTerminateDebugSession.fire(l),this._debugSessions.delete(l.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,l){(await this.getSession(o))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(o,l){const d={session:await this.getSession(o),event:l.event,body:l.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(o){if(o instanceof I.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof I.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const l=this._adapterFactories.filter(a=>a.type===o);if(l.length>0)return l[0].factory}getAdapterDescriptorFactoryByHandle(o){const l=this._adapterFactories.filter(a=>a.handle===o);if(l.length>0)return l[0].factory}getConfigProviderByHandle(o){const l=this._configProviders.filter(a=>a.handle===o);if(l.length>0)return l[0].provider}definesDebugType(o,l){if(o.contributes){const a=o.contributes.debuggers;if(a&&a.length>0){for(const d of a)if(d.label&&d.type&&d.type===l)return!0}}return!1}getDebugAdapterTrackers(o){const a=o.configuration.type,d=this._trackerFactories.filter(n=>n.type===a||n.type==="*").map(n=>(0,c.asPromise)(()=>n.factory.createDebugAdapterTracker(o)).then(i=>i,i=>null));return Promise.race([Promise.all(d).then(n=>{const i=n.filter(p=>!!p);if(i.length>0)return new r(i)}),new Promise((n,i)=>{const p=setTimeout(()=>{clearTimeout(p),i(new Error("timeout"))},1e3)})]).catch(n=>{})}async getAdapterDescriptor(o,l){const a=l.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new I.DebugAdapterServer(a));if(o){const n=await this._extensionService.getExtensionRegistry();return(0,c.asPromise)(()=>o.createDebugAdapterDescriptor(l,this.daExecutableFromPackage(l,n))).then(i=>{if(i)return i})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(l,d))}daExecutableFromPackage(o,l){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,l,a){(o.length>0||l.length>0||a.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:l,changed:a}))}async getSession(o){if(o)if(typeof o=="string"){const l=this._debugSessions.get(o);if(l)return l}else{let l=this._debugSessions.get(o.id);if(!l){const a=await this.getFolder(o.folderUri),d=o.parent?this._debugSessions.get(o.parent):void 0;l=new v(this._debugServiceProxy,o.id,o.type,o.name,a,o.configuration,d),this._debugSessions.set(l.id,l),this._debugServiceProxy.$sessionCached(l.id)}return l}throw new Error("cannot find session")}getFolder(o){if(o){const l=P.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};f=Ve([He(0,A.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,h.IExtHostConfiguration),He(4,S.IExtHostEditorTabs),He(5,g.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class v{constructor(o,l,a,d,n,i,p){this._debugServiceProxy=o,this._id=l,this._type=a,this._name=d,this._workspaceFolder=n,this._configuration=i,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,l){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,l)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=v;class m{constructor(o){this.value=Object.freeze({append(l){o.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=m;class r{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(l=>l.onError?l.onError(o):void 0)}onExit(o,l){this.trackers.forEach(a=>a.onExit?a.onExit(o,l):void 0)}}class b extends _.AbstractDebugAdapter{constructor(o){super(),this.implementation=o,o.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends f{constructor(o,l,a,d,n,i){super(o,l,a,d,n,i)}};s=Ve([He(0,A.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,h.IExtHostConfiguration),He(4,S.IExtHostEditorTabs),He(5,g.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(De[287],Ie([1,0,10,74,2,5,279,13,84,85,25,194,16,55,41,93]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class g{static async installEarlyHandler(m){const r=m.get(T.ILogService),s=m.get(E.IExtHostRpcService).getProxy(P.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(u=>{r.error(u);const o=c.transformErrorForSerialization(u);s.$onUnexpectedError(o)})}static async installFullHandler(m){const r=m.get(T.ILogService),b=m.get(E.IExtHostRpcService),s=m.get(w.IExtHostExtensionService),u=m.get(h.IExtHostTelemetry),o=b.getProxy(P.MainContext.MainThreadExtensionService),l=b.getProxy(P.MainContext.MainThreadErrors),a=await s.getExtensionPathIndex(),d=new WeakMap;Error.prepareStackTrace=(n,i)=>{let p="",C,R;for(const M of i)p+=`
	at ${M.toString()}`,R=M.getFileName(),!C&&R&&(C=a.findSubstr(D.URI.file(R)));return d.set(n,C?.identifier),`${n.name||"Error"}: ${n.message||""}${p}`},c.setUnexpectedErrorHandler(n=>{r.error(n);const i=c.transformErrorForSerialization(n),p=d.get(n);if(!p){l.$onUnexpectedError(i);return}o.$onExtensionRuntimeError(p,i);const C=u.onExtensionError(p,n);r.trace("forwarded error to extension?",C,p)})}}Error.stackTraceLimit=100;class f{constructor(m,r,b,s,u){this._hostUtils=b,this._rpcProtocol=new y.RPCProtocol(m,null,s),r=f._transform(r,this._rpcProtocol);const o=new k.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());o.set(A.IExtHostInitDataService,{_serviceBrand:void 0,...r,messagePorts:u}),o.set(E.IExtHostRpcService,new E.ExtHostRpcService(this._rpcProtocol)),o.set(_.IURITransformerService,new _.URITransformerService(s)),o.set(w.IHostUtils,b);const l=new I.InstantiationService(o,!0);l.invokeFunction(g.installEarlyHandler),this._logService=l.invokeFunction(a=>a.get(T.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",r),this._extensionService=l.invokeFunction(a=>a.get(w.IExtHostExtensionService)),this._extensionService.initialize(),l.invokeFunction(g.installFullHandler)}async asBrowserUri(m){const r=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return D.URI.revive(await r.$asBrowserUri(m))}terminate(m){this._extensionService.terminate(m)}static _transform(m,r){m.allExtensions.forEach(s=>{s.extensionLocation=D.URI.revive(r.transformIncomingURIs(s.extensionLocation));const u={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(o=>u[o]=D.URI.revive(r.transformIncomingURIs(s.browserNlsBundleUris[o]))),s.browserNlsBundleUris=u)}),m.environment.appRoot=D.URI.revive(r.transformIncomingURIs(m.environment.appRoot));const b=m.environment.extensionDevelopmentLocationURI;return b&&(m.environment.extensionDevelopmentLocationURI=b.map(s=>D.URI.revive(r.transformIncomingURIs(s)))),m.environment.extensionTestsLocationURI=D.URI.revive(r.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=D.URI.revive(r.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=D.URI.revive(r.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=D.URI.revive(r.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=D.URI.revive(r.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=D.URI.revive(r.transformIncomingURIs(m.logsLocation)),m.logFile=D.URI.revive(r.transformIncomingURIs(m.logFile)),m.workspace=r.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=f}),define(De[288],Ie([1,0,18,12,178,193,201,75,59,41,16,40,7,47,33,217,219,34]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let v=class extends T.ExtHostDebugServiceBase{constructor(u,o,l,a,d,n,i){super(u,o,l,a,n,i),this._terminalService=d,this._integratedTerminalInstances=new b}createDebugAdapter(u,o){switch(u.type){case"server":return new h.SocketDebugAdapter(u);case"pipeServer":return new h.NamedPipeDebugAdapter(u);case"executable":return new h.ExecutableDebugAdapter(u,o.type)}return super.createDebugAdapter(u,o)}daExecutableFromPackage(u,o){const l=h.ExecutableDebugAdapter.platformAdapterExecutable(o.getAllExtensionDescriptions(),u.type);if(l)return new E.DebugAdapterExecutable(l.command,l.args,l.options)}createSignService(){return new y.SignService}async $runInTerminal(u,o){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const l=await this._configurationService.getConfigProvider(),a=this._terminalService.getDefaultShell(!0),d=this._terminalService.getDefaultShellArgs(!0),n=u.title||D.localize(0,null),i=JSON.stringify({shell:a,shellArgs:d});let p=await this._integratedTerminalInstances.checkout(i,n),C,R=!1;if(p)C=u.cwd;else{const L={shellPath:a,shellArgs:d,cwd:u.cwd,name:n,iconPath:new E.ThemeIcon("debug")};R=!0,p=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(p,i)}p.show(!0);const M=await p.processId;R?await new Promise(L=>setTimeout(L,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?p.sendText("cls"):a.indexOf("bash")>=0?p.sendText("clear"):t.isWindows?p.sendText("cls"):p.sendText("clear"));const $=(0,g.prepareCommand)(a,u.args,!!u.argsCanBeInterpretedByShell,C,u.env);p.sendText($);const x=this.onDidTerminateDebugSession(L=>{L.id===o&&(this._integratedTerminalInstances.free(p),x.dispose())});return M}else if(u.kind==="external")return r(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,o)}};v=Ve([He(0,A.IExtHostRpcService),He(1,w.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,f.IExtHostConfiguration),He(4,I.IExtHostTerminalService),He(5,S.IExtHostEditorTabs),He(6,_.IExtHostVariableResolverProvider)],v),e.ExtHostDebugService=v;let m;function r(s,u){if(!m)if(t.isWindows)m=new P.WindowsExternalTerminalService;else if(t.isMacintosh)m=new P.MacExternalTerminalService;else if(t.isLinux)m=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=u.getConfiguration("terminal");return m.runInTerminal(s.title,s.cwd,s.args,s.env||{},o.external||{})}e.runInExternalTerminal=r;class b{constructor(){this._terminalInstances=new Map}async checkout(u,o){const a=[...this._terminalInstances.entries()].map(([d,n])=>(0,c.createCancelablePromise)(async i=>{if(d.name!==o||n.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await d.processId))return null;const p=Date.now();return n.lastUsedAt+b.minUseDelay>p||i.isCancellationRequested||n.config!==u?null:(n.lastUsedAt=p,d)}));return await(0,c.firstParallel)(a,d=>!!d)}insert(u,o){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:o})}free(u){const o=this._terminalInstances.get(u);o&&(o.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}b.minUseDelay=1e3}),define(De[289],Ie([1,0,9,2,114,33,58,34,45,40,16,25,73,14,13,68,22,83,47]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let m=class extends E.ExtHostTaskBase{constructor(b,s,u,o,l,a,d,n,i){super(b,s,u,o,l,a,d,n),this.workspaceService=u,this.variableResolver=i,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(_.Schemas.file,{scheme:_.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,s){const u=s;if(!s.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const o=E.TaskHandleDTO.from(u,this.workspaceService),l=await this._proxy.$getTaskExecution(o);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.getTaskExecution(l,s);return this._proxy.$executeTask(o).catch(()=>{}),a}else{const o=E.TaskDTO.from(s,b);if(o===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(o.execution)&&await this.addCustomExecution(o,s,!1);const l=await this.getTaskExecution(await this._proxy.$getTaskExecution(o),s);return this._proxy.$executeTask(o).catch(()=>{}),l}}provideTasksInternal(b,s,u,o){const l=[];if(o)for(const a of o){this.checkDeprecation(a,u),(!a.definition||!b[a.definition.type])&&this._logService.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const d=E.TaskDTO.from(a,u.extension);d&&(l.push(d),E.CustomExecutionDTO.is(d.execution)&&s.push(this.addCustomExecution(d,a,!0)))}return{tasks:l,extension:u.extension}}async resolveTaskInternal(b){return b}async getAFolder(b){let s=b&&b.length>0?b[0]:void 0;if(!s){const u=t.URI.file((0,f.homedir)());s=new S.WorkspaceFolder({uri:u,name:g.basename(u),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(b,s){const u=t.URI.revive(b),o={process:void 0,variables:Object.create(null)},l=await this._workspaceProvider.resolveWorkspaceFolder(u),a=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.variableResolver.getResolver(),n=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(a);for(const i of s.variables)o.variables[i]=await d.resolveAsync(n,i);if(s.process!==void 0){let i;if(s.process.path!==void 0){i=s.process.path.split(c.delimiter);for(let p=0;p<i.length;p++)i[p]=await d.resolveAsync(n,i[p])}o.process=await D.win32.findExecutable(await d.resolveAsync(n,s.process.name),s.process.cwd!==void 0?await d.resolveAsync(n,s.process.cwd):void 0,i)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(b,s,u){return D.win32.findExecutable(b,s,u)}};m=Ve([He(0,A.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,T.IExtHostConfiguration),He(5,k.IExtHostTerminalService),He(6,w.ILogService),He(7,h.IExtHostApiDeprecationService),He(8,v.IExtHostVariableResolverProvider)],m),e.ExtHostTask=m}),define(De[290],Ie([1,0,83,47]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class D extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=D}),define(De[141],Ie([1,0,17,18,21,50,14,9,22,2,30]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(v,m,r,b){this.query=v,this.provider=m,this.fileUtils=r,this.processType=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,m){const r=this.query.folderQueries||[],b=new D.CancellationTokenSource;return m.onCancellationRequested(()=>b.cancel()),new Promise((s,u)=>{this.collector=new _(v);let o=!1;const l=(a,d)=>{if(!o&&!this.isLimitHit){const n=this.resultSize(a);h(a)&&typeof this.query.maxResults=="number"&&this.resultCount+n>this.query.maxResults&&(this.isLimitHit=!0,o=!0,b.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const i=this.resultSize(a);this.resultCount+=i,(i>0||!h(a))&&this.collector.add(a,d)}};Promise.all(r.map((a,d)=>this.searchInFolder(a,n=>l(n,d),b.token))).then(a=>{b.dispose(),this.collector.flush();const d=a.some(n=>!!n&&!!n.limitHit);s({limitHit:this.isLimitHit||d,messages:(0,c.flatten)(a.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.processType}})},a=>{b.dispose();const d=(0,P.toErrorMessage)(a);u(new Error(d))})})}resultSize(v){return h(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,m){const r=Array.isArray(v.ranges)?v.ranges:[v.ranges],b=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:r.slice(0,m),preview:{matches:b.slice(0,m),text:v.preview.text},uri:v.uri}}async searchInFolder(v,m,r){const b=new A.QueryGlobTester(this.query,v),s=[],u={report:a=>{if(!this.validateProviderResult(a))return;const d=v.folder.scheme===y.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(S.dirname(a.uri))):void 0,n=S.relativePath(v.folder,a.uri);if(n){const i=b.includedInQuery(n,T.basename(n),d);(0,t.isThenable)(i)?s.push(i.then(p=>{p&&m(a)})):i&&m(a)}}},o=this.getSearchOptionsForFolder(v),l=await this.provider.provideTextSearchResults(E(this.query.contentPattern),o,u,r);return s.length&&await Promise.all(s),l}validateProviderResult(v){if(h(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const m=(0,A.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),r=(0,A.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),b={folder:k.URI.from(v.folder),excludes:r,includes:m,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return b.usePCRE2=this.query.usePCRE2,b}}e.TextSearchManager=I;function E(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class _{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,m=>this.sendItems(m))}add(v,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!S.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(w(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=_;function w(f){return h(f)?{preview:{matches:(0,c.mapArrayOrNot)(f.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:f.preview.text},ranges:(0,c.mapArrayOrNot)(f.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function h(f){return!!f.preview}e.extensionResultIsMatch=h;class g{constructor(v,m){this.maxBatchSize=v,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,m){!v||this.addItemToBatch(v,m)}addItems(v,m){!v||this.addItemsToBatch(v,m)}addItemToBatch(v,m){this.batch.push(v),this.batchSize+=m,this.onUpdate()}addItemsToBatch(v,m){this.batch=this.batch.concat(v),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(De[76],Ie([1,0,6,5,3,283,16,55,13,2,141]),function(Z,e,c,t,D,P,y,T,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let I=class{constructor(h,g,f){this.extHostRpc=h,this._uriTransformer=g,this._logService=f,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,g){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const f=this._handlePool++;return this._textSearchProvider.set(f,g),this._proxy.$registerTextSearchProvider(f,this._transformScheme(h)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(h,g){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const f=this._handlePool++;return this._fileSearchProvider.set(f,g),this._proxy.$registerFileSearchProvider(f,this._transformScheme(h)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(h,g,f,v){const m=E(f),r=this._fileSearchProvider.get(h);if(r)return this._fileSearchManager.fileSearch(m,r,b=>{this._proxy.$handleFileMatch(h,g,b.map(s=>s.resource))},v);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,g,f,v){const m=this._textSearchProvider.get(h);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const r=E(f);return this.createTextSearchManager(r,m).search(s=>this._proxy.$handleTextMatch(h,g,s),v)}$enableExtensionHostSearch(){}createTextSearchManager(h,g){return new A.TextSearchManager(h,g,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};I=Ve([He(0,y.IExtHostRpcService),He(1,T.IURITransformerService),He(2,S.ILogService)],I),e.ExtHostSearch=I;function E(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(_),extraFileResources:w.extraFileResources&&w.extraFileResources.map(h=>k.URI.revive(h))}}e.reviveQuery=E;function _(w){return{...w,folder:k.URI.revive(w.folder)}}}),define(De[291],Ie([1,0,84,140,33,137,34,39,58,40,73,75,76,96,54,68,139,69,46,95,93,59,138,13,229,47,94]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m,r,b,s,u,o,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,c.registerSingleton)(u.ILoggerService,s.ExtHostLoggerService,1),(0,c.registerSingleton)(u.ILogService,o.ExtHostLogService,1),(0,c.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService,!1),(0,c.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,!1),(0,c.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,!1),(0,c.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,!1),(0,c.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,!1),(0,c.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,!1),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,!1),(0,c.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,c.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,c.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,!1),(0,c.registerSingleton)(_.IExtHostStorage,_.ExtHostStorage,!1),(0,c.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,!1),(0,c.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,!1),(0,c.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService,!1),(0,c.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow,!1),(0,c.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,!1),(0,c.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState,!1),(0,c.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry,!1),(0,c.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,!1),(0,c.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,!1)}),define(De[97],Ie([1,0,17,13,30,72]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=y;function T(I,E,_,w){const h=(0,c.mapArrayOrNot)(_,S),g=new D.TextSearchMatch(E,h,w),f=g.preview.matches;return{ranges:(0,c.mapArrayOrNot)(h,k),uri:I,preview:{text:g.preview.text,matches:(0,c.mapArrayOrNot)(f,k)}}}e.createTextSearchResult=T;function S(I){return new D.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function k(I){return new P.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let A=class{constructor(E,_){this.prefix=E,this.logService=_}appendLine(E){this.logService.debug(`${this.prefix}#search`,E)}};A=Ve([He(1,t.ILogService)],A),e.OutputChannel=A}),define(De[292],Ie([1,0,44,9,80,32,12,8,97,293]),function(Z,e,c,t,D,P,y,T,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const A=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(m,r,b,s){const u=E(m,r,b,s),o=r.folder.fsPath;return{cmd:c.spawn(A,u.args,{cwd:o}),rgDiskPath:A,siblingClauses:u.siblingClauses,rgArgs:u,cwd:o}}e.spawnRipgrepCmd=I;function E(m,r,b,s){const u=["--files","--hidden","--case-sensitive"];w([r],b,!1).forEach(l=>{const a=(0,S.anchorGlob)(l);if(u.push("-g",a),y.isMacintosh){const d=(0,D.normalizeNFD)(a);d!==a&&u.push("-g",d)}});const o=_([r],s,void 0,!1);return o.globArgs.forEach(l=>{const a=`!${(0,S.anchorGlob)(l)}`;if(u.push("-g",a),y.isMacintosh){const d=(0,D.normalizeNFD)(a);d!==a&&u.push("-g",d)}}),r.disregardIgnoreFiles!==!1?u.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),r.ignoreSymlinks||u.push("--follow"),m.exists&&u.push("--quiet"),u.push("--no-config"),r.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:o.siblingClauses}}function _(m,r,b,s=!0){const u=[];let o={};return m.forEach(l=>{const a=Object.assign({},l.excludePattern||{},r||{}),d=h(a,s?l.folder.fsPath:void 0,b);u.push(...d.globArgs),d.siblingClauses&&(o=Object.assign(o,d.siblingClauses))}),{globArgs:u,siblingClauses:o}}e.foldersToRgExcludeGlobs=_;function w(m,r,b=!0){const s=[];return m.forEach(u=>{const o=Object.assign({},r||{},u.includePattern||{}),l=h(o,b?u.folder.fsPath:void 0);s.push(...l.globArgs)}),s}e.foldersToIncludeGlobs=w;function h(m,r,b){const s=[],u={};return Object.keys(m).forEach(o=>{if(b&&b.has(o)||!o)return;const l=m[o];o=f(r?g(r,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof l=="boolean"&&l?(o.startsWith("\\\\")&&(o+="**"),s.push(v(o))):l&&l.when&&(u[o]=l)}),{globArgs:s,siblingClauses:u}}function g(m,r){return t.isAbsolute(r)?r:t.join(m,r)}e.getAbsoluteGlob=g;function f(m){return m=T.rtrim(m,"\\"),T.rtrim(m,"/")}function v(m){return P.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=v}),define(De[294],Ie([1,0,44,65,9,295,17,50,37,80,32,12,51,8,11,29,30,292,109]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(o=>o())});class r{constructor(l){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=l,this.filePattern=l.filePattern||"",this.includePattern=l.includePattern&&S.parse(l.includePattern),this.maxResults=l.maxResults||null,this.exists=!!l.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=l.excludePattern&&S.parse(l.excludePattern),this.folderExcludePatterns=new Map,l.folderQueries.forEach(a=>{const d=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),n=a.folder.fsPath;l.folderQueries.map(i=>i.folder.fsPath).filter(i=>i!==n).forEach(i=>{(0,A.isEqualOrParent)(i,n)&&(d[D.relative(n,i)]=!0)}),this.folderExcludePatterns.set(n,new s(d,n))})}cancel(){this.isCanceled=!0,m.forEach(l=>l())}walk(l,a,d,n,i){if(this.fileWalkSW=E.StopWatch.create(!1),this.isCanceled)return i(null,this.isLimitHit);a.forEach(p=>{const C=D.basename(p.fsPath);this.globalExcludePattern&&this.globalExcludePattern(p.fsPath,C)||this.matchFile(d,{relativePath:p.fsPath,searchPath:void 0})}),this.cmdSW=E.StopWatch.create(!1),this.parallel(l,(p,C)=>{this.call(this.cmdTraversal,this,p,d,n,R=>{if(R){const M=(0,T.toErrorMessage)(R);console.error(M),this.errors.push(M),C(R,void 0)}else C(null,void 0)})},(p,C)=>{this.fileWalkSW.stop();const R=p?y.coalesce(p)[0]:null;i(R,this.isLimitHit)})}parallel(l,a,d){const n=new Array(l.length),i=new Array(l.length);let p=!1,C=0;if(l.length===0)return d(null,[]);l.forEach((R,M)=>{a(R,($,x)=>{if($?(p=!0,n[M]=null,i[M]=$):(n[M]=x,i[M]=null),++C===l.length)return d(p?i:null,n)})})}call(l,a,...d){try{l.apply(a,d)}catch(n){d[d.length-1](n)}}cmdTraversal(l,a,d,n){const i=l.folder.fsPath,p=I.isMacintosh,C=()=>L&&L.kill();m.add(C);let R=U=>{m.delete(C),R=()=>{},n(U)},M="";const $=this.initDirectoryTree(),x=(0,f.spawnRipgrepCmd)(this.config,l,this.config.includePattern,this.folderExcludePatterns.get(l.folder.fsPath).expression),L=x.cmd,B=!Object.keys(x.siblingClauses).length,O=x.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let z=`${x.rgDiskPath} ${O}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),d({message:z}),this.cmdResultCount=0,this.collectStdout(L,"utf8",d,(U,F,V)=>{if(U){R(U);return}if(this.isLimitHit){R();return}const Q=(M+(p?k.normalizeNFC(F||""):F)).split(`
`);if(V){const K=Q.length;Q[K-1]=Q[K-1].trim(),Q[K-1]||Q.pop()}else M=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=Q.length,B){for(const K of Q)if(this.matchFile(a,{base:i,relativePath:K,searchPath:this.getSearchPath(l,K)}),this.isLimitHit){C();break}(V||this.isLimitHit)&&R();return}this.addDirectoryEntries(l,$,i,Q,a),V&&(this.matchDirectoryTree($,i,a),R())})}spawnFindCmd(l){const a=this.folderExcludePatterns.get(l.folder.fsPath),d=a.getBasenameTerms(),n=a.getPathTerms(),i=["-L","."];if(d.length||n.length){i.push("-not","(","(");for(const p of d)i.push("-name",p),i.push("-o");for(const p of n)i.push("-path",p),i.push("-o");i.pop(),i.push(")","-prune",")")}return i.push("-type","f"),c.spawn("find",i,{cwd:l.folder.fsPath})}readStdout(l,a,d){let n="";this.collectStdout(l,a,()=>{},(i,p,C)=>{if(i){d(i);return}n+=p,C&&d(null,n)})}collectStdout(l,a,d,n){let i=(R,M,$)=>{(R||$)&&(i=()=>{},this.cmdSW?.stop()),n(R,M,$)},p=!1;l.stdout?(this.forwardData(l.stdout,a,i),l.stdout.once("data",()=>p=!0)):d({message:"stdout is null"});let C;l.stderr?C=this.collectData(l.stderr):d({message:"stderr is null"}),l.on("error",R=>{i(R)}),l.on("close",R=>{let M;!p&&(M=this.decodeData(C,a))&&u(M)?i(new Error(`command failed with error code ${R}: ${this.decodeData(C,a)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),i(null,"",!0))})}forwardData(l,a,d){const n=new P.StringDecoder(a);return l.on("data",i=>{d(null,n.write(i))}),n}collectData(l){const a=[];return l.on("data",d=>{a.push(d)}),a}decodeData(l,a){const d=new P.StringDecoder(a);return l.map(n=>d.write(n)).join("")}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries(l,{pathToEntries:a},d,n,i){n.indexOf(this.filePattern)!==-1&&this.matchFile(i,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(l,this.filePattern)});const p=C=>{const R=D.basename(C),M=D.dirname(C);let $=a[M];$||($=a[M]=[],p(M)),$.push({base:d,relativePath:C,basename:R,searchPath:this.getSearchPath(l,C)})};n.forEach(p)}matchDirectoryTree({rootEntries:l,pathToEntries:a},d,n){const i=this,p=this.folderExcludePatterns.get(d),C=this.filePattern;function R(M){i.directoriesWalked++;const $=(0,g.hasSiblingFn)(()=>M.map(x=>x.basename));for(let x=0,L=M.length;x<L;x++){const B=M[x],{relativePath:O,basename:z}=B;if(p.test(O,z,C!==z?$:void 0))continue;const U=a[O];if(U)R(U);else{if(i.filesWalked++,O===C)continue;i.matchFile(n,B)}if(i.isLimitHit)break}}R(l)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(l,a,d,n,i){const p=l.folder,C=(0,g.hasSiblingFn)(()=>d);this.parallel(d,(R,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const $=a?[a,R].join(D.sep):R;if(this.folderExcludePatterns.get(l.folder.fsPath).test($,R,this.config.filePattern!==R?C:void 0))return M(null);const x=[p.fsPath,$].join(D.sep);t.lstat(x,(L,B)=>{if(L||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded(x,B,(O,z)=>O||this.isCanceled||this.isLimitHit?M(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(x,B,(U,F)=>U||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?M(null):(this.walkedPaths[F]=!0,h.Promises.readdir(x).then(V=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(l,$,V,n,H=>M(H||null))},V=>{M(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&w.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(n,{base:p.fsPath,relativePath:$,searchPath:this.getSearchPath(l,$)}),M(null,void 0)))})},R=>{const M=R&&y.coalesce(R);return i(M&&M.length>0?M[0]:void 0)})}matchFile(l,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,D.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||l(a))}isFileMatch(l){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,g.isFilePatternMatch)(l,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(l,a,d){return a.isSymbolicLink()?t.stat(l,d):d(null,a)}realPathIfNeeded(l,a,d){return a.isSymbolicLink()?t.realpath(l,(n,i)=>n?d(n):d(null,i)):d(null,l)}getSearchPath(l,a){return l.folderName?D.join(l.folderName,a):a}}e.FileWalker=r;class b{constructor(l){this.folderQueries=l.folderQueries,this.extraFiles=l.extraFileResources||[],this.walker=new r(l)}search(l,a,d){this.walker.walk(this.folderQueries,this.extraFiles,l,a,(n,i)=>{d(n,{limitHit:i,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=b;class s{constructor(l,a){this.expression=l,this.root=a,this.init(l)}init(l){let a,d;Object.keys(l).filter(n=>l[n]).forEach(n=>{D.isAbsolute(n)?(a=a||S.getEmptyExpression(),a[n]=l[n]):(d=d||S.getEmptyExpression(),d[n]=l[n])}),this.absoluteParsedExpr=a&&S.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=d&&S.parse(d,{trimForExclusions:!0})}test(l,a,d){return this.relativeParsedExpr&&this.relativeParsedExpr(l,a,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,l),a,d)}getBasenameTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...S.getBasenameTerms(this.relativeParsedExpr)),l}getPathTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...S.getPathTerms(this.relativeParsedExpr)),l}}function u(o){const l=o.trim().split(`
`),a=l[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return _.uppercaseFirstLetter(l[l.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=u}),define(De[296],Ie([1,0,100,23]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===o)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,y=512,T=512*8,S=512*128;var k;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(k=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class A extends Error{constructor(l,a){super(l),this.decodeStreamErrorKind=a}}e.DecodeStreamError=A;class I{static async create(l){let a;if(l!==e.UTF8)a=(await new Promise((n,i)=>{Z(["@vscode/iconv-lite-umd"],n,i)})).getDecoder(h(l));else{const d=new TextDecoder;a={write(n){return d.decode(n,{stream:!0})},end(){return d.decode()}}}return new I(a)}constructor(l){this.iconvLiteDecoder=l}write(l){return this.iconvLiteDecoder.write(l)}end(){return this.iconvLiteDecoder.end()}}function E(o,l){const a=l.minBytesRequiredForDetection??l.guessEncoding?T:y;return new Promise((d,n)=>{const i=(0,c.newWriteableStream)(x=>x.join("")),p=[];let C=0,R,M;const $=async()=>{try{const x=await u({buffer:t.VSBuffer.concat(p),bytesRead:C},l.guessEncoding);if(x.seemsBinary&&l.acceptTextOnly)throw new A("Stream is binary but only text is accepted for decoding",1);x.encoding=await l.overwriteEncoding(x.encoding),R=await I.create(x.encoding);const L=R.write(t.VSBuffer.concat(p).buffer);i.write(L),p.length=0,C=0,d({stream:i,detected:x})}catch(x){M?.dispose(),i.destroy(),n(x)}};M=(0,c.listenStream)(o,{onData:async x=>{R?i.write(R.write(x.buffer)):(p.push(x),C+=x.byteLength,C>=a&&(o.pause(),await $(),setTimeout(()=>o.resume())))},onError:x=>i.error(x),onEnd:async()=>{R||await $(),i.end(R?.end())}})})}e.toDecodeStream=E;async function _(o,l,a){const n=(await new Promise((C,R)=>{Z(["@vscode/iconv-lite-umd"],C,R)})).getEncoder(h(l),a);let i=!1,p=!1;return{read(){if(p)return null;const C=o.read();if(typeof C!="string"){if(p=!0,!i&&a?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=n.end();return R&&R.length>0?(i=!0,t.VSBuffer.wrap(R)):null}return i=!0,t.VSBuffer.wrap(n.write(C))}}}e.toEncodeReadable=_;async function w(o){return(await new Promise((a,d)=>{Z(["@vscode/iconv-lite-umd"],a,d)})).encodingExists(h(o))}e.encodingExists=w;function h(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=h;function g(o,l){if(!o||l<e.UTF16be_BOM.length)return null;const a=o.readUInt8(0),d=o.readUInt8(1);if(a===e.UTF16be_BOM[0]&&d===e.UTF16be_BOM[1])return e.UTF16be;if(a===e.UTF16le_BOM[0]&&d===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const n=o.readUInt8(2);return a===e.UTF8_BOM[0]&&d===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=g;const f=["ascii","utf-16","utf-32"];async function v(o){const l=await new Promise((p,C)=>{Z(["jschardet"],p,C)}),a=o.slice(0,S),d=b(a.buffer),n=l.detect(d);if(!n||!n.encoding)return null;const i=n.encoding.toLowerCase();return 0<=f.indexOf(i)?null:r(n.encoding)}const m={ibm866:"cp866",big5:"cp950"};function r(o){const l=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return m[l]||l}function b(o){let l="";for(let a=0;a<o.length;a++)l+=String.fromCharCode(o[a]);return l}function s(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=o.match(/windows(\d+)/);return l?"windows-"+l[1]:o}}}e.toCanonicalName=s;function u({buffer:o,bytesRead:l},a){let d=g(o,l),n=!1;if(d!==e.UTF16be&&d!==e.UTF16le&&o){let i=!0,p=!0,C=!1;for(let R=0;R<l&&R<P;R++){const M=R%2===1,$=o.readUInt8(R)===0;if($&&(C=!0),i&&(M&&!$||!M&&$)&&(i=!1),p&&(M&&$||!M&&!$)&&(p=!1),$&&!i&&!p)break}C&&(i?d=e.UTF16le:p?d=e.UTF16be:n=!0)}return a&&!n&&!d&&o?v(o.slice(0,l)).then(i=>({seemsBinary:!1,encoding:i})):{seemsBinary:n,encoding:d}}e.detectEncodingFromBuffer=u,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[142],Ie([1,0,296,29,141]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends D.TextSearchManager{constructor(T,S,k=t,A="searchProcess"){super(T,S,{readdir:I=>k.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,c.toCanonicalName)(I)},A)}}e.NativeTextSearchManager=P}),define(De[297],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(D){if(D&&this._dragOperations.has(D)){const P=this._dragOperations.get(D);return this._dragOperations.delete(D),P}}addDragOperationTransfer(D,P){this._dragOperations.set(D,P)}getRenderedTreeElement(D){if(this._renderedElements.has(D))return this._renderedElements.get(D)}addRenderedTreeItemElement(D,P){this._renderedElements.set(D,P)}removeRenderedTreeItemElement(D){this._renderedElements.has(D)&&this._renderedElements.delete(D)}}e.TreeviewsService=c}),define(De[298],Ie([1,0,176,7,22,2,4,6,18,7,11,17,15,21,297,27]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(m,r){if((0,A.isString)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let b;return Array.isArray(m.highlights)&&(b=m.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),b=b.length?b:void 0),{label:m.label,highlights:b}}}class f{constructor(r,b,s){this._proxy=r,this.commands=b,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeviewsService;function u(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}b.registerArgumentProcessor({processArgument:o=>u(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(l=>u(l)?this.convertArgument(l):l):o})}registerTreeDataProvider(r,b,s){const u=this.createTreeView(r,{treeDataProvider:b},s);return{dispose:()=>u.dispose()}}createTreeView(r,b,s){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=b.dragAndDropController?.dropMimeTypes??[],o=b.dragAndDropController?.dragMimeTypes??[],l=!!b.dragAndDropController?.handleDrag,a=!!b.dragAndDropController?.handleDrop,d=this.createExtHostTreeView(r,b,s),n=this._proxy.$registerTreeViewDataProvider(r,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,dropMimeTypes:u,dragMimeTypes:o,hasHandleDrag:l,hasHandleDrop:a});return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,h.checkProposedApiEnabled)(s,"treeItemCheckbox"),d.onDidChangeCheckboxState},get message(){return d.message},set message(i){d.message=i},get title(){return d.title},set title(i){d.title=i},get description(){return d.description},set description(i){d.description=i},get badge(){return d.badge},set badge(i){i!==void 0&&k.ViewBadge.isViewBadge(i)?d.badge={value:Math.floor(Math.abs(i.value)),tooltip:i.tooltip}:i===void 0&&(d.badge=void 0)},reveal:(i,p)=>d.reveal(i,p),dispose:async()=>{await n,this.treeViews.delete(r),d.dispose()}}}$getChildren(r,b){const s=this.treeViews.get(r);return s?s.getChildren(b):Promise.reject(new Error((0,c.localize)(0,null,r)))}async $handleDrop(r,b,s,u,o,l,a,d){const n=this.treeViews.get(r);if(!n)return Promise.reject(new Error((0,c.localize)(1,null,r)));const i=E.DataTransfer.toDataTransfer(s,async p=>(await this._proxy.$resolveDropFileData(r,b,p)).buffer);return a===r&&d&&await this.addAdditionalTransferItems(i,n,d,o,l),n.onDrop(i,u,o)}async addAdditionalTransferItems(r,b,s,u,o){const l=this.treeDragAndDropService.removeDragOperationTransfer(o);if(l)(await l)?.forEach((a,d)=>{a&&r.set(d,a)});else if(o&&b.handleDrag){const a=b.handleDrag(s,r,u);this.treeDragAndDropService.addDragOperationTransfer(o,a),await a}return r}async $handleDrag(r,b,s,u){const o=this.treeViews.get(r);if(!o)return Promise.reject(new Error((0,c.localize)(2,null,r)));const l=await this.addAdditionalTransferItems(new t.DataTransfer,o,b,u,s);if(!!l)return E.DataTransfer.toDataTransferDTO(l)}async $hasResolve(r){const b=this.treeViews.get(r);if(!b)throw new Error((0,c.localize)(3,null,r));return b.hasResolve}$resolve(r,b,s){const u=this.treeViews.get(r);if(!u)throw new Error((0,c.localize)(4,null,r));return u.resolveTreeItem(b,s)}$setExpanded(r,b,s){const u=this.treeViews.get(r);if(!u)throw new Error((0,c.localize)(5,null,r));u.setExpanded(b,s)}$setSelection(r,b){const s=this.treeViews.get(r);if(!s)throw new Error((0,c.localize)(6,null,r));s.setSelection(b)}$setFocus(r,b){const s=this.treeViews.get(r);if(!s)throw new Error((0,c.localize)(7,null,r));s.setFocus(b)}$setVisible(r,b){const s=this.treeViews.get(r);if(!s)throw new Error((0,c.localize)(8,null,r));s.setVisible(b)}$changeCheckboxState(r,b){const s=this.treeViews.get(r);if(!s)throw new Error((0,c.localize)(9,null,r));s.setCheckboxState(b)}createExtHostTreeView(r,b,s){const u=new v(r,b,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(r,u),u}convertArgument(r){const b=this.treeViews.get(r.$treeViewId);return b&&"$treeItemHandle"in r?b.getExtensionElement(r.$treeItemHandle):b&&"$focusedTreeItem"in r&&r.$focusedTreeItem?b.focusedElement:null}}e.ExtHostTreeViews=f;class v extends T.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(r=>this.getExtensionElement(r)).filter(r=>!(0,A.isUndefinedOrNull)(r))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(r,b,s,u,o,l){if(super(),this.viewId=r,this.proxy=s,this.commands=u,this.logService=o,this.extension=l,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new y.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new _.CancellationTokenSource,l.contributes&&l.contributes.views)for(const n in l.contributes.views)for(const i of l.contributes.views[n])i.id===r&&(this._title=i.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let a,d;this._register(y.Event.debounce(this._onDidChangeData.event,(n,i)=>(n||(n={message:!1,elements:[]}),i.element!==!1&&(a||(a=new Promise(p=>d=p),this.refreshPromise=this.refreshPromise.then(()=>a)),Array.isArray(i.element)?n.elements.push(...i.element):n.elements.push(i.element)),i.message&&(n.message=!0),n),200,!0)(({message:n,elements:i})=>{i.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=d;return a=null,this.refresh(i).then(()=>p())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(r){const b=r?this.getExtensionElement(r):void 0;if(r&&!b)return this.logService.error(`No tree item with id '${r}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(r);return s||(s=await this.fetchChildrenNodes(b)),s?s.map(u=>u.item):void 0}getExtensionElement(r){return this.elements.get(r)}reveal(r,b){b=b||{select:!0,focus:!1};const s=(0,A.isUndefinedOrNull)(b.select)?!0:b.select,u=(0,A.isUndefinedOrNull)(b.focus)?!1:b.focus,o=(0,A.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):r?this.refreshPromise.then(()=>this.resolveUnknownParentChain(r)).then(l=>this.resolveTreeNode(r,l[l.length-1]).then(a=>this.proxy.$reveal(this.viewId,{item:a.item,parentChain:l.map(d=>d.item)},{select:s,focus:u,expand:o})),l=>this.logService.error(l)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:u,expand:o})}get message(){return this._message}set message(r){this._message=r,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(r){this._title=r,this.proxy.$setTitle(this.viewId,r,this._description)}get description(){return this._description}set description(r){this._description=r,this.proxy.$setTitle(this.viewId,this._title,r)}get badge(){return this._badge}set badge(r){this._badge?.value===r?.value&&this._badge?.tooltip===r?.tooltip||(this._badge=E.ViewBadge.from(r),this.proxy.$setBadge(this.viewId,r))}setExpanded(r,b){const s=this.getExtensionElement(r);s&&(b?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(r){(0,I.equals)(this._selectedHandles,r)||(this._selectedHandles=r,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(r){this._focusedHandle=r}setVisible(r){r!==this._visible&&(this._visible=r,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(r){const b=(await Promise.all(r.map(async s=>{const u=this.getExtensionElement(s.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);b.forEach(s=>{s.treeItem.checkboxState=s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:b.map(s=>[s.extensionItem,s.newState])})}async handleDrag(r,b,s){const u=[];for(const o of r){const l=this.getExtensionElement(o);l&&u.push(l)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,b,s),b}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(r,b,s){const u=b?this.getExtensionElement(b):void 0;if(!(!u&&b||!this.dndController?.handleDrop))return(0,S.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,r,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(r,b){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(r);if(s){const u=this.nodes.get(s);if(u){const o=await this.dataProvider.resolveTreeItem(u.extensionItem,s,b)??u.extensionItem;return this.validateTreeItem(o),u.item.tooltip=this.getTooltip(o.tooltip),u.item.command=this.getCommand(u.disposableStore,o.command),u.item}}}resolveUnknownParentChain(r){return this.resolveParent(r).then(b=>b?this.resolveUnknownParentChain(b).then(s=>this.resolveTreeNode(b,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}resolveParent(r){const b=this.nodes.get(r);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(r))}resolveTreeNode(r,b){const s=this.nodes.get(r);return s?Promise.resolve(s):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(u=>this.createHandle(r,u,b,!0)).then(u=>this.getChildren(b?b.item.handle:void 0).then(()=>{const o=this.getExtensionElement(u);if(o){const l=this.nodes.get(o);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(r){if(r){let b;if(typeof r=="string"){const s=this.getExtensionElement(r);b=s?this.nodes.get(s):void 0}else b=r;return b&&b.children||void 0}return this.roots}async fetchChildrenNodes(r){this.clearChildren(r);const b=new _.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=r?this.nodes.get(r):void 0,u=await this.dataProvider.getChildren(r);if(b.token.isCancellationRequested)return;const o=await Promise.all((0,I.coalesce)(u||[]).map(async l=>{const a=await this.dataProvider.getTreeItem(l);return a&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(l,a,s):null}));return b.token.isCancellationRequested?void 0:(0,I.coalesce)(o)}finally{b.dispose()}}refresh(r){if(r.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new _.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(r);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(r){const b=new Set,s=r.map(o=>this.nodes.get(o));for(const o of s)if(o&&!b.has(o.item.handle)){let l=o;for(;l&&l.parent&&s.findIndex(a=>l&&l.parent&&a&&a.item.handle===l.parent.item.handle)===-1;){const a=this.elements.get(l.parent.item.handle);l=a?this.nodes.get(a):void 0}l&&!l.parent&&b.add(o.item.handle)}const u=[];return b.forEach(o=>{const l=this.elements.get(o);if(l){const a=this.nodes.get(l);a&&(!a.parent||!b.has(a.parent.item.handle))&&u.push(o)}}),u}refreshHandles(r){const b={};return Promise.all(r.map(s=>this.refreshNode(s).then(u=>{u&&(b[s]=u.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(r){const b=this.getExtensionElement(r);if(b){const s=this.nodes.get(b);if(s)return this.clearChildren(b),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(u=>{if(u){const o=this.createTreeNode(b,u,s.parent);return this.updateNodeCache(b,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(r,b,s){const u=this.createTreeNode(r,b,s);if(b.id&&this.elements.has(u.item.handle))throw new Error((0,c.localize)(10,null,b.id));return this.addNodeToCache(r,u),this.addNodeToParentCache(u,s),u}getTooltip(r){return k.MarkdownString.isMarkdownString(r)?E.MarkdownString.from(r):r}getCommand(r,b){return b?{...this.commands.toInternal(b,r),originalId:b.command}:void 0}getCheckbox(r){if(!r.checkboxState)return;let b,s;return typeof r.checkboxState=="number"?b=r.checkboxState:(b=r.checkboxState.state,s=r.checkboxState.tooltip),{isChecked:b===k.TreeItemCheckboxState.Checked,tooltip:s}}validateTreeItem(r){if(!k.TreeItem.isTreeItem(r,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(r,b,s){this.validateTreeItem(b);const u=new T.DisposableStore,o=this.createHandle(r,b,s),l=this.getLightIconPath(b);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:g(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(u,b.command),contextValue:b.contextValue,icon:l,iconDark:this.getDarkIconPath(b)||l,themeIcon:this.getThemeIcon(b),collapsibleState:(0,A.isUndefinedOrNull)(b.collapsibleState)?k.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation,checkbox:this.getCheckbox(b)},extensionItem:b,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(r){return r.iconPath instanceof k.ThemeIcon?r.iconPath:void 0}createHandle(r,{id:b,label:s,resourceUri:u},o,l){if(b)return`${v.ID_HANDLE_PREFIX}/${b}`;const a=g(s,this.extension),d=o?o.item.handle:v.LABEL_HANDLE_PREFIX;let n=a?a.label:u?(0,D.basename)(u):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const i=this.nodes.has(r)?this.nodes.get(r).item.handle:void 0,p=this.getChildrenNodes(o)||[];let C,R=0;do{if(C=`${d}/${R}:${n}`,l||!this.elements.has(C)||i===C)break;R++}while(R<=p.length);return C}getLightIconPath(r){if(r.iconPath&&!(r.iconPath instanceof k.ThemeIcon))return typeof r.iconPath=="string"||P.URI.isUri(r.iconPath)?this.getIconPath(r.iconPath):this.getIconPath(r.iconPath.light)}getDarkIconPath(r){if(r.iconPath&&!(r.iconPath instanceof k.ThemeIcon)&&r.iconPath.dark)return this.getIconPath(r.iconPath.dark)}getIconPath(r){return P.URI.isUri(r)?r:P.URI.file(r)}addNodeToCache(r,b){this.elements.set(b.item.handle,r),this.nodes.set(r,b)}updateNodeCache(r,b,s,u){this.elements.delete(b.item.handle),this.nodes.delete(r),b.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(r,b);const o=this.getChildrenNodes(u)||[],l=o.filter(a=>a.item.handle===s.item.handle)[0];l&&o.splice(o.indexOf(l),1,b)}addNodeToParentCache(r,b){b?(b.children||(b.children=[]),b.children.push(r)):(this.roots||(this.roots=[]),this.roots.push(r))}clearChildren(r){if(r){const b=this.nodes.get(r);if(b){if(b.children)for(const s of b.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}b.children=void 0}}else this.clearAll()}clear(r){const b=this.nodes.get(r);if(b){if(b.children)for(const s of b.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}this.nodes.delete(r),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(r=>r.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(De[299],Ie([1,0,21,10,4,42,2,119,104,149,159,38,5,92,243,242,39,244,34,246,247,248,231,249,58,41,250,251,254,255,256,140,234,260,261,262,96,40,264,298,15,7,267,71,139,33,214,253,86,137,73,75,76,13,55,16,25,257,230,54,68,240,265,70,69,270,268,269,241,46,263,266,95,59,93,258,72,259,14,123,233,210,252,6,27,215,94,207]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m,r,b,s,u,o,l,a,d,n,i,p,C,R,M,$,x,L,B,O,z,U,F,V,H,Q,K,de,ee,fe,Y,ve,Ee,ke,Re,ze,ie,ce,me,J,ae,ne,se,N,j,G,X,ge,be,le,ye,Ce,We,je,Je,Qe,Ze,Be,ut,re,oe,_e,ue,Pe,Le,Ne,qe,Ye,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function bt(st){const et=st.get(ce.IExtHostInitDataService),wt=st.get(ye.IExtHostFileSystemInfo),St=st.get(G.IExtHostConsumerFileSystem),Ct=st.get(l.IExtHostExtensionService),ft=st.get(K.IExtHostWorkspace),Dt=st.get(Qe.IExtHostTelemetry),Ft=st.get(v.IExtHostConfiguration),Ut=st.get(ze.IURITransformerService),Xe=st.get(ie.IExtHostRpcService),Tt=st.get(L.IExtHostStorage),Rt=st.get(j.IExtensionStoragePaths),Nt=st.get(Re.ILoggerService),pt=st.get(Re.ILogService),Ae=st.get(ae.IExtHostTunnelService),Oe=st.get(ne.IExtHostApiDeprecationService),Se=st.get(Q.IExtHostWindow),te=st.get(je.IExtHostSecretState),Fe=st.get(Je.IExtHostEditorTabs);Xe.set(E.ExtHostContext.ExtHostFileSystemInfo,wt),Xe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Nt),Xe.set(E.ExtHostContext.ExtHostWorkspace,ft),Xe.set(E.ExtHostContext.ExtHostConfiguration,Ft),Xe.set(E.ExtHostContext.ExtHostExtensionService,Ct),Xe.set(E.ExtHostContext.ExtHostStorage,Tt),Xe.set(E.ExtHostContext.ExtHostTunnelService,Ae),Xe.set(E.ExtHostContext.ExtHostWindow,Se),Xe.set(E.ExtHostContext.ExtHostSecretState,te),Xe.set(E.ExtHostContext.ExtHostTelemetry,Dt),Xe.set(E.ExtHostContext.ExtHostEditorTabs,Fe);const xe=Xe.set(E.ExtHostContext.ExtHostDecorations,st.get(Y.IExtHostDecorations)),rt=Xe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,st.get(o.IExtHostDocumentsAndEditors)),Ge=Xe.set(E.ExtHostContext.ExtHostCommands,st.get(g.IExtHostCommands)),ot=Xe.set(E.ExtHostContext.ExtHostTerminalService,st.get(B.IExtHostTerminalService)),lt=Xe.set(E.ExtHostContext.ExtHostDebugService,st.get(Ee.IExtHostDebugService)),It=Xe.set(E.ExtHostContext.ExtHostSearch,st.get(ke.IExtHostSearch)),vt=Xe.set(E.ExtHostContext.ExtHostTask,st.get(ve.IExtHostTask)),kt=Xe.set(E.ExtHostContext.ExtHostOutputService,st.get(C.IExtHostOutputService)),_t=Xe.set(E.ExtHostContext.ExtHostLocalization,st.get(Ye.IExtHostLocalizationService)),Lt=Xe.set(E.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Xe)),mt=Xe.set(E.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Xe,rt)),zt=Xe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(Xe,rt,pt)),tn=Xe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(pt,mt,Xe.getProxy(E.MainContext.MainThreadBulkEdits))),Et=Xe.set(E.ExtHostContext.ExtHostNotebook,new me.ExtHostNotebookController(Xe,Ge,rt,mt)),Wt=Xe.set(E.ExtHostContext.ExtHostNotebookDocuments,new ue.ExtHostNotebookDocuments(Et)),nn=Xe.set(E.ExtHostContext.ExtHostNotebookEditors,new _e.ExtHostNotebookEditors(pt,Et)),rn=Xe.set(E.ExtHostContext.ExtHostNotebookKernels,new Ze.ExtHostNotebookKernels(Xe,et,Et,Ge,pt)),bn=Xe.set(E.ExtHostContext.ExtHostNotebookRenderers,new ut.ExtHostNotebookRenderers(Xe,Et)),Pt=Xe.set(E.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Xe,rt)),sn=Xe.set(E.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(Xe.getProxy(E.MainContext.MainThreadTreeViews),Ge,pt)),xt=Xe.set(E.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Xe.getProxy(E.MainContext.MainThreadEditorInsets),Pt,et.remote)),Yt=Xe.set(E.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(Xe,pt,wt,rt)),on=Xe.set(E.ExtHostContext.ExtHostLanguages,new i.ExtHostLanguages(Xe,mt,Ge.converter,Ut)),dt=Xe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Ut,mt,Ge,Yt,pt,Oe,Dt)),Jt=Xe.set(E.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(Xe,dt)),Ht=Xe.set(E.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(Xe,pt,rt)),Gt=Xe.set(E.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Xe,ft,Ge)),an=Xe.set(E.ExtHostContext.ExtHostSCM,new $.ExtHostSCM(Xe,Ge,pt)),wn=Xe.set(E.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Xe,Ge,mt)),cn=Xe.set(E.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Xe.getProxy(E.MainContext.MainThreadProgress))),En=Xe.set(E.ExtHostContext.ExtHosLabelService,new ee.ExtHostLabelService(Xe)),ln=Xe.set(E.ExtHostContext.ExtHostTheming,new J.ExtHostTheming(Xe)),Zt=Xe.set(E.ExtHostContext.ExtHostAuthentication,new se.ExtHostAuthentication(Xe)),Nn=Xe.set(E.ExtHostContext.ExtHostTimeline,new N.ExtHostTimeline(Xe,Ge)),Sn=Xe.set(E.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(Xe,et.remote,ft,pt,Oe)),en=Xe.set(E.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Xe,Sn,ft)),_n=Xe.set(E.ExtHostContext.ExtHostCustomEditors,new ge.ExtHostCustomEditors(Xe,mt,Rt,Sn,en)),yn=Xe.set(E.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Xe,Sn)),Kt=Xe.set(E.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(Xe,Ge,rt)),Fn=Xe.set(E.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Xe));Xe.set(E.ExtHostContext.ExtHostInteractive,new Pe.ExtHostInteractive(Xe,Et,rt,Ge,pt));const Cn=Object.values(E.ExtHostContext);Xe.assertRegistered(Cn);const Dn=new le.ExtHostBulkEdits(Xe,rt),Mn=new h.ExtHostClipboard(Xe),In=new p.ExtHostMessageService(Xe,pt),Pn=new r.ExtHostDialogs(Xe),An=new x.ExtHostStatusBar(Xe,Ge.converter);return w.ExtHostApiCommands.register(Ge),function($e,Vt,un){const gt=function(){let pe=!$e.isUnderDevelopment;function we(){pe||(pt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Me(at){if(Array.isArray(at))at.forEach(Me);else if(typeof at=="string")we();else{const yt=at;typeof yt.scheme>"u"&&we(),typeof yt.exclusive=="boolean"&&(0,Ne.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return at}}(),Un={getSession(pe,we,Me){return Zt.getSession($e,pe,we,Me)},async hasSession(pe,we){return(0,Ne.checkProposedApiEnabled)($e,"authSession"),!!await Zt.getSession($e,pe,we,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(pe,we,Me,at){return Zt.registerAuthenticationProvider(pe,we,Me,at)}},Bn={registerCommand(pe,we,Me){return Ge.registerCommand(!0,pe,we,Me,void 0,$e)},registerTextEditorCommand(pe,we,Me){return Ge.registerCommand(!0,pe,(...at)=>{const yt=Pt.getActiveTextEditor();if(!yt){pt.warn("Cannot execute "+pe+" because there is no active text editor.");return}return yt.edit(At=>{we.apply(Me,[yt,At,...at])}).then(At=>{At||pt.warn("Edits from command "+pe+" were not applied.")},At=>{pt.warn("An error occurred while running command "+pe,At)})},void 0,void 0,$e)},registerDiffInformationCommand:(pe,we,Me)=>((0,Ne.checkProposedApiEnabled)($e,"diffCommand"),Ge.registerCommand(!0,pe,async(...at)=>{const yt=rt.activeEditor(!0);if(!yt){pt.warn("Cannot execute "+pe+" because there is no active text editor.");return}const At=await Pt.getDiffInformation(yt.id);we.apply(Me,[At,...at])},void 0,void 0,$e)),executeCommand(pe,...we){return Ge.executeCommand(pe,...we)},getCommands(pe=!1){return Ge.getCommands(pe)}},Rn={get machineId(){return et.telemetryInfo.machineId},get sessionId(){return et.telemetryInfo.sessionId},get language(){return et.environment.appLanguage},get appName(){return et.environment.appName},get appRoot(){return et.environment.appRoot?.fsPath??""},get appHost(){return et.environment.appHost},get uriScheme(){return et.environment.appUriScheme},get clipboard(){return Mn.value},get shell(){return ot.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ne.checkProposedApiEnabled)($e,"envShellEvent"),ot.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)($e,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)($e,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Qe.isNewAppInstall)(et.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe){return(0,Ne.checkProposedApiEnabled)($e,"telemetryLogger"),Dt.instantiateLogger($e,pe)},openExternal(pe,we){return Se.openUri(pe,{allowTunneling:!!et.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===et.environment.appUriScheme)return Lt.createAppUri(pe);try{return await Se.asExternalUri(pe,{allowTunneling:!!et.remote.authority})}catch(we){if((0,oe.matchesScheme)(pe,re.Schemas.http)||(0,oe.matchesScheme)(pe,re.Schemas.https))return pe;throw we}},get remoteName(){return(0,fe.getRemoteName)(et.remote.authority)},get remoteAuthority(){return(0,Ne.checkProposedApiEnabled)($e,"resolvers"),et.remote.authority},get uiKind(){return et.uiKind},get logLevel(){return(0,Ne.checkProposedApiEnabled)($e,"extensionLog"),pt.getLevel()},get onDidChangeLogLevel(){return(0,Ne.checkProposedApiEnabled)($e,"extensionLog"),pt.onDidChangeLogLevel}};et.environment.extensionTestsLocationURI||Object.freeze(Rn);const dn={createTestController(pe,we,Me){return Kt.createTestController(pe,we,Me)},createTestObserver(){return(0,Ne.checkProposedApiEnabled)($e,"testObserver"),Kt.createTestObserver()},runTests(pe){return(0,Ne.checkProposedApiEnabled)($e,"testObserver"),Kt.runTests(pe)},get onDidChangeTestResults(){return(0,Ne.checkProposedApiEnabled)($e,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,Ne.checkProposedApiEnabled)($e,"testObserver"),Kt.results}},hn=et.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,zn={getExtension(pe,we){(0,Ne.isProposedApiEnabled)($e,"extensionsAny")||(we=!1);const Me=Vt.mine.getExtensionDescription(pe);if(Me)return new l.Extension(Ct,$e.identifier,Me,hn,!1);if(we){const at=Vt.all.getExtensionDescription(pe);if(at)return new l.Extension(Ct,$e.identifier,at,hn,!0)}},get all(){const pe=[];for(const we of Vt.mine.getAllExtensionDescriptions())pe.push(new l.Extension(Ct,$e.identifier,we,hn,!1));return pe},get allAcrossExtensionHosts(){(0,Ne.checkProposedApiEnabled)($e,"extensionsAny");const pe=new Ne.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),we=[];for(const Me of Vt.all.getAllExtensionDescriptions()){const at=!pe.has(Me.identifier);we.push(new l.Extension(Ct,$e.identifier,Me,hn,at))}return we},get onDidChange(){return(0,Ne.isProposedApiEnabled)($e,"extensionsAny")?D.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Wn={createDiagnosticCollection(pe){return Yt.createDiagnosticCollection($e.identifier,pe)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:pe=>Yt.getDiagnostics(pe),getLanguages(){return on.getLanguages()},setTextDocumentLanguage(pe,we){return on.changeLanguage(pe.uri,we)},match(pe,we){const Me=mt.getDocumentData(we.uri)?.notebook;return(0,A.score)(U.LanguageSelector.from(pe),we.uri,we.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(pe,we,Me){return dt.registerCodeActionProvider($e,gt(pe),we,Me)},registerDocumentPasteEditProvider(pe,we,Me){return(0,Ne.checkProposedApiEnabled)($e,"documentPaste"),dt.registerDocumentPasteEditProvider($e,gt(pe),we,Me)},registerCodeLensProvider(pe,we){return dt.registerCodeLensProvider($e,gt(pe),we)},registerDefinitionProvider(pe,we){return dt.registerDefinitionProvider($e,gt(pe),we)},registerDeclarationProvider(pe,we){return dt.registerDeclarationProvider($e,gt(pe),we)},registerImplementationProvider(pe,we){return dt.registerImplementationProvider($e,gt(pe),we)},registerTypeDefinitionProvider(pe,we){return dt.registerTypeDefinitionProvider($e,gt(pe),we)},registerHoverProvider(pe,we){return dt.registerHoverProvider($e,gt(pe),we,$e.identifier)},registerEvaluatableExpressionProvider(pe,we){return dt.registerEvaluatableExpressionProvider($e,gt(pe),we,$e.identifier)},registerInlineValuesProvider(pe,we){return dt.registerInlineValuesProvider($e,gt(pe),we,$e.identifier)},registerDocumentHighlightProvider(pe,we){return dt.registerDocumentHighlightProvider($e,gt(pe),we)},registerLinkedEditingRangeProvider(pe,we){return dt.registerLinkedEditingRangeProvider($e,gt(pe),we)},registerReferenceProvider(pe,we){return dt.registerReferenceProvider($e,gt(pe),we)},registerRenameProvider(pe,we){return dt.registerRenameProvider($e,gt(pe),we)},registerDocumentSymbolProvider(pe,we,Me){return dt.registerDocumentSymbolProvider($e,gt(pe),we,Me)},registerWorkspaceSymbolProvider(pe){return dt.registerWorkspaceSymbolProvider($e,pe)},registerDocumentFormattingEditProvider(pe,we){return dt.registerDocumentFormattingEditProvider($e,gt(pe),we)},registerDocumentRangeFormattingEditProvider(pe,we){return dt.registerDocumentRangeFormattingEditProvider($e,gt(pe),we)},registerOnTypeFormattingEditProvider(pe,we,Me,...at){return dt.registerOnTypeFormattingEditProvider($e,gt(pe),we,[Me].concat(at))},registerDocumentSemanticTokensProvider(pe,we,Me){return dt.registerDocumentSemanticTokensProvider($e,gt(pe),we,Me)},registerDocumentRangeSemanticTokensProvider(pe,we,Me){return dt.registerDocumentRangeSemanticTokensProvider($e,gt(pe),we,Me)},registerSignatureHelpProvider(pe,we,Me,...at){return typeof Me=="object"?dt.registerSignatureHelpProvider($e,gt(pe),we,Me):dt.registerSignatureHelpProvider($e,gt(pe),we,typeof Me>"u"?[]:[Me,...at])},registerCompletionItemProvider(pe,we,...Me){return dt.registerCompletionItemProvider($e,gt(pe),we,Me)},registerInlineCompletionItemProvider(pe,we){return we.handleDidShowCompletionItem&&(0,Ne.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider($e,gt(pe),we)},registerInlineCompletionItemProviderNew(pe,we){if((0,Ne.checkProposedApiEnabled)($e,"inlineCompletionsNew"),we.handleDidShowCompletionItem&&!(0,Ne.isProposedApiEnabled)($e,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew($e,gt(pe),we)},registerDocumentLinkProvider(pe,we){return dt.registerDocumentLinkProvider($e,gt(pe),we)},registerColorProvider(pe,we){return dt.registerColorProvider($e,gt(pe),we)},registerFoldingRangeProvider(pe,we){return dt.registerFoldingRangeProvider($e,gt(pe),we)},registerSelectionRangeProvider(pe,we){return dt.registerSelectionRangeProvider($e,pe,we)},registerCallHierarchyProvider(pe,we){return dt.registerCallHierarchyProvider($e,pe,we)},registerTypeHierarchyProvider(pe,we){return dt.registerTypeHierarchyProvider($e,pe,we)},setLanguageConfiguration:(pe,we)=>dt.setLanguageConfiguration($e,pe,we),getTokenInformationAtPosition(pe,we){return(0,Ne.checkProposedApiEnabled)($e,"tokenInformation"),on.tokenAtPosition(pe,we)},registerInlayHintsProvider(pe,we){return dt.registerInlayHintsProvider($e,pe,we)},createLanguageStatusItem(pe,we){return on.createLanguageStatusItem($e,pe,we)},registerDocumentDropEditProvider(pe,we){return dt.registerDocumentOnDropEditProvider($e,pe,we)}},Hn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ot.activeTerminal},get terminals(){return ot.terminals},async showTextDocument(pe,we,Me){const at=await(y.URI.isUri(pe)?Promise.resolve(fn.openTextDocument(pe)):Promise.resolve(pe));return Pt.showTextDocument(at,we,Me)},createTextEditorDecorationType(pe){return Pt.createTextEditorDecorationType($e,pe)},onDidChangeActiveTextEditor(pe,we,Me){return Pt.onDidChangeActiveTextEditor(pe,we,Me)},onDidChangeVisibleTextEditors(pe,we,Me){return Pt.onDidChangeVisibleTextEditors(pe,we,Me)},onDidChangeTextEditorSelection(pe,we,Me){return Pt.onDidChangeTextEditorSelection(pe,we,Me)},onDidChangeTextEditorOptions(pe,we,Me){return Pt.onDidChangeTextEditorOptions(pe,we,Me)},onDidChangeTextEditorVisibleRanges(pe,we,Me){return Pt.onDidChangeTextEditorVisibleRanges(pe,we,Me)},onDidChangeTextEditorViewColumn(pe,we,Me){return Pt.onDidChangeTextEditorViewColumn(pe,we,Me)},onDidCloseTerminal(pe,we,Me){return ot.onDidCloseTerminal(pe,we,Me)},onDidOpenTerminal(pe,we,Me){return ot.onDidOpenTerminal(pe,we,Me)},onDidChangeActiveTerminal(pe,we,Me){return ot.onDidChangeActiveTerminal(pe,we,Me)},onDidChangeTerminalDimensions(pe,we,Me){return(0,Ne.checkProposedApiEnabled)($e,"terminalDimensions"),ot.onDidChangeTerminalDimensions(pe,we,Me)},onDidChangeTerminalState(pe,we,Me){return ot.onDidChangeTerminalState(pe,we,Me)},onDidWriteTerminalData(pe,we,Me){return(0,Ne.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),ot.onDidWriteTerminalData(pe,we,Me)},get state(){return Se.state},onDidChangeWindowState(pe,we,Me){return Se.onDidChangeWindowState(pe,we,Me)},showInformationMessage(pe,...we){return In.showMessage($e,P.default.Info,pe,we[0],we.slice(1))},showWarningMessage(pe,...we){return In.showMessage($e,P.default.Warning,pe,we[0],we.slice(1))},showErrorMessage(pe,...we){return In.showMessage($e,P.default.Error,pe,we[0],we.slice(1))},showQuickPick(pe,we,Me){return Gt.showQuickPick(pe,we,Me)},showWorkspaceFolderPick(pe){return Gt.showWorkspaceFolderPick(pe)},showInputBox(pe,we){return Gt.showInput(pe,we)},showOpenDialog(pe){return Pn.showOpenDialog(pe)},showSaveDialog(pe){return Pn.showSaveDialog(pe)},createStatusBarItem(pe,we,Me){let at,yt,At;return typeof pe=="string"?(at=pe,yt=we,At=Me):(yt=pe,At=we),An.createStatusBarEntry($e,at,yt,At)},setStatusBarMessage(pe,we){return An.setStatusBarMessage(pe,we)},withScmProgress(pe){return Oe.report("window.withScmProgress",$e,"Use 'withProgress' instead."),cn.withProgress($e,{location:F.ProgressLocation.SourceControl},(we,Me)=>pe({report(at){}}))},withProgress(pe,we){return cn.withProgress($e,pe,we)},createOutputChannel(pe,we){return kt.createOutputChannel(pe,we,$e)},createWebviewPanel(pe,we,Me,at){return en.createWebviewPanel($e,pe,we,Me,at)},createWebviewTextEditorInset(pe,we,Me,at){return(0,Ne.checkProposedApiEnabled)($e,"editorInsets"),xt.createWebviewEditorInset(pe,we,Me,at,$e)},createTerminal(pe,we,Me){return typeof pe=="object"?"pty"in pe?ot.createExtensionTerminal(pe):ot.createTerminalFromOptions(pe):ot.createTerminal(pe,we,Me)},registerTerminalLinkProvider(pe){return ot.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,we){return ot.registerProfileProvider($e,pe,we)},registerTreeDataProvider(pe,we){return sn.registerTreeDataProvider(pe,we,$e)},createTreeView(pe,we){return sn.createTreeView(pe,we,$e)},registerWebviewPanelSerializer:(pe,we)=>en.registerWebviewPanelSerializer($e,pe,we),registerCustomEditorProvider:(pe,we,Me={})=>_n.registerCustomEditorProvider($e,pe,we,Me),registerFileDecorationProvider(pe){return xe.registerFileDecorationProvider(pe,$e.identifier)},registerUriHandler(pe){return Lt.registerUriHandler($e.identifier,pe)},createQuickPick(){return Gt.createQuickPick($e)},createInputBox(){return Gt.createInputBox($e)},get activeColorTheme(){return ln.activeColorTheme},onDidChangeActiveColorTheme(pe,we,Me){return ln.onDidChangeActiveColorTheme(pe,we,Me)},registerWebviewViewProvider(pe,we,Me){return yn.registerWebviewViewProvider($e,pe,we,Me?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,we,Me){return Et.onDidChangeActiveNotebookEditor(pe,we,Me)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,we,Me){return nn.onDidChangeNotebookEditorSelection(pe,we,Me)},onDidChangeNotebookEditorVisibleRanges(pe,we,Me){return nn.onDidChangeNotebookEditorVisibleRanges(pe,we,Me)},showNotebookDocument(pe,we){return Et.showNotebookDocument(pe,we)},registerExternalUriOpener(pe,we,Me){return(0,Ne.checkProposedApiEnabled)($e,"externalUriOpener"),Fn.registerExternalUriOpener($e.identifier,pe,we,Me)},get tabGroups(){return Fe.tabGroups}},fn={get rootPath(){return Oe.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(pe){throw t.readonly()},getWorkspaceFolder(pe){return ft.getWorkspaceFolder(pe)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(pe){throw t.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(pe){throw t.readonly()},updateWorkspaceFolders:(pe,we,...Me)=>ft.updateWorkspaceFolders($e,pe,we||0,...Me),onDidChangeWorkspaceFolders:function(pe,we,Me){return ft.onDidChangeWorkspace(pe,we,Me)},asRelativePath:(pe,we)=>ft.getRelativePath(pe,we),findFiles:(pe,we,Me,at)=>ft.findFiles(pe,we,Me,$e.identifier,at),findTextInFiles:(pe,we,Me,at)=>{(0,Ne.checkProposedApiEnabled)($e,"findTextInFiles");let yt,At;return typeof we=="object"?(yt=we,At=Me):(yt={},At=we,at=Me),ft.findTextInFiles(pe,yt||{},At,$e.identifier,at)},saveAll:pe=>ft.saveAll(pe),applyEdit(pe,we){return Dn.applyWorkspaceEdit(pe,$e,we)},createFileSystemWatcher:(pe,we,Me,at)=>Ht.createFileSystemWatcher(ft,$e,pe,we,Me,at),get textDocuments(){return mt.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw t.readonly()},openTextDocument(pe){let we;const Me=pe;if(typeof pe=="string")we=Promise.resolve(y.URI.file(pe));else if(y.URI.isUri(pe))we=Promise.resolve(pe);else if(!Me||typeof Me=="object")we=mt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(at=>mt.ensureDocumentData(at).then(yt=>yt.document))},onDidOpenTextDocument:(pe,we,Me)=>mt.onDidAddDocument(pe,we,Me),onDidCloseTextDocument:(pe,we,Me)=>mt.onDidRemoveDocument(pe,we,Me),onDidChangeTextDocument:(pe,we,Me)=>mt.onDidChangeDocument(pe,we,Me),onDidSaveTextDocument:(pe,we,Me)=>mt.onDidSaveDocument(pe,we,Me),onWillSaveTextDocument:(pe,we,Me)=>tn.getOnWillSaveTextDocumentEvent($e)(pe,we,Me),get notebookDocuments(){return Et.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,we){let Me;if(y.URI.isUri(pe))Me=pe,await Et.openNotebookDocument(pe);else if(typeof pe=="string")Me=y.URI.revive(await Et.createNotebookDocument({viewType:pe,content:we}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(pe,we,Me){return Wt.onDidSaveNotebookDocument(pe,we,Me)},onDidChangeNotebookDocument(pe,we,Me){return Wt.onDidChangeNotebookDocument(pe,we,Me)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(pe,we,Me,at){return Et.registerNotebookSerializer($e,pe,we,Me,(0,Ne.isProposedApiEnabled)($e,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(pe,we,Me,at)=>((0,Ne.checkProposedApiEnabled)($e,"notebookContentProvider"),Oe.report("workspace.registerNotebookContentProvider",$e,"The notebookContentProvider API is not on track for finalization and will be removed."),Et.registerNotebookContentProvider($e,pe,we,Me)),onDidChangeConfiguration:(pe,we,Me)=>un.onDidChangeConfiguration(pe,we,Me),getConfiguration(pe,we){return we=arguments.length===1?void 0:we,un.getConfiguration(pe,we,$e)},registerTextDocumentContentProvider(pe,we){return zt.registerTextDocumentContentProvider(pe,we)},registerTaskProvider:(pe,we)=>(Oe.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider($e,pe,we)),registerFileSystemProvider(pe,we,Me){return(0,Le.combinedDisposable)(Jt.registerFileSystemProvider($e,pe,we,Me),St.addFileSystemProvider(pe,we))},get fs(){return St.value},registerFileSearchProvider:(pe,we)=>((0,Ne.checkProposedApiEnabled)($e,"fileSearchProvider"),It.registerFileSearchProvider(pe,we)),registerTextSearchProvider:(pe,we)=>((0,Ne.checkProposedApiEnabled)($e,"textSearchProvider"),It.registerTextSearchProvider(pe,we)),registerRemoteAuthorityResolver:(pe,we)=>((0,Ne.checkProposedApiEnabled)($e,"resolvers"),Ct.registerRemoteAuthorityResolver(pe,we)),registerResourceLabelFormatter:pe=>((0,Ne.checkProposedApiEnabled)($e,"resolvers"),En.$registerResourceLabelFormatter(pe)),onDidCreateFiles:(pe,we,Me)=>Ht.onDidCreateFile(pe,we,Me),onDidDeleteFiles:(pe,we,Me)=>Ht.onDidDeleteFile(pe,we,Me),onDidRenameFiles:(pe,we,Me)=>Ht.onDidRenameFile(pe,we,Me),onWillCreateFiles:(pe,we,Me)=>Ht.getOnWillCreateFileEvent($e)(pe,we,Me),onWillDeleteFiles:(pe,we,Me)=>Ht.getOnWillDeleteFileEvent($e)(pe,we,Me),onWillRenameFiles:(pe,we,Me)=>Ht.getOnWillRenameFileEvent($e)(pe,we,Me),openTunnel:pe=>((0,Ne.checkProposedApiEnabled)($e,"tunnels"),Ae.openTunnel($e,pe).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Ne.checkProposedApiEnabled)($e,"tunnels"),Ae.getTunnels()},onDidChangeTunnels:(pe,we,Me)=>((0,Ne.checkProposedApiEnabled)($e,"tunnels"),Ae.onDidChangeTunnels(pe,we,Me)),registerPortAttributesProvider:(pe,we)=>((0,Ne.checkProposedApiEnabled)($e,"portsAttributes"),Ae.registerPortsAttributesProvider(pe,we)),registerTimelineProvider:(pe,we)=>((0,Ne.checkProposedApiEnabled)($e,"timeline"),Nn.registerTimelineProvider(pe,we,$e.identifier,Ge.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:pe=>((0,Ne.checkProposedApiEnabled)($e,"workspaceTrust"),ft.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,we,Me)=>ft.onDidGrantWorkspaceTrust(pe,we,Me),registerEditSessionIdentityProvider:(pe,we)=>((0,Ne.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(pe,we))},$n={get inputBox(){return Oe.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),an.getLastInputBox($e)},createSourceControl(pe,we,Me){return an.createSourceControl($e,pe,we,Me)}},jt={createCommentController(pe,we){return wn.createCommentController($e,pe,we)}},mn={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(pe,we,Me){return lt.onDidStartDebugSession(pe,we,Me)},onDidTerminateDebugSession(pe,we,Me){return lt.onDidTerminateDebugSession(pe,we,Me)},onDidChangeActiveDebugSession(pe,we,Me){return lt.onDidChangeActiveDebugSession(pe,we,Me)},onDidReceiveDebugSessionCustomEvent(pe,we,Me){return lt.onDidReceiveDebugSessionCustomEvent(pe,we,Me)},onDidChangeBreakpoints(pe,we,Me){return lt.onDidChangeBreakpoints(pe,we,Me)},registerDebugConfigurationProvider(pe,we,Me){return lt.registerDebugConfigurationProvider(pe,we,Me||qe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,we){return lt.registerDebugAdapterDescriptorFactory($e,pe,we)},registerDebugAdapterTrackerFactory(pe,we){return lt.registerDebugAdapterTrackerFactory(pe,we)},startDebugging(pe,we,Me){return!Me||typeof Me=="object"&&"configuration"in Me?lt.startDebugging(pe,we,{parentSession:Me}):lt.startDebugging(pe,we,Me||{})},stopDebugging(pe){return lt.stopDebugging(pe)},addBreakpoints(pe){return lt.addBreakpoints(pe)},removeBreakpoints(pe){return lt.removeBreakpoints(pe)},asDebugSourceUri(pe,we){return lt.asDebugSourceUri(pe,we)}},xn={registerTaskProvider:(pe,we)=>vt.registerTaskProvider($e,pe,we),fetchTasks:pe=>vt.fetchTasks(pe),executeTask:pe=>vt.executeTask($e,pe),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(pe,we,Me)=>vt.onDidStartTask(pe,we,Me),onDidEndTask:(pe,we,Me)=>vt.onDidEndTask(pe,we,Me),onDidStartTaskProcess:(pe,we,Me)=>vt.onDidStartTaskProcess(pe,we,Me),onDidEndTaskProcess:(pe,we,Me)=>vt.onDidEndTaskProcess(pe,we,Me)},Mt={createNotebookController(pe,we,Me,at,yt){return rn.createNotebookController($e,pe,we,Me,at,(0,Ne.isProposedApiEnabled)($e,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,we)=>Et.registerNotebookCellStatusBarItemProvider($e,pe,we),createRendererMessaging(pe){return bn.createRendererMessaging($e,pe)},onDidChangeNotebookCellExecutionState(pe,we,Me){return(0,Ne.checkProposedApiEnabled)($e,"notebookCellExecutionState"),rn.onDidChangeNotebookCellExecutionState(pe,we,Me)}},gn={t(...pe){if(typeof pe[0]=="string"){const we=pe.shift(),Me=!pe||typeof pe[0]!="object"?pe:pe[0];return _t.getMessage($e.identifier.value,{message:we,args:Me})}return _t.getMessage($e.identifier.value,pe[0])},get bundle(){return _t.getBundle($e.identifier.value)},get uri(){return _t.getBundleUri($e.identifier.value)}};return{version:et.version,authentication:Un,commands:Bn,comments:jt,debug:mn,env:Rn,extensions:zn,l10n:gn,languages:Wn,notebooks:Mt,scm:$n,tasks:xn,tests:dn,window:Hn,workspace:fn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CommentThreadState:F.CommentThreadState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:qe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:F.InlineCompletionTriggerKindNew,EventEmitter:D.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionItemNew:F.InlineSuggestionNew,InlineCompletionList:F.InlineSuggestionList,InlineCompletionListNew:F.InlineSuggestionsNew,Hover:F.Hover,IndentAction:k.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalLocation:F.TerminalLocation,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,SnippetTextEdit:F.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItem2:F.TreeItem,TreeItemCheckboxState:F.TreeItemCheckboxState,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:_.UIKind,Uri:y.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,DocumentDropEdit:F.DocumentDropEdit,DocumentPasteEdit:F.DocumentPasteEdit,InlayHint:F.InlayHint,InlayHintLabelPart:F.InlayHintLabelPart,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,NotebookControllerAffinity2:F.NotebookControllerAffinity2,NotebookEdit:F.NotebookEdit,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:Be.TextSearchCompleteMessageType,DataTransfer:F.DataTransfer,DataTransferItem:F.DataTransferItem,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity,QuickPickItemKind:F.QuickPickItemKind,InputBoxValidationSeverity:F.InputBoxValidationSeverity,TabInputText:F.TextTabInput,TabInputTextDiff:F.TextDiffTabInput,TabInputTextMerge:F.TextMergeTabInput,TabInputCustom:F.CustomEditorTabInput,TabInputNotebook:F.NotebookEditorTabInput,TabInputNotebookDiff:F.NotebookDiffEditorTabInput,TabInputWebview:F.WebviewEditorTabInput,TabInputTerminal:F.TerminalEditorTabInput,TabInputInteractiveWindow:F.InteractiveWindowInput,TerminalExitReason:F.TerminalExitReason,LogLevel:Re.LogLevel,EditSessionIdentityMatch:it.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=bt}),define(De[300],Ie([1,0,272,309,310,2,311]),function(Z,e,c,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(I,E,_,w,h,g){const f=g.environment.useHostProxy,v=typeof f=="boolean"?f:!g.remote.isRemote,m=(0,y.createProxyResolver)({resolveProxy:b=>I.resolveProxy(b),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(b,s,...u)=>{switch(b){case y.LogLevel.Trace:w.trace(s,...u);break;case y.LogLevel.Debug:w.debug(s,...u);break;case y.LogLevel.Info:w.info(s,...u);break;case y.LogLevel.Warning:w.warn(s,...u);break;case y.LogLevel.Error:w.error(s,...u);break;case y.LogLevel.Critical:w.critical(s,...u);break;case y.LogLevel.Off:break;default:o(b,s,u);break}function o(l,a,...d){w.error("Unknown log level",l),w.error(a,...d)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:v,env:process.env}),r=S(E,m);return A(_,r)}e.connectProxyResolver=T;function S(I,E){const _={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(h=>{_.config=I.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(h=>{w.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,y.createHttpPatch)(c,E,{config:"off"},w,!0)),on:Object.assign({},c,(0,y.createHttpPatch)(c,E,{config:"on"},w,!0)),override:Object.assign({},c,(0,y.createHttpPatch)(c,E,{config:"override"},w,!0)),onRequest:Object.assign({},c,(0,y.createHttpPatch)(c,E,_,w,!0)),default:Object.assign(c,(0,y.createHttpPatch)(c,E,_,w,!1))},https:{off:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"off"},w,!0)),on:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"on"},w,!0)),override:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"override"},w,!0)),onRequest:Object.assign({},t,(0,y.createHttpPatch)(t,E,_,w,!0)),default:Object.assign(t,(0,y.createHttpPatch)(t,E,_,w,!1))},tls:Object.assign(D,(0,y.createTlsPatch)(D))}}const k=new Map;function A(I,E){return I.getExtensionPathIndex().then(_=>{const w=Z.__$__nodeRequire("module"),h=w._load;w._load=function(f,v,m){if(f==="tls")return E.tls;if(f!=="http"&&f!=="https")return h.apply(this,arguments);const r=E[f],b=_.findSubstr(P.URI.file(v.filename));let s=k.get(b);if(s||k.set(b,s={}),!s[f]){const u=r.default;s[f]={...u}}return s[f]}})}}),define(De[301],Ie([1,0,74,299,286,300,41,274,2,14,7,271,113,273]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends D.RequireInterceptor{_installInterceptor(){const f=this,v=Z.__$__nodeRequire("module"),m=v._load;v._load=function(u,o,l){return u=b(u),f._factories.has(u)?f._factories.get(u).load(u,S.URI.file((0,E.realpathSync)(o.filename)),a=>m.apply(this,[a,o,l])):m.apply(this,arguments)};const r=v._resolveLookupPaths;v._resolveLookupPaths=(s,u)=>r.call(this,b(s),u);const b=s=>{for(const u of f._alternatives){const o=u(s);if(o){s=o;break}}return s}}}class h extends y.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(_.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(T.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const r=this._instaService.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath}await this._instaService.createInstance(w,f,{mine:this._myRegistry,all:this._globalRegistry}).install(),c.mark("code/extHost/didInitAPI");const m=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,m,this,this._logService,this._mainThreadTelemetryProxy,this._initData),c.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(f){return f.main}async _loadCommonJSModule(f,v,m){if(v.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${v}', must be of file-scheme`);let r=null;m.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${v.toString(!0)}`),this._logService.flush();const b=f?.identifier.value;f&&await this._extHostLocalizationService.initializeLocalizedMessages(f);try{b&&c.mark(`code/extHost/willLoadExtensionCode/${b}`),r=Z.__$__nodeRequire(v.fsPath)}finally{b&&c.mark(`code/extHost/didLoadExtensionCode/${b}`),m.codeLoadingStop()}return r}async $setRemoteEnvironment(f){if(!!this._initData.remote.isRemote)for(const v in f){const m=f[v];m===null?delete process.env[v]:process.env[v]=m}}}e.ExtHostExtensionService=h}),define(De[143],Ie([1,0,44,312,295,17,78,37,9,8,2,30,72,313,293,97]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const g=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(p){this.outputChannel=p}provideTextSearchResults(p,C,R,M){return this.outputChannel.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise(($,x)=>{M.onCancellationRequested(()=>H());const L=u(p,C),B=C.folder.fsPath,O=L.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.outputChannel.appendLine(`${g} ${O}
 - cwd: ${B}`);let z=c.spawn(g,L,{cwd:B});z.on("error",fe=>{console.error(fe),this.outputChannel.appendLine("Error: "+(fe&&fe.message)),x((0,I.serializeSearchError)(new I.SearchError(fe&&fe.message,I.SearchErrorCode.rgProcessError)))});let U=!1;const F=new r(C.maxResults,B,C.previewOptions);F.on("result",fe=>{U=!0,K="",R.report(fe)});let V=!1;const H=()=>{V=!0,z?.kill(),F?.cancel()};let Q=!1;F.on("hitLimit",()=>{Q=!0,H()});let K="";z.stdout.on("data",fe=>{F.handleData(fe),U||(K+=fe)});let de=!1;z.stdout.once("data",()=>de=!0);let ee="";z.stderr.on("data",fe=>{const Y=fe.toString();this.outputChannel.appendLine(Y),ee.length+Y.length<1e6&&(ee+=Y)}),z.on("close",()=>{if(this.outputChannel.appendLine(de?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),V)$({limitHit:Q});else{F.flush(),z=null;let fe;ee&&!de&&(fe=v(ee))?x((0,I.serializeSearchError)(new I.SearchError(fe.message,fe.code))):$({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=f;function v(i){const p=i.split(`
`),C=p[0].trim();if(p.some(M=>M.startsWith("regex parse error")))return new I.SearchError(m(p),I.SearchErrorCode.regexParseError);const R=C.match(/grep config error: unknown encoding: (.*)/);if(R)return new I.SearchError(`Unknown encoding: ${R[1]}`,I.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new I.SearchError(C.charAt(0).toUpperCase()+C.substr(1),I.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new I.SearchError(C.charAt(0).toUpperCase()+C.substr(1),I.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(C,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function m(i){const p=["Regex parse error"],C=i.filter(R=>R.startsWith("PCRE2:"));if(C.length>=1){const R=C[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const M=R.split(":")[1];p.push(":"+M)}}return p.join("")}e.buildRegexParseError=m;class r extends t.EventEmitter{constructor(p,C,R){super(),this.maxResults=p,this.rootFolder=C,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(p,C){return super.on(p,C),this}handleData(p){if(this.isDone)return;const C=typeof p=="string"?p:this.stringDecoder.write(p);this.handleDecodedData(C)}handleDecodedData(p){let C=p.indexOf(`
`);const R=this.remainder+p;if(C>=0)C+=this.remainder.length;else{this.remainder=R;return}let M=0;for(;C>=0;)this.handleLine(R.substring(M,C).trim()),M=C+1,C=R.indexOf(`
`,M);this.remainder=R.substring(M)}handleLine(p){if(this.isDone||!p)return;let C;try{C=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(C.type==="match"){const R=b(C.data.path),M=A.URI.file(S.join(this.rootFolder,R)),$=this.createTextSearchMatch(C.data,M);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const R=b(C.data.path),M=A.URI.file(S.join(this.rootFolder,R));this.createTextSearchContext(C.data,M).forEach(x=>this.onResult(x))}}createTextSearchMatch(p,C){const R=p.line_number-1,M=b(p.lines),$=Buffer.from(M);let x=0,L=0,B=R;p.submatches.length===0&&p.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const O=(0,P.coalesce)(p.submatches.map((z,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const F=b(z.match),V=$.slice(x,z.start).toString(),H=s(V),Q=H.numLines>0?H.lastLineLength:H.lastLineLength+L,K=s(F),de=H.numLines+B,ee=K.numLines+de,fe=K.numLines>0?K.lastLineLength:K.lastLineLength+Q;return x=z.end,L=fe,B=ee,new E.Range(de,Q,ee,fe)}));return(0,h.createTextSearchResult)(C,M,O,this.previewOptions)}createTextSearchContext(p,C){const R=b(p.lines),M=p.line_number;return R.replace(/\r?\n$/,"").split(`
`).map(($,x)=>({text:$,uri:C,lineNumber:M+x}))}onResult(p){this.emit("result",p)}}e.RipgrepParser=r;function b(i){return i.bytes?Buffer.from(i.bytes,"base64").toString():i.text}function s(i){const p=/\n/g;let C=0,R=-1,M;for(;M=p.exec(i);)C++,R=M.index;const $=R>=0?i.length-R-1:i.length;return{numLines:C,lastLineLength:$}}function u(i,p){const C=["--hidden"];C.push(i.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:M}=(0,y.groupBy)(p.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const x=new Set;M.forEach(L=>{x.add(L)}),C.push("-g","!*"),x.forEach(L=>{o(L).map(h.anchorGlob).forEach(B=>{C.push("-g",B)})})}R&&R.length&&R.forEach(x=>{C.push("-g",x)}),p.excludes.map(h.anchorGlob).forEach(x=>C.push("-g",`!${x}`)),p.maxFileSize&&C.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),p.followSymlinks&&C.push("--follow"),p.encoding&&p.encoding!=="utf8"&&C.push("--encoding",p.encoding),i.pattern==="--"&&(i.isRegExp=!0,i.pattern="\\-\\-"),i.isMultiline&&!i.isRegExp&&(i.pattern=(0,k.escapeRegExpCharacters)(i.pattern),i.isRegExp=!0),p.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),i.isRegExp&&(i.pattern=l(i.pattern),C.push("--engine","auto"));let $;if(i.isWordMatch){const L=(0,k.createRegExp)(i.pattern,!!i.isRegExp,{wholeWord:i.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",L)}else if(i.isRegExp){let x=d(i.pattern);x=n(x),C.push("--regexp",x)}else $=i.pattern,C.push("--fixed-strings");return C.push("--no-config"),p.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),i.isMultiline&&C.push("--multiline"),p.beforeContext&&C.push("--before-context",p.beforeContext+""),p.afterContext&&C.push("--after-context",p.afterContext+""),C.push("--"),$&&C.push($),C.push("."),C}function o(i){const p=(0,T.splitGlobAware)(i,"/");return p.map((C,R)=>p.slice(0,R+1).join("/"))}e.spreadGlobComponents=o;function l(i){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;i.match(p);)i=i.replace(p,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;i.match(C);)i=i.replace(C,"$1\\x{$2}");return i}e.unicodeEscapesToPCRE2=l;const a=i=>i.type==="Assertion"&&i.kind==="lookbehind";function d(i){let p;try{p=new _.RegExpParser().parsePattern(i)}catch{return i}let C="",R=0;const M=(L,B,O)=>{C+=i.slice(R,L)+O,R=B},$=[];return new _.RegExpVisitor({onCharacterEnter(L){if(L.raw!=="\\n")return;const B=$[0];if(!B)M(L.start,L.end,"\\r?\\n");else if(!$.some(a))if(B.type==="CharacterClass")if(B.negate){const O=i.slice(B.start+2,L.start)+i.slice(L.end,B.end-1);B.parent?.type==="Quantifier"?M(B.start,B.end,O?`[^${O}]`:"."):M(B.start,B.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=i.slice(B.start+1,L.start)+i.slice(L.end,B.end-1);M(B.start,B.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else B.type==="Quantifier"&&M(L.start,L.end,"(?:\\r?\\n)")},onQuantifierEnter(L){$.unshift(L)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(L){$.unshift(L)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(L){$.unshift(L)},onCharacterClassLeave(){$.shift()},onAssertionEnter(L){a(L)&&$.push(L)},onAssertionLeave(L){$[0]===L&&$.shift()}}).visit(p),C+=i.slice(R),C}e.fixRegexNewline=d;function n(i){return i.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(De[302],Ie([1,0,21,143,124,14]),function(Z,e,c,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,A,I,E){const _=new t.RipgrepTextSearchEngine(this.outputChannel);if(A.folder.scheme===P.Schemas.vscodeUserData){const w={...A,folder:A.folder.with({scheme:P.Schemas.file})},h=new D.Progress(g=>I.report({...g,uri:g.uri.with({scheme:A.folder.scheme})}));return this.withToken(E,g=>_.provideTextSearchResults(k,w,h,g))}else return this.withToken(E,w=>_.provideTextSearchResults(k,A,I,w))}async withToken(k,A){const I=T(k);this.inProgress.add(I);const E=await A(I.token);return this.inProgress.delete(I),E}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=y;function T(S){const k=new c.CancellationTokenSource;return S.onCancellationRequested(()=>k.cancel()),k}}),define(De[303],Ie([1,0,29,143,142]),function(Z,e,c,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(S){this.query=S}search(S,k,A){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(_){A({message:_})}},E=new D.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(I),c);return new Promise((_,w)=>E.search(h=>{k(h.map(y))},S).then(h=>_({limitHit:h.limitHit,type:"success",stats:h.stats}),w))}}e.TextSearchEngineAdapter=P;function y(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,k)=>{if(k.ranges){const A=k;return S+(Array.isArray(A.ranges)?A.ranges.length:1)}else return S+1},0)}}}),define(De[304],Ie([1,0,17,18,10,4,109,9,51,2,38,30,294,303]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class w{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let b;const s=f(r),u=new P.Emitter({onFirstListenerDidAdd:()=>{b=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(E.Engine,s,l=>u.fire(l),o)),b.then(o=>u.fire(o),o=>u.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{b.cancel()}});return u.event}textSearch(r){let b;const s=f(r),u=new P.Emitter({onFirstListenerDidAdd:()=>{b=(0,t.createCancelablePromise)(o=>this.ripgrepTextSearch(s,l=>u.fire(l),o)),b.then(o=>u.fire(o),o=>u.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{b.cancel()}});return u.event}ripgrepTextSearch(r,b,s){return r.maxFileSize=(0,A.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new _.TextSearchEngineAdapter(r).search(s,b,b)}doFileSearch(r,b,s){return this.doFileSearchWithEngine(E.Engine,r,b,s)}doFileSearchWithEngine(r,b,s,u,o=w.BATCH_SIZE){let l=0;const a=n=>{Array.isArray(n)?(l+=n.length,s(n.map(i=>this.rawMatchToSearchItem(i)))):n.relativePath?(l++,s(this.rawMatchToSearchItem(n))):s(n)};if(b.sortByScore){let n=this.trySortedSearchFromCache(b,a,u);if(!n){const i=b.maxResults?Object.assign({},b,{maxResults:null}):b,p=new r(i);n=this.doSortedSearch(p,b,s,a,u)}return new Promise((i,p)=>{n.then(([C,R])=>{const M=R.map($=>this.rawMatchToSearchItem($));this.sendProgress(M,s,o),i(C)},p)})}const d=new r(b);return this.doSearch(d,a,o,u).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.processType,fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,T.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,b,s,u,o){const l=new P.Emitter;let a=(0,t.createCancelablePromise)(n=>{let i=[];const p=C=>{Array.isArray(C)?i=C:(u(C),l.fire(C))};return this.doSearch(r,p,-1,n).then(C=>[C,i])}),d;if(b.cacheKey){d=this.getOrCreateCache(b.cacheKey);const n={promise:a,event:l.event,resolved:!1};d.resultsToSearchCache[b.filePattern||""]=n,a.then(()=>{n.resolved=!0},i=>{delete d.resultsToSearchCache[b.filePattern||""]}),a=this.preventCancellation(a)}return a.then(([n,i])=>{const p=d?d.scorerCache:Object.create(null),C=(typeof b.maxResults!="number"||b.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(b,i,p,o).then(R=>{const M=C?C.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:b.folderQueries.length,resultCount:R.length},messages:n.messages,limitHit:n.limitHit||typeof b.maxResults=="number"&&i.length>b.maxResults},R]})})}getOrCreateCache(r){const b=this.caches[r];return b||(this.caches[r]=new h)}trySortedSearchFromCache(r,b,s){const u=r.cacheKey&&this.caches[r.cacheKey];if(!u)return;const o=this.getResultsFromCache(u,r.filePattern||"",b,s);if(o)return o.then(([l,a,d])=>{const n=S.StopWatch.create(!1);return this.sortResults(r,a,u.scorerCache,s).then(i=>{const p=n.elapsed(),C={fromCache:!0,detailStats:d,type:this.processType,resultCount:a.length,sortingTime:p};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&a.length>r.maxResults,stats:C},i]})})}sortResults(r,b,s,u){const o=(0,y.prepareQuery)(r.filePattern||""),l=(d,n)=>(0,y.compareItemsByFuzzyScore)(d,n,o,!0,g,s),a=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return c.topAsync(b,l,a,1e4,u)}sendProgress(r,b,s){if(s&&s>0)for(let u=0;u<r.length;u+=s)b(r.slice(u,u+s));else b(r)}getResultsFromCache(r,b,s,u){const o=S.StopWatch.create(!1),l=b.indexOf(T.sep)>=0;let a;for(const p in r.resultsToSearchCache)if(b.startsWith(p)){if(l&&p.indexOf(T.sep)<0&&p!=="")continue;const C=r.resultsToSearchCache[p];a={promise:this.preventCancellation(C.promise),event:C.event,resolved:C.resolved};break}if(!a)return null;const d=o.elapsed(),n=S.StopWatch.create(!1),i=a.event(s);return u&&u.onCancellationRequested(()=>{i.dispose()}),a.promise.then(([p,C])=>{if(u&&u.isCancellationRequested)throw(0,D.canceled)();const R=[],M=(0,y.prepareQuery)(b).normalizedLowercase;for(const $ of C)!(0,I.isFilePatternMatch)($,M)||R.push($);return[p,R,{cacheWasResolved:a.resolved,cacheLookupTime:d,cacheFilterTime:n.elapsed(),cacheEntryCount:C.length}]})}doSearch(r,b,s,u){return new Promise((o,l)=>{let a=[];u?.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(s?(a.push(d),s>0&&a.length>=s&&(b(a),a=[])):b(d))},d=>{b(d)},(d,n)=>{a.length&&b(a),d?l(d):o(n)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(b,s){return r.then(b,s)}catch(b){return this.then(void 0,b)}finally(b){return r.finally(b)}}}}e.SearchService=w,w.BATCH_SIZE=512;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(m){return(0,T.basename)(m.relativePath)}getItemDescription(m){return(0,T.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function f(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(v),extraFileResources:m.extraFileResources&&m.extraFileResources.map(r=>k.URI.revive(r))}}function v(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(De[305],Ie([1,0,6,14,2,29,13,25,16,76,55,30,304,302,97,142]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let g=class extends k.ExtHostSearch{constructor(v,m,r,b){super(v,r,b),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const s=new w.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new _.RipgrepSearchProvider(s)),m.remote.isRemote&&m.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const v=new w.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new _.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(t.Schemas.file,new E.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(v,m){const r=this._handlePool++;return this._internalFileSearchProvider=m,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(v)),(0,c.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(v,m,r,b){const s=(0,k.reviveQuery)(r);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,m,s,b):super.$provideFileSearchResults(v,m,r,b)}doInternalFileSearch(v,m,r,b){const s=u=>{if((0,I.isSerializedFileMatch)(u)&&(u=[u]),Array.isArray(u)){this._proxy.$handleFileMatch(v,m,u.map(o=>D.URI.file(o.path)));return}u.message&&this._logService.debug("ExtHostSearch",u.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,s,b)}$clearCache(v){return this._internalFileSearchProvider?.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,m){return new h.NativeTextSearchManager(v,m,void 0,"textSearchProvider")}};g=Ve([He(0,S.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,A.IURITransformerService),He(3,y.ILogService)],g),e.NativeExtHostSearch=g}),define(De[306],Ie([1,0,84,277,289,288,305,301,278,75,41,76,73,40,54,70,276,275,13,290,47]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f,v,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService,!1),(0,c.registerSingleton)(v.ILoggerService,f.ExtHostLoggerService,1),(0,c.registerSingleton)(h.IExtensionStoragePaths,g.ExtensionStoragePaths,!1),(0,c.registerSingleton)(k.IExtHostDebugService,P.ExtHostDebugService,!1),(0,c.registerSingleton)(I.IExtHostSearch,y.NativeExtHostSearch,!1),(0,c.registerSingleton)(E.IExtHostTask,D.ExtHostTask,!1),(0,c.registerSingleton)(_.IExtHostTerminalService,t.ExtHostTerminalService,!1),(0,c.registerSingleton)(w.IExtHostTunnelService,S.ExtHostTunnelService,!1),(0,c.registerSingleton)(r.IExtHostVariableResolverProvider,m.NodeExtHostVariableResolverProviderService,!1)}),define(De[314],Ie([1,0,218,315,74,10,116,117,197,92,287,23,29,113,18,119,213,227,291,306]),function(Z,e,c,t,D,P,y,T,S,k,A,I,E,_,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const v=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const a=Z.__$__nodeRequire("module"),d=a._load;a._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const m=process.exit.bind(process);function r(a){process.exit=function(d){if(a)m(d);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let b=function(a){m()};function s(){const a=(0,f.readExtHostConnection)(process.env);if(a.type===3)return new Promise((d,n)=>{const i=p=>{const C=p[0],R=new y.BufferedEmitter;C.on("message",M=>R.fire(I.VSBuffer.wrap(M.data))),C.on("close",()=>{b("renderer closed the MessagePort")}),C.start(),d({onMessage:R.event,send:M=>C.postMessage(M.buffer)})};if(global.vscodePorts){const p=global.vscodePorts;delete global.vscodePorts,i(p)}else global.vscodePortsCallback=i});if(a.type===2)return new Promise((d,n)=>{let i=null;const p=setTimeout(()=>{b("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),C=108e5,R=3e5,M=new w.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (1)"),C),$=new w.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (2)"),R);process.on("message",(L,B)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const O=I.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let z;if(L.skipWebSocketFrames)z=new T.NodeSocket(B,"extHost-socket");else{const U=I.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));z=new T.WebSocketNodeSocket(new T.NodeSocket(B,"extHost-socket"),L.permessageDeflate,U,!1)}i?(M.cancel(),$.cancel(),i.beginAcceptReconnection(z,O),i.endAcceptReconnection(),i.sendResume()):(clearTimeout(p),i=new y.PersistentProtocol(z,O),i.sendResume(),i.onDidDispose(()=>b("renderer disconnected")),d(i),i.onSocketClose(()=>{M.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if($.isScheduled())return;M.isScheduled()&&$.schedule()}});const x={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(x)});{const d=a.pipeName;return new Promise((n,i)=>{const p=c.createConnection(d,()=>{p.removeListener("error",i);const C=new y.PersistentProtocol(new T.NodeSocket(p,"extHost-renderer"));C.sendResume(),n(C)});p.once("error",i),p.on("close",()=>{b("renderer closed the socket")})})}}async function u(){const a=await s();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,a.onMessage(d=>{(0,k.isMessageOfType)(d,2)?(this._terminating=!0,b("received terminate message from renderer")):this._onMessage.fire(d)})}send(d){this._terminating||a.send(d)}async drain(){if(a.drain)return a.drain()}}}function o(a){return new Promise(d=>{const n=a.onMessage(i=>{n.dispose();const p=JSON.parse(i.toString()),C=p.commit,R=S.default.commit;if(C&&R&&C!==R&&m(55),p.parentPid){let M=0;setInterval(function(){try{process.kill(p.parentPid,0),M=0}catch(x){x&&x.code==="EPERM"?(M++,M>=3&&b(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):b(`parent process ${p.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let $;try{$=Z.__$__nodeRequire("native-watchdog"),$.start(p.parentPid)}catch(x){(0,P.onUnexpectedError)(x)}}a.send((0,k.createMessageOfType)(0)),d({protocol:a,initData:p})});a.send((0,k.createMessageOfType)(1))})}async function l(){const a=[];process.on("unhandledRejection",(M,$)=>{a.push($),setTimeout(()=>{const x=a.indexOf($);x>=0&&$.catch(L=>{a.splice(x,1),(0,P.isCancellationError)(L)||(console.warn(`rejected promise not handled within 1 second: ${L}`),L&&L.stack&&console.warn(`stack trace: ${L.stack}`),M&&(0,P.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const $=a.indexOf(M);$>=0&&a.splice($,1)}),process.on("uncaughtException",function(M){(0,P.onUnexpectedError)(M)}),D.mark("code/extHost/willConnectToRenderer");const d=await u();D.mark("code/extHost/didConnectToRenderer");const n=await o(d);D.mark("code/extHost/didWaitForInitData");const{initData:i}=n;r(!!i.environment.extensionTestsLocationURI),i.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,i.environment.skipWorkspaceStorageLock=(0,h.boolean)(v.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit($){m($)}exists($){return E.Promises.exists($)}realpath($){return(0,_.realpath)($)}};let C=null;i.remote.authority&&v.transformURIs&&(C=(0,g.createURITransformer)(i.remote.authority));const R=new A.ExtensionHostMain(n.protocol,i,p,C);b=M=>R.terminate(M)}e.startExtensionHostProcess=l,l().catch(a=>console.log(a))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6261075646f055b99068d3688932416f2346dd3b/core/vs/workbench/api/node/extensionHostProcess.js.map
